package org.act.ws.manage;

import org.act.xservices.rt.xcontainer.management.IContainerManagement;
import org.act.xservices.rt.xcontainer.management.ManagementUtil;

/**
 * @version 2008-4-15
 * @author chenyy [chenyy@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ObjectPoolInfo {
	/**
	 * ģʽģʽ
	 */
	public static final int IN_MODE = 0;

	/**
	 * ģʽģʽ
	 */
	public static final int OUT_MODE = 1;
	
	/**
	 * 
	 */
	public static final String FAIL="FAIL";
	/**
	 * ɹ
	 */
	public static final String SUC="SUCCESS";
	
	private static IContainerManagement containerManagement = ManagementUtil.getInstance().getContainerManagement();
	
	/**
	 * õصĴС
	 * @param name 
	 * @param mode ģʽin/out
	 * @return شС
	 */
	public String getObjectPoolSize(String name,String mode)
	{
		String result="FAIL";
		String poolName = mapObjectPoolName(name,mode);
		result=String.valueOf(containerManagement.getObjectPool(poolName).size());
		return result;
	}
	
	/**
	 * õС
	 * @param name 
	 * @param mode ģʽin/out
	 * @return С
	 */
	public String getObjectPoolMaxSize(String name,String mode)
	{
		String result="FAIL";
		String poolName = mapObjectPoolName(name,mode);
	    result=String.valueOf(containerManagement.getObjectPool(poolName).getMaxSize());
		return result;
	}
	
	/**
	 * ûС
	 * @param name 
	 * @param mode ģʽin/out
	 * @param maxSize С
	 * @return ɹʧϢ
	 */
	public String setObjectPoolMaxSize(String name,String mode,int maxSize)
	{
		String result="SUC";
		String poolName = mapObjectPoolName(name,mode);
		try
		{
			containerManagement.getObjectPool(poolName).setMaxSize(maxSize);
		   
		}
		catch (Exception ex)
		{
			result=String.valueOf(ex.toString());
		}
		return result;
	}
	
	
	public String getAllObjectPoolName()
	{
		return "^-^Hello^-^";
	}
	
	private String mapObjectPoolName(String name,String mode){
		if(name.equalsIgnoreCase("transport")){
			if(mode.equalsIgnoreCase("in"))
				return "transportObjectIn";
			else if(mode.equalsIgnoreCase("out"))
				return "transportObjectOut";
		}
		else if(name.equalsIgnoreCase("message")){
			if(mode.equalsIgnoreCase("in"))
				return "messageObjectIn";
			else if(mode.equalsIgnoreCase("out"))
				return "messageObjectOut";
		}
		else if(name.equalsIgnoreCase("serviceobject")){
			if(mode.equalsIgnoreCase("in"))
				return "serviceObjectIn";
			else if(mode.equalsIgnoreCase("out"))
				return "serviceObjectOut";
		}
		return null;
	}
  
	public static void main(String[] args){
		ObjectPoolInfo instance = new ObjectPoolInfo();
		System.out.println(instance.getObjectPoolMaxSize("transport", "in"));
		
	} 
}
