package org.act.ws.manage;

import org.act.xservices.rt.xcontainer.management.ITransportManagement;
import org.act.xservices.rt.xcontainer.management.ManagementUtil;

/**
 * @author chenyy [chenyy@act.buaa.edu.cn]
 * 2008-6-16
 */
public class StatisticInfo {

	private static ITransportManagement transportManagement = ManagementUtil.getInstance().getHTTPTransportManagement();
	

	/**
	 * һ˶ٸ
	 * @return
	 */
	public static long getAcceptedCount() {
		
		return transportManagement.getAcceptedSocketCount();
	}
	
    /**
     * Get average receive speed, in byte/s.
     * ƽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
	public static double getAvgReceiveSpeed(){
		
		return transportManagement.getAvgReceiveSpeed();
	}
	
	/**
     * Get average send speed, in byte/s.
     * ƽٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public static double getAvgSendSpeed() {

        return transportManagement.getAvgSendSpeed();
    }
		
    /**
     * Get instantaneous receive speed, in byte/s.
     * ʵʱĽٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public static double getReceiveSpeed() {

        return transportManagement.getReceiveSpeed();
    }
	
    /**
     * Get instantaneous send speed, in byte/s.
     * ʵʱķٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public static double getSendSpeed() {
        
    	return transportManagement.getSendSpeed();
    }
	
    /**
     * Get elapsed time after session started and before session closed, in ms.
     * ʱ
     * 
     * @return elapsed time,or -1 means statistic Function Unavailable.
     */
    public static long getElapsedTime() {
        
    	return transportManagement.getRunningTimeInMillis();
    }
    
    /**
     * Get received bytes count. If session restart, the value will reset to 0.
     * ֽܹܵ
     * 
     * @return received bytes count,or -1 means statistic Function Unavailable.
     */
    public static long getReceivedBytes() {

        return transportManagement.getReceivedBytes();
    }
    
    /**
     * Get sent bytes count. If session restart, the value will reset to 0.
     * ֽܹ
     * 
     * @return sent bytes count,or -1 means statistic Function Unavailable.
     */
    public static long getSentBytes() {
        
    	return transportManagement.getSentBytes();
    }
    
    //-------------------------add 2008-7-14----------------------------------
    
	/**
	 * жϴHTTPǷ
	 * @return
	 */
	public static boolean isAvailable(){
		
		return transportManagement.isAvailable();
	}
    
	/**
	 * ʾͳƹǷ
	 * @return
	 */
	public static boolean isThroughputStatisticAvailable(){
		
		return transportManagement.isThroughputStatisticAvailable();
	}
    
    /**
     * ͬʱSocket
     * @return
     */
    public static long getLargestManagedSocketCount(){
    	
    	return transportManagement.getLargestManagedSocketCount();
    }
    
    /**
     * ĿǰڴSocket
     * @return
     */
    public static int getManagedSocketCount(){
    	
    	return transportManagement.getManagedSocketCount();
    }
    
	/**
	 * ͳϢʱ
	 * @return
	 */
	public static int getThroughputCalculationInterval(){
		
		return transportManagement.getThroughputCalculationInterval();
	}
	
    /**
     * ͳϢʱĬΪ3
     */
    public static void setThroughputCalculationInterval(int throughputCalculationInterval){
    	
    	transportManagement.setThroughputCalculationInterval(throughputCalculationInterval);
    }
    
    /**
     * Get instantaneous receive speed, in num/s.
     * ʵʱϢٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public static double getMessageReceiveSpeed(){
    	
    	return transportManagement.getMessageReceiveSpeed();
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public static double getLargestReceiveSpeed(){
    	
    	return transportManagement.getLargestReceiveSpeed();
    }
    
    /**
     * Get average receive speed, in num/s.
     * ƽϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public static double getAvgMessageReceiveSpeed(){
    	
    	return transportManagement.getAvgMessageReceiveSpeed();
    }
    
    /**
     * Get average receive speed, in num/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public static double getLargestMessageReceiveSpeed(){
    	
    	return transportManagement.getLargestMessageReceiveSpeed();
    }
    
    /**
     * Get instantaneous send speed, in num/s.
     * ʵʱϢٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public static double getSendMessageSpeed(){
    	
    	return transportManagement.getSendMessageSpeed();
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڷٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public static double getLargestSendSpeed(){
    	
    	return transportManagement.getLargestSendSpeed();
    }
    
    /**
     * Get average send speed, in num/s.
     * ƽϢٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public static double getAvgMessageSendSpeed(){
    	
    	return transportManagement.getAvgMessageSendSpeed();
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public static double getLargestMessageSendSpeed(){
    	
    	return transportManagement.getLargestMessageSendSpeed();
    }
    
    /**
     * ôɷԴʱ
     * @return
     */
    public static long getStartTimeInMillis(){
    	
    	return transportManagement.getStartTimeInMillis();
    }
    
    /**
     * ܵϢ
     * @return
     */
    public static long getReceivedMessages(){
    	
    	return transportManagement.getReceivedMessages();
    }
    
    /**
     * ͵Ϣ
     * @return
     */
    public static long getSentMessages(){
    	
    	return transportManagement.getSentMessages();
    }
    
}
