package org.act.ws.manage;

import org.act.xservices.rt.metaset.*;

import java.util.List;

import javax.xml.namespace.QName;

import org.act.ws.manage.SystemInfo;

/**
 * @version 2008-4-15
 * @author chenyy [chenyy@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class SystemInfoMapping {
 
  private static SystemInfo instance = new SystemInfo();
  
  private MetasetBuilder metBuilder = MetasetBuilderFactory.newInstance().newMetasetBuilder();
 
  public Metaset getOperation(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    String getOperationReturn = instance.getOperation(param0,param1);
    
    Metaset response = metBuilder.newMetaset("getOperationResponse");
    Metaset ret = metBuilder.newMetaset("getOperationReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getOperationReturn);
    response.addChildren(ret);
    return response;
  }
  
  public Metaset getJVMTotalM(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    int param0=Integer.parseInt(((Metaset)params.get(0)).getValue());
    String getJVMTotalMReturn = instance.getJVMTotalM(param0);
    
    Metaset response = metBuilder.newMetaset("getJVMTotalMResponse");
    Metaset ret = metBuilder.newMetaset("getJVMTotalMReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getJVMTotalMReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getJVMMaxM(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    int param0=Integer.parseInt(((Metaset)params.get(0)).getValue());
    String getJVMMaxMReturn = instance.getJVMMaxM(param0);
    
    Metaset response = metBuilder.newMetaset("getJVMMaxMResponse");
    Metaset ret = metBuilder.newMetaset("getJVMMaxMReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getJVMMaxMReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getJVMFreeM(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    int param0=Integer.parseInt(((Metaset)params.get(0)).getValue());
    String getJVMFreeMReturn = instance.getJVMFreeM(param0);
    
    Metaset response = metBuilder.newMetaset("getJVMFreeMResponse");
    Metaset ret = metBuilder.newMetaset("getJVMFreeMReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getJVMFreeMReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getObjectPoolSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    String getObjectPoolSizeReturn = instance.getObjectPoolSize(param0,param1);
    
    Metaset response = metBuilder.newMetaset("getObjectPoolSizeResponse");
    Metaset ret = metBuilder.newMetaset("getObjectPoolSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getObjectPoolSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getObjectPoolMaxSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    String getObjectPoolMaxSizeReturn = instance.getObjectPoolMaxSize(param0,param1);
    
    Metaset response = metBuilder.newMetaset("getObjectPoolMaxSizeResponse");
    Metaset ret = metBuilder.newMetaset("getObjectPoolMaxSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getObjectPoolMaxSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset setObjectPoolMaxSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    int param2=Integer.parseInt(((Metaset)params.get(2)).getValue());
    String setObjectPoolMaxSizeReturn = instance.setObjectPoolMaxSize(param0,param1,param2);
    
    Metaset response = metBuilder.newMetaset("setObjectPoolMaxSizeResponse");
    Metaset ret = metBuilder.newMetaset("setObjectPoolMaxSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+setObjectPoolMaxSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getAllObjectPoolName(Metaset msg)
  {
    String getAllObjectPoolNameReturn = instance.getAllObjectPoolName();
    
    Metaset response = metBuilder.newMetaset("getAllObjectPoolNameResponse");
    Metaset ret = metBuilder.newMetaset("getAllObjectPoolNameReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getAllObjectPoolNameReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getTPActiveCount(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPActiveCountReturn = instance.getTPActiveCount(param0);
    
    Metaset response = metBuilder.newMetaset("getTPActiveCountResponse");
    Metaset ret = metBuilder.newMetaset("getTPActiveCountReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPActiveCountReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getTPCompletedTaskCount(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPCompletedTaskCountReturn = instance.getTPCompletedTaskCount(param0);
    
    Metaset response = metBuilder.newMetaset("getTPCompletedTaskCountResponse");
    Metaset ret = metBuilder.newMetaset("getTPCompletedTaskCountReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPCompletedTaskCountReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getTPCorePoolSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPCorePoolSizeReturn = instance.getTPCorePoolSize(param0);
    
    Metaset response = metBuilder.newMetaset("getTPCorePoolSizeResponse");
    Metaset ret = metBuilder.newMetaset("getTPCorePoolSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPCorePoolSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getTPMaximumPoolSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPMaximumPoolSizeReturn = instance.getTPMaximumPoolSize(param0);
    
    Metaset response = metBuilder.newMetaset("getTPMaximumPoolSizeResponse");
    Metaset ret = metBuilder.newMetaset("getTPMaximumPoolSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPMaximumPoolSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getTPPoolSize(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPPoolSizeReturn = instance.getTPPoolSize(param0);
    
    Metaset response = metBuilder.newMetaset("getTPPoolSizeResponse");
    Metaset ret = metBuilder.newMetaset("getTPPoolSizeReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPPoolSizeReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getTPCurrentTreadCount(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String getTPCurrentTreadCountReturn = instance.getTPCurrentTreadCount(param0);
    
    Metaset response = metBuilder.newMetaset("getTPCurrentTreadCountResponse");
    Metaset ret = metBuilder.newMetaset("getTPCurrentTreadCountReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getTPCurrentTreadCountReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getConfigFile(Metaset msg)
  {
    String getConfigFileReturn = instance.getConfigFile();
    
    Metaset response = metBuilder.newMetaset("getConfigFileResponse");
    Metaset ret = metBuilder.newMetaset("getConfigFileReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getConfigFileReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getConfigInfo(Metaset msg)
  {
    String getConfigInfoReturn = instance.getConfigInfo();
    
    Metaset response = metBuilder.newMetaset("getConfigInfoResponse");
    Metaset ret = metBuilder.newMetaset("getConfigInfoReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getConfigInfoReturn);
    response.addChildren(ret);

    return response;
  }
   
  public Metaset setConfigFile(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String setConfigFileReturn = instance.setConfigFile(param0);
    
    Metaset response = metBuilder.newMetaset("setConfigFileResponse");
    Metaset ret = metBuilder.newMetaset("setConfigFileReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+setConfigFileReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset setConfigInfo(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String setConfigInfoReturn = instance.setConfigInfo(param0);
    
    Metaset response = metBuilder.newMetaset("setConfigInfoResponse");
    Metaset ret = metBuilder.newMetaset("setConfigInfoReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+ setConfigInfoReturn);
    response.addChildren(ret);

    return response;
  }
  
  public Metaset getDeployedServices(Metaset msg)
  {
    String getDeployedServicesReturn = instance.getDeployedServices();
    
    Metaset response = metBuilder.newMetaset("getDeployedServicesResponse");
    Metaset ret = metBuilder.newMetaset("getDeployedServicesReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getDeployedServicesReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getWsdl(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    String getWsdlReturn = instance.getWsdl(param0,param1);
    
    Metaset response = metBuilder.newMetaset("getWsdlResponse");
    Metaset ret = metBuilder.newMetaset("getWsdlReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getWsdlReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset getWsdd(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    String getWsddReturn = instance.getWsdd(param0,param1);
    
    Metaset response = metBuilder.newMetaset("getWsddResponse");
    Metaset ret = metBuilder.newMetaset("getWsddReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
    ret.setValue(""+getWsddReturn);
    response.addChildren(ret);
    
    return response;
  }
  
  public Metaset deployService(Metaset msg)
  {
    List params = msg.filter(".\\*").getChildrens();
    String param0=((Metaset)params.get(0)).getValue();
    String param1=((Metaset)params.get(1)).getValue();
    boolean DeployServiceReturn = instance.deployService(param0,param1);
   
    Metaset response = metBuilder.newMetaset("deployServiceResponse");
    Metaset ret = metBuilder.newMetaset("deployServiceReturn");
    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
    ret.setValue(""+DeployServiceReturn);
    response.addChildren(ret);
   
    return response;
  }
  
	
   //----------add 2008-06-16
  
	public Metaset getXContainerVersion(Metaset msg){	   
		String getXContainerVersionReturn = instance.getXContainerVersion();
	    
	    Metaset response = metBuilder.newMetaset("getXContainerVersionResponse");
	    Metaset ret = metBuilder.newMetaset("getXContainerVersionReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + getXContainerVersionReturn);
	    response.addChildren(ret);

	    return response;		
	}
  
	public Metaset getXContainerName(Metaset msg) {
		
		String getXContainerNameReturn = instance.getXContainerName();
	    
	    Metaset response = metBuilder.newMetaset("getXContainerNameResponse");
	    Metaset ret = metBuilder.newMetaset("getXContainerNameReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + getXContainerNameReturn);
	    response.addChildren(ret);

	    return response;	
	}
  
	public Metaset getXContainerDescription(Metaset msg) {
		
		String getXContainerDescriptionReturn = instance.getXContainerDescription();
	    
	    Metaset response = metBuilder.newMetaset("getXContainerDescriptionResponse");
	    Metaset ret = metBuilder.newMetaset("getXContainerDescriptionReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + getXContainerDescriptionReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
	public Metaset getXContainerStartupTime(Metaset msg) {
		
		String getXContainerStartupTimeReturn = instance.getXContainerStartupTime();
	    
	    Metaset response = metBuilder.newMetaset("getXContainerStartupTimeResponse");
	    Metaset ret = metBuilder.newMetaset("getXContainerStartupTimeReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + getXContainerStartupTimeReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
    //-------------------------add 2008-7-14----------------------------------
	
	public Metaset startDeployServiceNow(Metaset msg) {
		
		boolean startDeployServiceNowReturn = instance.startDeployServiceNow();
	    
	    Metaset response = metBuilder.newMetaset("startDeployServiceNowResponse");
	    Metaset ret = metBuilder.newMetaset("startDeployServiceNowReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + startDeployServiceNowReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
	/**
     * ǰѲķ
     * @return еǰѲķ
     */
	public Metaset getDeployedServiceNum(Metaset msg){
		
		int getDeployedServiceNumReturn = instance.getDeployedServiceNum();
	    
	    Metaset response = metBuilder.newMetaset("getDeployedServiceNumResponse");
	    Metaset ret = metBuilder.newMetaset("getDeployedServiceNumReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:int"));
	    ret.setValue("" + getDeployedServiceNumReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
	/**
	 * ǰеķ
	 * @return еķ
	 */
	public Metaset getRunningServiceNum(Metaset msg){
		
		int getRunningServiceNumReturn = instance.getRunningServiceNum();
	    
	    Metaset response = metBuilder.newMetaset("getRunningServiceNumResponse");
	    Metaset ret = metBuilder.newMetaset("getRunningServiceNumReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:int"));
	    ret.setValue("" + getRunningServiceNumReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
	/**
	 * ʼǰʱ
	 * @return Ѵ
	 */
	public Metaset getProcessedServiceNum(Metaset msg){
		
		int getProcessedServiceNumReturn = instance.getProcessedServiceNum();
	    
	    Metaset response = metBuilder.newMetaset("getProcessedServiceNumResponse");
	    Metaset ret = metBuilder.newMetaset("getProcessedServiceNumReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:int"));
	    ret.setValue("" + getProcessedServiceNumReturn);
	    response.addChildren(ret);
	    
	    return response;	
	}
	
	/**
	 * ʼǰʱõĴ
	 * @return 
	 */
	public Metaset getErrorInvokeNum(Metaset msg){
		
		int getErrorInvokeNumReturn = instance.getErrorInvokeNum();
	    
	    Metaset response = metBuilder.newMetaset("getErrorInvokeNumResponse");
	    Metaset ret = metBuilder.newMetaset("getErrorInvokeNumReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:int"));
	    ret.setValue("" + getErrorInvokeNumReturn);
	    response.addChildren(ret);

	    return response;	
	}
	
	/**
	 * ĳ
	 * @param serviceName 
	 * @return ɹʧ
	 */
	public Metaset undeployService(Metaset msg){
		
	    List params = msg.filter(".\\*").getChildrens();
	    String param0=((Metaset)params.get(0)).getValue();
	    String param1=((Metaset)params.get(1)).getValue();
	    boolean undeployServiceReturn = instance.undeployService(param0,param1);
	    
	    Metaset response = metBuilder.newMetaset("undeployServiceResponse");
	    Metaset ret = metBuilder.newMetaset("undeployServiceReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + undeployServiceReturn);
	    response.addChildren(ret);

	    return response;
	}
	
	/**
	 * ֹͣĳֹͣ󣬸÷ͣSOAP󣬿ͨStart½SOAP
	 * @param serviceName
	 * @return ֹͣɹʧ
	 */
	public Metaset stopService(Metaset msg){
		
	    List params = msg.filter(".\\*").getChildrens();
	    String param0=((Metaset)params.get(0)).getValue();
	    boolean stopServiceReturn = instance.stopService(param0);
	    
	    Metaset response = metBuilder.newMetaset("stopServiceResponse");
	    Metaset ret = metBuilder.newMetaset("stopServiceReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + stopServiceReturn);
	    response.addChildren(ret);

	    return response;
	}
	
	/**
	 * ĳֹͣ״̬ķ񣬸÷½SOAP
	 * @param serviceName
	 * @return ɹʧ
	 */
    public Metaset startService(Metaset msg){
    	
	    List params = msg.filter(".\\*").getChildrens();
	    String param0=((Metaset)params.get(0)).getValue();
	    boolean startServiceReturn = instance.startService(param0);
	    
	    Metaset response = metBuilder.newMetaset("startServiceResponse");
	    Metaset ret = metBuilder.newMetaset("startServiceReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + startServiceReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * ĳĵǰ״̬ started/stopped
     * @param serviceName
     * @return ĳĵǰ״̬
     */
    public Metaset getServiceStatus(Metaset msg){
    	
	    List params = msg.filter(".\\*").getChildrens();
	    String param0=((Metaset)params.get(0)).getValue();
	    String getServiceStatusReturn = instance.getServiceStatus(param0);
	    
	    Metaset response = metBuilder.newMetaset("getServiceStatusResponse");
	    Metaset ret = metBuilder.newMetaset("getServiceStatusReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + getServiceStatusReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
	 * һ˶ٸ
	 * @return
	 */
	public Metaset getAcceptedCount(Metaset msg) {
		
	    long getAcceptedCountReturn = instance.getAcceptedCount();
	    
	    Metaset response = metBuilder.newMetaset("getAcceptedCountResponse");
	    Metaset ret = metBuilder.newMetaset("getAcceptedCountReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getAcceptedCountReturn);
	    response.addChildren(ret);

	    return response;
	}
	
    /**
     * Get average receive speed, in byte/s.
     * ƽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
	public Metaset getAvgReceiveSpeed(Metaset msg){
		
	    double getAvgReceiveSpeedReturn = instance.getAvgReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getAvgReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getAvgReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getAvgReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
	}
	
	/**
     * Get average send speed, in byte/s.
     * ƽٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getAvgSendSpeed(Metaset msg) {

	    double getAvgSendSpeedReturn = instance.getAvgSendSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getAvgSendSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getAvgSendSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getAvgSendSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get instantaneous receive speed, in byte/s.
     * ʵʱĽٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getReceiveSpeed(Metaset msg) {

	    double getReceiveSpeedReturn = instance.getReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get instantaneous send speed, in byte/s.
     * ʵʱķٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getSendSpeed(Metaset msg) {
        
	    double getSendSpeedReturn = instance.getSendSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getSendSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getSendSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getSendSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get elapsed time after session started and before session closed, in ms.
     * ʱ
     * 
     * @return elapsed time,or -1 means statistic Function Unavailable.
     */
    public Metaset getElapsedTime(Metaset msg) {
        
	    long getElapsedTimeReturn = instance.getElapsedTime();
	    
	    Metaset response = metBuilder.newMetaset("getElapsedTimeResponse");
	    Metaset ret = metBuilder.newMetaset("getElapsedTimeReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getElapsedTimeReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get received bytes count. If session restart, the value will reset to 0.
     * ֽܹܵ
     * 
     * @return received bytes count,or -1 means statistic Function Unavailable.
     */
    public Metaset getReceivedBytes(Metaset msg) {

	    long getReceivedBytesReturn = instance.getReceivedBytes();
	    
	    Metaset response = metBuilder.newMetaset("getReceivedBytesResponse");
	    Metaset ret = metBuilder.newMetaset("getReceivedBytesReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getReceivedBytesReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get sent bytes count. If session restart, the value will reset to 0.
     * ֽܹ
     * 
     * @return sent bytes count,or -1 means statistic Function Unavailable.
     */
    public Metaset getSentBytes(Metaset msg) {
        
	    long getSentBytesReturn = instance.getSentBytes();
	    
	    Metaset response = metBuilder.newMetaset("getSentBytesResponse");
	    Metaset ret = metBuilder.newMetaset("getSentBytesReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getSentBytesReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    //-------------------------add 2008-7-14----------------------------------
    
	/**
	 * жϴHTTPǷ
	 * @return
	 */
	public Metaset isAvailable(Metaset msg){
		
	    boolean isAvailableReturn = instance.isAvailable();
	    
	    Metaset response = metBuilder.newMetaset("isAvailableResponse");
	    Metaset ret = metBuilder.newMetaset("isAvailableReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + isAvailableReturn);
	    response.addChildren(ret);

	    return response;
	}
    
	/**
	 * ʾͳƹǷ
	 * @return
	 */
	public Metaset isThroughputStatisticAvailable(Metaset msg){
				
	    boolean isThroughputStatisticAvailableReturn = instance.isThroughputStatisticAvailable();
	    
	    Metaset response = metBuilder.newMetaset("isThroughputStatisticAvailableResponse");
	    Metaset ret = metBuilder.newMetaset("isThroughputStatisticAvailableReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:boolean"));
	    ret.setValue("" + isThroughputStatisticAvailableReturn);
	    response.addChildren(ret);

	    return response;
	}
    
    /**
     * ͬʱSocket
     * @return
     */
    public Metaset getLargestManagedSocketCount(Metaset msg){
    	
	    long getLargestManagedSocketCountReturn = instance.getLargestManagedSocketCount();
	    
	    Metaset response = metBuilder.newMetaset("getLargestManagedSocketCountResponse");
	    Metaset ret = metBuilder.newMetaset("getLargestManagedSocketCountReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getLargestManagedSocketCountReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * ĿǰڴSocket
     * @return
     */
    public Metaset getManagedSocketCount(Metaset msg){
    	
	    long getManagedSocketCountReturn = instance.getManagedSocketCount();
	    
	    Metaset response = metBuilder.newMetaset("getManagedSocketCountResponse");
	    Metaset ret = metBuilder.newMetaset("getManagedSocketCountReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getManagedSocketCountReturn);
	    response.addChildren(ret);

	    return response;
    }
    
	/**
	 * ͳϢʱ
	 * @return
	 */
	public Metaset getThroughputCalculationInterval(Metaset msg){
		
	    int getThroughputCalculationIntervalReturn = instance.getThroughputCalculationInterval();
	    
	    Metaset response = metBuilder.newMetaset("getThroughputCalculationIntervalResponse");
	    Metaset ret = metBuilder.newMetaset("getThroughputCalculationIntervalReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:int"));
	    ret.setValue("" + getThroughputCalculationIntervalReturn);
	    response.addChildren(ret);

	    return response;
	}
    
    /**
     * ͳϢʱĬΪ3
     */
    public Metaset setThroughputCalculationInterval(Metaset msg){
    	    	
	    List params = msg.filter(".\\*").getChildrens();
	    int param0= Integer.parseInt(((Metaset)params.get(0)).getValue());
	    boolean setThroughputCalculationIntervalReturn = instance.setThroughputCalculationInterval(param0);
	    
	    Metaset response = metBuilder.newMetaset("setThroughputCalculationIntervalResponse");
	    Metaset ret = metBuilder.newMetaset("setThroughputCalculationIntervalReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:string"));
	    ret.setValue("" + setThroughputCalculationIntervalReturn);
	    response.addChildren(ret);

	    return response;
    }
	
    /**
     * Get instantaneous receive speed, in num/s.
     * ʵʱϢٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getMessageReceiveSpeed(Metaset msg){
		
    	double getMessageReceiveSpeedReturn = instance.getMessageReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getMessageReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getMessageReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getMessageReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getLargestReceiveSpeed(Metaset msg){
		
    	double getLargestReceiveSpeedReturn = instance.getLargestReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getLargestReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getLargestReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getLargestReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average receive speed, in num/s.
     * ƽϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getAvgMessageReceiveSpeed(Metaset msg){

    	double getAvgMessageReceiveSpeedReturn = instance.getAvgMessageReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getAvgMessageReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getAvgMessageReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getAvgMessageReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average receive speed, in num/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getLargestMessageReceiveSpeed(Metaset msg){

    	double getLargestMessageReceiveSpeedReturn = instance.getLargestMessageReceiveSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getLargestMessageReceiveSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getLargestMessageReceiveSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getLargestMessageReceiveSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get instantaneous send speed, in num/s.
     * ʵʱϢٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getSendMessageSpeed(Metaset msg){

    	double getSendMessageSpeedReturn = instance.getSendMessageSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getSendMessageSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getSendMessageSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getSendMessageSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڷٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getLargestSendSpeed(Metaset msg){

    	double getLargestSendSpeedReturn = instance.getLargestSendSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getLargestSendSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getLargestSendSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getLargestSendSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average send speed, in num/s.
     * ƽϢٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getAvgMessageSendSpeed(Metaset msg){

    	double getAvgMessageSendSpeedReturn = instance.getAvgMessageSendSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getAvgMessageSendSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getAvgMessageSendSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getAvgMessageSendSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public Metaset getLargestMessageSendSpeed(Metaset msg){

    	double getLargestMessageSendSpeedReturn = instance.getLargestMessageSendSpeed();
	    
	    Metaset response = metBuilder.newMetaset("getLargestMessageSendSpeedResponse");
	    Metaset ret = metBuilder.newMetaset("getLargestMessageSendSpeedReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:double"));
	    ret.setValue("" + getLargestMessageSendSpeedReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * ôɷԴʱ
     * @return
     */
    public Metaset getStartTimeInMillis(Metaset msg){

    	long getStartTimeInMillisReturn = instance.getStartTimeInMillis();
	    
	    Metaset response = metBuilder.newMetaset("getStartTimeInMillisResponse");
	    Metaset ret = metBuilder.newMetaset("getStartTimeInMillisReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getStartTimeInMillisReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * ܵϢ
     * @return
     */
    public Metaset getReceivedMessages(Metaset msg){

    	long getReceivedMessagesReturn = instance.getReceivedMessages();
	    
	    Metaset response = metBuilder.newMetaset("getReceivedMessagesResponse");
	    Metaset ret = metBuilder.newMetaset("getReceivedMessagesReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getReceivedMessagesReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    /**
     * ͵Ϣ
     * @return
     */
    public Metaset getSentMessages(Metaset msg){

    	long getSentMessagesReturn = instance.getSentMessages();
	    
	    Metaset response = metBuilder.newMetaset("getSentMessagesResponse");
	    Metaset ret = metBuilder.newMetaset("getSentMessagesReturn");
	    ret.addAttribute(metBuilder.newAttribute(new QName("", "type","xsi"), "xsd:long"));
	    ret.setValue("" + getSentMessagesReturn);
	    response.addChildren(ret);

	    return response;
    }
    
    
    
    
	// //////////////////WF//////////////////
	/**
	 *ĻϢ
	 *
	 */
    public Metaset getEngineInfo(Metaset message) {
		String result = instance.getEngineInfo();

		Metaset response = metBuilder.newMetaset("getEngineInfoResponse");
		Metaset ret = metBuilder.newMetaset("getEngineInfoReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("", "type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;

	}  
		
    /**
     * ʷϢ
     * @param message
     * @return
     */
    public Metaset getEngineHistoryInfo(Metaset message) {
		String result = instance.getEngineHistoryInfo();

		Metaset response = metBuilder.newMetaset("getEngineHistoryInfoResponse");
		Metaset ret = metBuilder.newMetaset("getEngineHistoryInfoReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("", "type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;

	} 
        
	public Metaset UnDeployInstance(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.UnDeployInstance(tmp0);

		Metaset response = metBuilder.newMetaset("UnDeployInstanceResponse");
		Metaset ret = metBuilder.newMetaset("UnDeployInstanceReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;

	}
	
	public Metaset DeployInstance(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		String result = instance.DeployInstance(tmp0,tmp1);

		Metaset response = metBuilder.newMetaset("DeployInstanceResponse");
		Metaset ret = metBuilder.newMetaset("DeployInstanceReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}

	public Metaset getDeployedInstances(Metaset message) {
		String result = instance.getDeployedInstances();

		Metaset response = metBuilder.newMetaset("getDeployedInstancesResponse");
		Metaset ret = metBuilder.newMetaset("getDeployedInstancesReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}

	/**
	 * ̲ԪĻϢ
	 * @param message
	 * @return
	 */
	public Metaset getDeploymentUnitInfo(Metaset message) {
		String result = instance.getDeploymentUnitInfo();

		Metaset response = metBuilder.newMetaset("getDeploymentUnitInfoResponse");
		Metaset ret = metBuilder.newMetaset("getDeploymentUnitInfoReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	/**
	 * Id̲ԪĻϢ
	 * @param message
	 * @return
	 */
	public Metaset getDeploymentUnitInfobyId(Metaset message) {
		
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getDeploymentUnitInfobyId(tmp0);

		Metaset response = metBuilder.newMetaset("getDeploymentUnitInfobyIdResponse");
		Metaset ret = metBuilder.newMetaset("getDeploymentUnitInfobyIdReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset getBpel(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		String name = ((Metaset) childs.get(0)).getValue();
		String result = instance.getBpel(name);

		Metaset res = metBuilder.newMetaset("getBpelResponse");
		Metaset returnSS = metBuilder.newMetaset("getBpelReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}

	public Metaset getWSDL(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		String name = ((Metaset) childs.get(0)).getValue();
		String result = instance.getWSDL(name);

		Metaset res = metBuilder.newMetaset("getWSDLResponse");
		Metaset returnSS = metBuilder.newMetaset("getWSDLReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	public Metaset getPDD(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		String name = ((Metaset) childs.get(0)).getValue();
		String result = instance.getPDD(name);

		Metaset res = metBuilder.newMetaset("getPDDResponse");
		Metaset returnSS = metBuilder.newMetaset("getPDDReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	public Metaset getWFWsdd(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		String name = ((Metaset) childs.get(0)).getValue();
		String result = instance.getWFWsdd(name);

		Metaset res = metBuilder.newMetaset("getWFWsddResponse");
		Metaset returnSS = metBuilder.newMetaset("getWFWsddReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
    
	/**
	 * صĻӹϵ
	 * @param message
	 * @return
	 */
	public Metaset getPartnerLinks(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		// Ϊַ
		String id = ((Metaset) childs.get(0)).getValue();		
		String result = instance.getPartnerLinks(id);

		Metaset res = metBuilder.newMetaset("getPartnerLinksResponse");
		Metaset returnSS = metBuilder.newMetaset("getPartnerLinksReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	/**
	 * ̲ԪصʵϢ
	 * @param message
	 * @return
	 */
	public Metaset getInstanceUnits(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		// Ϊַ
		String id = ((Metaset) childs.get(0)).getValue();		
		String result = instance.getInstanceUnits(id);

		Metaset res = metBuilder.newMetaset("getInstanceUnitsResponse");
		Metaset returnSS = metBuilder.newMetaset("getInstanceUnitsReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	/**
	 * еʵϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 */
	public Metaset getAllInstanceUnits(Metaset message) {
		
		String result = instance.getAllInstanceUnits();

		Metaset res = metBuilder.newMetaset("getAllInstanceUnitsResponse");
		Metaset returnSS = metBuilder.newMetaset("getAllInstanceUnitsReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	/**
	 * ʵʶĳʵϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 */
	public Metaset getInstanceUnitsbyId(Metaset message) {
		
		List childs = message.filter(".\\*").getChildrens();
		String id = ((Metaset) childs.get(0)).getValue();		
		String result = instance.getInstanceUnitsbyId(id);

        Metaset res = metBuilder.newMetaset("getInstanceUnitsbyIdResponse");
		Metaset returnSS = metBuilder.newMetaset("getInstanceUnitsbyIdReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	/**
	 * ̲ԪصʵʷϢ
	 * @param message
	 * @return
	 */
	public Metaset getHistoryInstanceUnits(Metaset message) {
		List childs = message.filter(".\\*").getChildrens();
		// Ϊַ
		String id = ((Metaset) childs.get(0)).getValue();		
		String result = instance.getHistoryInstanceUnits(id);

		Metaset res = metBuilder.newMetaset("getHistoryInstanceUnitsResponse");
		Metaset returnSS = metBuilder.newMetaset("getHistoryInstanceUnitsReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
	
	/**
	 * ʷԼ͵ʵĿ
	 */
	public Metaset getHistoryInstanceCount(Metaset message) {
	
		String result = instance.getHistoryInstanceCount();

		Metaset res = metBuilder.newMetaset("getHistoryInstanceCountResponse");
		Metaset returnSS = metBuilder.newMetaset("getHistoryInstanceCountReturn"); // +Return
		returnSS.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		returnSS.setValue(result);
		res.addChildren(returnSS);

		return res;
	}
		
	public Metaset getActiveInstance(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getActiveInstance(tmp0);

		Metaset response = metBuilder.newMetaset("getActiveInstanceResponse");
		Metaset ret = metBuilder.newMetaset("getActiveInstanceReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}

	public Metaset getActivity(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getActivity(tmp0);

		Metaset response = metBuilder.newMetaset("getActivityResponse");
		Metaset ret = metBuilder.newMetaset("getActivityReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}

	public Metaset getHistoryActivity(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getHistoryActivity(tmp0);

		Metaset response = metBuilder.newMetaset("getHistoryActivityResponse");
		Metaset ret = metBuilder.newMetaset("getHistoryActivityReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;

	}
	
	public Metaset ActivetoSuspend(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.ActivetoSuspend(tmp0);

		Metaset response = metBuilder.newMetaset("ActivetoSuspendResponse");
		Metaset ret = metBuilder.newMetaset("ActivetoSuspendReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset SuspendtoActive(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.SuspendtoActive(tmp0);

		Metaset response = metBuilder.newMetaset("SuspendtoActiveResponse");
		Metaset ret = metBuilder.newMetaset("SuspendtoActiveReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset RunningtoSuspend(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.RunningtoSuspend(tmp0);

		Metaset response = metBuilder.newMetaset("RunningtoSuspendResponse");
		Metaset ret = metBuilder.newMetaset("RunningtoSuspendReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset RunningtoTerminate(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.RunningtoTerminate(tmp0);

		Metaset response = metBuilder.newMetaset("RunningtoTerminateResponse");
		Metaset ret = metBuilder.newMetaset("RunningtoTerminateReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset SuspendtoRunning(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.SuspendtoRunning(tmp0);

		Metaset response = metBuilder.newMetaset("SuspendtoRunningResponse");
		Metaset ret = metBuilder.newMetaset("SuspendtoRunningReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset SuspendtoTerminate(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.SuspendtoTerminate(tmp0);

		Metaset response = metBuilder.newMetaset("SuspendtoTerminateResponse");
		Metaset ret = metBuilder.newMetaset("SuspendtoTerminateReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;
	}
	
	public Metaset ProcessStatistic(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		String tmp2 = ((Metaset) parameters.get(2)).getValue();
		String tmp3 = ((Metaset) parameters.get(3)).getValue();
		String result = instance.ProcessStatistic(tmp0, tmp1, tmp2, tmp3);

		Metaset response = metBuilder.newMetaset("ProcessStatisticResponse");
		Metaset ret = metBuilder.newMetaset("ProcessStatisticReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);
		
		return response;

	}
	
	public Metaset TypeStatistic(Metaset message) {
		List parameters = message.filter(".\\*").getChildrens();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		String tmp2 = ((Metaset) parameters.get(2)).getValue();
		String result = instance.TypeStatistic(tmp0, tmp1, tmp2);

		Metaset response = metBuilder.newMetaset("TypeStatisticResponse");
		Metaset ret = metBuilder.newMetaset("TypeStatisticReturn");
		ret.addAttribute(metBuilder.newAttribute(new QName("","type", "xsi"), "xsd:string"));
		ret.setValue("" + result);
		response.addChildren(ret);

		return response;

	}
    

}