package org.act.ws.manage;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.ThreadPoolExecutor;

import org.act.xservices.rt.xcontainer.management.IContainerManagement;
import org.act.xservices.rt.xcontainer.management.ManagementConstants;
import org.act.xservices.rt.xcontainer.management.ManagementUtil;

/**
 * @version 2008-4-15
 * @author chenyy [chenyy@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class TreadPoolInfo {
	
	private static IContainerManagement containerManagement = ManagementUtil.getInstance().getContainerManagement();
	
	/**
	 * ִĽ߳
	 * @param name ̳߳
	 * @return
	 */
	public static String getTPActiveCount(String name)
	{
		String in = "";
        String out = "";

		if(name.equals("mtp"))
		{
		    
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getActiveCount());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getActiveCount());
			}
			
		    return (in + "#" + out);
			
		}
		else if(name.equals("stp"))
		{

			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getActiveCount());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getActiveCount());
			}

			return (in + "#" + out);

		}
		else if(name.equals("ptp"))
		{
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getActiveCount());
			}

			return (in + "#" + " ");
					
		}
		return "" + "#" + "";

	}
	
	/**
	 * ִе߳
	 * @param name ̳߳
	 * @return
	 */	
	public static String getTPCompletedTaskCount(String name)
	{
        String in = "";
        String out = "";
		if(name.equals("mtp"))
		{   
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCompletedTaskCount());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getCompletedTaskCount());
			}

			return (in + "#" + out);

		}
		else if(name.equals("stp"))
		{
            
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCompletedTaskCount());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getCompletedTaskCount());
			}
			
			return (in + "#" + out);

		}
		else if(name.equals("ptp"))
		{
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCompletedTaskCount());
			}

			return (in + "#" + " ");
	
		}
		return "" + "#" + "";

	}
	
	/**
	 * ߳
	 * @param name
	 * @return  
	 */	
	public static String getTPCorePoolSize(String name)
	{

        String in = "";
        String out = "";
		if(name.equals("mtp"))
		{   
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCorePoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getCorePoolSize());
			}

			return (in + "#" + out);

		}
		else if(name.equals("stp"))
		{
            
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCorePoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getCorePoolSize());
			}
			
			return (in + "#" + out);

		}
		else if(name.equals("ptp"))
		{
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getCorePoolSize());
			}

			return (in + "#" + " ");
	
		}
		
		return "" + "#" + "";
		
	}
	
	/**
	 * ߳
	 * @param name
	 * @return 
	 */
	public static String getTPMaximumPoolSize(String name)
	{

        String in = "";
        String out = "";
		if(name.equals("mtp"))
		{   
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getMaximumPoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getMaximumPoolSize());
			}

			return (in + "#" + out);

		}
		else if(name.equals("stp"))
		{
            
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getMaximumPoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getMaximumPoolSize());
			}
			
			return (in + "#" + out);

		}
		else if(name.equals("ptp"))
		{
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getMaximumPoolSize());
			}

			return (in + "#" + " ");
	
		}
		
		return "" + "#" + "";
		
	}
	
	/**
	 * еĵǰ߳
	 * @param name
	 * @return 
	 */
	public static String getTPPoolSize(String name)
	{

        String in = "";
        String out = "";
		if(name.equals("mtp"))
		{   
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getPoolSize());
			}

			return (in + "#" + out);

		}
		else if(name.equals("stp"))
		{
            
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			ExecutorService executorServiceOut = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_OUT);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}
			if(executorServiceOut instanceof ThreadPoolExecutor)
			{
				out =  String.valueOf(((ThreadPoolExecutor)executorServiceOut).getPoolSize());
			}
			
			return (in + "#" + out);

		}
		else if(name.equals("ptp"))
		{
			
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				in =  String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}

			return (in + "#" + " ");
	
		}
		
		return "" + "#" + "";
		
	}
		
	public static String getTPCurrentTreadCount(String name)
	{

		if(name.equals("mtp"))
		{   
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_MESSAGE_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				return String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}
			return "";	
		}
		else if(name.equals("stp"))
		{
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_SERVICE_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				return String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}
			return "";	
		}
		else if(name.equals("ptp"))
		{
			ExecutorService executorServiceIn = containerManagement.getThreadPool(ManagementConstants.THREADPOOL_ADAPTATION_IN);
			
			if(executorServiceIn instanceof ThreadPoolExecutor)
			{
				return String.valueOf(((ThreadPoolExecutor)executorServiceIn).getPoolSize());
			}
			return "";	
		}
		return "";
	}
}
