
package org.act.wsn.samples1;

import java.io.InputStream;
import java.util.Calendar;

import javax.xml.namespace.QName;

import org.act.xservices.rt.metaset.Metaset;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetBuilderFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xnotification.resourcecallback.NotificationResourceMonitor;
import org.act.xservices.rt.xresource.resource.IResourceCallBack;
import org.act.xservices.rt.xresource.resource.IResourceLifetime;
import org.act.xservices.rt.xresource.resource.IResourceWithCallback;
import org.act.xservices.rt.xresource.resource.ResourceProperties;
import org.act.xservices.rt.xresource.resource.ResourceProperty;



public class Counter1 implements IResourceWithCallback,IResourceLifetime{
	
	/** */
	private static final long serialVersionUID = 1L;
	private String key;
	private ResourceProperties properties;
	private Calendar terminationTime;
	
	private NotificationResourceMonitor resourceMonitor;
	private MetasetBuilder metBuilder = MetasetBuilderFactory.newInstance().getMetasetBuilder();
	
	public void init(){
		properties = new ResourceProperties("tns","CounterResourceProperties");
		
		properties.addAttribute(
				metBuilder.newAttribute(new QName("","tns","xmlns"),
						"http://ws.act.org/resource/example/counter"));
		
		ResourceProperty property = new ResourceProperty("tns","counter");
		property.setValue("10");
		properties.add(property);
		ResourceProperty termination = new ResourceProperty("tns","TerminationTime");
		termination.setValue("2009-04-09T12:30:30Z");
		properties.add(termination);

		/**
		<wstop:Topic xmlns="http://schemas.xmlsoap.org/soap/envelope/" xmlns:wstop="http://docs.oasis-open.org/wsn/t-2"  xmlns:newsSpace="http://www.newsSpace.com"  xmlns:wsa="http://schemas.xmlsoap.org/ws/2003/03/addressing"  xmlns:wsnt="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd">  
		<TopicNamespace name="newsSpace" targetNamespace="http://www.newsSpace.com">
		</TopicNamespace>
		<wsnt:TopicExpression Dialect= "http://docs.oasis-open.org/wsn/t-1/TopicExpression/Concrete">newsSpace:news/sports</wsnt:TopicExpression>
		<wsnt:ProducerReference>
		<wsa:Address>http://localhost:8080/wsn/services/news/sports</wsa:Address>
		</wsnt:ProducerReference>
		</wstop:Topic>
		*/
		
		//
		InputStream confInput = this.getClass().getResourceAsStream("TopicConfig1.conf");
		
		try {
			Metaset confM = metBuilder.parse(confInput);

			// 
			Metaset topicExp = metBuilder.newMetaset(new QName("",
					"TopicExpression", "wsnt"));

			topicExp.addAttribute(
					metBuilder.newAttribute("Dialect",
									"http://docs.oasis-open.org/wsn/t-1/TopicExpression/Concrete"));
			topicExp.setValue("newsSpace1:news/sports-" + key);

			confM.addChildren(topicExp);

			// ---
			System.out.println(confM.toXML());

			resourceMonitor = new NotificationResourceMonitor(confM);

		} catch (MetasetParsingException e1) {
			e1.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	
	public Object getID(){
		return this.key;
	}
	
	public void setID(Object id){
		this.key = (String)id;
	}
	
	public ResourceProperties getResourceProperties(){
		return this.properties;
	}
	
	public void setResourceProperties(ResourceProperties rpDocument){
		this.properties = rpDocument;
	}
	
	public void destroy(){
		
	}
	
	public Calendar getCurrentTime(){
		return Calendar.getInstance();
	}
	
	public Calendar getTerminationTime(){
		return this.terminationTime;
	}
	
	public void setTerminationTime(Calendar terminationTime){
		this.terminationTime = terminationTime;
	}


	public void addCallback(IResourceCallBack callback) {
		// TODO Auto-generated method stub
		
	}
	
	public IResourceCallBack getResourceCallBack() {
		// TODO Auto-generated method stub
		return resourceMonitor;
	}
	
	
}
