/**
 * Logback: the reliable, generic, fast and flexible logging framework.
 * Copyright (C) 1999-2009, QOS.ch. All rights reserved.
 *
 * This program and the accompanying materials are dual-licensed under
 * either the terms of the Eclipse Public License v1.0 as published by
 * the Eclipse Foundation
 *
 *   or (per the licensee's choosing)
 *
 * under the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation.
 */
package org.act.xservices.log.classic;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.act.xservices.log.LoggerFactory;

import org.act.xservices.log.core.status.StatusManager;
import org.act.xservices.log.core.status.ViewStatusMessagesServletBase;

public class ViewStatusMessagesServlet extends ViewStatusMessagesServletBase {

  private static final long serialVersionUID = 443878494348593337L;


  @Override
  protected StatusManager getStatusManager(HttpServletRequest req, HttpServletResponse resp) {
    LoggerContext lc = (LoggerContext) LoggerFactory.getILoggerFactory();
    return lc.getStatusManager();
  }

  @Override
  protected String getPageTitle(HttpServletRequest req, HttpServletResponse resp) {
    LoggerContext lc = (LoggerContext) LoggerFactory.getILoggerFactory();
    return "<h2>Status messages for LoggerContext named ["
        + lc.getName() + "]</h2>\r\n";
  }

}
