/**
 * Logback: the reliable, generic, fast and flexible logging framework.
 * Copyright (C) 1999-2009, QOS.ch. All rights reserved.
 *
 * This program and the accompanying materials are dual-licensed under
 * either the terms of the Eclipse Public License v1.0 as published by
 * the Eclipse Foundation
 *
 *   or (per the licensee's choosing)
 *
 * under the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation.
 */
package org.act.xservices.log.classic.filter;

import org.act.xservices.log.classic.Level;
import org.act.xservices.log.classic.spi.ILoggingEvent;

import org.act.xservices.log.core.filter.AbstractMatcherFilter;
import org.act.xservices.log.core.spi.FilterReply;

/**
 * A class that filters events by the level equality.

 * <p>
 * For more information about this filter, please refer to the online manual at
 * http://log.qos.ch/manual/filters.html#levelFilter
 * 
 * @author Ceki G&uuml;lc&uuml;
 * @author S&eacute;bastien Pennec
 */
/**
 * ݼ¼Լ¼¼
 */
public class LevelFilter extends AbstractMatcherFilter<ILoggingEvent> {

  Level level;
/**
 * Ҫʵֵĺ
 * 
 */
  @Override
  public FilterReply decide(ILoggingEvent event) {
    if (!isStarted()) {
      return FilterReply.NEUTRAL;
    }

    if (event.getLevel().equals(level)) {
      return onMatch;
    } else {
      return onMismatch;
    }
  }

  public void setLevel(String level) {
    this.level = Level.toLevel(level);
  }

  public void start() {
    if (this.level != null) {
      super.start();
    }
  }
}
