/**
 * Logback: the reliable, generic, fast and flexible logging framework.
 * Copyright (C) 1999-2009, QOS.ch. All rights reserved.
 *
 * This program and the accompanying materials are dual-licensed under
 * either the terms of the Eclipse Public License v1.0 as published by
 * the Eclipse Foundation
 *
 *   or (per the licensee's choosing)
 *
 * under the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation.
 */
package org.act.xservices.log.classic.sift;

import java.util.ArrayList;
import java.util.List;

import org.xml.sax.Attributes;

import org.act.xservices.log.core.joran.action.Action;
import org.act.xservices.log.core.joran.event.InPlayListener;
import org.act.xservices.log.core.joran.event.SaxEvent;
import org.act.xservices.log.core.joran.spi.ActionException;
import org.act.xservices.log.core.joran.spi.InterpretationContext;

public class SiftAction extends Action implements InPlayListener {
  List<SaxEvent> seList;

  @Override
  public void begin(InterpretationContext ec, String name, Attributes attributes)
      throws ActionException {
    seList = new ArrayList<SaxEvent>();
    ec.addInPlayListener(this);
  }

  @Override
  public void end(InterpretationContext ec, String name) throws ActionException {
    ec.removeInPlayListener(this);
    Object o = ec.peekObject();
    if (o instanceof SiftingAppender) {
      SiftingAppender sa = (SiftingAppender) o;
      AppenderFactory appenderFactory = new AppenderFactory(seList, sa
          .getDiscriminatorKey());
      sa.setAppenderFactory(appenderFactory);
    }
  }

  public void inPlay(SaxEvent event) {
    seList.add(event);
  }

  public List<SaxEvent> getSeList() {
    return seList;
  }

}
