package org.act.xservices.engine.rt;

import org.act.xservices.bpel11.TActivity;
import org.act.xservices.engine.rt.locale.StringManager;
import org.act.xservices.engine.rt.locale.StringManagerFactory;
import org.act.xservices.engine.rt.utils.TimeUtil;

public abstract class ActivityInstance {
	
	public static final int STATE_INACTIVE = 0;
	
	public static final int STATE_ACTIVE = 1;
	
	public static final int STATE_SUSPENDED = 2;
	
	public static final int STATE_COMPLETED = 3;
	
	protected StringManager StringManager =StringManagerFactory.getStringManager();
	
	protected String type;
	
	protected String name;
	
	protected InstanceUnit instanceUnit;
	
	protected int state = STATE_INACTIVE;
	
	protected String startTime;
	
	protected String endTime;
	
	//¼ActivityInstanceӦTActivity
	protected TActivity activity;
	
	//¼ActivityInstanceĸActivityInstance
	private  ActivityInstance activityInstanceOfFather;
	
	public void setActivity(TActivity activity){
		this.activity = activity;
	}
	
	public TActivity getActivity(){
		return activity;
	}
	
	public void setActivityInstanceOfFather(ActivityInstance activityInstanceOfFather){
		this.activityInstanceOfFather = activityInstanceOfFather;
	}
	
	public ActivityInstance getActivityInstanceOfFather(){
		return activityInstanceOfFather;
	}
	public String getType() {		
		return type;
	}

	public String getName() {
		return name;
	}
	
	public String getStartTime() {
		return startTime;
	}

	public String getEndTime() {
		return endTime;
	}

	public int getState() {
		return state;
	}
	
	public void start() {
		//¼ActivityInstanceĸActivityInstance
		this.setActivityInstanceOfFather(this.instanceUnit.getActivityInstanceFinished());
		
		state = STATE_ACTIVE;
		startTime = TimeUtil.getNowTime();
		System.out.println("");
		if(this.name != null) {
			System.out.println("***"+this.type+": "+ this.name+"***");
		}
		else{
			System.out.println("***"+this.type+"***");
		}
		instanceUnit.addActivityInstance(this);
	}
	
	public abstract void run() throws Exception;
	
	public void suspend() {
		state = STATE_SUSPENDED;
	}
	
	public void resume() {
		state = STATE_ACTIVE;
	}
	
	public void finish() {
		state = STATE_COMPLETED;
		endTime = TimeUtil.getNowTime();
		//¼Ļʵ
		this.instanceUnit.setActivityInstanceFinished(this);
	}

	public void setEndTime(String endTime) {
		this.endTime = endTime;
	}

	public InstanceUnit getInstanceUnit() {
		return instanceUnit;
	}
}
