package org.act.xservices.engine.rt;

import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;

public class MessageContainer {

	private String partnerLink;

	private String operation;

	private IServiceContext message;

	private Object waitPoint = new Object();
	
	private IServiceContext context;

	public IServiceContext getContext() {
		return context;
	}

	public void setContext(IServiceContext context) {
		this.context = context;
	}
	
	public void removeContext() {
		context = null;
	}

	public String getPartnerLink() {
		return partnerLink;
	}

	public void setPartnerLink(String partnerLink) {
		this.partnerLink = partnerLink;
	}

	public String getOperation() {
		return operation;
	}

	public void setOperation(String operation) {
		this.operation = operation;
	}

	public IServiceContext getMessage() {
		if (message == null) {
			synchronized (waitPoint) {
				try {
					waitPoint.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
		return message;
	}

	public void setMessage(IServiceContext message) {
		this.message = message;
		synchronized (waitPoint) {
			waitPoint.notifyAll();
		}
	}
	
	public void removeMessage() {
		message = null;
	}
	
	public boolean hasMessage() {
		if(message == null) {
			return false;
		}
		return true;
	}
}
