/**
 * 
 */
package org.act.xservices.engine.rt.aspect;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.act.xservices.bpel11.CaseType;
import org.act.xservices.bpel11.ProcessFactory;
import org.act.xservices.bpel11.TActivity;
import org.act.xservices.bpel11.TActivityContainer;
import org.act.xservices.bpel11.TAssign;
import org.act.xservices.bpel11.TCopy;
import org.act.xservices.bpel11.TEmpty;
import org.act.xservices.bpel11.TExtensibleElements;
import org.act.xservices.bpel11.TFlow;
import org.act.xservices.bpel11.TFrom;
import org.act.xservices.bpel11.TInvoke;
import org.act.xservices.bpel11.TOnAlarm;
import org.act.xservices.bpel11.TOnMessage;
import org.act.xservices.bpel11.TPartnerLink;
import org.act.xservices.bpel11.TPick;
import org.act.xservices.bpel11.TReceive;
import org.act.xservices.bpel11.TReply;
import org.act.xservices.bpel11.TRoles;
import org.act.xservices.bpel11.TScope;
import org.act.xservices.bpel11.TSequence;
import org.act.xservices.bpel11.TSwitch;
import org.act.xservices.bpel11.TTerminate;
import org.act.xservices.bpel11.TThrow;
import org.act.xservices.bpel11.TVariable;
import org.act.xservices.bpel11.TWait;
import org.act.xservices.bpel11.TWhile;
import org.act.xservices.bpel11.ToType;
import org.act.xservices.bpel11.TBoolean;
import org.act.xservices.engine.rt.aspect.model.Advice;
import org.act.xservices.engine.rt.aspect.model.Aspect;
import org.act.xservices.engine.rt.aspect.model.Aspect_Tag;
import org.act.xservices.engine.rt.aspect.model.Pointcut;

import org.eclipse.emf.common.util.EList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

/**
 * aspectĲ
 * @author 
 *
 */
public class AspectParsing {	
	/**
	 * aspectļAspect
	 * 
	 * @param file
	 *            aspectļ·
	 * @return Aspect
	 * @throws Exception
	 */
	public static Aspect parse(File aspectFile) throws Exception {

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		builder = dbf.newDocumentBuilder();
		Document doc = builder.parse(aspectFile);
		Element aspect_elem = doc.getDocumentElement(); // ȡԪ<aspect>
		String name=aspect_elem.getAttribute(Aspect_Tag.Name);
		
		Element pointcut_elem = (Element) aspect_elem.getElementsByTagName(
				Aspect_Tag.Pointcut).item(0);
		Pointcut pointcut = new Pointcut();
		pointcut.setName(pointcut_elem.getAttribute(Aspect_Tag.Name));
		if(pointcut_elem.getAttribute(Aspect_Tag.Pointcut_contextCollection).equalsIgnoreCase("true")){
			pointcut.setContextCollection(true);
		}else{
			if(pointcut_elem.getAttribute(Aspect_Tag.Pointcut_contextCollection).equalsIgnoreCase("false")){
				pointcut.setContextCollection(false);
			}
		}
		pointcut.setXPath(pointcut_elem.getFirstChild().getNodeValue());
		
		Element advice_elem = (Element) aspect_elem.getElementsByTagName(
				Aspect_Tag.Advice).item(0);	
		Advice advice = new Advice();
		advice.setType(advice_elem.getAttribute(Aspect_Tag.Type));
		
		//aspectname, pointcut,advice
		Aspect aspect = new Aspect(name, pointcut, advice);
		
		//aspectռ
		aspect.setTargetNamespace(aspect_elem.getAttribute(Aspect_Tag.TargetNamespace));
		aspect.setXmlns(aspect_elem.getAttribute(Aspect_Tag.Xmlns));
		NamedNodeMap nnm = aspect_elem.getAttributes();
		for(int i = 0; i < nnm.getLength(); i++){
			if(nnm.item(i).getNodeName().contains(":")){
				aspect.getExtendedNameSpaces().put(nnm.item(i).getNodeName(), nnm.item(i).getNodeValue());
			}
		}
		
		//xpath
		//aspect.setPoints(getCutinPoint(pointcut.getXPath()));
		
		String aspectType = aspect_elem.getAttribute(Aspect_Tag.Type);
		if (aspectType != null) {
			aspect.setType(aspectType);
		}
		for (int i = 0; i < advice_elem.getChildNodes().getLength(); i++) {
			if (advice_elem.getChildNodes().item(i).getNodeName() != "#text"){
				//سchildNodes()
				Element child = (Element) advice_elem.getChildNodes().item(i);
				String tagName = child.getNodeName();
				if (tagName.equals(Aspect_Tag.PartnerLinks)) {

					// partnerLink
					for (int j = 0; j < child.getChildNodes().getLength(); j++) {
						if (child.getChildNodes().item(j).getNodeName() != "#text"){
							Element node = (Element) child.getChildNodes().item(j);
							TPartnerLink partnerLink = ProcessFactory.eINSTANCE
									.createTPartnerLink();
							
							//ZYJ partnerLinkTypeΪQName
							String qname = node.getAttribute(Aspect_Tag.PartnerLinkType);
							int index = qname.indexOf(":");
							String prefix = qname.substring(0, index);
							String localPart = qname.substring(index+1);
							QName partnerLinkType = null;
							if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix)){
								String namespaceURI = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix);
								partnerLinkType = new QName(namespaceURI, localPart, prefix);
							}else{
								throw new Exception("Find no namespaceURI of partnerLinkType="+ qname);
							}
							partnerLink.setPartnerLinkType(partnerLinkType);
							
							partnerLink.setName(node.getAttribute(Aspect_Tag.Name));
							//javaStringĿΪnull,ԵĿΪ
							if(node.getAttribute(Aspect_Tag.PartnerLink_MyRole) != ""){
								partnerLink.setMyRole(node
										.getAttribute(Aspect_Tag.PartnerLink_MyRole));
							}
							if(node.getAttribute(Aspect_Tag.PartnerLink_PartnerRole) != ""){
								partnerLink.setPartnerRole(node
										.getAttribute(Aspect_Tag.PartnerLink_PartnerRole));
							}
							advice.getPartnerLinks().put(partnerLink.getName(),
									partnerLink);
						}	
					}
				} else if (tagName.equals(Aspect_Tag.Variables)) {
					// variable

					for (int j = 0; j < child.getChildNodes().getLength(); j++) {
						if (child.getChildNodes().item(j).getNodeName() != "#text"){
							Element node = (Element) child.getChildNodes().item(j);
							TVariable variable = ProcessFactory.eINSTANCE
									.createTVariable();
							variable.setName(node.getAttribute(Aspect_Tag.Name));

							//	ZYJ messageTypeΪQName
							String qname = node.getAttribute(Aspect_Tag.Variable_MessageType);
							if(qname != ""){
								int index = qname.indexOf(":");
								String prefix = qname.substring(0, index);
								String localPart = qname.substring(index+1);
								QName messageType = null;
								if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix)){
									String namespaceURI = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix);
									messageType = new QName(namespaceURI, localPart, prefix);
								}else{
									throw new Exception("Find no namespaceURI of messageType="+ qname);
								}
								variable.setMessageType(messageType);
							}
						
							//TypeΪQName
							String qname1 = node.getAttribute(Aspect_Tag.Variable_Type);
							if(qname1 != ""){
								int index1 = qname1.indexOf(":");
								String prefix1 = qname1.substring(0, index1);
								String localPart1 = qname1.substring(index1+1);
								QName type = null;
								if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix1)){
									String namespaceURI1 = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix1);
									type = new QName(namespaceURI1, localPart1, prefix1);
								}else{
									throw new Exception("Find no namespaceURI of type="+ qname);
								}	
								variable.setType(type);
							}
							
							//elementΪQName
							String qname2 = node.getAttribute(Aspect_Tag.Variable_element);
							if(qname2 != ""){
								int index2 = qname.indexOf(":");
								String prefix2 = qname.substring(0, index2);
								String localPart2 = qname.substring(index2+1);
								QName element = null;
								if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix2)){
									String namespaceURI2 = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix2);
									element = new QName(namespaceURI2, localPart2, prefix2);
								}else{
									throw new Exception("Find no namespaceURI of element="+ qname);
								}	
								variable.setElement(element);
							}
						
							advice.getVariables().put(variable.getName(), variable);
						}
					}
				} else {
					// activity
					TActivity activity = createActivity(aspect,child);
					advice.setActivity(activity);
				}
			}		
		}
		aspect.setAdvice(advice);
		return aspect;
	}
	/**
	 * XMLڵ㴴
	 * 
	 * @param child
	 * @return
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 */
	private static TActivity createActivity(Aspect aspect,Element child) throws SecurityException,
			IllegalArgumentException, NoSuchMethodException,
			IllegalAccessException, InvocationTargetException {
		if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Sequence)) {
			TSequence sequence = ProcessFactory.eINSTANCE.createTSequence();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				sequence.setName(child.getAttribute(Aspect_Tag.Name));
			}
			for (int i = 0; i < child.getChildNodes().getLength(); i++) {
				if(child.getChildNodes().item(i).getNodeName() != "#text"){
					TActivity activity = createActivity(aspect,(Element) child
							.getChildNodes().item(i));
					addSubActivity(sequence, activity);
				}	
			}
			return sequence;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Switch)) {
			TSwitch switch1 = ProcessFactory.eINSTANCE.createTSwitch();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				switch1.setName(child.getAttribute(Aspect_Tag.Name));
			}
			for (int i = 0; i < child.getChildNodes().getLength(); i++) {
				if(child.getChildNodes().item(i).getNodeName() != "#text"){
					Node node = child.getChildNodes().item(i);
					if (node.getNodeName().equals(Aspect_Tag.Case)) {
						CaseType caseType = ProcessFactory.eINSTANCE
								.createCaseType();
						switch1.getCase().add(caseType);
						caseType.setCondition(child
								.getAttribute(Aspect_Tag.Case_Condition));
						int j = 0; 
						for(;j < node.getChildNodes().getLength(); j++){
							if(node.getChildNodes().item(j).getNodeName() != "#text"){
								break;
							}
						}
						if (j != node.getChildNodes().getLength()) {

							TActivity activity = createActivity(aspect,(Element) node
									.getChildNodes().item(j));
							setSubActivity(caseType, activity);
						}
					} else if (node.getNodeName().equals(Aspect_Tag.Otherwise)) {
						TActivityContainer otherwise = ProcessFactory.eINSTANCE
								.createTActivityContainer();
						switch1.setOtherwise(otherwise);
						int j = 0;
						for(;j < node.getChildNodes().getLength(); j++){
							if(node.getChildNodes().item(j).getNodeName() != "#text"){
								break;
							}
						}
						if (j != node.getChildNodes().getLength()) {
							TActivity activity = createActivity(aspect,(Element) node
									.getChildNodes().item(j));
							setSubActivity(otherwise, activity);
						}
					}
				}				
			}
			return switch1;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Pick)) {
			TPick pick = ProcessFactory.eINSTANCE.createTPick();
			pick.setName(child.getAttribute(Aspect_Tag.Name));
			for (int i = 0; i < child.getChildNodes().getLength(); i++) {
				if(child.getChildNodes().item(i).getNodeName() != "#text"){
					Node node = child.getChildNodes().item(i);
					if (node.getNodeName().equals(Aspect_Tag.Pick_OMessage)) {
						TOnMessage onMessage = ProcessFactory.eINSTANCE
								.createTOnMessage();
						pick.getOnMessage().add(onMessage);
						onMessage.setPartnerLink(child
								.getAttribute(Aspect_Tag.PartnerLink));
						onMessage.setOperation(child
								.getAttribute(Aspect_Tag.PartnerLink));
						int j = 0;
						for (; j <= node.getChildNodes().getLength(); j++){
							if(node.getChildNodes().item(j).getNodeName() != "#text"){
								break;
							}
						}
						if (j != node.getChildNodes().getLength()) {
							TActivity activity = createActivity(aspect,(Element) node
									.getChildNodes().item(j));
							setSubActivity(onMessage, activity);
						}
					} else if (node.getNodeName().equals(Aspect_Tag.Pick_OAlarm)) {
						TOnAlarm onAlarm = ProcessFactory.eINSTANCE
								.createTOnAlarm();
						pick.getOnAlarm().add(onAlarm);
						onAlarm.setFor(((Element) node)
								.getAttribute(Aspect_Tag.For));
						onAlarm.setUntil(((Element) node)
								.getAttribute(Aspect_Tag.For));
						int j = 0;
						for (; j <= node.getChildNodes().getLength(); j++){
							if(node.getChildNodes().item(j).getNodeName() != "#text"){
								break;
							}
						}
						if (j != node.getChildNodes().getLength()) {
							TActivity activity = createActivity(aspect,(Element) node.getChildNodes().item(j));
							setSubActivity(onAlarm, activity);
						}
					}
				}
			}//endfor
				
			return pick;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.While)) {
			TWhile while1 = ProcessFactory.eINSTANCE.createTWhile();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				while1.setName(child.getAttribute(Aspect_Tag.Name));
			}
			int j = 0;
			for (; j <= child.getChildNodes().getLength(); j++){
				if(child.getChildNodes().item(j).getNodeName() != "#text"){
					break;
				}
			}
			if (j != child.getChildNodes().getLength()) {
				TActivity activity = createActivity(aspect,(Element) child
						.getChildNodes().item(j));
				setSubActivity(while1, activity);
			}
			return while1;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Scope)) {
			TScope scope = ProcessFactory.eINSTANCE.createTScope();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				scope.setName(child.getAttribute(Aspect_Tag.Name));
			}
			int j = 0;
			for (; j <= child.getChildNodes().getLength(); j++){
				if(child.getChildNodes().item(j).getNodeName() != "#text"){
					break;
				}
			}
			if (j != child.getChildNodes().getLength()) {
				TActivity activity = createActivity(aspect,(Element) child
						.getChildNodes().item(j));
				setSubActivity(scope, activity);
			}
			return scope;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Flow)) {
			TFlow flow = ProcessFactory.eINSTANCE.createTFlow();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				flow.setName(child.getAttribute(Aspect_Tag.Name));
			}
			for (int i = 0; i < child.getChildNodes().getLength(); i++) {
				if(child.getChildNodes().item(i).getNodeName() != "#text"){
					TActivity activity =createActivity(aspect,(Element) child
							.getChildNodes().item(i));
					addSubActivity(flow, activity);
				}
			}//endfor
			return flow;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Invoke)) {
			TInvoke invoke = ProcessFactory.eINSTANCE.createTInvoke();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				invoke.setName(child.getAttribute(Aspect_Tag.Name));
			}
			invoke.setPartnerLink(child.getAttribute(Aspect_Tag.PartnerLink));
			invoke.setPortType(child.getAttribute(Aspect_Tag.PortType));
			invoke.setOperation(child.getAttribute(Aspect_Tag.Operation));
			invoke.setInputVariable(child
					.getAttribute(Aspect_Tag.Invoke_inputVariable));
			if(child.getAttribute(Aspect_Tag.Invoke_outputVariable) != ""){
				invoke.setOutputVariable(child
						.getAttribute(Aspect_Tag.Invoke_outputVariable));
			}
			return invoke;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Receive)) {
			TReceive receive = ProcessFactory.eINSTANCE.createTReceive();
			receive.setName(child.getAttribute(Aspect_Tag.Name));
			receive.setPartnerLink(child.getAttribute(Aspect_Tag.PartnerLink));
			receive.setPortType(child.getAttribute(Aspect_Tag.PortType));
			receive.setOperation(child.getAttribute(Aspect_Tag.Operation));
			receive.setVariable(child.getAttribute(Aspect_Tag.Variable));
			receive.setCreateInstance(TBoolean
					.get(Aspect_Tag.Receive_createInstance));
			//ZYJ receiveеcorrelations
			/*for(int i = 0;i < child.getChildNodes().getLength(); i++){
				if(child.getChildNodes().item(i).getNodeName()
						.equalsIgnoreCase(Aspect_Tag.Receive_correlations)){
					Node child1 = child.getChildNodes().item(i);
					TCorrelations correlations = ProcessFactory.eINSTANCE.createTCorrelations();;
					for(int j = 0; j < child1.getChildNodes().getLength(); j++){
						if(child1.getChildNodes().item(j).getNodeName()
								.equalsIgnoreCase(Aspect_Tag.Correlation)){
							TCorrelation correlation = ProcessFactory.eINSTANCE.createTCorrelation();
							Node child2 = child1.getChildNodes().item(j);
							if(((Element)child2).getAttribute(Aspect_Tag.Correlation_initiate) != ""){
								correlation.setInitiate(TBoolean.get(((Element)child2)
										.getAttribute(Aspect_Tag.Correlation_initiate)));
							}
							correlation.setSet(((Element)child2)
									.getAttribute(Aspect_Tag.Correlation_initiate));
							//correlations.޷
						}
					}
					
					receive.setCorrelations(correlations);
					break; //ÿreceiveֻһcorrelations
				}
			}*/
			
			return receive;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Reply)) {
			TReply reply = ProcessFactory.eINSTANCE.createTReply();
			reply.setName(child.getAttribute(Aspect_Tag.Name));
			reply.setPartnerLink(child.getAttribute(Aspect_Tag.PartnerLink));
			reply.setPortType(child.getAttribute(Aspect_Tag.PortType));
			reply.setOperation(child.getAttribute(Aspect_Tag.Operation));
			reply.setVariable(child.getAttribute(Aspect_Tag.Variable));
			reply.setFaultName(child.getAttribute(Aspect_Tag.Reply_faultName));
			return reply;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Assign)) {
			TAssign assign = ProcessFactory.eINSTANCE.createTAssign();
			assign.setName(child.getAttribute(Aspect_Tag.Name));
			for (int i = 0; i < child.getChildNodes().getLength(); i++) {
				if (child.getChildNodes().item(i).getNodeName() != "#text"){
					Node node = child.getChildNodes().item(i);
					if (node.getNodeName().equals(Aspect_Tag.Assign_Copy)) {
						TCopy copy = ProcessFactory.eINSTANCE.createTCopy();
						Element fromMode = null;
						for(int fr = 0; fr < node.getChildNodes().getLength(); fr++){//xmlĵĻسchildNode
							if(node.getChildNodes().item(fr).getNodeName() != "#text"){
							  fromMode = (Element) node.getChildNodes().item(fr); 
								break;
							}
						}
						if (fromMode != null && fromMode.getNodeName()
								.endsWith(Aspect_Tag.Assign_From)) {
							TFrom from = ProcessFactory.eINSTANCE.createTFrom();
							if(fromMode.getAttribute(Aspect_Tag.Variable) != ""){//DOMĽΪʱΪ
								from.setVariable(fromMode
										.getAttribute(Aspect_Tag.Variable));
							}
							if(fromMode.getAttribute(Aspect_Tag.Variable_Part) != ""){
								from.setPart(fromMode
										.getAttribute(Aspect_Tag.Variable_Part));
							}
							if(fromMode.getAttribute(Aspect_Tag.Variable_Query) != ""){
								from.setQuery(fromMode.getAttribute(Aspect_Tag.Variable_Query));
							}			
							
							//ZYJ property趨ΪQName
							QName property = null;
							String qname = fromMode.getAttribute(Aspect_Tag.Variable_Property);
							if(qname != ""){
								int index = qname.indexOf(":");
								String prefix = qname.substring(0, index);
								String localPart = qname.substring(index+1);
								if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix)){
									String namespaceURI = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix);
									property = new QName(namespaceURI, localPart, prefix);
								}
							}
							from.setProperty(property);
							if(fromMode.getAttribute(Aspect_Tag.PartnerLink) != ""){
								from.setPartnerLink(fromMode
										.getAttribute(Aspect_Tag.PartnerLink));
							}	
							if (fromMode.getAttribute(
									Aspect_Tag.PartnerLink_EndpointReference)
									.equals(Aspect_Tag.PartnerLink_MyRole)) {
								from.setEndpointReference(TRoles.MY_ROLE);
							} else if (fromMode.getAttribute(
									Aspect_Tag.PartnerLink_EndpointReference)
									.equals(Aspect_Tag.PartnerLink_PartnerRole)) {
								from.setEndpointReference(TRoles.PARTNER_ROLE);
							}
							if(fromMode.getAttribute(Aspect_Tag.Assign_Expression) != ""){
								from.setExpression(fromMode
										.getAttribute(Aspect_Tag.Assign_Expression));
							}
							copy.setFrom(from);
						}
						Element toMode = null;
						for(int to = node.getChildNodes().getLength()-1;
											to >= 0; to--){//xmlĵĻسchildNode
							if(node.getChildNodes().item(to).getNodeName() != "#text"){
								toMode = (Element) node.getChildNodes().item(to);
								break;
							}
						}
						if (toMode !=null && toMode.getNodeName().endsWith( Aspect_Tag.Assign_TO)) {//ǴСд
							
							ToType toType = ProcessFactory.eINSTANCE.createToType();
							if(toMode.getAttribute(Aspect_Tag.Variable) != ""){
								
								toType.setVariable(toMode
										.getAttribute(Aspect_Tag.Variable));
							}
							if(toMode.getAttribute(Aspect_Tag.Variable_Part) != ""){
								toType.setPart(toMode
										.getAttribute(Aspect_Tag.Variable_Part));
							}
							if(toMode.getAttribute(Aspect_Tag.Variable_Query) != ""){
								toType.setQuery(toMode.getAttribute(Aspect_Tag.Variable_Query));
							}
							// property趨ΪQName
							QName property = null;
							String qname = toMode.getAttribute(Aspect_Tag.Variable_Property);
							if(qname != ""){
								int index = qname.indexOf(":");
								String prefix = qname.substring(0, index);
								String localPart = qname.substring(index+1);
								if(aspect.getExtendedNameSpaces().containsKey(Aspect_Tag.Xmlns+":"+prefix)){
									String namespaceURI = aspect.getExtendedNameSpaces().get(Aspect_Tag.Xmlns+":"+prefix);
									property = new QName(namespaceURI, localPart, prefix);
								}
							}
							toType.setProperty(property);
							
							if(toMode.getAttribute(Aspect_Tag.PartnerLink) != ""){
								toType.setPartnerLink(toMode
										.getAttribute(Aspect_Tag.PartnerLink));
							}
							copy.setTo(toType);
						}
						assign.getCopy().add(copy);
					}
				}	
			}
			return assign;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Terminate)) {
			TTerminate terminate = ProcessFactory.eINSTANCE.createTTerminate();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				terminate.setName(child.getAttribute(Aspect_Tag.Name));
			}
			return terminate;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Empty)) {
			TEmpty empty = ProcessFactory.eINSTANCE.createTEmpty();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				empty.setName(child.getAttribute(Aspect_Tag.Name));
			}
			return empty;
		} else if (child.getNodeName().equalsIgnoreCase(Aspect_Tag.Wait)) {
			TWait wait = ProcessFactory.eINSTANCE.createTWait();
			if(child.getAttribute(Aspect_Tag.Name) != ""){
				wait.setName(child.getAttribute(Aspect_Tag.Name));
			}
			if(child.getAttribute(Aspect_Tag.For) != ""){
				wait.setFor(child.getAttribute(Aspect_Tag.For));
			}
			if(child.getAttribute(Aspect_Tag.Until) != ""){
				wait.setUntil(child.getAttribute(Aspect_Tag.Until));
			}
			return wait;
		}
		return null;
	}

	private static void setSubActivity(TExtensibleElements activityContainer,
			Object subActivity) throws SecurityException,
			NoSuchMethodException, IllegalArgumentException,
			IllegalAccessException, InvocationTargetException {
		Class<?> c = activityContainer.getClass();
		Method method;

		if (subActivity instanceof TInvoke) {
			method = c.getMethod("setInvoke", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TReceive) {
			method = c.getMethod("setReceive", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TReply) {
			method = c.getMethod("setReply", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TAssign) {
			method = c.getMethod("setAssign", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TTerminate) {
			method = c.getMethod("setTerminate", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TEmpty) {
			method = c.getMethod("setEmpty", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TThrow) {
			method = c.getMethod("setThrow", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TWait) {
			method = c.getMethod("setWait", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TSequence) {
			method = c.getMethod("setSequence", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TSwitch) {
			method = c.getMethod("setSwitch", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TWhile) {
			method = c.getMethod("setWhile", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TPick) {
			method = c.getMethod("setPick", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TFlow) {
			method = c.getMethod("setFlow", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		} else if (subActivity instanceof TScope) {
			method = c.getMethod("setReply", new Class[] {});
			method.invoke(activityContainer, new Object[] { subActivity });
		}
	}

	/**
	 * 򸸻ӻ
	 * 
	 * @param activity
	 *            
	 * @param subActivity
	 *            ӻ
	 * @throws SecurityException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 */
	//@SuppressWarnings("unchecked")
	@SuppressWarnings("unchecked")
	private static void addSubActivity(TActivity activity, Object subActivity)
			throws SecurityException, NoSuchMethodException,
			IllegalArgumentException, IllegalAccessException,
			InvocationTargetException {
		Class<?> c = activity.getClass();
		Method method;
		EList<Object> activitys;
		if (subActivity instanceof TInvoke) {
			method = c.getMethod("getInvoke", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TInvoke) subActivity);
			}
		} else if (subActivity instanceof TReceive) {
			method = c.getMethod("getReceive", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TReceive) subActivity);
			}
		} else if (subActivity instanceof TReply) {
			method = c.getMethod("getReply", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TReply) subActivity);
			}
		} else if (subActivity instanceof TAssign) {
			method = c.getMethod("getAssign", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TAssign) subActivity);
			}

		} else if (subActivity instanceof TTerminate) {
			method = c.getMethod("getTerminate", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TTerminate) subActivity);
			}
		} else if (subActivity instanceof TEmpty) {
			method = c.getMethod("getEmpty", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TEmpty) subActivity);
			}

		} else if (subActivity instanceof TThrow) {
			method = c.getMethod("getThrow", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TThrow) subActivity);
			}

		} else if (subActivity instanceof TWait) {
			method = c.getMethod("getWait", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TWait) subActivity);
			}

		} else if (subActivity instanceof TSequence) {
			method = c.getMethod("getSequence", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TSequence) subActivity);
			}

		} else if (subActivity instanceof TSwitch) {
			method = c.getMethod("getSwitch", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TSwitch) subActivity);
			}

		} else if (subActivity instanceof TWhile) {
			method = c.getMethod("getWhile", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TWhile) subActivity);
			}

		} else if (subActivity instanceof TPick) {
			method = c.getMethod("getPick", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TPick) subActivity);
			}

		} else if (subActivity instanceof TFlow) {
			method = c.getMethod("getFlow", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TFlow) subActivity);
			}

		} else if (subActivity instanceof TScope) {
			method = c.getMethod("getScope", new Class[] {});
			activitys = (EList<Object>) method
					.invoke(activity, new Object[] {});
			if (activitys != null) {
				activitys.add((TScope) subActivity);
			}

		}
	}	
}

