package org.act.xservices.engine.rt.aspect;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public  class XPathEvaluator {
	/**
	 * XMLĵõDOM
	 * @param xmlFileName
	 */
	private static Document getDom(String filePath){
		Document domTree = null;
		DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
		domFactory.setNamespaceAware(true);
		DocumentBuilder builder = null;
		try {
			builder = domFactory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		FileInputStream is = null;
		try {
			is = new FileInputStream(filePath);
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		try {
			domTree = builder.parse(is);
			domTree.normalize();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return domTree;
	}
	/**
	 * XPath
	 * @param xpathString
	 * @return
	 */
	public static NodeList evaluateXPath(String filePath, String xpathString){
		XPathFactory factory = XPathFactory.newInstance();
		XPath xpath = factory.newXPath();
		XPathExpression expr = null;
		try {
			expr = xpath.compile(xpathString);
		} catch (XPathExpressionException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		NodeList nl = null;
		try {
			System.out.println("dom: "+ getDom(filePath).getDocumentElement().getAttribute("targetNamespace"));
			nl = (NodeList) expr.evaluate(getDom(filePath), XPathConstants.NODESET);
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("node:" + nl.getLength());
		return nl;
	}
	/**
	 * NodeListڵ
	 * @param nl
	 */
	public void outputNL(NodeList nl){
		for(int i=0; i<nl.getLength();i++){
			Node node = nl.item(i);
			switch (node.getNodeType()) {
			case Node.ELEMENT_NODE:System.out.println("Element node:"+node.getNodeName());break;
			case Node.ATTRIBUTE_NODE:System.out.println("Attribute node"+node.getNodeName()+
					"="+node.getNodeValue());break;
			case Node.TEXT_NODE:System.out.println("Text:"+node.getNodeValue());break;
			default:System.out.println(node);}
		}
	}
}
