/**
 * 
 */
package org.act.xservices.engine.rt.aspect.deploy;

import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;

import javax.wsdl.Message;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.Types;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.UnknownExtensibilityElement;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.act.xservices.bpel.wsdl.DefinitionsExtended;
import org.act.xservices.bpel.wsdl.PartnerLinkType;
import org.act.xservices.bpel.wsdl.impl.DefinitionsExtendedImpl;
import org.act.xservices.bpel11.TPartnerLink;
import org.act.xservices.bpel11.TVariable;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.VariableDef;

import org.act.xservices.engine.rt.aspect.*;
import org.act.xservices.engine.rt.aspect.model.Aspect;
import org.act.xservices.engine.rt.adapter.BPELAdapter;
import org.act.xservices.engine.rt.addressing.EndpointReference;
import org.act.xservices.engine.rt.deploy.BPELDeployMonitor;
import org.act.xservices.engine.rt.utils.ConstantUtil;
import org.act.xservices.engine.rt.utils.TimeUtil;
import org.act.xservices.engine.rt.utils.XSDUtil;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.xcontainer.deployment.ADeployMonitor;
import org.act.xservices.rt.xcontainer.deployment.DeployManager;
import org.act.xservices.rt.xcontainer.deployment.util.DeploymentConstants;
import org.act.xservices.rt.xcontainer.deployment.util.FileUtil;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

import commonj.sdo.DataObject;
import commonj.sdo.Type;
import commonj.sdo.helper.DataFactory;
import commonj.sdo.helper.TypeHelper;
import commonj.sdo.helper.XSDHelper;

/**
 * aspectĲ
 * 
 * @author
 * 
 */
public class AspectDeployerMonitor extends ADeployMonitor {

	final Logger logger = LoggerFactory.getLogger(BPELDeployMonitor.class);

	protected File aspects_Deploy_Dir;
	protected File aspects_Working_Dir;

	// static StringManager sm = StringManagerFactory.getStringManager();

	/**
	 * ¼޸ĵʱ
	 */
	private HashMap<String, Long> aspectLastModify = new HashMap<String, Long>();

	// ¼aspectĿ¼ļϴα޸ʱ
	private Long aspectDeployDirLastModify;

	private HashMap<String, String> deployedAspects = new HashMap<String, String>();

	public void init(DeployManager deployManager,
			IConfigElement deployMonitorConfig) {

		super.init(deployManager, deployMonitorConfig);

		this.aspects_Deploy_Dir = (File) containerEnv
				.getAttribute(DeploymentConstants.DIR_DEPLOY_ASPECTS);
		this.aspects_Working_Dir = (File) containerEnv
				.getAttribute(DeploymentConstants.DIR_WORKING_ASPECTS);
	}

	public void run() {

		aspectDeployDirLastModify = this.aspects_Deploy_Dir.lastModified();
		deleteOldWorkingFile(this.aspects_Working_Dir);
		if (!isStop) {
			logger.info("Start to deploy aspects");

			String id = ""; // ڶĿ¼
			deploy(this.aspects_Deploy_Dir, id);
		}

		while (!isStop) {

			// ûпͨȲܣڼµķ
			if (!isHotDeployment)
				break;
			else if (aspects_Deploy_Dir.lastModified() != aspectDeployDirLastModify) {
				// aspectDeployDir޸,зͲ
				aspectDeployDirLastModify = aspects_Deploy_Dir.lastModified();

				// aspect,aspectWorkingDirеļ
				logger.info("Start to undeploy aspects");
				undeploy();

				deleteOldWorkingFile(aspects_Working_Dir);
				String id = "";// ¼ļĿ¼
				logger.info("Start to deploy aspects");
				deploy(aspects_Deploy_Dir, id);
			}
			// һʱ
			try {
				Thread.sleep(deployerUpdateInterval);
			} catch (InterruptedException e) {
				logger.info("AspectDeployMonitor interrupt.");
			}
		}
	}

	/**
	 * жaspectĿ¼Ƿaspect*.zipļɾ,deployedAspectsеļ¼
	 * 
	 */
	private void undeploy() {
		Iterator<String> temp = deployedAspects.keySet().iterator();
		List<String> deletedAspectsList = new ArrayList<String>();
		while (temp.hasNext()) {
			String id = (String) temp.next();
			String path = deployedAspects.get(id);

			Boolean exsit = false;
			File[] files = aspects_Deploy_Dir.listFiles();
			for (int j = 0; j < files.length; j++) {
				// ͳһ·
				if (files[j].getAbsolutePath().equals(path)) {
					exsit = true;
					break;
				}
			}
			if (!exsit) {
				logger.info(path + " has been deleted!");
				AspectDeploymentUnitRegistry deploymentUnitRegistry = BPELAdapter
						.getAspectDeploymentUnitRegistry();
				deploymentUnitRegistry.delete(id);
				deletedAspectsList.add(id);
			}
		}
		for (int i = 0; i < deletedAspectsList.size(); i++) {
			deployedAspects.remove(deletedAspectsList.get(i));
			aspectLastModify.remove(deletedAspectsList.get(i));
		}
	}

	/**
	 * aspectĿ¼µļ
	 * 
	 * @param file
	 * @param id
	 */
	private void deploy(File file, String id) {

		for (int i = 0; i < file.listFiles().length; i++) {
			File subFile = file.listFiles()[i];
			String name = subFile.getName();

			if (subFile.isDirectory()) {
				// ļΪļ
				if (id.equals("")) {
					deploy(subFile, name);
				} else {
					deploy(subFile, id + "#" + name);
				}
			} else {
				// жǷҪ
				boolean needDeploy = false;
				String aspectId = null;// ¼aspectID
				AspectDeploymentUnitRegistry deploymentUnitRegistry = BPELAdapter
						.getAspectDeploymentUnitRegistry();
				long processModifyTime = subFile.lastModified();

				if (name.endsWith(".zip")) {
					// Ŀǰ"zip"ʽ
					// aspectId
					int index = name.indexOf(".");
					String str = name.substring(0, index);
					if (id.equals("")) {
						aspectId = str;
					} else {
						aspectId = id + "#" + str;
					}
					if (aspectLastModify.containsKey(aspectId)) {
						// aspectѾ
						long LastTime = aspectLastModify.get(aspectId)
								.longValue();
						if ((LastTime != processModifyTime)
								&& (processModifyTime != 0)) {
							// ļ޸ģ²aspect(ļɾ䱻޸ʱΪ0)
							deploymentUnitRegistry.delete(aspectId);
							needDeploy = true;
						} else {
							needDeploy = false;
						}// endof"if and else"
					} else {
						// aspectδҪ
						needDeploy = true;
					}
				} else {
					// RARѹ
				}

				// Ҫļ
				if (needDeploy) {
					aspectLastModify.put(aspectId, new Long(processModifyTime));
					try {
						// aspectѹ
						zip_deploy(subFile, id);
					} catch (Exception e) {
						// TODO Զ catch 
						e.printStackTrace();
					}
				}// endif
			}

		}
	}

	/**
	 * aspect.zipѹ
	 * 
	 * @param zipFile
	 * @param id
	 * @throws Exception
	 */
	private void zip_deploy(File zipFile, String id) throws Exception {

		long deployStart = System.currentTimeMillis();
		String aspectWorkingDir = aspects_Working_Dir.getAbsolutePath();
		String fileName = zipFile.getName();
		if (!id.equals("")) {
			String[] subIds = id.split("#");
			for (int j = 0; j < subIds.length; j++) {
				String subId = subIds[j];
				// ȷ.zipĿ¼
				aspectWorkingDir = aspectWorkingDir + File.separator + subId;
			}
		}// endif
			// .zipѹѹaspectWorkingĿ¼

		aspectWorkingDir = aspectWorkingDir + File.separator + fileName
				+ File.separator;
		FileUtil.inflate(zipFile, aspectWorkingDir); // Ϊ.zipѹʽҪ޸Ĵ

		File dir = new File(aspectWorkingDir);
		File[] aspectFiles = dir.listFiles(new FileFilter() {
			public boolean accept(File file) {

				String fn = file.getName();
				int len = fn.length();
				if (len > 7) {
					String ext = fn.substring(len - 7, len);
					return ext.equalsIgnoreCase(".aspect");
				}
				return false;
			}
		});
		if (aspectFiles.length == 0) {
			throw new Exception(zipFile.getName()
					+ " does't contain the Aspect file (.aspect)");
		}
		File aspectFile = aspectFiles[0];// 涨һѹһ.aspectļ
		// aspectļ
		aspect_deploy(aspectFile, id);

		// deploymentUnitеidһ
		Metaset aspect = MetasetParserFactory.getAspectMetasetParser().parse(
				aspectFile.toString());
		String name = aspect.attributeValue("name");
		if (id.equals("")) {
			id = name;
		} else {
			id += "#" + name;
		}

		AspectDeploymentUnit deploymentUnit = BPELAdapter
				.getAspectDeploymentUnitRegistry().get(id);

		// ѹеwsdl
		File[] wsdlFiles = dir.listFiles(new FileFilter() {
			public boolean accept(File file) {
				String fn = file.getName();
				int len = fn.length();
				if (len > 5) {
					String ext = fn.substring(len - 5, len);
					return ext.equalsIgnoreCase(".wsdl");
				}
				return false;
			}
		});
		if (wsdlFiles.length == 0) {
			throw new Exception(zipFile.getName()
					+ " does't contain the WSDL files (.wsdl)");
		}
		for (int i = 0; i < wsdlFiles.length; i++) {
			File wsdlFile = wsdlFiles[i];
			// wsdlļ
			wsdl_deploy(deploymentUnit, wsdlFile);
		}

		// ѹеXSD
		File[] xsdFiles = dir.listFiles(new FileFilter() {
			public boolean accept(File file) {
				String fn = file.getName();
				int len = fn.length();
				if (len > 4) {
					String ext = fn.substring(len - 4, len);
					return ext.equalsIgnoreCase(".xsd");
				}
				return false;
			}
		});
		for (int i = 0; i < xsdFiles.length; i++) {
			File xsdFile = xsdFiles[i];
			defineComplexTypeInXSD(xsdFile);
		}

		// б
		createPartnerLinkList(deploymentUnit);
		// ͣSDOϢͣSDOService Data Object
		createVariableType(deploymentUnit);
		
		// ӻʵʰ󶨵ַӲļPDDȡã
		File[] pddFiles = dir.listFiles(new FileFilter() {
			public boolean accept(File file) {
				String fn = file.getName();
				int len = fn.length();
				if (len > 5) {
					String ext = fn.substring(len - 4, len);
					return ext.equalsIgnoreCase(".pdd");
				}
				return false;
			}
		});
		if( pddFiles.length !=0){
			definePartnerLinkTypeInPdd(deploymentUnit,pddFiles[0]);
		}

		long deployEnd = System.currentTimeMillis();
		logger.info("Succeed Deployed Aspect " + deploymentUnit.getId()
				+ " in " + (deployEnd - deployStart) + " milliseconds");
	}

	/**
	 * aspectļ
	 * 
	 * @param file
	 * @throws Exception
	 */
	private void aspect_deploy(File file, String id) throws Exception {
		Metaset aspect = MetasetParserFactory.getAspectMetasetParser().parse(
				new FileInputStream(file));
		String name = aspect.attributeValue("name");
		String tns = aspect.attributeValue("targetNamespace");
		// WSDL
		AspectDeploymentUnit deploymentUnit = new AspectDeploymentUnit();
		// Ŀ¼+Ԫname
		if (id.equals("")) {
			deploymentUnit.setId(name);
		} else {
			deploymentUnit.setId(id + "#" + name);
		}
		// ļ
		deploymentUnit.setName(name);
		// ļƿռ
		deploymentUnit.setTargetNamespace(tns);
		// ʱ
		String deployTime = TimeUtil.getNowTime();
		deploymentUnit.setDeployTime(deployTime);
		// ļ
		deploymentUnit.setFile(file);
		// ļĿ¼
		deploymentUnit.setDirectory(aspects_Deploy_Dir.getAbsolutePath());

		Aspect aspect1 = AspectParsing.parse(file);// Aspect

		deploymentUnit.setAspect(aspect1);

		deploymentUnit.activize();
		AspectDeploymentUnitRegistry deploymentUnitRegistry = BPELAdapter
				.getAspectDeploymentUnitRegistry();
		deploymentUnitRegistry.add(deploymentUnit);
		logger.info("org.act.xservices.engine.rt.aspect.deploy:"
				+ deploymentUnit.getId());
		// ¼aspectļѾļ
		String path = file.getAbsolutePath();
		path = aspects_Deploy_Dir.getAbsolutePath()
				+ path.substring(this.aspects_Working_Dir.getAbsolutePath()
						.length());
		int index = path.indexOf(".zip");// 趨pathֻһ".zip"
		path = path.substring(0, index + 4);
		deployedAspects.put(deploymentUnit.getId(), path);

	}

	/**
	 * wsdlļ
	 * 
	 * @param deploymentUnit
	 * @param wsdlFile
	 */
	private void wsdl_deploy(AspectDeploymentUnit deploymentUnit, File wsdlFile) {
		String wsdlFileString = wsdlFile.toString();
		DefinitionsExtended wsdl = null;
		try {
			wsdl = new DefinitionsExtendedImpl(wsdlFileString);
		} catch (WSDLException e) {
			// TODO Զ catch 
			e.printStackTrace();
		}
		// ӵԪWSDLб
		deploymentUnit.addWsdl(wsdl);

		// 帴
		try {
			defineComplexTypeInWSDL(wsdl);
		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	/**
	 * XSD帴
	 * 
	 * @param xsdFile
	 * @throws Exception
	 */
	private void defineComplexTypeInXSD(File xsdFile) throws Exception {
		FileInputStream fis = new FileInputStream(xsdFile);
		XSDHelper.INSTANCE.define(fis, null);
		fis.close();
	}
	/**
	 * PDD partnerLinkType
	 * @param pddFile
	 * @throws Exception 
	 */
	private void definePartnerLinkTypeInPdd(AspectDeploymentUnit deploymentUnit,File pddFile) throws Exception{
		Metaset pdd = MetasetParserFactory.getBpelMetasetParser().parse(
				pddFile.toString());
		
		/*Metaset partnerLinks = pdd
				.filter(".\\partnerLinks\\partnerLink");*/
		Metaset partnerLinks = pdd.element("partnerLinks");
		
		for (int i = 0; i < partnerLinks.elements().size(); i++) {
			Metaset partnerLink = (Metaset) partnerLinks.elements()
					.get(i);
			String plName = partnerLink.attributeValue("name");
			/*Metaset address = partnerLink.filter(
					".\\EndpointReference\\Address").car();*/
			Metaset address = partnerLink.element("EndpointReference").element("Address");
			PartnerLink pl = deploymentUnit.getPartnerLink(plName);
			pl.getPartnerEndpoint().setAddress(address.getText());
		}
	}
	/**
	 * WSDLSchema帴
	 * 
	 * @param wsdl
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	private void defineComplexTypeInWSDL(DefinitionsExtended wsdl)
			throws Exception {
		Transformer serializer = TransformerFactory.newInstance()
				.newTransformer();
		Types types = wsdl.getDefinition().getTypes();
		if (types != null) {
			List<UnknownExtensibilityElement> schemas = types
					.getExtensibilityElements();
			for (int k = 0; k < schemas.size(); k++) {
				UnknownExtensibilityElement schema = schemas.get(k);
				StringWriter schemaString = new StringWriter();
				Source source = new DOMSource(schema.getElement());
				Result result = new StreamResult(schemaString);
				serializer.transform(source, result);
				XSDHelper.INSTANCE.define(schemaString.toString());
			}
		}
	}

	/**
	 * б
	 * 
	 * @param deploymentUnit
	 */
	@SuppressWarnings("unchecked")
	private static void createPartnerLinkList(
			AspectDeploymentUnit deploymentUnit) {
		Aspect aspect = deploymentUnit.getAspect();
		for (Iterator iter = aspect.getAdvice().getPartnerLinks().values()
				.iterator(); iter.hasNext();) {
			TPartnerLink tpartnerLink = (TPartnerLink) iter.next();
			PartnerLink partnerLink = new PartnerLink();
			partnerLink.setName(tpartnerLink.getName());
			// ȰPartnerLinkTypeΪQName
			javax.xml.namespace.QName qname = (javax.xml.namespace.QName) tpartnerLink
					.getPartnerLinkType();
			QName tpartnerLinkType = MetasetUtil.jQNameToxQName(qname);

			String pltURI = tpartnerLinkType.getNamespaceURI();
			String pltLocalPart = tpartnerLinkType.getName();
			DefinitionsExtended wsdl = deploymentUnit.getWsdl(pltURI);
			PartnerLinkType partnerLinkType = wsdl
					.getPartnerLinkType(pltLocalPart);
			partnerLink.setPartnerLinkType(partnerLinkType);
			String myRole = tpartnerLink.getMyRole();
			if (myRole != null) {
				partnerLink.setMyRole(myRole);
				EndpointReference endpoint = new EndpointReference();
				// QName portTypeNS =
				// partnerLinkType.getRole(myRole).getPortType().getName();
				QName portTypeNS = MetasetUtil.jQNameToxQName(partnerLinkType
						.getRole(myRole).getPortType().getName());
				wsdl = deploymentUnit.getWsdl(portTypeNS.getNamespaceURI());
				// PortType portType =
				// wsdl.getDefinition().getPortType(portTypeNS);
				PortType portType = wsdl.getDefinition().getPortType(
						MetasetUtil.xQNameTojQName(portTypeNS));
				endpoint.setPortType(portType);
				Service[] services = (Service[]) wsdl.getDefinition()
						.getServices().values().toArray(new Service[0]);
				for (int j = 0; j < services.length; j++) {
					Service service = services[j];
					Port[] ports = (Port[]) service.getPorts().values()
							.toArray(new Port[0]);
					for (int k = 0; k < ports.length; k++) {
						Port port = ports[k];
						if (port.getBinding().getPortType() == portType) {
							// myRoleҪaddress
							endpoint.setService(service);
							endpoint.setPort(port);
							List<UnknownExtensibilityElement> elements = port
									.getExtensibilityElements();
							for (int m = 0; m < elements.size(); m++) {
								UnknownExtensibilityElement element = elements
										.get(m);
								if (element.getElement().getLocalName()
										.equals("address")) {
									String address = element.getElement()
											.getAttribute("location");
									endpoint.setAddress(address);
								}
							}// endfor
						}
					}
				}
				partnerLink.setMyEndpoint(endpoint);
			} else {
				String partnerRole = tpartnerLink.getPartnerRole();
				if (partnerRole != null) {
					partnerLink.setPartnerRole(partnerRole);
					EndpointReference endpoint = new EndpointReference();
					// QName portTypeNS =
					// partnerLinkType.getRole(partnerRole).getPortType().getName();
					QName portTypeNS = MetasetUtil
							.jQNameToxQName(partnerLinkType
									.getRole(partnerRole).getPortType()
									.getName());
					wsdl = deploymentUnit.getWsdl(portTypeNS.getNamespaceURI());
					// PortType portType =
					// wsdl.getDefinition().getPortType(portTypeNS);
					PortType portType = wsdl.getDefinition().getPortType(
							MetasetUtil.xQNameTojQName(portTypeNS));
					endpoint.setPortType(portType);
					Service[] services = (Service[]) wsdl.getDefinition()
							.getServices().values().toArray(new Service[0]);
					for (int j = 0; j < services.length; j++) {
						Service service = services[j];
						Port[] ports = (Port[]) service.getPorts().values()
								.toArray(new Port[0]);
						for (int k = 0; k < ports.length; k++) {
							Port port = ports[k];
							if (port.getBinding().getPortType() == portType) {
								endpoint.setService(service);
								endpoint.setPort(port);
								// partnerRoleҪaddress
								List<UnknownExtensibilityElement> elements = port
										.getExtensibilityElements();
								for (int m = 0; m < elements.size(); m++) {
									UnknownExtensibilityElement element = elements
											.get(m);
									if (element.getElement().getLocalName()
											.equals("address")) {
										String address = element.getElement()
												.getAttribute("location");
										endpoint.setAddress(address);
									}
								}
							}
						}
					}
					partnerLink.setPartnerEndpoint(endpoint);
				}
			}// endelse
			deploymentUnit.addPartnerLink(partnerLink);
		}// endfor
	}

	/**
	 * ͣSDOϢ
	 * 
	 * @param deploymentUnit
	 */
	@SuppressWarnings("unchecked")
	private static void createVariableType(AspectDeploymentUnit deploymentUnit) {
		// Ŀǰֻ֧processǩ¶ı
		Aspect aspect = deploymentUnit.getAspect();
		for (Iterator iter = aspect.getAdvice().getVariables().values()
				.iterator(); iter.hasNext();) {
			VariableDef variableDef = new VariableDef();
			TVariable variable = (TVariable) iter.next();
			String varName = variable.getName();
			variableDef.setName(varName);
			javax.xml.namespace.QName qname = (javax.xml.namespace.QName) variable
					.getMessageType();
			QName messageType = MetasetUtil.jQNameToxQName(qname);

			if (messageType != null) {
				// ΪmessageType
				variableDef.setMessageType(messageType);
				// SDOϢ
				String msgTypeURI = messageType.getNamespaceURI();
				String msgTypeLocalPart = messageType.getName();
				DefinitionsExtended wsdl = deploymentUnit.getWsdl(msgTypeURI);
				Message message = wsdl.getDefinition().getMessage(
						MetasetUtil.xQNameTojQName(messageType));
				// DataObject messageObject =
				// DataFactory.INSTANCE.create("commonj.sdo", "Type");
				DataObject messageObject = DataFactory.INSTANCE.create(
						"commonj.sdo", "Type");
				messageObject.set("uri", msgTypeURI);
				messageObject.set("name", msgTypeLocalPart);
				Part[] parts = (Part[]) message.getParts().values()
						.toArray(new Part[0]);
				for (int k = 0; k < parts.length; k++) {
					Part part = parts[k];
					DataObject ptProperty = messageObject
							.createDataObject("property");
					ptProperty.set("name", part.getName());
					// QName partType = part.getTypeName();
					QName partType = MetasetUtil.jQNameToxQName(part
							.getTypeName());
					if (partType != null) {
						Type type = null;
						String uri = partType.getNamespaceURI();
						String local = partType.getName();
						if (uri.equals(ConstantUtil.NS_XSD)) {
							type = XSDUtil.getType(partType.getName());
						} else {
							type = TypeHelper.INSTANCE.getType(uri, local);
						}
						ptProperty.set("type", type);
					} else {
						// QName element = part.getElementName();
						QName element = MetasetUtil.jQNameToxQName(part
								.getElementName());
						if (element != null) {
							String uri = element.getNamespaceURI();
							String local = element.getName();
							Type type = TypeHelper.INSTANCE.getType(uri, local);
							ptProperty.set("type", type);
						}
					}
				}
				TypeHelper.INSTANCE.define(messageObject);
			}

			QName type = (QName) variable.getType();
			if (type != null) {
				// Ϊtype
				variableDef.setType(type);
			}

			QName element = (QName) variable.getElement();
			if (element != null) {
				// Ϊelement
				variableDef.setElement(element);
			}

			deploymentUnit.addVariableDef(variableDef);
		}
	}

	/**
	 * ֹͣ
	 */
	public void stop() {
		this.isStop = true;
	}
}
