package org.act.xservices.engine.rt.aspect.deploy;

import java.io.File;
import java.util.HashMap;

import org.act.xservices.bpel.wsdl.DefinitionsExtended;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.aspect.model.Aspect;

public class AspectDeploymentUnit {

	public static final int STATE_ACTIVE = 0;

	public static final int STATE_SUSPENDED = 1;

	/**
	 * ״̬
	 */
	private int state = STATE_SUSPENDED;

	private Aspect aspect;

	/**
	 * ID
	 */
	private String id;

	/**
	 * 
	 */
	private String name;

	/**
	 * ƿռ
	 */
	private String targetNamespace;

	/**
	 * ļ
	 */
	private File file;

	/**
	 * ̲Ŀ¼
	 */
	private String directory;

	/**
	 * ̲ʱ
	 */
	private String deployTime;

	/**
	 * WSDLĿ¼
	 */
	private HashMap<String, DefinitionsExtended> wsdlCatalog = new HashMap<String, DefinitionsExtended>();

	/**
	 * Ӷ
	 */
	private HashMap<String, PartnerLink> partnerLinks = new HashMap<String, PartnerLink>();

	/**
	 * 
	 */
	private HashMap<String, VariableDef> variableDefs = new HashMap<String, VariableDef>();

	public void setId(String id) {
		this.id = id;
	}

	public String getId() {
		return this.id;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return this.name;
	}

	public String getTargetNamespace() {
		return targetNamespace;
	}

	public void setTargetNamespace(String targetNamespace) {
		this.targetNamespace = targetNamespace;
	}

	public void setFile(File file) {
		this.file = file;
	}

	public File getFile() {
		return this.file;
	}

	public String getDeployTime() {
		return deployTime;
	}

	public void setDeployTime(String deployTime) {
		this.deployTime = deployTime;
	}

	public String getDirectory() {
		return directory;
	}

	public void setDirectory(String directory) {
		this.directory = directory;
	}

	/**
	 * Aspect
	 * 
	 * @param aspect
	 */
	public void setAspect(Aspect aspect) {
		this.aspect = aspect;
	}

	public Aspect getAspect() {
		return this.aspect;
	}

	public DefinitionsExtended getWsdl(String URI) {
		return wsdlCatalog.get(URI);
	}

	public DefinitionsExtended[] getWsdls() {
		return wsdlCatalog.values().toArray(new DefinitionsExtended[0]);
	}

	public void addWsdl(DefinitionsExtended wsdl) {
		wsdlCatalog.put(wsdl.getDefinition().getTargetNamespace(), wsdl);
	}

	public int getState() {
		return state;
	}

	public void activize() {
		this.state = STATE_ACTIVE;
	}

	public void suspended() {
		this.state = STATE_SUSPENDED;
	}

	// PartnerLinkд
	public void addPartnerLink(PartnerLink partnerLink) {
		partnerLinks.put(partnerLink.getName(), partnerLink);
	}

	public void removePartnerLink(String name) {
		partnerLinks.remove(name);
	}

	public PartnerLink[] getPartnerLinks() {
		return partnerLinks.values().toArray(new PartnerLink[0]);
	}

	public PartnerLink getPartnerLink(String name) {
		return partnerLinks.get(name);
	}

	// Variableд
	public void addVariableDef(VariableDef variableDef) {
		variableDefs.put(variableDef.getName(), variableDef);
	}

	public void removeVariableDef(String name) {
		variableDefs.remove(name);
	}

	public VariableDef[] getVariableDefs() {
		return variableDefs.values().toArray(new VariableDef[0]);
	}

	public VariableDef getVariableDef(String name) {
		return variableDefs.get(name);
	}

}
