package org.act.xservices.engine.rt.aspect.evolution;

import org.act.xservices.bpel11.TActivity;
import org.act.xservices.engine.rt.InstanceUnit;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.bpel11.Bpel11ActivityInstance;
import org.act.xservices.engine.rt.bpel11.Bpel11InstanceUnit;
import org.act.xservices.engine.rt.bpel11.InstanceUtil;
import org.act.xservices.engine.rt.adapter.BPELAdapter;
import org.act.xservices.engine.rt.aspect.*;
import org.act.xservices.engine.rt.aspect.deploy.AspectDeploymentUnit;
import org.act.xservices.engine.rt.aspect.model.Advice;
import org.act.xservices.engine.rt.aspect.model.Aspect;

public class DynamicEvolution {
	/**
	 * ƥaspect,ִлʵ
	 * @param instance
	 * @param aspectDeploymentUnit
	 * @throws Exception 
	 */
	public static void executeActivityInstance(Bpel11InstanceUnit instanceUnit,
							Bpel11ActivityInstance instance) throws Exception{
		String aspectId = EvolutionJudgment.getEvolutionAspectID(instanceUnit, instance);
    	AspectDeploymentUnit aspectDeploymentUnit = BPELAdapter.
    												getAspectDeploymentUnitRegistry().get(aspectId);
    	if(aspectDeploymentUnit == null){
    		throw new Exception("The matched aspect doesn't exist!");
    	}
		Aspect aspect = aspectDeploymentUnit.getAspect();
		//ZYJ aspectеvariableDef뵽ƥڵĲԪУûǷظ
		VariableDef[] variableDefs = aspectDeploymentUnit.getVariableDefs();
		for(int i = 0; i < variableDefs.length; i++){
			instanceUnit.getDeploymentUnit().addVariableDef(variableDefs[i]);
		}
		//ZYJ aspectеpartnerLink뵽ƥڵĲԪ,ûǷظ
		PartnerLink[] partnerLinks =aspectDeploymentUnit.getPartnerLinks();
		for(int i = 0; i < partnerLinks.length; i++){
			instanceUnit.getDeploymentUnit().addPartnerLink(partnerLinks[i]);
		}
		
		if(aspect.getPointcut().getContextCollection()){
			//ThisJPActivity
			ThisJPActivity thisJPActivity = new ThisJPActivity();
			thisJPActivity.setName(instance.getName());
			thisJPActivity.setType(instance.getType());
			thisJPActivity.setProcessName(instanceUnit.getDeploymentUnit().getName());
			instanceUnit.setThisJPActivity(thisJPActivity);
		}
		
		Advice  advice = aspect.getAdvice();
		String adviceType = advice.getType();
		if(adviceType.equalsIgnoreCase("before")){
			executeBefore(instanceUnit,instance,aspect);
		}else if(adviceType.equalsIgnoreCase("after")){
			executeAfter(instanceUnit,instance,aspect);
		}else if(adviceType.equalsIgnoreCase("around")){
			executeAround(instanceUnit,aspect);
		}
	}
	private static void executeBefore(Bpel11InstanceUnit instanceUnit,
							Bpel11ActivityInstance instance,Aspect aspect) throws Exception{
		//ZYJ ĿǰΪadviceֻһԭӻṹ
		System.out.println("aspect type is \"before\":");
		//ZYJ ⣺ҪƥĻӦı
		//ʵӦĻѹջ
		TActivity activity = instance.getActivity();
		instanceUnit.getActivitiesStack().push(activity);
		InstanceUnit.hasMatch = true;

		TActivity activityAspect = aspect.getAdvice().getActivity();
		Bpel11ActivityInstance aspectInstance = InstanceUtil.getActivityInstance(activityAspect, instanceUnit);
		aspectInstance.run();
		//̻ʵִ
	}
	private static void executeAfter(Bpel11InstanceUnit instanceUnit,
			Bpel11ActivityInstance instance,Aspect aspect) throws Exception{
		System.out.println("aspect type is \"after\":");
		//aspectеĻѹջ
		TActivity activityAspect = aspect.getAdvice().getActivity();
		instanceUnit.getActivitiesStack().push(activityAspect);
		
		instance.run();
		
	}
	private static void executeAround(Bpel11InstanceUnit instanceUnit,Aspect aspect){
		//ȡ
		System.out.println("aspect type is \"around\":");
		
		TActivity activity = aspect.getAdvice().getActivity();
		instanceUnit.getActivitiesStack().push(activity);
	}
}
