package org.act.xservices.engine.rt.aspect.evolution;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.act.xservices.engine.rt.ActivityInstance;
import org.act.xservices.engine.rt.InstanceUnit;
import org.act.xservices.engine.rt.adapter.BPELAdapter;
import org.act.xservices.engine.rt.aspect.deploy.AspectDeploymentUnit;
import org.act.xservices.engine.rt.aspect.deploy.AspectDeploymentUnitRegistry;

import org.act.xservices.engine.rt.aspect.evolution.ActivityInstanceLocationInstance;
import org.act.xservices.engine.rt.aspect.evolution.XPathLocationInstance;
import org.act.xservices.engine.rt.aspect.model.Aspect;
import org.act.xservices.engine.rt.bpel11.InstanceUtil;
import org.eclipse.emf.ecore.xml.type.internal.QName;

public class EvolutionJudgment {
	
	private static Map<String, String> matchedAspectsID = new HashMap<String, String>();
	/**
	 * жϸûʵǷaspectpointcut
	 * 
	 * @param instanceUnit
	 * @param activityInstance
	 * @return
	 * @throws Exception
	 */
	public static Boolean isNeedEvolution(InstanceUnit instanceUnit,
			ActivityInstance activityInstance) throws Exception {
		// ¼aspectxpath
		ArrayList<String> xpaths = getXPathString();
		// ¼ûʵִ·
		ActivityInstanceLocation location = ActivityInstanceLocationInstance
				.getActivityInstanceLocation(instanceUnit);
		// жǷƥaspectеpointcut
		if (xpaths.size() == 0) {
			return false;
		}
		for (int i = 0; i < xpaths.size(); i++) {
			// ÿaspectԪ
			ArrayList<XPathLocation> xpathLocations = XPathLocationInstance
					.getXPathLocation(xpaths.get(i));
			for (int j = 0; j < xpathLocations.size(); j++) {

				XPathLocation xpath = xpathLocations.get(j);
				ArrayList<String> activities = xpath.getActivities();
				int length = activities.size();

				if (activities.get(length - 1).equalsIgnoreCase(
						activityInstance.getType())) {
					// ǰƥ
					String activity = activities.get(length - 1);

					AspectDeploymentUnitRegistry aspectDeploymentUnitRegistry = BPELAdapter
							.getAspectDeploymentUnitRegistry();
					AspectDeploymentUnit deploymentUnit = aspectDeploymentUnitRegistry
							.getAll()[i];
					Aspect aspect = deploymentUnit.getAspect();
					Boolean match = isAttributesEqual(aspect, activity, xpath,
							activityInstance);// жǷƥ
					if (match) {
						// ǰƥ䣬жִ·Ƿƥ
						if (isLocationEqual(aspect, location, xpath)) {
							String key = instanceUnit.getId() + "#" + activityInstance.getName();
							if (InstanceUnit.hasMatch) {
								InstanceUnit.hasMatch = false;// Իı
								matchedAspectsID.remove(key);
							} else {
								System.out.println();
								System.out.println("recent activity match!" + activityInstance.getType());
								String aspectDepoymentUnitID = deploymentUnit.getId();
								
								matchedAspectsID.put(key, aspectDepoymentUnitID);	
								System.out.println("aspectId matched : " + aspectDepoymentUnitID);
								return true;
							}
						}
					}
				}// endif
			}// endfor(һaspectӦpointcut)

		}
		return false;
	}
    /**
     * õƥaspectID
     * @param instanceUnit
     * @param activityInstance
     * @return
     * @throws Exception
     */
	public static String getEvolutionAspectID(InstanceUnit instanceUnit,
			ActivityInstance activityInstance){
		String aspectDepoymentUnitID = null;
		String key = instanceUnit.getId() + "#" + activityInstance.getName();
		aspectDepoymentUnitID = matchedAspectsID.get(key);
		if(aspectDepoymentUnitID == null){
			try {
				throw new Exception("Does not exist matched aspect!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return aspectDepoymentUnitID;
		
	}
	/*public static String getEvolutionAspectID(InstanceUnit instanceUnit,
			ActivityInstance activityInstance) throws Exception {
		String aspectDepoymentUnitID = null;
		// ¼aspectxpath
		ArrayList<String> xpaths = getXPathString();
		// ¼ûʵִ·
		ActivityInstanceLocation location = ActivityInstanceLocationInstance
				                     .getActivityInstanceLocation(instanceUnit);
		// жǷƥaspectеpointcut
		for (int i = 0; i < xpaths.size(); i++) {
			// ÿaspectԪ
			ArrayList<XPathLocation> xpathLocations = XPathLocationInstance.getXPathLocation(xpaths
					.get(i));
			for (int j = 0; j < xpathLocations.size(); j++) {
				// ZYJ ÿpointcut
				XPathLocation xpath = xpathLocations.get(j);
				ArrayList<String> activities = xpath.getActivities();
				int length = activities.size();

				if (activities.get(length - 1).equalsIgnoreCase(
						activityInstance.getType())) {
					// ǰƥ
					String activity = activities.get(length - 1);
					AspectDeploymentUnitRegistry aspectDeploymentUnitRegistry = BPELAdapter
							.getAspectDeploymentUnitRegistry();
					AspectDeploymentUnit deploymentUnit = aspectDeploymentUnitRegistry
							.getAll()[i];
					Aspect aspect = deploymentUnit.getAspect();
					Boolean match = isAttributesEqual(aspect, activity, xpath,
							activityInstance);// жǷƥ
					if (match) {
						// ǰƥ䣬жִ·Ƿƥ
						if (isLocationEqual(aspect, location, xpath)) {

							aspectDepoymentUnitID = deploymentUnit.getId();
							System.out.println("aspectId matched : "
									+ aspectDepoymentUnitID);
						}
					}
				}// endif
			}// endfor(һaspectӦpointcut)

		}
		return aspectDepoymentUnitID;

	}*/

	/**
	 * /** õĿǰвaspectpointcutXPath,һ.aspectӦһXPath
	 * 
	 * @param instanceUnit
	 * @return
	 */
	private static ArrayList<String> getXPathString() {
		ArrayList<String> xpaths = new ArrayList<String>();
		// þ̬
		AspectDeploymentUnitRegistry aspectDeploymentUnitRegistry = BPELAdapter
				.getAspectDeploymentUnitRegistry();
		if (aspectDeploymentUnitRegistry != null) {
			AspectDeploymentUnit[] aspectDeploymentUnits = aspectDeploymentUnitRegistry
					.getAll();
			for (int i = 0; i < aspectDeploymentUnits.length; i++) {
				AspectDeploymentUnit aspectDeploymentUnit = aspectDeploymentUnits[i];
				String xpath = aspectDeploymentUnit.getAspect().getPointcut()
						.getXPath();
				xpaths.add(xpath);
			}
		}
		return xpaths;
	}

	/**
	 * ڻƥǰ£жϻǷƥ
	 * 
	 * @param activity
	 * @param xpath
	 * @param activityInstance
	 * @return
	 * @throws Exception
	 */
	private static Boolean isAttributesEqual(Aspect aspect, String activity,
			XPathLocation xpath, ActivityInstance activityInstance)
			throws Exception {
		if (xpath.getActivityAttributes().containsKey(activity)) {
			// ƥĻ
			Map<String, String> attributes = xpath
					.getActivityAttributes(activity);
			Iterator<String> it = attributes.keySet().iterator();
			Class<?> activityClass = InstanceUtil
					.getTActivityClass(activityInstance.getActivity());
			while (it.hasNext()) {
				// ZYJ жϵǰǷƥpointcut
				String attrName = it.next();
				String attrValue = attributes.get(attrName);
				String methodName = "get"
						+ attrName.substring(0, 1).toUpperCase()
						+ attrName.substring(1);
				Method method = activityClass.getMethod(methodName, null);
				if (method != null) {
					// ڸ
					Object value = method.invoke(
							activityInstance.getActivity(), null);
					// QName͵ֵֻlocalPartֺURI
					if (value instanceof QName) {
						// עQNameڵĿ
						String valLocalPart = ((QName) value).getLocalPart();
						String valURI = ((QName) value).getNamespaceURI();
						// ΪQName
						if (attrValue.contains(":")) {
							// xpathֵΪQName
							int i11 = attrValue.indexOf(":");
							String attrValLocalPart = attrValue
									.substring(i11 + 1);
							String attrValPrex = attrValue.substring(0, i11);
							// жQName͵ֵǷͬ
							if (!valLocalPart.equals(attrValLocalPart)) {
								return false;
							} else {
								HashMap<String, String> uris = aspect
										.getExtendedNameSpaces();
								if (uris.containsKey("xmlns:" + attrValPrex)) {
									String attrURI = uris.get("xmlns:"
											+ attrValPrex);
									if (!valURI.equals(attrURI)) {
										return false;
									}
								} else {
									throw new Exception("attribute : "
											+ attrName + "URI can not find !");
								}
							}

						} else {
							// xpathֵΪQName
							if (!valLocalPart.equals(attrValue)) {
								return false;
							}
						}
					} else {
						// NCname
						if (!value.equals(attrValue)) {
							// ֵƥ
							return false;
						}
					}// end if/else
				}
			}// endwhile
		}
		return true;
	}

	/**
	 * жϻִ·Ƿƥ
	 * 
	 * @param location
	 * @param xpath
	 * @return
	 * @throws Exception
	 */
	private static Boolean isLocationEqual(Aspect aspect,
			ActivityInstanceLocation location, XPathLocation xpath)
			throws Exception {
		if (xpath.getProcessName() != null) {
			String processName = xpath.getProcessName();
			if (!processName.equals(location.getProcessName())) {
				// ƥ
				return false;
			}
		}
		// ڻƥ䣬жϻִ·
		// ȡxpathĻ·һ㣩
		ArrayList<String> xpathActNames = new ArrayList<String>();
		ArrayList<String> names = xpath.getActivities();
		for (int i = 0; i < names.size() - 1; i++) { // xpathһ㲻
			xpathActNames.add(names.get(i));
		}
		// ȡʵִ·ǰʵ
		StringBuffer locs = new StringBuffer();
		LinkedList<ActivityInstance> actInstances = location
				.getActivityInstance();
		for (int i = 0; i < actInstances.size(); i++) {
			locs.append(actInstances.get(i).getType());
		}
		// xpathĻ·дʽ
		String regex = ".*";
		for (int i = 0; i < xpathActNames.size(); i++) {
			regex += xpathActNames.get(i) + ".*";
		}
		Pattern p = Pattern.compile(regex, Pattern.CASE_INSENSITIVE);
		Matcher m = p.matcher(locs.toString());
		if (!m.matches()) {
			// ·ƥ
			return false;
		} else {
			// жÿ
			int j = 0;
			for (int i = 0; i < xpathActNames.size(); i++) {
				regex = "(?i)" + xpathActNames.get(i); // ԴСдʽƥ
				if (j >= actInstances.size()) {
					// xpathеĻûƥ
					return false;
				} else {
					for (; j < actInstances.size(); j++) {
						String act = actInstances.get(j).getType();
						if (act.matches(regex)) {
							// ƥ䣬жϻǷƥ
							String activityName = xpathActNames.get(i);
							ActivityInstance actInstance = actInstances.get(j);
							if (isAttributesEqual(aspect, activityName, xpath,
									actInstance)) {
								j++; // ע˴
								break; // תxpathһ
							}
						}
					}
				}

			}
		}
		return true;
	}
}
