package org.act.xservices.engine.rt.bpel11;

import java.util.Stack;

import org.act.xservices.bpel11.TCompensate;
import org.act.xservices.bpel11.TCompensationHandler;

public class CompensateInstance extends Bpel11ActivityInstance {
	
	private Stack<Object> activitiesStack;
	
	public CompensateInstance(TCompensate compensate, Bpel11InstanceUnit instanceUnit) {
		this.type = "Compensate";
		this.name = compensate.getName();
		this.activity = compensate;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public CompensateInstance(TCompensate compensate, Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(compensate, instanceUnit);
		this.activitiesStack = activitiesStack;
	}
	
	//<compensate scope="ncname"? standard-attributes>
	//   standard-elements
	//</compensate>
	//<compensationHandler>?
	//   activity
	//</compensationHandler>
	public void run() throws Exception{
		super.start();
		//TCompensate compensate = (TCompensate) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;
		TCompensationHandler compensationHandler = ((Bpel11DeploymentUnit)instanceUnit.getDeploymentUnit()).getBpel().getCompensationHandler();
		if(compensationHandler != null) {
			Object activity = InstanceUtil.getSubActivity(compensationHandler);
			activitiesStack.push(activity);
		}
		super.finish();
	}
}
