package org.act.xservices.engine.rt.bpel11;

import java.util.Iterator;
import java.util.Stack;

import org.act.xservices.bpel11.TActivity;
import org.act.xservices.bpel11.TFlow;
import org.act.xservices.bpel11.TLink;
import org.act.xservices.bpel11.TLinks;

public class FlowInstance extends Bpel11ActivityInstance {

	/**
	 * ֧Ļ۵
	 */
	private Integer merger = new Integer(0);
	
	/**
	 * ʾ֧Ƿ
	 */
	private boolean error = false;

	public FlowInstance(TFlow flow, Bpel11InstanceUnit instanceUnit) {
		this.type = "Flow";
		this.name = flow.getName();
		this.activity = flow;
		this.instanceUnit = instanceUnit;
	}

	// <flow standard-attributes>
	// standard-elements
	// <links>?
	// <link name="ncname">+
	// </links>
	// activity+
	// </flow>
	public void run() throws Exception{
		super.start();
		TFlow flow = (TFlow) this.activity;
		final Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;
		TLinks links = flow.getLinks();
		if(links != null) {
			for(int i=0; i<links.getLink().size(); i++) {
				TLink link = links.getLink().get(i);
			    String linkName = link.getName();
			    instanceUnit.addLink(linkName);
		    }
		}
		
		//ڲִе²eventHandlers
		for (Iterator<Object> iter = flow.getActivity().valueListIterator(); iter
				.hasNext();) {
			synchronized (merger) {
				merger++;
			}
			final TActivity activity = (TActivity) iter.next();
			final FlowInstance flowInstance = this;
			Runnable runnable = new Runnable() {
				public void run() {
					try {
						Stack<Object> activitiesStack = new Stack<Object>();
					    activitiesStack.push(activity);
					    while (!activitiesStack.isEmpty()) {
					    	while(instanceUnit.getState() == Bpel11InstanceUnit.STATE_SUSPENDED) {
						        //ʵ״̬ѾԱ޸Ϊsuspended
						        Thread.sleep(5000);
						    }
					    	if (instanceUnit.getState() != Bpel11InstanceUnit.STATE_TERMINATED) {
					    		Object object = activitiesStack.pop();
					    		Bpel11ActivityInstance instance = InstanceUtil.getActivityInstance(object, instanceUnit);
							    instance.run();
							}else{
								//ʵ״̬ѾԱ޸Ϊterminated  ֧
								throw new Exception("Error caused by one branch of flow activity or by the administrator");
						    }
					    }
					    flowInstance.merge();
					} catch (Exception e) {
						flowInstance.errorHandler();
						flowInstance.merge();
						e.printStackTrace();
					}
				}
			};
			new Thread(runnable).start();
		}
		if (merger.intValue() != 0) {
			synchronized (this) {
				this.wait();
			}
			if(error) {
				throw new Exception("Error caused by one branch of flow activity");
			}
		}
		super.finish();
	}
	
	public void errorHandler() {
		this.instanceUnit.terminate();
		this.error = true;
	}

	public void merge() {
		synchronized (merger) {
			merger--;
		}
		if (merger.intValue() == 0) {
			synchronized (this) {
				this.notifyAll();
			}
		}
	}
}
