package org.act.xservices.engine.rt.bpel11;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Stack;

import org.act.xservices.bpel.wsdl.PropertyAlias;
import org.act.xservices.bpel11.TAssign;
import org.act.xservices.bpel11.TBoolean;
import org.act.xservices.bpel11.TCorrelation;
import org.act.xservices.bpel11.TCorrelationSet;
import org.act.xservices.bpel11.TCorrelations;
import org.act.xservices.bpel11.TEmpty;
import org.act.xservices.bpel11.TEventHandlers;
import org.act.xservices.bpel11.TFlow;
import org.act.xservices.bpel11.TInvoke;
import org.act.xservices.bpel11.TOnAlarm;
import org.act.xservices.bpel11.TOnMessage;
import org.act.xservices.bpel11.TPick;
import org.act.xservices.bpel11.TReceive;
import org.act.xservices.bpel11.TReply;
import org.act.xservices.bpel11.TScope;
import org.act.xservices.bpel11.TSequence;
import org.act.xservices.bpel11.TSwitch;
import org.act.xservices.bpel11.TTerminate;
import org.act.xservices.bpel11.TThrow;
import org.act.xservices.bpel11.TWait;
import org.act.xservices.bpel11.TWhile;
import org.act.xservices.engine.rt.CorrelatedInstanceUnit;
import org.act.xservices.engine.rt.CorrelationSetInstance;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.PropertyInstance;
import org.act.xservices.engine.rt.VariableContainer;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.bpel.expression.DateExpression;
import org.act.xservices.engine.rt.bpel.expression.DurationExpression;
import org.act.xservices.engine.rt.utils.DataUtil;
import org.act.xservices.engine.rt.utils.QNameUtil;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

import commonj.sdo.DataObject;
import commonj.sdo.Type;
import commonj.sdo.helper.DataFactory;
import commonj.sdo.helper.TypeHelper;

public class InstanceUtil {

	public static Object getSubActivity(Object activity) throws Exception {
		Class<?> c = activity.getClass();

		Method getEmptyMethod = c.getMethod("getEmpty", new Class[] {});
		Object empty = getEmptyMethod.invoke(activity, new Object[] {});
		if (empty != null) {
			return empty;
		}

		Method getInvokeMethod = c.getMethod("getInvoke", new Class[] {});
		Object invoke = getInvokeMethod.invoke(activity, new Object[] {});
		if (invoke != null) {
			return invoke;
		}

		Method getReceiveMethod = c.getMethod("getReceive", new Class[] {});
		Object receive = getReceiveMethod.invoke(activity, new Object[] {});
		if (receive != null) {
			return receive;
		}

		Method getReplyMethod = c.getMethod("getReply", new Class[] {});
		Object reply = getReplyMethod.invoke(activity, new Object[] {});
		if (reply != null) {
			return reply;
		}

		Method getAssignMethod = c.getMethod("getAssign", new Class[] {});
		Object assign = getAssignMethod.invoke(activity, new Object[] {});
		if (assign != null) {
			return assign;
		}

		Method getWaitMethod = c.getMethod("getWait", new Class[] {});
		Object wait = getWaitMethod.invoke(activity, new Object[] {});
		if (wait != null) {
			return wait;
		}

		Method getThrowMethod = c.getMethod("getThrow", new Class[] {});
		Object Throw = getThrowMethod.invoke(activity, new Object[] {});
		if (Throw != null) {
			return Throw;
		}

		Method getTerminateMethod = c.getMethod("getTerminate", new Class[] {});
		Object terminate = getTerminateMethod.invoke(activity, new Object[] {});
		if (terminate != null) {
			return terminate;
		}

		Method getFlowMethod = c.getMethod("getFlow", new Class[] {});
		Object flow = getFlowMethod.invoke(activity, new Object[] {});
		if (flow != null) {
			return flow;
		}

		Method getSwitchMethod = c.getMethod("getSwitch", new Class[] {});
		Object Switch = getSwitchMethod.invoke(activity, new Object[] {});
		if (Switch != null) {
			return Switch;
		}

		Method getWhileMethod = c.getMethod("getWhile", new Class[] {});
		Object While = getWhileMethod.invoke(activity, new Object[] {});
		if (While != null) {
			return While;
		}

		Method getSequenceMethod = c.getMethod("getSequence", new Class[] {});
		Object sequence = getSequenceMethod.invoke(activity, new Object[] {});
		if (sequence != null) {
			return sequence;
		}

		Method getPickMethod = c.getMethod("getPick", new Class[] {});
		Object pick = getPickMethod.invoke(activity, new Object[] {});
		if (pick != null) {
			return pick;
		}

		Method getScopeMethod = c.getMethod("getScope", new Class[] {});
		Object scope = getScopeMethod.invoke(activity, new Object[] {});
		if (scope != null) {
			return scope;
		}

		throw new Exception("Can't support the activity named " + c.getName());
	}

	public static Bpel11ActivityInstance getActivityInstance(Object activity,
			Bpel11InstanceUnit instanceUnit) throws Exception {
		Bpel11ActivityInstance instance = null;
		if (activity instanceof TEmpty) {
			instance = new EmptyInstance((TEmpty) activity, instanceUnit);
		}
		if (activity instanceof TInvoke) {
			instance = new InvokeInstance((TInvoke) activity, instanceUnit);
		}
		if (activity instanceof TReceive) {
			instance = new ReceiveInstance((TReceive) activity, instanceUnit);
		}
		if (activity instanceof TReply) {
			instance = new ReplyInstance((TReply) activity, instanceUnit);
		}
		if (activity instanceof TAssign) {
			instance = new AssignInstance((TAssign) activity, instanceUnit);
		}
		if (activity instanceof TWait) {
			instance = new WaitInstance((TWait) activity, instanceUnit);
		}
		if (activity instanceof TThrow) {
			instance = new ThrowInstance((TThrow) activity, instanceUnit);
		}
		if (activity instanceof TTerminate) {
			instance = new TerminateInstance((TTerminate) activity,
					instanceUnit);
		}
		if (activity instanceof TFlow) {
			instance = new FlowInstance((TFlow) activity, instanceUnit);
		}
		if (activity instanceof TSwitch) {
			instance = new SwitchInstance((TSwitch) activity, instanceUnit);
		}
		if (activity instanceof TWhile) {
			instance = new WhileInstance((TWhile) activity, instanceUnit);
		}
		if (activity instanceof TSequence) {
			instance = new SequenceInstance((TSequence) activity, instanceUnit);
		}
		if (activity instanceof TPick) {
			instance = new PickInstance((TPick) activity, instanceUnit);
		}
		if (activity instanceof TScope) {
			instance = new ScopeInstance((TScope) activity, instanceUnit);
		}
		if (instance != null) {
			return instance;
		}
		throw new Exception("Can't create the instance of activity named "
				+ activity.getClass().getName());
	}

	public static Class getTActivityClass(Object activity) throws Exception {
		Class c = null;
		if (activity instanceof TEmpty) {
			c = Class.forName(TEmpty.class.getName());
		}
		if (activity instanceof TInvoke) {
			c = Class.forName(TInvoke.class.getName());
		}
		if (activity instanceof TReceive) {
			c = Class.forName(TReceive.class.getName());
		}
		if (activity instanceof TReply) {
			c = Class.forName(TReply.class.getName());
		}
		if (activity instanceof TAssign) {
			c = Class.forName(TAssign.class.getName());
		}
		if (activity instanceof TWait) {
			c = Class.forName(TWait.class.getName());
		}
		if (activity instanceof TThrow) {
			c = Class.forName(TThrow.class.getName());
		}
		if (activity instanceof TTerminate) {
			c = Class.forName(TTerminate.class.getName());
		}
		if (activity instanceof TFlow) {
			c = Class.forName(TFlow.class.getName());
		}
		if (activity instanceof TSwitch) {
			c = Class.forName(TSwitch.class.getName());
		}
		if (activity instanceof TWhile) {
			c = Class.forName(TWhile.class.getName());
		}
		if (activity instanceof TSequence) {
			c = Class.forName(TSequence.class.getName());
		}
		if (activity instanceof TPick) {
			c = Class.forName(TPick.class.getName());
		}
		if (activity instanceof TScope) {
			c = Class.forName(TScope.class.getName());
		}
		if (c != null) {
			return c;
		}
		throw new Exception("Can't create the instance of activity named "
				+ activity.getClass().getName());
	}

	// <eventHandlers>?
	// <!-- there must be at least one onMessage or onAlarm handler -->
	// <onMessage partnerLink="ncname" portType="qname" operation="ncname"
	// variable="ncname"?>*
	// <correlations>?
	// <correlation set="ncname" initiate="yes|no">+
	// </correlations>
	// activity
	// </onMessage>
	// <onAlarm for="duration-expr"? until="deadline-expr"?>*
	// activity
	// </onAlarm>
	// </eventHandlers>
	public static void eventHandlers(TEventHandlers eventHandlers,
			Bpel11InstanceUnit instanceUnit, Long beginTime) throws Exception {
		Stack<Object> activitiesStack = instanceUnit.getActivitiesStack();
		boolean message = false;
		for (int i = 0; i < eventHandlers.getOnMessage().size(); i++) {
			TOnMessage onMessage = eventHandlers.getOnMessage().get(i);
			message = onMessageHandler(onMessage, instanceUnit, activitiesStack);
			if (message) {
				break;
			}
		}

		if (!message) {
			// ҵonAlarmǩʱ亯
			for (int i = 0; i < eventHandlers.getOnAlarm().size(); i++) {
				TOnAlarm onAlarm = eventHandlers.getOnAlarm().get(i);
				boolean alarm = onAlarmHandler(onAlarm, activitiesStack,
						beginTime);
				if (alarm) {
					break;
				}
			}
		}
	}

	public static boolean onMessageHandler(TOnMessage onMessage,
			Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack)
			throws Exception {
		String partnerLink = onMessage.getPartnerLink();
		String operation = onMessage.getOperation();
		String variable = onMessage.getVariable();
		TCorrelations correlations = onMessage.getCorrelations();

		Bpel11DeploymentUnit deploymentUnit = (Bpel11DeploymentUnit) instanceUnit
				.getDeploymentUnit();

		if (instanceUnit.hasMessage(partnerLink, operation)) {
			IServiceContext message = instanceUnit.getMessage(partnerLink,
					operation);
			//PartnerLink pl = deploymentUnit.getPartnerLink(partnerLink);
			// if (pl.getPartnerEndpoint() == null) {
			instanceUnit.storeMessageContext(partnerLink, operation, message);
			// }
			/*Metaset paras = message.getInMessage()
					.filter(".\\Body\\" + operation).car();*/
			Metaset paras = message.getInMessage().getBody().element(operation);
			
			VariableDef variableDef = deploymentUnit.getVariableDef(variable);
			QName messageType = variableDef.getMessageType();
			String messageTypeURI = messageType.getNamespaceURI();
			String messageTypeLocalPart = messageType.getName();
			Type varType = TypeHelper.INSTANCE.getType(messageTypeURI,
					messageTypeLocalPart);
			DataObject var = DataFactory.INSTANCE.create(varType);
			DataUtil.metaset2data(paras, var);
			VariableContainer variableContainer = instanceUnit
					.getVariableContainer();
			variableContainer.setVariable(variable, var);

			if (correlations != null) {
				for (int i = 0; i < correlations.getCorrelation().size(); i++) {
					TCorrelation correlation = correlations.getCorrelation()
							.get(i);
					if (correlation.getInitiate().equals(TBoolean.YES)) {
						String set = correlation.getSet();
						CorrelatedInstanceUnit correlatedInstanceUnit = new CorrelatedInstanceUnit();
						correlatedInstanceUnit.setInstanceId(instanceUnit
								.getId());
						CorrelationSetInstance correlationSetInstance = new CorrelationSetInstance();
						correlationSetInstance.setName(set);
						TCorrelationSet correlationSet = deploymentUnit
								.getCorrelationSet(set);
						for (int j = 0; j < correlationSet.getProperties()
								.size(); j++) {
							QName property = QNameUtil.translate(correlationSet
									.getProperties().get(j));
							PropertyInstance propertyInstance = new PropertyInstance();
							propertyInstance.setQname(property);
							ArrayList<PropertyAlias> propertyAliases = deploymentUnit
									.getPropertyAlias(messageType);
							for (int k = 0; k < propertyAliases.size(); k++) {
								PropertyAlias propertyAlias = propertyAliases
										.get(k);
								String part = propertyAlias.getPart();
								String query = propertyAlias.getQuery();
								Object value = var.get(part + query);
								propertyInstance.setValue(value);
							}
							correlationSetInstance
									.addPropertyInstance(propertyInstance);
						}
						correlatedInstanceUnit
								.setCorrelationSetInstance(correlationSetInstance);
						deploymentUnit
								.addCorrelatedInstanceUnit(correlatedInstanceUnit);
					}
				}
			}
			Object activity = InstanceUtil.getSubActivity(onMessage);
			activitiesStack.push(activity);
			return true;
		}
		return false;
	}

	public static boolean onAlarmHandler(TOnAlarm onAlarm,
			Stack<Object> activitiesStack, long beginTime) throws Exception {
		String durationExpression = onAlarm.getFor();
		String dateExpression = onAlarm.getUntil();

		// Ϊ,ôҪӡϢ
		if ((durationExpression == null) && (dateExpression == null)) {
			throw new Exception("Wrong format of onAlarm in eventHandlers");
		}

		long runningTime = System.currentTimeMillis() - beginTime;
		if (!onTime(durationExpression, dateExpression, runningTime)) {
			Object activity = InstanceUtil.getSubActivity(onAlarm);
			activitiesStack.push(activity);
			return true;
		}
		return false;
	}

	private static boolean onTime(String durationExpression,
			String dateExpression, long runningTime) {

		if (durationExpression != null) {
			if (runningTime < DurationExpression
					.getExpressionValue(durationExpression))
				return true;
			else
				return false;
		}

		if (dateExpression != null) {
			if (DateExpression.getExpressionValue(dateExpression) > 0)
				return true;
			else
				return false;
		}
		return false;
	}
}
