package org.act.xservices.engine.rt.bpel11;

import java.util.Stack;

import org.act.xservices.bpel11.TOnAlarm;
import org.act.xservices.bpel11.TOnMessage;
import org.act.xservices.bpel11.TPick;

public class PickInstance extends Bpel11ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public PickInstance(TPick pick, Bpel11InstanceUnit instanceUnit) {
		this.type = "Pick";
		this.name = pick.getName();
		this.activity = pick;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public PickInstance(TPick pick, Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(pick, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <pick createInstance="yes|no"? standard-attributes>
	// standard-elements
	// <onMessage partnerLink="ncname" portType="qname"
	// operation="ncname" variable="ncname"?>+
	// <correlations>?
	// <correlation set="ncname" initiate="yes|no"?>+
	// </correlations>
	// activity
	// </onMessage>
	// <onAlarm (for="duration-expr" | until="deadline-expr")>*
	// activity
	// </onAlarm>
	// </pick>
	public void run() throws Exception{
		super.start();
		TPick pick = (TPick) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;

		boolean loop = true;
		long beginTime = System.currentTimeMillis();
		while (loop) {
			// õonMessageǩһonMessage
			for (int i = 0; i < pick.getOnMessage().size(); i++) {
				TOnMessage onMessage = pick.getOnMessage().get(i);
				boolean start = InstanceUtil.onMessageHandler(onMessage, instanceUnit, activitiesStack);	
				if (start) {
					loop = false;
					break;
				}
			}
			if (loop) {
				// ҵonAlarmǩʱ亯
				for (int i = 0; i < pick.getOnAlarm().size(); i++) {
					TOnAlarm onAlarm = pick.getOnAlarm().get(i);
					boolean start = InstanceUtil.onAlarmHandler(onAlarm, activitiesStack, beginTime);
					if(start) {
						loop = false;
						break;
					}
				}
				if(loop) {
					Thread.sleep(5000);
				}
			}
		}
		super.finish();
	}
}
