package org.act.xservices.engine.rt.bpel11;

import java.util.ArrayList;

import org.act.xservices.bpel.wsdl.PropertyAlias;
import org.act.xservices.bpel11.TBoolean;
import org.act.xservices.bpel11.TCorrelation;
import org.act.xservices.bpel11.TCorrelationSet;
import org.act.xservices.bpel11.TCorrelations;
import org.act.xservices.bpel11.TReceive;
import org.act.xservices.engine.rt.CorrelatedInstanceUnit;
import org.act.xservices.engine.rt.CorrelationSetInstance;
import org.act.xservices.engine.rt.PropertyInstance;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.utils.DataUtil;
import org.act.xservices.engine.rt.utils.QNameUtil;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPVersion;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

import commonj.sdo.DataObject;
import commonj.sdo.Type;
import commonj.sdo.helper.DataFactory;
import commonj.sdo.helper.TypeHelper;

public class ReceiveInstance extends Bpel11ActivityInstance {

	public static String XMLNS_XSD = "http://www.w3.org/2001/XMLSchema";

	public ReceiveInstance(TReceive receive, Bpel11InstanceUnit instanceUnit) {
		this.type = "Receive";
		this.name = receive.getName();
		this.activity = receive;
		this.instanceUnit = instanceUnit;
	}

	// :
	// <receive partnerLink="ncname" portType="qname" operation="ncname"
	// variable="ncname"? createInstance="yes|no"? standard-attributes>
	// standard-elements
	// <correlations>?
	// <correlation set="ncname" initiate="yes|no"?>+
	// </correlations>
	// </receive>
	public void run() throws Exception{
		super.start();
		TReceive receive = (TReceive) activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;
		
		String partnerLink = receive.getPartnerLink();
		String operation = receive.getOperation();
		String varName = receive.getVariable();
		TCorrelations correlations = receive.getCorrelations();
		
		Bpel11DeploymentUnit deploymentUnit = (Bpel11DeploymentUnit)instanceUnit.getDeploymentUnit();

		System.out.println("partnerLink: " + partnerLink + " operation: " + operation + "  variable: " + varName);

		IServiceContext message = this.instanceUnit.getMessage(partnerLink, operation);
		
		//PartnerLink pl = deploymentUnit.getPartnerLink(partnerLink);
		//if (pl.getPartnerEndpoint() == null) {
			this.instanceUnit.storeMessageContext(partnerLink, operation, message);
		//}
		//Metaset paras = message.getInMessage().filter(".\\Body\\" + operation).car();
		ISOAPBody body = message.getInMessageBody();
		Metaset paras = body.element(operation);
		VariableDef variableDef = deploymentUnit.getVariableDef(varName);
		QName messageType = variableDef.getMessageType();
		String messageTypeURI = messageType.getNamespaceURI();
		String messageTypeLocalPart = messageType.getName();
		Type varType = TypeHelper.INSTANCE.getType(messageTypeURI, messageTypeLocalPart);
		DataObject var = DataFactory.INSTANCE.create(varType);
		if(deploymentUnit.getId().equals("bank")){
			String arg = paras.getFirstElement().getStringValue();
			System.out.println(arg);
			Object[] args = arg.split(" ");
			Metaset para1 = MetasetBuilder.getInstance()
			.newMetaset("para1");
			for(int i = 0; i < args.length; i ++){
				Metaset para = MetasetBuilder.getInstance()
				.newMetaset("para"+i);
				para.setText(args[i].toString());
				para1.add(para);
			}
			DataUtil.metaset2data(para1, var);
		}else{
			DataUtil.metaset2data(paras, var);
		}
		instanceUnit.getVariableContainer().setVariable(varName, var);

		if (correlations != null) {
			for (int i = 0; i < correlations.getCorrelation().size(); i++) {
				TCorrelation correlation = correlations.getCorrelation().get(i);
				if (correlation.getInitiate().equals(TBoolean.YES)) {
					String set = correlation.getSet();
					CorrelatedInstanceUnit correlatedInstanceUnit = new CorrelatedInstanceUnit();
					correlatedInstanceUnit.setInstanceId(this.instanceUnit.getId());
					CorrelationSetInstance correlationSetInstance = new CorrelationSetInstance();
					correlationSetInstance.setName(set);
					TCorrelationSet correlationSet = deploymentUnit.getCorrelationSet(set);
					for (int j = 0; j < correlationSet.getProperties().size(); j++) {
						QName property = QNameUtil.translate((org.eclipse.emf.ecore.xml.type.internal.QName) correlationSet.getProperties().get(j));
						PropertyInstance propertyInstance = new PropertyInstance();
						propertyInstance.setQname(property);
						ArrayList<PropertyAlias> propertyAliases = deploymentUnit.getPropertyAlias(messageType);
						for(int k=0; k<propertyAliases.size(); k++) {
							PropertyAlias propertyAlias = propertyAliases.get(k);
							String part = propertyAlias.getPart();
							String query = propertyAlias.getQuery();
							String path = query;
							if(part != null) {
								path = part + path;
							}
							Object value = var.get(path);
							propertyInstance.setValue(value);
						}
						correlationSetInstance.addPropertyInstance(propertyInstance);	
					}
					correlatedInstanceUnit.setCorrelationSetInstance(correlationSetInstance);
					deploymentUnit.addCorrelatedInstanceUnit(correlatedInstanceUnit);
				}
			}
		}
		super.finish();
	}
}
