package org.act.xservices.engine.rt.bpel11;

import java.util.List;

import org.act.xservices.bpel.wsdl.DefinitionsExtended;
import org.act.xservices.bpel11.TReply;
import org.act.xservices.engine.rt.utils.DataUtil;
import org.act.xservices.engine.rt.utils.SoapUtil;
import org.act.xservices.engine.rt.utils.WSDLUtil;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.eclipse.emf.ecore.xml.type.internal.QName;

public class ReplyInstance extends Bpel11ActivityInstance {

	public ReplyInstance(TReply reply, Bpel11InstanceUnit instanceUnit) {
		this.type = "Reply";
		this.name = reply.getName();
		this.activity = reply;
		this.instanceUnit = instanceUnit;
	}

	// 壺
	// <reply partnerLink="ncname" portType="qname" operation="ncname"
	// variable="ncname"? faultName="qname"? standard-attributes>
	// standard-elements
	// <correlations>?
	// <correlation set="ncname" initiate="yes|no"?>+
	// </correlations>
	// </reply>
	public void run() throws Exception {
		super.start();
		TReply reply = (TReply) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit) this.instanceUnit;

		String partnerLink = reply.getPartnerLink();
		QName portType = (QName) reply.getPortType();
		String operation = reply.getOperation();
		String variable = reply.getVariable();

		System.out.println("partnerLink: " + partnerLink + " operation: "
				+ operation + "  variable: " + variable);

		IServiceContext context = instanceUnit.getContext(partnerLink,
				operation);

		Metaset soapMsg = SoapUtil.createEmptySoap();
		// Metaset body = soapMsg.filter(".\\Body").car();
		Metaset body = soapMsg.element("Body");

		String opUri = portType.getNamespaceURI();
		
		// жSOAPϢʽ
		boolean isDocument;
		Bpel11DeploymentUnit deploymentUnit = (Bpel11DeploymentUnit) instanceUnit
				.getDeploymentUnit();
		DefinitionsExtended wsdl = deploymentUnit.getWsdl(opUri);
		isDocument = WSDLUtil.isDocument(wsdl);
			
		Metaset paras = creatReply(operation+ "Response", opUri, variable, isDocument);
		body.add(paras);

		// Metaset requestService = context.getInMessage();
		// Metaset messageID = requestService.filter(".\\Header\\MessageID");
		// if(messageID != null) {
		// Metaset header = soapMsg.filter(".\\Header").car();
		// header.add(messageID.car());
		// }

		// add by viking 2010 07 07
		ISOAPEnvelope envelope = SOAPMessageUtil
				.convertMetasetToSOAPEnvelope(soapMsg);
		context.setOutMessage(envelope);
		this.instanceUnit.getMessageOut().put(context);

		super.finish();
	}

	private Metaset creatReply(String op, String opUri,
			String inputVariable, boolean isDocument) {
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit) this.instanceUnit;

		Metaset paras = MetasetBuilder.getInstance()
				.newMetaset(opUri, op, "ns");
		DataUtil.data2metaset(instanceUnit, inputVariable, paras);
		if (isDocument) {
			Metaset paras0 = MetasetBuilder.getInstance().newMetaset(opUri, op,
					"ns");
			List<Metaset> parts = paras.elements();
			for (int i = 0; i < parts.size(); i++) {
				Metaset part = parts.get(i);
				paras.remove(part);
				List<Metaset> elements = part.elements();
				for (int j = 0; j < elements.size(); j++) {
					Metaset element = elements.get(j);
					part.remove(element);
					paras0.add(element);
				}
			}
			return paras0;
		}
		return paras;
	}
}
