package org.act.xservices.engine.rt.bpel11;

import java.util.Stack;

import org.act.xservices.bpel11.CaseType;
import org.act.xservices.bpel11.TActivityContainer;
import org.act.xservices.bpel11.TSwitch;
import org.act.xservices.engine.rt.bpel.expression.BooleanExpression;

public class SwitchInstance extends Bpel11ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public SwitchInstance(TSwitch Switch, Bpel11InstanceUnit instanceUnit) {
		this.type = "Switch";
		this.name = Switch.getName();
		this.activity = Switch;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public SwitchInstance(TSwitch Switch, Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(Switch, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <switch standard-attributes>
	// standard-elements
	// <case condition="bool-expr">+
	// activity
	// </case>
	// <otherwise>?
	// activity
	// </otherwise>
	// </switch>
	public void run() throws Exception {
		super.start();
		TSwitch Switch = (TSwitch) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;
		boolean otherwise = true;

		// ҵƥcasecaseĶѹջ
		for(int i=0; i<Switch.getCase().size(); i++) {
			CaseType activityCase = Switch.getCase().get(i);
			String condition = activityCase.getCondition();
			try {
				if (BooleanExpression.getExpressionValue(condition,instanceUnit)) {
					Object activity = InstanceUtil.getSubActivity(activityCase);
					activitiesStack.push(activity);
					otherwise = false;
					break;
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		
		if(otherwise){
			TActivityContainer activityOtherwise = Switch.getOtherwise();
			if(activityOtherwise != null) {
				Object activity = InstanceUtil.getSubActivity(activityOtherwise);
				activitiesStack.push(activity);
			}
		}
		super.finish();
	}
}
