package org.act.xservices.engine.rt.bpel11;

import java.util.Stack;

import org.act.xservices.bpel11.TActivityOrCompensateContainer;
import org.act.xservices.bpel11.TCatch;
import org.act.xservices.bpel11.TFaultHandlers;
import org.act.xservices.bpel11.TThrow;

public class ThrowInstance extends Bpel11ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public ThrowInstance(TThrow Throw, Bpel11InstanceUnit instanceUnit) {
		this.type = "Throw";
		this.name = Throw.getName();
		this.activity = Throw;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public ThrowInstance(TThrow Throw, Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(Throw, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <throw faultName="qname" faultVariable="ncname"? standard-attributes>
	// standard-elements
	// </throw>
	// <faultHandlers>?
	// <!-- there must be at least one fault handler or default -->
	// <catch faultName="qname"? faultVariable="ncname"?>*
	// activity
	// </catch>
	// <catchAll>?
	// activity
	// </catchAll>
	// </faultHandlers>
	public void run() throws Exception {
		super.start();
		TThrow Throw = (TThrow) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;

		Object faultName = Throw.getFaultName();
		String faultVariable = Throw.getFaultVariable();

		//Ŀǰֻ֧process¶ĴfaultHandlers
		TFaultHandlers faultHandlers = ((Bpel11DeploymentUnit)instanceUnit.getDeploymentUnit())
				.getBpel().getFaultHandlers();
		TCatch catchHandler = null;
		if (faultHandlers != null) {
			TActivityOrCompensateContainer catchAll = faultHandlers.getCatchAll();
			if (faultVariable == null) {
				//ûصĹ
				for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
					TCatch Catch = faultHandlers.getCatch().get(i);
					Object fName = Catch.getFaultName();
					if(faultName.equals(fName)) {
						//ѡ catch ָƥ faultName ֵ
						catchHandler = Catch;
						break;
					}
				}
			}
			else{
				//صĹ
				for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
					TCatch Catch = faultHandlers.getCatch().get(i);
					Object fName = Catch.getFaultName();
					String fVariable = Catch.getFaultVariable();
					if(faultName.equals(fName) && faultVariable.equals(fVariable)) {
						//ѡ catch ָƥ faultName ֵԼͣWSDL Ϣͣƥ͵ faultVariable
						catchHandler = Catch;
						break;
					}
				}
				if(catchHandler != null) {
					for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
						TCatch Catch = faultHandlers.getCatch().get(i);
						String fVariable = Catch.getFaultVariable();
						if(faultVariable.equals(fVariable)) {
							//򣬾ͽѡ񲻴ָ faultName ƥ͵ faultVariable  catch 
							catchHandler = Catch;
							break;
						}
					}
				}
			}
			if(catchHandler != null) {
				Object activity = InstanceUtil.getSubActivity(catchHandler);
				activitiesStack.push(activity);
			}else if(catchAll != null) {
				//ѡȱʡ catchAll 
				Object activity = InstanceUtil.getSubActivity(catchAll);
				activitiesStack.push(activity);
			}
		}
		super.finish();
	}
}
