package org.act.xservices.engine.rt.bpel11;

import org.act.xservices.bpel11.TWait;
import org.act.xservices.engine.rt.bpel.expression.DateExpression;
import org.act.xservices.engine.rt.bpel.expression.DurationExpression;

public class WaitInstance extends Bpel11ActivityInstance {
	
	public WaitInstance(TWait wait, Bpel11InstanceUnit instanceUnit) {
		this.type = "Wait";
		this.name = wait.getName();
		this.activity = wait;
		this.instanceUnit = instanceUnit;
	}
	
	public void run() throws Exception {
		super.start();
		TWait wait = (TWait) this.activity;
		boolean isDuration = true;
		String durationExpression = null;
		String dateExpression = null;
		
		durationExpression = wait.getFor();
		dateExpression = wait.getUntil();
		
		if(durationExpression == null)
			isDuration = false;
		
		long waitingTime = 0;
		if (isDuration) {
			waitingTime = DurationExpression
					.getExpressionValue(durationExpression);
				
		}else {
			waitingTime = DateExpression.getExpressionValue(dateExpression);
		}
		try {
			Thread.sleep(waitingTime);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		super.finish();
	}
}
