package org.act.xservices.engine.rt.bpel11;

import java.util.Stack;

import org.act.xservices.bpel11.TWhile;
import org.act.xservices.engine.rt.bpel.expression.BooleanExpression;

public class WhileInstance extends Bpel11ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public WhileInstance(TWhile While, Bpel11InstanceUnit instanceUnit) {
		this.type = "While";
		this.name = While.getName();
		this.activity = While;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public WhileInstance(TWhile While, Bpel11InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(While, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <while condition="bool-expr" standard-attributes>
	// standard-elements
	// activity
	// </while>
	public void run() throws Exception {
		super.start();
		TWhile While = (TWhile) this.activity;
		Bpel11InstanceUnit instanceUnit = (Bpel11InstanceUnit)this.instanceUnit;
		
		String condition = While.getCondition();
		if (BooleanExpression.getExpressionValue(condition,instanceUnit)) {
			Object activity = InstanceUtil.getSubActivity(While);
			activitiesStack.push(While);
			activitiesStack.push(activity);
		}
		super.finish();
	}
}
