package org.act.xservices.engine.rt.bpel20;

import java.util.ArrayList;

import javax.wsdl.Message;

import org.act.xservices.bpel.wsdl.DefinitionsExtended;
import org.act.xservices.bpel.wsdl.PropertyAlias;
import org.act.xservices.bpel20.TAssign;
import org.act.xservices.bpel20.TCopy;
import org.act.xservices.bpel20.TFrom;
import org.act.xservices.bpel20.TTo;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.VariableContainer;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.addressing.EndpointReference;
import org.act.xservices.engine.rt.bpel.expression.GeneralExpression;
import org.act.xservices.engine.rt.utils.ConstantUtil;
import org.act.xservices.engine.rt.utils.QNameUtil;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.xom.QName;

import commonj.sdo.DataObject;
import commonj.sdo.helper.DataFactory;

public class AssignInstance extends Bpel20ActivityInstance{
	
	public AssignInstance(TAssign assign, Bpel20InstanceUnit instanceUnit) {
		this.type = "Assign";
		this.name = assign.getName();
		this.activity = assign;
		this.instanceUnit = instanceUnit;
	}
	
	// :
	// <assign validate="yes|no"? standard-attributes>
	// standard-elements 
	// (
	// <copy keepSrcElementName="yes|no"? ignoreMissingFromData="yes|no"?>
	// from-spec to-spec
	// </copy>
	// |
	// <extensionAssignOperation>
	// assign-element-of-other-namespace
	// </extensionAssignOperation>
	// )+
	// </assign>

	// 
	// <from variable="BPELVariableName" part="NCName"?>
	// <query queryLanguage="anyURI"?>?
    // queryContent
	// </query>
    // </from>
	// <from partnerLink="NCName" endpointReference="myRole|partnerRole" />
    // <from variable="BPELVariableName" property="QName" />
	// <from expressionLanguage="anyURI"?>expression</from>
    // <from><literal>literal value</literal></from>
    // <from/>

	// 
	// <to variable="BPELVariableName" part="NCName"?>
	// <query queryLanguage="anyURI"?>?
	// queryContent
    // </query>
    // </to>
	// <to partnerLink="NCName" />
    // <to variable="BPELVariableName" property="QName" />
    // <to expressionLanguage="anyURI"?>expression</to>
    // <to/>

	public void run() throws Exception{
		super.start();
		TAssign assign = (TAssign)this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;
		Bpel20DeploymentUnit deploymentUnit = (Bpel20DeploymentUnit)instanceUnit.getDeploymentUnit();
		VariableContainer variableContainer = instanceUnit.getVariableContainer();
		for(int i=0; i<assign.getCopy().size(); i++) {
			TCopy copy = assign.getCopy().get(i);
			TFrom from = copy.getFrom();
			TTo to = copy.getTo();
			String fromVariable = from.getVariable();
			String fromPart = from.getPart();
			String fromPartnerLink = from.getPartnerLink();
			String fromEndpointReference = from.getEndpointReference().getName();
			QName fromProperty = QNameUtil.translate(from.getProperty());
			String fromExpression = (String)from.getAny().get(0).getValue();
			String toVariable = to.getVariable();
			String toPart = to.getPart();
			String toPartnerLink = to.getPartnerLink();
			QName toProperty = QNameUtil.translate(to.getProperty());
			
			Object value = null;
			
			if (fromVariable != null) {
				Object var = variableContainer.getVariable(fromVariable);
				VariableDef variableDef = deploymentUnit.getVariableDef(fromVariable);
				if (fromPart != null) {
					if(from.getQuery() != null) {
						// <from variable="BPELVariableName" part="NCName">
						// <query queryLanguage="anyURI"?>
					    // queryContent
						// </query>
						String fromQuery = (String)from.getQuery().getAny().get(0).getValue();
						System.out.println("FROM " + "variable:" + fromVariable + " part:" + fromPart + " query:" + fromQuery);
						value = ((DataObject)var).get(fromPart + fromQuery);
					}else{
						// <from variable="BPELVariableName" part="NCName"/>
					    System.out.println("FROM " + "variable:" + fromVariable + " part:" + fromPart);
					    value = ((DataObject)var).get(fromPart);
					}
				}else if(fromProperty != null){
					// <from variable="BPELVariableName" property="QName"/>
					String localPart = fromProperty.getName();
					System.out.println("FROM " + "variable:" + fromVariable + " property:" + localPart);		
					QName messageType = variableDef.getMessageType();
					ArrayList<PropertyAlias> propertyAliases = deploymentUnit.getPropertyAlias(messageType);
					for(int j=0; j<propertyAliases.size(); j++) {
						PropertyAlias propertyAlias = propertyAliases.get(j);
						QName property = MetasetUtil.jQNameToxQName( propertyAlias.getPropertyName() );
						if(property.equals(fromProperty)) {
							String part = propertyAlias.getPart();
							String query = propertyAlias.getQuery();
							DataObject data = (DataObject)variableContainer.getVariable(fromVariable);
							value = data.get(part+query);
						}
					}
				}else{
					if(from.getQuery() != null) {
						// <from variable="BPELVariableName">
						// <query queryLanguage="anyURI"?>
					    // queryContent
						// </query>
						String fromQuery = (String)from.getQuery().getAny().get(0).getValue();
						System.out.println("FROM " + "variable:" + fromVariable + " query:" + fromQuery);
						value = ((DataObject)var).get(fromQuery);
					}else{
						// <from variable="BPELVariableName"/>
					    System.out.println("FROM " + "variable:" + fromVariable);
					    value = var;
					}
				}
			}else if (fromPartnerLink != null) {
				// <from partnerLink="NCName" endpointReference="myRole|partnerRole"/>
				System.out.println("FROM " + "partnerLink:" + fromPartnerLink + " endpointReference:" + fromEndpointReference);
				PartnerLink partnerLink = deploymentUnit.getPartnerLink(fromPartnerLink);
				if (fromEndpointReference.equals("myRole")) {	
					EndpointReference endpoint = partnerLink.getMyEndpoint();
					value = endpoint;
				}else{
					EndpointReference endpoint = partnerLink.getPartnerEndpoint();
					value = endpoint;
				}
			}else if (fromExpression != null) {
				// <from expressionLanguage="anyURI"?>expression</from>
				System.out.println("FROM " + "expression:" + fromExpression);
				value = GeneralExpression.getExpressionValue(fromExpression, this.instanceUnit);
			}else {
				// <from><literal>literal value</literal></from>
				//value = from.getLiteral().getAny().get(0).getValue();
			}
			
			if (toVariable != null) {	
				Object var = variableContainer.getVariable(toVariable);
				VariableDef variableDef = deploymentUnit.getVariableDef(toVariable);
				if (toPart != null) {
					QName messageType = variableDef.getMessageType();
					String messageTypeURI = messageType.getNamespaceURI();
					String messageTypeLocalPart = messageType.getName();
					if(var == null) {
						var = DataFactory.INSTANCE.create(messageTypeURI, messageTypeLocalPart);
						variableContainer.setVariable(toVariable, var);
					}
					Object partVar = ((DataObject)var).get(toPart); 
					if(to.getQuery() != null) {
						// <to variable="BPELVariableName" part="NCName">
						// <query queryLanguage="anyURI"?>
						// queryContent
					    // </query>
						String toQuery = (String)to.getQuery().getAny().get(0).getValue();
						System.out.println("TO " + "variable:" + toVariable + " part:" + toPart + " query:" + toQuery);
						if(partVar == null) {
							DefinitionsExtended wsdl = deploymentUnit.getWsdl(messageTypeURI);
							Message message = wsdl.getDefinition().getMessage(MetasetUtil.xQNameTojQName( messageType ));
							QName partType = MetasetUtil.jQNameToxQName( message.getPart(toPart).getTypeName());
							String ptUrl = partType.getNamespaceURI();
							String ptLocalName = partType.getName();
							partVar = DataFactory.INSTANCE.create(ptUrl, ptLocalName);
							((DataObject)var).set(toPart, partVar);
						}
						((DataObject)partVar).set(toQuery, value);
					}else{
						// <to variable="BPELVariableName" part="NCName"/>
					    System.out.println("TO " + "variable:" + toVariable + " part:" + toPart);			
					    if(value instanceof EndpointReference) {
					    	// <to partnerLink="NCName" />
					    	String address = ((EndpointReference)value).getAddress();
					    	String wsaURI = ConstantUtil.NS_WSA;
					    	DataObject addr = DataFactory.INSTANCE.create(wsaURI, "Address");
					    	addr.set(0, address);
					    	((DataObject)var).set("Address", addr);
					    }else{
					    	((DataObject)var).set(toPart, value);
					    }
					}
				}else if(toProperty != null){
					// <to variable="BPELVariableName" property="QName" />
					String localPart = toProperty.getName();
					System.out.println("TO " + "variable:" + toVariable + " property:" + localPart);
					QName messageType = variableDef.getMessageType();
					String messageTypeURI = messageType.getNamespaceURI();
					String messageTypeLocalPart = messageType.getName();
					if(var == null) {
						var = DataFactory.INSTANCE.create(messageTypeURI, messageTypeLocalPart);
						variableContainer.setVariable(toVariable, var);
					}
					ArrayList<PropertyAlias> propertyAliases = deploymentUnit.getPropertyAlias(messageType);
					for(int j=0; j<propertyAliases.size(); j++) {
						PropertyAlias propertyAlias = propertyAliases.get(j);
						QName property = MetasetUtil.jQNameToxQName(propertyAlias.getPropertyName());
						if(property.equals(toProperty)) {
							String part = propertyAlias.getPart();
							String query = propertyAlias.getQuery();
							if(query != null) {
								Object partVar = ((DataObject)var).get(part);
								if(partVar == null) {
									DefinitionsExtended wsdl = deploymentUnit.getWsdl(messageTypeURI);
									Message message = wsdl.getDefinition().getMessage(MetasetUtil.xQNameTojQName( messageType));
									QName partType = MetasetUtil.jQNameToxQName(message.getPart(toPart).getTypeName());
									String ptUrl = partType.getNamespaceURI();
									String ptLocalName = partType.getName();
									partVar = DataFactory.INSTANCE.create(ptUrl, ptLocalName);
									((DataObject)var).set(toPart, partVar);
								}
								((DataObject)partVar).set(query, value);
		                        ((DataObject)var).set(part, partVar);
							}else{
								((DataObject)var).set(part, value);
							}
						}
					}
				}else{
					if(to.getQuery() != null) {
						// <to variable="BPELVariableName">
						// <query queryLanguage="anyURI"?>
						// queryContent
					    // </query>
						String toQuery = (String)to.getQuery().getAny().get(0).getValue();
						System.out.println("TO " + "variable:" + toVariable + " query:" + toQuery);
						if(var == null) {
							QName type = variableDef.getType();
							if(type == null) {
								//typeelement壬messageType
								type = variableDef.getElement();
							}
							String typeURI = type.getNamespaceURI();
							String tyepLocalPart = type.getName();
							var = DataFactory.INSTANCE.create(typeURI, tyepLocalPart);
							variableContainer.setVariable(toVariable, var);
						}	
						((DataObject)var).set(toQuery, value);
					}else{
						// <to variable="BPELVariableName"/>
						System.out.println("TO " + "variable:" + toVariable);
						if(value instanceof EndpointReference) {
							QName messageType = variableDef.getMessageType();
						    String messageTypeURI = messageType.getNamespaceURI();
						    String messageTypeLocalPart = messageType.getName();
						    var = DataFactory.INSTANCE.create(messageTypeURI, messageTypeLocalPart);
						    variableContainer.setVariable(toVariable, var);
						    String address = ((EndpointReference)value).getAddress();
						    String wsaURI = ConstantUtil.NS_WSA;
						    DataObject addr = DataFactory.INSTANCE.create(wsaURI, "Address");
						    addr.set(0, address);
						    ((DataObject)var).set("Address", addr);
						}else{
							variableContainer.setVariable(toVariable, value);
					    }		
					}
				}
			}
			
			if (toPartnerLink != null) {
				// <to partnerLink="NCName" />
				System.out.println("To " + "partnerLink:" + toPartnerLink); 
				PartnerLink partnerLink = deploymentUnit.getPartnerLink(toPartnerLink);
				EndpointReference endpoint = partnerLink.getPartnerEndpoint();
				if (value instanceof EndpointReference) {
					String address = ((EndpointReference)value).getAddress();
					endpoint.setAddress(address);
				}else{
					DataObject uri = (DataObject)((DataObject)value).get("Address");
					String address = uri.get(0).toString();
					endpoint.setAddress(address);
				}
			}
		}
		super.finish();
	}
}
