package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TActivity;
import org.act.xservices.bpel20.TActivityContainer;
import org.act.xservices.bpel20.TCompensate;
import org.act.xservices.bpel20.TScope;

public class CompensateInstance extends Bpel20ActivityInstance {
	
	private Stack<Object> activitiesStack;
	
	public CompensateInstance(TCompensate compensate, Bpel20InstanceUnit instanceUnit) {
		this.type = "Compensate";
		this.name = compensate.getName();
		this.activity = compensate;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public CompensateInstance(TCompensate compensate, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(compensate, instanceUnit);
		this.activitiesStack = activitiesStack;
	}
	
	//<compensate standard-attributes>
	//   standard-elements
	//</compensate>
	//<compensationHandler>?
	//   activity
	//</compensationHandler>
	public void run() throws Exception{
		super.start();
		//TCompensate compensate = (TCompensate) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;
		TScope scope = (TScope)instanceUnit.getScopesStack().get(0);
		TActivityContainer compensationHandler = scope.getCompensationHandler();
		if(compensationHandler != null) {
			TActivityContainer father = compensationHandler;
			TActivity activity = null;
			if (father.getEmpty() != null) {
				activity = father.getEmpty();
			}
			if (father.getInvoke() != null) {
				activity = father.getInvoke();
			}
			if (father.getReceive() != null) {
				activity = father.getReceive();
			}
			if (father.getReply() != null) {
				activity = father.getReply();
			}
			if (father.getAssign() != null) {
				activity = father.getAssign();
			}
			if (father.getWait() != null) {
				activity = father.getWait();
			}
			if (father.getThrow() != null) {
				activity = father.getThrow();
			}
			if (father.getRethrow() != null) {
				activity = father.getRethrow();
			}
			if (father.getExit() != null) {
				activity = father.getExit();
			}
			if (father.getFlow() != null) {
				activity = father.getFlow();
			}
			if (father.getForEach() != null) {
				activity = father.getForEach();
			}
			if (father.getIf() != null) {
				activity = father.getIf();
			}
			if (father.getWhile() != null) {
				activity = father.getWhile();
			}
			if (father.getRepeatUntil() != null) {
				activity = father.getRepeatUntil();
			}
			if (father.getSequence() != null) {
				activity = father.getSequence();
			}
			if (father.getPick() != null) {
				activity = father.getPick();
			}
			if (father.getScope() != null) {
				activity = father.getScope();
			}
			activitiesStack.push(activity);
		}
		super.finish();
	}
}
