package org.act.xservices.engine.rt.bpel20;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Stack;

import org.act.xservices.bpel.wsdl.PropertyAlias;
import org.act.xservices.bpel20.TAssign;
import org.act.xservices.bpel20.TBoolean;
import org.act.xservices.bpel20.TCorrelation;
import org.act.xservices.bpel20.TCorrelationSet;
import org.act.xservices.bpel20.TCorrelations;
import org.act.xservices.bpel20.TDeadlineExpr;
import org.act.xservices.bpel20.TDurationExpr;
import org.act.xservices.bpel20.TEmpty;
import org.act.xservices.bpel20.TEventHandlers;
import org.act.xservices.bpel20.TExit;
import org.act.xservices.bpel20.TFlow;
import org.act.xservices.bpel20.TForEach;
import org.act.xservices.bpel20.TIf;
import org.act.xservices.bpel20.TInvoke;
import org.act.xservices.bpel20.TOnAlarmEvent;
import org.act.xservices.bpel20.TOnAlarmPick;
import org.act.xservices.bpel20.TOnEvent;
import org.act.xservices.bpel20.TOnMessage;
import org.act.xservices.bpel20.TPick;
import org.act.xservices.bpel20.TReceive;
import org.act.xservices.bpel20.TRepeatUntil;
import org.act.xservices.bpel20.TReply;
import org.act.xservices.bpel20.TRethrow;
import org.act.xservices.bpel20.TScope;
import org.act.xservices.bpel20.TSequence;
import org.act.xservices.bpel20.TThrow;
import org.act.xservices.bpel20.TWait;
import org.act.xservices.bpel20.TWhile;
import org.act.xservices.engine.rt.CorrelatedInstanceUnit;
import org.act.xservices.engine.rt.CorrelationSetInstance;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.PropertyInstance;
import org.act.xservices.engine.rt.VariableContainer;
import org.act.xservices.engine.rt.VariableDef;
import org.act.xservices.engine.rt.bpel.expression.DateExpression;
import org.act.xservices.engine.rt.bpel.expression.DurationExpression;
import org.act.xservices.engine.rt.utils.DataUtil;
import org.act.xservices.engine.rt.utils.QNameUtil;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

import commonj.sdo.DataObject;
import commonj.sdo.Type;
import commonj.sdo.helper.DataFactory;
import commonj.sdo.helper.TypeHelper;

public class InstanceUtil {
	
	public static Object getSubActivity(Object activity) throws Exception {
		Class<?> c = activity.getClass();
		
		Method getEmptyMethod = c.getMethod("getEmpty", new Class[] {});
		Object empty = getEmptyMethod.invoke(activity, new Object[] {});
		if(empty != null) {
			return empty;
		}
		
		Method getInvokeMethod = c.getMethod("getInvoke", new Class[] {});
		Object invoke = getInvokeMethod.invoke(activity, new Object[] {});
		if(invoke != null) {
			return invoke;
		}
		
		Method getReceiveMethod = c.getMethod("getReceive", new Class[] {});
		Object receive = getReceiveMethod.invoke(activity, new Object[] {});
		if(receive != null) {
			return receive;
		}
		
		Method getReplyMethod = c.getMethod("getReply", new Class[] {});
		Object reply = getReplyMethod.invoke(activity, new Object[] {});
		if(reply != null) {
			return reply;
		}
		
		Method getAssignMethod = c.getMethod("getAssign", new Class[] {});
		Object assign = getAssignMethod.invoke(activity, new Object[] {});
		if(assign != null) {
			return assign;
		}
		
		Method getWaitMethod = c.getMethod("getWait", new Class[] {});
		Object wait = getWaitMethod.invoke(activity, new Object[] {});
		if(wait != null) {
			return wait;
		}
		
		Method getThrowMethod = c.getMethod("getThrow", new Class[] {});
		Object Throw = getThrowMethod.invoke(activity, new Object[] {});
		if(Throw != null) {
			return Throw;
		}
		
		Method getRethrowMethod = c.getMethod("getRethrow", new Class[] {});
		Object Rethrow =getRethrowMethod.invoke(activity, new Object[] {});
		if(Rethrow != null) {
			return Rethrow;
		}
		
		Method getExitMethod = c.getMethod("getExit", new Class[] {});
		Object exit = getExitMethod.invoke(activity, new Object[] {});
		if(exit != null) {
			return exit;
		}
		
		Method getFlowMethod = c.getMethod("getFlow", new Class[] {});
		Object flow = getFlowMethod.invoke(activity, new Object[] {});
		if(flow != null) {
			return flow;
		}
		
		Method getForEachMethod = c.getMethod("getForEach", new Class[] {});
		Object forEach = getForEachMethod.invoke(activity, new Object[] {});
		if(forEach != null) {
			return forEach;
		}
		
		Method getIfMethod = c.getMethod("getIf", new Class[] {});
		Object If = getIfMethod.invoke(activity, new Object[] {});
		if(If != null) {
			return If;
		}
		
		Method getWhileMethod = c.getMethod("getWhile", new Class[] {});
		Object While = getWhileMethod.invoke(activity, new Object[] {});
		if(While != null) {
			return While;
		}
		
		Method getRepeatUntilMethod = c.getMethod("getRepeatUntil", new Class[] {});
		Object repeatUntil = getRepeatUntilMethod.invoke(activity, new Object[] {});
		if(repeatUntil != null) {
			return repeatUntil;
		}
		
		Method getSequenceMethod = c.getMethod("getSequence", new Class[] {});
		Object sequence = getSequenceMethod.invoke(activity, new Object[] {});
		if(sequence != null) {
			return sequence;
		}
		
		Method getPickMethod = c.getMethod("getPick", new Class[] {});
		Object pick = getPickMethod.invoke(activity, new Object[] {});
		if(pick != null) {
			return pick;
		}
		
		Method getScopeMethod = c.getMethod("getScope", new Class[] {});
		Object scope = getScopeMethod.invoke(activity, new Object[] {});
		if(scope != null) {
			return scope;
		}
		
		throw new Exception("Can't support the activity named " + c.getName());
	}
	
	public static Bpel20ActivityInstance getActivityInstance(Object activity, Bpel20InstanceUnit instanceUnit) throws Exception {
		Bpel20ActivityInstance instance = null;
		if (activity instanceof TEmpty) {
			instance = new EmptyInstance((TEmpty) activity, instanceUnit);
		}
		if (activity instanceof TInvoke) {
			instance = new InvokeInstance((TInvoke) activity, instanceUnit);
		}
		if (activity instanceof TReceive) {
			instance = new ReceiveInstance((TReceive) activity, instanceUnit);
		}
		if (activity instanceof TReply) {
			instance = new ReplyInstance((TReply) activity, instanceUnit);
		}
		if (activity instanceof TAssign) {
			instance = new AssignInstance((TAssign) activity, instanceUnit);
		}
		if (activity instanceof TWait) {
			instance = new WaitInstance((TWait) activity, instanceUnit);
		}
		if (activity instanceof TThrow) {
			instance = new ThrowInstance((TThrow) activity, instanceUnit);
		}
		if (activity instanceof TRethrow) {
			instance = new RethrowInstance((TRethrow) activity, instanceUnit);
		}
		if (activity instanceof TExit) {
			instance = new ExitInstance((TExit) activity, instanceUnit);
		}
		if (activity instanceof TFlow) {
			instance = new FlowInstance((TFlow) activity, instanceUnit);
		}
		if (activity instanceof TForEach) {
			instance = new ForEachInstance((TForEach) activity, instanceUnit);
		}
		if (activity instanceof TIf) {
			instance = new IfInstance((TIf) activity, instanceUnit);
		}
		if (activity instanceof TWhile) {
			instance = new WhileInstance((TWhile) activity, instanceUnit);
		}
		if (activity instanceof TRepeatUntil) {
			instance = new RepeatUntilInstance((TRepeatUntil) activity, instanceUnit);
		}
		if (activity instanceof TSequence) {
			instance = new SequenceInstance((TSequence) activity, instanceUnit);
		}
		if (activity instanceof TPick) {
			instance = new PickInstance((TPick) activity, instanceUnit);
		}
		if (activity instanceof TScope) {
			instance = new ScopeInstance((TScope) activity, instanceUnit);
		}
		if(instance != null) {
			return instance;
		}
		throw new Exception("Can't create the instance of activity named " + activity.getClass().getName());
	}
	
	// <eventHandlers>?
    // <onEvent partnerLink="NCName" 
	// portType="QName"? 
    // operation="NCName" 
	// ( messageType="QName" | element="QName" )? 
    // variable="BPELVariableName"?
    // messageExchange="NCName"?>*
	// <correlations>?
    // <correlation set="NCName" initiate="yes|join|no"? />+
    // </correlations>
    // <fromParts>?
	// <fromPart part="NCName" toVariable="BPELVariableName" />+
    // </fromParts>
	// <scope ...>...</scope>
    // </onEvent>
	// <onAlarm>* 
	// (
	// <for expressionLanguage="anyURI"?>duration-expr</for> 
	// |
	// <until expressionLanguage="anyURI"?>deadline-expr</until>
	// )?
	// <repeatEvery expressionLanguage="anyURI"?>?
    // duration-expr
	// </repeatEvery>
	// <scope ...>...</scope>
    // </onAlarm>
    // </eventHandlers>
	public static void eventHandlers(TEventHandlers eventHandlers, Bpel20InstanceUnit instanceUnit, 
			Long beginTime) throws Exception{
		Stack<Object> activitiesStack = instanceUnit.getActivitiesStack();
		boolean event = false;
		for (int i = 0; i < eventHandlers.getOnEvent().size(); i++) {
			TOnEvent onMessage = eventHandlers.getOnEvent().get(i);
			event = onEventHandler(onMessage, instanceUnit, activitiesStack);
			if (event) {
				break;
			}	
		}
		
		if (!event) {
			// ҵonAlarmǩʱ亯
			for (int i = 0; i < eventHandlers.getOnAlarm().size(); i++) {
				TOnAlarmEvent onAlarm = eventHandlers.getOnAlarm().get(i);
				boolean alarm = onAlarmEventHandler(onAlarm, activitiesStack, beginTime);
				if(alarm) {
					break;
				}
			}
		}
	}
	
	public static boolean onEventHandler(TOnEvent onEvent, Bpel20InstanceUnit instanceUnit, 
			Stack<Object> activitiesStack) throws Exception{
		String partnerLink = onEvent.getPartnerLink();
		String operation = onEvent.getOperation();
		String variable = onEvent.getVariable();
		TCorrelations correlations = onEvent.getCorrelations();

		Bpel20DeploymentUnit deploymentUnit = (Bpel20DeploymentUnit)instanceUnit.getDeploymentUnit();

		if (instanceUnit.hasMessage(partnerLink, operation)) {
			IServiceContext message = instanceUnit.getMessage(partnerLink, operation);
			PartnerLink pl = deploymentUnit.getPartnerLink(partnerLink);
			//if (pl.getPartnerEndpoint() == null) {
				instanceUnit.storeMessageContext(partnerLink, operation, message);
			//}
			//Metaset paras = message.getInMessage().filter(".\\Body\\" + operation).car();
			ISOAPEnvelope envelope = message.getInMessage();
			Metaset paras = envelope.getBody().element(operation);	
			VariableDef variableDef = deploymentUnit.getVariableDef(variable);
			QName messageType = variableDef.getMessageType();
			String messageTypeURI = messageType.getNamespaceURI();
			String messageTypeLocalPart = messageType.getName();
			Type varType = TypeHelper.INSTANCE.getType(messageTypeURI, messageTypeLocalPart);
			DataObject var = DataFactory.INSTANCE.create(varType);
			DataUtil.metaset2data(paras, var);
			VariableContainer variableContainer = instanceUnit.getVariableContainer();
			variableContainer.setVariable(variable, var);

			if (correlations != null) {
				for (int i = 0; i < correlations.getCorrelation().size(); i++) {
					TCorrelation correlation = correlations.getCorrelation().get(i);
					if (correlation.getInitiate().equals(TBoolean.YES)) {
						String set = correlation.getSet();
						CorrelatedInstanceUnit correlatedInstanceUnit = new CorrelatedInstanceUnit();
						correlatedInstanceUnit.setInstanceId(instanceUnit.getId());
						CorrelationSetInstance correlationSetInstance = new CorrelationSetInstance();
						correlationSetInstance.setName(set);
						TCorrelationSet correlationSet = deploymentUnit.getCorrelationSet(set);
						for (int j = 0; j < correlationSet.getProperties().size(); j++) {
							QName property = QNameUtil.translate(correlationSet.getProperties().get(j));
							PropertyInstance propertyInstance = new PropertyInstance();
							propertyInstance.setQname(property);
							ArrayList<PropertyAlias> propertyAliases = deploymentUnit.getPropertyAlias(messageType);
							for (int k = 0; k < propertyAliases.size(); k++) {
								PropertyAlias propertyAlias = propertyAliases.get(k);
								String part = propertyAlias.getPart();
								String query = propertyAlias.getQuery();
								Object value = var.get(part + query);
								propertyInstance.setValue(value);
							}
							correlationSetInstance.addPropertyInstance(propertyInstance);
						}
						correlatedInstanceUnit.setCorrelationSetInstance(correlationSetInstance);
						deploymentUnit.addCorrelatedInstanceUnit(correlatedInstanceUnit);
					}
				}
			}
			Object activity = InstanceUtil.getSubActivity(onEvent);
			activitiesStack.push(activity);
			return true;
		}
		return false;
	}
	
	public static boolean onMessageHandler(TOnMessage onMessage, Bpel20InstanceUnit instanceUnit, 
			Stack<Object> activitiesStack) throws Exception{
		String partnerLink = onMessage.getPartnerLink();
		String operation = onMessage.getOperation();
		String variable = onMessage.getVariable();
		TCorrelations correlations = onMessage.getCorrelations();

		Bpel20DeploymentUnit deploymentUnit = (Bpel20DeploymentUnit)instanceUnit.getDeploymentUnit();

		if (instanceUnit.hasMessage(partnerLink, operation)) {
			IServiceContext message = instanceUnit.getMessage(partnerLink, operation);
			PartnerLink pl = deploymentUnit.getPartnerLink(partnerLink);
			//if (pl.getPartnerEndpoint() == null) {
				instanceUnit.storeMessageContext(partnerLink, operation, message);
			//}
			//Metaset paras = message.getInMessage().filter(".\\Body\\" + operation).car();
			ISOAPEnvelope envelope = message.getInMessage();
			Metaset paras = envelope.getBody().element(operation);
			VariableDef variableDef = deploymentUnit.getVariableDef(variable);
			QName messageType = variableDef.getMessageType();
			String messageTypeURI = messageType.getNamespaceURI();
			String messageTypeLocalPart = messageType.getName();
			Type varType = TypeHelper.INSTANCE.getType(messageTypeURI, messageTypeLocalPart);
			DataObject var = DataFactory.INSTANCE.create(varType);
			DataUtil.metaset2data(paras, var);
			VariableContainer variableContainer = instanceUnit.getVariableContainer();
			variableContainer.setVariable(variable, var);

			if (correlations != null) {
				for (int i = 0; i < correlations.getCorrelation().size(); i++) {
					TCorrelation correlation = correlations.getCorrelation().get(i);
					if (correlation.getInitiate().equals(TBoolean.YES)) {
						String set = correlation.getSet();
						CorrelatedInstanceUnit correlatedInstanceUnit = new CorrelatedInstanceUnit();
						correlatedInstanceUnit.setInstanceId(instanceUnit.getId());
						CorrelationSetInstance correlationSetInstance = new CorrelationSetInstance();
						correlationSetInstance.setName(set);
						TCorrelationSet correlationSet = deploymentUnit.getCorrelationSet(set);
						for (int j = 0; j < correlationSet.getProperties().size(); j++) {
							QName property = QNameUtil.translate(correlationSet.getProperties().get(j));
							PropertyInstance propertyInstance = new PropertyInstance();
							propertyInstance.setQname(property);
							ArrayList<PropertyAlias> propertyAliases = deploymentUnit.getPropertyAlias(messageType);
							for (int k = 0; k < propertyAliases.size(); k++) {
								PropertyAlias propertyAlias = propertyAliases.get(k);
								String part = propertyAlias.getPart();
								String query = propertyAlias.getQuery();
								Object value = var.get(part + query);
								propertyInstance.setValue(value);
							}
							correlationSetInstance.addPropertyInstance(propertyInstance);
						}
						correlatedInstanceUnit.setCorrelationSetInstance(correlationSetInstance);
						deploymentUnit.addCorrelatedInstanceUnit(correlatedInstanceUnit);
					}
				}
			}
			Object activity = InstanceUtil.getSubActivity(onMessage);
			activitiesStack.push(activity);
			return true;
		}
		return false;
	}
	
	public static boolean onAlarmEventHandler(TOnAlarmEvent onAlarm, Stack<Object> activitiesStack, long beginTime) throws Exception{
		TDurationExpr durationExpression = onAlarm.getFor();
		TDeadlineExpr dateExpression = onAlarm.getUntil();

		// Ϊ,ôҪӡϢ
		if ((durationExpression == null) && (dateExpression == null)) {
			throw new Exception("Wrong format of onAlarm in eventHandlers");
		}

		String duration = null;
		String date = null;
		
		if(durationExpression != null) {
			duration = (String)durationExpression.getMixed().getValue(0);
		}
		if(dateExpression != null) {
			date = (String)dateExpression.getMixed().getValue(0);
		}
			
		long runningTime = System.currentTimeMillis() - beginTime;
		if (!onTime(duration, date, runningTime)) {
			activitiesStack.push(onAlarm.getScope());
			return true;
		}
		return false;
	}
	
	public static boolean onAlarmPickHandler(TOnAlarmPick onAlarm, Stack<Object> activitiesStack, long beginTime) throws Exception{
		TDurationExpr durationExpression = onAlarm.getFor();
		TDeadlineExpr dateExpression = onAlarm.getUntil();

		// Ϊ,ôҪӡϢ
		if ((durationExpression == null) && (dateExpression == null)) {
			throw new Exception("Wrong format of onAlarm in eventHandlers");
		}

		String duration = null;
		String date = null;
		
		if(durationExpression != null) {
			duration = (String)durationExpression.getMixed().getValue(0);
		}
		if(dateExpression != null) {
			date = (String)dateExpression.getMixed().getValue(0);
		}
			
		long runningTime = System.currentTimeMillis() - beginTime;
		if (!onTime(duration, date, runningTime)) {
			Object activity = InstanceUtil.getSubActivity(onAlarm);
			activitiesStack.push(activity);
			return true;
		}
		return false;
	}
	
	private static boolean onTime(String durationExpression, String dateExpression, long runningTime) {

		if (durationExpression != null) {
			if (runningTime < DurationExpression
					.getExpressionValue(durationExpression))
				return true;
			else
				return false;
		}

		if (dateExpression != null) {
			if (DateExpression.getExpressionValue(dateExpression) >0)
				return true;
			else
				return false;
		}
		return false;
	}
}
