package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TOnAlarmPick;
import org.act.xservices.bpel20.TOnMessage;
import org.act.xservices.bpel20.TPick;

public class PickInstance extends Bpel20ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public PickInstance(TPick pick, Bpel20InstanceUnit instanceUnit) {
		this.type = "Pick";
		this.name = pick.getName();
		this.activity = pick;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public PickInstance(TPick pick, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(pick, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <pick createInstance="yes|no"? standard-attributes>
	// standard-elements
	// <onMessage partnerLink="NCName" 
	// portType="QName"? 
	// operation="NCName"
	// variable="BPELVariableName"? 
	// messageExchange="NCName"?>+
	// <correlations>?
	// <correlation set="NCName" initiate="yes|join|no"? />+
	// </correlations>
	// <fromParts>?
	// <fromPart part="NCName" toVariable="BPELVariableName" />+
	// </fromParts>
	// activity
	// </onMessage>
	// <onAlarm>* 
	// (
	// <for expressionLanguage="anyURI"?>duration-expr</for>
	// |
	// <until expressionLanguage="anyURI"?>deadline-expr</until>
	// ) 
	// activity
	// </onAlarm>
	// </pick>

	public void run() throws Exception{
		super.start();
		TPick pick = (TPick) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;

		boolean loop = true;
		long beginTime = System.currentTimeMillis();
		while (loop) {
			// õonMessageǩһonMessage
			for (int i = 0; i < pick.getOnMessage().size(); i++) {
				TOnMessage onMessage = pick.getOnMessage().get(i);
				boolean start = InstanceUtil.onMessageHandler(onMessage, instanceUnit, activitiesStack);	
				if (start) {
					loop = false;
					break;
				}
			}
			if (loop) {
				// ҵonAlarmǩʱ亯
				for (int i = 0; i < pick.getOnAlarm().size(); i++) {
					TOnAlarmPick onAlarm = pick.getOnAlarm().get(i);
					boolean start = InstanceUtil.onAlarmPickHandler(onAlarm, activitiesStack, beginTime);
					if(start) {
						loop = false;
						break;
					}
				}
				if(loop) {
					Thread.sleep(5000);
				}
			}
		}
		super.finish();
	}
}
