package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TActivity;
import org.act.xservices.bpel20.TRepeatUntil;
import org.act.xservices.engine.rt.bpel.expression.BooleanExpression;

public class RepeatUntilInstance extends Bpel20ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public RepeatUntilInstance(TRepeatUntil repeatUntil, Bpel20InstanceUnit instanceUnit) {
		this.type = "RepeatUntil";
		this.name = repeatUntil.getName();
		this.activity = repeatUntil;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public RepeatUntilInstance(TRepeatUntil repeatUntil, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(repeatUntil, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <repeatUntil standard-attributes>
	// standard-elements 
	// activity
	// <condition expressionLanguage="anyURI"?>bool-expr</condition>
	// </repeatUntil>


	public void run() throws Exception {
		super.start();
		TRepeatUntil repeatUntil = (TRepeatUntil) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;
		
		String condition = (String)repeatUntil.getCondition().getMixed().getValue(0);
		try {	
			if (BooleanExpression.getExpressionValue(condition,instanceUnit)) {
				TRepeatUntil father = repeatUntil;
				TActivity activity = null;
				if (father.getEmpty() != null) {
					activity = father.getEmpty();
				}
				if (father.getInvoke() != null) {
					activity = father.getInvoke();
				}
				if (father.getReceive() != null) {
					activity = father.getReceive();
				}
				if (father.getReply() != null) {
					activity = father.getReply();
				}
				if (father.getAssign() != null) {
					activity = father.getAssign();
				}
				if (father.getWait() != null) {
					activity = father.getWait();
				}
				if (father.getThrow() != null) {
					activity = father.getThrow();
				}
				if (father.getRethrow() != null) {
					activity = father.getRethrow();
				}
				if (father.getExit() != null) {
					activity = father.getExit();
				}
				if (father.getFlow() != null) {
					activity = father.getFlow();
				}
				if (father.getForEach() != null) {
					activity = father.getForEach();
				}
				if (father.getIf() != null) {
					activity = father.getIf();
				}
				if (father.getWhile() != null) {
					activity = father.getWhile();
				}
				if (father.getRepeatUntil() != null) {
					activity = father.getRepeatUntil();
				}
				if (father.getSequence() != null) {
					activity = father.getSequence();
				}
				if (father.getPick() != null) {
					activity = father.getPick();
				}
				if (father.getScope() != null) {
					activity = father.getScope();
				}
				activitiesStack.push(repeatUntil);
				activitiesStack.push(activity);
			}
			super.finish();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}

