package org.act.xservices.engine.rt.bpel20;

import org.act.xservices.bpel20.TReply;
import org.act.xservices.engine.rt.utils.DataUtil;
import org.act.xservices.engine.rt.utils.SoapUtil;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

public class ReplyInstance extends Bpel20ActivityInstance {
	
	public ReplyInstance(TReply reply, Bpel20InstanceUnit instanceUnit) {
		this.type = "Reply";
		this.name = reply.getName();
		this.activity = reply;
		this.instanceUnit = instanceUnit;
	}

	// 壺
	// <reply partnerLink="ncname" portType="qname" operation="ncname"
	// variable="ncname"? faultName="qname"? standard-attributes>
	// standard-elements
	// <correlations>?
	// <correlation set="ncname" initiate="yes|no"?>+
	// </correlations>
	// </reply>
	public void run() throws Exception {
		super.start();
		TReply reply = (TReply) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;
		
		String partnerLink = reply.getPartnerLink();
		QName portType = MetasetUtil.jQNameToxQName(reply.getPortType());
		String operation = reply.getOperation();
		String variable = reply.getVariable();

		System.out.println("partnerLink: " + partnerLink + " operation: "
				+ operation + "  variable: " + variable);
		
		IServiceContext context = instanceUnit.getContext(partnerLink, operation);
		
		Metaset soapMsg = SoapUtil.createEmptySoap();
		//Metaset body = soapMsg.filter(".\\Body").car();
		Metaset body = soapMsg.element("Body");
		
		Metaset paras = MetasetBuilder.getInstance().newMetaset(portType.getNamespaceURI(), operation+"Response", "ns");
		paras.add(MetasetBuilder.getInstance().newAttribute("xmlns:ns", portType.getNamespaceURI()));
		DataUtil.data2metaset(instanceUnit, variable, paras);
		body.add(paras);
		
//		Metaset requestService = context.getInMessage();
//		Metaset messageID = requestService.filter(".\\Header\\MessageID");
//		if(messageID != null) {
//			Metaset header = soapMsg.filter(".\\Header").car();
//			header.add(messageID.car());
//		}
		
		
		//add by viking 2010 07 07 
		ISOAPEnvelope envelope=SOAPMessageUtil.convertMetasetToSOAPEnvelope(soapMsg);
		context.setOutMessage(envelope);

		this.instanceUnit.getMessageOut().put(context);

	    super.finish();
	}
}
