package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TScope;

public class ScopeInstance extends Bpel20ActivityInstance {
	
	private Stack<Object> activitiesStack;
	
	public ScopeInstance(TScope scope, Bpel20InstanceUnit instanceUnit) {
		this.type = "Scope";
		this.name = scope.getName();
		this.activity = scope;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public ScopeInstance(TScope scope, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(scope, instanceUnit);
		this.activitiesStack = activitiesStack;
	}
	
	// <scope isolated="yes|no"? exitOnStandardFault="yes|no"?
	// standard-attributes>
	// standard-elements
	// <variables>?
	// ...
	// </variables>
	// <partnerLinks>?
	// ...
	// </partnerLinks>
	// <messageExchanges>?
	// ...
	// </messageExchanges>
	// <correlationSets>?
	// ...
	// </correlationSets>
	// <eventHandlers>? 
	// ...
	// </eventHandlers>
	// <faultHandlers>?
	// ...
	// </faultHandlers>
	// <compensationHandler>?
	// ...
	// </compensationHandler>
	// <terminationHandler>?
	// ...
	// </terminationHandler>
	// activity
	// </scope>

	public void run() throws Exception {
		super.start();
		TScope scope = (TScope) this.activity;
		this.instanceUnit.getScopesStack().push(scope);
		Object activity = InstanceUtil.getSubActivity(scope);
		activitiesStack.push(activity);
		super.finish();
	}
}
