package org.act.xservices.engine.rt.bpel20;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Stack;

import org.act.xservices.bpel20.TActivity;
import org.act.xservices.bpel20.TSequence;

public class SequenceInstance extends Bpel20ActivityInstance {
	
	private Stack<Object> activitiesStack;
	
	public SequenceInstance(TSequence sequence, Bpel20InstanceUnit instanceUnit) {
		this.type = "Sequence";
		this.name = sequence.getName();
		this.activity = sequence;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public SequenceInstance(TSequence sequence, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(sequence, instanceUnit);
		this.activitiesStack = activitiesStack;
	}
	
	public void run() throws Exception {
		super.start();
		TSequence sequence = (TSequence) activity;
		ArrayList<TActivity> activities = new ArrayList<TActivity>();
		for(Iterator<Object> iter = sequence.getActivity().valueListIterator() ; iter.hasNext(); ) {
			TActivity activity = (TActivity)iter.next();
			activities.add(activity);
		}
		for(int i=activities.size()-1; i >= 0; i--) {
			TActivity activity = activities.get(i);
			activitiesStack.push(activity);
		}
		super.finish();
	}
}
