package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TActivity;
import org.act.xservices.bpel20.TActivityContainer;
import org.act.xservices.bpel20.TCatch;
import org.act.xservices.bpel20.TFaultHandlers;
import org.act.xservices.bpel20.TThrow;

public class ThrowInstance extends Bpel20ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public ThrowInstance(TThrow Throw, Bpel20InstanceUnit instanceUnit) {
		this.type = "Throw";
		this.name = Throw.getName();
		this.activity = Throw;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public ThrowInstance(TThrow Throw, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(Throw, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <throw faultName="qname" faultVariable="ncname"? standard-attributes>
	// standard-elements
	// </throw>
	// <faultHandlers>
    // <catch faultName="QName"? 
	// faultVariable="BPELVariableName"?
	// ( faultMessageType="QName" | faultElement="QName" )? >*
    // activity
	// </catch>
	// <catchAll>?
	// activity
    // </catchAll>
    // </faultHandlers>

	public void run() throws Exception {
		super.start();
		TThrow Throw = (TThrow) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;

		Object faultName = Throw.getFaultName();
		String faultVariable = Throw.getFaultVariable();

		TFaultHandlers faultHandlers = ((Bpel20DeploymentUnit)instanceUnit.getDeploymentUnit()).getBpel().getFaultHandlers();
		TCatch catchHandler = null;
		if (faultHandlers != null) {
			TActivityContainer catchAll = faultHandlers.getCatchAll();
			if (faultVariable == null) {
				//ûصĹ
				for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
					TCatch Catch = faultHandlers.getCatch().get(i);
					Object fName = Catch.getFaultName();
					if(faultName.equals(fName)) {
						//ѡ catch ָƥ faultName ֵ
						catchHandler = Catch;
						break;
					}
				}
			}
			else{
				//صĹ
				for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
					TCatch Catch = faultHandlers.getCatch().get(i);
					Object fName = Catch.getFaultName();
					String fVariable = Catch.getFaultVariable();
					if(faultName.equals(fName) && faultVariable.equals(fVariable)) {
						//ѡ catch ָƥ faultName ֵԼͣWSDL Ϣͣƥ͵ faultVariable
						catchHandler = Catch;
						break;
					}
				}
				if(catchHandler != null) {
					for (int i = 0; i < faultHandlers.getCatch().size(); i++) {
						TCatch Catch = faultHandlers.getCatch().get(i);
						String fVariable = Catch.getFaultVariable();
						if(faultVariable.equals(fVariable)) {
							//򣬾ͽѡ񲻴ָ faultName ƥ͵ faultVariable  catch 
							catchHandler = Catch;
							break;
						}
					}
				}
			}
			if(catchHandler != null) {
				TCatch father = catchHandler;
				TActivity activity = null;
				if (father.getEmpty() != null) {
					activity = father.getEmpty();
				}
				if (father.getInvoke() != null) {
					activity = father.getInvoke();
				}
				if (father.getReceive() != null) {
					activity = father.getReceive();
				}
				if (father.getReply() != null) {
					activity = father.getReply();
				}
				if (father.getAssign() != null) {
					activity = father.getAssign();
				}
				if (father.getWait() != null) {
					activity = father.getWait();
				}
				if (father.getThrow() != null) {
					activity = father.getThrow();
				}
				if (father.getRethrow() != null) {
					activity = father.getRethrow();
				}
				if (father.getExit() != null) {
					activity = father.getExit();
				}
				if (father.getFlow() != null) {
					activity = father.getFlow();
				}
				if (father.getForEach() != null) {
					activity = father.getForEach();
				}
				if (father.getIf() != null) {
					activity = father.getIf();
				}
				if (father.getWhile() != null) {
					activity = father.getWhile();
				}
				if (father.getRepeatUntil() != null) {
					activity = father.getRepeatUntil();
				}
				if (father.getSequence() != null) {
					activity = father.getSequence();
				}
				if (father.getPick() != null) {
					activity = father.getPick();
				}
				if (father.getScope() != null) {
					activity = father.getScope();
				}
				activitiesStack.push(activity);
			}else if(catchAll != null) {
				//ѡȱʡ catchAll 
				TActivityContainer father = catchAll;
				TActivity activity = null;
				if (father.getEmpty() != null) {
					activity = father.getEmpty();
				}
				if (father.getInvoke() != null) {
					activity = father.getInvoke();
				}
				if (father.getReceive() != null) {
					activity = father.getReceive();
				}
				if (father.getReply() != null) {
					activity = father.getReply();
				}
				if (father.getAssign() != null) {
					activity = father.getAssign();
				}
				if (father.getWait() != null) {
					activity = father.getWait();
				}
				if (father.getThrow() != null) {
					activity = father.getThrow();
				}
				if (father.getRethrow() != null) {
					activity = father.getRethrow();
				}
				if (father.getExit() != null) {
					activity = father.getExit();
				}
				if (father.getFlow() != null) {
					activity = father.getFlow();
				}
				if (father.getForEach() != null) {
					activity = father.getForEach();
				}
				if (father.getIf() != null) {
					activity = father.getIf();
				}
				if (father.getWhile() != null) {
					activity = father.getWhile();
				}
				if (father.getRepeatUntil() != null) {
					activity = father.getRepeatUntil();
				}
				if (father.getSequence() != null) {
					activity = father.getSequence();
				}
				if (father.getPick() != null) {
					activity = father.getPick();
				}
				if (father.getScope() != null) {
					activity = father.getScope();
				}
				activitiesStack.push(activity);
			}
		}
		super.finish();
	}
}
