package org.act.xservices.engine.rt.bpel20;

import org.act.xservices.bpel20.TWait;
import org.act.xservices.engine.rt.bpel.expression.DateExpression;
import org.act.xservices.engine.rt.bpel.expression.DurationExpression;

public class WaitInstance extends Bpel20ActivityInstance {
	
	public WaitInstance(TWait wait, Bpel20InstanceUnit instanceUnit) {
		this.type = "Wait";
		this.name = wait.getName();
		this.activity = wait;
		this.instanceUnit = instanceUnit;
	}
	
	// <wait standard-attributes>
	// standard-elements 
	// (
	// <for expressionLanguage="anyURI"?>duration-expr</for>
	// |
	// <until expressionLanguage="anyURI"?>deadline-expr</until>
	// )
	// </wait>

	public void run() throws Exception {
		super.start();
		TWait wait = (TWait) this.activity;
		boolean isDuration = true;
		String durationExpression = null;
		String dateExpression = null;
		
		if(wait.getFor() != null) {
			durationExpression = (String)wait.getFor().getMixed().getValue(0);
		}
		
		if(wait.getUntil() != null) {
			dateExpression = (String)wait.getUntil().getMixed().getValue(0);
		}
		
		if(durationExpression == null)
			isDuration = false;
		
		long waitingTime = 0;
		if (isDuration) {
			waitingTime = DurationExpression
					.getExpressionValue(durationExpression);
				
		}else {
			waitingTime = DateExpression.getExpressionValue(dateExpression);
		}
		try {
			Thread.sleep(waitingTime);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		super.finish();
	}
}
