package org.act.xservices.engine.rt.bpel20;

import java.util.Stack;

import org.act.xservices.bpel20.TWhile;
import org.act.xservices.engine.rt.bpel.expression.BooleanExpression;

public class WhileInstance extends Bpel20ActivityInstance {

	private Stack<Object> activitiesStack;
	
	public WhileInstance(TWhile While, Bpel20InstanceUnit instanceUnit) {
		this.type = "While";
		this.name = While.getName();
		this.activity = While;
		this.instanceUnit = instanceUnit;
		this.activitiesStack = instanceUnit.getActivitiesStack();
	}
	
	public WhileInstance(TWhile While, Bpel20InstanceUnit instanceUnit, Stack<Object> activitiesStack) {
		this(While, instanceUnit);
		this.activitiesStack = activitiesStack;
	}

	// <while standard-attributes>
	// standard-elements
	// <condition expressionLanguage="anyURI"?>bool-expr</condition>
	// activity
	// </while>

	public void run() throws Exception {
		super.start();
		TWhile While = (TWhile) this.activity;
		Bpel20InstanceUnit instanceUnit = (Bpel20InstanceUnit)this.instanceUnit;
		
		String condition = (String)While.getCondition().getMixed().getValue(0);
		if (BooleanExpression.getExpressionValue(condition,instanceUnit)) {
			Object activity = InstanceUtil.getSubActivity(While);
			activitiesStack.push(While);
			activitiesStack.push(activity);
		}
		super.finish();
	}
}
