
package org.act.xservices.engine.rt.management;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

import org.act.xservices.engine.rt.ActivityInstance;
import org.act.xservices.engine.rt.InstanceUnit;
import org.act.xservices.engine.rt.PartnerLink;
import org.act.xservices.engine.rt.adapter.BPELAdapter;
import org.act.xservices.engine.rt.deploy.DeploymentUnit;
import org.act.xservices.engine.rt.persistence.ActivityInstanceRecord;
import org.act.xservices.engine.rt.persistence.EngineRecord;
import org.act.xservices.engine.rt.persistence.ProcessInstanceRecord;
import org.act.xservices.rt.xcontainer.deployment.util.DeploymentConstants;
import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;

import sun.misc.*;

/**
 * @author chenyy chenyy@act.buaa.edu.cn
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class WFInfo {
	
	public static final char NL = '\n';

	public static final char CR = '\r';

	/**
	 * The prefered line separator
	 */
	public static final String LS = System.getProperty("line.separator",
			(new Character(NL)).toString());

	private static final BPELAdapter engine = BPELManageUtil.getBpelProcessor();
	
	private static final IContainerEnvironment containerEnv = BPELManageUtil.getContainerEnvironment();
	
	/**
	 * ĻϢ
	 * @return
	 */
	public static String getEngineInfo() {
		 
		String name = engine.getName();
		String version = engine.getVersion();
		String description = engine.getDescription();
		String startTime = engine.getStartupTime();
		String databaseType = engine.getDatabase().getType();
	    return name + "#" + version + "#" + description + "#" + startTime + "#" + databaseType + "#";
	}
		
	/**
	 *ʷϢ 
	 *
	 */
	public static String getEngineHistoryInfo(){
		
		ArrayList<EngineRecord> engineRecordList = engine.getDatabase().getAllEngineRecords();
		String engineHistory = null;
		for(int i = 0; i < engineRecordList.size(); i ++)
		{
			EngineRecord engineRecord = engineRecordList.get(i);
			engineHistory += engineRecord.getStartupTime() + "~" + engineRecord.getShutdownTime() + "#";
		}
		return engineHistory;
	}
		
	/**
	 * ȡѲͣ#ŷָ
	 * 
	 * @return
	 */
	public static String getDeployedInstances() {
		
		DeploymentUnit[] wfContext = engine.getDeploymentUnitRegistry().getAll();
		String instanceList = "#";
		for (int i = 0; i < wfContext.length; i++)
		{
			String str= wfContext[i].getId().replaceAll("#", "/");
			instanceList = instanceList + str + "#";			
		}
		return instanceList;		
	}
    
	/**
	 * ̲Ԫ
	 * ̲ԪĻϢ
	 * ʶơ汾ƿռ䡢ʱ䡢Ŀ¼״̬
	 */
	public static String getDeploymentUnitInfo(){
		
		DeploymentUnit[] deploymentUnitList = engine.getDeploymentUnitRegistry().getAll();
		String deploymentUnitInfo = "#";
		for(int i = 0; i < deploymentUnitList.length; i++)
		{
			DeploymentUnit deploymentUnit = deploymentUnitList[i];
			deploymentUnitInfo += deploymentUnit.getId() + "~" + deploymentUnit.getName() + "~" + deploymentUnit.getVersion() + "~" + 
            deploymentUnit.getTargetNamespace() + "~" + deploymentUnit.getDeployTime() + "~" + deploymentUnit.getState() + "#";
		}
		
		return deploymentUnitInfo;
	}
	
	/**
	 * ̲Ԫ
	 * ̲ԪĻϢ
	 * ʶơ汾ƿռ䡢ʱ䡢Ŀ¼״̬
	 */
	public static String getDeploymentUnitInfobyId(String id){
		
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(id);
		String deploymentUnitInfo = "";

		deploymentUnitInfo += deploymentUnit.getId() + "#" + deploymentUnit.getName() + "#" + deploymentUnit.getVersion() + "#" + 
        deploymentUnit.getTargetNamespace() + "#" + deploymentUnit.getDeployTime() + "#" + deploymentUnit.getState() + "#" + deploymentUnit.getInstanceUnitPool().getCurrentNumber();
	
		return deploymentUnitInfo;
	}
	
		
	/**
	 * 
	 * 
	 * @param type
	 *            
	 * @param file
	 *            ̲ļ
	 * @return
	 */
	public static String DeployInstance(String file, String type) {
		
		File bpelDeployDir = (File)
			containerEnv.getAttribute(DeploymentConstants.DIR_DEPLOY_BPELSERVICES);
		
		String dir = bpelDeployDir.getAbsolutePath() + File.separator + type + ".bar";
		
		BASE64Decoder base64De = new BASE64Decoder();		
		try {
			 byte[] fileByte = base64De.decodeBuffer(file);
			 OutputStream fos = new FileOutputStream(dir);
			 fos.write(fileByte);
             fos.close();
             fos = null;
             return "ok";
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "fail";
		}  catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "fail";
		}
		//		 TODO Auto-generated constructor stub
	}

	/**
	 * 
	 * 
	 * @param type
	 *            
	 * @return
	 */
	public static String UnDeployInstance(String type) {
		
//		String t = type.replaceAll("/", "#");
//		
//		String result = "";
//		try {
//			DeploymentManager dm = new DeploymentManager();
//			dm.anti_deploy(t);
//			
//				result = "success";
////			else
////				result = "fail";
//		} catch (Exception ex) {
//			result = "error";
//		}
//		return result;
//		//TODO
		return null;
	}

	/**
	 * ʼã
	 * 
	 * @param type
	 *            
	 * @param invokeInfo
	 *            ʼϢ
	 * @return
	 */
	public static String invokeInstance(String type, String invokeInfo) {
		return null;
		//TODO
	}

	/**
	 * BPEL
	 * 
	 * @param type
	 *            
	 * @return
	 */
	public static String getBpel(String id) {
		
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(id);
		String dir = deploymentUnit.getBPELPath();
		
		String fileContent = "";

		try {
			File wsdlFile = new File(dir);
			
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();

			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}

			input.close();
			fileContent = new String(outputstrem.toByteArray());
			outputstrem.close();
		} catch (FileNotFoundException e) {
			System.err.print(id + "bpelļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		//System.out.println(normalize(fileContent.trim()));
		return fileContent.trim();
	}

	/**
	 * ̵WSDLļ
	 * 
	 * @param id
	 *            
	 * @return
	 */
	public static String getWSDL(String id) {
		
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(id);
		String dir = deploymentUnit.getWSDLPath();
		
		String fileContent = "";

		try {
			File wsdlFile = new File(dir);
			
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();

			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}

			input.close();
			fileContent = new String(outputstrem.toByteArray());
			outputstrem.close();
		} catch (FileNotFoundException e) {
			System.err.print(id + "WSDLļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		//System.out.println(normalize(fileContent.trim()));
		return fileContent.trim();
	}
	
	/**
	 * ̲ԪPDDļ
	 * 
	 * @param id
	 *            
	 * @return
	 */
	public static String getPDD(String id) {
		
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(id);
		String dir = deploymentUnit.getPDDPath();
		
		String fileContent = "";

		try {
			File wsdlFile = new File(dir);
			
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();

			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}

			input.close();
			fileContent = new String(outputstrem.toByteArray());
			outputstrem.close();
		} catch (FileNotFoundException e) {
			System.err.print(id + "PDDļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		//System.out.println(normalize(fileContent.trim()));
		return fileContent.trim();
	}
		
	/**
	 * WSDD
	 * 
	 * @param type
	 *            
	 * @return
	 */
	public static String getWFWsdd(String type) {
		
		File bpelWorkDir = (File)
			containerEnv.getAttribute(DeploymentConstants.DIR_WORKING_BPELSERVICES);
		
		String dir = bpelWorkDir.getAbsolutePath()
				+ File.separator + type + ".bar"
				+ File.separator + "META-INF" + File.separator
				+ "service.xml";
		String fileContent = "";
		try {
			File wsdlFile = new File(dir);
			
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();

			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}

			input.close();
			fileContent = new String(outputstrem.toByteArray());
		} catch (FileNotFoundException e) {
			System.err.print(type + "wsddļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		return normalize(fileContent.trim());
	}

	/**
	 * صĻӹϵ
	 * name~myRole~partnerRole~partnerLinkType~myEndpoint~partnerEndpoint
	 * @param id  Ϊ̲Ԫıʶ
	 */
	public static String getPartnerLinks(String id){
		
		PartnerLink[] partnerLinkList = engine.getDeploymentUnitRegistry().get(id).getPartnerLinks();
		String partnerLinksInfo = "#";
		for(int i = 0; i < partnerLinkList.length; i++)
		{
			PartnerLink partnerLink = partnerLinkList[i];
			partnerLinksInfo += partnerLink.getName() + "~" + partnerLink.getMyRole() + "~" + partnerLink.getPartnerRole()
			                   + "~" + partnerLink.getPartnerLinkType() + "~" + partnerLink.getMyEndpoint() + "~"
			                   + partnerLink.getPartnerEndpoint() + "#";			
		}
		return partnerLinksInfo;
	}
	
	/**
	 * ̲ԪصʵϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 * @param id Ϊ̲Ԫıʶ
	 */
	public static String getInstanceUnits(String id){
		
		InstanceUnit[] instanceUnitList = engine.getDeploymentUnitRegistry().get(id).getInstanceUnitPool().getAll();
	    String InstanceUnitsInfo = "#";
	    for(int i = 0; i < instanceUnitList.length; i++)
	    {
	    	InstanceUnit instanceUnit = instanceUnitList[i];
	    	InstanceUnitsInfo += instanceUnit.getId() + "~" + instanceUnit.getDeploymentUnit().getId() + "~" 
	    	                    + instanceUnit.getStartTime() + "~" + instanceUnit.getEndTime() + "~" + instanceUnit.getState() + "#";
	    }
	    return InstanceUnitsInfo;
	}
	
	/**
	 * еʵϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 */
	public static String getAllInstanceUnits(){
		
		DeploymentUnit[] deploymentUnitList = engine.getDeploymentUnitRegistry().getAll();
	    String InstanceUnitsInfo = "#";
	    for(int i = 0; i < deploymentUnitList.length; i++)
	    {
		    InstanceUnit[] instanceUnitList = deploymentUnitList[i].getInstanceUnitPool().getAll();
	    	for(int j = 0; j < instanceUnitList.length; j++)
		    {
		    	InstanceUnit instanceUnit = instanceUnitList[j];
		    	InstanceUnitsInfo += instanceUnit.getId() + "~" + instanceUnit.getDeploymentUnit().getId() + "~" 
		    	                    + instanceUnit.getStartTime() + "~" + instanceUnit.getEndTime() + "~" + instanceUnit.getState() + "#";
		    }
	    }

	    return InstanceUnitsInfo;
	}
	
	/**
	 * ʵʶĳʵϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 */
	public static String getInstanceUnitsbyId(String id){
		
		DeploymentUnit[] deploymentUnitList = engine.getDeploymentUnitRegistry().getAll();
	    String InstanceUnitsInfo = "";
	    for(int i = 0; i < deploymentUnitList.length; i++)
	    {
		    InstanceUnit instanceUnit = deploymentUnitList[i].getInstanceUnitPool().get(id);
	    	if(instanceUnit.equals(null))
	    		continue;
	    	else
		    	InstanceUnitsInfo += instanceUnit.getId() + "#" + instanceUnit.getDeploymentUnit().getId() + "#" 
		    	                    + instanceUnit.getStartTime() + "#" + instanceUnit.getEndTime() + "#" + instanceUnit.getState();
		    break;
	    }

	    return InstanceUnitsInfo;
	}
	
	/**
	 * ̲ԪصʵʷϢ
	 * ʵʶ~~ʼʱ~ʱ~״̬
	 * @param id Ϊ̲Ԫıʶ
	 */
	public static String getHistoryInstanceUnits(String id){
		
		ArrayList<ProcessInstanceRecord> processInstanceRecordAL = engine.getDatabase().getProcessInstanceRecordsByType(id);
	    String historyInstanceUnitsInfo = "#";
	    for(int i = 0; i < processInstanceRecordAL.size(); i ++)
	    {
	    	ProcessInstanceRecord processInstanceRecord = processInstanceRecordAL.get(i);
	    	historyInstanceUnitsInfo += processInstanceRecord.getId() + "~" + processInstanceRecord.getType() + "~" 
	    	                    + processInstanceRecord.getStartTime() + "~" + processInstanceRecord.getEndTime() + "~" + processInstanceRecord.getState() + "#";
	    }
	    return historyInstanceUnitsInfo;
	}
	
	/**
	 * ʷԼ͵ʵĿ
	 */
	public static String getHistoryInstanceCount(){
		
		ArrayList<ProcessInstanceRecord> processInstanceRecordAL = engine.getDatabase().getAllProcessInstanceRecords();
		ArrayList<TypeInfo> result = new ArrayList<TypeInfo>();
		for(int i = 0; i < processInstanceRecordAL.size(); i ++)
		{
			ProcessInstanceRecord processInstanceRecord = processInstanceRecordAL.get(i);
			String type = processInstanceRecord.getType();
			if(search(result,type)==null)
			{
				result.add(new TypeInfo(type,1));
			}
			else
			{
				TypeInfo typeInfo = search(result,type);
				int count = typeInfo.getCount();
				count ++;
				typeInfo.setCount(count);
			}
		}
		String instanceCount = "#";
		for(int i = 0; i < result.size(); i++)
		{
			TypeInfo typeInfo = result.get(i);
			instanceCount += typeInfo.getType() + "~" + typeInfo.getCount() + "#";
		}
		return instanceCount;
	}
	
	private static TypeInfo search(ArrayList<TypeInfo> al, String type){
		 for(int i = 0; i < al.size(); i++)
		 {
			 if(al.get(i).getType().equals(type))
				 return al.get(i);
		 }
		 return null;
	}
	
	
	/**
	 * ĳ͵ǰ̼Ϣ
	 * 
	 * @param type
	 *            
	 * @return
	 */
	public static String getActiveInstance(String type) {
				
		String t1 = type.replaceAll("/", "#");
		
		InstanceUnit[] wfRuntimeContexts = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().getAll();

		String InstanceList = "#";
        
		for (int i = 0; i < wfRuntimeContexts.length; i++) {
			InstanceUnit wrc = (InstanceUnit) wfRuntimeContexts[i];
			//		add by cainn 2005-10-04txid-instanceid

			if (wrc.getId()!=null) {

				InstanceList = InstanceList + t1.replaceAll("#", "/") +"~";
				
				InstanceList = InstanceList + wrc.getId().replaceAll("#", "/")+ "~";
				
				InstanceList = InstanceList + wrc.getStartTime() + "~";
                
				String state = "INITIATED";				
				int instanceState = wrc.getState();
				if(instanceState == 1)
                       state = "RUNNING";
				else if(instanceState == 2)
					   state = "ACTIVE";
				else if(instanceState == 3)
					   state = "SUSPENDED";
				else if(instanceState == 4)
					   state = "COMPLETED";
				else if(instanceState == 5)
					   state = "TERMINATED";
				
				InstanceList = InstanceList + state + "~";
				
				for (int j = 0; j < wrc.getActivityInstances().size(); j++) {
					ActivityInstance war = (ActivityInstance) (wrc
							.getActivityInstances().get(j));
					String activityName = war.getName();
				    if(activityName == null)
				    	 activityName = war.getType();
				    InstanceList = InstanceList + activityName + "`";
					InstanceList = InstanceList + war.getType() + "`";
					InstanceList = InstanceList + war.getStartTime() + "`";
					if (null == "")
						InstanceList = InstanceList + war.getEndTime() + "`";
					else
						InstanceList = InstanceList + war.getEndTime() + "`";
					
					int stateInt = war.getState();
					String stateStr = "COMPLETED" ;
					if(stateInt==0)
					{
						stateStr = "INACTIVE";
					}else if(stateInt==1)
					{
						stateStr = "ACTIVE";
					}else if(stateInt==2)
					{
						stateStr = "SUSPENDED";
					}else if(stateInt==3)
					{
						stateStr = "COMPLETED";
					}
					
					InstanceList = InstanceList + stateStr + "`";
					//add by cainn 2005-10-04Ϣ
					if (null == "")
						InstanceList = InstanceList + ""
								+ "`";
					else {
						InstanceList = InstanceList + ""
								+ "`";
					}
			    }
		
				InstanceList = InstanceList + "~";
				InstanceList = InstanceList + "#";
			}

		}
		return InstanceList;
	}

	/**
	 * ĳ̵ĻϢ
	 * 
	 * @param instanceID
	 * @return
	 */
	public static String getActivity(String instanceID) {
		String inId = instanceID.replaceAll("/", "#");
		int k = inId.indexOf(":");
		String t1 = inId.substring(0, k);

		InstanceUnit instanceUnit = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().get(instanceID);
		ArrayList<ActivityInstance> al = instanceUnit.getActivityInstances();		
		
		String  activityInfo = "#";
		
		for(int i = 0; i < al.size(); i ++)
		{
			ActivityInstance activityInstance = al.get(i);
			activityInfo += activityInstance.getType() + "~" + activityInstance.getName() + "~" + activityInstance.getStartTime()
			               + "~" + activityInstance.getEndTime() + "~";
			int stateInt = activityInstance.getState();
			String stateStr = "COMPLETED" ;
			if(stateInt==0)
			{
				stateStr = "INACTIVE";
			}else if(stateInt==1)
			{
				stateStr = "ACTIVE";
			}else if(stateInt==2)
			{
				stateStr = "SUSPENDED";
			}else if(stateInt==3)
			{
				stateStr = "COMPLETED";
			}
			activityInfo += stateStr + "#";
		}
		
		return activityInfo;
	
	}

	/**
	 * ĳ̵ʷϢ
	 * 
	 * @param instanceID
	 * @return
	 */
	public static String getHistoryActivity(String instanceID) {

		ArrayList<ActivityInstanceRecord> al= engine.getDatabase().getActivityInstanceRecordsByProcessInstanceId(instanceID);	
		
		String  activityInfo = "#";
		
		for(int i = 0; i < al.size(); i ++)
		{
			ActivityInstanceRecord activityInstanceRecord = al.get(i);
			activityInfo += activityInstanceRecord.getType() + "~" + activityInstanceRecord.getId() + "~" + activityInstanceRecord.getStartTime()
			               + "~" + activityInstanceRecord.getEndTime() + "~" + activityInstanceRecord.getState() + "#";
		}
		
		return activityInfo;
	
	}
	
	/**
	 * ̲Ԫ״̬
	 * ӻ״̬״̬
	 */
	public static String ActivetoSuspend(String type)
	{
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(type);
		int state = deploymentUnit.getState();
		if(state==0)
		{
			deploymentUnit.suspended();
			return "true";
		}
		return "false";
	}	
	
	/**
	 * ̲Ԫ״̬
	 * ӹ״̬״̬
	 */
	public static String SuspendtoActive(String type)
	{
		DeploymentUnit deploymentUnit = engine.getDeploymentUnitRegistry().get(type);
		int state = deploymentUnit.getState();
		if(state==1)
		{
			deploymentUnit.activize();
			return "true";
		}
		return "false";
	}	
		
	/**
	 * е̵״̬
	 * ״̬״̬
	 */
	public static String RunningtoSuspend(String instanceID)
	{
		String inId = instanceID.replaceAll("/", "#");
		int k = inId.indexOf(":");
		String t1 = inId.substring(0, k);

		InstanceUnit instanceUnit = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().get(instanceID);
		int state = instanceUnit.getState();
		if(state==1)
		{
			instanceUnit.suspend();
			return "true";
		}
		return "false";
	}
	
	/**
	 * е̵״̬
	 * ״ֹ̬״̬
	 */
	public static String RunningtoTerminate(String instanceID)
	{
		String inId = instanceID.replaceAll("/", "#");
		int k = inId.indexOf(":");
		String t1 = inId.substring(0, k);

		InstanceUnit instanceUnit = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().get(instanceID);
		int state = instanceUnit.getState();
		if(state==1)
		{
			instanceUnit.terminate();
			return "true";
		}
		return "false";
	}
	
	/**
	 * Թ̵״̬
	 * ӹ״̬״̬
	 */
	public static String SuspendtoRunning(String instanceID)
	{
		String inId = instanceID.replaceAll("/", "#");
		int k = inId.indexOf(":");
		String t1 = inId.substring(0, k);

		InstanceUnit instanceUnit = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().get(instanceID);
		int state = instanceUnit.getState();
		if(state==3)
		{
			instanceUnit.resume();
			return "true";
		}
		return "false";
	}
	
	/**
	 * Թ̵״̬
	 * ӹ״ֹ̬״̬
	 */
	public static String SuspendtoTerminate(String instanceID)
	{
		String inId = instanceID.replaceAll("/", "#");
		int k = inId.indexOf(":");
		String t1 = inId.substring(0, k);

		InstanceUnit instanceUnit = engine.getDeploymentUnitRegistry().get(t1).getInstanceUnitPool().get(instanceID);
		int state = instanceUnit.getState();
		if(state==3)
		{
			instanceUnit.terminate();
			return "true";
		}
		return "false";
	}	
	
	public static String ProcessStatistic(String beginTime, String endTime, String type, String status)
	{

		ArrayList<ProcessInstanceRecord> processInstanceRecordAL = engine.getDatabase().getProcessInstanceRecordsByType(type);
		int state = 0;
		if (status.equals("FinishTime"))
			state = 4;
		ArrayList<ProcessInstanceRecord> statisticAL = new ArrayList<ProcessInstanceRecord>();
		for(int i = 0; i < processInstanceRecordAL.size(); i ++)
		{
			ProcessInstanceRecord processInstanceRecord = processInstanceRecordAL.get(i);
			if(state == 4)
			{
				if(processInstanceRecord.getState()==4 && compareTime(processInstanceRecord.getStartTime(), beginTime)&&compareTime(endTime, processInstanceRecord.getEndTime()))
				{
					statisticAL.add(processInstanceRecord);
				}
			}
			else
			{
				if(processInstanceRecord.getState()!=4 && compareTime(processInstanceRecord.getStartTime(), beginTime)&&compareTime(endTime, processInstanceRecord.getEndTime()))
				{
					statisticAL.add(processInstanceRecord);
				}
			}
		}
	    String processStatisticInfo = "#";
	    for(int i = 0; i < statisticAL.size(); i ++)
	    {
	    	ProcessInstanceRecord processInstanceRecord = statisticAL.get(i);
	    	processStatisticInfo += processInstanceRecord.getId() + "~" + processInstanceRecord.getType() + "~" 
	    	                    + processInstanceRecord.getStartTime() + "~" + processInstanceRecord.getEndTime() + "~" + processInstanceRecord.getState() + "#";
	    }
	    return processStatisticInfo;
		
	}	
	
	public static String TypeStatistic(String beginTime, String endTime, String status)
	{

		ArrayList<ProcessInstanceRecord> processInstanceRecordAL = engine.getDatabase().getAllProcessInstanceRecords();
		int state = 0;
		if (status.equals("FinishTime"))
			state = 4;
			
		ArrayList<ProcessInstanceRecord> statisticAL = new ArrayList<ProcessInstanceRecord>();
		for(int i = 0; i < processInstanceRecordAL.size(); i ++)
		{
			ProcessInstanceRecord processInstanceRecord = processInstanceRecordAL.get(i);
			if(state == 4)
			{
				if(processInstanceRecord.getState()==4 && compareTime(processInstanceRecord.getStartTime(), beginTime)&&compareTime(endTime, processInstanceRecord.getEndTime()))
				{
					statisticAL.add(processInstanceRecord);
				}
			}
			else
			{
				if(processInstanceRecord.getState()!=4 && compareTime(processInstanceRecord.getStartTime(), beginTime)&&compareTime(endTime, processInstanceRecord.getEndTime()))
				{
					statisticAL.add(processInstanceRecord);
				}
			}
		}
	    String processStatisticInfo = "#";
	    for(int i = 0; i < statisticAL.size(); i ++)
	    {
	    	ProcessInstanceRecord processInstanceRecord = statisticAL.get(i);
	    	processStatisticInfo += processInstanceRecord.getId() + "~" + processInstanceRecord.getType() + "~" 
	    	                    + processInstanceRecord.getStartTime() + "~" + processInstanceRecord.getEndTime() + "~" + processInstanceRecord.getState() + "#";
	    }
	    return processStatisticInfo;
		
	}
	
	/**
	 * ʽ
	 * @param s
	 * @return
	 */
	private static String normalize(String s) {
		StringBuffer str = new StringBuffer();
		int len = (s != null) ? s.length() : 0;

		for (int i = 0; i < len; i++) {
			char ch = s.charAt(i);

			switch (ch) {
			case '<': {
				str.append("&lt;");
				break;
			}
			case '>': {
				str.append("&gt;");
				break;
			}
			case '&': {
				str.append("&amp;");
				break;
			}
			case '"': {
				str.append("&quot;");
				break;
			}
			case NL: {
				if (i > 0) {
					char lastChar = str.charAt(str.length() - 1);

					if (lastChar != CR) {
						str.append(LS);
					} else {
						str.append(NL);
					}
				} else {
					str.append(LS);
				}
				break;
			}
			default: {
				str.append(ch);
			}
			}
		}

		return (str.toString());
	} // end of "private static String normalize(String s)"	
	
	//yyyy-MM-dd HH:mm:ss
	private static boolean compareTime(String firstTime, String secondTime){
		
		  for(int i = 0; i < 19; i ++)
		  {
			  if(firstTime.charAt(i) > secondTime.charAt(i))
			  {
				  return true;
			  }
			  else if(firstTime.charAt(i) < secondTime.charAt(i))
			  {
				  return false;
			  }
			  else
				  continue;
		  }
		  return true;		
	}
	
}
