package org.act.xservices.engine.rt.persistence;

import java.util.ArrayList;

import org.act.xservices.engine.rt.ActivityInstance;
import org.act.xservices.engine.rt.InstanceUnit;
import org.act.xservices.engine.rt.adapter.BPELAdapter;
import org.act.xservices.engine.rt.deploy.DeploymentUnit;
import org.act.xservices.engine.rt.deploy.DeploymentUnitRegistry;
import org.act.xservices.engine.rt.management.BPELManageUtil;
import org.act.xservices.engine.rt.utils.TimeUtil;

public class StoreUtil {
	
	public static void storeProcessInstance(InstanceUnit instanceUnit) {
		BPELAdapter bpelProcessor = BPELManageUtil.getBpelProcessor();
		IDatabase database = bpelProcessor.getDatabase();
		DeploymentUnitRegistry registry = bpelProcessor.getDeploymentUnitRegistry();
		DeploymentUnit deploymentUnit = registry.get(instanceUnit.getDeploymentUnit().getId());
		
		if((instanceUnit.getState() != InstanceUnit.STATE_COMPLETED)
				&& (instanceUnit.getState() != InstanceUnit.STATE_SUSPENDED)) {
			instanceUnit.suspend();
		}		
		ProcessInstanceRecord processInstanceRecord = new ProcessInstanceRecord();
		processInstanceRecord.setId(instanceUnit.getId());
		processInstanceRecord.setType(instanceUnit.getDeploymentUnit().getId());
		processInstanceRecord.setState(instanceUnit.getState());
		processInstanceRecord.setStartTime(instanceUnit.getStartTime());
		processInstanceRecord.setEndTime(instanceUnit.getEndTime());
		processInstanceRecord.setActivityInstances(instanceUnit.getActivityInstances().size());
		database.insertProcessInstanceRecord(processInstanceRecord);
		deploymentUnit.getInstanceUnitPool().delete(instanceUnit);
		
		ArrayList<ActivityInstance> instances = instanceUnit.getActivityInstances();
		for(int i=0; i<instances.size(); i++) {
			ActivityInstance instance = instances.get(i);
			if(instance.getState() == ActivityInstance.STATE_ACTIVE) {
				instance.suspend();
				instance.setEndTime(TimeUtil.getNowTime());
			}
			ActivityInstanceRecord activityInstanceRecord = new ActivityInstanceRecord();
			activityInstanceRecord.setProcessInstanceId(instance.getInstanceUnit().getId());
			activityInstanceRecord.setType(instance.getType());
			activityInstanceRecord.setState(instance.getState());
			activityInstanceRecord.setStartTime(instance.getStartTime());
			activityInstanceRecord.setEndTime(instance.getEndTime());
			database.insertActivityInstanceRecord(activityInstanceRecord);
		}
	}
}
