package org.act.xservices.engine.rt.utils;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.List;

import org.act.xservices.engine.rt.InstanceUnit;
import org.act.xservices.engine.rt.VariableContainer;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;

import commonj.sdo.DataObject;
import commonj.sdo.Property;
import commonj.sdo.Type;
import commonj.sdo.helper.DataFactory;
import commonj.sdo.helper.XMLDocument;
import commonj.sdo.helper.XMLHelper;

public class DataUtil {

	public static String XMLNS_XSI = "http://www.w3.org/2001/XMLSchema-instance";

	public static void metaset2data(Metaset paras, DataObject var) {
		Type varType = var.getType();
		int parasSize = paras.elements().size();
		int propsSize = varType.getProperties().size();
		if (parasSize == propsSize) {
			for (int i = 0; i < varType.getProperties().size(); i++) {
				Metaset para = (Metaset) paras.elements().get(i);
				Property prop = (Property) varType.getProperties().get(i);
				Type propType = prop.getType();
				if (propType.isDataType()) {
					String value = para.getText();
					Object data = getSimpleData(propType, value);
					var.set(i, data);
					/*
					 * Class c = propType.getInstanceClass(); if (c !=
					 * String.class) { if (!c.getName().equals("int")) { if
					 * (!c.getName().equals("boolean")) { if
					 * (!c.getName().equals("float")) { try { Method method =
					 * propType .getInstanceClass() .getMethod( "valueOf", new
					 * Class[] { String.class }); Object valueObject =
					 * method.invoke( null, new Object[] { value }); var.set(i,
					 * valueObject); } catch (Exception e) {
					 * e.printStackTrace(); } } else { var.set(i,
					 * Float.valueOf(value)); } } else { var.set(i,
					 * Boolean.valueOf(value)); } } else { var.set(i,
					 * Integer.valueOf(value)); } } else { var.set(i, value); }
					 */
				} else {
					DataObject dataObject = getDataObject(propType, para);
					var.set(i, dataObject);
					/*
					 * for (int j = 0; j < para.attributes().size(); j++) {
					 * Attribute attribute = (Attribute) para.attributes()
					 * .get(j); para.remove(attribute); } MetasetBuilder builder
					 * = MetasetBuilder.getInstance(); Attribute xsi = builder
					 * .newAttribute("xmlns:xsi", XMLNS_XSI); para.add(xsi);
					 * Attribute ns = builder.newAttribute("xmlns: ns",
					 * propType.getURI()); para.add(ns); Attribute type =
					 * MetasetBuilder.getInstance().newAttribute( "xsi:type",
					 * "ns:" + propType.getName()); para.add(type); XMLDocument
					 * xmlDoc = XMLHelper.INSTANCE.load(para.toXML());
					 * DataObject partVar = xmlDoc.getRootObject(); var.set(i,
					 * partVar);
					 */
				}
			}
		} else {
			// 鶨
			Attribute xsi = MetasetBuilder.getInstance().newAttribute(
					"xmlns:xsi", XMLNS_XSI);
			paras.add(xsi);
			Attribute ns = MetasetBuilder.getInstance().newAttribute(
					"xmlns:ns", varType.getURI());
			paras.add(ns);
			Attribute type = MetasetBuilder.getInstance().newAttribute(
					"xsi:type", "ns:" + varType.getName());
			paras.add(type);
			XMLDocument xmlDoc = XMLHelper.INSTANCE.load(paras.toXML());
			DataObject partVar = xmlDoc.getRootObject();
			var.set(0, partVar.get(0));
		}
	}

	private static DataObject getDataObject(Type type, Metaset paras) {
		if (type.isDataType()) {
			try {
				throw new Exception("Type is not DataObject!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		DataObject dataObject = null;
		String uri = type.getURI();
		String name = type.getName();
		dataObject = DataFactory.INSTANCE.create(uri, name);
		metaset2data(paras, dataObject);
		return dataObject;
	}

	private static Object getSimpleData(Type type, String value) {
		Object data = null;
		if (!type.isDataType()) {
			try {
				throw new Exception("Type is not DataType!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		Class c = type.getInstanceClass();
		if (c != String.class) {
			if (!c.getName().equals("int")) {
				if (!c.getName().equals("boolean")) {
					if (!c.getName().equals("float")) {
						try {
							Method method = type.getInstanceClass().getMethod(
									"valueOf", new Class[] { String.class });
							Object valueObject = method.invoke(null,
									new Object[] { value });
							data = valueObject;
						} catch (Exception e) {
							e.printStackTrace();
						}
					} else {
						data = Float.valueOf(value);
					}
				} else {
					data = Boolean.valueOf(value);
				}
			} else {
				data = Integer.valueOf(value);
			}
		} else {
			data = value;
		}
		return data;
	}

	public static void data2metaset(InstanceUnit instanceUnit, String varName,
			Metaset paras) {
		VariableContainer vc = instanceUnit.getVariableContainer();
		DataObject var = (DataObject) vc.getVariable(varName);
		@SuppressWarnings("unchecked")
		List<Property> properties = var.getType().getProperties();
		for (int i = 0; i < properties.size(); i++) {
			Property property = properties.get(i);
			String partName = property.getName();
			if (var.get(i) instanceof DataObject) {
				Metaset value = getMetaset((DataObject) var.get(i), partName);
				paras.add(value);
				/*
				 * XMLDocument doc = XMLHelper.INSTANCE.createDocument(
				 * (DataObject) var.get(i), null, partName);
				 * doc.setEncoding("GB2312");
				 * 
				 * try {
				 * 
				 * ByteArrayOutputStream output = new ByteArrayOutputStream();
				 * 
				 * XMLHelper.INSTANCE.save(doc, output, null);
				 * 
				 * ByteArrayInputStream input = new ByteArrayInputStream(
				 * output.toByteArray());
				 * 
				 * Metaset value = MetasetParserFactory.getBpelMetasetParser()
				 * .parse(input);
				 * 
				 * input.close();
				 * 
				 * output.close();
				 * 
				 * // System.err.println(
				 * "\n--value.toXML()----org.act.xservices.engine.rt.utils.DataUtil---------------\n"
				 * // +value.toXML()+"\n------------------\n"); Metaset val =
				 * value.getFirstElement(); Metaset child =
				 * MetasetBuilder.getInstance().newMetaset( val.getName());
				 * paras.add(child); child.setText(val.getText().toString());
				 * paras.add(value);
				 * 
				 * } catch (MetasetParsingException e) { e.printStackTrace(); }
				 * catch (IOException e) { e.printStackTrace(); }
				 */

			} else if (var.get(i) instanceof List) {
				@SuppressWarnings("unchecked")
				List<DataObject> elements = var.getList(0);
				for (int j = 0; j < elements.size(); j++) {
					DataObject element = elements.get(j);
					XMLDocument doc = XMLHelper.INSTANCE.createDocument(
							element, null, partName);
					doc.setEncoding("GB2312");
					ByteArrayOutputStream output = new ByteArrayOutputStream();
					try {
						XMLHelper.INSTANCE.save(doc, output, null);
					} catch (IOException e) {
						e.printStackTrace();
					}
					ByteArrayInputStream input = new ByteArrayInputStream(
							output.toByteArray());
					Metaset value = null;
					try {
						value = MetasetParserFactory.getBpelMetasetParser()
								.parse(input);
						while (value.attributes().size() != 0) {
							List<Attribute> attributes = value.attributes();
							value.remove(attributes.get(0));
						}
					} catch (MetasetParsingException e) {
						e.printStackTrace();
					}
					paras.add(value);
				}
			} else {
				Metaset part = MetasetBuilder.getInstance()
						.newMetaset(partName);
				paras.add(part);
				part.setText(var.get(i).toString());
			}
		}
	}

	private static Metaset getMetaset(DataObject var, String varName) {
		Metaset value = MetasetBuilder.getInstance().newMetaset(varName);
		List<Property> properties = var.getType().getProperties();
		for (int i = 0; i < properties.size(); i++) {
			Property property = properties.get(i);
			String eName = property.getName();
			Metaset childValue = null;
			if (var.get(i) instanceof DataObject) {
				childValue = getMetaset((DataObject) var.get(i), eName);

			} else {
				childValue = MetasetBuilder.getInstance().newMetaset(eName);
				childValue.setText(var.get(i).toString());
			}
			value.add(childValue);
		}
		return value;
	}
	// public static void data2metaset(Bpel11InstanceUnit instanceUnit, String
	// varName, Metaset paras) {
	// Bpel11DeploymentUnit deploymentUnit = instanceUnit.getDeploymentUnit();
	// VariableContainer vc = instanceUnit.getVariableContainer();
	// DataObject var = (DataObject)vc.getVariable(varName);
	// VariableDef varDef = deploymentUnit.getVariableDef(varName);
	//
	// QName messageType = varDef.getMessageType();
	// String messageTypeURI = messageType.getNamespaceURI();
	// DefinitionsExtended wsdl = deploymentUnit.getWsdl(messageTypeURI);
	// Message message = wsdl.getDefinition().getMessage(messageType);
	//
	// List<Property> properties = var.getType().getProperties();
	// List<String> namespaces = new ArrayList<String>();
	// for(int i=0; i<properties.size(); i++) {
	// Property property = properties.get(i);
	// String partName = property.getName();
	// Metaset part = new Metaset(partName);
	// QName partType = message.getPart(partName).getTypeName();
	// String ptUrl = partType.getNamespaceURI();
	// String ptLocalName = partType.getLocalPart();
	// String prefix = null;
	// //
	// if(ptUrl.equals(ConstantUtil.NS_XSD)) {
	// prefix = "xsd";
	// String partValue = var.get(i).toString();
	// part.setValue(partValue);
	// }
	// //
	// else{
	// int index = namespaces.indexOf(ptUrl);
	// if(index == -1) {
	// namespaces.add(ptUrl);
	// index = namespaces.size() - 1;
	// paras.add(new Attribute("xmlns:ns"+(index+1), ptUrl));
	// }
	// prefix = "ns"+(index+1);
	// getValue(part, (DataObject)var.get(i));
	// }
	// //part.add(new Attribute("xsi:type", prefix+":"+ptLocalName));
	// paras.add(part);
	// }
	// }
	//
	// private static void getValue(Metaset part, DataObject var) {
	// Type varType = var.getType();
	// for (int i = 0; i < varType.getProperties().size(); i++) {
	// Property prop = (Property) varType.getProperties().get(i);
	// String propName = prop.getName();
	// Type propType = prop.getType();
	// if (propType.isDataType()) {
	// Object value = var.get(i);
	// if(value != null) {
	// String valueString = value.toString();
	// if(!(value instanceof Integer && valueString.equals("0.0"))) {
	// Metaset property = new Metaset(propName);
	// part.add(property);
	// property.setValue(valueString);
	// }
	// }
	// }
	// else{
	// if(var.get(i) instanceof DataObject) {
	// Metaset property = new Metaset(propName);
	// part.add(property);
	// getValue(property, (DataObject)var.get(i));
	// }
	// else if(var.get(i) instanceof EList){
	// getValue(part, propName, (EList)var.get(i));
	// }
	// }
	// }
	// }
	//
	// private static void getValue(Metaset part, String propName, EList vars) {
	// for(int i=0; i<vars.size(); i++) {
	// Object var = vars.get(i);
	// Metaset property = new Metaset(propName);
	// part.add(property);
	// if(var instanceof DataObject) {
	// getValue(property, (DataObject)var);
	// }else {
	// String valueString = var.toString();
	// if(!(var instanceof Integer && valueString.equals("0.0"))) {
	// property.setValue(valueString);
	// }
	// }
	// }
	//
	// }

}
