package org.act.xservices.engine.rt.utils;

import commonj.sdo.Type;
import commonj.sdo.helper.TypeHelper;

public class XSDUtil {
	
	public static Type getType(String xsdType) {
		String sdoType = xsd2sdo(xsdType);
		return TypeHelper.INSTANCE.getType("commonj.sdo", sdoType);
	}
	
	private static String xsd2sdo(String xsdType) {
		if(xsdType.equals("boolean")) return "Boolean";
		if(xsdType.equals("byte")) return "Byte";
		if(xsdType.equals("hexBinary")) return "Bytes";
		if(xsdType.equals("string")) return "String";
		if(xsdType.equals("anyType")) return "DataObject";
		if(xsdType.equals("dateTime")) return "DateTime";
		if(xsdType.equals("gDay")) return "Day";
		if(xsdType.equals("decimal")) return "Decimal";
		if(xsdType.equals("double")) return "Double";
		if(xsdType.equals("duration")) return "Duration";
		if(xsdType.equals("float")) return "Float";
		if(xsdType.equals("int")) return "Int";
		if(xsdType.equals("integer")) return "Integer";
		if(xsdType.equals("long")) return "Long";
		if(xsdType.equals("gMonth")) return "Month";
		if(xsdType.equals("gMonthDay")) return "MonthDay";
		if(xsdType.equals("anySimpleType")) return "Object";
		if(xsdType.equals("short")) return "Short";
		if(xsdType.equals("time")) return "Time";
		if(xsdType.equals("gYear")) return "Year";
		if(xsdType.equals("gYearMonth")) return "YearMonth";
		if(xsdType.equals("date")) return "YearMonthDay";
		if(xsdType.equals("anyURI")) return "URI";
		return "Object"; 
	}
}
