package org.act.xservices.rt.xcontainer.adaptation;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.adaptation.adapter.IAdapter;
import org.act.xservices.rt.xcontainer.framework.dispatch.ASafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;


/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-06-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class AdaptationInTask extends ASafeTask{
	
	final Logger logger = LoggerFactory.getLogger(AdaptationInTask.class);
	
	private IServiceContext serviceContext;
	
	private IAdapter wsProcessor;

	private IAdapter bpelProcessor;
	
	
	public AdaptationInTask(){
	}
	
	public void execute() throws Exception {
		
		// **************************
		logger.debug("*********** Received RequestMessage at AdaptationInWorker**************");
		logger.debug("\n{}", serviceContext.getInMessage().toFormatXML());
		// ********************************
		
		if(serviceContext.isWSService()){
			wsProcessor.process(serviceContext);
			
		}else if(serviceContext.isBPELService() || serviceContext.isSpecialSoap()){
			bpelProcessor.process(serviceContext);
		}
		
	}

	public void handleException(Throwable exception) {
		// TODO Auto-generated method stub
		System.out.println("exception in AdaptationInExecutable");
	}

//	public IServiceContext getServiceContext() {
//		return serviceContext;
//	}

	public void setServiceContext(IServiceContext serviceContext) {
		this.serviceContext = serviceContext;
	}
	
	public void setWsProcessor(IAdapter wsProcessor) {
		this.wsProcessor = wsProcessor;
	}

	public void setBpelProcessor(IAdapter bpelProcessor) {
		this.bpelProcessor = bpelProcessor;
	}
}
