package org.act.xservices.rt.xcontainer.adaptation.adapter;

import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.lifecycle.ALifecycle;
import org.act.xservices.rt.xcontainer.framework.objectpool.IDispatchTarget;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;

public abstract class AbstractAdapter extends ALifecycle implements IAdapter{
	
	private String name;

	private String description;
	
	/** Ŀ */
	protected IDispatchTarget<IServiceContext> targetObjectPool;
	
	protected IContainerEnvironment containerEnv;
	
	public void config(IConfigElement configurableElement) throws Exception {
		this.setName(configurableElement.getAttribute("name"));
		this.setDescription(configurableElement.getAttribute("description"));
	}
	
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	public abstract void process(IServiceContext serviceContext);
	

	public void setTargetObjectPool(IDispatchTarget<IServiceContext> targetObjectPool) {
		this.targetObjectPool = targetObjectPool;
	}
	
	public void setContainerEnvironment(IContainerEnvironment containerEnv){
		this.containerEnv = containerEnv;
	}
	
}
