package org.act.xservices.rt.xcontainer.adaptation.adapter;


import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.constants.SOAPConstants;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.lifecycle.LifecycleException;
import org.act.xservices.rt.xcontainer.framework.provider.IProvider;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;

public class WSAdapter extends AbstractAdapter{

	final Logger logger = LoggerFactory.getLogger(WSAdapter.class);
	
	
	public void config(IConfigElement configurableElement) throws Exception {
		super.config(configurableElement);
		
		logger.info("Succeed add Component: "+ getName());
		//... ...
	}
	
	public void start() throws LifecycleException {
		// TODO Auto-generated method stub
		logger.info("XServices WS Container Start");
		
	}

	public void stop() throws LifecycleException {
		// TODO Auto-generated method stub
		logger.info( getName()+ " Stop");
		
	}
	
	public void destroy() {
		// TODO Auto-generated method stub
		
	}

	
	public void process(IServiceContext serviceContext) {

		//TODO SpecialϢκδֱӷ
		if(serviceContext.isSpecialSoap()){
			return ;
		}
		
		//---IProvider
		XcService xcService = serviceContext.getXcService();
		IProvider operationProvider = serviceContext.getXcOperation().getProvider();

		//---ĲûжӦProviderϢ
		if (operationProvider == null) {
			
			ISOAPEnvelope faultMessage = SOAPMessageUtil.creatStdSimpleFaultMessage(
					serviceContext.getInMessage().getVersion(),
					SOAPConstants.FAULT_CODE_RECEIVER,
					"The request Operation "+serviceContext.getXcOperation().getQName()
							+" of serivce " + xcService.getServiceName() + " has no Provider. ");
			
			serviceContext.setOutMessage(faultMessage); // SOAPFaultMessage
			serviceContext.setFaultOutMessage(true);
			try {
				targetObjectPool.put(serviceContext);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			return ;
		}

		//---з
		try {
			IServiceContext serviceContextOut = operationProvider.process(serviceContext);
			if (serviceContextOut != null) { 
				targetObjectPool.put(serviceContextOut);
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		return ;
	}

}
