package org.act.xservices.rt.xcontainer.addressing;

import java.net.URI;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.addressing.faults.SoapFault;
import org.act.xservices.rt.xcontainer.addressing.uitl.WsaConstants;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.util.MetasetHelper;

/**
 * 
 * EndpointReferenceǶWS-Addressing 1.0жEndpointReferenceTypeȫʵ <br>
 * <br>
 * ౻ʵΪһEPRXMLʽİװ,ṩûȡͨJavaͶDOM͵ķ
 * ͬʱҲṩ˿ԸݲͬԴEPRsĹ
 * 
 */
public class EndpointReference {
	//
	// ڲ쳣Ϣ
	//
	private URI _address = null;

	//
	// ָreference parametersϵָ  ָӵһӵʱ
	// ýڵ㱻ӵEPRXML
	//
	private Metaset _parameters = null;

	//
	// XMLʽиԪصQNameĬֵΪwsa:EndpointReferenceͻһ
	// ͬQName
	//
	private QName _rootName = null;

	//
	// EPRXML(Metaset)ʽ
	//
	private Metaset _xml = null;

	/**
	 * 
	 * @see #EndpointReference(Element, boolean)
	 *      һָXMLһµEPRķʹõĹڴУ䴴һ
	 *      ൱ڵEndpointReference(Element, boolean)캯ͬʱѸù캯
	 *      ڶΪ"true"
	 * 
	 */
	public EndpointReference(Metaset root) throws SoapFault {
		this(root, true);
	}
	
	/**
     * 
     * ָXML崴һµEPR
     *
     * @param root
     *        EPRXML
     * 
     * @param makeDeepCopyOfXML
     *        ϣ࿽ָXMLƬΣͻһݶݿôͰ
     *        makeDeepCopyOfXMLΪTrue. ָXMLĿͻᱣ
     *        ĸԪQName.
     * 
     * @throws SoapFault
     *         <ul>
     *         <li>WS-A EPRͶ壬XMLƬЧ</li>
     *         </ul>
     *
     */
    public EndpointReference(Metaset root, boolean makeDeepCopyOfXML)
        throws SoapFault
    {
        if (root == null)
            throw new NullPointerException("The SOAP Header element is null.");
        
        //
        // option #1 - XMLĿ
        //
        if (makeDeepCopyOfXML)
            _xml = root.createCopy();
        
        //
        // option #2 - ʹѴڵXMLƬ
        //
        else
            _xml = root;
         
        initializeFromXML();
    }
    
    /**
     * 
     * һܷĹ캯൱ڵEndpointReference(EndpointReference, QName)
     * 캯ʹñ׼wsa:EndpointReference QName.
     * 
     * @see #EndpointReference(EndpointReference, QName)
     * @see WsaConstants#EPR_QNAME
     *
     */
    public EndpointReference(EndpointReference copy)
    {
        this(copy, WsaConstants.EPR_QNAME);
    }
    
    /**
     * 
     * EPRsĿ캯 - ָEPRлΪXMLʱָQNameԪ
     * (ǱEPRĸQName)
     *
     * @param copy
     *        ڿEPR ()
     * 
     * @param typeName
     *        The QName of the root element when this EPR is serialized to XML.
     *        EPRлΪXMLʱ,typeNameǸԪصQName
     *
     */
    public EndpointReference(EndpointReference copy, QName typeName) 
    {
        if (copy == null)
            throw new NullPointerException("The SOAP Header element is null.");
        
        if (typeName == null)
            throw new NullPointerException("The QName for the EndpointReference type is null.");
        
        MetasetBuilder metBuilder = MetasetBuilder.getInstance();
        //
        // create the root element - we can't just importNode because the 
        // QName might be different
        //
        _xml = metBuilder.createElement(typeName);
        
        //
        // now copy all child elements...
        //
        // NodeList children = copy.toXML().getChildNodes();
        List<Metaset> children = copy.toMetaset().elements();
        int length = children.size();
        
        for (int n = 0; n < length; ++n)
        {
            Metaset nextMet = children.get(n).createCopy();
            _xml.add(nextMet);
        }
        
        try
        {
            initializeFromXML();
        }
        
        catch (SoapFault error)
        {
            throw new RuntimeException("The EndpointReference being copied is invalid. The XML serialization (or deserialization) is broken - it should not be possible to create an invalid EPR.");
        }
    }
    
    /**
     * 
     * һݹ캯,൱ڵEndpointReference(URI, QName)캯,
     * ͬʱʹñ׼wsa:EndpointReference QName.
     *
     * @see #EndpointReference(URI, QName)
     * @see WsaConstants#EPR_QNAME
     *
     */
    public EndpointReference(URI address)
    {
        this(address, WsaConstants.EPR_QNAME);
    }
    
    /**
     * 
     * ʹָwsa:Address URIһµEPR; EPRлΪXMLʱ, ĸԪ
     * ӵָQName. µEPRûreference parametersproperties elements.
     *
     * @param address
     *        EPRwsa:Address
     * 
     * @param typeName
     *        EPRлΪXMLʱ,ԪصQName
     *
     */
    public EndpointReference(URI address, QName typeName)
    {
        if (address == null)
            throw new NullPointerException("The wsa:To URI is null.");

        if (typeName == null)
            throw new NullPointerException("The QName for the EndpointReference type is null.");
        
        _address = address;
        
        MetasetBuilder metBuilder = MetasetBuilder.getInstance();
        
        _xml = metBuilder.createElement(typeName);
        
        //
        // wsa:Address
        //
        Metaset addressMet = metBuilder.createElement(WsaConstants.ADDRESS_QNAME);
        addressMet.setText(address.toString());
        _xml.add(addressMet);
        
        //
        // create blank parameters
        //
        _parameters = metBuilder.createElement(WsaConstants.PARAMETERS_QNAME);
    }
    
    /**
     * 
     * ָԪصreference parameters. ö󽫴Ԫصһ
     *
     * @param parameter
     *
     */
    public void addParameter(Metaset parameter)
    {
        if (parameter == null)
            throw new NullPointerException("The reference parameter is null.");
        
        //
        // ReferenceParameters֮ǰǿյģҪ׷ӵEPR XML
        // ΪҪһԪص_parametersУԲŻѿյ_parametersӽȥ
        //
        if (_parameters.elements().size() == 0)
            _xml.add(_parameters);
        
        //
        // parameter elementReferenceParameters
        //
        _parameters.add(parameter.createCopy());
    }
    
    /**
     * 
     * һڵddParameter(QName, Object)ıݷʹÿյparameterֵ.
     * 
     * @see #addParameter(QName, Object)
     *
     */
    public void addParameter(QName qname)
    {
        addParameter(qname, null);
    }
    
    /**
     * 
     * ʹָnamevalueһµreference parameter
     *
     * @param qname
     *        reference parameterXMLԪص
     * 
     * @param value
     *        The parameter value (can be null).
     *
     */
    public void addParameter(QName qname, Object value)
    {
        if (qname == null)
            throw new NullPointerException("The reference parameter QName is null.");
        
        //
        // translate to XML, add it to the internal tree
        //
//        Element parameter = XmlUtils.createElement(qname, value);
        Metaset parameter = MetasetBuilder.getInstance().createElement(qname);
        if(value instanceof String){
        	parameter.setText(value.toString());
        }else{
        	parameter.add(((Metaset)value).createCopy());
        }
        
        addParameter(parameter);
    }
    
    /**
     * 
     * @return True, if:
     *         <ul>
     *         <li>Ϊ</li>
     *         <li> wsa:Address ֵƥ</li>
     *         <li>The wsa:PortType values match (if present).</li>
     *         <li>wsa:PortType ƥ(ڵĻ).</li>
     *         <li>wsa:ServiceName and PortNameֵƥ ().</li>
     *         </ul>
     *         ڴEPRsXMLлУȲԲȽʹõĸԪصQNames.
     *         ҲȽκreference parameters or properties.
     *
     */
    public boolean equals(Object obj)
    {
        if (obj == null)
            return false;

        EndpointReference that = (EndpointReference)obj;
        
        //
        // Ƚwsa:Address - host. ǱȽEPRsǷͬ
        // IPַͻ/localhost
        //
        String thisPath = getAddress().getPath();
        String thatPath = that.getAddress().getPath();
        
        if (!thisPath.equals(thatPath))
            return false;
        
        //
        // ûϣȲеĲԲ
        //

        Metaset[] values1 = getParameters();
        Metaset[] values2 = that.getParameters();
        
        if (values1.length != values2.length)
            return false;
        
        for (int n = 0; n < values1.length; ++n)
            if (!MetasetHelper.getInstance().isEqual(values1[n], values2[n]))
                return false;
        
        //
        // ǿԵ˵еֵ
        //
        return true;
    }
    
    /**
     * 
     * @return The wsa:Address value.
     *
     */
    public URI getAddress()
    {
        return _address;
    }
    
    /**
     *
     * @return The current number of elements in the wsa:ReferenceParameters 
     *         section.
     * @return  wsa:ReferenceParameters еĵǰԪصĸ
     *
     */
    public int getNumberOfParameters()
    {
        return _parameters.elements().size();
    }
    
    /**
     *
     * @param qname
     *        Ҫҵ reference parameter 
     * 
     * @return ָƥĵһʵ, ʵΪֵ
     *
     */
    public Metaset getParameter(QName qname)
    {
        return getParameter(qname, 0);
    }
    
    /**
     * 
     * @param qname
     *        Ҫҵ reference parameter 
     * 
     * @return ָƥĵnʵ, ʵΪnull
     * 
     */
    public Metaset getParameter(QName qname, int index)
    {
    	List<Metaset> children = _parameters.elements(qname);
    	if(index >= children.size()){
    		return null;
    	}
    	return _parameters.elements(qname).get(index);
    }
    
    /**
     *
     * @return еreference parameter ʵ(֤ǰԪصԭ˳). 
     * 		         ûreference parameter,Ϊempty.	
     *
     */
    public Metaset[] getParameters()
    {
    	Metaset[] a = new Metaset[0];
        return _parameters.elements().toArray(a);
    }
    
    /**
    *
    * @return ӵиƵreference parameterʵ. ûиƵʵ,
    * 		      Ϊempty.
    *
    */
    public Metaset[] getParameters(QName qname)
    {
    	Metaset[] a = new Metaset[0];
        return _parameters.elements(qname).toArray(a);
    }
    
    /**
     * 
     * @param qname
     *        Ҫҵreference parameter
     * 
     * @return parameterһʵıֵ,û򷵻ֵΪnull
     *
     */
    public String getParameterString(QName qname)
    {
        return getParameterString(qname, 0);
    }
    
    /**
     * 
     * @param qname
     *        Ҫҵreference parameter
     * 
     * @return parameternʵıֵ,û򷵻ֵΪnull
     *
     */
    public String getParameterString(QName qname, int index)
    {
        Metaset xml = getParameter(qname, index);
        
        if (xml == null)
            return null;
        
        return xml.getTextTrim();
    }
    
    /**
     *
     * @return ڴEPRXMLл,ڸԪصQName,Ĭֵwsa:EndpointReference.
     * 		         ⲢǱ
     *
     */
    public QName getRootTypeName()
    {
        return _rootName;
    }
    
    /**
     * 
     * ÷Ѿʵд,ڴ(account for)equals(Object) дequals(Object)
     * ʱдhashCode(),ô洢صݽṹʱΪ
     *
     */
    public int hashCode()
    {
        String address = getAddress().getPath();
        
        Metaset[] parameters = getParameters();
        int paramHashCode = 0;
        
        for (int n = 0; n < parameters.length; ++n)
            paramHashCode += getHashCode(parameters[n]);
                
        return address.hashCode() + paramHashCode;
    }
    
    /**
     * 
     * @param xml
     * 
     * @return Calculates a hash code for the DOM Element based on its 
     *         text value and the hash codes of any child elements (the 
     *         function recurses through the sub-tree). DOM does not 
     *         specify a standard hashCode() for DOM Nodes, so this 
     *         method gives us some standard behavior to rely on.
     *
     */
    private int getHashCode(Metaset xml)
    {
        String text = xml.getTextTrim();
        int hashCode = text == null ? 0 : text.hashCode();
        
        List<Metaset> children = xml.elements();
        
        for (int n = 0; n < children.size(); ++n)
            hashCode += getHashCode(children.get(n));
        
        return hashCode;
    }

    
    /**
     * 
     * EPRڲXMLʽ,ڻread-onlyֵöfrequently-usedݽṹ
     *
     * @throws SoapFault
     *         <ul>
     *         <li>WS-A EPR schema,XMLЧ</li>
     *         </ul>
     *
     */
    private void initializeFromXML()
        throws SoapFault
    {
        //
        // EPR͵QName ()
        //
        _rootName = _xml.getQName();
        String uri = _xml.elementText(WsaConstants.ADDRESS_QNAME.getName());
        
        try
        {
            _address = new URI(uri);
        }
            
        catch (Exception error)
        {
            Object[] filler = { uri };
            String message = "Invalid wsa:Address URI: " +filler.toString();
            throw new SoapFault(message, error);
        }
        
        //
        // save references to the parameters sub-tree
        // 浽parameters sub-tree
        //        
        _parameters = _xml.element(WsaConstants.PARAMETERS_QNAME);
        
        if (_parameters == null){
        	_parameters = MetasetBuilder.getInstance().createElement(WsaConstants.PARAMETERS_QNAME);
        }
    }
    
    /**
     * 
     * һݷ,ɾӵָƵreference parameterĵһʵ. 
     * ൱ڵremoveParameter(QName, 0).
     *
     * @see #removeParameter(QName, int)
     *
     */
    public void removeParameter(QName qname)
    {
        removeParameter(qname, 0);
    }
    
    /**
     * 
     * ɾӵָƵparameterĵnʵ. parameterreference parameters
     * һ, wsa:ReferenceParameters ֽٱлEPR's XML.
     *
     * @param qname
     *        Ҫɾparameterʵ
     * 
     * @param index
     *        Ҫɾparameterʵ
     *
     */
    public void removeParameter(QName qname, int index)
    {
    	Metaset match = _parameters.elements(qname).get(index);
        
        if (match == null)
        {
            Object[] filler = { qname };
            String message = "The reference parameter does not exist: " + filler.toString();
            throw new IllegalArgumentException(message);
        }
        
        _parameters.remove(match);
        
        //
        // wsa:ReferenceParametersemptyEPR XMLнҪ
        //
        if (_parameters.elements().size() == 0)
            _xml.remove(_parameters);
    }
    
    /**
     * 
     * ɾӵָƵparameterʵ. Щparametersreference parameters
     * е, wsa:ReferenceParametersֽٱлEPR's XML.
     *
     * @param qname
     *        The name of the parameter(s) to delete.
     *
     */
    public void removeParameters(QName qname)
    {
    	List<Metaset> matches = _parameters.elements(qname);
        
        if (matches.size() == 0)
        {
            Object[] filler = { qname };
            String message = "No reference parameter does not exist: " + filler.toString();
            throw new IllegalArgumentException(message);
        }
        
        for (int n = 0; n < matches.size(); ++n)
            _parameters.remove(matches.get(n));
        
        //
        // wsa:wsa:ReferenceParametersǿֵ,EPR XMLнҪ
        //
        if (_parameters.elements().size() == 0)
            _xml.remove(_parameters);
    }
    
    /**
     * 
     * @param address
     *        EPR wsa:Address, Ϊ
     *
     */
    public void setAddress(URI address)
    {
        if (address == null)
            throw new NullPointerException("The wsa:To URI is null.");
        
        _address = address;
//        XmlUtils.setElement(_xml, WsaConstants.ADDRESS_QNAME, _address);
        Metaset addressMet = _xml.element(WsaConstants.ADDRESS_QNAME);
        if(addressMet == null){
        	addressMet = MetasetBuilder.getInstance().createElement(WsaConstants.ADDRESS_QNAME);
        	_xml.add(addressMet);
        }
        
        addressMet.setText(address.toString());
    }
    
    
    
    /**
     * 
     * @return EPRXMLʽַ
     *
     */
    public String toString()
    {
        return _xml.asXML();
    }
    
    /**
    *
    * @return EPRXMLʽ. EPRʵϵĵײݽṹ,κ޸ĶӦñǵ
    * 		        (һĻ).
    * 
    * @see #toXML(Document)
    *
    */
   public Metaset toMetaset()
   {
       return _xml;
   }
}
