/* 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

package org.act.xservices.rt.xcontainer.addressing;

import org.act.xservices.rt.xom.QName;


/**
 *
 * SoapConstants is a collection of values related to SOAP 1.2.
 *
 * @author Dan Jemiolo (danj)
 *
 */

public class SoapConstants
{
    /**
     * 
     * The SOAP 1.2 namespace URI.
     * 
     */
    public static final String NAMESPACE_URI = "http://www.w3.org/2003/05/soap-envelope";
    
    public static final String PREFIX = "soap";
    
    public static final String ACTOR = "actor";
    
    public static final String MUST_UNDERSTAND = "mustUnderstand";
    
    public static final String CONTENT_TYPE_HEADER = "application/soap+xml";
    
    public static final QName ENVELOPE_QNAME = 
        new QName(NAMESPACE_URI, "Envelope", PREFIX);
    
    public static final QName HEADER_QNAME = 
        new QName(NAMESPACE_URI, "Header", PREFIX);
    
    public static final QName BODY_QNAME = 
        new QName(NAMESPACE_URI, "Body", PREFIX);

    public static final QName FAULT_QNAME = 
        new QName(NAMESPACE_URI, "Fault", PREFIX);

    public static final QName CODE_QNAME = 
        new QName(NAMESPACE_URI, "Code", PREFIX);

    public static final QName SUBCODE_QNAME = 
        new QName(NAMESPACE_URI, "Subcode", PREFIX);

    public static final QName VALUE_QNAME = 
        new QName(NAMESPACE_URI, "Value", PREFIX);

    public static final QName REASON_QNAME = 
        new QName(NAMESPACE_URI, "Reason", PREFIX);

    public static final QName TEXT_QNAME = 
        new QName(NAMESPACE_URI, "Text", PREFIX);

    public static final QName NODE_QNAME = 
        new QName(NAMESPACE_URI, "Node", PREFIX);

    public static final QName ROLE_QNAME = 
        new QName(NAMESPACE_URI, "Role", PREFIX);

    public static final QName DETAIL_QNAME = 
        new QName(NAMESPACE_URI, "Detail", PREFIX);

    public static final QName SENDER_QNAME = 
        new QName(NAMESPACE_URI, "Sender", PREFIX);

    public static final QName RECEIVER_QNAME = 
        new QName(NAMESPACE_URI, "Receiver", PREFIX);
}
