package org.act.xservices.rt.xcontainer.addressing.impl;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xcontainer.addressing.WSAddressingConstants;
import org.act.xservices.rt.xom.Metaset;

/**
 * 
 * @version 1.0 2008-3-7
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
@Deprecated
public class EndpointReference implements IEndpointReference {

	private String address;

	private Metaset referenceParameters;

	private Metaset metadata;
	
	
	
	
	
    public EndpointReference(Metaset endpointReference) {
        this.toEndpointReference(endpointReference);
    }
	
    public EndpointReference(String address) {
        this.address = address;
    }
    
    public EndpointReference() {
    }
    

    private void toEndpointReference(Metaset endpointReference) {

    	Metaset addr = endpointReference.filter(".\\Address");
		if (addr != null) {
			this.setAddress(addr.car().getText());
		}

		Metaset rfp = endpointReference.filter(".\\ReferenceParameters");
		if (rfp != null) {
			this.setReferenceParameters(rfp.car());
		}

		Metaset med = endpointReference.filter(".\\Metadata");
		if (med != null) {
			this.setMetadata(med.car());
		}

	}

	public String getAddress() {
		return address;
	}

	public Metaset getMetadata() {
		return this.metadata;
	}

	public Metaset getReferenceParameters() {
		return this.referenceParameters;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public void setMetadata(Metaset metadata) {
		this.metadata = metadata;
	}

	public void setReferenceParameters(Metaset referenceParameters) {
		this.referenceParameters = referenceParameters;
	}
	
	
    /** 
     * һ¹Metaset
     * @return
     * @see org.act.xservices.rt.xcontainer.addressing.IEndpointReference#toMetaset()
     */
    public Metaset toMetaset() {
    	MetasetBuilder metBuilder = MetasetBuilder.getInstance();
    	
    	Metaset epr = metBuilder.newMetaset(WSAddressingConstants.PREFIX_WSA_NamespaceURI,
        		WSAddressingConstants.LOCALPART_ENDPOINTREFERENCE,
        		WSAddressingConstants.PREFIX_WSA);
        
        if (this.getAddress() != null) {
        	Metaset metaset = metBuilder.newMetaset(
        			WSAddressingConstants.PREFIX_WSA_NamespaceURI,
        			"Address",WSAddressingConstants.PREFIX_WSA);
            metaset.setText(this.getAddress());
            epr.add(metaset);
        }
        
        if (this.getReferenceParameters() != null
                && this.getReferenceParameters().elements().size() != 0) {
            epr.add(this.getReferenceParameters());
        }
        
        if (this.getMetadata() != null
                && this.getMetadata().elements().size() != 0) {
            epr.add(this.getMetadata());
        }
        return epr;
    }
    
    
    
    //add by cover_eye(2007-8-1)ΪhashMapвkeyʱʹá
	//add by lizq 2008-03-10 ˴Ƚ address ⣬дǣ
	/** 
	 * 
	 * @param obj
	 * @return
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		EndpointReference temp = (EndpointReference) obj;

		return (temp.getAddress()).equals(this.getAddress());
	}

	public int hashCode() {
		return this.getAddress().hashCode();

	}
}
