package org.act.xservices.rt.xcontainer.addressing.impl;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xcontainer.addressing.IMessageAddressingProperties;
import org.act.xservices.rt.xcontainer.addressing.WSAddressingConstants;
import org.act.xservices.rt.xom.Metaset;

/**
 * ּ֧ʹ
 * @version 1.0 2008-3-7
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
@Deprecated
public class MessageAddressingProperties implements
		IMessageAddressingProperties {
	
	
	private String to = null;
	
	private IEndpointReference from;
	
	private IEndpointReference replyTo;
	
	private IEndpointReference faultTo;
	
	private String Action;
	
    private String messageID;

    private Metaset relatesTo;
    
    private Metaset referenceParameters;

    
    
    public MessageAddressingProperties(){
    	
    }
    
    
    /**
	 * ĲӦsoapheader塣Ҳheaderֶ
	 * 
	 * @param soapheader
	 */
	public MessageAddressingProperties(Metaset soapheader) {
		this.buildMAPFromSOAPHeader(soapheader);
	}
    
    
    
    private void buildMAPFromSOAPHeader(Metaset soapheader) {
        
    	Metaset to = soapheader.filter(".\\To");
		if (to != null) {
			this.setTo(to.car().getText());
		}

		Metaset from = soapheader.filter(".\\From");
		if (from != null) {
			this.setFrom(new EndpointReference(from.car()));
		}

		Metaset rlyt = soapheader.filter(".\\ReplyTo");
		if (rlyt != null) {
			this.setReplyTo(new EndpointReference(rlyt.car()));
		}

		Metaset faultTo = soapheader.filter(".\\FaultTo");
		if (faultTo != null) {
			this.setFaultTo(new EndpointReference(faultTo.car()));
		}

		Metaset act = soapheader.filter(".\\Action");
		if (act != null) {
			this.setAction(act.car().getText());
		}

		Metaset mid = soapheader.filter(".\\MessageID");
		if (mid != null) {
			this.setMessageID(mid.car().getText());
		}

		Metaset relatesTo = soapheader.filter(".\\RelatesTo");
		if (relatesTo != null) {
			this.setRelatesTo(relatesTo.car());
		}

		Metaset rfp = soapheader.filter(".\\ReferenceParameters");
		if (rfp != null) {
			this.setReferenceParameters(rfp.car());
		}
       
    }

    
    public Metaset toMetaset() {
    	
    	MetasetBuilder metBuilder = MetasetBuilder.getInstance();
    	
    	Metaset map = metBuilder.newMetaset("MessageAddressingProperties");

		if (this.getTo() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "To","wsa");
			metaset.setText(this.getTo());
			map.add(metaset);
		}

		if (this.getFrom() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "From","wsa");
			for (Metaset temp : from.toMetaset().elements()) {
				metaset.add(temp);
			}
			map.add(metaset);
		}

		if (this.getReplyTo() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "ReplyTo","wsa");
			for (Metaset temp : replyTo.toMetaset().elements()) {
				metaset.add(temp);
			}
			map.add(metaset);
		}

		if (this.getFaultTo() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "FaultTo","wsa");
			for (Metaset temp : faultTo.toMetaset().elements()) {
				metaset.add(temp);
			}
			map.add(metaset);
		}

		if (this.getAction() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "Action","wsa");
			metaset.setText(this.getAction());
			map.add(metaset);
		}

		if (this.getMessageID() != null) {
			Metaset metaset = metBuilder.newMetaset(
					WSAddressingConstants.PREFIX_WSA_NamespaceURI, "MessageID","wsa");
			metaset.setText(this.getMessageID());
			map.add(metaset);
		}

		if (this.getRelatesTo() != null) {
			map.add(relatesTo);
		}

		if (this.getReferenceParameters() != null) {
			map.add(referenceParameters);
		}

		return map;

	}

    
	public String toString() {
		return "[MessageAddressingProperties:]\r" + "\rTo:" + this.getTo()
				+ "\rFrom:" + this.getFrom().toString() + "\rReplyTo:"
				+ this.getReplyTo().toString() + "\rFaultTo:"
				+ this.getFaultTo().toString() + "\rAction:" + this.getAction()
				+ "\rMessageID:" + this.getMessageID() + "\rRelatesTo:"
				+ this.getRelatesTo() + "\rReferenceParameters:"
				+ this.getReferenceParameters();
	}
    
    
	public String getAction() {
		return Action;
	}

	public void setAction(String action) {
		Action = action;
	}

	public IEndpointReference getFaultTo() {
		return faultTo;
	}

	public void setFaultTo(IEndpointReference faultTo) {
		this.faultTo = faultTo;
	}

	public IEndpointReference getFrom() {
		return from;
	}

	public void setFrom(IEndpointReference from) {
		this.from = from;
	}

	public String getMessageID() {
		return messageID;
	}

	public void setMessageID(String messageID) {
		this.messageID = messageID;
	}

	public Metaset getReferenceParameters() {
		return referenceParameters;
	}

	public void setReferenceParameters(Metaset referenceParameters) {
		this.referenceParameters = referenceParameters;
	}

	public Metaset getRelatesTo() {
		return relatesTo;
	}

	public void setRelatesTo(Metaset relatesTo) {
		this.relatesTo = relatesTo;
	}

	public IEndpointReference getReplyTo() {
		return replyTo;
	}

	public void setReplyTo(IEndpointReference replyTo) {
		this.replyTo = replyTo;
	}

	public String getTo() {
		return to;
	}

	public void setTo(String to) {
		this.to = to;
	}
	
	
	
}
