/* 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

package org.act.xservices.rt.xcontainer.addressing.uitl;

import java.util.StringTokenizer;

/**
 *
 * StringUtils provides java.lang.String-related methods that are part of 
 * the J2SE API but not its J2ME equivalent.
 *
 * @author Dan Jemiolo (danj)
 *
 */

public class StringUtils
{
    public static String replaceFirst(String s, String pattern, String replacement)
    {
        int patternStart = s.indexOf(pattern);
        
        if (patternStart < 0)
            return s;
        
        String start = s.substring(0, patternStart);
        String end = s.substring(patternStart + pattern.length());
        return start + replacement + end;
    }
    
    public static String[] split(String s)
    {
        return split(s, " ");
    }
    
    public static String[] split(String s, String separator)
    {
        StringTokenizer parser = new StringTokenizer(s, separator);
        int numberOfTokens = parser.countTokens();
        String[] results = new String[numberOfTokens];
        
        for (int n = 0; n < numberOfTokens; ++n)
            results[n] = parser.nextToken();
        
        return results;
    }
}
