package org.act.xservices.rt.rpc.client;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.act.xservices.rt.client.XServicesException;
import org.act.xservices.rt.client.entry.Entry;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xom.QName;


public class JavaBeanMapClient {
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws SerializationException,
			XServicesException, DeserializationException {
		RPCServiceClient client = new RPCServiceClient(
				"http://localhost:8091/SimpleHashMap");

		Map<Entry, Entry> map = new HashMap<Entry, Entry>();
		ArrayList<String> values = new ArrayList<String>();
		values.add("hello");
		values.add("world");

		Entry entry1 = new Entry();
		entry1.setCity("city1");
		entry1.setName("name1");
		entry1.setPostalCode("postalCode1");
		entry1.setState("state1");
		entry1.setStreet("street1");
		entry1.setValues(values);

		Entry entry2 = new Entry();
		entry2.setCity("city2");
		entry2.setName("name2");
		entry2.setPostalCode("postalCode2");
		entry2.setState("state2");
		entry2.setStreet("street2");
		entry2.setValues(values);
		map.put(entry1, entry2);

		QName op = new QName("http://map.pojo.rt.xservices.act.org", "chech",
				"ns");
		Object[] paramters = new Object[] { map };
		Class<?>[] returnTypes = new Class<?>[] { Map.class };
		Object[] results = client.invokeBlocking(op, paramters, returnTypes);
		Map<Entry, Entry> result = (Map<Entry, Entry>) results[0];
		for (Entry key : result.keySet()) {
			System.out.println("Key:" + key + " value:" + result.get(key));
		}

	}
}
