package org.act.xservices.rt.rpc.client;

import java.util.ArrayList;

import org.act.xservices.rt.client.entry.Entry;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xcontainer.util.JavaObjectDeserializeUtil;
import org.act.xservices.rt.xcontainer.util.JavaObjectSerializeUtil;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

public class JavaSerializeAndDeserialize {
	public static void main(String[] args) throws SerializationException,
			DeserializationException {
		// QName of the target method
		QName opAdd = new QName("http://collection.pojo.rt.xservices.act.org",
				"add", "ns");
		ArrayList<Entry> array = new ArrayList<Entry>();
		ArrayList<String> values = new ArrayList<String>();
		values.add("hello");
		values.add("world");

		Entry entry1 = new Entry();
		entry1.setCity("city1");
		entry1.setName("name1");
		entry1.setPostalCode("postalCode1");
		entry1.setState("state1");
		entry1.setStreet("street1");
		entry1.setValues(values);

		Entry entry2 = new Entry();
		entry2.setCity("city2");
		entry2.setName("name2");
		entry2.setPostalCode("postalCode2");
		entry2.setState("state2");
		entry2.setStreet("street2");
		entry2.setValues(values);

		array.add(entry1);
		array.add(entry2);
		// parameters

		byte[] bytes = new byte[] { '1', '2' };
		int[] ints = new int[] { 1, 2, 3, 4 };
		String[] argNames = new String[] {};
		// partName = new QName("sadfas", "p", "t");
		Object[] parameters = new Object[] { entry1, ints, "hello", bytes, 2,
				true };
		Metaset request = JavaObjectSerializeUtil.serializeJavaObject(opAdd,
				parameters, argNames, false);

		System.out.println(request.toFormatXML());

		Class<?>[] javaTypes = new Class<?>[] { Entry.class, int[].class,
				String.class, byte[].class, int.class, boolean.class };
		Object[] result = JavaObjectDeserializeUtil.deserializeJavaObject(
				request, javaTypes);

		Entry list = (Entry) result[0];

		System.out.println(list.getCity());
		System.out.println(list.getName());
		System.out.println(list.getPostalCode());
		System.out.println(list.getState());
		System.out.println(list.getStreet());

		for (String value : list.getValues()) {
			System.out.println(value);
		}
		// for (int i = 0; i < list.size(); i++) {
		//
		// }
		int[] intss = (int[]) result[1];
		for (int i : intss) {
			System.out.print(" " + i);
		}
		System.out.println("");
		String hello = (String) result[2];
		System.out.println(hello);
		byte[] bytess = (byte[]) result[3];
		for (byte b : bytess) {
			System.out.println(b);
		}
		int in = (Integer) result[4];
		System.out.println(in);
		boolean value = (Boolean) result[5];
		System.out.println(value);
	}
}
