package org.act.xservices.rt.rpc.client;

import org.act.xservices.rt.client.XServicesException;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;


public class POJOXOMClient {
	public static void main(String[] args) throws XServicesException, SerializationException, DeserializationException {
		RPCServiceClient serviceClient = new RPCServiceClient("http://localhost:8091/POJOXOM");
		
		MetasetBuilder factory = MetasetBuilder.getInstance();

		Metaset name = factory.newMetaset(new QName("www.baidu.com",
				"Book", "B"));
		Metaset book = factory.newMetaset(new QName("www.google.cn",
				"Name", "N"));
		Metaset autor = factory.newMetaset(new QName("www.csdn.net",
				"Autor", "A"));
		Metaset isbn = factory.newMetaset(new QName("www.qq.com",
				"ISBN", "I"));
		book.add(name);
		book.add(autor);
		book.add(isbn);
		// parameters
		Object[] opArgs = new Object[] { book };

		// QName of the target method
		QName opboolean = new QName("http://xom.pojo.rt.xservices.act.org",
				"add");

		// return type
		Class<?>[] returnTypes = new Class<?>[] { Metaset.class };

		// invoke web service
		 Object[] response = serviceClient.invokeBlocking(opboolean, opArgs,
		 returnTypes);

		// add
		 Metaset result = (Metaset) response[0]; 
		System.out.println(result.toFormatXML());

	}
}
