package org.act.xservices.rt.rpc.client;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.client.entry.Entry;
import org.act.xservices.rt.xom.QName;

import sun.reflect.generics.reflectiveObjects.ParameterizedTypeImpl;

public class SimpleCollectionListClient {
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws Exception {
		RPCServiceClient serviceClient = new RPCServiceClient(
				"http://192.168.2.250:8091/CollectionListSimpleType");

		ArrayList<Integer> array = new ArrayList<Integer>();
		array.add(new Integer(1));
		array.add(new Integer(2));
		array.add(new Integer(3));
		array.add(new Integer(4));

		// parameters
		Object[] opArgs = new Object[] { "d" };

		// QName of the target method
		QName opAdd = new QName("http://collection.pojo.rt.xservices.act.org",
				"add");

		Type[] types = new Type[] { Entry.class };
		Type type = ParameterizedTypeImpl.make(ArrayList.class, types,
				List.class);

		// return type
		Type[] returnTypes = new Type[] { type };

		// invoke web service
		Object[] response = serviceClient.invokeBlocking(opAdd, opArgs,
				returnTypes);
		// OMElement result=serviceClient.invokeBlocking(opAdd, opArgs);
		// System.out.println(result.toString());
		// add
		List<Entry> result = (ArrayList<Entry>) response[0];
		for (int i = 0; i < result.size(); i++) {
			Entry entry = result.get(i);
			System.out.println("result[" + i + "] = ");
			System.out.println(entry.getCity());
			System.out.println(entry.getName());
			System.out.println(entry.getPostalCode());
			System.out.println(entry.getState());
			System.out.println(entry.getStreet());

			for (String value : entry.getValues()) {
				System.out.println(value);
			}
		}

	}

	public int add(int a, int b) throws Exception {
		RPCServiceClient serviceClient = new RPCServiceClient(
				"http://localhost:8091/CollectionListSimpleType");

		Object[] opArgs = new Object[] { a, b };

		// QName of the target method
		QName opAdd = new QName("http://collection.pojo.rt.xservices.act.org",
				"add");
		// return type
		Class<?>[] returnTypes = new Class<?>[] { Integer.class };
		// invoke web service
		Object[] response = serviceClient.invokeBlocking(opAdd, opArgs,
				returnTypes);

		int result = (Integer) response[0];
		return result;
	}

}
