package org.act.xservices.rt.rpc.client;

import org.act.xservices.rt.client.XServicesException;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xom.QName;

public class SimpleTypeArrayIntegerClient {
	public static void main(String[] args) throws SerializationException,
			XServicesException, DeserializationException {
		RPCServiceClient serviceClient = new RPCServiceClient(
				"http://localhost:8091/SimpleTypeArrayInteger");

		Integer[] a = new Integer[] { 1, 8, 6 };
		Integer[] b = new Integer[] { 11, 82, 36 };

		// parameters
		Object[] opArgs = new Object[] { a, b };

		// QName of the target method
		QName opAdd = new QName(
				"http://simpletypearray.pojo.rt.xservices.act.org", "add","q0");

		String[] argNames=new String[]{"a","b"};
		// QName of the method to invoke
		QName opSub = new QName(
				"http://simpletypearray.pojo.rt.xservices.act.org", "sub","q1");

		// return type
		Class<?>[] returnTypes = new Class<?>[] { Integer[].class };
		serviceClient.setArgNames(argNames);
		// invoke web service
		Object[] response = serviceClient.invokeBlocking(opAdd, opArgs,
				returnTypes);
		
		// add
		Integer[] result = (Integer[]) response[0];

		for (int i = 0; i < a.length; i++) {
			System.out.println(a[i] + " + " + b[i] + " = " + result[i]);
		}
		serviceClient = new RPCServiceClient(
		"http://localhost:8091/SimpleTypeArrayInteger");
		serviceClient.setArgNames(argNames);
		// sub
		response = serviceClient.invokeBlocking(opSub, opArgs, returnTypes);

		result = (Integer[]) response[0];
		for (int i = 0; i < a.length; i++) {
			System.out.println(a[i] + " + " + b[i] + " = " + result[i]);
		}

	}

}
