package org.act.xservices.rt.rpc.client;

import org.act.xservices.rt.client.XServicesException;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xom.QName;

public class SimpleTypeFloatClient {
	public static void main(String[] args) throws SerializationException,
			XServicesException, DeserializationException {
		RPCServiceClient serviceClient = new RPCServiceClient(
				"http://localhost:8091/SimpleTypeFloat");

		float a = 10.3f;
		float b = 13.89f;

		// parameters
		Object[] opArgs = new Object[] { a, b };

		// QName of the target method
		QName opAdd = new QName("http://simpletype.pojo.rt.xservices.act.org",
				"add");

		// QName of the method to invoke
		QName opSub = new QName("http://simpletype.pojo.rt.xservices.act.org",
				"sub");

		String[] argNames = new String[] { "a", "b" };
		serviceClient.setArgNames(argNames);
		// return type
		Class<?>[] returnTypes = new Class<?>[] { Float.class };

		// invoke web service
		Object[] response = serviceClient.invokeBlocking(opAdd, opArgs,
				returnTypes);
		// add
		Float result = (Float) response[0];
		System.out.println(a + " + " + b + " = " + result);
		serviceClient = new RPCServiceClient(
				"http://localhost:8091/SimpleTypeFloat");
		// sub
		response = serviceClient.invokeBlocking(opSub, opArgs, returnTypes);

		result = (Float) response[0];
		System.out.println(a + " - " + b + " = " + result);

	}

}
