package org.act.xservices.rt.rpc.client;

import org.act.xservices.rt.client.entry.Entry;
import org.act.xservices.rt.rpc.client.RPCServiceClient;
import org.act.xservices.rt.xom.QName;


public class TestXserviceClient {
	public static void main(String[] args) throws Exception {

		RPCServiceClient client = new RPCServiceClient(
				"http://localhost:8091/AddressBook");

		QName opFindEntry = new QName("http://service.addressbook.sample",
				"findEntry", "ns");
		String name = "Abby Cadabby";
		String[] argNames=new String[]{"name"};
		//client.setArgNames(argNames);
		Object[] opFindEntryArgs = new Object[] { name };
		Class<?>[] returnTypes = new Class<?>[] { Entry.class };
		client.setArgNames(argNames);
		Object[] response = client.invokeBlocking(opFindEntry, opFindEntryArgs,
				returnTypes);
		Entry result = (Entry) response[0];

		if (result == null) {
			System.out.println("No entry found for " + name);
			return;
		}

		System.out.println("Name :" + result.getName());
		System.out.println("Street :" + result.getStreet());
		System.out.println("City :" + result.getCity());
		System.out.println("State :" + result.getState());
		System.out.println("Postal Code :" + result.getPostalCode());
	}
}
