package org.act.xservices.rt.stub.client;

import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;
import org.act.xservices.rt.xcontainer.framework.util.JavaUtils;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;
import org.act.xservices.rt.xcontainer.rpc.DeserializationException;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xcontainer.xdb.MessageReceiveInOut;
import org.act.xservices.rt.xom.Metaset;

public class HelloMessageRecerierInOut extends MessageReceiveInOut {

	@Override
	protected IServiceContext invokeBusinessLogic(IServiceContext serviceContext)
			throws ProviderProcessException, ServiceProcessException {
		// get the implementation class for the Web Service
		Object implClass = getImplementationObject(serviceContext
				.getXcService());
		HelloSkeleton skel = (HelloSkeleton) implClass;
		ISOAPEnvelope envelope = null;
		// get the operation of the web service
		XcOperation xcOperation = serviceContext.getXcOperation();

		if (xcOperation == null) {
			throw new ProviderProcessException(
					"Operation is not located, if this is doclit style the SOAP-ACTION should specified via the SOAP Action to use the RawXMLProvider");
		}
		java.lang.String methodName;
		if (xcOperation.getQName() != null
				& (methodName = JavaUtils.xmlNameToJava(xcOperation.getQName()
						.getName())) != null) {

			Metaset content = serviceContext.getInMessageBody()
					.getFirstElement();
			if ("sayHello".equals(methodName)) {
				HelloResponse response = null;

				try {
					Hello newOperation = new Hello().deserialize(content);					 
					response = skel.NewOperation(newOperation);
					envelope = toEnvelope(getSOAPFactory(serviceContext),
							response);
				} catch (SerializationException e) {
					throw new ServiceProcessException(e);
				} catch (DeserializationException e) {
					throw new ServiceProcessException(e);
				}
			}
		}
		serviceContext.setOutMessage(envelope);
		return serviceContext;
	}
}
