package org.act.xservices.rt.xcontainer.container;

import java.io.File;

import org.act.xservices.rt.xcontainer.framework.AbstractEnvironment;
import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderFactory;
import org.act.xservices.rt.xcontainer.inf.service.SpecialSOAPRegistry;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcServiceRegistry;

/**
 * 
 * @author Lizq [lizq@act.buaa.edu.cn]
 * 2007-06-20
 */
public class ContainerEnvironment extends AbstractEnvironment implements IContainerEnvironment{
	
	private String runtimePath = System.getProperty("user.dir");
	
	/** Serviceע */
	private XcServiceRegistry xcServiceRegistry = new XcServiceRegistry();
	
	/** SOAPϢעRequestURI --> ServiceName */
	private SpecialSOAPRegistry specialSOAPRegistry = new SpecialSOAPRegistry();
	
	/**  */
	private ProviderFactory providerFactory;

	
	public void config(IConfigElement configurableElement) throws Exception {
		
		this.environmentConfiguration = configurableElement;
	}

	public String getRuntimePath() {
		return runtimePath;
	}

	/**
	 * ServiceURI,ô˷ӦWSDLĵλ
	 */
	public File getWSDLFileByURL(String serviceURLPath) {
		XcService xcs = xcServiceRegistry.getXcServiceByURLPath(serviceURLPath);
		
		if(xcs != null){
			return xcs.getWsdlFile();
		}else{
			return null;
		}
	}

	public XcServiceRegistry getXcServiceRegistry() {
		return xcServiceRegistry;
	}
	
	public SpecialSOAPRegistry getSpecialSOAPRegistry() {
		return specialSOAPRegistry;
	}
	
	public ProviderFactory getProviderFactory(){
		return providerFactory;
	}
	
	public void setProviderFactory(ProviderFactory providerFactory) {
		this.providerFactory = providerFactory;
	}
	
}
