package org.act.xservices.rt.xcontainer.management;

import java.util.concurrent.ExecutorService;

import org.act.xservices.rt.xcontainer.container.XContainer;
import org.act.xservices.rt.xcontainer.framework.IRuntimeContainer;
import org.act.xservices.rt.xcontainer.framework.objectpool.IObjectPool;

/**
 * 
 * 
 * @version 1.0 2008-6-16
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ContainerManagement implements IContainerManagement{
	
	/**Եǰ */
	private final IRuntimeContainer wsRuntimeContainer;
	
	
	protected ContainerManagement(IRuntimeContainer wsRuntimeContainer){
		this.wsRuntimeContainer = wsRuntimeContainer;
	}
	
	
	
	//------------------------------------------
	
	/**
	 * ݶ󻺳ƻö󻺳ص
	 * 
	 * @param poolName
	 * @return ƶӦĶ󻺳أ򷵻null
	 */
	public IObjectPool getObjectPool(String objectPoolName){
		return wsRuntimeContainer.getObjectPoolMap().get(objectPoolName);
	}
	
	
	/**
	 * ̳߳صƻ̳߳ص
	 * 
	 * @param threadPoolName
	 * @return
	 */
	public ExecutorService getThreadPool(String threadPoolName){
		
		if(threadPoolName.equals(ManagementConstants.THREADPOOL_TRANSPORT_IN)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_TRANSPORT).getInputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_TRANSPORT_OUT)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_TRANSPORT).getOutputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_MESSAGE_IN)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_MESSAGE).getInputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_MESSAGE_OUT)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_MESSAGE).getOutputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_SERVICE_IN)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_SERVICE).getInputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_SERVICE_OUT)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_SERVICE).getOutputThreadpool();
			
		}else if(threadPoolName.equals(ManagementConstants.THREADPOOL_ADAPTATION_IN)){
			return wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_ADAPTATION).getInputThreadpool();
		}
		
		//޷ʶʱ null
		return null;
	}
	

	
	/**
	 * ļľ·
	 * @return
	 */
	public String getConfigFileAbsolutePath(){
		return wsRuntimeContainer.getConfigFileAbsolutePath();
	}
	
	
	/**
	 * ߳sleepжϣ̽ز
	 */
	public void startDeployServiceNow(){
		((XContainer)wsRuntimeContainer).deployManager.wsMonitorThread.interrupt();
	}
	
	//-------------------Ϣ-----------------------
	
	
	/**
	 * ĿǰXServiceContainerİ汾
	 * @return
	 */
	public String getXContainerVersion(){
		return wsRuntimeContainer.getVersion();
	}
	
	
	public String getName() {
		return wsRuntimeContainer.getName();
	}

	public String getDescription() {
		return wsRuntimeContainer.getDescription();
	}

	public String getStartupTime() {
		return wsRuntimeContainer.getStartupTime();
	}

}
