package org.act.xservices.rt.xcontainer.management;

import org.act.xservices.rt.xcontainer.framework.IRuntimeContainer;

/**
 * ʹãṩʱ
 * @version 1.0 2008-4-10
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class ManagementUtil implements IManagementUtil {

	/**Եǰ */
	private static IRuntimeContainer wsRuntimeContainer;
	
	/**ģʽ */
	private static ManagementUtil instance;
	

	
	private ManagementUtil(){
	}
	
	
	public static IManagementUtil getInstance(){
		return instance == null ? 
				instance = new ManagementUtil() : instance;
	}
	
	public static void setRuntimeContainer(IRuntimeContainer wsRC){
		wsRuntimeContainer = wsRC;
	}
	
	
	private IServiceManagement serviceManagement;
	
	private IContainerManagement containerManagement;
	
	private ITransportManagement httpTransportManagement;



	public IContainerManagement getContainerManagement() {
		if(wsRuntimeContainer == null)
			return null;
		
		return containerManagement == null?
				containerManagement = new ContainerManagement(wsRuntimeContainer) : containerManagement;
	}


	public IServiceManagement getServiceManagement() {
		if(wsRuntimeContainer == null)
			return null;
		
		return serviceManagement == null?
				serviceManagement = new ServiceManagement(wsRuntimeContainer) : serviceManagement;
	}


	public ITransportManagement getHTTPTransportManagement() {
		if(wsRuntimeContainer == null)
			return null;
		
		return httpTransportManagement == null?
				httpTransportManagement = new HTTPTransportManagement(wsRuntimeContainer) : httpTransportManagement;
	}
	
	
	
	
	
}
