package org.act.xservices.rt.xcontainer.management;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import org.act.xservices.rt.xcontainer.container.XContainer;
import org.act.xservices.rt.xcontainer.deployment.util.DeploymentConstants;
import org.act.xservices.rt.xcontainer.framework.IRuntimeContainer;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcBindingMessage;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcBindingOperation;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcEndpoint;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcMessagePart;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xom.QName;

import sun.misc.BASE64Decoder;

/**
 * 
 * @version 1.0 2008-6-16
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceManagement implements IServiceManagement{
	
	/**Եǰ */
	private final XContainer wsRuntimeContainer;
	
	
	protected ServiceManagement(IRuntimeContainer wsRuntimeContainer){
		this.wsRuntimeContainer = (XContainer) wsRuntimeContainer;
	}
	
	
	
	//------------------ȡѲϢط------------------
	
	/**
	 * ݷ  WSDLļľ·
	 * @return WSDLļľ·޷ҵ򷵻null
	 */
	public String getWSDLFileAbsolutePath(String serviceName, String namespaceURI){
		
		XcService xcser = 
			wsRuntimeContainer.getContainerEnvironment().getXcServiceRegistry(
					).getXcServiceByQName(new QName(namespaceURI,serviceName));

		String serviceURI = xcser.getAllSupportURLPath().iterator().next();	
		
		return wsRuntimeContainer.getContainerEnvironment(
				).getWSDLFileByURL(serviceURI).getAbsolutePath();
	}
	
	
	
	/**
	 * ݷ  WSDDļľ·
	 * @param serviceName
	 * @return
	 */
	public String getWSDDFileAbsolutePath(String serviceName, String namespaceURI){
		String wsdldir = getWSDLFileAbsolutePath(serviceName, namespaceURI);
		
		String wsdddir = 
			wsdldir.substring(0, wsdldir.length() - serviceName.length() - 5) + "service.xml";	
		
		return wsdddir; //˷ʵдһǣadd by lizq,2008-04-10
	}
	
	
	/**
	 * ѲķƵļ
	 * @return
	 */
	public Set<QName> getDeployedServicesName(){
		
		return wsRuntimeContainer.getContainerEnvironment().getXcServiceRegistry(
				).getDeployedServicesQName();
	}
	
	
	/**
	 * ݷƷش˷ֵ֧ķϢ
	 * @param serviceName
	 * @return 
	 */
	public Set<MethodInfoBean> getMethodsInfo(String serviceName, String namespaceURI){
		
		XcService xcser = 
			wsRuntimeContainer.getContainerEnvironment().getXcServiceRegistry(
					).getXcServiceByQName(new QName(namespaceURI,serviceName));
		
		
		//Ϣ
		Set<MethodInfoBean> mibSet = new HashSet<MethodInfoBean>();	
		
		// ֵ֧Ķ˵
		Set<QName> serBindingNameSet = new HashSet<QName>();
		for (XcEndpoint serEpT : xcser.getAllXcEndpoints()) {
			// ܴڶ˵ӦͬһBinding
			if (serBindingNameSet.contains(serEpT.getXcBinding().getQName())) {
				continue; // 鿴һEndpoint
			} else {
				serBindingNameSet.add(serEpT.getXcBinding()
						.getQName());
			}

			for (XcBindingOperation serMethodT : serEpT.getXcBinding()
					.getXcBindingOperationMap().values()) {

				MethodInfoBean mibT = new MethodInfoBean();

				mibT.setMethodName(serMethodT.getQName().toString());
				mibT.setExchangeModel(serMethodT.getXcOperation().getMepURI());
				mibT.setOperationStyle(serMethodT.getOperationStyle());

				mibT.setParameterTypes(getMessagepartTypes(serMethodT
						.getInputMessage()));
				mibT.setReturnTypes(getMessagepartTypes(serMethodT
						.getOutputMessage()));

				List<XcBindingMessage> faultMesList = serMethodT
						.getFaultMessages();
				Set<List<String>> faultTypesSet = new HashSet<List<String>>();
				for (XcBindingMessage mesImplT : faultMesList) {
					faultTypesSet.add(getMessagepartTypes(mesImplT));
				}
				mibT.setFaultTypesSet(faultTypesSet);

				mibSet.add(mibT);
			}//
		}// end of for ServiceEndpoint
		
		
		return mibSet;
	}
	
	
	private List<String> getMessagepartTypes(XcBindingMessage mesImpl){
		List<String> paraTypesList = new LinkedList<String>();	
		for(XcMessagePart mesPartT : mesImpl.getXcMessage().getXcMessagePartMap().values()){
			paraTypesList.add(mesPartT.getParameterType().toString());
		}
		return paraTypesList;
		
	}
	
	
	
	//-------------------------------------------------------------
	
	/**
	 * ĳ,ɾ˷ӦWSARļ˵󣬴˷񽫱²
	 * @param serviceName 
	 * @return ɹʧ
	 */
	public synchronized boolean undeployService(String serviceName, String namespaceURI){
		QName serQName = new QName(namespaceURI,serviceName);
		
		XcService serImpl = wsRuntimeContainer.getContainerEnvironment(
				).getXcServiceRegistry().getXcServiceByQName(
				new QName(namespaceURI,serviceName));
		
		if(serImpl == null)
			return false;
		
		wsRuntimeContainer.getContainerEnvironment().getXcServiceRegistry(
				).removeXcServiceByQName(serQName);

		return true;
	}
	
	
	
	//----------add 2008-06-16
	
	/**
     * ǰѲķ
     * @return еǰѲķ
     */
	public int getDeployedServiceNum(){
		return 0;
	}
	
	/**
	 * ǰеķ
	 * @return еķ
	 */
	public int getRunningServiceNum(){
		return 0;
	}
	
	/**
	 * ʼǰʱ
	 * @return Ѵ
	 */
	public int getProcessedServiceNum(){
		return 0;
	}
	
	/**
	 * ʼǰʱõĴ
	 * @return 
	 */
	public int getErrorInvokeNum(){
		return 0;
	}
	
	/**
	 * һWeb
	 * @param wsar
	 * @return ɹʧ
	 */
	public boolean deployService(String serviceWSAR, String serviceName){
		
		String dir = wsRuntimeContainer.getContainerEnvironment(
				).getAttribute(DeploymentConstants.DIR_DEPLOY_WSSERVICES) 
				+ java.io.File.separator + serviceName + ".wsar";
		
		BASE64Decoder base64De = new BASE64Decoder();		
		try {
			 byte[] fileByte = base64De.decodeBuffer(serviceWSAR);
			 OutputStream fos = new FileOutputStream(dir);
			 fos.write(fileByte);
             fos.close();
             fos = null;
             return true;
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}  catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}
	

	
	/**
	 * ֹͣĳֹͣ󣬸÷ͣSOAP󣬿ͨStart½SOAP
	 * @param serviceName
	 * @return ֹͣɹʧ
	 */
	public boolean stopService(String serviceName){
		return true;
	}
	
	/**
	 * ĳֹͣ״̬ķ񣬸÷½SOAP
	 * @param serviceName
	 * @return ɹʧ
	 */
    public boolean startService(String serviceName){
    	return true;
    }
    
    /**
     * ĳĵǰ״̬ started/stopped
     * @param serviceName
     * @return ĳĵǰ״̬
     */
    public String getServiceStatus(String serviceName){
    	return "start";
    }
     
}
