package org.act.xservices.rt.xcontainer.management;

import java.util.List;

import org.act.xservices.rt.xcontainer.framework.IRuntimeContainer;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportProtocol;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportReceiver;
import org.act.xservices.rt.xcontainer.transport.TransportConnector;

/**
 * 
 * 
 * @version 1.0 2008-6-16
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class TransportManagement implements ITransportManagement{
	
	/**Եǰ */
	protected final IRuntimeContainer wsRuntimeContainer;
	
	
	protected TransportManagement(IRuntimeContainer wsRuntimeContainer){
		this.wsRuntimeContainer = wsRuntimeContainer;
	}
	
	
	//------------------ȡͳϢ------------------
	protected List<ITransportReceiver> getTransportReceiverByName(String protocolIdentifier){
		TransportConnector transportConnector = 
			(TransportConnector)wsRuntimeContainer.getConnectorByName(
					ManagementConstants.CONNECTOR_TRANSPORT);
		
		ITransportProtocol transportProtocol = 
			transportConnector.getTransportProtocolByIdentifier(protocolIdentifier);
		
		if(transportProtocol == null){
			return null;
		}
		
		return transportProtocol.getTransportReceiverList();
		
	}
	
}




