package org.act.xservices.rt.xcontainer.deployment;

import java.io.File;
import java.io.FileFilter;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xcontainer.deployment.deployer.IDeployer;

/**
 * һļ
 * ܴͣWebBPELModuleģ
 * @LastModifyTime 2009-3-16
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class WSInfo {
	
    public static final int TYPE_WSSERVICE = 0;
    public static final int TYPE_BPELSERVICES = 1;
    public static final int TYPE_MODULE = 2;

    /** ļ */
    private File file;
    
    /** ļID
     * A/B/C/TestWS,  A/B/C/TestWS.wsar
     */
    private String fileID;
    
    /**һθʱ */
    private long lastModifiedDate;

    private int type = TYPE_WSSERVICE;

    private IDeployer deployer;
    
    private ClassLoader classLoader;
    
    private String serviceWorkingLocation;
    
    
    /**
     * 
     * @param file
     * @param lastModifiedDate
     * @param deployer
     * @param type
     */
    public WSInfo(File file, String fileID, long lastModifiedDate, IDeployer deployer, int type) {
        this.file = file;
        this.fileID = fileID;
        this.lastModifiedDate = lastModifiedDate;
        this.deployer = deployer;
        this.type = type;
    }

    public String getFileID() {
        return fileID;
    }

    public long getLastModifiedDate() {
        return lastModifiedDate;
    }

    public int getType() {
        return type;
    }

    public void setFile(File file) {
        this.file = file;
    }

    public void setLastModifiedDate(long lastmodifieddate) {
        this.lastModifiedDate = lastmodifieddate;
    }
    
    public IDeployer getDeployer() {
        return deployer;
    }

	public File getFile() {
		return file;
	}

    /**
     * 
     * @param parent
     * @param wsarWorkingfile Ŀ¼
     * @throws DeploymentException
     */
    public void setClassLoader(ClassLoader parent, File wsarWorkingfile)throws DeploymentException {
		if (wsarWorkingfile != null) {
			classLoader = getServiceClassLoader(parent, wsarWorkingfile);
		}
	}

	public ClassLoader getClassLoader() {
		return classLoader;
	}
	
	/**
	 * @param wsarLocation
	 *            wsarLocation the full path of web services archive.
	 * @return the class loader of the web services archive.
	 */
	private ClassLoader getServiceClassLoader(ClassLoader parent, File wsarWorkingfile) {
		try {
			List<URL> classpathes = new ArrayList<URL>();
			
			File classesDir = new File(wsarWorkingfile, "classes"); //TODO: ע˴дˣд add by lizq
			if (classesDir.exists() && classesDir.isDirectory())
				classpathes.add(classesDir.toURL());

			File libDir = new File(wsarWorkingfile, "lib");
			if (libDir.exists() && libDir.isDirectory()) {
				File[] files = libDir.listFiles(jarFileFilter);
				for (int i = 0; i < files.length; i++) {
					classpathes.add(files[i].toURL());
				}
			}
			URL[] urls = classpathes.toArray(new URL[0]);
			
			return new URLClassLoader(urls, parent);
		} catch (Exception ex) {
			ex.printStackTrace();
			return null;
		}
	}
	
	/** һļ.jar.zipļ */
	private FileFilter jarFileFilter = new FileFilter() {
		public boolean accept(File file) {	
			if(file.isDirectory())
				return false;
			
			String fn = file.getName();
			return ((fn.endsWith(".jar")) || (fn.endsWith(".zip")));
		}
	};

	public String getServiceWorkingLocation() {
		return serviceWorkingLocation;
	}

	public void setServiceWorkingLocation(String serviceWorkingLocation) {
		this.serviceWorkingLocation = serviceWorkingLocation;
	}
}
