package org.act.xservices.rt.xcontainer.deployment.deployer;

import org.act.xservices.rt.xcontainer.deployment.DeploymentException;
import org.act.xservices.rt.xcontainer.deployment.WSInfo;
import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.policy.IPolicyConfiger;


/**
 * This interface is used to provide the custom deployment mechanism , where you
 * can write your own Deployer to process a particular type and make that to
 * a service or a module.
 * 
 * @LastModifyTime 2009-4-8
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface IDeployer{

    
	/**
	 * ʼ;
	 * дIPolicyConfigerڴWSDLеPolicyϢ
	 * @param extension
	 * @param containerEnv
	 * @param policyConfigers
	 */
	public void init(String extension, IContainerEnvironment containerEnv, IPolicyConfiger[] policyConfigers);
	
	/**
     * Process a file and add it to the configuration
     * @param wsFile the DeploymentFileData object to deploy
     * @throws DeploymentException if there is a problem
     */
	public void deploy(WSInfo wsFile) throws DeploymentException;

    /**
     * Remove a given file from the configuration
     * @param wsFile name of item to remove
     * @throws DeploymentException if there is a problem
     */
	public void unDeploy(String wsFileName) throws DeploymentException;
    
	
    /**
     * ôDeployerֵ֧ļĺ׺
     * @return
     */
    public String getExtension();
    
}
