package org.act.xservices.rt.xcontainer.deployment.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

/**
 * <p>Title: TMConstants</p>
 * <p>Description: װõļ</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUAA ACT</p>
 * @author <a href="mailto:mxx@cscw.buaa.edu.cn">mxx</a>
 * @version 1.0
 */

public class FileUtil {
    /**
     * :ļ
     * @param src Դļ
     * @param des Ŀļ
     * @exception    ˵
     * @throws IOException IO쳣
     */
    public static void copyFile(File src,File des) throws IOException {
          FileInputStream in=new FileInputStream(src);
          OutputStream out=new FileOutputStream(des);

          write(in,out);
          out.close ();
          in.close();
    }

    /**
     * :ļ
     * @param src Դļ
     * @param des Ŀļ
     * @exception    ˵
     * @throws IOException IO쳣
     */
    public static void copyFile(byte[] src,File des) throws IOException {
          OutputStream out=new FileOutputStream(des);
          out.write(src);
          out.flush ();
          out.close ();
    }

    /**
     * :ԶURLļ
     * @param src ԴļURL
     * @param dest ĿļURL
     * @exception    ˵
     * @throws IOException IO쳣
     */
    public static void downLoadFile(URL src,File dest) throws IOException {
          //if (!dest.getProtocol ().equals ("file"))
          // throw new IOException ("only file: protocoll is allowed as destination!");

          InputStream in;
          OutputStream out;

          /*String s = dest.getFile ();
          File dir = new File (s.substring (0, s.lastIndexOf("/")));
          if (!dir.exists ())
                 dir.mkdirs ();
          */

          in = src.openStream ();
          out = new FileOutputStream (dest);

          write (in, out);
          out.close ();
          in.close ();
    }

    /**
     * :дļ
     * @param in   
     * @param out  
     * @exception    ˵
     * @throws IOException IO쳣
     */
    public static void write (InputStream in, OutputStream out) throws IOException{
          byte[] buffer = new byte[1024*512];
          int read;
          while (true){
                read =in.read(buffer);
                if (read == -1)
                        break;
                 out.write(buffer, 0, read);
          }
          out.flush ();
   }

    /**
     * :ݹɾĿ¼
     * @param _file    Ҫɾ·
     * @return				
     * @exception  IOException
     */
    public static void deleteRecursive(File _file) throws IOException{
        if (_file.isDirectory()){
            File[] files = _file.listFiles();
            for (int i = 0, l = files.length; i < l; ++i)
                deleteRecursive(files[i]);
        }
        _file.delete();
    }

//    public static void main(String[] args) throws IOException {
//		File ff = new File("H:/a");
//		deleteRecursive(ff);
//	}

    /**
     * :չѹ
     * @param zipFile     չļ
     * @param _destDir    չļ·
     * @exception  IOException
     */
    public static void inflate( File zipFile, String _destDir )
            throws IOException {

        FileInputStream fis = new FileInputStream( zipFile );
        ZipInputStream _in = new ZipInputStream( fis );

        try {
            OutputStream out;
            ZipEntry entry;
            //wsarĿ¼֤Ŀ¼һᱻ
            File destDir = new File(_destDir);
            if (!destDir.exists())
                destDir.mkdir();
            while ( (entry = _in.getNextEntry()) != null) {
                String name = entry.getName();

                if (entry.isDirectory()) {
                    // Ŀ¼
                    File dir = new File(_destDir, name);
                    if (!dir.exists())
                        dir.mkdirs();
                }
                else {
                    //ֱwindowʹzipѹʱ/\
                    int index_java = name.lastIndexOf("/");
                    int index_win = name.lastIndexOf("\\");
                    int index = -1;
                    if ( (index = index_java) != -1 || (index = index_win) != -1) {
                        //ļ·
                        File dir = new File(_destDir, name.substring(0, index));
                        if (!dir.exists())
                            dir.mkdirs();
                    }
                    //ļչ·
                    //õĿļ·
                    File file = new File(_destDir, name);
                    //ǸĿ¼,"lib\"Ķ,˵ǿĿ¼,追
                    if (file.isDirectory()){
                      continue;
                    }
                    //ļ
                    out = new FileOutputStream(file);
                    copy(_in, out, false, true);
                    //last modified time
                    long time = entry.getTime();
                    if (time > 0)
                        file.setLastModified(time);
                }
            }
        }
        finally {
            _in.close();
        }
    }

    /**
     * :չѹ
     * @param in     չļ
     * @param _destDir    չļ·
     * @exception  IOException
     */
    public static void inflate( InputStream in, String _destDir )
            throws IOException {

        ZipInputStream _in = new ZipInputStream(in);
        try {
            OutputStream out;
            ZipEntry entry;
            //wsarĿ¼֤Ŀ¼һᱻ
            File destDir = new File(_destDir);
            if (!destDir.exists())
                destDir.mkdir();
            while ( (entry = _in.getNextEntry()) != null) {
                String name = entry.getName();

                if (entry.isDirectory()) {
                    // Ŀ¼
                    File dir = new File(_destDir, name);
                    if (!dir.exists())
                        dir.mkdirs();
                }
                else {
                    //ֱwindowʹzipѹʱ/\
                    int index_java = name.lastIndexOf("/");
                    int index_win = name.lastIndexOf("\\");
                    int index = -1;
                    if ( (index = index_java) != -1 || (index = index_win) != -1) {
                        //ļ·
                        File dir = new File(_destDir, name.substring(0, index));
                        if (!dir.exists())
                            dir.mkdirs();
                    }
                    //ļչ·
                    //õĿļ·
                    File file = new File(_destDir, name);
                    //ǸĿ¼,"lib\"Ķ,˵ǿĿ¼,追
                    if (file.isDirectory()){
                      continue;
                    }
                    //ļ
                    out = new FileOutputStream(file);
                    copy(_in, out, false, true);
                    //last modified time
                    long time = entry.getTime();
                    if (time > 0)
                        file.setLastModified(time);
                }
            }
        }
        finally {
            _in.close();
        }
    }


    /**
     * :ɿļĹ
     * @param _in    Դļ
     * @param _out   Ŀļ
     * @param _closeInput   Ƿر
     * @exception  IOException
     */
    public static void copy(InputStream _in, OutputStream _out, boolean _closeInput, boolean _closeOutput)
            throws IOException {

        byte[] buffer = new byte[1024 * 512];
        int read;
        while (true) {
            read = _in.read(buffer);
            if (read == -1)
                break;
            _out.write(buffer, 0, read);
        }
        _out.flush();
        if (_closeOutput)
            _out.close();
        if (_closeInput)
            _in.close();
    }

}
