package org.act.xservices.rt.xcontainer.framework;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.act.xservices.rt.xcontainer.framework.lifecycle.ALifecycle;
import org.act.xservices.rt.xcontainer.framework.objectpool.IObjectPool;
import org.act.xservices.rt.xcontainer.inf.config.ContainerConfiguration;
/**
 * Web
 * @version 1.0 2007-04-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class ARuntimeContainer extends ALifecycle implements IRuntimeContainer {
	
	/**е */
	protected List<IConnector> connectorList = new ArrayList<IConnector>(4);
	
	/**ڵж */
	protected HashMap<String, IObjectPool> objectPoolMap;
	
	/**ɱ */
	protected IContainerEnvironment containerEnvironment;
	
	/**Ϣ */
	protected ContainerConfiguration containerConfiguration;
	
	
	
	public ContainerConfiguration getContainerConfiguration() {
		return containerConfiguration;
	}
	
	public IContainerEnvironment getContainerEnvironment() {
		return containerEnvironment;
	}
	
	public List<IConnector> getConnectorList() {
		return connectorList;
	}

	public HashMap<String, IObjectPool> getObjectPoolMap() {
		return objectPoolMap;
	}
	
	/**
	 * ConnectorNameConector
	 * @param ConnectorName
	 * @return
	 */
	public IConnector getConnectorByName(String ConnectorName){
		for(int i=0; i<connectorList.size(); i++){
			if(connectorList.get(i).getConnectorName().equals(ConnectorName)){
				return connectorList.get(i);
			}
		}
		return null;
	}
    
}
