package org.act.xservices.rt.xcontainer.framework;

import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;


/**
 * ConnectorEnvironmentContainerEnvironment
 * 
 * @LastModifyTime 2009-10-2
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class AbstractEnvironment implements IEnvironment{

	private Map<String,Object> attributeMap = new ConcurrentHashMap<String,Object>();
	
	/**Ԫ */
	protected IConfigElement environmentConfiguration;
	
	public IConfigElement getEnvironmentConfiguration(){
		return environmentConfiguration;
	}
	
	public Object getAttribute(String name) {
		return attributeMap.get(name);
	}

	public Iterator<String> getAttributeNames() {
		return attributeMap.keySet().iterator();
	}

	public void removeAttribute(String name) {
		attributeMap.remove(name);
	}

	public void setAttribute(String name, Object object) {
		attributeMap.put(name, object);
	}
}
