package org.act.xservices.rt.xcontainer.framework.config;

import java.io.IOException;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * XMLDOMģ͵ķװ
 * @version 1.0 2007-04-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ConfigurableElementDomImpl implements IConfigElement {


	/**ÿConfigurableElementװһElement */
	private Element xmlElement;

	/**
	 * ͨXMLļƣôļ rootElement зװ
	 * @param filename
	 */
	public ConfigurableElementDomImpl(String filename) {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		try {
			DocumentBuilder parser = factory.newDocumentBuilder();
			Document xmlConfigDoc = parser.parse(filename);
			xmlElement = xmlConfigDoc.getDocumentElement();
			xmlElement.normalize();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * ֱӷװ xmlElement
	 * @param xmlElement
	 */
	public ConfigurableElementDomImpl(Element xmlElement){
		this.xmlElement = xmlElement;
		this.xmlElement.normalize();
	}


	/** 
	 * Attribute֣Attributeֵ
	 * @param attributename
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getAttribute(java.lang.String)
	 */
	public String getAttribute(String attributename) {
		return xmlElement.getAttribute(attributename);
	}

	
	/** 
	 * 
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getChildren()
	 */
	public IConfigElement[] getChildren() {
		NodeList childList = xmlElement.getChildNodes();
		ArrayList<ConfigurableElementDomImpl> childElements = new ArrayList<ConfigurableElementDomImpl>();
		
		if( childList.getLength() > 0){
			for(int i=0; i<childList.getLength(); i++){
				Node node = childList.item(i);
				if(node.getNodeType() == Node.ELEMENT_NODE){ //ӽڵ
					childElements.add(new ConfigurableElementDomImpl((Element)node));
				}
			}
			ConfigurableElementDomImpl[] ChildConfigurableElement = new ConfigurableElementDomImpl[childElements.size()];
			return childElements.toArray(ChildConfigurableElement);
		}
		return NONE;
	}

	/** 
	 * ֱֲԪ,طԪ,û򷵻سΪ0
	 * @param childName
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getChildrenWithName(java.lang.String)
	 */
	public IConfigElement[] getChildrenWithName(String childName){
		NodeList childList = xmlElement.getElementsByTagName(childName);
		ArrayList<ConfigurableElementDomImpl> childElements = new ArrayList<ConfigurableElementDomImpl>();
		
		if( childList.getLength() > 0){
			for(int i=0; i<childList.getLength(); i++){
				Node node = childList.item(i);
				if(node.getNodeType() == Node.ELEMENT_NODE){ //ӽڵ
					childElements.add(new ConfigurableElementDomImpl((Element)node));
				}
			}
			ConfigurableElementDomImpl[] ChildConfigurableElement = new ConfigurableElementDomImpl[childElements.size()];
			return childElements.toArray(ChildConfigurableElement);
		}
		return NONE;
	}
	
	
	/** 
	 * ֱֲԪأطĵһԪ,û򷵻null
	 * @param childName
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getFirstChildWithName(java.lang.String)
	 */
	public IConfigElement getFirstChildWithName(String childName) {
		IConfigElement[] childEle = this.getChildrenWithName(childName);
		if(childEle.length == 0){
			return null;
		}else{
			return childEle[0];
		}
	}
	
	
	/** 
	 * Elementname ǰ׺
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getName()
	 */
	public String getName() {

		return xmlElement.getNodeName();
	}


	/** 
	 * شElementеTextڵֵ
	 * @return
	 * @see org.act.xservices.rt.xcontainer.framework.config.IConfigElement#getValue()
	 */
	public String getValue() {
		NodeList childList = xmlElement.getChildNodes();
		StringBuffer str = new StringBuffer();
		for(int i=0; i<childList.getLength(); i++){
			Node node = childList.item(i);
			if(node.getNodeType() == Node.TEXT_NODE){
				str.append(node.getNodeValue());
			}
		}
		if(str.length() != 0){
			return str.toString();
		}
		return null;  //ElementûTextڵ㣬򷵻null
	}
	
	
	//-----test
	public static void main(String args[]){
		ConfigurableElementDomImpl ce = new ConfigurableElementDomImpl("conf/connector.conf");
		System.out.println(ce.getName());
		System.out.println((ce.getChildren())[0].getName());
	}



}
