package org.act.xservices.rt.xcontainer.framework.dispatch;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import org.act.xservices.rt.xcontainer.framework.objectpool.IDispatchSource;

/**
 * ɷ
 * ɷԴȡͨһɷɴ
 * 
 * TODO ǳҪɷԴȡҪTaskȻ̴߳Ŀǰʵǽ̳߳ش
 * ̳߳е߳ûȼ֣޷ʵķּҪ޸
 * 
 * @LastModifyTime 2009-10-2
 * @CreationTime 2007-03-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class Dispatcher<S> extends Thread { //ɷ

	private volatile boolean isRunning = false;

	private ITaskFactory<S> taskFactory;

	private IDispatchSource<S> source;

	private ExecutorService threadpool; //ִ̳߳
	
	private final Lock lock = new ReentrantLock();
	
	/**
	 * ʼɷɷԴ̳߳
	 * @param environment
	 *          the interactive environment to be set.
	 * @param threadpool
	 *          the threadpool to be set.
	 */
	public final void initialize(IDispatchSource<S> source, ITaskFactory<S> factory, 
			ExecutorService threadpool, int threadPriority) {
		
		this.source = source;
		this.taskFactory = factory;
		this.threadpool = threadpool;
		
		super.setPriority(threadPriority); //߳ȼ
	}

	
	/**
	 * Dispatch object from <code>DispatchSource</code>. <p/> NOTICE: this
	 * method must not be inherited by any user.
	 */
	public void run() {
		isRunning = true;
		while (isRunning) {
			try {
				//ȡԴ
				S object = source.get();
				lock.lock();
				dispatchTask(object);
				lock.unlock();
			} catch (InterruptedException e) {  //ж쳣***
				isRunning = false;
				//e.printStackTrace();
			}
		}
	}
	
	/**
	 * ݲObjectTask̳߳ش
	 * @param object
	 */
	protected void dispatchTask(S object){
		//Դ ɷ
		ISafeTask safeTask = taskFactory.createSafeTask(object);
		if (safeTask != null) {
			//ִ̳߳д,ģʽ
			threadpool.execute(safeTask);
		}
	}

	/**
	 * Return if the thread of <code>Dispatcher</code> is active.
	 * 
	 * @return if the thread of <code>Dispatcher</code> is active.
	 */
	public boolean isActive() {
		return isRunning;
	}

	/**
	 * Terminate the <code>Dispatcher</code>, set the state of <code>
	 * Dispatcher</code> to STOPPING.
	 */
	public final void terminate() {
		isRunning = false;
		if (lock.tryLock()) {
			try {
				interrupt();
			} finally {
				lock.unlock();
			}
		}
	}
}
