package org.act.xservices.rt.xcontainer.framework.handler;

import org.act.xservices.rt.xcontainer.framework.config.IConfigurable;


/**
 * ϢһЩ
 * 
 * @LastModifyTime 2008-9-8
 * @CreationTime 2007-05-28
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface IHandler<T> extends IConfigurable  {
	
	/**
	 * @return
	 */
	public IHandler<T> getNextInHandler();

	/**
	 * @param nextInHandler
	 */
	public void setNextInHandler(IHandler<T> nextInHandler);

	/**
	 * @return
	 */
	public IHandler<T> getNextOutHandler();

	/**
	 * @param nextOutHandler
	 */
	public void setNextOutHandler(IHandler<T> nextOutHandler);
	
	/**
	 * 봦
	 */
	public T[] handlerIn(T context);
	
	/**
	 * 
	 */
	public T[] handlerInFault(T context);
	
	/**
	 * 
	 */
	public T[] handlerOut(T context);
	
	/**
	 * 
	 */
	public T[] handlerOutFault(T context);
	
	/**
	 * ʼ
	 */
	public void init();
	
	/**
	 * ٴ,ͷԴ
	 */
	public void destroy();
	
	/**
	 * Get the name of the handler
	 * @return   Get the name of the handler
	 */
	public String getHandlerName();
	
	/**
	 * Get the description of the handler
	 * @return   the description of the handler
	 */
	public String getHandlerDescription();

}
