package org.act.xservices.rt.xcontainer.framework.lifecycle;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * 
 * @version 1.0 2005-6-23
 * @author liujian [liujian@act.buaa.edu.cn]
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class ALifecycle implements ILifecycle {

	public List<ILifecycleListener> lifecycleListenerList = new ArrayList<ILifecycleListener>();

	public void addLifecycleListener(ILifecycleListener listener) {
		lifecycleListenerList.add(listener);

	}

	public void removeLifecycleListener(ILifecycleListener listener) {
		lifecycleListenerList.remove(listener);
	}

	public ILifecycleListener[] getLifecycleListeners() {
		return lifecycleListenerList.toArray(new ILifecycleListener[0]);
	}
	
	/**
	 * ¼
	 * @param event
	 */
	public void fireLifecycleEvent(LifecycleEvent event){
		for (Iterator<ILifecycleListener> iter = lifecycleListenerList.iterator(); iter.hasNext();) {
			ILifecycleListener listener =  iter.next();
			listener.lifecycleEvent(event);
		}
	}

}
