package org.act.xservices.rt.xcontainer.framework.objectpool.impl;

import java.util.concurrent.ArrayBlockingQueue;

import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.objectpool.IObjectPool;

/**
 * ڹ̶СеĶ󻺳ءFIFO
 * 
 * @LastModifyTime 2008-7-8
 * @CreationTime 2008-7-8
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ObjectBlockQueuePool<T> implements IObjectPool<T>{

	
	private static final int DEFAULT_SIZE = 100;

	private int size = DEFAULT_SIZE;
	
	private String name;
	
	private ArrayBlockingQueue<T> blockQueue;
	

	public ObjectBlockQueuePool() {
		
	}
	
	public void destroy() {
		 while (blockQueue.size() != 0) {
			 try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
		 } 
		 blockQueue = null;
		
	}

	public int getMaxSize() {
		return this.size;
	}

	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public boolean isEmpty() {
		return blockQueue.isEmpty();
	}

	public boolean isFull() {
		return blockQueue.size() == this.size;
	}

	public void setMaxSize(int size) {
		//дСڳʼܸı
		if(blockQueue == null)
			this.size = size;
	}

	public int size() {
		return blockQueue.size();
	}

	public T get() throws InterruptedException {
		return blockQueue.take();
	}

	public void put(T x) throws InterruptedException {
		blockQueue.put(x);
		
	}

	public void config(IConfigElement objectPoolconfElem) throws Exception {
		
		this.setName(objectPoolconfElem.getAttribute("name"));
		
		this.setMaxSize(Integer.parseInt(objectPoolconfElem.getAttribute("maxsize")));
		
		if("true".equalsIgnoreCase(objectPoolconfElem.getAttribute("fair"))){
			this.blockQueue = new ArrayBlockingQueue<T>(size, true);
		}else{
			this.blockQueue = new ArrayBlockingQueue<T>(size, false);
		}
	}

}
