package org.act.xservices.rt.xcontainer.framework.transport;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.IConnectorEnvironment;
import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;


/**
 *  Э
 *  
 * @LastModifyTime 2008-10-10
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class ATransportProtocol implements ITransportProtocol{

      
    /**Э */
    private String name;
    
	/**Э */
	private String description;
	
	/**Э汾 */
	private String version;
	
	/**Ƿ */
	private boolean enable;

	/**ɷԴбһЭɲɸɷԴ */
	private List<ITransportReceiver> transportReceiverList = new ArrayList<ITransportReceiver>();
	
	private IConnector<IATFTransportSession, IATFTransportContext> connector;
	
	
    /**  */
    private final Map<Object,Object> attributes = new ConcurrentHashMap<Object,Object>(0);
	

    public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}
	
	
	public abstract String getTransportIdentifier();

	public boolean isEnable() {
		return enable;
	}

	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	public abstract void startup();

	public abstract void shutdown();

	public abstract boolean isOneWay();
	
	public void initialize(IConfigElement transportProtocolConfig, 
			IConnector<IATFTransportSession, IATFTransportContext> connector) throws Exception{
		
		this.connector = connector;
		
		this.name = transportProtocolConfig.getAttribute("name");
		this.version = transportProtocolConfig.getAttribute("version");
		this.description = transportProtocolConfig.getAttribute("description");
		
		if (transportProtocolConfig.getAttribute("enabled").equals("true"))
			setEnable(true);
		else
			setEnable(false);
	}
	
	
	public List<ITransportReceiver> getTransportReceiverList() {
		return transportReceiverList;
	}
	
	
    public Map<Object, Object> getAttributes() {
        return Collections.unmodifiableMap(attributes);
    }

    public Object getAttribute(Object key) {
        return attributes.get(key);
    }

    public boolean containsAttribute(Object key) {
        return attributes.containsKey(key);
    }

    public void setAttribute(Object key, Object attribute) {
        attributes.put(key, attribute);
    }

    public void removeAttribute(Object key) {
        attributes.remove(key);
    }

	public IConnector<IATFTransportSession, IATFTransportContext> getConnector() {
		return connector;
	}
	
	public IConnectorEnvironment<IATFTransportSession, IATFTransportContext> getConnectorEnvironment() {
		return getConnector().getConnectorEnvironment();
	}
	
	public IContainerEnvironment getContainerEnvironment(){
		return getConnector().getConnectorEnvironment().getContainerEnvironment();
	}
	
}
