package org.act.xservices.rt.xcontainer.framework.transport;

/**
 * ˽ӿڰôͳϢķ
 * @LastModifyTime 2008-12-23
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface IStatistical {
	
    /**
     * ܹյSocket
     * @return
     */
    public long getAcceptedSocketCount();
    
    /**
     * ͬʱSocket
     * @return
     */
    public long getLargestManagedSocketCount();
    
    /**
     * ĿǰڴSocket
     * @return
     */
    public long getManagedSocketCount();
    
	
	/**
	 * ʾͳƹǷ
	 * @return
	 */
	public boolean isThroughputStatisticAvailable();
	
	/**
	 * ͳϢʱ
	 * @return
	 */
	public int getThroughputCalculationInterval();
	
	
    /**
     * ͳϢʱĬΪ3
     */
    public void setThroughputCalculationInterval(int throughputCalculationInterval);
	
	
	

	//--------------
    /**
     * Get instantaneous receive speed, in byte/s.
     * ʵʱֽڽٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public double getReceiveSpeed();
    
    /**
     * Get instantaneous receive speed, in byte/s.
     * ʵʱϢٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public double getMessageReceiveSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ƽֽڽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgReceiveSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getLargestReceiveSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ƽϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgMessageReceiveSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getLargestMessageReceiveSpeed();
    
    //--------------

    
    
    
    //--------------
    
    /**
     * Get instantaneous send speed, in byte/s.
     * ʵʱֽڷٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public double getSendSpeed();
    
    /**
     * Get instantaneous send speed, in byte/s.
     * ʵʱϢٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public double getSendMessageSpeed();

    /**
     * Get average send speed, in byte/s.
     * ƽֽڷٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgSendSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰֽڷٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getLargestSendSpeed();
    
    /**
     * Get average send speed, in byte/s.
     * ƽϢٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgMessageSendSpeed();
    
    /**
     * Get average receive speed, in byte/s.
     * ýֹĿǰϢٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getLargestMessageSendSpeed();
    
    //-----------------


    
    
    /**
     * ôɷԴʱ
     * @return
     */
    public long getStartTimeInMillis();
    

    /**
     * Get elapsed time after session started and before session closed, in ms.
     * ʱ
     * 
     * @return elapsed time,or -1 means statistic Function Unavailable.
     */
    public long getRunningTimeInMillis();


    
    /**
     * Get received bytes count. If session restart, the value will reset to 0.
     * ֽܹܵ
     * 
     * @return received bytes count,or -1 means statistic Function Unavailable.
     */
    public long getReceivedBytes();
    
    /**
     * ܵϢ
     * @return
     */
    public long getReceivedMessages();

    /**
     * Get sent bytes count. If session restart, the value will reset to 0.
     * ֽܹ
     * 
     * @return sent bytes count,or -1 means statistic Function Unavailable.
     */
    public long getSentBytes();
    
    /**
     * ͵Ϣ
     * @return
     */
    public long getSentMessages();

}
