package org.act.xservices.rt.xcontainer.framework.transport;

import java.util.List;
import java.util.Map;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.IConnectorEnvironment;
import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;


/**
 * ԴЭĳ
 * 
 * @LastModifyTime 2008-10-10
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface ITransportProtocol{
	
	/**
	 * شЭʶΨһʾһЭ
	 * @return
	 */
	public String getTransportIdentifier(); 
	
    /**
     * ش˴Э
     * @return
     */
    public String getDescription();

	public void setDescription(String description);

	/**
	 * ش˴Э
	 * @return
	 */
	public String getName();

	public void setName(String name);

	public String getVersion();

	public void setVersion(String version);

	public boolean isEnable();

	public void setEnable(boolean enable);

	public void startup();

	public void shutdown();

	public boolean isOneWay();

	
	/**
	 * ʼ
	 * @param transportProtocolConfig
	 * @param connector
	 * @throws Exception
	 */
	public void initialize(IConfigElement transportProtocolConfig, 
			IConnector<IATFTransportSession, IATFTransportContext> connector) throws Exception; 
	

	
//	public void setConnectorEnvironment(IConnectorEnvironment<IATFTransportSession, IATFTransportContext> containerEnvironment);



//	public void setConnector(IConnector<IATFTransportSession, IATFTransportContext> connector);
	
	public IConnector<IATFTransportSession, IATFTransportContext> getConnector();
	
	public IConnectorEnvironment<IATFTransportSession, IATFTransportContext> getConnectorEnvironment();
	
	public IContainerEnvironment getContainerEnvironment();
	
	
	
	/**
	 * 
	 * @return
	 */
	public List<ITransportReceiver> getTransportReceiverList();
	
	/**
	 * ش˴ЭӦSender
	 * @return
	 */
	public ITransportSender getTransportSender();
	
	
	//---Attribute---
    public Map<Object, Object> getAttributes();

    public Object getAttribute(Object key);

    public boolean containsAttribute(Object key);

    public void setAttribute(Object key, Object attribute);
    
    public void removeAttribute(Object key);
}
