package org.act.xservices.rt.xcontainer.inf.config;

import org.act.xservices.rt.xcontainer.framework.config.ConfigElementParser;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;

/**
 * XContainer Ϣ
 * 
 * @LastModifyTime 2009-2-17
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class ContainerConfiguration {

	/** */
	private String containerName;
	
	/**汾 */
	private String version;
	
	/** */
	private String description;
	
	private IConfigElement xcObjectPoolConfig;
	
	private IConfigElement xcEnvironmentConfig;
	
	private IConfigElement xcConnectorsConfig;
	
	private IConfigElement deploymentConfig;
	
	
	
	public ContainerConfiguration(IConfigElement xcontainer) {
		this.init(xcontainer);
	}
	
	/**
	 * 
	 * @param filename ļ·
	 */
	public ContainerConfiguration(String filename) {		
		
		IConfigElement xcConfig = ConfigElementParser.parseConfigFile(filename);		
		
		this.init(xcConfig);
	} 
	
	private void init(IConfigElement xcConfig){
		containerName = xcConfig.getAttribute("name");
		
		version = xcConfig.getAttribute("version");
		
		description = xcConfig.getAttribute("description");
		
		xcEnvironmentConfig = xcConfig.getFirstChildWithName("containerEnvironment");
		
		xcObjectPoolConfig = xcConfig.getFirstChildWithName("containerObjectPool");
		
		xcConnectorsConfig = xcConfig.getFirstChildWithName("containerConnectors");
		
		deploymentConfig = xcConfig.getFirstChildWithName("deployment");
	}
	
	

	public String getContainerName() {
		return containerName;
	}

	public IConfigElement getXcObjectPoolConfig() {
		return xcObjectPoolConfig;
	}

	public IConfigElement getXcConnectorsConfig() {
		return xcConnectorsConfig;
	}

	public IConfigElement getXcEnvironmentConfig() {
		return xcEnvironmentConfig;
	}
	
	public IConfigElement getTransportConectorConfig(){
		return xcConnectorsConfig.getChildren()[0];
	}
	
	public IConfigElement getMessageConectorConfig(){
		return xcConnectorsConfig.getChildren()[1];
	}
	
	public IConfigElement getServiceConectorConfig(){
		return xcConnectorsConfig.getChildren()[2];
	}
	
	public IConfigElement getAdaptationConectorConfig(){
		return xcConnectorsConfig.getChildren()[3];
	}

	public String getDescription() {
		return description;
	}

	public String getVersion() {
		return version;
	}

	public IConfigElement getDeploymentConfig() {
		return deploymentConfig;
	}
	
}
