package org.act.xservices.rt.xcontainer.inf.context;

import java.util.List;

import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcEndpoint;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;

/**
 * @LastModifyTime 2009-09-30
 * @CreationTime 2007-09-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface IServiceContext {

	/**
	 * URI
	 * 
	 * @return
	 */
	public String getRequestURI();

	/**
	 * SOAPģԪΪSOAP Envelope
	 * 
	 * @return
	 */
	public ISOAPEnvelope getInMessage();

	/**
	 * SOAPϢ壬ԪΪSOAP Body
	 * 
	 * @return
	 */
	public ISOAPBody getInMessageBody();

	/**
	 * SOAPеSOAPļͷ
	 * 
	 * @return
	 */
	public List<ISOAPHeaderBlock> getInMessageHeaders();

	/**
	 * ϢSOAP
	 * 
	 * @return
	 */
	public ISOAPEnvelope getOutMessage();

	public void setOutMessage(ISOAPEnvelope outMessage);

	/**
	 * ϢǷΪϢ
	 * 
	 * @return
	 */
	public boolean isFaultOutMessage();

	public void setFaultOutMessage(boolean isFaultOutMessage);

	/**
	 * ôServiceContextMessageContext
	 * 
	 * @return
	 */
	public IMessageContext getMessageContext();

	public void setMessageContext(IMessageContext messageContext);

	/**
	 * ǷΪSOAPϢ
	 * 
	 * @return
	 */
	public boolean isSpecialSoap();

	public void setSpecialSoap(boolean isSpecialSoap);

	/**
	 * ServiceContextӦķǷΪWebService
	 * 
	 * @return
	 */
	public boolean isWSService();

	/**
	 * ServiceContextӦķǷΪBPELService
	 * 
	 * @return
	 */
	public boolean isBPELService();

	/**
	 * ôServiceContextӦXcService
	 * 
	 * @return
	 */
	public XcService getXcService();

	public void setXcService(XcService xcService);

	/**
	 * ôServiceContextӦXcEndpoint
	 * 
	 * @return
	 */
	public XcEndpoint getXcEndpoint();

	/**
	 * ôServiceContextӦXcOperation
	 * 
	 * @return
	 */
	public XcOperation getXcOperation();

	public void setXcOperation(XcOperation xcOperation);

}
