package org.act.xservices.rt.xcontainer.inf.context.impl;

import java.net.URI;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;

/**
 * 
 * 
 * @LastModifyTime 2008-10-6
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public final class ATFTransportContext implements IATFTransportContext {

	//Ϣ
	protected URI requestUri;
	protected String requestSoapAction;  //ʾ soap-Action
	protected byte[] requestContent;
	protected String requestContentType;
	
	//ӦϢ
	protected URI responseUri;
	protected String responseSoapAction;  //ʾ soap-Action
	protected byte[] responseContent;
	protected String responseContentType;

	//TODO ˱дǣlizq 2008-12-03
	protected final Map<String,String> parameters = new LinkedHashMap<String,String>();

	protected IATFTransportSession session;  //Ự
	
	
	
	public ATFTransportContext(){
		
	}
	
	
	//---reuqest---
	
	public String getRequestUriString() {
		return requestUri.toString();
	}
	
	public URI getRequestUri(){
		return requestUri;
	}
	
	public void setRequestUri(URI requestUri){
		this.requestUri = requestUri;
	}
	
	public String getRequestSoapAction() {
		return requestSoapAction;
	}

	public void setRequestSoapAction(String action) {
		this.requestSoapAction = action;
	}
	
	public byte[] getRequestContent() {
		return requestContent;
	}

	public void setRequestContent(byte[] content) {
		this.requestContent = content;
	}
	
	public String getRequestContentType() {
		return requestContentType;
	}

	public void setRequestContentType(String contentType) {
		this.requestContentType = contentType;
	}
	
	
	
	//---response---
	
	public URI getResponseUri() {
		return responseUri;
	}

	public void setResponseUri(URI responseUri) {
		this.responseUri = responseUri;
	}
	
	public String getResponseSoapAction() {
		return responseSoapAction;
	}

	public void setResponseSoapAction(String responseSoapAction) {
		this.responseSoapAction = responseSoapAction;
	}
	
	public byte[] getResponseContent() {
		return responseContent;
	}

	public void setResponseContent(byte[] responseContent) {
		this.responseContent = responseContent;
	}

	public String getResponseContentType() {
		return responseContentType;
	}

	public void setResponseContentType(String responseContentType) {
		this.responseContentType = responseContentType;
	}



	//---Parameter---
	
    public final void setParameter(String key, String value) {
        if (key != null) {
            if (value == null)
                parameters.remove(key);
            else
                parameters.put(key, value);
        }
    }

    public final String getParameter(String key) {
        return key == null ? null :parameters.get(key);
    }

    public final Map<String, String> getParameters() {
        return Collections.unmodifiableMap(parameters);
    }
    
	/**
	 * @return Returns the transportSession.
	 */
	public IATFTransportSession getATFTransportSession() {
		return session;
	}

	/**
	 * @param transportSession The transportSession to set.
	 */
	public void setATFTransportSession(IATFTransportSession session) {
		this.session = session;
	}
    


    //TODO д޸ģlizq 2008-12-03
    public String toString(){
    	StringBuffer buffer = new StringBuffer();
    	buffer.append(headersToString());
    	if(requestContent != null){
    		buffer.append(Charset.forName("UTF-8").decode(
    				ByteBuffer.wrap(requestContent)).toString());
    	}
    	return buffer.toString();
    }


    /** 
     * ͷַʽ
     * @return
     */
    private String headersToString() {
        StringBuffer buffer = new StringBuffer();
        for (Iterator iter = parameters.entrySet().iterator(); iter.hasNext();) {
            Entry entry = (Entry) iter.next();
            buffer.append(entry.getKey()).append(": ").append(entry.getValue()).append("\r\n");
        }
        buffer.append("\r\n"); 
        return buffer.toString();
    }

}
