package org.act.xservices.rt.xcontainer.inf.context.impl;

import java.net.URI;
import java.util.List;

import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcEndpoint;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;

/**
 * @LastModifyTime 2009-4-14
 * @CreationTime 2007-09-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceContextInOutImpl implements IServiceContext {

	/** Ϣ */
	private IMessageContext messageContext;

	/** URIӦBindingOperationDescription */
	private XcOperation xcOperation;

	/** URLӦServiceDescription */
	private XcService xcService;

	/** ʾǷΪspecialϢϢЭͬȣSpeicalSOAPRegistryнע */
	private boolean isSpecialSoap = false;

	// ӦϢ
	private ISOAPEnvelope outMessage;

	// ӦϢǷΪSOAPϢ
	private boolean isFaultOutMessage;

	public ServiceContextInOutImpl(IMessageContext messageContext) {
		this.messageContext = messageContext;
	}

	/**
	 * MessageContextлSOAPģԪΪSOAP Envelope
	 */
	public ISOAPEnvelope getInMessage() {
		return getMessageContext().getSoapMessage();
	}

	public ISOAPBody getInMessageBody() {
		return getMessageContext().getSoapMessage().getBody();
	}

	public List<ISOAPHeaderBlock> getInMessageHeaders() {
		ISOAPHeader header = getMessageContext().getSoapMessage().getHeader();
		if (header == null) {
			return null;
		}
		return header.getAllHeaderBlocks();
	}

	public ISOAPEnvelope getOutMessage() {
		return outMessage;
	}

	public void setOutMessage(ISOAPEnvelope outMessage) {
		this.outMessage = outMessage;
	}

	public boolean isFaultOutMessage() {
		return isFaultOutMessage;
	}

	public void setFaultOutMessage(boolean isFaultOutMessage) {
		this.isFaultOutMessage = isFaultOutMessage;
	}

	public IMessageContext getMessageContext() {
		return messageContext;
	}

	public void setMessageContext(IMessageContext messageContext) {
		this.messageContext = messageContext;
	}

	public boolean isSpecialSoap() {
		return isSpecialSoap;
	}

	public void setSpecialSoap(boolean isSpecialSoap) {
		this.isSpecialSoap = isSpecialSoap;
	}

	/**
	 * URIIPַಿ֣"/TestWS"
	 * 
	 * @return
	 */
	public String getRequestURI() {
		if (getMessageContext() != null) {
			return getMessageContext().getUri();
		}
		return null;
	}

	/**
	 * URIҶӦXcEndpoint
	 * 
	 * @return
	 */
	public XcEndpoint getXcEndpoint() {
		XcEndpoint xcEP = null;
		String uri = getRequestURI();
		if (uri == null) // URIΪnullֱӷnull
			return null;

		URI requestUri = URI.create(uri);

		if (xcService != null) {
			for (XcEndpoint xce : xcService.getAllXcEndpoints()) {
				if (xce.getEndpointURLPath().equals(requestUri.getPath())) {
					xcEP = xce; // ҵӦXcEndpoint
					break;
				}
			}
		}

		return xcEP;
	}

	public XcOperation getXcOperation() {
		return xcOperation;
	}

	public void setXcOperation(XcOperation xcOperation) {
		if (this.xcOperation != null)
			return;
		this.xcOperation = xcOperation;
	}

	public XcService getXcService() {
		return xcService;
	}

	public void setXcService(XcService xcService) {
		if (this.xcService != null)
			return;
		this.xcService = xcService;
	}

	/**
	 * ServiceContextӦķǷΪWebService
	 * 
	 * @return
	 */
	public boolean isWSService() {
		if (this.xcService != null) {
			return XcService.SERVICE_TYPE_WS.equals(xcService.getServiceType());
		}
		return false;
	}

	/**
	 * ServiceContextӦķǷΪBPELService
	 * 
	 * @return
	 */
	public boolean isBPELService() {
		if (this.xcService != null) {
			return XcService.SERVICE_TYPE_BPEL.equals(xcService
					.getServiceType());
		}
		return false;
	}
}
