package org.act.xservices.rt.xcontainer.inf.service.wsdl;



import org.act.xservices.rt.xom.QName;
import org.w3c.dom.Element;



public class ExtenseElement {

	private QName elementType;

	private boolean required;
	
	private Element extElement;
	
	
	public ExtenseElement() {
	}
	
	public ExtenseElement(Element extElement) {
		this.extElement = extElement;
	}
	
	
	/**
	 * Set the type of this extensibility element.
	 *
	 * @param elementType the type
	 */
	public void setElementType(QName elementType) {
		this.elementType = elementType;
	}

	/**
	 * Get the type of this extensibility element.
	 *
	 * @return the extensibility element's type
	 */
	public QName getElementType() {
		return elementType;
	}

	/**
	 * Set whether or not the semantics of this extension are required.
	 * Relates to the wsdl:required attribute.
	 */

	public void setRequired(boolean required) {
		this.required = required;
	}

	/**
	 * Get whether or not the semantics of this extension are required. Relates
	 * to the wsdl:required attribute.
	 */
	public boolean isRequired() {
		return required;
	}

	public Element getExtElement() {
		return extElement;
	}

	public void setExtElement(Element extElement) {
		this.extElement = extElement;
	}
	
	

}
