package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import java.util.List;

import org.act.xservices.rt.xom.QName;

public interface IElementExtensible {

    /**
     * Add an extensibility element.
     *
     * @param extElement the extensibility element to be added
     */
    public boolean addExtensibilityElement(ExtenseElement extElement);
    
    /**
     * Remove an extensibility element.
     *
     * @param extElement the extensibility element to be removed
     * @return the extensibility element which was removed
     */
    public ExtenseElement removeExtensibilityElement(ExtenseElement extElement);

    /**
     * Get all the extensibility elements defined here.
     */
    public List<ExtenseElement> getExtensibilityElements();
    
    
    public List<ExtenseElement> getExtensibilityElementsByName(QName elementName);
    
    
}
