package org.act.xservices.rt.xcontainer.inf.service.wsdl;

public interface WSDLConstants {

	static String SOAP11_PREFIX = "soap";
	static String SOAP12_PREFIX = "soap12";
	static String DEFAULT_WSDL_NAMESPACE_PREFIX = "wsdl";
	static String DEFAULT_SCHEMA_NAMESPACE_PREFIX = "xs";
	static String DEFAULT_TARGET_NAMESPACE_PREFIX = "xservices";
	static String TARGETNAMESPACE_PREFIX = "tns";
	static String SCHEMA_NAMESPACE_PRFIX = "ns";
	static String FORM_DEFAULT_QUALIFIED = "qualified";
	static String FORM_DEFAULT_UNQUALIFIED = "unqualified";
	static String DOC_LIT_BARE_PARAMETER = "doclitBare";

	static String DEFAULT_TARGET_NAMESPACE = "http://org.act.buaa.edu/xservices";
	static String WSDL_NAMESPACE = "http://schemas.xmlsoap.org/wsdl/";
	static String XSERVICES_XSD = "http://org.act.buaa.edu/xsd";
	static String URI_WSDL12_SOAP = "http://schemas.xmlsoap.org/wsdl/soap12/";
	static String URI_WSDL11_SOAP = "http://schemas.xmlsoap.org/wsdl/soap/";
	static String TRANSPORT_URI = "http://schemas.xmlsoap.org/soap/http";
	static String DEFAULT_LOCATION_URL = "http://localhost:8090/";
	static String WSAD_NS = "http://www.w3.org/2006/05/addressing/wsdl";

	static String HTTP_NAMESPACE = "http://schemas.xmlsoap.org/wsdl/http/";
	static String MIME_NAMESPACE = "http://schemas.xmlsoap.org/wsdl/mime/";
	static String HTTP_PREFIX = "http";
	static String MIME_PREFIX = "mime";
	static String URN_PREFIX = "urn";
	static String COLON_SEPARATOR = ":";

	static String BINDING_NAME_SUFFIX = "SOAP11Binding";
	static String SOAP12BINDING_NAME_SUFFIX = "SOAP12Binding";
	static String HTTP_BINDING = "HttpBinding";
	static String PORT_TYPE_SUFFIX = "PortType";
	static String PORT_NAME_SUFFIX = "Port";
	static String MESSAGE_LOCAL_NAME = "message";
	static String ATTRIBUTE_NAME = "name";
	static String REQUEST_MESSAGE = "RequestMessage";
	static String RESPONSE_MESSAGE = "ResponseMessage";
	static String FAULT_MESSAGE = "Message";
	static String MESSAGE_SUFFIX = "Request";
	static String REQUEST = "Request";
	static String RESPONSE = "Response";
	static String RESULT = "Result";
	static String PORT_TYPE_LOCAL_NAME = "portType";
	static String OPERATION_LOCAL_NAME = "operation";
	static String IN_PUT_LOCAL_NAME = "input";
	static String OUT_PUT_LOCAL_NAME = "output";
	static String SERVICE_LOCAL_NAME = "service";
	static String BINDING_LOCAL_NAME = "binding";
	static String PORT = "port";
	static String SOAP12PORT = "SOAP12port";
	static String SOAP11PORT = "SOAP11port";
	static String HTTP_PORT = "Httpport";
	static String PART_ATTRIBUTE_NAME = "part";
	static String ELEMENT_ATTRIBUTE_NAME = "element";
	static String FAULT_LOCAL_NAME = "fault";

	static String SOAP_ADDRESS = "address";
	static String LOCATION = "location";
	static String TRANSPORT = "transport";
	static String STYLE = "style";
	static String SOAP_ACTION = "soapAction";
	static String SOAP_BODY = "body";
	static String SOAP_USE = "use";
	static String DOCUMENT = "document";
	static String LITERAL = "literal";
	//
	// Schema XSD Namespaces
	//
	static String URI_2001_SCHEMA_XSD = "http://www.w3.org/2001/XMLSchema";
	static String XSD_PREFIX = "xsd";
	//
	// Schema XSI Namespaces
	//
	static String URI_2001_SCHEMA_XSI = "http://www.w3.org/2001/XMLSchema-instance";
	static String XSI_PREFIX = "xsi";

	static String ATTR_FORM_DEFAULT_OPTION = "afd";
	static String ATTR_FORM_DEFAULT_OPTION_LONG = "attributeFormDefault";
	static String CLASSNAME_OPTION = "cn";
	static String CLASSNAME_OPTION_LONG = "className";
	static String CLASSPATH_OPTION = "cp";
	static String CLASSPATH_OPTION_LONG = "classPath";
	static String DOC_LIT_BARE = "dlb";
	static String DOC_LIT_BARE_LONG = "doclitbare";
	static String ELEMENT_FORM_DEFAULT_OPTION = "efd";
	static String ELEMENT_FORM_DEFAULT_OPTION_LONG = "elementFormDefault";
	static String EXTRA_CLASSES_DEFAULT_OPTION = "xc";
	static String EXTRA_CLASSES_DEFAULT_OPTION_LONG = "extraClasses";
	static String JAVA_PKG_2_NSMAP_OPTION = "p2n";
	static String JAVA_PKG_2_NSMAP_OPTION_LONG = "package2Namespace";
	static String LOCATION_OPTION = "l";
	static String LOCATION_OPTION_LONG = "location";
	static String NAMESPACE_GENERATOR_OPTION = "nsg";
	static String NAMESPACE_GENERATOR_OPTION_LONG = "namespaceGenerator";
	static String OUTPUT_FILENAME_OPTION = "of";
	static String OUTPUT_FILENAME_OPTION_LONG = "outputFilename";
	static String OUTPUT_LOCATION_OPTION = "o";
	static String OUTPUT_LOCATION_OPTION_LONG = "output";
	static String SCHEMA_GENERATOR_OPTION = "sg";
	static String SCHEMA_GENERATOR_OPTION_LONG = "schemaGenerator";
	static String SCHEMA_TARGET_NAMESPACE_OPTION = "stn";
	static String SCHEMA_TARGET_NAMESPACE_OPTION_LONG = "schemaTargetnamespace";
	static String SCHEMA_TARGET_NAMESPACE_PREFIX_OPTION = "stp";
	static String SCHEMA_TARGET_NAMESPACE_PREFIX_OPTION_LONG = "schemaTargetnamespacePrefix";
	static String SERVICE_NAME_OPTION = "sn";
	static String SERVICE_NAME_OPTION_LONG = "serviceName";
	static String STYLE_OPTION = "st";
	static String STYLE_OPTION_LONG = "style";
	static String TARGET_NAMESPACE_OPTION = "tn";
	static String TARGET_NAMESPACE_OPTION_LONG = "targetNamespace";
	static String TARGET_NAMESPACE_PREFIX_OPTION = "tp";
	static String TARGET_NAMESPACE_PREFIX_OPTION_LONG = "targetNamespacePrefix";
	static String USE_OPTION = "u";
	static String USE_OPTION_LONG = "use";
	static String WSDL_VERSION_OPTION = "wv";
	static String WSDL_VERSION_OPTION_LONG = "wsdl-version";
	static String CUSTOM_SCHEMA_LOCATION = "csl";
	static String CUSTOM_SCHEMA_LOCATION_LONG = "custom-schema-location";
	static String SCHEMA_MAPPING_FILE_LOCATION = "mfl";
	static String SCHEMA_MAPPING_FILE_LOCATION_LONG = "mapping-file-location";

	static String AXIS2_NAMESPACE_PREFIX = "ns1";

	static final String SOLE_INPUT = "SOLE_INPUT";

	static String WSDL_VERSION_2 = "2.0";
	static String WSDL_VERSION_2_OPTIONAL = "2";
	static String WSDL_VERSION_1 = "1.1";
	static String PARAMETERS = "parameters";

	static final String ELEM_IMPORT = "import";
	static final String ATTR_NAMESPACE = "namespace";
}
