package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xom.QName;

/**
 * ǶPortTypeBindingеOperationĳ
 * 
 * @version 1.0 2007-09-25
 * @version 1.1 2008-04-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class XcBindingOperation extends XcElement{

	private static final long serialVersionUID = -5535267497791674305L;
	
	//񷽷
	private QName qName;	
	
//	//Ϣģʽ,Ĭֵ
//	private String mesExchPattern = WSDL11Constants.MEP_IN_OUT;
	
	//Ϣ
	private XcBindingMessage inputMessage;

	//Ϣ
	private XcBindingMessage outputMessage;
	
	//Ϣб
	private List<XcBindingMessage> faultMessageList = new ArrayList<XcBindingMessage>();
	
	//from Binding 񷽷ʽ
	private String operationStyle = WSDL11Constants.STYLE_DOC;
	private String soapAction;
	
	private XcOperation xcOperation;
	
	private XcBinding xcBinding;

	


	public XcBindingOperation(){
		
	}
	
	public XcBindingOperation(QName qname){
		this.qName = qname;
	}
	
	public QName getQName() {
		return qName;
	}

	public void setQName(QName qname) {
		this.qName = qname;
	}

	public XcBindingMessage getInputMessage() {
		return inputMessage;
	}

	public void setInputMessage(XcBindingMessage inputMessage) {
		this.inputMessage = inputMessage;
		
	}

//	public String getMesExchPattern() {
//		return mesExchPattern;
//	}
//	
//	public void setMesExchPattern(String mesExchPattern) {
//		this.mesExchPattern = mesExchPattern;
//	}

	public XcBindingMessage getOutputMessage() {
		return outputMessage;
	}

	public void setOutputMessage(XcBindingMessage outputMessage) {
		this.outputMessage = outputMessage;
	}

	public XcBinding getXcBinding() {
		return xcBinding;
	}

	public void setXcBinding(XcBinding xcBinding) {
		this.xcBinding = xcBinding;
	}

	public String getSoapAction() {
		return soapAction;
	}

	public void setSoapAction(String soapb_soapAction) {
		this.soapAction = soapb_soapAction;
	}

	public String getOperationStyle() {
		return operationStyle;
	}

	public void setOperationStyle(String operationStyle) {
		this.operationStyle = operationStyle;
	}


	public List<XcBindingMessage> getFaultMessages(){
		return this.faultMessageList;
	}
	
	public boolean addFaultMessage(XcBindingMessage faultMessage){
		return this.faultMessageList.add(faultMessage);
	}
	
	public boolean removeFaultMessage(XcBindingMessage faultMessage){
		return this.faultMessageList.remove(faultMessage);
	}
	
	public XcBindingMessage  getgetFaultMessageByName(String faultMesName){
		for(XcBindingMessage faultMes : faultMessageList){
			if(faultMes.getName().equals(faultMesName))
				return faultMes;
		}
		return null;
	}

	

	/**
	 * ش˶һȿ¡
	 * @return
	 * @throws Exception
	 */
	public XcBindingOperation copy() throws Exception{
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		ObjectOutputStream out = new ObjectOutputStream(bout);
		out.writeObject(this);
		out.close();
		
		ByteArrayInputStream bin = new ByteArrayInputStream(bout.toByteArray());
		ObjectInputStream in = new ObjectInputStream(bin);
		XcBindingOperation serviceMethod = (XcBindingOperation) in.readObject();
		in.close();
		bin.close();
		return serviceMethod;
	}

	public XcOperation getXcOperation() {
		return xcOperation;
	}

	public void setXcOperation(XcOperation xcOperation) {
		this.xcOperation = xcOperation;
	}

}
