package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xcontainer.framework.policy.IPolicyProcessor;
import org.act.xservices.rt.xom.QName;

/**
 * ǶServiceԪеportԪصĳ
 * 
 * @version 1.0 2007-09-25
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class XcEndpoint extends XcElement {

	private static final long serialVersionUID = -7848680697726346668L;

	private QName qName;
	
	private XcBinding xcBinding;
	
	private String endpointURL; //IPַ,http://localhost:8080/a/b/c/TestWS?p=client	
	private String endpointURLPath; //IPַಿ֣"/a/b/c/TestWS"
	
	
//	private QName serviceQName;  //ӦWSDLĵе<service>Ԫصname
	
	private XcService xcService;
	
	//---------Policy--------by lizq 2010-07-02---
	private List<IPolicyProcessor> policyProcessorChain;
	
	public boolean addPolicyProcessor(IPolicyProcessor policyProcessor){
		if(policyProcessorChain == null){
			policyProcessorChain = new ArrayList<IPolicyProcessor>();
		}
		return policyProcessorChain.add(policyProcessor);
	}
	
	public boolean removePolicyProcessor(IPolicyProcessor policyProcessor){
		if(policyProcessorChain == null){
			return false;
		}
		return policyProcessorChain.remove(policyProcessor);
	}
	
	public List<IPolicyProcessor> getPolicyProcessor(){
		return policyProcessorChain;
	}
	//--------end-Policy--------------------------
	
	public XcEndpoint(){
		
	}
	
	public XcEndpoint(String serviceURIAll){
		this.setEndpointURL(serviceURIAll);
	}
	
	public XcEndpoint(QName qname){
		this.qName = qname;
	}
	

	public QName getQName() {
		return qName;
	}

	public void setQName(QName name) {
		this.qName = name;
	}
	
	
	public XcBinding getXcBinding() {
		return xcBinding;
	}

	public void setXcBinding(XcBinding xcBinding) {
		this.xcBinding = xcBinding;
	}


//	public String getWsPolicy() {
//		return wsPolicy;
//	}
//
//	public void setWsPolicy(String wsPolicy) {
//		this.wsPolicy = wsPolicy;
//	}
//
//	public List<IPolicyProcessor> getPolicyProcessorList() {
//		return policyProcessorList;
//	}
//
//	public void setPolicyProcessorList(List<IPolicyProcessor> policyProcessorList) {
//		this.policyProcessorList = policyProcessorList;
//	}

	public String getEndpointURLPath() {
		return endpointURLPath;
	}

	public String getEndpointURL() {
		return endpointURL;
	}

	public void setEndpointURL(String endpointURL) {
		if(endpointURL == null || "".equals(endpointURL))
			return;
		
		this.endpointURL = endpointURL;
		
		//URLPath
    	try {
    		URL url = new URL(endpointURL);
    		this.endpointURLPath = url.getPath();
    	} catch (Exception e) {
    		e.printStackTrace();
		}
	}


//	public QName getServiceQName() {
//		return serviceQName;
//	}
//
//	public void setServiceQName(QName serviceName) {
//		this.serviceQName = serviceName;
//	}
//	
//	public String getServiceName(){
//		return serviceQName.getLocalPart();
//	}

	public XcService getXcService() {
		return xcService;
	}

	public void setXcService(XcService xcService) {
		this.xcService = xcService;
	}
	
}
