package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import org.act.xservices.rt.xom.QName;

/**
 * һ
 * 
 * @version 1.0 2007-09-25
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class XcMessagePartType extends XcElement{
	
	/** */
	private static final long serialVersionUID = 1L;
	
	private QName name;
	
	

	/**
	 * Construct a web service type object.
	 * 
	 * @param namespace the namespace of the type
	 * @param name the name of the type
	 */
	public XcMessagePartType(String localPartName) {
		this.name = new QName(localPartName );
	}
	
	public XcMessagePartType(String namespaceURI, String localPartName) {
		this.name = new QName(namespaceURI, localPartName );
	}
	
	public XcMessagePartType(String namespaceURI, String localPart, String prefix) {
		this.name = new QName(namespaceURI, localPart, prefix);
	}

	/**
	 * @return Returns the name.
	 */
	public String getlocalPartName() {
		return name.getName();
	}


	/**
	 * @return Returns the namespace.
	 */
	public String getNamespaceURI() {
		return name.getNamespaceURI();
	}
	
	public String getPrefix() {
		return name.getNamespacePrefix();
	}


	/*
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (!(obj instanceof XcMessagePartType)) {
			return false;
		}
		XcMessagePartType type = (XcMessagePartType) obj;
		return name.equals(type.name);
	}

	/*
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return name.hashCode();
	}

	/*
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return name.toString();
	}
}
