package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xcontainer.framework.policy.IPolicyProcessor;
import org.act.xservices.rt.xcontainer.framework.provider.IProvider;
import org.act.xservices.rt.xom.QName;

/**
 * @LastModifyTime 2009-4-14
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class XcOperation extends XcElement {

	/** лҪ */
	private static final long serialVersionUID = 1L;

	private QName qName;

	private String parameterOrder;

	// Ϣģʽ,to store mepURL
	private String mepURI;

	// from Binding 񷽷ʽ
	private String operationStyle = WSDL11Constants.STYLE_DOC;
	private String soapAction;

	// Ϣ
	private XcMessage inputXcMessage;

	// Ϣ
	private XcMessage outputXcMessage;

	// Ϣб
	private List<XcMessage> faultXcMessageList = new ArrayList<XcMessage>();

	private XcPortType xcPortType;

	private XcService xcService;

	private XcBindingOperation xcBindingOperation;

	// ---WSDD---
	private Method method;

	private IProvider provider;

	// ---------Policy--------by lizq 2010-07-02---
	private List<IPolicyProcessor> policyProcessorChain;

	public boolean addPolicyProcessor(IPolicyProcessor policyProcessor) {
		if (policyProcessorChain == null) {
			policyProcessorChain = new ArrayList<IPolicyProcessor>();
		}
		return policyProcessorChain.add(policyProcessor);
	}

	public boolean removePolicyProcessor(IPolicyProcessor policyProcessor) {
		if (policyProcessorChain == null) {
			return false;
		}
		return policyProcessorChain.remove(policyProcessor);
	}

	public List<IPolicyProcessor> getPolicyProcessor() {
		return policyProcessorChain;
	}

	// --------end-Policy--------------------------

	public XcOperation() {

	}

	public XcOperation(QName qname) {
		this.qName = qname;
	}

	public QName getQName() {
		return qName;
	}

	public void setQName(QName qname) {
		this.qName = qname;
	}

	public XcMessage getInputXcMessage() {
		return inputXcMessage;
	}

	public void setInputXcMessage(XcMessage inputXcMessage) {
		this.inputXcMessage = inputXcMessage;
	}

	public String getMepURI() {
		return mepURI;
	}

	public void setMepURI(String mepURI) {
		this.mepURI = mepURI;
	}

	public String getOperationStyle() {
		return operationStyle;
	}

	public void setOperationStyle(String operationStyle) {
		this.operationStyle = operationStyle;
	}

	public XcMessage getOutputXcMessage() {
		return outputXcMessage;
	}

	public void setOutputXcMessage(XcMessage outputXcMessage) {
		this.outputXcMessage = outputXcMessage;
	}

	public String getSoapAction() {
		return soapAction;
	}

	public void setSoapAction(String soapAction) {
		this.soapAction = soapAction;
	}

	public List<XcMessage> getFaultXcMessages() {
		return this.faultXcMessageList;
	}

	public boolean addFaultXcMessage(XcMessage faultXcMessage) {
		return this.faultXcMessageList.add(faultXcMessage);
	}

	public boolean removeFaultXcMessage(XcMessage faultXcMessage) {
		return this.faultXcMessageList.remove(faultXcMessage);
	}

	public XcMessage getgetFaultMessageByName(String faultXcMessageName) {
		for (XcMessage faultMes : faultXcMessageList) {
			if (faultMes.getQName().getName().equals(faultXcMessageName))
				return faultMes;
		}
		return null;
	}

	public String getParameterOrder() {
		return parameterOrder;
	}

	public void setParameterOrder(String parameterOrder) {
		this.parameterOrder = parameterOrder;
	}

	public XcPortType getXcPortType() {
		return xcPortType;
	}

	public void setXcPortType(XcPortType xcPortType) {
		this.xcPortType = xcPortType;
	}

	public XcService getXcService() {
		return xcService;
	}

	public void setXcService(XcService xcService) {
		this.xcService = xcService;
	}

	public XcBindingOperation getXcBindingOperation() {
		return xcBindingOperation;
	}

	public void setXcBindingOperation(XcBindingOperation xcBindingOperation) {
		this.xcBindingOperation = xcBindingOperation;
	}

	// -------------WSDD-----------

	public Method getMethod() {
		return method;
	}

	public void setMethod(Method method) {
		this.method = method;
	}

	public IProvider getProvider() {
		return provider;
	}

	public void setProvider(IProvider provider) {
		this.provider = provider;
	}

}
