package org.act.xservices.rt.xcontainer.inf.service.wsdl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.act.xservices.rt.xom.QName;





/**
 * XcServiceע
 * XContainerķϢ
 * 
 * @version 1.0 2007-09-25
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class XcServiceRegistry {

	/**
	 * <scheme>://<authority><path>?<query>#<fragment>
	 * ֵΪ serviceURLPath --> XcService 
	 * עMapпܻжserviceURLPathӦͬһXcService
	 */
	private Map<String,XcService> xcServiceURLPathMap = 
		new ConcurrentHashMap<String,XcService>();
	
	/**ֵΪ serviceQName --> XcService */
	private Map<QName,XcService> xcServiceQNameMap = 
		new ConcurrentHashMap<QName,XcService>();
	
	
	/**
	 * ֮ǰע򷵻false
	 * @param xcser
	 * @return
	 */
	public synchronized boolean addXcService(XcService xcser){
		
		if(xcser == null){
			return false;
		}
		
		//жϷǷע
		if( xcServiceQNameMap.get(xcser.getQName()) != null ){
			return false;
		}else{
			//жϷURLǷע
			for(String serURL : xcser.getAllSupportURLPath()){
				if(xcServiceURLPathMap.get(serURL) != null){
					return false;
				}
			}
		}
		//зע
		xcServiceQNameMap.put(xcser.getQName(), xcser);
		
		//зURLע
		for(String serURL : xcser.getAllSupportURLPath()){
			xcServiceURLPathMap.put(serURL, xcser);
		}
		return true;
	}
	
	public XcService getXcServiceByQName(QName serQName){
		return xcServiceQNameMap.get(serQName);
	}
	
	/**
	 * <scheme>://<authority><path>?<query>#<fragment>
	 * @param serviceURLPath
	 * @return
	 */
	public XcService getXcServiceByURLPath(String serviceURLPath){
		return xcServiceURLPathMap.get(serviceURLPath);
	}

	public synchronized XcService removeXcServiceByQName(QName serQName){
		XcService xcser = xcServiceQNameMap.remove(serQName);
		if(xcser == null)
			return null;
		
		for(String serURI : xcser.getAllSupportURLPath()){
			xcServiceURLPathMap.remove(serURI);
		}
		return xcser;
	}
	
	public XcService removeXcServiceByURL(String serviceURL){
		XcService xcser = getXcServiceByURLPath(serviceURL);
		if(xcser == null)
			return null;
		
		return removeXcServiceByQName(xcser.getQName());
	}
	

	public XcService removeXcService(XcService xcser){		
		return removeXcServiceByQName(xcser.getQName());
	}
	
	public List<XcService> getDeployedXcServices(){
		return new ArrayList<XcService>(xcServiceQNameMap.values());
	}
	
	public Set<QName> getDeployedServicesQName(){
		return xcServiceQNameMap.keySet();
	}

	public Set<String> getDeployedServiceURL(){
		return xcServiceURLPathMap.keySet();
	}
	
	/** 
	 * ͨƻ URI, ˷ûƿռ䣬򷴲ʱӣby lizq 20080709
	 * WSARƼΪQNameLocalpartӶͬĴ
	 * 
	 * @param serviceName
	 * @return
	 */
	public Set<String> getServiceURLByServiceName(String serviceName) {
		
		for(QName serQName : xcServiceQNameMap.keySet()){
			if(serQName.getName().equals(serviceName)){
				return xcServiceQNameMap.get(serQName).getAllSupportURLPath();
			}
		}

		return null;
	}
	
	public XcService getXcServiceByServiceName(String serviceName) {
		
		Set<String> urls = getServiceURLByServiceName(serviceName);
	
		return getXcServiceByURLPath(urls.iterator().next());
	}
	
}
