package org.act.xservices.rt.xcontainer.inf.service.wsdl.schema;

import java.util.List;

import javax.xml.namespace.QName;

/**
 * 
 * @author viking
 * @date 2010-7-29
 * @since JDK 1.5.0
 * @version 1.0.0
 * 
 *          ComplexType contains several ElementTypes. There are three
 *          particles, sequence,all and choice. Sequence particle means the
 *          elements sequence must be same as the defined sequence. All particle
 *          means the elements sequence can be arbitrary. Choice particle means
 *          one of the elements can present.
 * 
 */
public interface ComplexType extends SchemaType {
	/**
	 * Get all types of the complex type.The sequence is the same as the
	 * variable declared in complex type.
	 * 
	 */
	List<ElementType> getElementTypes();

	/**
	 * Add element type
	 * 
	 * @param element
	 */
	void addElementType(ElementType element);

	/**
	 * Set the particle of the complex type. There are three particle: sequence,
	 * all, choice.
	 * 
	 * @param particle
	 */
	void setComplexParticle(String particle);

	/**
	 * Get the particle of the complex type.
	 * 
	 * @return one of three type,sequence,all,choice.
	 */
	String getComplexParticle();

	/**
	 * When content model is simple content,the content is simple content
	 * extension or simple content restriction. So there is no element type. The
	 * complex type is equals simple element type.
	 * 
	 * @return
	 */
	QName getType();
	
	void setType(QName type);
}
