package org.act.xservices.rt.xcontainer.inf.service.wsdl.schema;

import java.util.List;

import javax.xml.namespace.QName;

/**
 * 
 * @author viking
 * @date 2010-7-30
 * @since JDK 1.5.0
 * @version 1.0.0
 * 
 */
public interface ElementType extends SchemaType {
	/**
	 * Element has tow style. <element name="" type=""/> and <element name="">
	 * 
	 * @return
	 */
	boolean isSimpleType();

	/**
	 * if maxOccurs >1 , this type is an array.
	 * 
	 * @return
	 */
	boolean isArrayType();

	boolean isNillable();
	
	boolean isGroupType();

	/**
	 * set the maxOccur attribute
	 * 
	 * @param max
	 */
	void setMaxOccurs(long max);

	/**
	 * Get the maxOccur attribute
	 * 
	 * @return
	 */
	long getMaxOccurs();

	void setIsNillable(boolean nillable);
    void setGroupType(boolean isGroup);
	// ===================Complex type ========================/
	ComplexType getComplex();

	void setComplex(ComplexType complex);

	// ===================Simple type ========================/
	/** Get the schema type name */
	QName getType();

	/** Set the schema type name */
	void addType(QName type);
	
	/**
	 * Union has more than one type.
	 * @return
	 */
	List<QName> getTypes();
}
