package org.act.xservices.rt.xcontainer.inf.service.wsdl.schema;

import java.util.List;

/**
 * 
 * @author viking
 * @date 2010-7-30
 * @since JDK 1.5.0
 * @version 1.0.0
 * 
 *          WSDL message contains several parts. Every part is defined as an
 *          ElementType. The type attribute reference to a simple or complex
 *          type, and the part is a simple type or reference to a complex type
 *          ElementType. The element attribute reference to ElementType, and the
 *          ElementType represents this part.
 * 
 */
public interface MessageSchema extends SchemaType {
	
	/**
	 * Get all ElementType equals get all parts
	 * @return
	 */
	List<ElementType> getAllElements();

	/**
	 *  Add ElementType 
	 * @param element
	 */
	void addElement(ElementType element);

}
