package org.act.xservices.rt.xcontainer.message;

import org.act.xservices.rt.xcontainer.framework.AConnectorEnvironment;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.message.builder.MessageBuilderFactory;
import org.act.xservices.rt.xcontainer.message.formatter.MessageFormatterFactory;

/**
 * Ϣִл
 * @author Lizq [lizq@act.buaa.edu.cn]
 * 2007-05-28
 *
 */
public class MessageConnectorEnvironment extends AConnectorEnvironment<IATFTransportContext, IMessageContext> {
	
	private MessageBuilderFactory messageBuilderFactory;
	
	private MessageFormatterFactory messageFormatterFactory;
	
	
	public MessageConnectorEnvironment(){
		
	}
	
	public void config(IConfigElement configurableElement) throws Exception {
        super.config(configurableElement);
		
		//MessageBuilder
		IConfigElement buildersConfig = configurableElement.getFirstChildWithName("messageBuilders");
		if(buildersConfig != null){
			messageBuilderFactory = new MessageBuilderFactory();
			messageBuilderFactory.config(buildersConfig);
		}
		
		//MessageFormatter
		IConfigElement formattersConfig = configurableElement.getFirstChildWithName("messageFormatters");
		if(formattersConfig != null){
			messageFormatterFactory = new MessageFormatterFactory();
			messageFormatterFactory.config(formattersConfig);
		}
    }
	
	
	public MessageBuilderFactory getMessageBuilderFactory(){
		return messageBuilderFactory;
	}

	public MessageFormatterFactory getMessageFormatterFactory() {
		return messageFormatterFactory;
	}
	
}
