package org.act.xservices.rt.xcontainer.message;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.dispatch.ATaskFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ISafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.message.handler.MessageSerializeHandler;


/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-5-24
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class MessageInTaskFactory extends ATaskFactory<IATFTransportContext> {

	private MessageSerializeHandler messageSerializeHandler;

	@SuppressWarnings("unchecked")
	public MessageInTaskFactory(IConnector connector) {
		super(connector);
	}


	public final ISafeTask createSafeTask(IATFTransportContext x) {
		MessageInTask messageInTask = new MessageInTask();
		messageInTask.setTransportContext(x);
		messageInTask.setMessageSerializeHandler(messageSerializeHandler);
		return messageInTask;
	}

	public MessageSerializeHandler getTransportPoolHandler() {
		return messageSerializeHandler;
	}

	public void setTransportPoolHandler(
			MessageSerializeHandler transportPoolHandler) {
		this.messageSerializeHandler = transportPoolHandler;
	}
}
