package org.act.xservices.rt.xcontainer.message;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ASafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.message.handler.MessageValidateHandler;


/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-05-28
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class MessageOutTask extends ASafeTask {
	
	final Logger logger = LoggerFactory.getLogger(MessageOutTask.class);

	private IMessageContext messageContext;
	
	private MessageValidateHandler messagePoolHandler;
	
	public MessageOutTask(){
	}
	
	
	/**
	 * ϢȡϢд
	 */
	public void execute() throws Exception {
		
		//**************************
			logger.debug("*********** Response Message at MessageOutWorker*************");
			if(messageContext.getSoapMessage() != null)
				logger.debug("\n{}", messageContext.getSoapMessage().toFormatXML());
			else
				logger.debug("In-Only MEP");
		//*******************************
		
		//MessagePoolHandler
		if(messageContext.isSOAPFaultMessage()){ //鿴ǷǴϢ
			messagePoolHandler.handlerOutFault(messageContext);
		}else{
			messagePoolHandler.handlerOut(messageContext);
		}
	}

	public void handleException(Throwable exception) {
		System.out.println("exception");
	}

	public void setMessageContext(IMessageContext messageContext) {
		this.messageContext = messageContext;
	}
	
	public void setMessagePoolHandler(MessageValidateHandler messagePoolHandler) {
		this.messagePoolHandler = messagePoolHandler;
	}

}
