package org.act.xservices.rt.xcontainer.message;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.dispatch.ATaskFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ISafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.message.handler.MessageValidateHandler;


/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-05-28
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class MessageOutTaskFactory extends ATaskFactory<IMessageContext> {
	
	private MessageValidateHandler messagePoolHandler;
	
	public MessageValidateHandler getMessagePoolHandler() {
	
		return messagePoolHandler;
	}

	
	public void setMessagePoolHandler(MessageValidateHandler messagePoolHandler) {
	
		this.messagePoolHandler = messagePoolHandler;
	}

	@SuppressWarnings("unchecked")
	public MessageOutTaskFactory(IConnector connector){
		super(connector);
	}

	@Override
	public final ISafeTask createSafeTask(IMessageContext x) {
		MessageOutTask messageOutTask = new MessageOutTask();
		
		messageOutTask.setMessageContext(x);
		messageOutTask.setMessagePoolHandler(messagePoolHandler);
		return messageOutTask;
	}
}
