package org.act.xservices.rt.xcontainer.message.builder;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPMessage;
import org.act.xservices.rt.soap.builder.ISOAPBuilder;
import org.act.xservices.rt.soap.builder.SOAPBuilderFactory;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.inf.context.impl.MessageContextInOutImpl;

public abstract class AMessageBuilder implements IMessageBuilder {

	private String contentType;

	/**
	 * شMessageBuilderֵ֧
	 * 
	 * @return
	 */
	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	/**
	 * ˷᷵null
	 * 
	 * @param transportContext
	 * @return
	 * @throws SOAPException
	 * @throws MetasetParsingException
	 */
	public IMessageContext buildMessageContext(
			IATFTransportContext transportContext) throws SOAPException,
			MetasetParsingException {

		// ʱURIǰ/,"/TestWS"
		IMessageContext messageContext = new MessageContextInOutImpl(
				transportContext);

		// ø
		// messageContext.setVersion(new Integer(11)); //Ŀǰ֧SOAP1.1

		// SOAPEnvelope
		byte[] soapmessage = transportContext.getRequestContent();

		ByteArrayInputStream bin = new ByteArrayInputStream(soapmessage);

		ISOAPBuilder buider = SOAPBuilderFactory.getSOAPBuilder();
		try {
			ISOAPMessage message = buider.readSOAPMessage(bin);
			ISOAPEnvelope soapEnv = message.getSOAPEnvelope();
			bin.close();

			// SOAP Message﷨м򵥵ж
			if (soapEnv == null || !soapEnv.getName().equals("Envelope")
					|| soapEnv.element("Body") == null) {

				// SOAPϢ﷨޷Metaset
				// SOAPϢʽҪʱ(EnvelopeBodyԪ),null
				throw new SOAPException("Error SOAP Message.");
			}

			messageContext.setSoapMessage(soapEnv); // ûпǸʱΪnull
			transportContext.setRequestContent(null);// ע˴ԭʼֽ

		} catch (IOException e) {
			e.printStackTrace();
		}

		return messageContext;

	}

}
