package org.act.xservices.rt.xcontainer.message.handler;

import org.act.xservices.rt.xcontainer.framework.handler.AbstractHandler;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;

/**
 * 
 * 
 * @LastModifyTime 2008-9-8
 * @CreationTime
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class AbstractMessageHandler extends AbstractHandler<IMessageContext>{

	

	public IMessageContext[] handlerIn(IMessageContext context) {
		IMessageContext[] contextArray = doHandlerIn(context);
		IMessageContext temp = null;
		for (int i = 0; i < contextArray.length; i++) {
			temp = contextArray[i];
			//صǴϢش
			if(temp.isSOAPFaultMessage()){
				handlerOutFault(temp);
			}else{
				this.getNextInHandler().handlerIn(temp);
			}

		}
		return contextArray;
	}
	
	protected abstract IMessageContext[] doHandlerIn(IMessageContext context);
	


	public IMessageContext[] handlerInFault(IMessageContext context) {
		IMessageContext[] contextArray = doHandlerInFault(context);
		IMessageContext temp = null;
		for (int i = 0; i < contextArray.length; i++) {
			temp = contextArray[i];
			this.getNextInHandler().handlerInFault(temp);
		}
		return contextArray;
	}

	protected abstract IMessageContext[] doHandlerInFault(IMessageContext context);
	
	
	/**
	 * 
	 */
	public IMessageContext[] handlerOut(IMessageContext context) {
		IMessageContext[] contextArray = doHandlerOut(context);
		IMessageContext temp = null;
		for (int i = 0; i < contextArray.length; i++) {
			temp = contextArray[i];
			//жǷǴϢ
			if(temp.isSOAPFaultMessage()){
				handlerOutFault(temp);
			}else{
				this.getNextOutHandler().handlerOut(temp);
			}
		}
		return contextArray;
	}

	protected abstract IMessageContext[] doHandlerOut(IMessageContext context);
	
	
	/**
	 * 
	 */
	public IMessageContext[] handlerOutFault(IMessageContext context) {
		IMessageContext[] contextArray = doHandlerOutFault(context);
		IMessageContext temp = null;
		for (int i = 0; i < contextArray.length; i++) {
			temp = contextArray[i];
			this.getNextOutHandler().handlerOutFault(temp);
		}
		return contextArray;
	}
	
	protected abstract IMessageContext[] doHandlerOutFault(IMessageContext context);
	
}
