/*
 * @author Lizq [lizq@buaa.edu.cn]
 * May 28, 2007 
 */

package org.act.xservices.rt.xcontainer.message.handler;

import java.io.File;
import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;


public class MessageLogHandler extends AbstractMessageHandler {


	private Logger mesLogger = Logger.getLogger("org.act.ws.message.messageLog");

	protected IMessageContext[] doHandlerIn(IMessageContext context) {
		mesLogger.info(context.getSoapMessage().toXML());
		return new IMessageContext[]{context};
	}

	protected IMessageContext[] doHandlerInFault(IMessageContext context) {
		mesLogger.info(context.getSoapMessage().toXML());
		return new IMessageContext[]{context};
	}

	protected IMessageContext[] doHandlerOut(IMessageContext context) {
		if(context.getSoapMessage() != null) //20080911
			mesLogger.info(context.getSoapMessage().toXML());
		return new IMessageContext[]{context};
	}

	protected IMessageContext[] doHandlerOutFault(IMessageContext context) {
		mesLogger.info(context.getSoapMessage().toXML());
		return new IMessageContext[]{context};
	}

	//
	public void config(IConfigElement handlerconfigElement) {

		this.setHandlerName(handlerconfigElement.getAttribute("name"));
		this.setHandlerDescription(handlerconfigElement.getAttribute("description"));
		
		if (System.getProperty("java.util.logging.config.class") == null
				&& System.getProperty("java.util.logging.config.file") == null) {
			try {
				// жlogFileǷ
				File logFile = new File("logs/messageLogHandler.log");
				if (!logFile.exists()) { // ־ļֱ
					File logDir = new File("logs");
					if (!logDir.exists()) {
						logDir.mkdir();
						logFile.createNewFile();
					} else {
						logFile.createNewFile();
					}
					logDir = null;
				}
				logFile = null;

				// ʼ־ļ
				FileHandler fhandler = new FileHandler("logs/messageLogHandler.log",
						500000, 1, true);
				fhandler.setFormatter(new SimpleFormatter());
				mesLogger.addHandler(fhandler);
				mesLogger.setUseParentHandlers(false);

			} catch (SecurityException e) {
				e.printStackTrace();
			} catch (IOException e) {
				mesLogger.log(Level.SEVERE,"Can't creat log file handler", e);
			}
		}
		
	}
	
	//ر־ļ
	public void destroy() {
		Handler[] handlerList = mesLogger.getHandlers();
		for (int i = 0; i < handlerList.length; i++) {
			handlerList[i].flush();
			handlerList[i].close();
		}
	}

}
