package org.act.xservices.rt.xcontainer.service;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ASafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.service.handler.MessageDispatchHandler;

/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-06-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceInTask extends ASafeTask {

	final Logger logger = LoggerFactory.getLogger(ServiceInTask.class);

	private IMessageContext inMessageContext;

	/** Ϣɷƥ */
	private MessageDispatchHandler messageDispatchHandler;

	public ServiceInTask() {
	}

	/**
	 * IMessageContextServiceObject
	 */
	public void execute() throws Exception {

		// **************************
		logger
				.debug("*********** Received RequestMessage at ServiceInWorker**************");
		logger.debug("\n{}", inMessageContext.getSoapMessage().toFormatXML());
		// ********************************

		messageDispatchHandler.processIn(inMessageContext);
	}

	public void handleException(Throwable exception) {
		// TODO Auto-generated method stub
		System.out.println("exception");
	}

	public void setInMessageContext(IMessageContext inMessageContext) {
		this.inMessageContext = inMessageContext;
	}

	public void setMessageDispatchHandler(
			MessageDispatchHandler messagePoolHandlerS) {
		this.messageDispatchHandler = messagePoolHandlerS;
	}
}
