package org.act.xservices.rt.xcontainer.service;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.dispatch.ATaskFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ISafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.service.handler.MessageDispatchHandler;

/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-06-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceInTaskFactory extends ATaskFactory<IMessageContext>{

	private MessageDispatchHandler messageDispatchHandler;
	
	@SuppressWarnings("unchecked")
	public ServiceInTaskFactory(IConnector connector){
		super(connector);
	}
	
	public final ISafeTask createSafeTask(IMessageContext messageContext) {
		ServiceInTask serviceInExecutable = new ServiceInTask();
		serviceInExecutable.setInMessageContext(messageContext);
		serviceInExecutable.setMessageDispatchHandler(messageDispatchHandler);
		return serviceInExecutable;
	}

	public MessageDispatchHandler getMessagePoolHandler() {
		return messageDispatchHandler;
	}

	public void setMessagePoolHandler(MessageDispatchHandler messagePoolHandler) {
		this.messageDispatchHandler = messagePoolHandler;
	}

}
