package org.act.xservices.rt.xcontainer.service;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ASafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IMessageContext;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.context.impl.ServiceContextInOutImpl;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.WSDL20Constants;
import org.act.xservices.rt.xcontainer.service.handler.ServiceValidationHandler;

/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-06-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceOutTask extends ASafeTask {
	
	final Logger logger = LoggerFactory.getLogger(ServiceOutTask.class);
	
	private IServiceContext serviceContext;
	
	private ServiceValidationHandler serviceValidationHandler;
	
	
	public ServiceOutTask(){
	}
	
	
	/**
	 * ServiceContextServiceObject
	 * ݲͬĽģʽֱдӶֽģʽ
	 */
	public void execute() throws Exception {
		
		// **************************
		logger.debug("************* Response Message at ServiceOutWorker*******************");
				if(serviceContext.getOutMessage() != null)
					logger.debug("\n{}", serviceContext.getOutMessage().toFormatXML());
				else
					logger.debug("In-Only MEP");
		
		
		//ģʽΪInOutʱ
		//עһЩWSDLĵĴ󣬴ʱڴ˴INONLYģʽҲз,д****
		if (serviceContext.getXcOperation().getMepURI().equals(WSDL20Constants.MEP_URI_IN_OUT) ||
				serviceContext.getXcOperation().getMepURI().equals(WSDL20Constants.MEP_URI_IN_ONLY)) {	
			
			ServiceContextInOutImpl serviceContextInOut = (ServiceContextInOutImpl)serviceContext;
			
			//ϢģıϢеSOAPMessage
			IMessageContext outMessageContext = serviceContextInOut.getMessageContext();
			outMessageContext.setSoapMessage(serviceContextInOut.getOutMessage());
			
			if(serviceContextInOut.isFaultOutMessage()){ //SOAPFaultMessage
				outMessageContext.setSOAPFaultMessage(true);
				serviceValidationHandler.handlerOutFault(serviceContextInOut);
				
			}else{ //SOAPӦϢ
				//ϢMessageContextҽıϢеSOAPMessage
				serviceValidationHandler.handlerOut(serviceContextInOut);
			}
		}else{
			//TODO: ݲ֧Ľģʽ
			logger.error("Unsupported Message Exchange Pattern : "
					+serviceContext.getXcOperation().getMepURI());
		}
		
	}//end of execute()

	

	public void handleException(Throwable exception) {
		// TODO Auto-generated method stub
		logger.error("exception on ServiceOutExecutable");
	}

//	public IServiceContext getServiceContext() {
//		return serviceContext;
//	}

	public void setServiceContext(IServiceContext serviceContext) {
		this.serviceContext = serviceContext;
	}

//	public ServiceValidationHandler getServicePoolHandler() {
//		return servicePoolHandler;
//	}

	public void setServiceValidationHandler(ServiceValidationHandler servicePoolHandler) {
		this.serviceValidationHandler = servicePoolHandler;
	}
	
}
