package org.act.xservices.rt.xcontainer.service;

import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.dispatch.ATaskFactory;
import org.act.xservices.rt.xcontainer.framework.dispatch.ISafeTask;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.service.handler.ServiceValidationHandler;

/**
 * @LastModifyTime 2008-7-7
 * @CreationTime 2007-06-20
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ServiceOutTaskFactory extends ATaskFactory<IServiceContext>{

	
	private ServiceValidationHandler servicePoolHandler;
	
	@SuppressWarnings("unchecked")
	public ServiceOutTaskFactory(IConnector connector){
		super(connector);
	}
	
	
	@Override
	public ISafeTask createSafeTask(IServiceContext serviceContext) {
		ServiceOutTask serviceOutTask = new ServiceOutTask();
		serviceOutTask.setServiceContext(serviceContext);
		serviceOutTask.setServiceValidationHandler(servicePoolHandler);

		return serviceOutTask;
	}



	public ServiceValidationHandler getServicePoolHandler() {
		return servicePoolHandler;
	}



	public void setServicePoolHandler(ServiceValidationHandler servicePoolHandler) {
		this.servicePoolHandler = servicePoolHandler;
	}





}
