package org.act.xservices.rt.xcontainer.service.resolver;



import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;

public class SOAPBodyBasedOperationResolver extends AbstractOperationResolver {

	private final static String NAME = "SOAPBodyBasedOperationResolver";
	
	@Override
	protected void init() {
		this.name = NAME;
	}
	
	
	@Override
	public XcOperation findOperation(IServiceContext serviceContext)
			throws ResolverProcessException {
		
		XcService xcService = serviceContext.getXcService();
		
		String reqMesQNameStr = serviceContext.getInMessageBody().getFirstElementLocalName();
		Namespace reqMesQNameNp = serviceContext.getInMessageBody().getFirstElementNS();
		
		if( xcService != null && reqMesQNameStr != null){
			
			return xcService.getXcOperation( new QName(reqMesQNameStr, reqMesQNameNp) );
			
		}else{
			return null;
		}
	}
}
