package org.act.xservices.rt.xcontainer.transport.http;

import org.act.xservices.rt.xcontainer.framework.transport.IStatistical;
import org.apache.mina.transport.socket.SocketAcceptor;


public abstract class AStatisticalTransportReceiver implements IStatistical{
	
	
	public abstract SocketAcceptor getSocketAcceptor();
	
	
	//----------------------ͳϢ-----------------------
    /**
     * ܹյSocket
     * @return
     */
    public long getAcceptedSocketCount() {
        return getSocketAcceptor().getStatistics().getCumulativeManagedSessionCount();
    }
    
	
	/**
	 * ʾͳƹǷ
	 * @return
	 */
	public boolean isThroughputStatisticAvailable(){
		return true;
	}
	

    /**
     * Get average receive speed, in byte/s.
     * ƽٶ
     * 
     * @return average receive speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getReceivedBytes() * 1000.0 / getRunningTimeInMillis();
    	}
        return -1;
    }

    /**
     * Get average send speed, in byte/s.
     * ƽٶ
     * 
     * @return average send speed,or -1 means statistic Function Unavailable.
     */
    public double getAvgSendSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSentBytes() * 1000.0 / getRunningTimeInMillis();
    	}
        return -1;
    }
    
    /**
     * Get instantaneous receive speed, in byte/s.
     * ʵʱĽٶ
     * 
     * @return received speed,or -1 means statistic Function Unavailable.
     */
    public double getReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getReadBytesThroughput();
    	}
        return -1;
    }

    /**
     * Get instantaneous send speed, in byte/s.
     * ʵʱķٶ
     * 
     * @return send speed,or -1 means statistic Function Unavailable.
     */
    public double getSendSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getWrittenBytesThroughput();
    	}
        return -1;
    }
    
    

    /**
     * Get elapsed time after session started and before session closed, in ms.
     * ʱ
     * 
     * @return elapsed time,or -1 means statistic Function Unavailable.
     */
    public long getRunningTimeInMillis() {
    	if(isThroughputStatisticAvailable()){
    		return System.currentTimeMillis() - getSocketAcceptor().getActivationTime();
    	}
        return -1;
    }
    
    /**
     * ôɷԴʱ
     * @return
     */
    public long getStartTimeInMillis(){
    	return getSocketAcceptor().getActivationTime();
    }
    
    
    /**
     * Get received bytes count. If session restart, the value will reset to 0.
     * ֽܹܵ
     * 
     * @return received bytes count,or -1 means statistic Function Unavailable.
     */
    public long getReceivedBytes() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getReadBytes();
    	}
        return -1;
    }

    /**
     * Get sent bytes count. If session restart, the value will reset to 0.
     * ֽܹ
     * 
     * @return sent bytes count,or -1 means statistic Function Unavailable.
     */
    public long getSentBytes() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getWrittenBytes();
    	}
        return -1;
    }


	public double getAvgMessageReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getReceivedMessages() * 1000.0 / getRunningTimeInMillis();
    	}
        return -1;
	}


	public double getAvgMessageSendSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSentMessages() * 1000.0 / getRunningTimeInMillis();
    	}
        return -1;
	}


	public long getLargestManagedSocketCount() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getLargestManagedSessionCount();
    	}
        return -1;
	}


	public double getLargestMessageReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getLargestReadMessagesThroughput();
    	}
        return -1;
	}


	public double getLargestMessageSendSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getLargestWrittenMessagesThroughput();
    	}
        return -1;
	}


	public double getLargestReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getLargestReadBytesThroughput();
    	}
        return -1;
	}


	public double getLargestSendSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getLargestWrittenBytesThroughput();
    	}
        return -1;
	}


	public long getManagedSocketCount() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getCumulativeManagedSessionCount();
    	}
        return -1;
	}


	public double getMessageReceiveSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getReadMessagesThroughput();
    	}
        return -1;
	}


	public long getReceivedMessages() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getReadMessages();
    	}
        return -1;
	}


	public double getSendMessageSpeed() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getWrittenMessagesThroughput();
    	}
        return -1;
	}


	public long getSentMessages() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getWrittenMessages();
    	}
        return -1;
	}


	public int getThroughputCalculationInterval() {
    	if(isThroughputStatisticAvailable()){
    		return getSocketAcceptor().getStatistics().getThroughputCalculationInterval();
    	}
        return -1;
	}


	public void setThroughputCalculationInterval(int throughputCalculationInterval) {
		getSocketAcceptor().getStatistics().setThroughputCalculationInterval(throughputCalculationInterval);
		
	}
    
	
}
