package org.act.xservices.rt.xcontainer.transport.http;

import org.act.xservices.rt.hs.server.ServiceContainer;
import org.act.xservices.rt.hs.server.transport.mina.HttpIoHandler;
import org.act.xservices.rt.xcontainer.transport.http.codec.ATFSingleHttpSessionIoHandler;
import org.apache.mina.core.session.IoSession;
import org.apache.mina.handler.multiton.SingleSessionIoHandler;
import org.apache.mina.handler.multiton.SingleSessionIoHandlerDelegate;
import org.apache.mina.handler.multiton.SingleSessionIoHandlerFactory;

/**
 * չMINAеIoHandler
 * 
 * @LastModifyTime 2008-11-30
 * @CreationTime 2008-11-30
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class ATFHttpIoHandler extends SingleSessionIoHandlerDelegate implements HttpIoHandler {

	/** the default idle time in seconds - 5 minutes */
	public static final int DEFAULT_IDLE_TIME = 300;

	public ATFHttpIoHandler() {
		super(new Factory());
	}

	public ServiceContainer getContainer() {
		return ((Factory) getFactory()).getContainer();
	}

	public void setContainer(ServiceContainer container) {
		((Factory) getFactory()).setContainer(container);
	}

	public void setReadIdle(int idleTime) {
		((Factory) getFactory()).setReadIdle(idleTime);
	}

	private static class Factory implements SingleSessionIoHandlerFactory {
		private ServiceContainer container;

		private int readIdleTime = DEFAULT_IDLE_TIME;

		public ServiceContainer getContainer() {
			return container;
		}

		public void setContainer(ServiceContainer container) {
			this.container = container;
		}

		public void setReadIdle(int idleTime) {
			this.readIdleTime = idleTime;
		}

		public SingleSessionIoHandler getHandler(IoSession session) {
			ATFSingleHttpSessionIoHandler handler = new ATFSingleHttpSessionIoHandler(
					container, session);
			handler.setReadIdleTime(readIdleTime);
			return handler;
		}
	}

}
