package org.act.xservices.rt.xcontainer.transport.http.mina;

import java.net.HttpURLConnection;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.act.xservices.rt.xcontainer.framework.transport.ITransportSender;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.impl.ATFTransportContext;
import org.act.xservices.rt.xcontainer.transport.TransportConstants;
import org.act.xservices.rt.xcontainer.transport.http.Http11TransportProtocol;
import org.act.xservices.rt.xcontainer.transport.http.mina.codec.HTTPTransportSession;
import org.apache.mina.core.future.IoFutureListener;
import org.apache.mina.core.future.WriteFuture;
import org.apache.mina.core.session.IoSession;

/**
 * HTTPЭ鷢
 * 
 * @LastModifyTime 2008-10-11
 * @CreationTime
 * @author Liujian [liujian@act.buaa.edu.cn]
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class HTTPMINATransportSender implements ITransportSender {
	

	/** 
	 * ʹ
	 * @param transportContext
	 * @return
	 */
	public IATFTransportContext send(IATFTransportContext transportContext) throws Exception {

		HTTPTransportSession httpSession = (HTTPTransportSession) transportContext.getATFTransportSession();	
		
		IoSession iosession = (IoSession) httpSession.getIoSession();
		
//		URL url = null;
		String protocolIdentifier = null;

		if (iosession == null) { // ΪգΪ½
//			
//			session = new SocketChannelSession();
//			
//			try {
//
//				url = new URL(transportContext.getUri()); // ȡITransportContextеURIͨͻ˽
//
//				session.setRemoteAddress(new InetSocketAddress(url.getHost(),url.getPort()));
//
//				session.setTransportMEP(TransportConstants.MEP_OUT_IN);
//				
//				protocolName = url.getProtocol();
//
//				session.setTCPSessionHandler(this);
//
//				// 
//				session.start();//ڴ˷channel
//
//			} catch (MalformedURLException e) {
//				e.printStackTrace();
//			}

		} else { // 
			protocolIdentifier = httpSession.getTransportIdentifier();
		}

		// HTTP
		if (protocolIdentifier.equalsIgnoreCase(Http11TransportProtocol.HTTP_TRANSPORT_IDENTIFIER)) {

			ATFTransportContext resObject = build(transportContext);

			boolean keepAlive = "keep-alive".equalsIgnoreCase(
					resObject.getParameter(TransportConstants.HTTP_HEADER_CONNECTION));
			
			WriteFuture writeFuture = iosession.write(resObject);

			if (!keepAlive) {
				writeFuture.addListener( new IoFutureListener<WriteFuture>() {
	                public void operationComplete(WriteFuture future) {
	                	future.getSession().close(false);
	                }
	            });
			}

		}
		
		return transportContext; //˴дǣOut-INģʽӦ÷ITransportSession

	}


	
	private final ATFTransportContext build(IATFTransportContext traObject){

		//if(context.getTransportMEP().equals(TransportConstants.MEP_IN_OUT))
			return buildResponse(traObject);
		//else
		//	return buildRequest(context);
	}
	
//	private final TransportContext buildRequest(
//			ITransportContext context){
//		
//		System.out.println("Error used method HTTP11TransportHandler.buildRequest()");
//		
//		return null;
//	}

	private final ATFTransportContext buildResponse(IATFTransportContext traContext){
        
		
		HTTPTransportSession session = (HTTPTransportSession)traContext.getATFTransportSession();
		
		session.setResponseCode(HttpURLConnection.HTTP_OK);

		switch (session.getResponseCode()) {
			case HttpURLConnection.HTTP_OK:
				session.setReasonPhrase("OK");
				break;
			case HttpURLConnection.HTTP_NOT_FOUND:
				session.setReasonPhrase("Not Found");
				break;
		}
		
		//responseContext.setATFTransportSession(responseSession);
		
		// keep-alive
		boolean keepAlive = "keep-alive".equalsIgnoreCase(
				traContext.getParameter(TransportConstants.HTTP_HEADER_CONNECTION));

		traContext.setParameter("Connection", keepAlive ? "keep-alive" : "close");
		
		traContext.setParameter("Content-Type", traContext.getResponseContentType());
		
		traContext.setParameter("Server", "ACT XServices");  
		traContext.setParameter("Date", new SimpleDateFormat(
                "yyyy-MM-dd 'T' HH:mm:ss zzz").format(new Date()));
		traContext.setParameter("Last-Modified", new SimpleDateFormat(
                "yyyy-MM-dd 'T' HH:mm:ss zzz").format(new Date()));
		
		//עⱨĳȲڱʱӣʹλͷһ

        return (ATFTransportContext)traContext;
	}
}
