package org.act.xservices.rt.xcontainer.transport.http.server;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.Date;

import org.act.xservices.rt.hs.fileservice.index.DirectoryIndexGenerator;
import org.act.xservices.rt.hs.fileservice.mimetype.MimeMap;
import org.apache.mina.core.buffer.IoBuffer;

public class XServiceDirectoryIndexGenerator implements DirectoryIndexGenerator {


	public IoBuffer generateIndex(File curDir, File rootDir) {
		File[] files = curDir.listFiles();
		String curPath = curDir.getAbsolutePath();
		String rootPath = rootDir.getAbsolutePath();
		String relativePath = curPath.substring(rootPath.length())+ File.separator;
		
		String relativeLevel = "";
		for(int i=1; i<relativePath.length(); i++){
			if(relativePath.charAt(i) == File.separator.charAt(0)){
				relativeLevel += "../";
			}
		}

		StringBuilder html = new StringBuilder(1024);
		html.append("<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">");
		html.append("<html><head>");
		html.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
		html.append("<title>XServices - ");
		html.append(curDir.getName());
		html.append("</title><style><!--");
		XServicesCSS.appendToXService(html).append("--></style>");
		html.append("</head></body>\n");
		
		html.append("<div style=\"width:100%; height:63px;\">");
		html.append("<img src='" + relativeLevel + "ROOT/images/xservices_logo.jpg' alt=\"XServices\" id=\"logo\" width=\"188px\" height=\"63px\" /></div>");
		html.append("<div id=\"navigation_bar\">&nbsp;</div>");
		html.append("<h3>"+relativePath+"</h3>");
		
		html.append("<table cellpadding=\"5\"><tr><th width='40%'>");
		html.append("Name").append("</th><th>");
		html.append("Type").append("</th><th>");
		html.append("Size").append("</th><th>");
		html.append("Last modified").append("</th></tr>\n");	
		
		if(!relativePath.equals(File.separator)){
			// back to parent directory
	        html.append("<tr><td><a href=\"..\">").append("Parent Directory");
	        html.append("</a></td><td>DIR</td><td></td><td></td></tr>\n");
		}
		
		for (File file : files) {
            html.append("<tr><td><a href=\"").append(file.getName());
            if (file.isDirectory()) {
                html.append("/");
            }
            html.append("\">");
            html.append(file.getName());
            if (file.isDirectory()) {
                html.append("/");
            }
            html.append("</a></td><td>");
            html.append(getType(file));
            html.append("</td><td>");
            html.append(file.length());
            html.append("</td><td>");
            html.append(new Date(file.lastModified()));
            html.append("</td></tr>\n");
        }

		html.append("</table>\n");
		html.append("<div id=\"footer\"><div id=\"credits\"><a href=\"#\">XServices</a></div></div></body></html>");
		
		IoBuffer out = IoBuffer.allocate(html.length());

		// encodings
		try {
			byte[] bytes = html.toString().getBytes("US-ASCII");
			out.put(bytes);
		} catch (UnsupportedEncodingException e) {
			throw new RuntimeException(e);
		}

		return out;
	}

	private String getType(File file) {
		if (file.isDirectory()) {
			return "DIR";
		}

		String extension = MimeMap.getExtension(file.getName());

		if (extension == null) {
			return "";
		} else {
			return extension.toLowerCase();
		}
	}

	public IoBuffer generateIndex(File directory) {
		return null;
	}

}
