package org.act.xservices.rt.xcontainer.transport.https;

import java.io.IOException;

import org.act.xservices.rt.hs.common.DefaultHttpResponse;
import org.act.xservices.rt.hs.common.HttpResponse;
import org.act.xservices.rt.hs.common.HttpResponseStatus;
import org.act.xservices.rt.hs.common.MutableHttpResponse;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportSender;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;
import org.act.xservices.rt.xcontainer.transport.TransportConstants;
import org.act.xservices.rt.xcontainer.transport.http.codec.ATFHttpTransportSession;
import org.apache.mina.core.buffer.IoBuffer;

/**
 * Send the message to the client
 * @LastModifyTime 2010-6-23
 * @author niyong [niyong@act.buaa.edu.cn]
 *
 * @since jdk1.5
 */
public class HttpsTransportSender implements ITransportSender {
	
	//ͱ
	public IATFTransportContext send(IATFTransportContext transportContext) throws IOException {

		IATFTransportSession atfSession = transportContext.getATFTransportSession();	
		

		if (atfSession == null) { // ΪգҪ½ӣΪOut-Inģʽδʵ
//			
//			session = new SocketChannelSession();
//			
//			try {
//
//				URL url = new URL(transportContext.getUri()); // ȡITransportObjectеURIͨͻ˽
//
//				session.setRemoteAddress(new InetSocketAddress(url.getHost(),url.getPort()));
//
//				session.setTransportMEP(TransportConstants.MEP_OUT_IN);
//				
//				protocolName = url.getProtocol();
//
//				session.setTCPSessionHandler(this);
//
//				// 
//				session.start();//ڴ˷channel
//
//			} catch (MalformedURLException e) {
//				e.printStackTrace();
//			}

		} else { // ,ΪIn-Outģʽ
			
			// HTTP
			if (atfSession.getTransportIdentifier().equalsIgnoreCase(TransportConstants.PROTOCOL_HTTP)) {
				HttpResponse response = buildResponse(transportContext);
				((ATFHttpTransportSession)atfSession).getAtfHttpServiceContext().commitResponse(response);  //Ϣ
			}
		}

		return transportContext; //˴дǣOut-INģʽӦ÷ITransportSession

	}


	
//	private final HttpResponse build(IATFTransportContext atfContext){
//
//		//if(context.getTransportMEP().equals(TransportConstants.MEP_IN_OUT))
//			return buildResponse(context);
//		//else
//		//	return buildRequest(context);
//	}
	
//	private final TransportContext buildRequest(
//			ITransportObject context){
//		
//		System.out.println("Error used method HTTP11TransportHandler.buildRequest()");
//		
//		return null;
//	}

	private final HttpResponse buildResponse(IATFTransportContext context)
	{
		MutableHttpResponse response = new DefaultHttpResponse();
		
		if(context.getResponseContent() == null){
			response.setStatus(HttpResponseStatus.INTERNAL_SERVER_ERROR);
			response.setContent(null);
			
		}else{
			response.setStatus(HttpResponseStatus.OK);
			response.setHeader("Content-Type", context.getResponseContentType());
			response.setContent(IoBuffer.wrap(context.getResponseContent()));
		}
		
        return response;
	}
}
