package org.act.xservices.rt.xcontainer.transport.smtp;

import java.net.URI;

import org.act.xservices.rt.xcontainer.framework.IContainerEnvironment;
import org.act.xservices.rt.xcontainer.framework.objectpool.IDispatchTarget;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportSender;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;
import org.act.xservices.rt.xcontainer.inf.context.impl.ATFTransportContext;

/**
 * 
 * @author Lizq 
 * 2008-1-18
 */
public class SMTPTransportHandler {
	
	
	@SuppressWarnings("unused")
	private IContainerEnvironment _containerEnvironment;
	
	private IDispatchTarget<IATFTransportContext> _inPool;
	
	/**SMTPЭ鷢 */
	@SuppressWarnings("unused")
	private ITransportSender smtpSender;
	
	
	public void setInPool(IDispatchTarget<IATFTransportContext> inPool) {
		this._inPool = inPool;
	}
	
	
	public void setContainerEnvironment(IContainerEnvironment containerContext) {
		this._containerEnvironment = containerContext;
	}
	
	
	public void setTransportSender(ITransportSender smtpSender) {
		this.smtpSender = smtpSender;
	}
	

	
	// ITransportSession  ITransportContext
	public final IATFTransportContext buildTransportContext(IATFTransportSession session) throws Exception {
		
		SMTPTransportSession smtpSession = (SMTPTransportSession) session;
		
		IATFTransportContext transportObject = null;
		
//		if (smtpSession.getTransportMEP().equals(TransportConstants.MEP_IN_OUT)) {
			transportObject = parseRequest(smtpSession);
//		} else {
//			transportObject = parseResponse(smtpSession);
//		}
		
		return transportObject;

	}
	
	
	private final IATFTransportContext parseRequest(SMTPTransportSession smtpSession)throws Exception{
		
		ATFTransportContext smtpObject = new ATFTransportContext();
		
		
		smtpObject.setRequestUri(URI.create(
				(String)smtpSession.getAttribute(SMTPConstants.MAIL_HEADER_SUBJECT)));

		
		smtpObject.setRequestContentType(smtpSession.getContentType());
		smtpObject.setRequestContent(smtpSession.getContent());
		
		smtpSession.setContent(null); //ɵContent
		
		smtpObject.setATFTransportSession(smtpSession);
		
		_inPool.put(smtpObject);
		
		return smtpObject;
		
	}
	
	
//	//ӦϢд
//	private final ITransportObject parseResponse(SMTPTransportSession smtpSession) throws Exception {
//		return null;
//	}
	
}
