package org.act.xservices.rt.xcontainer.transport.smtp;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.IConnector;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.transport.ATransportProtocol;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportReceiver;
import org.act.xservices.rt.xcontainer.framework.transport.ITransportSender;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportContext;
import org.act.xservices.rt.xcontainer.inf.context.IATFTransportSession;

/**
 * 
 * @author Lizq 
 * 2008-1-18
 */
public class SMTPTransportProtocol extends ATransportProtocol {
	
	final Logger logger = LoggerFactory.getLogger(SMTPTransportProtocol.class);
	
	/**SMTPЭʶ */
	public static final String SMTP_TRANSPORT_IDENTIFIER = "SMTP";
	
	/**SMTPЭ鷢 */
	private ITransportSender smtpSender = new SMTPSender();
	
	
	
	public void initialize(IConfigElement transportProtocolConfig, 
			IConnector<IATFTransportSession, IATFTransportContext> connector) throws Exception{
		super.initialize(transportProtocolConfig, connector);

		try {

			// òɷԴ
			IConfigElement[] mailConfigArray = transportProtocolConfig
					.getFirstChildWithName("mails").getChildren();

			for (int i = 0; i < mailConfigArray.length; i++) {
				SMTPTransportDispatchSource smtpTDS = new SMTPTransportDispatchSource();
				
				// ʼ
				smtpTDS.initialize(mailConfigArray[i],this);

				this.getTransportReceiverList().add(smtpTDS); // 
				
			}// end of for

//			// handler Ϣ;
//			IConfigurableElement handlerConfig = configurableElement
//					.findChildConfigurableElement("handler");
//			ITransportHandler handler = (ITransportHandler) Class.forName(
//					handlerConfig.getAttribute("class")).newInstance();
//			setTransportHandler(handler);

		} catch (SMTPSourceException e) {
			e.printStackTrace();
		}
	}

	@Override
	public boolean isOneWay() {

		return true;
	}

	@Override
	public void startup() {
		//ɷԴ
		for (ITransportReceiver tds : this.getTransportReceiverList()) {
			tds.startup();
			logger.info(this.getDescription() +" Startup " + tds.getDescription());
		}
	}

	@Override
	public void shutdown() {
		// TODO Auto-generated method stub
		//رɷԴ
		for (ITransportReceiver tds : this.getTransportReceiverList()) {
			tds.shutdown();
			logger.info("Shutdown " + tds.getDescription());
		}
	}

	@Override
	public String getTransportIdentifier() {
		return SMTP_TRANSPORT_IDENTIFIER;
	}

	public ITransportSender getTransportSender() {
		return smtpSender;
	}

}
