package org.act.xservices.rt.xcontainer.parser.wsdl;

import java.io.File;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;

public abstract class AWSDLParser implements IWSDLParser{

	protected File wsdlFile;
	
	protected XcService xcService;
	
	protected String baseUri;
	

	public AWSDLParser(File wsdlFile){
		this.wsdlFile = wsdlFile;
		this.baseUri = this.wsdlFile.getParentFile().toURI().toString();
	}
	
	
    /**
     * Gets the URI associated with the base document
     * for the WSDL definition.  Note that this URI
     * is for the base document, not the imports.
     * 
     * @return The URI as a String
     */
    public String getBaseUri() {
        return baseUri;
    }

    /**
     * Sets the URI associated with the base document
     * for the WSDL definition.  Note that this URI
     * is for the base document, not the imports.
     * 
     * @param baseUri  The URI as a String
     */
    public void setBaseUri(String baseUri) {
        this.baseUri = baseUri;
    }
}
