package org.act.xservices.rt.xcontainer.wsdl.schemaImpl;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ComplexType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ElementType;
/**
 * 
 * @author viking
 * @date 2010-8-4
 * @since JDK 1.5.0
 * @version 1.0.0
 *
 */
public class ElementTypeImpl extends SchemaTypeImpl implements ElementType {
	private long maxOccurs = 1;
	private boolean nillable = true;
	private boolean group=false;
	private List<QName> types = new ArrayList<QName>();
	private ComplexType complex = null;

	public ElementTypeImpl(String name) {
		super(name);
	}

	public ElementTypeImpl() {
		super();
	}

	public ComplexType getComplex() {
		return this.complex;
	}

	public QName getType() {
		if (types.size() > 0) {
			return types.get(0);
		}
		return null;
	}

	public boolean isSimpleType() {
		if (complex != null) {
			return false;
		}
		return true;
	}

	public void setComplex(ComplexType complex) {
		this.complex = complex;
	}

	public void addType(QName type) {
		types.add(type);
	}

	public boolean isArrayType() {
		if (maxOccurs > 1)
			return true;
		else
			return false;
	}

	public boolean isNillable() {
		return this.nillable;
	}

	public void setMaxOccurs(long maxOccurs) {
		this.maxOccurs = maxOccurs;
	}

	public void setIsNillable(boolean nillable) {
		this.nillable = nillable;
	}

	public long getMaxOccurs() {
		return maxOccurs;
	}

	public List<QName> getTypes() {

		return null;
	}

	public boolean isGroupType() {
		 
		return group;
	}

	public void setGroupType(boolean isGroup) {
		this.group=isGroup;
	}

}
