package org.act.xservices.rt.xcontainer.wsdl.schemaImpl;

import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.MessageSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.OperationSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ServiceSchema;
/**
 * 
 * @author viking
 * @date 2010-8-4
 * @since JDK 1.5.0
 * @version 1.0.0
 *
 */
public class ServiceSchemaImpl implements ServiceSchema {

	private List<OperationSchema> operations = new ArrayList<OperationSchema>();
	private List<MessageSchema> messages = new ArrayList<MessageSchema>();

	public void addOperation(OperationSchema operation) {
		operations.add(operation);
	}

	public MessageSchema getInputMessage(String opName) {
		for (OperationSchema opertation : operations) {
			if (opertation.getName().equals(opName)) {
				return opertation.getInputMessage();
			}
		}
		return null;
	}

	public List<OperationSchema> getOperations() {
		return operations;
	}

	public MessageSchema getOutputMessage(String opName) {
		for (OperationSchema opertation : operations) {
			if (opertation.getName().equals(opName)) {
				return opertation.getOutputMessage();
			}
		}
		return null;
	}

	public MessageSchema getMessageSchema(String messgaeName) {
		for (MessageSchema message : messages) {
			if (message.getName().equals(messgaeName)) {
				return message;
			}
		}
		return null;
	}

	public void addMessageSchema(MessageSchema message) {
		this.messages.add(message);
	}

	public List<MessageSchema> getMessageSchemas() {	 
		return this.messages;
	}

}
