package org.act.xservices.rt.xcontainer.wsdl.utils;

import java.util.List;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcMessage;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ComplexType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ElementType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.MessageSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ServiceSchema;
import org.act.xservices.rt.xcontainer.wsdl.schemaImpl.SchemaAnalyze;

public class ParameterNameUtil {
	public static String[] getResponseArgNames(XcMessage message) {

		String[] responseArgNames = message.getArgNames();
		if (responseArgNames != null) {
			return responseArgNames;
		}
		XcService service = message.getXcOperation().getXcService();
		ServiceSchema serviceSchema = service.getServiceSchema();
		MessageSchema messageSchema = null;
		if (serviceSchema == null) {
			SchemaAnalyze analyze = new SchemaAnalyze(service.getSchema());
			messageSchema = analyze.analyzeMessage(message);
		} else {
			messageSchema = serviceSchema.getMessageSchema(message.getQName()
					.getName());
		}
		if (messageSchema != null) {
			List<ElementType> elements = messageSchema.getAllElements();
			if (elements != null) {
				if (elements.size() > 1) {
					responseArgNames = new String[elements.size()];
				}
				for (int i = 0; i < elements.size(); i++) {
					ElementType element = elements.get(i);
					if (element.isSimpleType()) {
						responseArgNames[i] = element.getName();
					} else {
						ComplexType complex = element.getComplex();
						List<ElementType> args = complex.getElementTypes();
						if (args.size() > 0) {
							responseArgNames = new String[args.size()];
							for (int j = 0; j < args.size(); j++) {
								responseArgNames[j] = args.get(j).getName();
							}
						}
					}
				}
			}
		}

		return responseArgNames;
	}
}
