package org.act.xservices.rt.xcontainer.wsdl.test;

import java.util.List;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ComplexType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ElementType;

public class SchemaAnalyzeBase {

	public static void showElements(List<ElementType> elements, int num) {
		for (ElementType element : elements) {
			showElement(element, num);
		}
	}

	public static void showElement(ElementType element, int num) {		 
		if (element.isSimpleType()) {
			printSpace(num);
			System.out.print(element.getName() + ":-->");	 
			if (element.getMaxOccurs() > 1) {
				System.out.print(" [Array] ");
			}
			System.out.println(element.getType().getLocalPart());
		} else if(element.isGroupType()){
			showElements(element.getComplex().getElementTypes(),num);
		}else {
			printSpace(num);
			System.out.println(element.getName() + ":");
			showComplexSchema(element.getComplex(), num);
		}
	}

	public static void showComplexSchema(ComplexType complex, int num) {
		String name = complex.getName();		
		if (name != null) {		
			printSpace(num);
			System.out.println("<" + name + ">");
		}
		num = num + 3;
		if(complex.getElementTypes().size()>0){
		showElements(complex.getElementTypes(), num);
		}else if(complex.getType()!=null){
			System.out.println(complex.getType().getLocalPart());
		}
		if (name != null) {
			for (int i = 0; i < num - 3; i++) {
				System.out.print(" ");
			}
			System.out.println("</" + name + ">");
		}
	}
	
	private static void printSpace(int num){
		for (int i = 0; i < num; i++) {
			System.out.print(" ");
		}
	}
}
