package org.act.xservices.rt.xcontainer.wsdl.test;

import java.io.File;

import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.MessageSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.OperationSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ServiceSchema;
import org.act.xservices.rt.xcontainer.parser.wsdl.WSDL11ParserUSEWSDL4J;
import org.act.xservices.rt.xcontainer.wsdl.WSDLParseException;

public class ServiceSchemaAnalyze extends SchemaAnalyzeBase {
	public static void showSchema(String filepath) throws WSDLParseException {
		File file = new File(filepath);
		WSDL11ParserUSEWSDL4J parser = new WSDL11ParserUSEWSDL4J(file);
		XcService xservice = parser.parseWSDL();
		ServiceSchema schema = xservice.getServiceSchema();
		showServiceSchema(schema);
	}

	public static void showServiceSchema(ServiceSchema schema) {
		for (OperationSchema op : schema.getOperations()) {
			System.out.println("============ [Operation]"+op.getName()+" start =============");		 

			MessageSchema input = op.getInputMessage();
			if (input != null) {
				System.out.println("[Input]:");
				showElements(input.getAllElements(),1);
			}
			MessageSchema output = op.getOutputMessage();
			if (output != null) {
				System.out.println("[Output]:");
				showElements(output.getAllElements(),1);
			}
			System.out.println("============ [Operation]"+op.getName()+" end =============");
			System.out.println();
			System.out.println();
		}
	}

}
