package org.act.xservice.rt.xcontainer.wsdl2java;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.ClassInfoBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.InOutTypeBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.InOutTemplate;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.MsgRecerierInOutTomplate;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.SkeletonTemplate;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.StubTemplate;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.TestTemplate;
import org.act.xservice.rt.xcontainer.wsdl2java.gentemplate.XmlTemplate;

/**
 * Эɵѡ˳
 * @author orange
 *
 */
public class CodeGenOperator {

	WsdlBean wb;
	ClassInfoBean cib;
	String packageName;
	String stubFoldPath;
	
	public CodeGenOperator(WsdlBean wb, ClassInfoBean cib) {
		this.wb = wb;
		this.cib = cib;
		this.packageName = cib.getPackageName();
		this.stubFoldPath = cib.getStubFoldFullPath();
		
	}

//	private void genSrcFold(){
//		packageAbsoluteLoc = cib.getPackageLocation();
//		File fold = new File(packageAbsoluteLoc);
//		String [] folds = cib.getPackageName().split("\\.");
//		for(int i = 0; i < folds.length; i++){
//			packageAbsoluteLoc += "/"+folds[i];
//			fold = new File(fold, folds[i]);
//			if(!fold.exists()){
//				fold.mkdir();
//			}
//		}
//		
//	}
	
	public void gen(){
		
		//ɴ֮ǰɴļ
		//genSrcFold();//ڲҪˣΪڲѾ
		
		if(cib.isGenClient()){
			String stubClassName = genClient();
			if(cib.isGenTest()){
				genTest(stubClassName);
			}
		}
		if(cib.isGenService()){
			genService();
		}
		
	}
	
	
	private String  genClient(){
		
		StubTemplate stubTemplate = new StubTemplate(wb, packageName);
		String context = stubTemplate.genClass();
		String className = stubTemplate.getClassName();
		String fileFullName = stubFoldPath+"\\"+className +".java";
		write(context, fileFullName);
		
		return className;
	}
	private void genService(){
		SkeletonTemplate st = new SkeletonTemplate(wb, packageName);
		String context = st.genClass();
		String skeletonClassName =st.getClassName();
		String fileFullName = stubFoldPath+"\\"+skeletonClassName +".java";
		write(context, fileFullName);
		
		MsgRecerierInOutTomplate msg = new MsgRecerierInOutTomplate(wb, packageName);
		context = msg.genClass();
		String msgRecerierInOutClassName = msg.getClassName();
		fileFullName = stubFoldPath+"\\"+msgRecerierInOutClassName +".java";
		write(context, fileFullName);
		
		for(InOutTypeBean iotb: wb.getComplexTypes().values()){
			InOutTemplate iot = new InOutTemplate(iotb, packageName,false);
			context = iot.genClassWithImport();
			String className = iotb.getClassName();
			fileFullName = stubFoldPath+"\\"+className +".java";
			write(context, fileFullName);
		}
		
		XmlTemplate xmlTemplate = new XmlTemplate(wb, packageName, skeletonClassName, msgRecerierInOutClassName);
		context = xmlTemplate.genServiceXml();
		fileFullName = getStubSrcFoldPath()+"service.xml";
		write(context, fileFullName);
		
	}
	//ȡstub_src·Աservice.xmlԱservice.xmlļλù
	private String  getStubSrcFoldPath(){
		String [] packs = packageName.split("\\.");
		String pack = "";
		for(String s:packs){
			pack+=s+"\\";
		}
		pack = pack.substring(0,pack.length() - 2);
		String path = stubFoldPath.substring(0,stubFoldPath.lastIndexOf(pack));
		return path;
	}
	private void genTest(String stubClassName){
		TestTemplate testTemplate = new TestTemplate(wb, packageName, stubClassName);
		String context = testTemplate.genClass();
		String className = testTemplate.getTestClassName();
		String fileFullName = stubFoldPath+"\\"+className +".java";
		write(context, fileFullName);
	}
	
	/**
	 * ɵļдӦļ
	 * @param context ɵļ
	 * @param fileAbsolutePath ļľ·
	 */
	private void write(String context, String fileAbsolutePath){
		//String fileAbsolutePath = stubFoldPath+"\\"+className+".java";
		File javaFile = new File(fileAbsolutePath);
		BufferedWriter fw = null;
		try {
			fw = new BufferedWriter(new FileWriter(javaFile));
			fw.write(context);
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(fw != null){
				try {
					fw.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		
		
		
	}
}
