package org.act.xservice.rt.xcontainer.wsdl2java;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.xml.namespace.QName;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.FieldBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.InOutTypeBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;

import org.act.xservices.log.Logger;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ComplexType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ElementType;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.MessageSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.OperationSchema;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.schema.ServiceSchema;
import org.act.xservices.rt.xcontainer.parser.wsdl.WSDL11ParserUSEWSDL4J;
import org.act.xservices.rt.xcontainer.wsdl.WSDLParseException;
import org.apache.ws.commons.schema.XmlSchemaCollection;

/**
 * XcServiceлȡjavaݣ
 * תWsdlBeanԱ
 * 
 * @author ֽ
 *
 */
public class WsdlParserAdapter {
	String wsdlFileloc;
	WsdlBean wb = new WsdlBean();
	String globTargetNamespace; //wsdl ĵtargetnamespace
	Logger logger = Const.logger;
	XmlSchemaCollection schemaCol;
	
	List<ComplexType> analysedComplexTypes;//ֹѭ
	
	/**
	 * @return ȡת
	 */
	public WsdlBean getWsdlBean() {
		return wb;
	}


	public WsdlParserAdapter(String wsdlFileloc) {
		this.wsdlFileloc = wsdlFileloc;
		analysedComplexTypes = new ArrayList<ComplexType>();
		
		//ȡwsdlļ
		wb.setWsdlFileName(wsdlFileloc.substring(wsdlFileloc.lastIndexOf("\\")+1).trim());
		
	}

	/**
	 * ¶ǰwsdlĵĽṹת
	 * 
	 */
	public void parser() {
		logger.debug("**********start parseing to get wsdlBean *************\n");
		
		File file = new File(wsdlFileloc);
		WSDL11ParserUSEWSDL4J parser = new WSDL11ParserUSEWSDL4J(file);
		XcService xservice = null;
		try {
			xservice = parser.parseWSDL();
		} catch (WSDLParseException e) {
			logger.error("", e);
		}
		ServiceSchema schema = xservice.getServiceSchema();
		wb.setServiceName(xservice.getServiceName());

		globTargetNamespace = xservice.getTargetNamespace();
		wb.setTargetNameSpace(globTargetNamespace);
		logger.debug("glob target name spsce = "+globTargetNamespace);
		
		for (OperationSchema op : schema.getOperations()) {
			parseOp(op);
		}
		logger.debug("************* end parseing to get wsdlBean *************\n");
	}

	/**
	 * operation
	 * @param op
	 */
	private void parseOp(OperationSchema op) {
		logger.debug("\n\n***************operation************************");
		String opName = op.getName();
		logger.debug("op name = " + opName);
		OperationBean opb = new OperationBean(wb);
		opb.setOpName(opName);

		MessageSchema input = op.getInputMessage();
		if (input != null) {
			logger.debug("\n\ninput msg name = " + input.getName());
			InOutTypeBean iotb = parseMsg(input);
			if(iotb != null){
				opb.setInClassBean(iotb.getElementName());
			}
		}
		MessageSchema output = op.getOutputMessage();
		if (output != null) {
			logger.debug("\n\noutput msg name = " + output.getName());
			InOutTypeBean iotb = parseMsg(output);
			if(iotb != null){
				opb.setOutClassBean(iotb.getElementName());
			}
		}
		wb.addOperation(opb);
	}
	
	/**
	 * Ϣ
	 */
	private InOutTypeBean parseMsg(MessageSchema schema){
		String msgName = schema.getName();

		InOutTypeBean iotb = new InOutTypeBean();
		
		List<ElementType> elements = schema.getAllElements();
		if (elements.size() > 1) {//϶type
			for(ElementType e: elements){
				parseElement2(e, iotb);
			}
			iotb.setTargetNamespace(globTargetNamespace);
			iotb.setElementName(msgName);
		} else if (elements.size() == 1) {
			ElementType element = elements.get(0);
			
			if (element.isSimpleType()) {
				parseElement2(element, iotb);
				iotb.setTargetNamespace(globTargetNamespace);
				iotb.setElementName(msgName);
			} else {//type  element
				//ﲻparseElementelementеcomplex typeܻûname
				iotb = parseElementOrCompleType(element);
			}
		}else {
			return null;
		}
		wb.addType(iotb.getElementName(), iotb);
		return iotb;
	}
	/**
	 * ֻǷmessageelementcomplex type
	 * @param element
	 * @return
	 */
	private InOutTypeBean parseElementOrCompleType(ElementType element){
		
		InOutTypeBean iotb = new InOutTypeBean();

		ComplexType complexType = element.getComplex();
		if(complexType != null && complexType.getName() != null){
			parseElement2(element, iotb);
			iotb.setElementName(complexType.getName());
		}else{
			List<ElementType> elementTypes = element.getComplex().getElementTypes();
			for(ElementType e: elementTypes){
				parseElement2(e, iotb);
			}
			iotb.setElementName(element.getName());
		}
		
		QName elType = element.getType();
		String nameSpace = element.getType().getNamespaceURI();
		if(iotb.getTargetNamespace() == null){
			iotb.setTargetNamespace(nameSpace);
		}
		
		logger.debug("message name space = " + nameSpace);
		logger.debug("message type  = " + element.getType().getLocalPart());
	
		return iotb;
		
	}
	
	
	/**
	 * 
	 */
	private void parseElement2(ElementType element, InOutTypeBean iotb){
		FieldBean fb = new FieldBean();
		String name = element.getName();
		name = checkName(name);
		fb.setName(name);
		fb.setTypeName(element.getType().getLocalPart());
		iotb.addFieldBean(fb);
		
		if(!element.isSimpleType()){
			InOutTypeBean iotb2 = new InOutTypeBean();
			ComplexType complexType = element.getComplex();
			if(analysedComplexTypes.contains(complexType)){
				return ;
			}else{
				analysedComplexTypes.add(complexType);
			}
			for(ElementType e:complexType.getElementTypes()){
				parseElement2(e, iotb2);//ݹ
			}
			iotb2.setElementName(complexType.getName());
			iotb2.setTargetNamespace(element.getType().getNamespaceURI());
			wb.addType(iotb2.getElementName(), iotb2);
		}
	}

	/**
	 * ΪreturnĲĳreturnArg
	 */
	private String checkName(String name) {
		String temp = name;
		if(name.equalsIgnoreCase("return") ){
			temp += "Arg";
		}
		return temp;
	}
	

	public static void main(String[] a) throws SecurityException,
			NoSuchMethodException {
		WsdlParserAdapter t = new WsdlParserAdapter(
				"src\\main\\resources\\LearnWSDL.wsdl");
		t.parser();

		WsdlBean wBean = t.wb;

		Map<String, InOutTypeBean> aaa = wBean.getComplexTypes();
		Iterator it = aaa.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry<String, InOutTypeBean> entry = (Entry<String, InOutTypeBean>) it
					.next();
			System.out.println("complex type name = " + entry.getKey()
					+ ";  value = " + entry.getValue().getElementName());
		}

		int i = 0;
		i++;

	}
	
	
	
}
