package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;


import org.act.xservice.rt.xcontainer.wsdl2java.bean.FieldBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.InOutTypeBean;
import org.act.xservice.rt.xcontainer.wsdl2java.util.Util;

/**
 * ɸ
 * @author orange
 *
 */
public class InOutTemplate {

	private boolean classStatic = false;
	private InOutTypeBean inOutClassBean;
	private String  packageName;
	private String inOutClassName;
	
	
	public String getInOutClassName() {
		return inOutClassName;
	}

	public InOutTemplate(InOutTypeBean inOutClassBean, String  packageName) {
		this(inOutClassBean, packageName, false);
	}
	
	public InOutTemplate(InOutTypeBean inOutClassBean, String  packageName, boolean classStatic) {
		this.inOutClassBean = inOutClassBean;
		this.packageName = packageName;
		this.classStatic = classStatic;
		
		inOutClassName = Util.upperCaseStringAt(inOutClassBean.getElementName(), 0);//inOutClassBean.getClassName();
	}
	

	private String genQName(){
		String java  ="";
		
		java += "public static final QName MY_QNAME = new QName(\n"+
			"\"" + inOutClassBean.getTargetNamespace() +"\", \""+
			inOutClassBean.getElementName()+"\",\"ns1\");\n";
		//TODO change ns1
		return java;
	}
	
	private String genField(String type, String name ){
		String java = "";
		java += "private "+type+" "+ name+";\n";
		return java;
	}
	
	private  String  genGetsAndSets(String type,String name){
		String java = "";
		String methodName = Util.upperCaseStringAt(name, 0);// name.substring(0,1).toUpperCase() + name.substring(1);
		
		//setter
		java += "public void set"+methodName+"( " + type+" "+name+" ){\n"+
			"this."+name +" = "+name+";\n}\n\n";
		
		//getter
		java += "public "+type+" get"+methodName+"( ){\n"+
			"return "+name+";\n}\n";
		
		return java;
	}
	/**
	 * л
	 * @return
	 */
	private  String genSerialized(){
		String java  = "";
		java +="public Metaset serialize(QName myQname) throws SerializationException {\n"+
			"Metaset response = MetasetBuilder.getInstance().createElement(myQname);\n"+
			"QName partName;\n"+
			"Metaset[] items;\n";
		
		for(FieldBean fb : inOutClassBean.getFieldBeanList()){
			String name = fb.getName();
			java += "partName = new QName(\""+name+"\");\n"+
					"items = JavaObjectSerializeUtil.serializeParameter("+ name+",\""+name+"\",null,  false);\n"+
					"for (Metaset item : items) {\n"+
					"response.add(item);\n"+
					"}\n";
		}
		java+= "return response;\n" +
				"}\n";	
		
		return java;	
	}

	/**
	 * ɷл
	 * @return
	 */
	private String genDeserialize(){
		String java  = "";
		String objName = Util.lowerCaseStringAt(inOutClassName, 0);
		java +="public "+inOutClassName +" deserialize(Metaset param)\n"+
			"throws DeserializationException {\n"+
			inOutClassName+" "+objName+" = new "+inOutClassName+"();\n"+
			"List<Metaset> items = param.elements();\n"+
			"for (int i = 0; i < items.size();) {\n"+
			"Metaset[] params = JavaObjectDeserializeUtil.getSameItems(i, items);\n"+
			"i = +params.length;\n"+
			"Object arg;\n";
		
		for(FieldBean fb : inOutClassBean.getFieldBeanList()){
			//TODO
			String fieldName = fb.getName();
			String fielType = fb.getTypeClassName();
			java += "arg = JavaObjectDeserializeUtil.deserializeParameter(\n"+
						"params,"+fielType+".class, null);\n";
			
			java += "this.set"+Util.upperCaseStringAt(fieldName, 0)+"(("+fielType+") arg );\n";
		}
		
		java += "}\n" +
			"return this;\n" +
			"}\n";
		
		return java;
	}
	
	public InOutTypeBean getClassFileBean() {
		return inOutClassBean;
	}

	public void setClassFileBean(InOutTypeBean classFileBean) {
		this.inOutClassBean = classFileBean;
	}
	
	private String genPackImport(){
		String java = "";
		java += "package "+packageName+";\n\n"+
			"import java.util.List;\n"+
			"import org.act.xservices.rt.metaset.MetasetBuilder;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.DeserializationException;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.SerializationException;\n"+
			"import org.act.xservices.rt.xcontainer.util.JavaObjectDeserializeUtil;\n"+
			"import org.act.xservices.rt.xcontainer.util.JavaObjectSerializeUtil;\n"+
			"import org.act.xservices.rt.xom.Metaset;\n"+
			"import org.act.xservices.rt.xcontainer.xdb.XDBBean;\n"+
			"import org.act.xservices.rt.xom.QName;\n\n";
					
		return java;
	}
	
	private String genGetMyQname(){
		String java ="";
		java +="public QName getMyQName() {\n"+
			"return this.MY_QNAME;\n"+
			"}\n";
		return java;
	}
	
	public String genClassWithImport(){
		String java = "";
		java += genPackImport();
		java += genClassWithoutImport();
		return java ;
	}

	/**
	 * stubڲ࣬ûimport
	 * @return
	 */
	public String genClassWithoutImport(){
		String java = "";
		String staticString = "";
		if(classStatic)
			staticString = "static";
		java += "public "+staticString+" class "+inOutClassName+" implements XDBBean {\n";
		java += genQName();
		for(FieldBean fb:inOutClassBean.getFieldBeanList()){
			java += genField(fb.getTypeClassName(), fb.getName());
			java += genGetsAndSets(fb.getTypeClassName(), fb.getName());
		}
		java += genSerialized();
		java += genDeserialize();
		java += genGetMyQname();
		java +="}\n";
		return java ;
	}
}
