package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
import org.act.xservice.rt.xcontainer.wsdl2java.util.Util;

/**
 * 
 * @author ֽ
 *
 */
public class MsgRecerierInOutTomplate {

	private WsdlBean wb;
	private String  packageName;
	private String className;

	public String getClassName() {
		return className;
	}

	public MsgRecerierInOutTomplate(WsdlBean wb, String packageName) {
		this.wb = wb;
		this.packageName = packageName;
		this.className = Util.upperCaseStringAt(wb.getServiceName(),0)+"MessageRecerierInOut";
	}

	/*
	public String genFromMetaset(){
		String java = "";
		java +="private java.lang.Object fromMetaset(Metaset param, java.lang.Class<?> type) {\n"+
			"	try {\n";
		List<OperationBean> ops = wb.getOperations();
		for(OperationBean op:ops){
			if(op.isInExist()){
				java +="if("+op.getInClassBean().getClassName()+".class.equals(type)){\n"+
					"return "+op.getInClassBean().getClassName()+".deserialize(param);\n" +
					"}\n";
			}
			if(op.isOutExist()){
				java +="if("+op.getOutClassBean().getClassName()+".class.equals(type)){\n"+
					"return "+op.getOutClassBean().getClassName()+".deserialize(param);\n" +
					"}\n";
			}
		}
		java += "	} catch (Exception e) {\n"+
				"		throw new RuntimeException(e);\n"+
				"	}\n"+
				"	return null;\n" +
				"}";
		return java ;
	}
	public String genToEnvelope(String outClassName){
		String java = "";
		java += "private ISOAPEnvelope toEnvelope(SOAPFactory factory, "+outClassName+" param)\n"+
			"throws SerializationException {\n"+
			"ISOAPEnvelope emptyEnvelope = factory.getDefaultEnvelope();\n"+
			"Metaset bodycontent = param.serialize("+outClassName+".MY_QNAME);\n"+
			"emptyEnvelope.getBody().add(bodycontent);\n"+
			"return emptyEnvelope;\n"+
			"}";
		
		return java ;
	}
	
	public String genSoapFactory() {
		String java = "";
		java +="private SOAPFactory getSOAPFactory(IServiceContext serviceContext)\n"+
			"			throws ProviderProcessException {\n"+
			"	String nsURI = serviceContext.getInMessage().getNamespaceURI();\n"+
			"	if (SOAP12Constants.SOAP_ENVELOPE_NAMESPACE_URI.equals(nsURI)) {\n"+
			"		return SOAPFactory.getSOAP11Factory();\n"+
			"	} else if (SOAP11Constants.SOAP_ENVELOPE_NAMESPACE_URI.equals(nsURI)) {\n"+
			"		return SOAPFactory.getSOAP11Factory();\n"+
			"	} else {\n"+
			"		throw new ProviderProcessException(\"invalidSOAPversion\");\n"+
			"	}\n"+
			"}\n";
		
		return java ;
	}
	*/
	
	//TODO ж޲
	public String genInvokeBusinessLogic(){
		String skeletonClassName = Util.upperCaseStringAt(wb.getServiceName(),0)+"Skeleton"; 
		String java = "";
		
		java += "protected IServiceContext invokeBusinessLogic(IServiceContext serviceContext)\n"+
			"throws ProviderProcessException, ServiceProcessException {\n"+
			"Object implClass = getImplementationObject(serviceContext.getXcService());\n"+
			skeletonClassName+" skel = ("+skeletonClassName+") implClass;\n"+
			"ISOAPEnvelope envelope = null;\n"+
			"XcOperation xcOperation = serviceContext.getXcOperation();\n"+
			"if (xcOperation == null) {\n"+
			"	throw new ProviderProcessException(\n"+
			"		\"Operation is not located, if this is doclit style the SOAP-ACTION should specified via the SOAP Action to use the RawXMLProvider\");\n"+
			"}\n"+
			"java.lang.String methodName;\n"+
			"if (xcOperation.getQName() != null\n"+
			"	&& (methodName = JavaUtils.xmlNameToJava(xcOperation.getQName().getName())) != null) {\n"+
			"Metaset content = serviceContext.getInMessageBody().getFirstElement();\n";
		
		for(OperationBean op:wb.getOperations()){
			java += "if(\""+op.getOpName()+"\".equals(methodName)) {\n";
				if(op.isOutExist()){
					java += op.getOutClassBean().getClassName()+" response = null;\n" +
//							op.getInClassBean().getClassName()+ " newOperation = ("+op.getInClassBean().getClassName()+") fromMetaset(content, "+op.getInClassBean().getClassName()+".class);\n"+
							
							"try{";
							if(op.isInExist()){
								java += op.getInClassBean().getClassName()+ " newOperation = new "+op.getInClassBean().getClassName()+"().deserialize(content);\n"+
								"response = skel.NewOperation(newOperation);\n";
							}
							else {
								java +="response = skel.NewOperation();\n";
							}
							java +="envelope = toEnvelope(getSOAPFactory(serviceContext),	response);\n"+
							"} catch (SerializationException e) {\n"+
							"	throw new ServiceProcessException(e);\n"+
							"}\n";
							if(op.isInExist()){
								java +=" catch (DeserializationException e) {\n"+
								"	throw new ServiceProcessException(e);\n"+
								"}";
							}
				}
			java += "}\n";
		}
		java += "}\n";
		java +="serviceContext.setOutMessage(envelope);\n"+
			"return serviceContext;\n"+
			"}\n";
		return java ;
	}
	
	
	

	private String genPackImport(){
		String java = "";
		java += "package "+packageName+";\n\n"+
			"import org.act.xservices.rt.soap.ISOAPEnvelope;\n"+
			"import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;\n"+
			"import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;\n"+
			"import org.act.xservices.rt.xcontainer.framework.util.JavaUtils;\n"+
			"import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;\n"+
			"import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.DeserializationException;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.SerializationException;\n"+
			"import org.act.xservices.rt.xcontainer.xdb.MessageReceiveInOut;\n"+
			"import org.act.xservices.rt.xom.Metaset;\n\n";
		
		return java;
	}
	
	public String genClass(){
		String java = "";
		java += genPackImport();
		java += "public class "+className+" extends MessageReceiveInOut{\n";
		java += genInvokeBusinessLogic();
//		java += genFromMetaset();
//		for(OperationBean op:wb.getOperations()){
//			if(op.isOutExist()){
//				java +=genToEnvelope(op.getOutClassBean().getClassName());
//			}
//		}
//		java += genSoapFactory();
		java +="}\n";
		return java;
	}
	
}
