package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
import org.act.xservice.rt.xcontainer.wsdl2java.util.Util;

public class SkeletonTemplate {

	WsdlBean wb;
	String  packageName;
	String className;
	
	public String getClassName() {
		return className;
	}

	public SkeletonTemplate(WsdlBean wb, String  packageName) {
		this.wb = wb;
		this.packageName = packageName;
		className = Util.upperCaseStringAt(wb.getServiceName(),0) + "Skeleton";
	}

	public String genSkeleton(){
		String java = "";
		
		java += "public class "+className+"{\n";
		for (OperationBean op : wb.getOperations()) {
			java += "public " ;
			if(op.isOutExist()){
				java += op.getOutClassBean().getClassName()+" ";
			}else {
				java += " void ";
			}
			java += " NewOperation(";
			if(op.isInExist()){
				java += op.getInClassBean().getClassName() + " arg";
			}
			java += ")\n{";
			java += "throw  new RuntimeException();\n"+
				"}\n";
		}
		java += "}\n";
		return java;
	}
	public String genClass(){
		String java ="";
		java += "package "+ packageName+";\n\n";
		java += genSkeleton();
		return java ;
	}
}
