package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;

import java.util.List;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.InOutTypeBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
import org.act.xservice.rt.xcontainer.wsdl2java.util.Util;

/**
 * stubͻ˴
 * @author ֽ
 *
 */
public class StubTemplate {

	private WsdlBean wb;
	private String packageName;
	private String stubClassName;
	
	
	public StubTemplate(WsdlBean wb, String packageName) {
		this.wb = wb;
		this.packageName = packageName;
		stubClassName = Util.upperCaseStringAt(wb.getServiceName(), 0)+"Stub";
	}
	
	public String getClassName(){
		return stubClassName;
	}
	
	public String genConstruct(){
		String java = "";
		
		java += "private ServiceClient serverClient;\n"+
			"public "+stubClassName+"() {\n"+
			"	this(\"http://www.example.org/\");\n"+
			"}\n"+	
			"public "+stubClassName+"(String uri) {\n"+
			"	serverClient = new ServiceClient(uri);\n"+
			"}\n";
		
		//TODO ûɲ
		for(OperationBean op: wb.getOperations()){
			if(op.isOutExist()){
				boolean inExist = op.isInExist();
				java += "public "+op.getOutClassBean().getClassName()+" "+ op.getOpName()+"(";
				if(inExist){
					java +=op.getInClassBean().getClassName()+" in";
				}
				java +=")\n" +
						"throws SerializationException,XServicesException {\n";
				if(inExist){
					java+="Metaset request = in.serialize(in.getMyQName());\n"+
						"Metaset response = serverClient.sendReceive(request);\n";
				}else {
					
					java +="QName opname=new QName(\""+wb.getTargetNameSpace()+"\",\""+op.getOpName()+"\");\n"+
						"Metaset playload=JavaObjectSerializeUtil.serializeJavaObject(opname, new Object[]{}, null, false);\n"+
						"Metaset response = serverClient.sendReceive(playload);\n";
				}
						
					java +="Object obj ;\n"+
						"try {\n"+
						"	obj = new "+op.getOutClassBean().getClassName()+"().deserialize(response);\n"+
						"} catch (DeserializationException e) {\n"+
						"	throw new XServicesException(e);\n"+
						"}\n"+
						"return ("+op.getOutClassBean().getClassName()+") obj;\n"+
						"}\n";
			}
		}
		
		return java;
	}

//	public String genFromMetaset(){
//		String java = "";
//		java +="private java.lang.Object fromMetaset(Metaset param, java.lang.Class<?> type) {\n"+
//			"	try {\n";
//		List<OperationBean> ops = wb.getOperations();
//		for(OperationBean op:ops){
//			if(op.isInExist()){
//				java +="if("+op.getInClassBean().getClassName()+".class.equals(type)){\n"+
//					"return "+op.getInClassBean().getClassName()+".deserialize(param);\n" +
//					"}\n";
//			}
//			if(op.isOutExist()){
//				java +="if("+op.getOutClassBean().getClassName()+".class.equals(type)){\n"+
//					"return "+op.getOutClassBean().getClassName()+".deserialize(param);\n" +
//					"}\n";
//			}
//		}
//		java += "	} catch (Exception e) {\n"+
//				"		throw new RuntimeException(e);\n"+
//				"	}\n"+
//				"	return null;\n" +
//				"}";
//		return java ;
//	}
	/**
	 * еĸڲ
	 */
	public String genInnerClass(){
		String java ="";
		
		for(InOutTypeBean iotb: wb.getComplexTypes().values()){
			InOutTemplate iot = new InOutTemplate(iotb, packageName,true);
			java += iot.genClassWithoutImport();
		}
		
		return java;
	}

	private String  genPackImport(){
		String java = "";
		java += "package "+packageName+";\n";
		java +="import java.util.List;\n"+
			"import org.act.xservices.rt.client.ServiceClient;\n"+
			"import org.act.xservices.rt.client.XServicesException;\n"+
			"import org.act.xservices.rt.metaset.MetasetBuilder;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.DeserializationException;\n"+
			"import org.act.xservices.rt.xcontainer.rpc.SerializationException;\n"+
			"import org.act.xservices.rt.xcontainer.util.JavaObjectDeserializeUtil;\n"+
			"import org.act.xservices.rt.xcontainer.util.JavaObjectSerializeUtil;\n"+
			"import org.act.xservices.rt.xcontainer.xdb.XDBBean;\n"+
			"import org.act.xservices.rt.xom.Metaset;\n"+
			"import org.act.xservices.rt.xom.QName;\n";
		return java;
	}
	
	public String genClass(){
		String java = "";
		java += genPackImport();
		java +="public class "+stubClassName+"{\n";
		java += genConstruct();
//		java += genFromMetaset();
		java += genInnerClass();
		java += "}\n";
		
		return java;
	}
}
