package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;

import java.util.ArrayList;
import java.util.List;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.FieldBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.InOutTypeBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
import org.act.xservice.rt.xcontainer.wsdl2java.util.Util;

public class TestTemplate {

	private WsdlBean wb;
	private String  packageName;
	private String TestClassName;
	private String stubFullName;
	
	private String stubClassName;
	
	public TestTemplate(WsdlBean wb,String  packageName, String stubClassName){
		this.wb = wb;
		this.packageName = packageName;
		this.stubClassName = stubClassName;
		TestClassName = Util.upperCaseStringAt(wb.getServiceName(), 0)+"Test";
		stubFullName = packageName+"."+stubClassName;
	}
	public String getTestClassName() {
		return TestClassName;
	}
	private String genImportPack(){
		String java = "";
		java+= "package "+packageName+";\n";
		
		return java;
	}
	
	public String genClass(){
		getStubInnerClasses();
		
		String java = "";
		java += genImportPack();
		java += "public class "+ TestClassName+"{\n";
		
		java += genMain();
		java += genGetObjClass();
		java += genOp();
		
		java += "}\n";
		
		
		return java;
	}
	private List<String >stubInnerClasses = new ArrayList<String>();
	private void getStubInnerClasses(){
		for(InOutTypeBean iotb:wb.getComplexTypes().values()){
			stubInnerClasses.add(iotb.getClassName());
		}
	}
	private String getStubInnerClassFulName(String typeName){
		if(stubInnerClasses.contains(typeName)){
			return stubFullName+"."+typeName;
		}
		return typeName;
	}
	private String genOp() {
		String java = "";

		for(OperationBean op : wb.getOperations()){
			
			FieldBean outfb = op.getOutClassBean().getFieldBeanList().get(0);
			java += "public "+getStubInnerClassFulName(outfb.getTypeClassName())+" "+op.getOpName()+"(";
			
			String temp = "";
			if(op.isInExist()){
				for(FieldBean infb : op.getInClassBean().getFieldBeanList()){
					temp += ", "+getStubInnerClassFulName(infb.getTypeClassName())+" "+infb.getName();
				}
				java +=temp.substring(1);
			}
			java += ")throws java.lang.Exception {\n";
			String inbeanName = "";
			if(op.isInExist()){
				java += "String uri = \""+op.getInClassBean().getTargetNamespace()+"\";\n"+
				stubClassName+" stub = new "+stubClassName+"(uri);\n";
				String inbeanClass = stubClassName + "."+op.getInClassBean().getClassName();
				inbeanName= " request";
				java += inbeanClass + inbeanName + " = ("+inbeanClass+")getTestObject("+inbeanClass+".class);\n";
			}else{
				java += "String uri = \""+wb.getTargetNameSpace()+"\";\n"+
				stubClassName+" stub = new "+stubClassName+"(uri);\n";
			}
			
			
			temp = "";
			if(op.isInExist()){
				for(FieldBean infb : op.getInClassBean().getFieldBeanList()){
					temp += inbeanName+".set"+Util.upperCaseStringAt(infb.getName(), 0)+"("+infb.getName()+");\n";
				}
			}
			
			java += temp;
			java += stubClassName+"."+op.getOutClassBean().getClassName()+" response = stub."+op.getOpName()+"("+inbeanName+");\n"+
					"return response.get"+Util.upperCaseStringAt(outfb.getName(), 0)+"();\n"+
					"}\n";
			
		}
		
		return java;
	}

	private String genMain(){
		String java = "";
		
		java +="public static void main(String[] args) throws Exception {\n"+
				TestClassName+" test = new "+TestClassName +"();\n"+
				"//TODO call the function yourself\n";
//		int i = 0;
//		for(OperationBean op:wb.getOperations()){
//			FieldBean outfb = op.getOutClassBean().getFieldBeanList().get(0);
//			java +=  outfb.getTypeClassName()+" ret"+i+"= test."+op.getOpName()+"();\n";
//			i ++;
//		}
		java+= "}\n";
		
		return java;
	}
	private String genGetObjClass(){
		String java = "";
		
		java +="public Object getTestObject(Class<?> type) throws Exception {\n"+
			"return  type.newInstance();\n"+
			"}\n";
		
		return java;
	}
	
}
