package org.act.xservice.rt.xcontainer.wsdl2java.gentemplate;

import org.act.xservice.rt.xcontainer.wsdl2java.bean.OperationBean;
import org.act.xservice.rt.xcontainer.wsdl2java.bean.WsdlBean;
/**
 * service.xmlļ
 * @author ֽ
 *
 */
public class XmlTemplate {

	public XmlTemplate(WsdlBean wb, String packageName,
			String skeletonClassName, String mesgInoutClassName) {
		this.wb = wb;
		this.wsdlFileName = wb.getWsdlFileName();
		this.packageName = packageName;
		this.skeletonClassName = skeletonClassName;
		this.mesgInoutClassName = mesgInoutClassName;
	}

	WsdlBean wb;

	String wsdlFileName;
	String packageName;
	String skeletonClassName;
	String mesgInoutClassName;

	
	public String genServiceXml(){
		String java = "";
		java +="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"+
			"<service WSDLLocation=\""+wsdlFileName+"\" scope=\"Request\""+
			" serviceName=\""+wb.getServiceName()+"\"\n" +
			" xmlns=\"http://act.buaa.edu.cn/soap/wsdd\"\n"+
			" xmlns:xsi=\"http://www.w3.org/2000/10/XMLSchema-instance\"\n"+
			" xsi:schemaLocation=\"http://act.buaa.edu.cn/soap/wsdd/schema.xsd\">\n"+
			
			"<description>"+wb.getServiceName()+"</description>";
		java +="<transports>\n"+
			"	<transport Type=\"http\">\n"+
			"		<parameter name=\"URLPattern\">/"+wb.getServiceName()+"</parameter>\n"+
			"	</transport>\n"+
			"</transports>\n";
		
		java += "<parameter name=\"ServiceClass\">"+packageName+"."+skeletonClassName+"</parameter>\n";
		java += genProvider();
		java += operation();
		
		java += "</service>\n";
		return java;
	}

	private String genProvider() {
		String java = "";
		java += "	<providers>\n"+
				"<provider type=\"XDBInOutProvider\"\n"+
			"mep=\"http://www.w3.org/2004/08/wsdl/in-out\"\n"+
			"class=\""+packageName+"."+mesgInoutClassName+"\" />\n"+
			"</providers>\n";
		return java;
	}

	private String operation() {
		String java = "";
		java +="<operations>\n";
		for(OperationBean opb: wb.getOperations()){
			java +="<operation name=\""+opb.getOpName() +"\">\n"+
				"	<actionMapping>urn:"+opb.getOpName() +"</actionMapping>\n"+
				"	<provider>XDBInOutProvider</provider>\n"+
				"</operation>\n";
		}
		java +="</operations>\n";
		return java;
	}
}
