package org.act.xservices.rt.xcontainer.rpc.receivers;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.provider.AbstractInProvider;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.rpc.util.RPCProcessInvokeUtil;

/**
 * 
 * @author viking
 * @date 2010-6-27
 * @since JDK 1.5.0
 * @version 1.0.0
 * 
 *          This provider is used for InOnly soap message request. 
 */
public class RPCInOnlyMessageProvider extends AbstractInProvider {

	@Override
	public IServiceContext invokeBusinessLogic(IServiceContext serviceContext)
			throws ProviderProcessException, ServiceProcessException {
		Logger log = LoggerFactory.getLogger(RPCInOnlyMessageProvider.class);
		log.debug("InOnly Service process has began...");
		// get the Web Service implementation instance class
		Object implClass = getImplementationObject(serviceContext
				.getXcService());

		if (implClass == null) {
			log.error("The service implemetation class instance is null.");
		} else {
			log
					.debug("Got the service implemetation class instance. Now invoking...");
		}

		RPCProcessInvokeUtil.invokeBusinessLogic(serviceContext, implClass,
				true);
		log.debug("The service has invoked.");
		// This is a InOnly web service,so there is no response soap
		// message.
		serviceContext.setOutMessage(null);
		return serviceContext;
	}
}
