package org.act.xservices.rt.xcontainer.rpc.receivers;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.framework.provider.AbstractInOutProvider;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.rpc.util.RPCProcessInvokeUtil;
import org.act.xservices.rt.xcontainer.rpc.util.RPCProcessResponseUtil;

/**
 * 
 * @author viking
 * @date 2010-6-27
 * @since JDK 1.5.0
 * @version 1.0.0
 * 
 *  This class is used for InOut soap message request.
 */

public class RPCInOutMessageProvider extends AbstractInOutProvider {

	@Override
	protected IServiceContext invokeBusinessLogic(IServiceContext serviceContext)
			throws ProviderProcessException, ServiceProcessException {
		Logger log = LoggerFactory.getLogger(RPCInOutMessageProvider.class);
		log.debug("InOut Service process has began...");
		// get the implementation class for the Web Service
		Object implClass = getImplementationObject(serviceContext
				.getXcService());
		
		if (implClass == null) {
			log.error("The service implemetation class instance is null.");
		} else {
			log
					.debug("Got the service implemetation class instance. Now invoking...");
		}		
		Object resObject = RPCProcessInvokeUtil.invokeBusinessLogic(
				serviceContext, implClass, false);
        log.debug("The service has invoked, and now it is deserializing the result.");
		return RPCProcessResponseUtil.processResonse(serviceContext, resObject);
	}
}
