package org.act.xservices.rt.xcontainer.xdb;

import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.xcontainer.framework.provider.AbstractInOutProvider;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.rpc.SerializationException;
import org.act.xservices.rt.xom.Metaset;

public abstract class MessageReceiveInOut extends AbstractInOutProvider {

	/**
	 * Get the soap factory.If it is a soap1.1 soap message then return
	 * SOAP11Factory. If it is a soap1.2 message then return
	 * SOAP12Factory,otherwise throw a ProviderProcessException
	 * 
	 * @param serviceContext
	 * @return
	 * @throws ProviderProcessException
	 */
	public SOAPFactory getSOAPFactory(IServiceContext serviceContext){
		String nsURI = serviceContext.getInMessage().getNamespaceURI();
		 return SOAPFactory.getSOAPFactory(nsURI);
	}

	public ISOAPEnvelope toEnvelope(SOAPFactory factory, XDBBean param)
			throws SerializationException {
		ISOAPEnvelope emptyEnvelope = factory.getDefaultEnvelope();
		Metaset bodycontent = param.serialize(param.getMyQName());
		emptyEnvelope.getBody().add(bodycontent);

		return emptyEnvelope;
	}
}
