package org.act.xservices.rt.xnotification;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.act.xservices.rt.xnotification.base.INotificationPublisher;
import org.act.xservices.rt.xnotification.broker.INotificationBroker;
import org.act.xservices.rt.xnotification.topic.expression.TopicCompileEngine;

/**
 * ʱ,͹رWS-Nϵͳ
 * 
 * @version 1.0 2006-6-14
 * @author cover_eye wangyg@act.buaa.edu.cn
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class WSNRuntime {

	//private ConfigManager configManager = null;

	private TopicCompileEngine topicEngine = null;

	private NotifyMessageBus notifyMessageBus;
	
	//עӳ
	private Map<String, INotificationPublisher> publisherMap = 
		new ConcurrentHashMap<String, INotificationPublisher>();
	
	//֪ͨ עӳ
	private Map<String, INotificationBroker> brokerMap = 
		new ConcurrentHashMap<String, INotificationBroker>();
	
	
	
	private WSNRuntime() {
		start();
	}
	
	private static WSNRuntime instance = new WSNRuntime();

	public static WSNRuntime getRuntime() {
		return instance;
	}

	
	public void start() {
		
		//System.out.println("---WSNRuntime---WSNRuntime Start");
		
//		// 
//		configManager = new ConfigManager("path to be added");
//		// configManager.getConfigcontext();
		
		// 
		//System.out.println("---WSNRuntime---");
		this.topicEngine = TopicCompileEngine.getTopicEngine();
		
		// Ϣ
		//System.out.println("---WSNRuntime---Ϣ");
		this.notifyMessageBus = NotifyMessageBus.getNotifyMessageBus();
		
	}

	/*
	 * лĹ
	 */
	public void stop() {
	}

	
	public INotificationPublisher registerPublisher(String wsAddress, INotificationPublisher publisher){
		
		System.out.println("---class-WSNRuntime--registerPublisher "+ wsAddress);	
		return publisherMap.put(wsAddress, publisher);
	}
	
	public INotificationPublisher unRegisterPublisher(String wsAddress){
		System.out.println("---class-WSNRuntime---unRegisterPublisher "+ wsAddress);
		return publisherMap.remove(wsAddress);
	}
	
	public INotificationPublisher getPublisherByAddress(String wsAddress){
		return publisherMap.get(wsAddress);
	}
	
	
	public INotificationBroker registerBroker(String wsAddress, INotificationBroker broker){
		System.out.println("---class---WSNRuntime---registerBroker "+ wsAddress);
		return brokerMap.put(wsAddress, broker);
	}
	
	public INotificationBroker unRegisterBroker(String wsAddress){
		System.out.println("---class---WSNRuntime---unRegisterBroker "+ wsAddress);
		return brokerMap.remove(wsAddress);
	}
	
	public INotificationBroker getBrokerByAddress(String wsAddress){
		return brokerMap.get(wsAddress);
	}
	
	
	

	/**
	 * @return  topicEngine
	 */
	public TopicCompileEngine getTopicEngine() {
		return topicEngine;
	}

	/**
	 * @return  notifyMessageBus
	 */
	public NotifyMessageBus getNotifyMessageBus() {
		return notifyMessageBus;
	}

}
