package org.act.xservices.rt.xnotification.base;

import org.act.xservices.rt.xnotification.topic.ITopic;
import org.act.xservices.rt.xnotification.topic.exception.TopicExpressionException;
import org.act.xservices.rt.xnotification.topic.expression.ITopicExpression;
import org.act.xservices.rt.xnotification.topic.expression.TopicExpression;

/**
 * ⼯ӿ
 * ʾֵ֧
 * 
 * @version 1.0 2008-3-3
 * @author cover_eye wangyg@act.buaa.edu.cn 2007-7-25
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface IPublisherTopicSet {
	/**
	 * Sets the boolean that indicates if this topic set is fixed as defined 
	 * by the WS-BaseNotification specification.
	 *
	 * @param fixed
	 */
	public void setFixed(boolean fixed);

	/**
	 * Returns a boolean that indicates if this topic set is fixed as defined 
	 * by the WS-BaseNotification specification.
	 */
	public boolean isFixed();



	/**
	 * Returns the topics contained in this topic set.
	 */
	public ITopic[] getAllTopics();

	/**
	 * 
	 * @param topics
	 */
	public void addTopics(ITopic[] topics);
	
	public void addTopic(ITopic topic);
	
	/**
	 * ɾ
	 * @param topics
	 */
	public void removeTopics(ITopic[] topics);

	/**
	 * ͨʹʽ
	 * @param topicExpr
	 */
	public void addTopicWithExpression(TopicExpression topicExpr, ITopicTreesSet topicTreeSet)
			throws TopicExpressionException;

	/**
	 *
	 * @param topic the path to exactly one Topic (e.g. new QName( "http://example.org/topicSpace/example1", "t4/t5" ))
	 *
	 * @return true if this topic set contains the specified topic, or false if it does not
	 */
	public boolean containsTopic(ITopic topic);

	/**
	 * ʽ
	 * @param topicExpr
	 * @return
	 * @throws TopicExpressionException
	 */
	public ITopic[] evaluateTopicExpression(ITopicExpression topicExpression,ITopicTreesSet topicTreeSet)
			throws TopicExpressionException;

	
	/**
	 * жTopicSetǷΪգԼʱɾûзķߡ
	 * @return
	 */
	public boolean isEmpty();
}
