package org.act.xservices.rt.xnotification.base;

import java.util.Calendar;

import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xcontainer.addressing.impl.MessageAddressingProperties;
import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.message.base.IFilter;
import org.act.xservices.rt.xnotification.message.base.Message;

/**
 * ˽ӿڵлһsubscription֮б뱣Ϣ 
 * ĵлϢڷرĵпҪϢ
 * 
 * @version 1.0 2008-3-3
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface ISubscriptionContext {
	
    
	/**
	 * ֪ͨߵĶ˵
	 * @return
	 */
	public IEndpointReference getNotificationConsumer();

    public void setNotificationConsumer(IEndpointReference notificationConsumer);
    

    /**
     * ֪ͨϢĹ
     * @param filter
     */
    public void setFilters(IFilter filter);

    public IFilter getFilters();


    /**
     * öĵֹʱ
     * @param terminationTime
     */
    public void setTerminationTime(Calendar terminationTime);

    public Calendar getTerminationTime();

    

    /**
     * öز
     * @return
     */
    public ISubscriptionPolicy getSubscriptionPolicy();

    public void setSubscriptionPolicy(ISubscriptionPolicy policy);

    
    /**
     * öļ¼Դ
     * @return
     */
    public ISubscriptionResource getSubscriptionResource();

    public void setSubscriptionResource(ISubscriptionResource resource);
    
    
    public MessageAddressingProperties getMessageAddressingProperties();
    public void setMessageAddressingProperties(MessageAddressingProperties header);

    
    
    /**
     * ݶϢɶ
     * @param subscriptionMessage
     * @return
     * @throws InvalidTopicExpressionException
     */
    public ISubscriptionContext buildSubscriptionContext(
    		Message subscriptionMessage) throws InvalidTopicExpressionException;
    
    
    
    
    public boolean validate();

    // /**
    // * Cancel this subscription.
    // */
    // void unsubscribe( );
    
    
    
    
    
    /**
     * Returns true if this subscription is currently paused, or false otherwise.
     *
     * @return true if this subscription is currently paused, or false otherwise
     */
    public boolean isPaused(  );
    
    /**
     * Temporarily suspends the delivery of notification messages for this subscription.
     *
     * @throws PauseFailedException if unable to suspend message delivery
     */
    public void pause(  );

    /**
     * Resumes the delivery of notification messages for this subscription.
     *
     * @throws ResumeFailedException if unable to resume message delivery
     */
    public void resume(  );

}
