
package org.act.xservices.rt.xnotification.base.fault;

import java.util.Calendar;

import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xom.Metaset;

/**
 * Ϣ
 * 
 * @version 1.0 2008-3-21
 * @author Liwu 2006-3-16
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class BaseFault extends RuntimeException{
	
	private static final long serialVersionUID = 1L;

	private String name;

	private Calendar timestamp;

	private IEndpointReference originatorReference;

	private Metaset errorCode;

	private String description;

	private Metaset faultCause;
	
	
	
	public BaseFault(String name,Calendar timestamp,String description){
		super();
		this.name = name;
		this.timestamp = timestamp;
		this.description = description;
	}
	
	public BaseFault(String name,Calendar timestamp,IEndpointReference originatorReference,
						Metaset errorCode,String description,Metaset faultCause){
		super();
		this.name = name;
		this.timestamp = timestamp;
		this.originatorReference = originatorReference;
		this.errorCode = errorCode;
		this.description = description;
		this.faultCause = faultCause;
	}
	

	public String getName(){
		return this.name;
	}
	

	public void setName(String name){
		this.name = name;
	}
	
	public Calendar gettimestamp(){
		return this.timestamp;
	}
	
	public void settimestamp(Calendar timestamp){
		this.timestamp = timestamp;
	}
	

	public IEndpointReference getOriginatorReference(){
		return this.originatorReference;
	}
	

	public void setOriginatorReference(IEndpointReference originatorReference){
		this.originatorReference = originatorReference;
	}
	

	public String getDescription(){
		return this.description;
	}
	

	public void setDescription(String description){
		this.description = description;
	}
	

	public Metaset getErrorCode(){
		return this.errorCode;
	}
	

	public void setErrorCode(Metaset errorCode){
		this.errorCode = errorCode;
	}
	

	public Metaset getFaultCause(){
		return this.faultCause;
	}
	

	public void setFaultCause(Metaset faultCause){
		this.faultCause = faultCause;
	}
	
	public Metaset toMetaset(){
		
		Metaset fault = NotificationUtil.getMetasetNoPrefix(this.name);
		
		Metaset timestamp = NotificationUtil.getMetasetNoPrefix("timestamp");
		
		timestamp.setText(this.timestamp.getTime().toString());
		
		fault.add(timestamp);
		
		if(this.originatorReference != null){
			Metaset originatorReference = NotificationUtil.getMetasetNoPrefix("OriginatorReference");
			originatorReference.add(this.originatorReference.toMetaset());
			fault.add(originatorReference);
		}
		
		if(this.errorCode != null){
			fault.add(this.errorCode);
		}
		
		if(this.description != null){
			Metaset description = NotificationUtil.getMetasetNoPrefix("Description");
			description.setText(this.description);
			fault.add(description);
		}
		
		if(this.faultCause != null){
			fault.add(this.faultCause);
		}
		
		return fault;
	}
}
