package org.act.xservices.rt.xnotification.base.impl;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xnotification.NotificationConstants;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.WSNRuntime;
import org.act.xservices.rt.xnotification.base.INotificationProducer;
import org.act.xservices.rt.xnotification.base.ISubscriptionContext;
import org.act.xservices.rt.xnotification.base.ISubscriptionManager;
import org.act.xservices.rt.xnotification.message.base.GetCurrentMessageResponseMessage;
import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xnotification.message.base.MessageFactory;
import org.act.xservices.rt.xnotification.topic.ITopic;
import org.act.xservices.rt.xnotification.topic.ITopicNamespace;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

/**
 * ֪ͨʵ
 * 뷢߲ͬڣֶ֧ĹܣGetCurrentMessage
 * 
 * @version 1.0 2008-3-3
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class NotificationProducer extends ANotificationPublisher implements INotificationProducer{
	
	private MetasetBuilder mb = MetasetBuilder.getInstance();
	
	/**Ĺ */
	protected ISubscriptionManager subscriptionManager;
	
	
	/**Ƿ֪ͨ */
	private boolean isUseBroker = false;
	
	
	
	public NotificationProducer(IEndpointReference producerEPR) {
		super(producerEPR);
		this.subscriptionManager = new SubscriptionManager(producerEPR, 
				this.topicTreesSet, this.publisherTopicSet);
	}
	
	
	/** 
	 * ֪ͨϢ
	 * @param topic
	 * @param notificationMessage
	 * @see org.act.xservices.rt.xnotification.base.INotificationPublisher#sendNotification(org.act.xservices.rt.xnotification.topic.ITopic, org.act.xservices.rt.metaset.Metaset)
	 */
	public void sendNotification(ITopic topic) {
		
		Metaset notificationMessage = 
			NotificationUtil.getMetasetOfPrefix_WSNT("NotificationMessage");
		
		// ӶĹϢ
		Metaset subsciptionEPR = this.getEPR().toMetaset();
		subsciptionEPR.setQName(new QName(
				NotificationConstants.URI_NS_WSNT, "SubscriptionReference" ,"wsnt"));

		notificationMessage.add(subsciptionEPR);
		

		// ֪ͨϢӦϢ
		Metaset topicMetaset = NotificationUtil.getMetasetOfPrefix_WSNT("Topic");
		
		ITopicNamespace topicNS = topic.getTopicNamespace();
		topicMetaset.add(NotificationUtil.getNewAttribute("Dialect",
				"http://docs.oasis-open.org/wsn/t-1/TopicExpression/Concrete"));
		topicMetaset.add(NotificationUtil.getNewAttribute(
				"xmlns:" + topicNS.getName(), topicNS.getTargetNamespace()));
		topicMetaset.setText(topic.toString());
		notificationMessage.add(topicMetaset);
		
		
		// ֪ͨߵϢ
		Metaset producerEPR = this.getEPR().toMetaset();
		producerEPR.setQName(new QName(NotificationConstants.URI_NS_WSNT,"ProducerReference","wsnt"));
		notificationMessage.add(producerEPR);
		

		//֪ͨϢ
		notificationMessage.add((Metaset) topic.getContect());
		
		
        Metaset notify = NotificationUtil.getMetasetOfPrefix_WSNT("Notify");
        notify.add(notificationMessage);

        Message message = MessageFactory.getNofitifyMessage(notify);
        
        
        //עϢ֪ͨ	
		ISubscriptionContext[] subspContext = subscriptionManager.getSubscription(topic);
        System.out.println("һҪ͵ϢһУ" + subspContext.length);
        
        for (int i = 0; i < subspContext.length; i++) {
 
            String consumerAddress = subspContext[i].getNotificationConsumer().getAddress();

            Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
            
            to.setText(consumerAddress);
            message.getHeader().add(to);
            WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithoutResponse(
            		message.toMetaset(), consumerAddress);

        }
        //ʹôģʽҲҪ֪ͨ
        if(isUseBroker){
        	WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithoutResponse(
            		message.toMetaset(), notificationBrokerEPR.getAddress());
        }
        
	}


	public GetCurrentMessageResponseMessage GetCurrentMessage(Message message) {
		// TODO Auto-generated method stub
		return null;
	}
	

	
	
	public void supportedTopicChanged() {
		
		System.out.println("---supportedTopicChanged()---");
		
		//ע⣬ڴʵУעǰɾǰע¼
		this.RegistPublisher(false, "2008-12-25T00:00:00.00000");
	}
	
	
	
	//----------------------------------------------------
	/** 
	 * ش֪ͨʹõĶĹ
	 * @return
	 * @see org.act.xservices.rt.xnotification.base.INotificationProducer#getSubscriptionManager()
	 */
	public ISubscriptionManager getSubscriptionManager() {
		return subscriptionManager;
	}

	public ISubscriptionContext[] getSubscription(ITopic topic) {

		return subscriptionManager.getSubscription(topic);
	}

//	public void receiveSubscription(ISubscriptionContext subscribe, ITopic[] topics) throws TopicNotSupportedException {
//
//		subscriptionManager.receiveSubscription(subscribe, topics);
//	}
//
//	public boolean removeSubscription(ISubscriptionContext subscribe, ITopic[] topics) throws UnsupportedTopicExpressionException, InvalidTopicExpressionException, TopicNotSupportedException {
//
//		return subscriptionManager.removeSubscription(subscribe, topics);
//	}
//	
//	public void removeSubscritionByTopic(ITopic topic) {
//		subscriptionManager.removeSubscritionByTopic(topic);
//	}

	public Message handlePause(Message pauseMessage) {

		return subscriptionManager.handlePause(pauseMessage);
	}


	public Message handleRenew(Message renewMessage) {

		return subscriptionManager.handleRenew(renewMessage);
	}


	public Message handleResume(Message resumeMessage) {

		return subscriptionManager.handleResume(resumeMessage);
	}


	public Message handleUnSubscribe(Message unSubscribeMessage) {

		return subscriptionManager.handleUnSubscribe(unSubscribeMessage);
	}
	

	public Message handleSubscribe(Message subscriptionMessage) {

		return subscriptionManager.handleSubscribe(subscriptionMessage);
	}


	public boolean isUseBroker() {
		return isUseBroker;
	}


	public void setUseBroker(boolean isUseBroker) {
		this.isUseBroker = isUseBroker;
	}


	public IEndpointReference getNotificationBrokerEPR() {
		return notificationBrokerEPR;
	}


	public void setNotificationBrokerEPR(IEndpointReference notificationBrokerEPR) {
		this.notificationBrokerEPR = notificationBrokerEPR;
	}

	//----------------------------------------------------

	
	/**
	 * ֪ͨ ע ֪ͨ
	 * @param demand ǷûĴģʽ
	 * @param initialTerminationTime ע¼ֹʱ
	 * @return ӦϢ
	 */
	public Metaset RegistPublisher(boolean demand, String initialTerminationTime){
		
		if(!isUseBroker){
			System.err.println("--- NO use notificationBroker modle!");
			return null; //ʹô
		}
		
		if(notificationBrokerEPR == null){
			System.err.println("--- NO notificationBroker EPR!");
			return null;
		}
		
		//עϢ
		Metaset messagebody = NotificationUtil.getMetasetOfPrefix_WSNBR("RegisterPublisher");
		
		//ƿռǰ׺2008-09-11
		messagebody.add(mb.newAttribute("xmlns:wsn-br", NotificationConstants.URI_NS_WSN_BR));
		messagebody.add(mb.newAttribute("xmlns:wsa", NotificationConstants.URI_NS_WSA));
		
		Metaset publisherReferenceM = publisherEPR.toMetaset();
		
		publisherReferenceM.setQName(new QName(
				NotificationConstants.URI_NS_WSN_BR,"PublisherReference","wsn-br"));
		messagebody.add(publisherReferenceM);
		
		for(ITopic topicTemp : publisherTopicSet.getAllTopics()){
			messagebody.add(topicTemp.getConcreteExpression());
		}
		
		Metaset demandM = NotificationUtil.getMetasetOfPrefix_WSNBR("Demand");
		
		demandM.setText(String.valueOf(demand));
		
		Metaset terminateTimeM = 
			NotificationUtil.getMetasetOfPrefix_WSNBR("InitialTerminationTime");
			
		terminateTimeM.setText(initialTerminationTime);
		
		messagebody.add(demandM);
		messagebody.add(terminateTimeM);
		
		Message message = MessageFactory.getRegisterPublisherRequestMessage(messagebody);
		
        Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
        to.setText(notificationBrokerEPR.getAddress());
        message.getHeader().add(to);
        
        Metaset replyTo = NotificationUtil.getMetasetOfPrefix_WSA("ReplyTo");
        replyTo.setText(this.publisherEPR.getAddress());
        message.getHeader().add(replyTo);
        
        FutureTask<Metaset> responseTask = 
        	WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithResponse(
        			message.toMetaset(), notificationBrokerEPR.getAddress()); //֪ͨע
		
        Metaset responseMessageM = null;
		try {
			responseMessageM = responseTask.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
		//ӦϢ
		return responseMessageM;

	}


	public Metaset DestroyPublisherRegistration() {
		
		if(!isUseBroker){
			System.err.println("--- NO use notificationBroker modle!");
			return null; //ʹô
		}
		
		if(notificationBrokerEPR == null){
			System.err.println("--- NO notificationBroker EPR!");
			return null;
		}
		
		//עϢ
		Metaset messagebody = NotificationUtil.getMetasetOfPrefix_WSNBR("DestroyRegistration");
		
		//ƿռǰ׺2008-09-11
		messagebody.add(mb.newAttribute("xmlns:wsn-br", NotificationConstants.URI_NS_WSN_BR));
		messagebody.add(mb.newAttribute("xmlns:wsa", NotificationConstants.URI_NS_WSA));
		
		Metaset publisherReferenceM = publisherEPR.toMetaset();
		
		publisherReferenceM.setQName(new QName(
				NotificationConstants.URI_NS_WSN_BR,"PublisherReference","wsn-br"));

		messagebody.add(publisherReferenceM);
		
		Message message = 
			MessageFactory.getDestroyRegistrationRequestMessage(messagebody);
		
        Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
        to.setText(notificationBrokerEPR.getAddress());
        message.getHeader().add(to);
        
        Metaset replyTo = NotificationUtil.getMetasetOfPrefix_WSA("ReplyTo");
        replyTo.setText(this.publisherEPR.getAddress());
        message.getHeader().add(replyTo);
        
        FutureTask<Metaset> responseTask = 
        	WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithResponse(
        			message.toMetaset(), notificationBrokerEPR.getAddress()); 
		
        Metaset responseMessageM = null;
        
		try {
			responseMessageM = responseTask.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
		//ӦϢ
		return responseMessageM;
	}
	
}
