package org.act.xservices.rt.xnotification.base.impl;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xcontainer.addressing.impl.EndpointReference;
import org.act.xservices.rt.xnotification.NotificationConstants;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.WSNRuntime;
import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xnotification.message.base.MessageFactory;
import org.act.xservices.rt.xnotification.topic.ITopic;
import org.act.xservices.rt.xnotification.topic.ITopicNamespace;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;


/**
 * ֪ͨʵ
 * ֪֪ͨͨĲͬڣֶ֪߲֧ͨĹ
 * 
 * @version 1.0 2008-3-3
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class NotificationPublisher extends ANotificationPublisher{

	private MetasetBuilder mb = MetasetBuilder.getInstance();
	
	public NotificationPublisher(IEndpointReference publisherEPR){
		super(publisherEPR);
	}
	
	public NotificationPublisher(IEndpointReference publisherEPR, IEndpointReference notificationBrokerEPR){
		super(publisherEPR);
		this.notificationBrokerEPR = notificationBrokerEPR;
	}
	
	public NotificationPublisher(String publisherWSAddress){
		super(new EndpointReference(publisherWSAddress));
	}
	
	
	
	
	/** 
	 * ص֪ͨϢ
	 * 
	 * @param topic
	 * @param notificationMessage
	 * @see org.act.xservices.rt.xnotification.base.INotificationPublisher#sendNotification(org.act.xservices.rt.xnotification.topic.ITopic, org.act.xservices.rt.metaset.Metaset)
	 */
	public void sendNotification(ITopic topic) {

		Metaset notificationMessage = 
			NotificationUtil.getMetasetOfPrefix_WSNT("NotificationMessage");

		// ֪ͨߵϢ
		Metaset producerEPR = this.getEPR().toMetaset();

		producerEPR.setQName(new QName(
				NotificationConstants.URI_NS_WSNT,"ProducerReference","wsnt"));
		notificationMessage.add(producerEPR);

		// ֪ͨϢӦϢ
		Metaset topicMetaset = NotificationUtil.getMetasetOfPrefix_WSNT("Topic");
		ITopicNamespace topicNS = topic.getTopicNamespace();
		topicMetaset.add(NotificationUtil.getNewAttribute(
				"Dialect", "http://docs.oasis-open.org/wsn/t-1/TopicExpression/Concrete"));
		topicMetaset.add(NotificationUtil.getNewAttribute(
				"xmlns:" + topicNS.getName(), topicNS.getTargetNamespace()));
		topicMetaset.setText(topic.toString());
		notificationMessage.add(topicMetaset);

		//֪ͨϢ
		notificationMessage.add((Metaset) topic.getContect());

		// ڷֶ߲֧ĹܣеϢ͵֪ͨ
		String brokerAddress = notificationBrokerEPR.getAddress();

		Metaset notify = NotificationUtil.getMetasetOfPrefix_WSNT("Notify");

		notify.add(notificationMessage);

		Message message = MessageFactory.getNofitifyMessage(notify);

		Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
		to.setText(brokerAddress);
		message.getHeader().add(to);

		System.out.println("---NotificationPublisher.sendNotification()---\n"+message.toMetaset().toXML());
		//֪ͨϢ
		WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithoutResponse(
				message.toMetaset(), brokerAddress);

	}





	public void supportedTopicChanged() {
		
		System.out.println("---supportedTopicChanged()---");
		
		//ע⣺˴ҪжϷǷ⣬û
		
		if(this.publisherTopicSet.isEmpty()){
			this.DestroyPublisherRegistration();
		}else{
			//ע⣬ڴʵУעǰɾǰע¼
			this.RegistPublisher(false, "2009-12-25T00:00:00.00000");
		}

	}
	
	
	
    /**
     * ע 
     * 
    <s:Envelope ...>
	<s:Header>
		<wsa:Action>
			http://docs.oasis-open.org/wsn/brw-2/RegisterPublisher/RegisterPublisherRequest
		</wsa:Action>
		...
	</s:Header>
	<s:Body>
		<wsn-br:RegisterPublisher>
			
			<wsn-br:PublisherReference>
				<wsa:Address>
					http://www.example.org/PublisherEndpoint
				</wsa:Address>
				<wsa:ReferenceParameters>
					<npex: NPResourceDisambiguator>
						uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22
					</npex:NPResourceDisambiguator>
				</wsa:ReferenceParameters>
			</wsn-br:PublisherReference>
			
			<wsn-br:Topic
				Dialect="http://docs.oasis-open.org/wsn/t-1/TopicExpression/Simple">
				npex:SomeTopic
			</wsn-br:Topic>*
			
			<wsn-br:Demand>true</wsn-br:Demand>
			
			<wsn-br:InitialTerminationTime>
				2003-12-25T00:00:00.00000
			</wsn-br:InitialTerminationTime>
			
		</wsn-br:RegisterPublisher>
	</s:Body>
	</s:Envelope>  
    */

	/**
	 * ֪ͨ ע ֪ͨ
	 * @param demand ǷûĴģʽ
	 * @param initialTerminationTime ע¼ֹʱ
	 * @return ӦϢ
	 */
	public Metaset RegistPublisher(boolean demand, String initialTerminationTime){
		
		//עϢ
		Metaset messagebody = NotificationUtil.getMetasetOfPrefix_WSNBR("RegisterPublisher");
		
		//ƿռǰ׺2008-09-11
		messagebody.add(mb.newAttribute("xmlns:wsn-br", NotificationConstants.URI_NS_WSN_BR));
		messagebody.add(mb.newAttribute("xmlns:wsa", NotificationConstants.URI_NS_WSA));
		
		Metaset publisherReferenceM = publisherEPR.toMetaset();
		publisherReferenceM.setQName(new QName(
				NotificationConstants.URI_NS_WSN_BR,"PublisherReference","wsn-br"));
		messagebody.add(publisherReferenceM);
		
		for(ITopic topicTemp : publisherTopicSet.getAllTopics()){
			messagebody.add(topicTemp.getConcreteExpression());
		}
		
		Metaset demandM = NotificationUtil.getMetasetOfPrefix_WSNBR("Demand");
		demandM.setText(String.valueOf(demand));
		
		Metaset terminateTimeM = NotificationUtil.getMetasetOfPrefix_WSNBR("InitialTerminationTime");
		terminateTimeM.setText(initialTerminationTime);
		
		messagebody.add(demandM);
		messagebody.add(terminateTimeM);
		
		Message message = MessageFactory.getRegisterPublisherRequestMessage(messagebody);
		
        Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
        to.setText(notificationBrokerEPR.getAddress());
        message.getHeader().add(to);
        
        Metaset replyTo = NotificationUtil.getMetasetOfPrefix_WSA("ReplyTo");
        replyTo.setText(this.publisherEPR.getAddress());
        message.getHeader().add(replyTo);
        
        FutureTask<Metaset> responseTask = 
        	WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithResponse(
        			message.toMetaset(), notificationBrokerEPR.getAddress()); //֪ͨע
		
        Metaset responseMessageM = null;
		try {
			responseMessageM = responseTask.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
		//ӦϢ
		return responseMessageM;
		
		
	}
	
	/**
	 * ٷעϢ
	<s:Envelope ... >
	  <s:Header>
	    <wsa:Action>
	      http://docs.oasis-open.org/wsn/brw-2/PublisherRegistrationManager/DestroyRegistrationRequest
	    </wsa:Action>
	    ...
	  </s:Header>
	  <s:Body>
	    <wsn-br:DestroyRegistration>
	       <wsn-br:PublisherReference>
             <wsa:Address>
                http://www.example.org/PublisherEndpoint
             </wsa:Address>
           </wsn-br:PublisherReference>
	    <wsn-br:DestroyRegistration/>
	  </s:Body>
	</s:Envelope>
	*/
	

	public Metaset DestroyPublisherRegistration() {
		
		//עϢ
		Metaset messagebody = NotificationUtil.getMetasetOfPrefix_WSNBR("DestroyRegistration");
		
		//ƿռǰ׺2008-09-11
		messagebody.add(mb.newAttribute("xmlns:wsn-br", NotificationConstants.URI_NS_WSN_BR));
		messagebody.add(mb.newAttribute("xmlns:wsa", NotificationConstants.URI_NS_WSA));
		
		Metaset publisherReferenceM = publisherEPR.toMetaset();
		publisherReferenceM.setQName(new QName(
				NotificationConstants.URI_NS_WSN_BR,"PublisherReference","wsn-br"));
		messagebody.add(publisherReferenceM);
		
		Message message = 
			MessageFactory.getDestroyRegistrationRequestMessage(messagebody);
		
        Metaset to = NotificationUtil.getMetasetOfPrefix_WSA("To");
        to.setText(notificationBrokerEPR.getAddress());
        message.getHeader().add(to);
        
        Metaset replyTo = NotificationUtil.getMetasetOfPrefix_WSA("ReplyTo");
        replyTo.setText(this.publisherEPR.getAddress());
        message.getHeader().add(replyTo);
        
        FutureTask<Metaset> responseTask = 
        	WSNRuntime.getRuntime().getNotifyMessageBus().sendMessageWithResponse(
        			message.toMetaset(), notificationBrokerEPR.getAddress()); 
		
        Metaset responseMessageM = null;
        
		try {
			responseMessageM = responseTask.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
		
		//ӦϢ
		return responseMessageM;
	}

}
