
package org.act.xservices.rt.xnotification.base.impl;

import java.util.Calendar;

import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xcontainer.addressing.impl.EndpointReference;
import org.act.xservices.rt.xcontainer.addressing.impl.MessageAddressingProperties;
import org.act.xservices.rt.xnotification.base.ISubscriptionContext;
import org.act.xservices.rt.xnotification.base.ISubscriptionPolicy;
import org.act.xservices.rt.xnotification.base.ISubscriptionResource;
import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.message.base.Filter;
import org.act.xservices.rt.xnotification.message.base.IFilter;
import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xom.Metaset;

/**
 * to store as a ws resource will facilitate the mangagement, 
 * however, will effect the efficiency...
 * 
 * @version 1.0 2008-3-5
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-6-27
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class SubscriptionContext implements ISubscriptionContext {

	/**ֹʱ */
	private Calendar _terminationTime = null;

	/**֪ͨ */
	private IEndpointReference _notificationConsumer = null;

	/**Ϣ */
	private IFilter _filter = null;

	/**ϢеĲ */
	private ISubscriptionPolicy _policy = null;

	/**ļ¼Դ */
	private ISubscriptionResource _subscriptionResource = null;

	/** */
	private MessageAddressingProperties _mih = null;

	/**ͣʾ */
	private boolean m_isPaused;

	
	public SubscriptionContext() {
		super();
	}

	public SubscriptionContext(Message message)
			throws InvalidTopicExpressionException {
		super();
		this.buildSubscriptionContext(message);
		
		creatResourceProperty(message);
	}

	private void creatResourceProperty(Message message) {
		//FIXME:  do it with the ....RM....
		this.setSubscriptionResource(new SubscriptionResource());

	}

	public MessageAddressingProperties getMessageAddressingProperties() {
		return _mih;
	}

	public void setMessageAddressingProperties(MessageAddressingProperties header) {
		this._mih = header;
	}

	public IEndpointReference getNotificationConsumer() {

		return _notificationConsumer;
	}
	
	public void setNotificationConsumer(IEndpointReference notificationConsumer) {
		this._notificationConsumer = notificationConsumer;

	}

	public void setFilters(IFilter filter) {
		this._filter = filter;

	}

	public IFilter getFilters() {

		return _filter;
	}

	public void setTerminationTime(Calendar terminationTime) {
		this._terminationTime = terminationTime;

	}

	public Calendar getTerminationTime() {

		return this._terminationTime;
	}

	public ISubscriptionPolicy getSubscriptionPolicy() {

		return this._policy;
	}

	public void setSubscriptionPolicy(ISubscriptionPolicy policy) {
		this._policy = policy;

	}

	public ISubscriptionResource getSubscriptionResource() {

		return _subscriptionResource;
	}

	public void setSubscriptionResource(ISubscriptionResource resource) {
		this._subscriptionResource = resource;

	}



	//    <wsnt:Subscribe>                                           
	//    <wsnt:ConsumerReference>            
	//       <!-- make this filesystem for now... -->            
	//          <wsa:Address>http://localhost:8080/pubscribe/services/filesystem</wsa:Address>        
	//          <wsa:ReferenceProperties/>                             
	//       </wsnt:ConsumerReference>                  
	//       <wsnt:TopicExpression Dialect="http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Simple">fs:MountPointDirectory</wsnt:TopicExpression>                  
	//       <wsnt:UseNotify>true</wsnt:UseNotify>                
	//    </wsnt:Subscribe> 

	//    <wsnt:Subscribe> 
	//    <wsnt:ConsumerReference> 
	//    wsa:IEndpointReference 
	//    </wsnt:ConsumerReference> 
	//    <wsnt:Filter> 
	//    [ <wsnt:TopicExpression Dialect="xsd:anyURI"> 
	//    {any} ? 
	//    </wsnt:TopicExpression> | 
	//    <wsnt:ProducerProperties Dialect="xsd:anyURI"> 
	//    {any} ? 
	//    </wsnt:ProducerProperties> | 
	//    <wsnt:MessageContent Dialect="xsd:anyURI"> 
	//    {any} 
	//    </wsnt:MessageContent> | 
	//    {any} * 
	//    ] * 
	//    </wsnt:Filter> ? 
	//    <wsnt:InitialTerminationTime> 
	//    [xsd:dateTime | xsd:duration] 
	//    </wsnt:InitialTerminationTime> ? 
	//    <wsnt:SubscriptionPolicy> 
	//    [ <wsnt:UseRaw/> | 
	//    {any} 
	//    ] * 
	//    </wsnt:SubscriptionPolicy> ? 
	//    {any}* 
	//    </wsnt:Subscribe>
	/*
	 private Calendar _terminationTime=null;
	 private Calendar _creationTime=null;
	 private IEndpointReference _notificationConsumer=null;
	 private NotificationProducer _notificationProducer=null;
	 private Filter _filter=null;
	 private SubscriptionPolicy _policy=null;
	 private SubscriptionResource _subscriptionResource=null;
	 */
	public ISubscriptionContext buildSubscriptionContext(Message subscriptionMessage)
			throws InvalidTopicExpressionException {
		MessageAddressingProperties mih = new MessageAddressingProperties(
				subscriptionMessage.getHeader());
		
		this.setMessageAddressingProperties(mih);
		Metaset message = subscriptionMessage.getBody().filter(".\\Subscribe").car();

		if (message != null) {
			Metaset consumer = message.filter(".\\ConsumerReference");
			if (consumer != null) {
				IEndpointReference consumerEpr = new EndpointReference(consumer.car());
				this.setNotificationConsumer(consumerEpr);
			}
			Metaset useNotify = message.filter(".\\SubscriptionPolicy");
			if (useNotify != null) {
				SubscriptionPolicy policy = new SubscriptionPolicy(useNotify.car());
				this.setSubscriptionPolicy(policy);
			}

			Metaset filter = message.filter(".\\Filter");
			if (filter != null) {
				// this is special...
				Filter ft = new Filter(subscriptionMessage);
				this.setFilters(ft);
			}
			Metaset termin = message.filter(".\\InitialTerminationTime");
			if (termin != null) {
				//FIXME: this is in correct...to ûдʱ.ô
				this.setTerminationTime(null);
			}

		}
		return this;

	}

	/*
	 * validate weather it is a correct object...
	 * To add more feature in future...
	 * FIXME: todo...and more check...
	 */
	public boolean validate() {
		if (this._notificationConsumer != null && this._filter != null) {
			return true;
		}
		return false;
	}


	
	public boolean equals(Object obj) {

		SubscriptionContext temp = (SubscriptionContext) obj;
		//޸ by cover_eye:Ϊڻ֧terminationTimepolicy
		//        if(_terminationTime.equals(temp.getTerminationTime())&&_notificationConsumer.equals(temp.getNotificationConsumer())
		//                &&_filter.equals(temp.getFilters())&&_policy.equals(temp.getSubscriptionPolicy())
		if (_notificationConsumer.equals(temp.getNotificationConsumer())
				&& _filter.equals(temp.getFilters())) {
			return true;
		} else {
			return false;
		}
	}

	
	public boolean isPaused() {
		return m_isPaused;
	}

	public void pause() {
		m_isPaused = true;
	}

	public void resume() {
		m_isPaused = false;
	}



}
