package org.act.xservices.rt.xnotification.base.impl;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.base.ITopicTreesSet;
import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xnotification.message.base.MessageFactory;
import org.act.xservices.rt.xnotification.topic.ITopicNamespace;
import org.act.xservices.rt.xom.Metaset;

/**
 * ļ
 * һֵ֪֧ͨνṹ
 * 
 * @version 1.0 2006-6-16
 * @author cover_eye wangyg@act.buaa.edu.cn
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class TopicTreesSet implements ITopicTreesSet{
   

    /**
     * treeholder hold the Namespace as a topic tree
     * targetNameSpace --> ITopicNamespace
     * */
    private Map<String,ITopicNamespace> topicTreesMap;
    
    
    public TopicTreesSet() {
    	//ʼӳ
    	topicTreesMap = new ConcurrentHashMap<String,ITopicNamespace>();
    }

    /**
     * ƿռ䷵
     * @param targetNameSpace
     * @return
     */
    public ITopicNamespace getTopicTreeByTopicNamespace(String targetNameSpace) {
        return topicTreesMap.get(targetNameSpace);
    }

    /**
     * עе
     * @return
     */
    public ITopicNamespace[] getRegisteredTopicTrees() {
        return topicTreesMap.values().toArray(new ITopicNamespace[0]) ;
    }

    /**
     * עһ
     * @param namespace
     */
    public void registerTopicTree(ITopicNamespace namespace) {
        topicTreesMap.put(namespace.getTargetNamespace(), namespace);

        System.out.println("---TopicTreesSet.registerTopicTree()---"+namespace.getTargetNamespace());
    }
    
    
    /**
     * жǷںֺֿͬռµNamespace
     * @param name
     * @param targetNamespace
     * @return
     */
    public ITopicNamespace contains(String name,String targetNamespace){
    	ITopicNamespace namespace[]= this.getRegisteredTopicTrees();
		for (int i = 0; i < namespace.length; i++) {
			if(namespace[i].getName().equals(name)
					&&namespace[i].getTargetNamespace().equals(targetNamespace)){				
				return namespace[i];
			}		
		}
		return null;
    }
    
    



	public String toString() {
		ITopicNamespace[] space = getRegisteredTopicTrees();
		String s = "";
		for (int i = 0; i < space.length; i++) {
			s = s + space[i].toString();
		}
		return s;
	}
	
	
    /**
	 * صǰеWS-Topicб
	 * 
	 * @return
	 */
	public Message getTopicListResponse() {
		Message ret = MessageFactory.getGetTopicListResponseMesseage(this.getTopicListMetaset());
		return ret;
	}
	
	private Metaset getTopicListMetaset() {
		
		Metaset meta = NotificationUtil.getMetasetNoPrefix("GetTopicListResponse");
		ITopicNamespace[] space = getRegisteredTopicTrees();

		for (int i = 0; i < space.length; i++) {
			meta.add(space[i].toMetaset());
		}
		return meta;
	}
	
    
}
