package org.act.xservices.rt.xnotification.client.http;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xnotification.client.ICallClient;
import org.act.xservices.rt.xom.Metaset;

/**
 * 
 * @version 1.0 2005-10-10
 * @author liwu@act.buaa.edu.cn
 * @since JDK1.5
 */
public class HttpCallClient implements ICallClient {

	/**
	 * 
	 */
	public HttpCallClient() {
		super();
		// TODO Զɹ캯
	}


	public Metaset call(URL addr, Metaset message) {

		//һStringBufferȥȻ תΪһbyte
		StringBuffer document = new StringBuffer();

		HttpURLConnection con = null;
		try {
			con = (HttpURLConnection)addr.openConnection();
			
			con.setRequestMethod("POST");
			con.setRequestProperty("Content-type", "text/xml; charset=utf-8");
			con.setDoOutput(true);
			con.setDoInput(true);
			//con.setReadTimeout(20000); //öȡʱΪ20
			con.connect();

			OutputStream out = con.getOutputStream();

			out.write(message.toXML().getBytes());
			out.flush();

			// InputStream input=con.getInputStream();
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					con.getInputStream()));

			String line = null;
			while ((line = reader.readLine()) != null) {
				document.append(line + "\n");
			}
			reader.close();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		if (document.length() == 0) {
			try {
				throw new HttpCallClientException();
			} catch (HttpCallClientException e1) {
				e1.printStackTrace();
			}
		}
		
		Metaset resm = null;
		
		try {
			resm = MetasetParserFactory.getMetasetParser().parse(
					new ByteArrayInputStream(document.toString().getBytes()));
		} catch (MetasetParsingException e) {
			e.printStackTrace();
		}

		return resm;

	}


	public Metaset call(String addr, Metaset message) {
		Metaset resm = null;
		try {
			URL url = new URL(addr);
			resm = call(url, message);
		} catch (MalformedURLException e) {
			// TODO Զ catch 
			e.printStackTrace();
		}
		return resm;
	}
	
	
	
	/**
	 * һϢرӣӦ
	 * @param address
	 * @param message
	 */
	public void callWithoutResponse(String address, Metaset message) {

		HttpURLConnection con = null ;
		
		try {
			con = (HttpURLConnection)new URL(address).openConnection();

			con.setRequestMethod("POST");	
			con.setRequestProperty("Content-type", "text/xml; charset=utf-8");
			con.setDoOutput(true);
			con.setDoInput(true);
			
			con.connect();
			
			OutputStream out = con.getOutputStream();
			out.write(message.toXML().getBytes());
			out.flush();
			out.close();
			

			//ǿע⣺˴Ӵ˷ݽ޷ͳȥBugûеõдǣ add by lizq 2008-03-24		
			BufferedReader bufIn = new BufferedReader(new InputStreamReader(con.getInputStream()));
			//ע˴bufInȡHTTPЧأHTTPͷ
			
//			StringBuffer retIn = new StringBuffer();
//			
//			char[] buffer = new char[10240];
//			int length = -1;
//			
//			while ((length = bufIn.read(buffer, 0,buffer.length)) != -1) {
//				retIn.append(buffer, 0, length);
//			}

			System.out.println("---callWithoutResponse-OK--");
			
			bufIn.close();

			con.disconnect();

		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
