package org.act.xservices.rt.xnotification.message.base;

import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.topic.expression.ITopicExpression;
import org.act.xservices.rt.xnotification.topic.expression.TopicExpressionFactory;
import org.act.xservices.rt.xom.Metaset;

/**
 * 
 * @version 1.0 2008-3-5
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-6-27
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class Filter implements IFilter {

	private ITopicExpression[] topicExpressions = null;

	private Metaset producerResourceProperty;

	private Metaset messageContent = null;

	
	public Filter(Message filterMessage) throws InvalidTopicExpressionException {
		buildFilter(filterMessage);
	}

	/** 
	 * 
	 * @param topicExpression
	 * @see org.act.xservices.rt.xnotification.message.base.IFilter#setTopicExpressions(org.act.xservices.rt.xnotification.topic.expression.ITopicExpression)
	 */
	public void setTopicExpressions(ITopicExpression[] topicExpression) {
		this.topicExpressions = topicExpression;

	}

	public ITopicExpression[] getTopicExpressions() {

		return topicExpressions;
	}

	
	
	/**
	 * 
	 * @param producerResourceProperty
	 * @see org.act.xservices.rt.xnotification.message.base.IFilter#setProducerProperties(java.lang.Object)
	 */
	public void setProducerProperties(Metaset producerResourceProperty) {
		this.producerResourceProperty = producerResourceProperty;

	}
	
	public Metaset getProducerProperties() {

		return producerResourceProperty;
	}

	/**
	 * 
	 * @param messageContent
	 * @see org.act.xservices.rt.xnotification.message.base.IFilter#setMessageContent(java.lang.Object)
	 */
	public void setMessageContent(Metaset messageContent) {
		this.messageContent = messageContent;

	}

	public Metaset getMessageContent() {

		return messageContent;
	}

	/**
	 * FilterϢʽ
	 * 
	 <wsnt:Filter>
	 [ <wsnt:TopicExpression Dialect="xsd:anyURI">
	 {any} ?
	 </wsnt:TopicExpression> |
	 <wsnt:ProducerProperties Dialect="xsd:anyURI">
	 {any} ?
	 </wsnt:ProducerProperties> |
	 <wsnt:MessageContent Dialect="xsd:anyURI">
	 {any}
	 </wsnt:MessageContent> |
	 {any} *
	 ] *
	 </wsnt:Filter> ?
	 */

	public void buildFilter(Message filterMessage)
			throws InvalidTopicExpressionException {
		
		//޸ by cover_eye
		// Metaset sub = message.getBody().filter("\\Body\\Subscribe\\Filter").car();
		//FIXIT:ֻ͵ıĽģӦдһͨõġ
		Metaset filterPart = filterMessage.getBody().filter("\\Body\\*\\Filter").car();

		Metaset topicExpressionM = filterPart.filter(".\\TopicExpression");
		
		if (topicExpressionM != null) {
			
			List<ITopicExpression> topicExpList = new ArrayList<ITopicExpression>();
			
			//ÿʽ
			for(Object topicExpTemp : topicExpressionM.elements()){
				topicExpList.add( TopicExpressionFactory.getTopicExpression(
						(Metaset)topicExpTemp, filterMessage.getEnvelopeNameSpace()) );
				//˴дǣby lizq 2008-03-05
			}
			
			this.setTopicExpressions(topicExpList.toArray(new ITopicExpression[0]));

		}
		
		
		
		Metaset producerProperties = filterPart.filter(".\\ProducerProperties");
		if (producerProperties != null) {
			this.setProducerProperties(producerProperties.car());
		}
		Metaset messageContent = filterPart.filter(".\\MessageContent");
		if (messageContent != null) {
			this.setMessageContent(messageContent.car());
		}

	}


	
	protected Object clone() throws CloneNotSupportedException {
		return super.clone();
	}


	//???
	public boolean equals(Object obj) {

		if (((Filter) obj).getTopicExpressions().equals(this.topicExpressions)) {
			return true;
		} else {
			return false;
		}

	}

	//???
	public int hashCode() {
		return this.topicExpressions.hashCode();
	}


	
	//
	public String toString() {

		return super.toString();
	}

	//???
	public Metaset toMetaset() {
		// TODO Զɷ
		return null;
	}

}
