package org.act.xservices.rt.xnotification.message.base;

import java.util.List;

import org.act.xservices.rt.xnotification.NotificationConstants;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.util.IConfigurable;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;


/**
 * Ϣ
 * һSOAPϢ
 * @version 1.0 2008-3-13
 * @author liwu 2006-6-12
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class Message implements IConfigurable {

	private Metaset header = null;

	private Metaset body = null;

	private Metaset envelope = null;

	private Metaset wSAAction = null;

	public Message() {

	}

	/**
	 * TODO: ϢĽģ飮
	 * */
	public void buildMessageFromMetaset(Metaset message){
		
	}

	protected void buildMessageSkeleton() {

		Metaset envelope = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Envelope", "s11");

		envelope.add(NotificationUtil.getNewAttribute(
				new QName("","s11","xmlns"),
				"http://schemas.xmlsoap.org/soap/envelope/"));
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "xsi","xmlns"),
				"http://www.w3.org/2001/XMLSchema-instance"));
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "xsd", "xmlns"),
				"http://www.w3.org/2001/XMLSchema"));
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "wsa", "xmlns"),
				"http://www.w3.org/2005/08/addressing"));
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "wsnt", "xmlns"),
				NotificationConstants.URI_NS_WSNT));

		this.setEnvelope(envelope);

		Metaset header = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Header", "s11");

		Metaset action = NotificationUtil.getMetasetOfPrefix_WSA("Action");

		this.setWSAAction(action);

		header.add(action);
		envelope.add(header);

		this.setHeader(header);

		Metaset body = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Body", "s11");

		envelope.add(body);

		this.setBody(body);
	}

	/**
	 * ֿռ
	 * @param namespace
	 */

	public void addNameSpaceToEnvelope(Attribute namespace) {
		this.envelope.add(namespace);
	}

	/**
	 * ȡеֿռAttribute
	 * @return
	 */
	public List getEnvelopeNameSpace() {
		return this.envelope.attributes();
	}

	/**
	 * @param header Ҫõ header
	 */
	public void setHeader(Metaset header) {
		this.header = header;
	}

	/**
	 * @return  header
	 */
	public Metaset getHeader() {
		return header;
	}

	/**
	 * @param body Ҫõ body
	 */
	public void setBody(Metaset body) {
		this.body = body;
	}

	/**
	 * @return  body
	 */
	public Metaset getBody() {
		return body;
	}

	/**
	 * @param envelope Ҫõ envelope
	 */
	public void setEnvelope(Metaset envelope) {
		this.envelope = envelope;
	}

	/**
	 * @return  envelope
	 */
	public Metaset getEnvelope() {
		return envelope;
	}

	/**
	 * @param wSAAction Ҫõ wSAAction
	 */
	public void setWSAAction(Metaset wSAAction) {
		this.wSAAction = wSAAction;
	}

	/**
	 * @return  wSAAction
	 */
	public Metaset getWSAAction() {
		return wSAAction;
	}

	public Metaset toMetaset() {
		return this.envelope;
	}

}
