package org.act.xservices.rt.xnotification.message.base;

import org.act.xservices.rt.xcontainer.addressing.impl.EndpointReference;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.base.fault.NotificationBaseException;
import org.act.xservices.rt.xnotification.message.broker.DestroyRegistrationRequestMessage;
import org.act.xservices.rt.xnotification.message.broker.DestroyRegistrationResponseMessage;
import org.act.xservices.rt.xnotification.message.broker.RegisterPublisherRequestMessage;
import org.act.xservices.rt.xnotification.message.broker.RegisterPublisherResponseMessage;
import org.act.xservices.rt.xom.Metaset;

/**
 * Ϣɹ
 * 
 * ɵĹǣ
 * <P>
 * Էر
 * <p>
 * 1ҪĲ
 * <p>
 * 2ļжҪظıģ塣ʱдڳУ
 * <p>
 * 3MetaSetΪصıġ
 * <p>
 * 뱨 <CODE> InputMessageImpl<CODE>
 * @return ɵķر
 * 
 * @version 1.0 2008-3-16
 * @author liwu 2006-6-12
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class MessageFactory {

    /**
     * 
     */
    public MessageFactory() {
        super();
    }

    
    public static Message getInputMessage(Metaset inputmessage) {
        InputMessageImpl message = new InputMessageImpl();
        message.buildInputMessage(inputmessage);
        return message;
    }

    //ӦϢϢҪǡby lizq 2008-03-16
    
    /**
     * ֪ͨϢ
     * @param response
     * @return
     */
    public static Message getNofitifyMessage(Metaset response) {
        return new NotifyMessage(response);
    }

    
    
    /**
     *  Ϣ
     * @param request
     * @return
     */
    
    public static Message getSubscribeRequestMessage(Metaset[] topicExpressions,String consumerAddress){
    	
    	Metaset filterM = NotificationUtil.getMetasetOfPrefix_WSNT("Filter");
    	
    	for(Metaset topicExpTemp : topicExpressions){
//    		// ֪ͨϢӦϢ
//    		Metaset topicExpMetaset = new Metaset("wsnt", "TopicExpression");
//    		ITopicNamespace topicNS = topicTemp.getTopicNamespace();
//    		topicExpMetaset.add(new Attribute("Dialect",
//    				"http://docs.oasis-open.org/wsn/t-1/TopicExpression/Concrete"));
//    		topicExpMetaset.add(new Attribute("xmlns:" + topicNS.getName(), topicNS
//    				.getTargetNamespace()));
//    		topicExpMetaset.setValue(topicTemp.toString());
    		filterM.add(topicExpTemp);
    	}
    	
    	SubscribeRequestMessage subReqMessage = new SubscribeRequestMessage(
    			new EndpointReference(consumerAddress),
    			filterM, 
    			"2008-12-25T00:00:00.00000");
    	
    	return subReqMessage;
    }
    
    
    /**
     * ɶӦϢ
     * @param response
     * @return
     */
    public static Message getSubscribeResponseMessage(Metaset response) {
        return new SubscribeResponseMessage(response);
    }
    
    
    /**
     *  ȡϢ
     * @param topicExpressions
     * @param consumerAddress
     * @return
     */
    public static Message getUnsubscribeRequestMessage(Metaset[] topicExpressions,String consumerAddress) {
    	
    	Metaset filterM = NotificationUtil.getMetasetOfPrefix_WSNT("Filter");
    	
    	for(Metaset topicExpTemp : topicExpressions){
    		filterM.add(topicExpTemp);
    	}
    	
    	UnsubscribeRequestMessage unSubReqMessage = new UnsubscribeRequestMessage(
    			new EndpointReference(consumerAddress), filterM);
    	
    	return unSubReqMessage;
    }
    
    
    
    public static Message getUnsubscribeResponseMessage(Metaset response) {
        return new UnsubscribeResponseMessage(response);
    }
    
    

    public static Message getGetCurrentMessageResponseMessage(Metaset response) {
        return new GetCurrentMessageResponseMessage(response);
    }
    
    
    public static Message getRegisterPublisherRequestMessage(Metaset request){
        return new RegisterPublisherRequestMessage(request);
    }
    
    
    public static Message getRegisterPublisherResponseMessage(Metaset response){
        return new RegisterPublisherResponseMessage(response);
    }

    
    public static Message getDestroyRegistrationResponseMessage(){
        return new DestroyRegistrationResponseMessage();
    }
    
    public static Message getDestroyRegistrationRequestMessage(Metaset request){
        return new DestroyRegistrationRequestMessage(request);
    }
    
    



    //------------------------------
    
    public static Message getRenewResponseMessage(Metaset response) {
        return new RenewResponseMessage(response);
    }

    public static Message getPauseSubsciptionResponseMessage() {
        return new PauseSubsciptionResponseMessage();
    }

    
    public static Message getResumeSubsciptionResponseMessage() {
        return new ResumeSubsciptionResponseMessage();
    }
    
    public static Message getDestroyPullPointResponseMessage() {
        return new DestroyPullPointResponseMessage();
    }

    public static Message getCreatePullPointResponseMessage(Metaset response) {
        return new CreatePullPointResponseMessage(response);
    }

    public static Message getGetMessagesResponse(Metaset response) {
        return new GetMessagesResponse(response);
    }
    //-------------------------------

    
    //---÷Ϣʾ. Exceptionаװ
    public static Message getExceptionResponseMessage(NotificationBaseException baseException){
        
    	ExceptionResponseMessage faultmessage = new ExceptionResponseMessage();
    	
        faultmessage.setBody(baseException.toMetaset());
        
    	return faultmessage;
    }
    
    
    
    /**
     * ͻ notifymessage
     * @return
     */
    public static Message getNotifyACKMessage(){
    	return new NotifyACKMessage();
    }
    
    public static Message getGetTopicListResponseMesseage(Metaset responsebody){
    	return new GetTopicListResponseMesseage(responsebody);
    }
    
    
}
