package org.act.xservices.rt.xnotification.message.base;

import java.util.LinkedList;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.xcontainer.addressing.impl.EndpointReference;
import org.act.xservices.rt.xnotification.topic.expression.ITopicExpression;
import org.act.xservices.rt.xnotification.topic.expression.TopicExpressionFactory;
import org.act.xservices.rt.xnotification.util.ConfigException;
import org.act.xservices.rt.xom.Metaset;

/**
 * ֪ͨϢ
 * a notify Message may be compose of several NotificationMessage
 * 
 * @version 1.0 2008-3-13
 * @author liwu 2006-6-12
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public class NotifyMessage extends Message {

	/**֪ͨϢ */
	private NotifyContext notifycontext = null;

	private String actionValue = "http://docs.oasis-open.org/wsn/bw-2/NotificationConsumer/Notify";

	public NotifyMessage(Metaset response) {
		this.buildMessageSkeleton();
		this.getWSAAction().setText(actionValue);
		this.getBody().add(response);
		//ע by cover_eye2007-12-7
		//this.notifycontext = new NotifyContext(this);
	}

	public NotifyMessage(Message message) {
		this.buildMessageFromMetaset(message);

	}

	public void buildMessageFromMetaset(Message message) {

		this.setBody(message.getBody());
		this.setEnvelope(message.getEnvelope());
		this.setHeader(message.getHeader());
		//this.getWSAAction().setValue(actionValue);  
		this.notifycontext = new NotifyContext(this);

	}

	public void config(Metaset config) throws ConfigException {
		// TODO Զɷ

	}

	/**
	 * @return  notifycontext
	 */
	public NotifyContext getNotifycontext() {
		return notifycontext;
	}

	/**
	 * @param notifycontext
	 *            Ҫõ notifycontext
	 */
	public void setNotifycontext(NotifyContext notifycontext) {
		this.notifycontext = notifycontext;
	}

	
	/**
	 * ֪ͨ
	 */
	public static class NotifyContext {
		/**
		 * NotificationMessagelist 洢Notifymessage
		 */
		private List<NotificationMessage> notificationMessagelist = 
			new LinkedList<NotificationMessage>();

		public NotifyContext(Message message) {
			buildNotifyContext(message);
		}


		private void buildNotifyContext(Message notifySoapMes) {

			if (notifySoapMes != null) {
				Metaset notifybody = notifySoapMes.getBody().filter(".\\Notify").car();

				if (notifybody != null) {

					List notifymessagelist = notifybody.elements();
					for (int i = 0; i < notifymessagelist.size(); i++) {

						Metaset notifyMessage = (Metaset) notifymessagelist.get(i);
						
						if ((notifyMessage.getName()).equals("NotificationMessage")) {
							
							NotificationMessage message = new NotificationMessage();

							message.toMetaset = notifyMessage;

							//ȡöĹEPR
							Metaset subref = notifyMessage.filter(".\\SubscriptionReference");
							if (subref != null) {
								EndpointReference subscriptionReference = 
									new EndpointReference(subref.car());
								
								message.setSubscriptionReference(subscriptionReference);
							}

							//producerReference..

							Metaset producerref = notifyMessage.filter(".\\ProducerReference");
							if (producerref != null) {
								EndpointReference producerReference = 
									new EndpointReference(producerref.car());
								message.setProducerReference(producerReference);
							}

							// topic
							Metaset topicExpression = notifyMessage.filter(".\\Topic");
							if (topicExpression != null) {
								ITopicExpression topicExp = TopicExpressionFactory
										.getTopicExpression(topicExpression.car(), 
												notifySoapMes.getEnvelopeNameSpace());
								message.setTopicExpression(topicExp);
							}

							//content
							Metaset notifyContent = notifyMessage.filter(".\\Message");
							if (notifyContent != null) {
								message.setMessageContent(notifyContent.car());
							}

							//added by cover_eye
							notificationMessagelist.add(message);
						}
					}//end of for

				}
			}

		}

		/**
		 * @return  notificationMessagelist
		 */
		public List<NotificationMessage> getNotificationMessagelist() {
			return notificationMessagelist;
		}

		/**
		 * @param notificationMessagelist
		 *            Ҫõ notificationMessagelist
		 */
		public void setNotificationMessagelist(
				List<NotificationMessage> notificationMessagelist) {
			this.notificationMessagelist = notificationMessagelist;
		}

	}//end of class

	
	/**
	 * @author leon liwu@act.buaa.edu.cn
	 *
	 *һNotifyMessageڲ,
	 *ʵпɵNotificationMessage
	 */
	public static class NotificationMessage {
		
		private EndpointReference subscriptionReference = null;

		private ITopicExpression topicExpression = null;

		private EndpointReference producerReference = null;

		private Metaset messageContent = null;

		//add by cover_eye:2007-7-31
		private Metaset toMetaset = null;



		/**
		 * @return  producerReference
		 */
		public EndpointReference getProducerReference() {
			return producerReference;
		}

		/**
		 * @param producerReference
		 *            Ҫõ producerReference
		 */
		public void setProducerReference(EndpointReference producerReference) {
			this.producerReference = producerReference;
		}

		/**
		 * @return  subscriptionReference
		 */
		public EndpointReference getSubscriptionReference() {
			return subscriptionReference;
		}

		/**
		 * @param subscriptionReference
		 *            Ҫõ subscriptionReference
		 */
		public void setSubscriptionReference(
				EndpointReference subscriptionReference) {
			this.subscriptionReference = subscriptionReference;
		}

		/**
		 * @return  topicExpression
		 */
		public ITopicExpression getTopicExpression() {
			return topicExpression;
		}

		/**
		 * @param topicExpression
		 *            Ҫõ topicExpression
		 */
		public void setTopicExpression(ITopicExpression topicExpression) {
			this.topicExpression = topicExpression;
		}

		public Metaset toMetaset() {

			return toMetaset;
		}

		public Metaset getMessageContent() {
			return messageContent;
		}

		public void setMessageContent(Metaset messageContent) {
			this.messageContent = messageContent;
		}

	}

	//NotifyMessageĹвԣ200781
	public static void main(String[] args) {
		try {
			Metaset notify = MetasetParserFactory.getMetasetParser().parse(".\\notify.xml");
			Message input = MessageFactory.getInputMessage(notify);
			NotifyMessage notifyMessage = new NotifyMessage(input);
			//		System.out.println(notifyMessage.getNotifycontext().getNotificationMessagelist().size());
			NotificationMessage notifi = (NotificationMessage) notifyMessage
					.getNotifycontext().getNotificationMessagelist().get(0);
			//		System.out.println(notifi.getTopicExpression());
			//		Topic[] topics = TopicEngine.getTopicEngine().compile(notifi.getTopicExpression());
			//		System.out.println(topics.length);
			EndpointReference reference = new EndpointReference();
			reference
					.setAddress("http://localhost:8080/pubscribe/services/filesystem");
			System.out.println(notifi.getProducerReference().getAddress());
		} catch (Exception e) {
			// TODO Զ catch 
			e.printStackTrace();
		}
	}
}
