
package org.act.xservices.rt.xnotification.message.broker;

import org.act.xservices.rt.xnotification.NotificationConstants;
import org.act.xservices.rt.xnotification.NotificationUtil;
import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

/**
 * 
 * @version 1.0 2008-3-16
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-8-30
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public abstract class BrokerMessage extends Message {

   protected void buildMessageSkeleton() {

		Metaset envelope = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Envelope", "s11");

		envelope.add(NotificationUtil.getNewAttribute(
				new QName("","wsn-br","xmlns"),NotificationConstants.URI_NS_WSN_BR));
		
		envelope.add(NotificationUtil.getNewAttribute(
				new QName("","s11","xmlns"),"http://schemas.xmlsoap.org/soap/envelope/"));
		
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "xsi","xmlns"),
		"http://www.w3.org/2001/XMLSchema-instance"));
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "xsd", "xmlns"),
		"http://www.w3.org/2001/XMLSchema"));
		
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "wsa", "xmlns"),
		"http://www.w3.org/2005/08/addressing"));
		
		envelope.add(NotificationUtil.getNewAttribute(new QName("", "wsnt", "xmlns"),
				NotificationConstants.URI_NS_WSNT));

		this.setEnvelope(envelope);

		Metaset header = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Header", "s11");

		Metaset action = NotificationUtil.getMetasetOfPrefix_WSA("Action");

		this.setWSAAction(action);

		header.add(action);
		envelope.add(header);

		this.setHeader(header);

		Metaset body = NotificationUtil.getMetaset(
				"http://schemas.xmlsoap.org/soap/envelope/", "Body", "s11");

		envelope.add(body);

		this.setBody(body);
	}

}
