
package org.act.xservices.rt.xnotification.message.broker;

import org.act.xservices.rt.xnotification.message.base.Message;
import org.act.xservices.rt.xnotification.util.ConfigException;
import org.act.xservices.rt.xom.Metaset;


/**
 * 
 * @version 1.0 2008-3-16
 * @author cover_eye wangyg@act.buaa.edu.cn 2007-7-27
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class RegisterPublisherRequestMessage extends Message {
	
	/*
	 * 
	 * <s:Envelope ... > <s:Header> <wsa:Action>
	 * http://docs.oasis-open.org/wsn/brw-2/RegisterPublisher/RegisterPublisherRequest
	 * </wsa:Action> ... </s:Header> 
	 * <s:Body> 
	 * <wsn-br:RegisterPublisher>
	 *  <wsn-br:PublisherReference>
	 *   <wsa:Address>
	 *     http://www.example.org/PublisherEndpoint 
	 *   </wsa:Address>
	 *   <wsa:ReferenceParameters> 
	 *      <npex: NPResourceDisambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22 </npex:NPResourceDisambiguator> 
	 *   </wsa:ReferenceParameters>
	 *  </wsn-br:PublisherReference> 
	 *  <wsn-br:Topic 
	 *         Dialect="http://docs.oasis-open.org/wsn/t-1/TopicExpression/Simple">npex:SomeTopic </wsn-br:Topic> 
	 *  <wsn-br:Demand> true </wsn-br:Demand>
	 *  <wsn-br:InitialTerminationTime> 2003-12-25T00:00:00.00000Z</wsn-br:InitialTerminationTime> 
	 * </wsn-br:RegisterPublisher>
	 * </s:Body> 
	 * </s:Envelope>
	 */
	
	
	private  String actionValue=
		"http://docs.oasis-open.org/wsn/brw-2/RegisterPublisher/RegisterPublisherRequest";
    
    public RegisterPublisherRequestMessage(Metaset messagebody) {
        buildMessageSkeleton();
        this.getWSAAction().setText(actionValue);
        this.getBody().add(messagebody); // TODO Զɹ캯
    }
    

	public void config(Metaset config) throws ConfigException {
	}

}
