package org.act.xservices.rt.xnotification.provider;

import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.addressing.impl.EndpointReference;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xnotification.WSNRuntime;
import org.act.xservices.rt.xnotification.base.INotificationPublisher;
import org.act.xservices.rt.xnotification.base.impl.NotificationProducer;
import org.act.xservices.rt.xnotification.base.impl.NotificationPublisher;
import org.act.xservices.rt.xnotification.broker.impl.NotificationBroker;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.provider.ResourceProvider;

/**
 * ֪ͨ
 * 
 * @LastModifyTime 2009-4-18
 * @CreationTime 2008-01-08
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class NotificationProvider extends ResourceProvider{
	
	
	/**
	 * ÿ֪ͨ һ֪ͨɫߣߣ֪ͨߣ
	 * ֪ͨϢ֪ͨɫ
	 */
	private INotificationPublisher notificationRole;
	
	
	/**
	 * 
	 */
	public NotificationProvider(){
	}
	
	

	
	public void init(IConfigElement providerConfig, XcService xcService) throws Exception {
		
		IConfigElement[] providerParameters = 
			providerConfig.getChildrenWithName("Parameter");
		
		//жǷͨ
		boolean isNormalService = true;
		for (int i = 0; i < providerParameters.length; i++) {
			if (providerParameters[i].getAttribute("Name").equals("ResourceClassName")) {
				isNormalService = false;
				break;
			}
		}
		
		
		if(!isNormalService){
			//Դ
			super.init(providerConfig, xcService);
			
		}else{
			//ͨ
			this.type = providerConfig.getAttribute("Type");
			this.mepURI = "http://www.w3.org/ns/wsdl/in-out";
		}
		
		
		//ʼ֪ͨز 
		IConfigElement notificationParameter = 
			providerConfig.getFirstChildWithName("NotificationParameter");
		
		if(notificationParameter != null){
			String notiType = notificationParameter.getAttribute("Type");
			
			//֪ͨ
			if(notiType.equals("publisher")){
				String pubAddress = 
					notificationParameter.getFirstChildWithName("PublisherReference").
					getFirstChildWithName("Address").getValue().trim();
				
				String brokerAddress = 
					notificationParameter.getFirstChildWithName("BrokerReference").
					getFirstChildWithName("Address").getValue().trim();
				
				NotificationPublisher publisher = new NotificationPublisher(pubAddress);
				publisher.setNotificationBrokerEPR(new EndpointReference(brokerAddress));
				
				WSNRuntime.getRuntime().registerPublisher(pubAddress, publisher);
				
				notificationRole = publisher;
				
			}else if(notiType.equals("producer")){
				 //֪ͨ
				String pubAddress = 
					notificationParameter.getFirstChildWithName("ProducerReference").
					getFirstChildWithName("Address").getValue().trim();
				
				NotificationProducer producer = new NotificationProducer(
						new EndpointReference(pubAddress));
				
				//Ƿʹôģʽ
				String isBroker = notificationParameter.getAttribute("IsBroker");
				if(isBroker.equals("true")){
					String brokerAddress = 
						notificationParameter.getFirstChildWithName("BrokerReference").
						getFirstChildWithName("Address").getValue().trim();
					producer.setNotificationBrokerEPR(new EndpointReference(brokerAddress));
					producer.setUseBroker(true);
				}
				
				WSNRuntime.getRuntime().registerPublisher(pubAddress, producer);
				
				notificationRole = producer;
				
			}else if(notiType.equals("broker")){
				//֪ͨ
				String brokerAddress = 
					notificationParameter.getFirstChildWithName("BrokerReference").
					getFirstChildWithName("Address").getValue().trim();
				
				NotificationBroker broker = 
					new NotificationBroker(new EndpointReference(brokerAddress));
				
				WSNRuntime.getRuntime().registerBroker(brokerAddress, broker);
				
				notificationRole = broker;
				
			}
			
		}
		
	}//end of config
	
	
	
	/** 
	 * ڴ˴ɽػϢ
	 * @param serviceContext
	 * @return
	 */
	
	/** 
	 * 
	 * 
	 * @param serviceContext
	 * @return
	 * @throws ProviderProcessException
	 * @throws ServiceProcessException
	 */
	public IServiceContext invokeBusinessLogic(IServiceContext serviceContext
			) throws ProviderProcessException, ServiceProcessException{
		
		//֪ͨĲ,֪ͨ
        if ( WSNRuntime.getRuntime().getNotifyMessageBus().isNotificationMessage(
        		serviceContext.getXcOperation().getQName().getName()) ) {
        	
        	Metaset response = null;
        	
        	
        	//ע˴ifжϵ˳ܸģС
        	if(notificationRole instanceof NotificationBroker){
				//֪ͨ
				NotificationBroker broker = (NotificationBroker) notificationRole;
				response = WSNRuntime.getRuntime().getNotifyMessageBus().forward2Broker(
						serviceContext.getInMessage(),
						serviceContext.getXcService().getServiceName(),
						serviceContext.getXcOperation().getQName().getName(),
						broker);
				
			}else if(notificationRole instanceof NotificationProducer){
				//֪ͨ
				NotificationProducer producer = (NotificationProducer) notificationRole;
				response = WSNRuntime.getRuntime().getNotifyMessageBus().forward2Producer(
						serviceContext.getInMessage(),
						serviceContext.getXcService().getServiceName(),
						serviceContext.getXcOperation().getQName().getName(),
						producer);
				
			}else if (notificationRole instanceof NotificationPublisher) {
        		//֪ͨ
				NotificationPublisher publisher = (NotificationPublisher) notificationRole;
				response = WSNRuntime.getRuntime().getNotifyMessageBus().forward2Publisher(
								serviceContext.getInMessage(),
								serviceContext.getXcService().getServiceName(),
								serviceContext.getXcOperation().getQName().getName(),
								publisher);
			}
        	
        	// add by viking  
        	 ISOAPEnvelope envelope=SOAPMessageUtil.convertMetasetToSOAPEnvelope(response);
        	//÷Ϣ
			serviceContext.setOutMessage(envelope);
			
			return serviceContext;
			
		}else{
			//֪ͨԴ˴д lizq 2008-01-08
			return super.invokeBusinessLogic(serviceContext);
		}
        
	}

}
