
package org.act.xservices.rt.xnotification.topic;

import java.util.Iterator;
import java.util.List;

import org.act.xservices.rt.xcontainer.addressing.IEndpointReference;
import org.act.xservices.rt.xom.Metaset;

/**
 * Interface for representing a topic. 
 * A topic is either a child of a parent topic or in the case of root topics of TopicNamespace. 
 * Non-root topics have names without a namespace component.
 * 
 * Ϊtopicڵ,Ҫжڵص(ӽڵ㣨topicɾ), ־topic:
 * <p>topic,messageType,final, parent MessagePattern
 * 
 * @version 1.0 2007-8-9
 * @author cover_eye wangyg@act.buaa.edu.cn
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public interface ITopic extends ITopicNode {

	/**
	 * Get the name of this topic.
	 *
	 * @return the name of this topic
	 */
	public String getName();

	/**
	 * Set the TopicSpace this Topic is part of
	 *
	 * @param topicNs The TopicSpace this Topic is part of
	 */
	public void setTopicNamespace(ITopicNamespace topicNs);

	/**
	 * Gets the TopicSpace this Topic is part of
	 *
	 * @return the TopicSpace this Topic is part of
	 */
	public ITopicNamespace getTopicNamespace();

	/**
	 * Set the topic path. The topic path is represented as a ordered list of topic names
	 *
	 * @param topicPath The topic path to associate with this topic
	 */
	public void setTopicPath(List<String> topicPath);

	/**
	 * Get the topic path. The topic path is represented as an ordered list of topic names
	 *
	 * @return The topic path of this topic
	 */
	public List<String> getTopicPath();

	
	/**
	 * ǲǲҶӽڵ
	 * finalˡ
	 * @return
	 */
	public boolean isFinal();

	public void setFinal(boolean value);

	/**
	 * Returns this topic as a Metaset 
	 * @return
	 */
	public Metaset toMetaset();

	
	
	//cover_eye(2007-8-9):ЩӿҪٿǷбҪ

	//Ӧ
	public void setContent(Object contenct);

	public Object getContect();

	//Ӧĸ㣬WSN1.3淶ֻиſиԡ
	public void setParent(String concretTopicExpression);

	public String getParent();

	//ָ֧ߡ
	public Iterator getProducerIterator();

	public void addNotificationProducer(IEndpointReference notificationEPR);

	public boolean containNotificationProducer(IEndpointReference notificationEPR);
	
	
	/**
	 * ôConcrete ͵ıʽ
	 * @return
	 */
	public Metaset getConcreteExpression();
	
	
	
	
	
}
