
package org.act.xservices.rt.xnotification.topic.expression;

import org.act.xservices.rt.xnotification.base.ITopicTreesSet;
import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.base.fault.TopicNotSupportedException;
import org.act.xservices.rt.xnotification.topic.ITopic;
import org.act.xservices.rt.xnotification.topic.exception.UnsupportedTopicExpressionException;

/**
 * 
 * @version 1.0 2008-3-4
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-5-12
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public interface ITopicCompileEngine {

	/**
	 * ʽָ
	 * 
	 * @param expression
	 * @return
	 * @throws UnsupportedTopicExpressionException
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public ITopic[] compile(ITopicExpression expression,
			ITopicTreesSet topicTreesSet)
			throws UnsupportedTopicExpressionException,
			InvalidTopicExpressionException, TopicNotSupportedException;

	/**
	 * TopicTreesSetʽָ
	 * 
	 * @param expression
	 * @param topicTreesSet
	 * @return
	 * @throws UnsupportedITopicExpressionException
	 * @throws InvalidITopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public ITopic addTopic(ITopicExpression expression, ITopicTreesSet topicTreesSet)
			throws UnsupportedTopicExpressionException,
			InvalidTopicExpressionException, TopicNotSupportedException;
	
	
	/**
	 * TopicTreesSetʽָ
	 * ڸ⣬й
	 * ˴صעܹ޷ɾ⣬Ϊûбʽָдǣ by lizq
	 * @param expression
	 * @param topicTreesSet
	 * @return
	 * @throws UnsupportedTopicExpressionException
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public ITopic addTopicTryBest(ITopicExpression expression, ITopicTreesSet topicTreesSet)
	throws UnsupportedTopicExpressionException,InvalidTopicExpressionException, 
	TopicNotSupportedException;
	
	

	/**
	 * TopicTreesSetɾʽָ
	 * Ӹ׽ڵ㵱ɾӽڵ㡣
	 * 
	 * @param topicExpression
	 * @param topic
	 * @return
	 * @throws UnsupportedITopicExpressionException
	 * @throws TopicNotSupportedException
	 * @throws InvalidITopicExpressionException
	 */
	public boolean removeTopic(ITopicExpression topicExpression,
			ITopicTreesSet topicTreesSet)
			throws UnsupportedTopicExpressionException,
			InvalidTopicExpressionException, TopicNotSupportedException;
	
	
	/**
	 * TopicTreesSetɾʽָ
	 * ɾⲻڣtrue
	 * 
	 * @param topicExpression
	 * @param topic
	 * @return
	 * @throws UnsupportedITopicExpressionException
	 * @throws TopicNotSupportedException
	 * @throws InvalidITopicExpressionException
	 */
	public boolean removeTopicTryBest(ITopicExpression topicExpression,
			ITopicTreesSet topicTreesSet)
			throws UnsupportedTopicExpressionException,
			InvalidTopicExpressionException, TopicNotSupportedException;
	
	
	
	
	
	/**
	 * 
	 * @param expression
	 * @return
	 */
	public void registerTopicCompiler(ITopicExpressionCompiler expression);

	public boolean removeTopicCompiler(ITopicExpressionCompiler expression);

	/**
	 * 
	 * @ return supportedTopiclanguage in a array
	 * 
	 **/
	public String[] getSupportedTopicCompilerName();
}
