package org.act.xservices.rt.xnotification.topic.expression;

import org.act.xservices.rt.xnotification.base.ITopicTreesSet;
import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.base.fault.TopicNotSupportedException;
import org.act.xservices.rt.xnotification.topic.ITopic;

/**
 * ʽ
 * 
 * @version 1.0 2008-3-4
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-5-22
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

public interface ITopicExpressionCompiler {

	/**
	 * õֵ֧Dialect
	 * @return
	 */
	public String getSupportedDialectName();

	/**
	 * ڸTopicTreesSetϽ ʽ  
	 * Ҳ
	 * @param expression
	 * @return
	 * @throws InvalidTopicExpressionException 
	 * @throws TopicNotSupportedException 
	 */
	public ITopic[] compile(ITopicExpression expression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException;

	
	/**
	 * ڸTopicTreesSet  ʽ 
	 * Ӳ
	 * @param expression
	 * @param namespace
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */

	public ITopic add(ITopicExpression expression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException;

	
	/**
	 * TopicTreesSetʽָ
	 * Ŭӣڸ⣬й
	 * 
	 * @param expression
	 * @param topicTreesSet
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public ITopic addTryBest(ITopicExpression expression, ITopicTreesSet topicTreesSet)
	throws InvalidTopicExpressionException, TopicNotSupportedException;
	
	
	
	/**
	 * ڸTopicTreesSet ɾ ʽ 
	 * ɾ
	 * @param topicExpression
	 * @param namespace
	 * @param topic
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public boolean remove(ITopicExpression topicExpression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException;
	
	/**
	 * ڸTopicTreesSet Ŭ ɾ ʽ 
	 * Ҳ⣬trueⲻ
	 * @param topicExpression
	 * @param namespace
	 * @param topic
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public boolean removeTryBest(ITopicExpression topicExpression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException;

}
