package org.act.xservices.rt.xnotification.topic.expression;

import java.util.Calendar;
import java.util.Map;

import org.act.xservices.rt.xnotification.base.ITopicTreesSet;
import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;
import org.act.xservices.rt.xnotification.base.fault.TopicNotSupportedException;
import org.act.xservices.rt.xnotification.topic.ITopic;
import org.act.xservices.rt.xnotification.topic.ITopicNamespace;
import org.act.xservices.rt.xnotification.topic.TopicConstants;
import org.act.xservices.rt.xnotification.topic.TopicNamespaceFactory;

/**
 * simple ͵ʽ
 * @version 1.0 2008-3-4
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-5-22
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class SimpleTopicExpressionCompiler implements ITopicExpressionCompiler {

	/** 
	 * ڸTopicTreesSetϽʽ 
	 * Simple ͵ıʽһʽָһ
	 * Ҳ򷵻null
	 * @param expression
	 * @param topicTreesSet
	 * @return  
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 * @see org.act.xservices.rt.xnotification.topic.expression.ITopicExpressionCompiler#compile(org.act.xservices.rt.xnotification.topic.expression.ITopicExpression, org.act.xservices.rt.xnotification.base.ITopicTreesSet)
	 */
	public ITopic[] compile(ITopicExpression expression,
			ITopicTreesSet topicTreesSet) throws InvalidTopicExpressionException, TopicNotSupportedException {

		Map<String,String> tpNSMap = expression.getTopicNamespaceMap();

		//ƿռ·ֿ
		String[] s = TopicExpressionHelper.splitExpression(expression.getContent());
		
		String namespaceuri = null;
		
		System.out.println("SimpleTopicExpressionCompiler.compile():" + s[0]); //
		
		namespaceuri = tpNSMap.get(s[0]);
		
		System.out.println("SimpleTopicExpressionCompiler.compile():"+ namespaceuri ); //
		

		if (namespaceuri == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}
		
		//л
		ITopicNamespace namespace = topicTreesSet.getTopicTreeByTopicNamespace(namespaceuri);
		
		if (namespace == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}

		//simple͵ʽֻӦһ
		ITopic topic = namespace.getTopic(s[1]);
		
		System.err.println("Topic in engine:" + topic);
		
		if(topic == null){
			return null;
		}
		
		return new ITopic[]{topic};
	}

	
	public String getSupportedDialectName() {
		return TopicConstants.SIMPLE_TOPICEXPRESSION;
	}

	
	
	public ITopic add(ITopicExpression expression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException {
		
		Map<String,String> tpNSMap = expression.getTopicNamespaceMap();

		String[] s = TopicExpressionHelper.splitExpression(expression.getContent());// 
		
		String namespaceuri = null;
		
		System.out.println("SimpleTopicExpressionCompiler.add():" + expression.getContent());

		namespaceuri = tpNSMap.get(s[0]);
		
		System.out.println("SimpleTopicExpressionCompiler.add():"+ s[0]+":"+namespaceuri );
		
		if (namespaceuri == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}

		ITopicNamespace namespace = TopicNamespaceFactory.getInstance()
				.getTopicNamespace(s[0], namespaceuri, topicTreesSet);

		if (namespace == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}

		//Ѵڣô滻ǰ⡣
		ITopic topic = namespace.addTopic(s[1]);
		
		
		
		return topic;
	}
	
	/**
	 * TopicTreesSetʽָ
	 * ڸ⣬й
	 * 
	 * @param expression
	 * @param topicTreesSet
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public ITopic addTryBest(ITopicExpression expression, ITopicTreesSet topicTreesSet)
	throws InvalidTopicExpressionException, TopicNotSupportedException{
		return this.add(expression, topicTreesSet);
	}
	
	

	public boolean remove(ITopicExpression expression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException {
		
		Map<String,String> tpNSMap = expression.getTopicNamespaceMap();

		String[] s = TopicExpressionHelper.splitExpression(expression
				.getContent());// 
		String namespaceuri = null;
		System.out.println("SimpleTopicExpressionCompiler.compile():" + s[0]);
		namespaceuri = tpNSMap.get(s[0]);
		System.out.println("SimpleTopicExpressionCompiler.compile():"+ namespaceuri );
		
		if (namespaceuri == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}

		//л
		ITopicNamespace namespace = topicTreesSet.getTopicTreeByTopicNamespace(namespaceuri);

		if (namespace == null) {
			throw new TopicNotSupportedException("TopicNotSupportedException",
					Calendar.getInstance(),"TopicNotSupportedException in namespace");
		}

		namespace.removeTopic(s[1]);

		return true;

	}
	
	/**
	 * ڸTopicTreesSet Ŭ ɾ ʽ 
	 * Ҳ⣬trueⲻ
	 * @param topicExpression
	 * @param namespace
	 * @param topic
	 * @return
	 * @throws InvalidTopicExpressionException
	 * @throws TopicNotSupportedException
	 */
	public boolean removeTryBest(ITopicExpression topicExpression, ITopicTreesSet topicTreesSet)
			throws InvalidTopicExpressionException, TopicNotSupportedException{
		
		return this.remove(topicExpression, topicTreesSet);
	}

}
