
package org.act.xservices.rt.xnotification.topic.expression;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.xnotification.topic.TopicConstants;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;

/**
 * ʽ
 * @version 1.0 2008-3-5
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-7-1
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class TopicExpressionFactory {

	/**
     * <wsnt:TopicExpression Dialect="xsd:anyURI">
     * {any} ?
     * </wsnt:TopicExpression>
	 */
	
	
    /**
     * Metasetʽʽ  ʽ
     * @param topicExpression
     * @param topicnamespaceNameList
     * @return
     */
    public static ITopicExpression getTopicExpression(Metaset topicExpression, 
    		List topicnamespaceNameList) {

        List list = topicExpression.attributes();
        String s = null;
        String dialect = null;

        for (int i = 0; i < list.size(); i++) {
            s = ((Attribute) list.get(i)).getName();
            if ("Dialect".equals(s)) {
                dialect = ((Attribute) list.get(i)).getText();
            }
        }
        
        Map<String,String> tpNSMap = new HashMap<String, String>();
        for (int i = 0; i < topicnamespaceNameList.size(); i++) {
        	tpNSMap.put(((Attribute) topicnamespaceNameList.get(i)).getName(),
        			((Attribute) topicnamespaceNameList.get(i)).getText());
        }
        
        //----------ʽҲ--------ʱԴʩby lizq 2008-03-19
        for (int i = 0; i < list.size(); i++) {
        	tpNSMap.put(((Attribute) list.get(i)).getName(),
        			((Attribute) list.get(i)).getText());
        }
        //----------
        
        
        if (dialect.equals(TopicConstants.SIMPLE_TOPICEXPRESSION)) {
            return new SimpleTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.CONCRETE_TOPICEXPRESSION)) {
            return new ConcreteTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.FULL_TOPICEXPRESSION)) {
            return new FullTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.XPATH_TOPICEXPRESSION)) {
            return new XpathTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        }
        return null;

    }
    
    
    public static ITopicExpression getTopicExpression(Metaset topicExpression, 
    		Map<String,String> tpNSMap) {

        List list = topicExpression.attributes();
        String s = null;
        String dialect = null;

        for (int i = 0; i < list.size(); i++) {
            s = ((Attribute) list.get(i)).getName();
            if ("Dialect".equals(s)) {
                dialect = ((Attribute) list.get(i)).getText();
            }
        }
        
        if (dialect.equals(TopicConstants.SIMPLE_TOPICEXPRESSION)) {
            return new SimpleTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.CONCRETE_TOPICEXPRESSION)) {
            return new ConcreteTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.FULL_TOPICEXPRESSION)) {
            return new FullTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        } else if (dialect.equals(TopicConstants.XPATH_TOPICEXPRESSION)) {
            return new XpathTopicExpression(dialect, topicExpression
                    .getText(),tpNSMap);
        }
        return null;

    }
    

}
