
package org.act.xservices.rt.xnotification.topic.expression;

import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;

import org.act.xservices.rt.xnotification.base.fault.InvalidTopicExpressionException;

/**
 * 
 * @version 1.0 2008-3-4
 * @author cover_eye wangyg@act.buaa.edu.cn 2006-7-2
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class TopicExpressionHelper {

	public TopicExpressionHelper() {

	}

	public static String[] splitExpression(String s)
			throws InvalidTopicExpressionException {
		if ((s.indexOf("//") != -1) || (s.indexOf("*") != -1)
				|| (s.indexOf("|") != -1) || (s.indexOf(".") != -1)) {
			// FIXME:.....This ....needs to be fixed...
			throw new InvalidTopicExpressionException(
					"Topic path '"
							+ "' contains one or more illegal characters ('//', '*', '|' or '.').",
					null, null, null, s, null);
		}
		// fs:MountPointDirectory
		StringTokenizer st = new StringTokenizer(s, ":");
		String[] name = new String[2];
		if (st.hasMoreTokens()) {
			name[0] = st.nextToken();
		}

		name[1] = s.substring(name[0].length() + 1);

		return name;
	}

	public static List<String> splitExpressionConcrete(String s) {
		// t1/t3/t4

		StringTokenizer st = new StringTokenizer(s, "/");
		List<String> namelist = new LinkedList<String>();

		while (st.hasMoreTokens()) {
			// System.out.print(st.nextToken());
			namelist.add(st.nextToken());

		}
		return namelist;

	}

	public static void main(String[] args) {
		try {
			System.out.println(TopicExpressionHelper.splitExpression("fs:MountPointDirectory/kdf")[1]);

			System.out.println(TopicExpressionHelper
					.splitExpressionConcrete("FirstRound/SecondLayer/Third"));
		} catch (InvalidTopicExpressionException e) {
			// TODO Զ catch 
			e.printStackTrace();
		}

	}

}
