package org.act.xservices.rt.soap.builder;

/**
 * 
 * @author Viking.Liu
 * @date 2010-6-10
 * @version 1.0.0
 * @since JDK 1.5
 *
 */
/**
 * This class is used to create SOAPBuilder. There are three SOAPBuilder,
 * SOAPSAXBuilder, SOAPStAXBuilder and SOAPXPPBuilder. The system has set
 * default SOAPBuilder. If you want to use one of the SOAPBuilders
 * specifically,please refer to <Code>SOAPSAXBuilder</Code> ,
 * <Code>SOAPStAXBuilder</Code> and <Code>SOAPXPPBuilder</Code>
 */
public class SOAPBuilderFactory {
	/**
	 * Gets the Default SOAPBuilder instance
	 * 
	 * @return Default SOAPBuilder which is set by the system.
	 */
	public static ISOAPBuilder getSOAPBuilder() {
		return newSOAPBuilder();
	}

	public static ISOAPBuilder newSOAPBuilder() {
		return new SOAPSAXBuilder();
	}

	public static ISOAPBuilder newSOAPSAXBuilder() {
		return new SOAPSAXBuilder();
	}

	public static ISOAPBuilder newSOAPStAXBuilder() {
		return new SOAPStAXBuilder();
	}

	public static ISOAPBuilder newSOAPXPPBuilder() {
		return new SOAPXPPBuilder();
	}
}
