package org.act.xservices.rt.soap.constants;

import org.act.xservices.rt.xom.QName;

/**
 * 
 * @author Viking.Liu
 * @time 2010-4-9
 * @version 1.0.0
 * @since JDK 1.6
 * 
 */
public class SOAP11Constants extends SOAPConstants {

	public static final String SOAP_ENVELOPE_NAMESPACE_URI = "http://schemas.xmlsoap.org/soap/envelope/";
	public static final String SOAP_ENCODING_NAMESPACE_URI = "http://schemas.xmlsoap.org/soap/encoding/";

	/** Field ATTR_ACTOR */
	public static final String ATTR_ACTOR = "actor";

	/** Field SOAP_FAULT_CODE_NAME */
	public static final String SOAP_FAULT_CODE_NAME = "faultcode";
	/** Field SOAP_FAULT_STRING_NAME */
	public static final String SOAP_FAULT_STRING_NAME = "faultstring";
	/** Field SOAP_FAULT_ACTOR_NAME */
	public static final String SOAP_FAULT_ACTOR_NAME = "faultactor";
	/** Field SOAP_FAULT_DETAIL_NAME */
	public static final String SOAP_FAULT_DETAIL_NAME = "detail";

	// SOAP 1.2 Content Type
	public static final String SOAP_11_CONTENT_TYPE = "text/xml";

	public static final String SOAP_ACTOR_NEXT = "http://schemas.xmlsoap.org/soap/actor/next";

	// QNames
	/**
	 * Actor QName
	 */
	public static final QName QNAME_ACTOR = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, ATTR_ACTOR);

	/**
	 * MustUnderstand QName
	 */
	public static final QName QNAME_MU_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_MUSTUNDERSTAND);
	/**
	 * Sender Fault Code QName
	 */
	public static final QName QNAME_SENDER_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_SENDER);
	/**
	 * Receive Fault Code QName
	 */
	public static final QName QNAME_RECEIVER_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_RECEIVER);

	/**
	 * Fault String QName
	 */
	public static final QName QNAME_FAULT_REASON = new QName(
			SOAP_FAULT_STRING_NAME);
	/**
	 * Fault Code QName
	 */
	public static final QName QNAME_FAULT_CODE = new QName(SOAP_FAULT_CODE_NAME);
	
	/**
	 * Fault Detail QName
	 */
	public static final QName QNAME_FAULT_DETAIL = new QName(
			SOAP_FAULT_DETAIL_NAME);
	/**
	 * Fault Actor QName
	 */
	public static final QName QNAME_FAULT_ROLE = new QName(
			SOAP_FAULT_ACTOR_NAME);
}
