package org.act.xservices.rt.soap.constants;

import org.act.xservices.rt.xom.QName;


/**
 * 
 * @author Viking.Liu
 * @time 2010-4-9
 * @version 1.0.0
 * @since JDK 1.6
 * 
 */
public class SOAP12Constants extends SOAPConstants {

	public static final String SOAP_ENVELOPE_NAMESPACE_URI = "http://www.w3.org/2003/05/soap-envelope";
	public static final String SOAP_ENCODING_NAMESPACE_URI = "http://www.w3.org/2003/05/soap-encoding";

	public static final String SOAP_ROLE = "role";
	public static final String SOAP_RELAY = "relay";

	// SOAP Fault Code
	public static final String SOAP_FAULT_CODE_NAME = "Code";
	public static final String SOAP_FAULT_SUB_CODE_NAME = "Subcode";
	public static final String SOAP_FAULT_VALUE_NAME = "Value";

	public static final String FAULT_CODE_DATAENCODINGUNKNOWN = "DataEncodingUnknown";
	// SOAP Fault Reason
	public static final String SOAP_FAULT_REASON_NAME = "Reason";
	public static final String SOAP_FAULT_TEXT_NAME = "Text";
	public static final String SOAP_FAULT_TEXT_LANG_ATTR_NAME = "lang";
	public static final String SOAP_FAULT_TEXT_LANG_ATTR_NS_URI = "http://www.w3.org/XML/1998/namespace";
	public static final String SOAP_FAULT_TEXT_LANG_ATTR_NS_PREFIX = "xml";

	// SOAP Fault Node
	public static final String SOAP_FAULT_NODE_NAME = "Node";

	// SOAP Fault Detail
	public static final String SOAP_FAULT_DETAIL_NAME = "Detail";

	// SOAP Fault Role
	public static final String SOAP_FAULT_ROLE_NAME = "Role";

	// SOAP 1.2 Content Type
	public static final String SOAP_12_CONTENT_TYPE = "application/soap+xml";

	public static final String SOAP_ROLE_NEXT = "http://www.w3.org/2003/05/soap-envelope/role/next";
	public static final String SOAP_ROLE_NONE = "http://www.w3.org/2003/05/soap-envelope/role/none";
	public static final String SOAP_ROLE_ULTIMATE_RECEIVER = "http://www.w3.org/2003/05/soap-envelope/role/ultimateReceiver";

	// QNames
	/**
	 * Role QName
	 */
	public static final QName QNAME_ROLE = new QName(SOAP_ENVELOPE_NAMESPACE_URI,
			SOAP_ROLE);

	/**
	 * Relay QName
	 */
	public static final QName RELAY = new QName(SOAP_ENVELOPE_NAMESPACE_URI,
			SOAP_RELAY);

	/**
	 * MustUnderstand QName
	 */
	public static final QName QNAME_MU_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_MUSTUNDERSTAND);

	/**
	 * Sender QName
	 */
	public static final QName QNAME_SENDER_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_SENDER);

	/**
	 * Receiver QName
	 */
	public static final QName QNAME_RECEIVER_FAULTCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, FAULT_CODE_RECEIVER);
	/**
	 * Reason QName
	 */
	public static final QName QNAME_FAULT_REASON = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_REASON_NAME);
	/**
	 * Code QName
	 */
	public static final QName QNAME_FAULT_CODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_CODE_NAME);

	/**
	 * Node QName
	 */
	public static final QName QNAME_FAULT_NODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_NODE_NAME);

	/**
	 * Detail QName
	 */
	public static final QName QNAME_FAULT_DETAIL = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_DETAIL_NAME);

	/**
	 * Role QNameQ
	 */
	public static final QName QNAME_FAULT_ROLE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_ROLE_NAME);

	/**
	 * Value QName
	 */
	public static final QName QNAME_FAULT_VALUE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_VALUE_NAME);

	/**
	 * SubCode QName
	 */
	public static final QName QNAME_FAULT_SUBCODE = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_SUB_CODE_NAME);

	/**
	 * Text QName
	 */
	public static final QName QNAME_FAULT_TEXT = new QName(
			SOAP_ENVELOPE_NAMESPACE_URI, SOAP_FAULT_TEXT_NAME);
}
