package org.act.xservices.rt.soap.exception;

/**
 * 
 * @author Viking.Liu
 * @time 2010-4-9
 * @version 1.0.0
 * @since JDK 1.6
 * 
 */
public class SOAPProcException extends SOAPException {

	private static final long serialVersionUID = -5432612295193716211L;

	private String soapFaultCode;

	/** Eran Chinthaka (chinthaka@apache.org) */
	public SOAPProcException(String message) {
		super(message);
	}

	public SOAPProcException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param messageText
	 *            - this will appear as the Text in the Reason information item
	 *            of SOAP Fault
	 * @param faultCode
	 *            - this will appear as the Value in the Code information item
	 *            of SOAP Fault
	 * @param cause
	 *            - this will appear under the Detail information item of SOAP
	 *            Fault
	 */
	public SOAPProcException(String messageText, String faultCode,
			Throwable cause) {
		super(messageText, cause);
		this.soapFaultCode = faultCode;
	}

	/**
	 * @param messageText
	 *            - this will appear as the Text in the Reason information item
	 *            of SOAP Fault
	 * @param faultCode
	 *            - this will appear as the Value in the Code information item
	 *            of SOAP Fault
	 */
	public SOAPProcException(String messageText, String faultCode) {
		super(messageText);
		this.soapFaultCode = faultCode;
	}

	public String getFaultCode() {
		return soapFaultCode;
	}

	public void setFaultCode(String soapFaultCode) {
		this.soapFaultCode = soapFaultCode;
	}
}
