package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPFaultCode;
import org.act.xservices.rt.soap.ISOAPFaultSubCode;
import org.act.xservices.rt.soap.ISOAPFaultValue;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.tree.DefaultElement;

/**
 * 
 * @author Viking.Liu
 * @date 2010-6-3
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public abstract class SOAPFaultCodeImpl extends DefaultElement implements
		ISOAPFaultCode {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAPFaultCodeImpl(QName qname) {
		super(qname);
	}

	public SOAPFaultCodeImpl(String name, Namespace namespace) {
		super(name, namespace);
	}

	public SOAPFaultCodeImpl(String name) {
		super(name);
	}

	public void addFaultSubCode(ISOAPFaultSubCode soapSubCode)
			throws SOAPProcException {
		if (elements().size() == 1) {
			if (getFaultValue() == null) {
				throw new SOAPProcException(
						"SOAP Fault Code first child is not Fault Value.");
			}
		} else {
			throw new SOAPProcException(
					"SOAP Fault Code first child must be Fault Value.The second child is Fault Subcode.");
		}
		add(soapSubCode);
	}

	public void addFaultValue(ISOAPFaultValue soapValue)
			throws SOAPProcException {
		if (elements().size() > 0) {
			throw new SOAPProcException(
					"The Fault Value must be the first child of the SOAP Fault SubCode. But there already has some other children existed!");
		}
		add(soapValue);
	}
}
