package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPFault;
import org.act.xservices.rt.soap.constants.SOAPConstants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.tree.DefaultElement;
/**
 * 
 * @author Viking.Liu
 * @date 2010-6-3
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public abstract class SOAPFaultImpl extends DefaultElement implements
		ISOAPFault {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected Exception exception;

	public SOAPFaultImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname should be not null.");
		}
		if (!qname.getName().equals(SOAPConstants.SOAP_BODY_FAULT_NAME)) {
			throw new SOAPException(
					"The SOAP Fault name should be Fault.But it is "
							+ qname.getName());
		}
	}

	public SOAPFaultImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null || !name.equals(SOAPConstants.SOAP_BODY_FAULT_NAME)) {
			throw new SOAPException(
					"The SOAP Fault name should be Fault.But it is " + name);
		}
	}

	public SOAPFaultImpl(Exception e) {
		super(SOAPConstants.SOAP_BODY_FAULT_NAME);		
	}

	public SOAPFaultImpl() {
		super(SOAPConstants.SOAP_BODY_FAULT_NAME);
	}

	public Exception getException() throws SOAPException {
		return exception;
	}	
}
