package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPFaultSubCode;
import org.act.xservices.rt.soap.ISOAPFaultValue;
import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.tree.DefaultElement;
/**
 * 
 * @author Viking.Liu
 * @date 2010-6-3
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public abstract class SOAPFaultSubCodeImpl extends DefaultElement implements
		ISOAPFaultSubCode {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAPFaultSubCodeImpl(QName qname) {
		super(qname);
	}

	public SOAPFaultSubCodeImpl(String name, Namespace namespace) {
		super(name, namespace);
	}

	public SOAPFaultSubCodeImpl(String name) {
		super(name);
	}

	public ISOAPFaultSubCode getFaultSubCode() {
		Metaset subCode = element(SOAP12Constants.SOAP_FAULT_SUB_CODE_NAME);
		if (subCode != null) {
			return (ISOAPFaultSubCode) subCode;
		}
		return null;
	}

	public ISOAPFaultValue getFaultValue() {
		Metaset value = element(SOAP12Constants.SOAP_FAULT_VALUE_NAME);
		if (value != null) {
			return (ISOAPFaultValue) value;
		}
		return null;
	}

	public void addFaultSubCode(ISOAPFaultSubCode subCode)
			throws SOAPProcException {

		if (elements().size() == 1) {
			if (getFaultValue() == null) {
				throw new SOAPProcException(
						"SOAP Fault SubCode first child is not Fault Value.");
			}
		} else {
			throw new SOAPProcException(
					"SOAP Fault SubCode has more than one child.The Fault SubCode must be the second child if there is a SubCode.");
		}
		this.add(subCode);
	}

	public void addFaultValue(ISOAPFaultValue soapFaultSubCodeValue)
			throws SOAPProcException {
		if (elements().size() > 0) {
			throw new SOAPProcException(
					"The Fault Value must be the first child of the SOAP Fault SubCode. But there already has some other children existed!");
		}
		add(soapFaultSubCodeValue);
	}

}
