package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPFaultText;
import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.tree.DefaultAttribute;
import org.act.xservices.rt.xom.tree.DefaultElement;
/**
 * 
 * @author Viking.Liu
 * @date 2010-6-3
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public abstract class SOAPFaultTextImpl extends DefaultElement implements
		ISOAPFaultText {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Attribute attri;

	public SOAPFaultTextImpl(QName qname) {
		super(qname);
	}

	public SOAPFaultTextImpl(String name, Namespace namespace) {
		super(name, namespace);
	}

	public SOAPFaultTextImpl(String name) {
		super(name);
	}

	public String getLang() {
		if (attri == null) {
			attri = attribute(new QName(
					SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_URI,
					SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NAME,
					SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_PREFIX));
		}
		return attri == null ? null : attri.getValue();
	}

	public void setLang(String lang) {
		attri = new DefaultAttribute(
				SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NAME, lang,
				new Namespace(SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_URI,
						SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_PREFIX));
		add(attri);
	}

}
