package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.soap.constants.SOAPConstants;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.Node;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.tree.DefaultElement;
/**
 * 
 * @author Viking.Liu
 * @date 2010-6-3
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public abstract class SOAPHeaderBlockImpl extends DefaultElement implements
		ISOAPHeaderBlock {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String prefix = null;

	private boolean process = false;

	public SOAPHeaderBlockImpl(QName qname) {
		super(qname);
	}

	public SOAPHeaderBlockImpl(String name, Namespace namespace) {
		super(name, namespace);
	}

	public SOAPHeaderBlockImpl(String name) {
		super(name);
	}

	public boolean isProcessed() {
		return process;
	}

	public void setProcessed() {
		process = true;
	}

	protected String getEnvelopePrefix() {
		if (prefix == null) {
			prefix = SOAPConstants.SOAP_DEFAULT_NAMESPACE_PREFIX;
			Node parent = getParent();
			if (parent instanceof ISOAPHeader) {
				prefix = ((ISOAPHeader) parent).getNamespacePrefix();
			}
		}
		return prefix;
	}
}
