package org.act.xservices.rt.soap.impl;

import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPMessage;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.tree.DefaultDocument;

/**
 * 
 * @author Viking.Liu
 * @date 2010-6-2
 * @since JDK 1.5
 * @version 1.0.0
 */
public class SOAPMessageImpl extends DefaultDocument implements ISOAPMessage {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAPMessageImpl() {
		super();
	}

	public SOAPMessageImpl(String encodingScheme) {
		this.setXMLEncoding(encodingScheme);
	}

	public SOAPMessageImpl(ISOAPEnvelope envelope) {
		super(envelope);
	}

	public ISOAPEnvelope getSOAPEnvelope() throws SOAPProcException {
		Metaset soapEnvelope = getRootElement();
		ISOAPEnvelope envelope = null;
		if (soapEnvelope instanceof ISOAPEnvelope) {
			envelope = (ISOAPEnvelope) soapEnvelope;
		} else {
			throw new SOAPProcException("The SOAP Envelope is null.");
		}
		return envelope;
	}

	public void setSOAPEnvelope(ISOAPEnvelope envelope)
			throws SOAPProcException {
		if (getRootElement() != null) {
			throw new SOAPProcException("The SOAP Envelope already exist.");
		}
		setRootElement(envelope);
	}
}
