package org.act.xservices.rt.soap11.impl;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPFaultRoleImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP11FaultActorImpl extends SOAPFaultRoleImpl {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP11FaultActorImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname is null.");
		}
		if (!qname.getName().equals(SOAP11Constants.SOAP_FAULT_ACTOR_NAME)) {
			throw new SOAPException(
					"The SOAP Fault Actor name should be SOAP11 faultactor. But it is "
							+ qname.getName());
		}
	}

	public SOAP11FaultActorImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null) {
			throw new SOAPException(
					"The Name should not be null.But it is null.");
		}
		if (!name.equals(SOAP11Constants.SOAP_FAULT_ACTOR_NAME)) {
			throw new SOAPException(
					"The SOAP Fault Actor name should  be faultactor. But it is "
							+ name);
		}
	}

	public SOAP11FaultActorImpl() {
		super(SOAP11Constants.SOAP_FAULT_ACTOR_NAME);
	}

}
