package org.act.xservices.rt.soap11.impl;

import org.act.xservices.rt.soap.ISOAPFaultSubCode;
import org.act.xservices.rt.soap.ISOAPFaultValue;
import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.soap.impl.SOAPFaultCodeImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP11FaultCodeImpl extends SOAPFaultCodeImpl {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP11FaultCodeImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname is null.");
		}
		if (!qname.getName().equals(SOAP11Constants.SOAP_FAULT_CODE_NAME)) {
			throw new SOAPException(
					"The SOAPFaultCodeName should be SOAP11 faultcode. But it is "
							+ qname.getName());
		}
	}

	public SOAP11FaultCodeImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null || !name.equals(SOAP11Constants.SOAP_FAULT_CODE_NAME)) {
			throw new SOAPException(
					"The SOAPFaultCodeName should be SOAP11 faultcode. But it is "
							+ name);
		}
	}

	public SOAP11FaultCodeImpl() {
		super(SOAP11Constants.SOAP_FAULT_CODE_NAME);
	}

	
	public ISOAPFaultSubCode getFaultSubCode() throws SOAPProcException {
		throw new SOAPProcException("SOAP1.1 does not support this method.");
	}

	
	public ISOAPFaultValue getFaultValue() throws SOAPProcException {
		throw new SOAPProcException("SOAP1.1 does not support this method.");
	}

	
	public void addFaultSubCode(ISOAPFaultSubCode value) throws SOAPProcException {
		throw new SOAPProcException("SOAP1.1 does not support this method.");
	}

	
	public void addFaultValue(ISOAPFaultValue value) throws SOAPProcException {
		throw new SOAPProcException("SOAP1.1 does not support this method.");
	}
}
