package org.act.xservices.rt.soap11.impl;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPFaultDetailImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP11FaultDetailImpl extends SOAPFaultDetailImpl {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP11FaultDetailImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname is null.");
		}
		if (!qname.getName().equals(SOAP11Constants.SOAP_FAULT_DETAIL_NAME)) {
			throw new SOAPException(
					"The SOAP Fault Detail Name should be SOAP11 detail. But it is "
							+ qname.getName());
		}
	}

	public SOAP11FaultDetailImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null
				|| !name.equals(SOAP11Constants.SOAP_FAULT_DETAIL_NAME)) {
			throw new SOAPException(
					"The SOAP Fault Detail Name should be SOAP11 detail. But it is "
							+ name);
		}
	}

	public SOAP11FaultDetailImpl() {
		super(SOAP11Constants.SOAP_FAULT_DETAIL_NAME);
	}

}
