package org.act.xservices.rt.soap11.impl;

import java.util.List;

import org.act.xservices.rt.soap.ISOAPFaultText;
import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.soap.impl.SOAPFaultReasonImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP11FaultStringImpl extends SOAPFaultReasonImpl {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP11FaultStringImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname is null.");
		}
		if (!qname.getName().equals(SOAP11Constants.SOAP_FAULT_STRING_NAME)) {
			throw new SOAPException(
					"The SOAP Fault String Name should be SOAP11 faultstring. But it is "
							+ qname.getName());
		}
	}

	public SOAP11FaultStringImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null
				|| !name.equals(SOAP11Constants.SOAP_FAULT_STRING_NAME)) {
			throw new SOAPException(
					"The SOAP Fault String Name should be SOAP11 faultstring. But it is "
							+ name);
		}
	}

	public SOAP11FaultStringImpl() {
		super(SOAP11Constants.SOAP_FAULT_STRING_NAME);
	}

		
	public void addFaultText(ISOAPFaultText soapFaultText)
			throws SOAPProcException {
		throw new SOAPException("SOAP11 has not the Node! ");		
	}

	
	public List<ISOAPFaultText> getAllFaultTexts() {
		throw new SOAPException("SOAP11 has not the Node! ");
	}

	
	public ISOAPFaultText getFirstFaultText() {
		throw new SOAPException("SOAP11 has not the Node! ");
	}

	
	public ISOAPFaultText getFaultText(String language) {
		throw new SOAPException("SOAP11 has not the Node! ");
	}
}
