package org.act.xservices.rt.soap11.impl;

import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPHeaderImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP11HeaderImpl extends SOAPHeaderImpl{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP11HeaderImpl() {
		super();
	}

	public SOAP11HeaderImpl(QName qname) {
		super(qname);
	}

	public SOAP11HeaderImpl(String name, Namespace namespace) {
		super(name, namespace);
	}

	public ISOAPHeaderBlock addHeaderBlock(String localName, Namespace ns)
			throws SOAPException {
		if (ns == null || ns.getURI() == null || "".equals(ns.getURI())) {
			throw new SOAPException(
					"All the SOAP Header blocks should be namespace qualified");
		}
		ISOAPHeaderBlock block = new SOAP11HeaderBlockImpl(localName, ns);
		add(block);
		return block;
	}
}
