package org.act.xservices.rt.soap12.impl;

import org.act.xservices.rt.soap.ISOAPFaultSubCode;
import org.act.xservices.rt.soap.ISOAPFaultValue;
import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPFaultCodeImpl;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;

/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0
 * 
 */
public class SOAP12FaultCodeImpl extends SOAPFaultCodeImpl {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP12FaultCodeImpl(QName qname) {
		super(qname);
		if (qname == null) {
			throw new SOAPException("The qname is null.");
		}
		if (!qname.getName().equals(SOAP12Constants.SOAP_FAULT_CODE_NAME)) {
			throw new SOAPException(
					"The SOAP Fault CodeName should be SOAP12 Code. But it is "
							+ qname.getName());
		}
	}

	public SOAP12FaultCodeImpl(String name, Namespace namespace) {
		super(name, namespace);
		if (name == null || !name.equals(SOAP12Constants.SOAP_FAULT_CODE_NAME)) {
			throw new SOAPException(
					"The SOAPFaultCodeName should be SOAP12 Code. But it is "
							+ name);
		}
	}

	public SOAP12FaultCodeImpl() {
		super(SOAP12Constants.SOAP_FAULT_CODE_NAME);
	}

	public ISOAPFaultSubCode getFaultSubCode() {
		Metaset subCode = element(SOAP12Constants.SOAP_FAULT_SUB_CODE_NAME);
		if (subCode != null) {
			return (ISOAPFaultSubCode) subCode;
		}
		return null;
	}

	public ISOAPFaultValue getFaultValue() {
		Metaset value = element(SOAP12Constants.SOAP_FAULT_VALUE_NAME);
		if (value != null) {
			return (ISOAPFaultValue) value;
		}
		return (ISOAPFaultValue) value;
	}
}
