package org.act.xservices.rt.soap12.impl;

import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPFaultValueImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
/**
 * 
 * @author Viking.Liu
 * @date2010-6-9
 * @since JDK 1.5
 * @version 1.0.0 
 *
 */
public class SOAP12FaultValueImpl extends SOAPFaultValueImpl{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public SOAP12FaultValueImpl(QName qname) {
		super(qname);
		if(qname==null){
			throw new SOAPException("The qname is null.");
		}
		if(!qname.getName().equals(SOAP12Constants.SOAP_FAULT_VALUE_NAME)){
			throw new SOAPException(
					"The SOAP Fault Value name should be SOAP12 Value. But it is "
					+ qname.getName());
		}
	}

	public SOAP12FaultValueImpl(String name, Namespace namespace) {
		super(name, namespace);
		if(name==null){
			throw new SOAPException("The Name should not be null.But it is null.");
		}
		if(!name.equals(SOAP12Constants.SOAP_FAULT_VALUE_NAME)){
			throw new SOAPException("The SOAP Fault Value name should  be Value. But it is "+name);
		}
	}

	public SOAP12FaultValueImpl() {
		super(SOAP12Constants.SOAP_FAULT_VALUE_NAME);
	}

}
