package org.act.xservices.rt.soap;

import static org.junit.Assert.assertEquals;

import java.util.Iterator;

import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.junit.BeforeClass;
import org.junit.Test;

public class InvalidMustUnderstandSOAP12 extends SOAPBaseTest {
	private static ISOAPMessage soapmessage = null;
	private static ISOAPEnvelope envelope = null;
	private static ISOAPHeader header = null;
	//private static ISOAPBody body = null;

	@BeforeClass
	public static void init() {
		soapmessage = readSOAPMessage("soap/invalidMustUnderstandSOAP12.xml");
		envelope = soapmessage.getSOAPEnvelope();
		header = envelope.getHeader();
		//body = envelope.getBody();
	}

	@Test
	public void TestSOAPEnvelope() {
		assertEquals("Envelope", envelope.getName());

		assertEquals(0, envelope.attributes().size());
		//assertEquals(2, envelope.declaredNamespaces().size());

		assertEquals("env", envelope.getNamespacePrefix());
		assertEquals("http://www.w3.org/2003/05/soap-envelope", envelope
				.getNamespaceURI());
	}

	@Test(expected=SOAPProcException.class)
	public void TestSOAPHeaderBlock() {
		Iterator<ISOAPHeaderBlock> headerblocks = header
				.examineHeaderBlocks("http://www.w3.org/2003/05/soap-envelope/role/ultimateReceiver");
		ISOAPHeaderBlock headerblock = null;
		while (headerblocks.hasNext()) {
			headerblock = headerblocks.next();
		}
		assertEquals(
				"http://www.w3.org/2003/05/soap-envelope/role/ultimateReceiver",
				headerblock.getRole()); 
		headerblock.getMustUnderstand();
	}
}
