package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP11FaultActorImplTest {

	@Test
	public void testSOAP11FaultActorImplQName() {
		SOAP11FaultActorImpl actor = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "faultactor", "");
		try {
			actor = new SOAP11FaultActorImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP11Constants.SOAP_FAULT_ACTOR_NAME, actor.getName());
	}

	@Test
	public void testSOAP11FaultActorImplStringNamespace() {
		SOAP11FaultActorImpl actor = null;
		String name = null;
		Namespace ns = new Namespace("", "");
		// name="actor";
		name = "faultactor";
		try {
			actor = new SOAP11FaultActorImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP11Constants.SOAP_FAULT_ACTOR_NAME, actor.getName());
		assertEquals(ns, actor.getNamespace());
	}

	@Test
	public void testSOAP11FaultActorImpl() {
		SOAP11FaultActorImpl actor = new SOAP11FaultActorImpl();
		assertEquals(SOAP11Constants.SOAP_FAULT_ACTOR_NAME, actor.getName());
	}

	@Test
	public void testGetRoleValue() {
		SOAP11FaultActorImpl actor = new SOAP11FaultActorImpl();
		String uri = "hello";
		actor.setRoleValue(uri);
		assertEquals(uri, actor.getRoleValue());
	}
}
