package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP11FaultCodeImplTest {

	@Test
	public void testSOAP11FaultCodeImplQName() {

		SOAP11FaultCodeImpl code = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "faultcode", "");
		try {
			code = new SOAP11FaultCodeImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(qname, code.getQName());
	}

	@Test
	public void testSOAP11FaultCodeImplStringNamespace() {
		SOAP11FaultCodeImpl code = null;
		Namespace ns = new Namespace("", "");
		String name = null;
		// name = "code";
		name = "faultcode";
		try {
			code = new SOAP11FaultCodeImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(name, code.getName());
		assertEquals(ns, code.getNamespace());
	}

	@Test
	public void testSOAP11FaultCodeImpl() {
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		assertEquals(SOAP11Constants.SOAP_FAULT_CODE_NAME, code.getName());
	}

	@Test(expected=SOAPProcException.class)
	public void testGetSubCode() throws SOAPProcException {
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		code.addFaultSubCode(SOAPFactory.getInstance().createSOAPFaultSubCode());
		code.getFaultSubCode();
	}

	@Test(expected=SOAPProcException.class)
	public void testGetValue() throws SOAPProcException {
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		code.addFaultValue(SOAPFactory.getInstance().createSOAPFaultValue());
		code.getFaultValue();
	}
	
}
