package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP11FaultDetailImplTest {

	@Test
	public void testSOAP11FaultDetailImplQName() {
		SOAP11FaultDetailImpl detail = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "detail", "");
		try {
			detail = new SOAP11FaultDetailImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(qname, detail.getQName());
	}

	@Test
	public void testSOAP11FaultDetailImplStringNamespace() {
		SOAP11FaultDetailImpl detail = null;
		Namespace ns = new Namespace("", "");
		String name = null;
		// name = "detail";
		name = "detail";
		try {
			detail = new SOAP11FaultDetailImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(name, detail.getName());
		assertEquals(ns, detail.getNamespace());
	}

	@Test
	public void testSOAP11FaultDetailImpl() {
		SOAP11FaultDetailImpl detail = new SOAP11FaultDetailImpl();
		assertEquals(SOAP11Constants.SOAP_FAULT_DETAIL_NAME, detail.getName());
	}
}
