package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAPConstants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP11FaultImplTest {

	@Test
	public void testSOAP11FaultImpl() {
		SOAP11FaultImpl fault = new SOAP11FaultImpl();
		assertEquals(SOAPConstants.SOAP_BODY_FAULT_NAME, fault.getName());
	}

	@Test
	public void testSOAP11FaultImplQName() {
		SOAP11FaultImpl fault = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "Fault", "");
		try {
			fault = new SOAP11FaultImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(qname, fault.getQName());
	}

	@Test
	public void testSOAP11FaultImplStringNamespace() {
		SOAP11FaultImpl fault = null;
		Namespace ns = new Namespace("", "");
		String name = null;
		// name = "fault";
		name = "Fault";
		try {
			fault = new SOAP11FaultImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(name, fault.getName());
		assertEquals(ns, fault.getNamespace());
	}

	@Test
	public void testSetCode() {
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		SOAP11FaultImpl fault = new SOAP11FaultImpl();
		try {
			// fault.addElement("hello");
			fault.addFaultCode(code);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(code, fault.getFaultCode());
	}

	@Test
	public void testSetReason() {
		SOAP11FaultStringImpl reason = new SOAP11FaultStringImpl();
		SOAP11FaultImpl fault = new SOAP11FaultImpl();
		try {
			SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
			fault.addFaultCode(code);
			fault.addFaultReason(reason);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(reason, fault.getFaultReason());

	}

	@Test
	public void testSetRole() {
		SOAP11FaultImpl fault = new SOAP11FaultImpl();
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		SOAP11FaultStringImpl reason = new SOAP11FaultStringImpl();
		SOAP11FaultActorImpl actor = new SOAP11FaultActorImpl();
		try {
			fault.addFaultCode(code);
			fault.addFaultReason(reason);
			fault.addFaultRole(actor);
		} catch (SOAPProcException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		assertEquals(actor, fault.getFaultRole());
	}

	@Test
	public void testSetDetail() {
		SOAP11FaultImpl fault = new SOAP11FaultImpl();
		SOAP11FaultCodeImpl code = new SOAP11FaultCodeImpl();
		SOAP11FaultStringImpl reason = new SOAP11FaultStringImpl();
		SOAP11FaultDetailImpl detail = new SOAP11FaultDetailImpl();
		try {
			fault.addFaultCode(code);
			fault.addFaultReason(reason);
			fault.addFaultDetail(detail);
		} catch (SOAPProcException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		assertEquals(detail, fault.getFaultDetail());
	}
}
