package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP11Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP11FaultStringImplTest {

	@Test
	public void testSOAP11FaultStringImplQName() {
		SOAP11FaultStringImpl faultstring = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "faultstring", "");
		try {
			faultstring = new SOAP11FaultStringImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(qname, faultstring.getQName());
	}

	@Test
	public void testSOAP11FaultStringImplStringNamespace() {
		SOAP11FaultStringImpl faultstring = null;
		Namespace ns = new Namespace("", "");
		String name = null;
		// name = "string";
		name = "faultstring";
		try {
			faultstring = new SOAP11FaultStringImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(name, faultstring.getName());
		assertEquals(ns, faultstring.getNamespace());
	}

	@Test
	public void testSOAP11FaultStringImpl() {
		SOAP11FaultStringImpl faultstring = new SOAP11FaultStringImpl();
		assertEquals(SOAP11Constants.SOAP_FAULT_STRING_NAME, faultstring
				.getName());
	}

}
