package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAPConstants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.impl.SOAPEnvelopeImpl;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAPEnvelopeImplTest {

	@Test
	public void testSOAPEnvelopeImpl() {
		SOAPEnvelopeImpl envelope = new SOAPEnvelopeImpl();
		assertEquals(SOAPConstants.SOAP_ENVELOPE_NAME, envelope.getName());
	}

	@Test
	public void testSOAPEnvelopeImplQName() {
		SOAPEnvelopeImpl envelope = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "Envelope", "");
		try {
			envelope = new SOAPEnvelopeImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(qname, envelope.getQName());
	}

	@Test
	public void testSOAPEnvelopeImplStringNamespace() {
		String name = null;
		SOAPEnvelopeImpl envelope = null;
		Namespace ns = new Namespace("", "");
		// name="envelope";
		name = "Envelope";
		try {
			envelope = new SOAPEnvelopeImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(name, envelope.getName());
		assertEquals(ns, envelope.getNamespace());
	}

	@Test
	public void testSetBody() {
		SOAP11BodyImpl body = new SOAP11BodyImpl();
		SOAPEnvelopeImpl envelope = new SOAPEnvelopeImpl();

		try {
			envelope.add(new SOAP11HeaderImpl());
			//envelope.add(new SOAP11HeaderImpl());
			// envelope.add(body);
			envelope.addBody(body);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(body, envelope.getBody());
	}

	@Test
	public void testSetHeader() {
		// SOAP11BodyImpl body = new SOAP11BodyImpl();
		SOAP11HeaderImpl header = new SOAP11HeaderImpl();
		SOAPEnvelopeImpl envelope = new SOAPEnvelopeImpl();
		try {
			// envelope.addBody(body);
			// envelope.add(header);
			envelope.addHeader(header);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(header, envelope.getHeader());

	}
}
