package org.act.xservices.rt.soap11.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.soap.impl.SOAPEnvelopeImpl;
import org.act.xservices.rt.soap.impl.SOAPMessageImpl;
import org.junit.Test;

public class SOAPMessageImplTest {

	@Test
	public void testSOAP11MessageImpl() throws SOAPProcException {
		SOAPEnvelopeImpl envelope = new SOAPEnvelopeImpl();
		SOAPMessageImpl message = new SOAPMessageImpl(envelope);
		assertEquals(envelope, message.getSOAPEnvelope());
	}

	@Test
	public void testSOAP11MessageImplString() {
		SOAPMessageImpl message = new SOAPMessageImpl("utf-8");
		assertEquals("utf-8", message.getXMLEncoding());
	}

	@Test(expected = SOAPProcException.class)
	public void testSetSOAPEnvelope() throws SOAPProcException {
		SOAPEnvelopeImpl envelope1 = new SOAPEnvelopeImpl();
		SOAPEnvelopeImpl envelope2 = new SOAPEnvelopeImpl();
		SOAPMessageImpl message = new SOAPMessageImpl();
		message.setSOAPEnvelope(envelope1);
		message.setSOAPEnvelope(envelope2);
	}

}
