package org.act.xservices.rt.soap12.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP12FaultCodeImplTest {

	@Test
	public void testSOAP12FaultCodeImplQName() {
		SOAP12FaultCodeImpl code = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "Code", "");
		try {
			code = new SOAP12FaultCodeImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_CODE_NAME, code.getName());
	}

	@Test
	public void testSOAP12FaultCodeImplStringNamespace() {
		SOAP12FaultCodeImpl code = null;
		String name = null;
		Namespace ns = new Namespace("", "");
		// name="code";
		name = "Code";
		try {
			code = new SOAP12FaultCodeImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_CODE_NAME, code.getName());
		assertEquals(ns, code.getNamespace());
	}

	@Test
	public void testSOAP12FaultCodeImpl() {
		SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
		assertEquals(SOAP12Constants.SOAP_FAULT_CODE_NAME, code.getName());
	}

	@Test
	public void testAddFaultSubCode() {
		SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
		SOAP12FaultSubCodeImpl subcode = new SOAP12FaultSubCodeImpl();
		try {
			SOAP12FaultValueImpl value = new SOAP12FaultValueImpl();
			code.addFaultValue(value);
			code.addFaultSubCode(subcode);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(subcode, code.getFaultSubCode());
	}

	@Test
	public void testAddFaultValue() {
		SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
		SOAP12FaultValueImpl value = new SOAP12FaultValueImpl();
		try {
			code.addFaultValue(value);
		} catch (SOAPProcException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		assertEquals(value, code.getFaultValue());
	}

}
