package org.act.xservices.rt.soap12.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.junit.Test;

public class SOAP12FaultImplTest {

	@Test
	public void testSOAP12FaultImplException() {

	}

	@Test
	public void testAddFaultCode() {
		SOAP12FaultImpl fault = new SOAP12FaultImpl();
		SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
		try {
			// fault.addElement("hello");
			fault.addFaultCode(code);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(code, fault.getFaultCode());
	}

	@Test
	public void testAddFaultReason() {
		SOAP12FaultImpl fault = new SOAP12FaultImpl();
		SOAP12FaultReasonImpl reason = new SOAP12FaultReasonImpl();
		try {
			SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
			fault.addFaultCode(code);
			fault.addFaultReason(reason);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(reason, fault.getFaultReason());
	}

	@Test
	public void testAddFaultNode() {
		SOAP12FaultImpl fault = new SOAP12FaultImpl();
		SOAP12FaultNodeImpl node = new SOAP12FaultNodeImpl();

		try {
			SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
			fault.addFaultCode(code);
			SOAP12FaultReasonImpl reason = new SOAP12FaultReasonImpl();
			fault.addFaultReason(reason);
			fault.addFaultNode(node);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(node, fault.getFaultNode());
	}

	@Test
	public void testAddFaultRole() {
		SOAP12FaultImpl fault = new SOAP12FaultImpl();
		SOAP12FaultRoleImpl role = new SOAP12FaultRoleImpl();

		try {
			SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
			fault.addFaultCode(code);
			SOAP12FaultReasonImpl reason = new SOAP12FaultReasonImpl();
			fault.addFaultReason(reason);
			fault.addFaultRole(role);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(role, fault.getFaultRole());
	}

	@Test
	public void testAddFaultDetail() {
		SOAP12FaultImpl fault = new SOAP12FaultImpl();
		SOAP12FaultDetailImpl detail = new SOAP12FaultDetailImpl();

		try {
			SOAP12FaultCodeImpl code = new SOAP12FaultCodeImpl();
			fault.addFaultCode(code);
			SOAP12FaultReasonImpl reason = new SOAP12FaultReasonImpl();
			fault.addFaultReason(reason);
			fault.addFaultDetail(detail);
		} catch (SOAPProcException e) {
			e.printStackTrace();
		}
		assertEquals(detail, fault.getFaultDetail());
	}
}
