package org.act.xservices.rt.soap12.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.exception.SOAPProcException;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP12FaultSubCodeImplTest {

	@Test
	public void testSOAP12FaultSubCodeImplQName() {
		SOAP12FaultSubCodeImpl subCode = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "Subcode", "");
		try {
			subCode = new SOAP12FaultSubCodeImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_SUB_CODE_NAME, subCode
				.getName());
	}

	@Test
	public void testSOAP12FaultSubCodeImplStringNamespace() {
		SOAP12FaultSubCodeImpl subcode = null;
		String name = null;
		Namespace ns = new Namespace("", "");
		// name="subcode";
		name = "Subcode";
		try {
			subcode = new SOAP12FaultSubCodeImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_SUB_CODE_NAME, subcode
				.getName());
		assertEquals(ns, subcode.getNamespace());
	}

	@Test
	public void testSOAP12FaultSubCodeImpl() {
		SOAP12FaultSubCodeImpl subcode = new SOAP12FaultSubCodeImpl();
		assertEquals(SOAP12Constants.SOAP_FAULT_SUB_CODE_NAME, subcode
				.getName());
	}

	@Test
	public void testAddFaultSubCode() {
		SOAP12FaultSubCodeImpl subcode = new SOAP12FaultSubCodeImpl();
		SOAP12FaultSubCodeImpl subSubcode = new SOAP12FaultSubCodeImpl();
		SOAP12FaultValueImpl value=new SOAP12FaultValueImpl();
		try {
			subcode.addFaultValue(value);
			subcode.addFaultSubCode(subSubcode);
		} catch (SOAPProcException e) {
			e.printStackTrace();
			return;
		}
	}

	@Test
	public void testAddFaultValue() {
		SOAP12FaultSubCodeImpl subcode = new SOAP12FaultSubCodeImpl();
		SOAP12FaultValueImpl value=new SOAP12FaultValueImpl();
		try {
			subcode.addFaultValue(value);
		} catch (SOAPProcException e) {
			e.printStackTrace();
			return;
		}
	}

}
