package org.act.xservices.rt.soap12.impl;

import static org.junit.Assert.*;

import org.act.xservices.rt.soap.constants.SOAP12Constants;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.junit.Test;

public class SOAP12FaultTextImplTest {

	@Test
	public void testSOAP12FaultTextImplQName() {
		SOAP12FaultTextImpl text = null;
		QName qname = null;
		// qname = new QName("", "", "");
		qname = new QName("", "Text", "");
		try {
			text = new SOAP12FaultTextImpl(qname);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_TEXT_NAME, text.getName());
	}

	@Test
	public void testSOAP12FaultTextImplStringNamespace() {
		SOAP12FaultTextImpl text = null;
		String name = null;
		Namespace ns = new Namespace("", "");
		// name="text";
		name = "Text";
		try {
			text = new SOAP12FaultTextImpl(name, ns);
		} catch (SOAPException e) {
			e.printStackTrace();
			return;
		}
		assertEquals(SOAP12Constants.SOAP_FAULT_TEXT_NAME, text.getName());
		assertEquals(ns, text.getNamespace());
	}

	@Test
	public void testSOAP12FaultTextImpl() {
		SOAP12FaultTextImpl text = new SOAP12FaultTextImpl();
		assertEquals(SOAP12Constants.SOAP_FAULT_TEXT_NAME, text.getName());
	}

	@Test
	public void testGetLang() {

		SOAP12FaultTextImpl text = new SOAP12FaultTextImpl();
		Attribute attri = SOAPFactory.getInstance().createAttribute(
				text,
				new QName(SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_URI,
						"lang",
						SOAP12Constants.SOAP_FAULT_TEXT_LANG_ATTR_NS_PREFIX),
				"en");
		text.add(attri);
		assertEquals("en", text.getLang());
	}

	@Test
	public void testSetLang() {
		SOAP12FaultTextImpl text = new SOAP12FaultTextImpl();
		text.setLang("ch");
		assertEquals("ch", text.getLang());
	}

}
