package org.act.xservices.rt.metaset;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.DocumentFactory;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.util.SingletonStrategy;

/**
 * Metaset  ʵǶDocumentFactoryķװ
 * 
 * @version 1.1 2008-05-10
 * @version 1.0 2005-06-23
 * @author liujian [liujian@act.buaa.edu.cn]
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */

@SuppressWarnings("unchecked")
public class MetasetBuilder extends DocumentFactory {

	private static final long serialVersionUID = 1L;

	/** The Singleton instance */
	private static SingletonStrategy singleton = null;

	static {
		try {
			String defaultSingletonClass = "org.act.xservices.rt.xom.util.SimpleSingleton";
			Class clazz = null;
			try {
				String singletonClass = defaultSingletonClass;
				singletonClass = System.getProperty(
						"org.act.xservices.rt.xom.singleton.strategy",
						singletonClass);
				clazz = Class.forName(singletonClass);
			} catch (Exception exc1) {
				try {
					String singletonClass = defaultSingletonClass;
					clazz = Class.forName(singletonClass);
				} catch (Exception exc2) {
				}
			}
			singleton = (SingletonStrategy) clazz.newInstance();
			singleton.setSingletonClassName(MetasetBuilder.class.getName());
		} catch (Exception exc3) {
		}
	}

	/**
	 * <p>
	 * Access to singleton implementation of DocumentFactory which is used if no
	 * DocumentFactory is specified when building using the standard builders.
	 * </p>
	 * 
	 * @return the default singleon instance
	 */
	public static MetasetBuilder getInstance() {
		return (MetasetBuilder) singleton.instance();
	}

	/**
	 * 
	 * @param qName org.act.xservices.rt.xom.QName 
	 * @param value String attribute value 
	 * @return Attribute
	 */
	public Attribute newAttribute(QName qName, String value) {
		return this.createAttribute(null, qName, value);
	}

	/**
	 * 
	 * @param attributeName String attribute name
	 * @param value String attribute value 
	 * @return Attribute
	 */
	public Attribute newAttribute(String attributeName, String value) {
		return this.createAttribute(null, attributeName, value);
	}

	/**
	 * 
	 * @param namespaceURI  
	 * @param attributeName 
	 * @param prefix  
	 * @param value
	 * @return 
	 */
	public Attribute newAttribute(String namespaceURI, String attributeName,
			String prefix, String value) {
		QName qName = new QName(namespaceURI, attributeName, prefix);
		return this.createAttribute(null, qName, value);
	}

	/**
	 *  The default Metaset Name is ""
	 * @return
	 */
	public Metaset newMetaset() {
		return this.createElement("");
	}

	/**
	 * 
	 * @param qName
	 * @return
	 */
	public Metaset newMetaset(QName qName) {
		return this.createElement(qName);
	}

	/**
	 *  Metaset name
	 * @param localPart
	 * @return
	 */
	public Metaset newMetaset(String localPart) {
		return this.createElement(localPart);
	}

	/**
	 * 
	 * @param namespaceURI
	 * @param localPart
	 * @return
	 */
	public Metaset newMetaset(String namespaceURI, String localPart) {
		return this.newMetaset(namespaceURI, localPart, "");
	}

	/**
	 * 
	 * @param namespaceURI
	 * @param localPart
	 * @param prefix 
	 * @return 
	 */
	public Metaset newMetaset(String namespaceURI, String localPart,
			String prefix) {
		QName qName = new QName(namespaceURI, localPart, prefix);
		return this.createElement(qName);
	}

}
