package org.act.xservices.rt.metaset;

import java.io.InputStream;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Metaset;

public interface MetasetParser {
	
	
	/**
	 * Parse an InputStream and return a ServiceSet
	 * 
	 * @param in
	 * @return
	 * @throws MetasetParsingException
	 */
	public Metaset parse(InputStream in) throws MetasetParsingException;

	/**
	 * Construct a Metaset from a xml file
	 * 
	 * @param filePath
	 *            String the xml file full path
	 * @return Metaset the <code>Metaset</code> constructed from the xml file
	 * @throws Exception
	 *             when exception occured.
	 */
	public Metaset parse(String filePath) throws MetasetParsingException;

	/**
	 * Construct a Metaset from a String
	 * 
	 * @param xmlString
	 * @return
	 * @throws Exception
	 */
	public Metaset parseXMLString(String xmlString) throws MetasetParsingException;

	

}
