package org.act.xservices.rt.metaset;

/**
 * Metaset
 * 
 * @author Rukey.Li
 * 
 */
public class MetasetParserFactory {

	private static MetasetSAXParser saxParser = new MetasetSAXParser();
	private static MetasetStAXParser staxParser = new MetasetStAXParser();

	private static Class<?> parserClass = null;
	// Ĭϵ Metasetʵ
	private static MetasetParser defaultParser = null;
	// bpelʵ
	private static MetasetParser bpelParser = null;
	// aspectʵ
	private static MetasetParser aspectParser = null;

	static {
		try {
			String defaultParserClassString = "org.act.xservices.rt.metaset.MetasetSAXParser";
			// Class clazz = null;
			try {
				String parserClassType = System.getProperty(
						"org.act.xservices.rt.xom.parser.type",
						defaultParserClassString);
				parserClass = Class.forName(parserClassType);
			} catch (Exception exc1) {
				try {
					parserClass = Class.forName(defaultParserClassString);
				} catch (Exception exc2) {
				}
			}
			defaultParser = (MetasetParser) parserClass.newInstance();
			bpelParser = (MetasetParser) parserClass.newInstance();
			aspectParser = (MetasetParser) parserClass.newInstance();
		} catch (Exception exc3) {
			defaultParser = new MetasetSAXParser();
			bpelParser = new MetasetSAXParser();
			aspectParser = new MetasetSAXParser();
		}
	}

	/**
	 * ʹgetMetasetParser()
	 * 
	 * @return
	 */
	@Deprecated
	public static MetasetParser getSAXParser() {
		return saxParser;
	}

	/**
	 * ʹgetMetasetParser()
	 * 
	 * @return
	 */
	@Deprecated
	public static MetasetParser getStAXParser() {
		return staxParser;
	}

	/**
	 * ʹnewMetasetParser()
	 * 
	 * @return
	 */
	@Deprecated
	public static MetasetParser newMetasetSAXParser() {
		MetasetParser metasetSAXParser = new MetasetSAXParser();
		return metasetSAXParser;
	}

	/**
	 * ʹnewMetasetParser()
	 * 
	 * @return
	 */
	@Deprecated
	public static MetasetParser newMetasetStAXParser() {
		MetasetParser metasetStAXParser = new MetasetStAXParser();
		return metasetStAXParser;
	}

	/**
	 * ˴ϵͳ÷ӦĲSAXStAXĽ
	 * 
	 * @return ÿηͬһMetasetʵ
	 */
	public static MetasetParser getMetasetParser() {
		return defaultParser;
	}

	/**
	 * Ϊʱbpelaspectwebʱòͬ߳̽вģڶ߳йһ
	 * ʵ⡣bpelһMetasetʵ
	 * 
	 * @return
	 */
	public static MetasetParser getBpelMetasetParser() {
		return bpelParser;
	}

	/**
	 * Ϊʱbpelaspectwebʱòͬ߳̽вģڶ߳йһ
	 * ʵ⡣aspectһMetasetʵ
	 * 
	 * @return
	 */
	public static MetasetParser getAspectMetasetParser() {
		return aspectParser;
	}

	/**
	 * ˴ϵͳ÷ӦĲSAXStAXĽ
	 * 
	 * @return ÿηһµMetasetʵ
	 */
	public static MetasetParser newMetasetParser() {
		try {
			return (MetasetParser) parserClass.newInstance();
		} catch (Exception e) {
			e.printStackTrace();
			return new MetasetSAXParser();
		}
	}

}
