package org.act.xservices.rt.metaset;

import java.io.File;
import java.io.InputStream;
import java.io.StringReader;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.xom.Document;
import org.act.xservices.rt.xom.DocumentException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.io.SAXReader;
import org.xml.sax.InputSource;

/**
 * 
 * @author Rukey.Li
 *
 */
public class MetasetSAXParser implements MetasetParser {

	private SAXReader sax = new SAXReader(MetasetBuilder.getInstance());

	public Metaset parse(InputStream in) throws MetasetParsingException {
		Document doc;
		try {
			doc = sax.read(in);
			return doc.getRootElement();
		} catch (DocumentException e) {
			e.printStackTrace();
		}
		return null;
	}

	public Metaset parse(String filePath) throws MetasetParsingException {
		Document doc;
		try {
			doc = sax.read(new File(filePath));
			return doc.getRootElement();
		} catch (DocumentException e) {
			e.printStackTrace();
		}
		return null;
	}

	public Metaset parseXMLString(String xmlString)
			throws MetasetParsingException {
//		System.out.println(xmlString);
		String encoding = MetasetUtil.getEncoding(xmlString);
		InputSource source = new InputSource(new StringReader(xmlString));
		source.setEncoding(encoding);
		Document doc;
		try {
			doc = sax.read(source);

			// if the XML parser doesn't provide a way to retrieve the encoding,
			// specify it manually
			if (doc.getXMLEncoding() == null) {
				doc.setXMLEncoding(encoding);
			}
			return doc.getRootElement();
		} catch (DocumentException e) {
			e.printStackTrace();
		}
		return null;
	}

}
