package org.act.xservices.rt.metaset;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Document;
import org.act.xservices.rt.xom.DocumentException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.io.XPP3Reader;
import org.xmlpull.v1.XmlPullParserException;
/**
 * 
 * @author viking
 *
 * the xpp parser is used to parse soap message.Because it does not validate
 * ,so it is fast .
 */
public class MetasetXPPParser implements MetasetParser{

	private XPP3Reader parser=new XPP3Reader();
	public Metaset parse(InputStream in) throws MetasetParsingException {
		try {
			Document doc=parser.read(in);
			return doc.getRootElement();
		} catch (DocumentException e) {
			throw new MetasetParsingException(e);
		} catch (IOException e) {
			throw new MetasetParsingException(e);
		} catch (XmlPullParserException e) {
			throw new MetasetParsingException(e);
		} 
	}

	public Metaset parse(String filePath) throws MetasetParsingException {
		File file=new File(filePath);
		try {
			FileInputStream in=new FileInputStream(file);
			return parse(in);
		} catch (FileNotFoundException e) {
			throw new MetasetParsingException(e);
		} 
	}

	public Metaset parseXMLString(String xmlString)
			throws MetasetParsingException {
		InputStream in = new ByteArrayInputStream(xmlString.getBytes());
		return parse(in);
	}

}
