package org.act.xservices.rt.metaset.query;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Stack;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.exception.ElementExpressionException;
import org.act.xservices.rt.metaset.exception.PathExpressionException;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.xpath.DefaultXPath;

/**
 * ˴ Metasetƥ·ʽ
 * 
 * @version 1.0 2008-5-9
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class FilterProcessor {
	
	private static FilterProcessor instance = new FilterProcessor();

	/**
	 * ģʽ
	 * 
	 * @return
	 */
	public static FilterProcessor getInstance() {
		return instance;
	}

	/**
	 * ȸ ·ʽַ  ·ʽexpression Ȼ metasetIn ѡ ƥ
	 * ·ʽexpression Metaset.
	 * 
	 * @param pathExp
	 * @param metasetIn
	 * @return
	 */
	public Metaset filter(String pathExp, Metaset metasetIn) {
		// TODO ˴쳣ζû׳дǣ by lizq 20080507
		try {
			IPathExpression expression = new PathExpression(pathExp);
			return filter(expression, metasetIn);

		} catch (ElementExpressionException e) {
			System.err.println("Error in pathExpression for " + e.getMessage());
			return null;
		} catch (PathExpressionException e) {
			System.err.println("Error in pathExpression for " + e.getMessage());
			return null;
		}
	}

	/**
	 * Use jaxen XPath Engine to query.
	 * 
	 * @param pathExp
	 * @param metasetIn
	 * @return
	 */
	public Metaset filterByXPath(String pathExp, Metaset metasetIn,
			Map<String, String> namespaceMap) {
			List<Metaset> result = new ArrayList<Metaset>();
			
			DefaultXPath xpathExpression = new DefaultXPath(pathExp);
			
			if (namespaceMap != null) {
				xpathExpression.setNamespaceURIs(namespaceMap);
			}

			List nodes = xpathExpression.selectNodes(metasetIn);
			for (int i = 0; i < nodes.size(); i++) {
				result.add((Metaset) nodes.get(i));
			}

			return MetasetUtil.encapsulateByMetaset(result);

	}

	/**
	 *  metasetIn ѡ ƥ ·ʽexpression Metaset.
	 * 
	 * @param pathExp
	 *            ·ʽ
	 * @param metasetIn
	 *            ϽвҵMetaset
	 * @return
	 */
	public Metaset filter(IPathExpression pathExp, Metaset metasetIn) {

		// ֵ
		ArrayList<Metaset> resultList = new ArrayList<Metaset>();

		// ʼջ
		Stack<Metaset> matchStack = new Stack<Metaset>();
		matchStack.push(metasetIn);

		// -------------·ʽֵ------------
		for (Iterator<ElementExpression> iter_pathEle = pathExp
				.getElementList().iterator(); iter_pathEle.hasNext();) {

			Stack<Metaset> nextMatchStack = new Stack<Metaset>(); // һѡƥ

			// ȡƥԪرʽ
			ElementExpression pathElemExp = iter_pathEle.next();

			// --------Ԫرʽƥ---------
			while (!matchStack.empty()) {
				// ջȡһѡƥ
				Metaset metTemp = matchStack.pop();

				boolean eleMatchFlag = false; // Ԫؼƥ

				if (matchPathElementName(pathElemExp, metTemp)) {// ƥԪ
					eleMatchFlag = true;

					// ·ԪذԽƥ
					eleMatchFlag = matchPathAttributeValue(pathElemExp
							.getAttrList(), metTemp);

					if (!eleMatchFlag) {// ƥʧܣջеԪ
						continue;
					} else {// Ԫؼƥɹ
						if (!iter_pathEle.hasNext()) {// ·ԪҪƥ䣬ɽ
							resultList.add(metTemp);
						} else {// һѡƥ
							Iterator<Metaset> children = metTemp
									.elementIterator();
							while (children.hasNext()) {
								nextMatchStack.push(children.next());
							}
						}
					}
				}
			}
			// --------end of Ԫرʽƥ---------

			matchStack = nextMatchStack;
		}
		// -------------end of ·ʽֵ-------------

		// Metasetаװ
		// TODO ע˴·ʽеԪرʽΪżʱΪΪʱΪ. by lizq 20080508
		if ((pathExp.getElementList().size() & 1) != 0) {
			return encapsulateByMetaset(resultList, false);

		} else { // ΪżҪ
			return encapsulateByMetaset(resultList, true);
		}

	}

	/**
	 * ·ԪذԽƥ
	 * 
	 * @param pathAttrList
	 * @param met
	 * @return
	 */
	private boolean matchPathAttributeValue(List<Attribute> pathAttrList,
			Metaset met) {

		// ·ԪؿܰԽƥ
		for (Attribute pathAttribute : pathAttrList) {
			boolean attrMatchFlag = false; // Լƥ

			// ÿ·ԲǷƥ
			Iterator<Attribute> attris = met.attributeIterator();
			while (attris.hasNext()) {// 
				Attribute attrTemp = attris.next();
				if (matchPathAttributeName(pathAttribute, attrTemp.getQName())) { // ƽƥ
					// Կܴڵֵƥ
					final boolean noAttrValue = pathAttribute
							.getValue().equals("");// ֵҪƥ
					final boolean allAttrValue = pathAttribute
							.getValue().equals(
									PathExpConstant.ALL_MATCH_CODE);// *ֵƥ
					final boolean match_Value = pathAttribute
							.getValue().equals(
									attrTemp.getValue());// ֵƥ

					if (noAttrValue || allAttrValue || match_Value) {
						attrMatchFlag = true;
						break;
					}
				}
			}// ---------------------
			Iterator<Namespace> namespaces=met.declaredNamespaces().iterator();
			while(namespaces.hasNext()){
				Namespace ns=namespaces.next(); 
				QName nsQName =null;
				if(ns.getPrefix()==null||ns.getPrefix().equals("")){
					nsQName= new QName(ns
						.getURI(), "", "xmlns");
				}else{
					nsQName= new QName(ns
							.getURI(), ns.getPrefix(), "xmlns");
				}
				if (matchPathAttributeName(pathAttribute, nsQName )) { // ƽƥ
					// Կܴڵֵƥ
					final boolean noAttrValue = pathAttribute
							.getValue().equals("");// ֵҪƥ
					final boolean allAttrValue = pathAttribute
							.getValue().equals(
									PathExpConstant.ALL_MATCH_CODE);// *ֵƥ
					final boolean match_Value = pathAttribute
							.getValue().equals(
									ns.getURI());// ֵƥ

					if (noAttrValue || allAttrValue || match_Value) {
						attrMatchFlag = true;
						break;
					}
				}
			}
			if (!attrMatchFlag) {// һ·ƥʧܣԪؼƥʧ
				return false;
			}
		}
		return true; // Զɹƥ
	}

	/**
	 * һյMetasetװһList<IMetaset>,anti_orderΪtrueеԪط
	 * Ϊ˽filterһbugby lizq 20080509 ListΪգ򷵻null
	 * 
	 * @param resultList
	 * @param anti_order
	 * @return
	 */
	private Metaset encapsulateByMetaset(List<Metaset> resultList,
			boolean anti_order) {
		if (resultList.isEmpty()) {
			return null;
		} else {

			Metaset resultMet = MetasetBuilder.getInstance().newMetaset();
		 
			if (anti_order) {
				for (int i = resultList.size() - 1; i >= 0; i--) {					
					resultMet.encapsulatedChild(resultList.get(i));
				}
			} else {
				for (int i = 0; i < resultList.size(); i++) {
					resultMet.encapsulatedChild(resultList.get(i));
				}
			}
			return resultMet;
		}
	}

	/**
	 * ƥ·ԪرʽеԪMetasetǷͬ LocalpartֱͬȻǰ׺ƿռ䣬бȽ
	 * ͬtrueͬfalse
	 * 
	 * @param pathElement
	 * @param met
	 * @return
	 */
	private boolean matchPathElementName(ElementExpression pathElement,
			Metaset met) {

		// ·Ԫصƺռ
		String elementLocalName = pathElement.getElementQName().getName()
				.trim();
		String elementNamespace = ""; // Ϊǰ׺ƿռ䣬pathElementһܶ
		if (!pathElement.getElementQName().getNamespacePrefix().equals("")) {
			elementNamespace = pathElement.getElementQName().getNamespacePrefix().trim();
		} else {
			elementNamespace = pathElement.getElementQName().getNamespaceURI()
					.trim();
		}

		// ơ.ʾƥ䵱ǰԪأ*ʾƥԪ
		if (elementLocalName.equals(PathExpConstant.SELF_MATCH_CODE)
				|| elementLocalName.equals(PathExpConstant.ALL_MATCH_CODE)) {
			return true;
		}

		if (elementLocalName.equals(met.getQName().getName())) { // localpartͬ
			if (elementNamespace.equals("")) { // pathElement֧ƿռ,ȽLocalpart
				return true;
			}

			if (!pathElement.getElementQName().getNamespacePrefix().equals("")
					&& elementNamespace.equals(met.getQName().getNamespacePrefix())) { // pathElementдǰ׺ǰ׺Ƚ
				return true;
			}

			if (!pathElement.getElementQName().getNamespaceURI().equals("")
					&& elementNamespace
							.equals(met.getQName().getNamespaceURI())) {// pathElementдƿռ䣬ƿռȽ
				return true;
			}

			return false; // ƿռ䲻ƥ

		} else {
			return false; // localpartƥ
		}

	}

	/**
	 * ƥ·ԪرʽеMetasetǷͬ
	 * 
	 * @param pathAttr
	 * @param attr
	 * @return
	 */
	private boolean matchPathAttributeName(Attribute pathAttr, QName qName) {

		String pathAttrLocalName = pathAttr.getQName().getName();
		String pathAttrNameSpace = "";
		if (!pathAttr.getQName().getNamespacePrefix().equals("")) {
			pathAttrNameSpace = pathAttr.getQName().getNamespacePrefix();
		} else {
			pathAttrNameSpace = pathAttr.getQName().getNamespaceURI();
		}

		// *ʾƥ
		if (pathAttrLocalName.equals(PathExpConstant.ALL_MATCH_CODE)) {
			return true;
		}

		// ע⣺ԵռΪ,κռ䣡 by lizq 20080506

		if (pathAttrLocalName.equals(qName.getName())) {

			if (pathAttrNameSpace.equals("")) { // ѡ·еattributeûռ
				return true;
			}

			if (!pathAttr.getQName().getNamespacePrefix().equals("")
					&& pathAttrNameSpace.equals(qName.getNamespacePrefix())) {// pathAttrдǰ׺ǰ׺Ƚ
				return true;
			}

			if (!pathAttr.getQName().getNamespaceURI().equals("")
					&& pathAttrNameSpace.equals(qName
							.getNamespaceURI())) {// pathAttrдƿռ䣬ƿռȽ
				return true;
			}

			return false; // ƿռ䲻ƥ

		} else {
			return false; // localpartƥ
		}
	}

}
