package org.act.xservices.rt.metaset.query;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
 

import org.act.xservices.rt.metaset.exception.QNameExpressionException;
import org.act.xservices.rt.metaset.utils.ExpressionUtil;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.xpath.DefaultXPath;


/**
 * ѡ
 * 
 * @version 1.0 2008-5-10
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class SelectorProcessor {

	private static SelectorProcessor instance = new SelectorProcessor();

	/**
	 * ģʽ
	 * 
	 * @return
	 */
	public static SelectorProcessor getInstance() {
		return instance;
	}

	/**
	 * ƥ·ĵһԪصԪƣ򷵻null
	 * 
	 * @param pathExp
	 * @return
	 */
	public QName selectorElementName(String pathExp, Metaset metasetIn) {
		List<QName> resultList = selectorsElementName(pathExp, metasetIn);

		if (resultList != null && resultList.size() > 0) {
			return resultList.get(0);
		}
		return null;
	}

	/**
	 * ƥ·ԪصԪƣ򷵻null
	 * 
	 * @param pathExp
	 * @return
	 */
	public List<QName> selectorsElementName(String pathExp, Metaset metasetIn) {

		Metaset tmp = FilterProcessor.getInstance().filter(pathExp, metasetIn);

		if (tmp != null) {
			Iterator<Metaset> children = tmp.elementIterator();
			List<QName> resultList = new ArrayList<QName>();
			while (children.hasNext()) {
				QName qname=children.next().getQName();
				resultList.add(qname);
			}
			return resultList;
		} 
		return null;

	}

	/**
	 * Ȳ ƥ·ĵһԪ Ȼ󷵻شԪΪattrNameԵֵ򷵻null
	 * attrNameΪʽ 1. attrLocalpart 2. prefix:attrLocalpart 3.
	 * {NamespaceURI}attrLocalpart
	 * 
	 * @param pathExp
	 * @param attrName
	 * @return
	 */
	public String selectorAttributeValue(String pathExp, String attrName,
			Metaset metasetIn) {

		Metaset tmp = FilterProcessor.getInstance().filter(pathExp, metasetIn);

		if (tmp != null) {
			Iterator<Metaset> children = tmp.elementIterator();
			if (children.hasNext()) {
				Metaset metT = children.next();
				try {
					List<String> resultList = getAttributeValueByName(metT, attrName);
					if (resultList.size() == 0) {
						return null;
					} else {
						return resultList.get(0); // صһ
					}
				} catch (QNameExpressionException e) {
					e.printStackTrace();
					return null;
				}
			}
		}
		return null;

	}

	/**
	 * Ȳ ƥ·Ԫ Ȼ List<String> ʽЩԪ
	 * ΪattrNameԵֵ򷵻null attrNameΪʽ 1. attrLocalpart 2.
	 * prefix:attrLocalpart 3. {NamespaceURI}attrLocalpart
	 * 
	 * @param pathExp
	 * @param attrName
	 * @return
	 */
	public List<String> selectorsAttributeValue(String pathExp,
			String attrName, Metaset metasetIn) {

		List<String> resultList = new ArrayList<String>();

		Metaset tmp = FilterProcessor.getInstance().filter(pathExp, metasetIn);

		if (tmp != null) {
			Iterator<Metaset> children = tmp.elementIterator();
			while (children.hasNext()) {
				Metaset metT = children.next();
				try {
					resultList.addAll(getAttributeValueByName(metT, attrName));
				} catch (QNameExpressionException e) {
					e.printStackTrace();
					return null;
				}
			}
		}

		if (resultList.size() == 0) {
			return null;
		} else {
			return resultList;
		}
	}

	@SuppressWarnings("unchecked")
	public List<String> selectorAttributeValueByXPath(String pathExp,
			String attrName, Metaset metasetIn, Map<String, String> namespaceMap) {

//		try {
			String newPath = pathExp + "/@" + attrName;

			List<String> attrValues = new ArrayList<String>();

			DefaultXPath xpathExpression = new DefaultXPath(newPath);

			if (namespaceMap != null) {
				xpathExpression.setNamespaceURIs(namespaceMap);
			}

			List<Attribute> attrs = xpathExpression.selectNodes(metasetIn);

			for (int i = 0; i < attrs.size(); i++) {
				attrValues.add(attrs.get(i).getValue());
			}

			return attrValues;

//		} catch (JaxenException e) {
//			e.printStackTrace();
//			return null;
//		}

	}

	/**
	 * attrNameΪʽ 1. attrLocalpart 2. prefix:attrLocalpart 3.
	 * {NamespaceURI}attrLocalpart
	 * 
	 * @param attrList
	 * @param attrName
	 * @return
	 * @throws QNameExpressionException
	 */
	private List<String> getAttributeValueByName(Metaset metaset,
			String attrName) throws QNameExpressionException {
		Iterator<Attribute> attrList=metaset.attributeIterator();

		QName attrQName = ExpressionUtil.parseQNameString(attrName);

		List<String> resultList = new ArrayList<String>();

		while (attrList.hasNext()) {
			Attribute attrT = attrList.next();
			if (ExpressionUtil.matchAttributeQName(attrQName, attrT.getQName())) {
				resultList.add(attrT.getValue());
			}
		}
		Iterator<Namespace> namespace=metaset.declaredNamespaces().iterator();
		while (namespace.hasNext()) {
			Namespace ns = namespace.next();
			QName nsQName =null;
			if(ns.getPrefix()==null||ns.getPrefix().equals("")){
				nsQName= new QName(ns
					.getURI(), "", "xmlns");
			}else{
				nsQName= new QName(ns
						.getURI(), ns.getPrefix(), "xmlns");
			}
			if (ExpressionUtil.matchAttributeQName(attrQName, nsQName)) {
				resultList.add(ns.getURI());
			}
		}
		return resultList;
	} 

}
