package org.act.xservices.rt.metaset.utils;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;

/**
 * Metaset
 * 
 * @version 1.0 2005-06-23
 * @version 1.1 2008-05-01
 * @author liujian [liujian@act.buaa.edu.cn]
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public final class MetasetUtil {

	/**
	 * Metasetǰ׺
	 * 
	 * @param met
	 * @param prefixName
	 * @param uriValue
	 */
	public static final void addNameSpaceDefinition(Metaset met,
			String prefixName, String uriValue) {
		Attribute att = MetasetBuilder.getInstance().newAttribute(
				"xmlns:" + prefixName, uriValue);
		met.add(att);
	}

	/**
	 * ôMetasetУƿռnameSpaceValueӦǰ׺Ԫغ͸Ԫе עʹô˷ʱ뽫
	 * MetasetParser  isIncludeNSPrefixAttribute Ϊtrue
	 * 
	 * @param met
	 * @param nameSpaceValue
	 * @return
	 */
	@Deprecated
	public static final String getPrefix(Metaset met, String nameSpaceValue) {
		Map<String, Attribute> nameSpaceList = getNameSpaceDefinitions(met);
		Iterator<Attribute> it = nameSpaceList.values().iterator();
		while (it.hasNext()) {
			Attribute att = it.next();
			if (att.getValue().equals(nameSpaceValue)) {
				return att.getQName().getName();
			}
		}
		return null;
	}

	/**
	 * ôMetasetеƿռԪغ͸Ԫе עʹô˷ʱ뽫 MetasetParser 
	 * isIncludeNSPrefixAttribute Ϊtrue
	 * 
	 * @param met
	 * @return
	 */
	@Deprecated
	public static final Map<String, Attribute> getNameSpaceDefinitions(
			Metaset met) {

		Map<String, Attribute> nameSpaceList = new HashMap<String, Attribute>();
		Iterator<Attribute> attris = met.attributeIterator();
		while (attris.hasNext()) {
			Attribute att = attris.next();
			String nameSpace = att.getQName().getNamespacePrefix();
			if (nameSpace.equals("xmlns")) {
				nameSpaceList.put(att.getQName().getName(), att);
			}
		}
		return nameSpaceList;
	}

	/**
	 * һյMetasetװһList<IMetaset> ListΪգ򷵻null
	 * 
	 * @param resultList
	 * @param anti_order
	 * @return
	 */
	public static final Metaset encapsulateByMetaset(List<Metaset> resultList) {
		if (resultList.isEmpty()) {
			return null;
		} else {
			Metaset resultMet = MetasetBuilder.getInstance().newMetaset();
			for (int i = 0; i < resultList.size(); i++) {
				resultMet.encapsulatedChild((Metaset) resultList.get(i));
			}
			return resultMet;
		}
	}

	/**
	 * Metaset丸ڵУǰ׺prefixƿռ䡣 prefixΪ null 
	 * ޷ҵӦURI򷵻null ע⣺˷ҪSAX
	 * saxParser.setProperty("http://xml.org/sax/features/namespace-prefixes",
	 * true);
	 * 
	 * @param met
	 * @param prefix
	 * @return
	 */
	public static final String findNsURIofPrefix(Metaset met, String prefix) {

		if (prefix == null || prefix.equals("")) {
			return null;
		} else {
			Metaset current = met;
			String namespace = null;
			do {
				namespace = current.selectorAttributeValue(".\\", "xmlns:"
						+ prefix);
				if (namespace != null) {
					break;
				}
				current = (Metaset) current.getParent();
				if (current == null) {
					break;
				}
			} while (true);

			return namespace;
		}
	}

	public static String getEncoding(String text) {
		String result = null;

		String xml = text.trim();

		if (xml.startsWith("<?xml")) {
			int end = xml.indexOf("?>");
			String sub = xml.substring(0, end);
			StringTokenizer tokens = new StringTokenizer(sub, " =\"\'");

			while (tokens.hasMoreTokens()) {
				String token = tokens.nextToken();

				if ("encoding".equals(token)) {
					if (tokens.hasMoreTokens()) {
						result = tokens.nextToken();
					}

					break;
				}
			}
		}

		return result;
	}
	
	/**
	 * javax.xml.namespace.QName ת org.act.xservices.rt.xom.QName
	 * ʱҪת 
	 * @param javax.xml.namespace.QName
	 * @return
	 */
    public static org.act.xservices.rt.xom.QName jQNameToxQName(javax.xml.namespace.QName jq){
    	
    	return new org.act.xservices.rt.xom.QName(
    			jq.getNamespaceURI(), jq.getLocalPart(), jq.getPrefix());
    }
    
    /**
     *  org.act.xservices.rt.xom.QName תΪ javax.xml.namespace.QName
     * ʱҪת 
     * @param org.act.xservices.rt.xom.QName
     * @return
     */
    public static javax.xml.namespace.QName xQNameTojQName(org.act.xservices.rt.xom.QName xq){
    	
    	return new javax.xml.namespace.QName(
    			xq.getNamespaceURI(), xq.getName(), xq.getNamespacePrefix());

    }
}
