/*
 * 
 * MetasetImpl
 * 
 * ע⣺ԹУΪ˷㣬AttributeImplĹ췽 ķʿƸΪ public
 *      ԭprotected.
 * 
 * 
 */

package org.act.xservices.rt.xom.impl.stax;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;


import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;

import junit.framework.TestCase;


public class MetasetImplTest extends TestCase {

	private Metaset metaset = null;
	private static MetasetBuilder builder = new MetasetBuilder();

	public MetasetImplTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		
		super.setUp();
		InputStream in =MetasetImplTest.class.getClassLoader().getResourceAsStream("textFile/MetasetImplTest_Sample.xml");
		this.metaset = MetasetParserFactory.getStAXParser().parse(in);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		this.metaset = null;
	}

	
	public void testGetNamespaceURI() {

		assertEquals("www.namespace", metaset.getNamespaceURI());
		assertEquals("", metaset.elements().get(0).getNamespaceURI());
		System.out.println(metaset.toDocument());
	}

	public void testGetFullStringName() {
		assertEquals("{www.namespace}personnel", metaset.getFullStringName());
		assertEquals("person", metaset.elements().get(0).getFullStringName());
	}

	public void testgetNamespacePrefix() {
		assertEquals("xsd", metaset.getNamespacePrefix());
		assertEquals("", metaset.elements().get(0).getNamespacePrefix());
	}

	public void testgetName() {
		assertEquals("personnel", metaset.getName());
		assertEquals("person", metaset.elements().get(0).getName());
	}

	public void testGetQName() {
		QName qName = new QName("www.namespace", "personnel", "xsd");
		assertEquals(qName, metaset.getQName());//ıȽϲprefix,xsdַͨԡ
		
		qName = new QName("", "person","");
		assertEquals(qName, metaset.elements().get(0).getQName());
	}

	public void testgetParent() {
		assertEquals(null, metaset.getParent());
		assertEquals(metaset, metaset.elements().get(0).getParent());
	}

	public void testAttributes() {
		
//		Attribute attr0 =  metaset.attributes().get(0);

//		assertEquals("http://www.w3.org/2000/xmlns/", attr0.getNamespaceURI());
//		assertEquals("xmlns", attr0.getNamespacePrefix());
//		assertEquals("xsd", attr0.getName());
//		assertEquals("www.namespace", attr0.getValue());

		Attribute attr1 =  metaset.attributes().get(0);
		assertEquals("http://act.org", attr1.getNamespaceURI());
		assertEquals("act", attr1.getNamespacePrefix());
		assertEquals("version", attr1.getName());
		assertEquals("1.0", attr1.getValue());
		
		
		Attribute attr00 = metaset.elements().get(0).attributes().get(0);

		assertEquals("", attr00.getNamespaceURI());
		assertEquals("", attr00.getNamespacePrefix());
		assertEquals("id", attr00.getName());
		assertEquals("Big.Boss", attr00.getValue());
	}

	
	public void testFilter() {
		assertEquals(null, metaset.filter(".\\person@id='three.worker'"));
		assertEquals(null, metaset.filter(""));
		
		assertEquals(metaset.elements().get(2).toXML(), metaset.filter(
				".\\person@id='two.worker'").toXML());
		assertEquals(metaset.toXML(), metaset.filter("personnel").toXML());
		assertEquals(metaset.elements().get(1).toXML(), metaset.filter(
				"personnel\\person@id='one.worker'").toXML());

		assertEquals(metaset.toXML(), metaset.filter("*").toXML());
		assertEquals(metaset.toXML(), metaset.filter("*@xmlns:xsd").toXML());
		assertEquals(metaset.toXML(), metaset.filter("*@xsd").toXML());

		assertEquals(null, metaset.filter("*@xmlns"));

		assertEquals(metaset.toXML(), metaset.filter("*@xsd='www.namespace'")
				.toXML());
		assertEquals(null, metaset.filter("*@xmlns='www.namespace'"));
		assertEquals(null, metaset.filter("*@id='one.worker'"));

		assertEquals(null, metaset.filter("given"));

		assertEquals(metaset.elements().get(1).toXML(), metaset.filter(
				"personnel\\*@id='one.worker'").toXML());
		assertEquals(null, metaset.filter("personnel\\*@id=' '"));

		assertEquals(null, metaset.filter("person@id='one.worker'"));

		assertEquals(metaset.toXML(), metaset.filter(".").toXML());
		assertEquals(metaset.toXML(), metaset.filter(".@xmlns:xsd").toXML());
		assertEquals(null, metaset.filter(".@xmlns"));
		assertEquals(metaset.toXML(), metaset.filter(".@xsd").toXML());
		assertEquals(metaset.toXML(), metaset.filter(".@xsd='www.namespace'")
				.toXML());

		assertEquals(null, metaset.filter(".\\person\\name\\family\\*"));

		assertNotNull(metaset.filter(".\\*\\name\\*"));

		assertNotNull(metaset.filter(".\\*\\address\\street\\*"));

		assertEquals(metaset.elements().get(3).elements().get(1)
				.elements().get(1).toXML(), metaset.filter(
				".\\*\\*\\street").toXML());

		assertEquals(metaset.elements().get(3).elements().get(1)
				.elements().get(1).toXML(), metaset.filter(
				".\\building\\address\\street").toXML());

		assertEquals(metaset.elements().get(3).elements().get(1)
				.elements().get(1).toXML(), metaset.filter(
				".\\building\\addr:address\\street").toXML());

		assertEquals(metaset.elements().get(3).elements().get(1)
				.elements().get(1).toXML(), metaset.filter(
				".\\building\\{www.namespace/building/address}address\\street")
				.toXML());

		// Isn't "personnel\\*@id=''" an legal ExPath?
		// assertEquals(null,metaset.filter("personnel\\*@id=''"));

		// Is ".\\" an legal ExPath?
		// assertEquals(null,metaset.filter(".\\"));

		// Is "\\*" an legal ExPath?
		// assertEquals(null,metaset.filter("\\*"));

		// Is "\\" an legal ExPath?
		// assertEquals(null,metaset.filter("\\"));

		// Is "" an legal ExPath?
		// assertEquals(null,metaset.filter(""));

		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < metaset.elements().size(); i++) {
			sb.append(metaset.elements().get(i).toXML());
		}
		// Order is reversed!
		assertEquals(sb.toString(), metaset.filter(".\\*").toXML());

	}

	public void testSelectorElementName() {

		assertEquals(new QName("www.namespace", "personnel", "xsd"), metaset
				.selectorElementName("."));
		assertEquals(new QName("www.namespace", "personnel", "xsd"), metaset
				.selectorElementName("*"));

		assertNull(metaset.selectorElementName(".\\somethingNotExist\\*"));
		assertNull(metaset.selectorElementName(".\\person\\name\\family\\*"));

		assertEquals(null, metaset.selectorElementName(".\\person\\*\\*\\*"));

		assertEquals(new QName("www.namespace/building/address/street/number",
				"code", ""), metaset.selectorElementName(".\\*\\*\\*\\*\\code"));

		/*
		 * ʧܵĲԡselectorElementName,صĲǵһƥQNameһ
		 */

		assertEquals(new QName("www.namespace/building/address/street/number",
				"code", ""), metaset.selectorElementName(".\\*\\*\\*\\*\\*"));
		assertEquals(new QName("", "person", ""), metaset
				.selectorElementName(".\\*"));

		assertEquals(new QName("", "family", ""), metaset
				.selectorElementName(".\\person\\name\\*"));
		assertEquals(new QName("", "family", ""), metaset
				.selectorElementName(".\\person\\*\\*"));
		assertEquals(new QName("", "family", ""), metaset
				.selectorElementName(".\\person@id='one.worker'\\name\\*"));
		assertEquals(new QName("", "family", ""), metaset
				.selectorElementName(".\\person\\name\\*"));

	}

	public void testSelectorsElementName() {


		List<QName> list1 = new ArrayList<QName>();
		list1.add(new QName("www.namespace", "personnel", "xsd"));
		assertEquals(list1, metaset.selectorsElementName("."));

		List<QName> list2 = new ArrayList<QName>();
		list2.add(new QName("www.namespace/building/address/street/number",
				"number", ""));
		assertEquals(list2, metaset
				.selectorsElementName(".\\building\\address\\street\\number"));

		List<QName> list3 = new ArrayList<QName>();
		list3.add(new QName("www.namespace/building/address/street/number",
				"number", ""));
		assertEquals(
				list3,
				metaset
						.selectorsElementName(".\\building\\addr:address\\street\\number"));

		List<QName> list4 = new ArrayList<QName>();
		list4.add(new QName("www.namespace/building/address/street/number",
				"number", ""));
		assertEquals(list4,
				metaset.selectorsElementName(
						".\\building\\{www.namespace/building/address}address\\street\\number"));

		List<QName> list5 = new ArrayList<QName>();
		list5.add(new QName("www.namespace/building/address/street/number",
				"number", ""));
		assertEquals(list5, metaset
				.selectorsElementName(".\\building\\address\\street\\number"));

		List<QName> list6 = new ArrayList<QName>();
		list6.add(new QName("", "name", ""));
		list6.add(new QName("", "name", ""));
		list6.add(new QName("", "name", ""));
		list6.add(new QName("", "name", ""));
		list6.add(new QName("www.namespace/company/register/name", "name",
				"regName"));
		assertEquals(list6, metaset.selectorsElementName(".\\*\\name"));

		List<QName> list7 = new ArrayList<QName>();
		list7.add(new QName("", "person", ""));
		list7.add(new QName("", "person", ""));
		list7.add(new QName("", "person", ""));
		list7.add(new QName("www.namespace/building", "building", "build"));
		list7.add(new QName("www.namespace/company", "company", "xsd"));
		
		assertEquals(list7, metaset.selectorsElementName(".\\*"));
	}

	public void testSelectorAttributeValue() {

		assertEquals("www.namespace", metaset
				.selectorAttributeValue(".", "xsd"));

		assertEquals("www.namespace/building/address/street/number", metaset
				.selectorAttributeValue(".\\*\\*\\*\\*", "*"));

		assertEquals("www.namespace/building/address/street/number", metaset
				.selectorAttributeValue(".\\building\\*\\*\\*", "*"));

		assertEquals("www.namespace/building/address/street/number", metaset
				.selectorAttributeValue(".\\building\\addr:address\\*\\*", "*"));

		assertEquals("www.namespace/building/address/street/number", metaset
				.selectorAttributeValue(
						".\\{www.namespace/building}building\\*\\*\\*", "*"));

		assertEquals(null, metaset.selectorAttributeValue(".\\*","xsd"));

		// ܴǰ׺
		assertEquals("www.namespace", metaset.selectorAttributeValue(".","xmlns:xsd"));

	}

	public void testSelectorsAttributeValue() {

		List<String> list = null;

		list = new ArrayList<String>();
		list.add("www.namespace/building/address/street/number");
		assertEquals(list, metaset
				.selectorsAttributeValue(".\\*\\*\\*\\*", "*"));

		list = new ArrayList<String>();
		list.add("www.namespace/company");
		assertEquals(list, metaset.selectorsAttributeValue(".\\*", "xsd"));

		// ˳෴
		// ʧ
		list = new ArrayList<String>();
		list.add("Big.Boss");
		list.add("one.worker");
		list.add("two.worker");
		assertEquals(list, metaset.selectorsAttributeValue(".\\person", "id"));

//		// 
//		// ͨ
//		list = new ArrayList<String>();
//		list.add("two.worker");
//		list.add("one.worker");
//		list.add("Big.Boss");
//		assertEquals(list, metaset.selectorsAttributeValue(".\\*", "id"));
	}

	public void testAddAttribute() {

		//һظԡ
		metaset.add(builder.newAttribute(new QName("http://www.w3.org/2000/xmlns/", "xsd",
				"xmlns"), "www.namespace"));

		// һԣȻ
		metaset.add(builder.newAttribute(new QName("", "id",
				""), "id-personnel"));

		assertEquals("id-personnel", metaset.selectorAttributeValue(".", "id"));

		//һnullԡ
		//assertFalse(metaset.add(null));

		assertEquals("id-personnel", metaset.selectorAttributeValue(".", "id"));

		// һԣֿռ䣩Ȼ
		metaset.add(builder.newAttribute(new QName(
				"www.namespace", "link", "xsd"), "link-personnel"));

		assertEquals("link-personnel", metaset.selectorAttributeValue(".",
				"link"));

		// Բܴǰ׺
		// ʧ
		assertEquals("link-personnel", metaset.selectorAttributeValue(".",
				"xsd:link"));

		// Բܴuri
		// ʧ
		assertEquals("link-personnel", metaset.selectorAttributeValue(".",
				"{www.namespace}link"));

	}

	public void testAddChildren() {

		//ԼԼ
		metaset.add(metaset);

		// һظԪ
		metaset.add((Metaset)metaset.elements().get(0).clone());

		List<String> list = new ArrayList<String>();
		list.add("Big.Boss");
		list.add("Big.Boss");

		// ѡԪصһֵӦÿԵõ
		// ͨ
		assertEquals(list, metaset.selectorsAttributeValue(
				".\\*@id='Big.Boss'", "id"));

		//һnullԪأȻٽĲԣִ


		assertEquals(list, metaset.selectorsAttributeValue(
				".\\*@id='Big.Boss'", "id"));

	}

	public void testAttribute1() {

		//ָյ·
		assertFalse(metaset.addAttribute(".\\person\\manager",
				builder.newAttribute(new QName("", "", ""), "")));

		//Է·ԪһԣȻҡ
		assertTrue(metaset.addAttribute(".\\person", builder.newAttribute(
				new QName("", "gender", ""), "mail")));

		List<String> list = new ArrayList<String>();
		list.add("mail");
		list.add("mail");
		list.add("mail");
		assertEquals(list, metaset.selectorsAttributeValue(".\\*@id", "gender"));

		//Է·Ԫһ(ֿռ)Ȼҡ
		assertTrue(metaset.addAttribute(".\\*@id\\*\\family",
				builder.newAttribute(new QName("www.namespace", "nns", "xsd"),
						"family-name-ns")));

		list = new ArrayList<String>();
		list.add("family-name-ns");
		list.add("family-name-ns");
		list.add("family-name-ns");

		assertEquals(list, metaset.selectorsAttributeValue(".\\*\\*\\family",
				"nns"));

		
		assertEquals(list, metaset.selectorsAttributeValue(".\\*\\*\\family",
				"nns"));

		//Է·Ԫһnull,Ȼĸԣִ

		assertEquals(list, metaset.selectorsAttributeValue(".\\*\\*\\family",
				"nns"));

		assertEquals(list, metaset.selectorsAttributeValue(".\\*\\*\\family",
				"xsd:nns"));
		assertEquals(list, metaset.selectorsAttributeValue(".\\*\\*\\family",
				"{www.namespace}nns"));
	}

	public void testadd1() {

		//ָյ·
		assertFalse(metaset.addChildren(".\\person\\manager", metaset));

		//ѸԪؼԪУ
		assertTrue(metaset.addChildren(".\\*@id", metaset));

		//ҼĲ֡
		List<QName> list = new ArrayList<QName>();
		list.add(new QName("www.namespace", "personnel", "xsd"));
		list.add(new QName("www.namespace", "personnel", "xsd"));
		list.add(new QName("www.namespace", "personnel", "xsd"));

		assertEquals(list, metaset.selectorsElementName(".\\*@id\\personnel"));

		//ֵݹˡ
		assertNull(metaset
				.filter(".\\person\\personnel\\person\\personnel\\person\\personnel\\person\\personnel"));

		//һnullظĲԣִ
		assertFalse(metaset.addChildren(".\\*@id", null));

		assertEquals(list, metaset.selectorsElementName(".\\*@id\\personnel"));
	}

	public void testRemoveAttribute() {

		//ͼɾһڵ
		assertFalse(metaset.remove(builder.newAttribute(new QName("", "",
				""), "")));

		//ͼɾnull

		//ɾһڵ
//		assertTrue(metaset.remove(builder.newAttribute(new QName("http://www.w3.org/2000/xmlns/",
//				"xsd", "xmlns"), "www.namespace")));

		//Ȼ
//		assertNull(metaset.selectorAttributeValue(".", "xsd"));

		//һnullԣȻɾ
	}

	public void testRemoveChildren() {

		//ͼɾһڵԪ,
		//assertFalse(metaset.removeChildren(metaset));

		//ɾһnullԪ
		//assertFalse(metaset.removeChildren(null));

		//ɾһڵԪ
		assertTrue(metaset.removeChildren(metaset.elements().get(0)));

		//Ȼ
		assertNull(metaset.filter(".\\*@id='Big.Boss'"));

		//һnullԪأȻɾ
		
		//assertFalse(metaset.removeChildren(null));
	}

	public void testRemoveAttribute1() {
		
		//ָյ·
		assertFalse(metaset.removeAttribute(".\\person\\manager", null));
		
		//ɾһnull
		assertFalse(metaset.removeAttribute(".\\*",null));
		
		//Ԫһ·ƥ䣬ֻһԪи
//		assertFalse(metaset.removeAttribute(".\\person", 
//				builder.newAttribute(new QName("","id",""),"Big.Boss")));
		
		//ѯ⼸ԪصԡӦֻһԪɾɹ
		
		//Ӧûɾ
		assertNotNull(metaset.elements().get(1).selectorAttributeValue(".", "id"));
		assertNotNull(metaset.elements().get(2).selectorAttributeValue(".", "id"));
		
		//Ӧɾɹ
		assertNotNull(metaset.elements().get(0).selectorAttributeValue(".", "id"));
		
		
//		/*
//		 * ֤˶ʧԭĲ²⡣
//		 * 
//		 * жԪ·ƥ䣬ֻһиҪɾԪءڲõĽ
//		 * ģȶһɾɹȻƥԪؽɾ
//		 * ʧܣءûлعƣǸԪصɾǳɹġ
//		 */
//		assertFalse(metaset.removeAttribute(".\\person", 
//				builder.newAttribute(new QName("","id",""),"two.worker")
//				));
//		assertNotNull(metaset.elements().get(0).selectorAttributeValue(".", "id"));
//		assertNull(metaset.elements().get(2).selectorAttributeValue(".", "id"));
//		assertNotNull(metaset.elements().get(1).selectorAttributeValue(".", "id"));
		
	}
	
	public void testRemoveChildren1(){
		
		//ָյ·
		assertFalse(metaset.removeChildren(".\\manager", null));
		
		//ҪɾԪز,metaset
		assertTrue(metaset.removeChildren(".\\person",metaset));
		
		//Ԫ·ƥ䣬ֻһҪɾԪ
		assertTrue(metaset.removeChildren(".\\*@id",metaset.elements().get(0).elements().get(0)));
		
		//ڲҪɾԪأɾɹ
		assertNotNull(metaset.elements().get(1).filter(".\\name"));
		assertNotNull(metaset.elements().get(2).filter(".\\name"));
		
		//Ӧɾɹ
		//ûɾɹԭͬtestRemoveAttribute1()
		assertNull(metaset.elements().get(0).filter(".\\name"));
	}

	public void testGetHeight(){
		assertEquals(5,metaset.getHeight());
		
		Metaset mt= metaset.filter(".\\person\\name\\given");
		assertEquals(1,mt.getHeight());
		
		mt= metaset.filter(".\\person\\name");
		assertEquals(2,mt.getHeight());
		
		mt= metaset.filter(".\\person");
		assertEquals(3,mt.getHeight());
		
	}
	
	public void testGetLeafCount(){
		assertEquals(17,metaset.getLeafCount());
		
		Metaset mt= metaset.filter(".\\person\\name\\given");
		assertEquals(3,mt.getLeafCount());
		
		mt= metaset.filter(".\\person\\name");
		assertEquals(6,mt.getLeafCount());
		
		mt= metaset.filter(".\\person");
		assertEquals(12,mt.getLeafCount());
	}
}
