package org.act.xservices.rt.xom.impl.xpath;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Metaset;

import junit.framework.TestCase;

/**
 * Test FilterByXPath and SelectorsAttribtuesByXPath
 * 
 * @author WuKan
 * 
 */
public class MetasetFilterByXPath extends TestCase {

	private Metaset metaset;
	private MetasetBuilder builder;

	public MetasetFilterByXPath(String name) {
		super(name);
	}

	public void setUp() {
		builder = new MetasetBuilder();
		metaset = builder.newMetaset();
	}

	public void testNormalSelection() throws MetasetParsingException {
		// Metaset root =
		// MetasetParserFactory.getStAXParser().parse("textFile/xpath/normalSelection.xml");
		// metaset.add(root);
		// root.setParent(metaset);
		//		
		// Metaset result1 = metaset.filterByXPath("./AAA", null);
		// Metaset result2 = metaset.filterByXPath("./AAA/CCC", null);
		// Metaset result3 = metaset.filterByXPath("./AAA/DDD/BBB", null);
		//		
		// assertEquals(1, result1.elements().size());
		// assertEquals("AAA", result1.elements().get(0).getQualifiedName());
		// assertEquals(2, result2.elements().size());
		// assertEquals("CCC", result2.elements().get(1).getQualifiedName());
		// assertEquals(1, result3.elements().size());
		// assertEquals("BBB", result3.elements().get(0).getQualifiedName());
		//		
		// metaset.elements().clear();

	}

	public void testDoubleSelection() throws MetasetParsingException {
		// Metaset root =
		// MetasetParserFactory.getStAXParser().parse("textFile/xpath/doubleSelection.xml");
		// metaset.add(root);
		// root.setParent(metaset);
		//		
		// Metaset result1 = metaset.filterByXPath(".//BBB", null);
		// Metaset result2 = metaset.filterByXPath(".//DDD/BBB", null);
		//		
		// assertEquals(5, result1.elements().size());
		// assertEquals(3, result2.elements().size());
		//		
		// metaset.elements().clear();

	}

	public void testStarSelection() throws MetasetParsingException {
		// Metaset root =
		// MetasetParserFactory.getStAXParser().parse("textFile/xpath/starSelection.xml");
		// metaset.add(root);
		// root.setParent(metaset);
		//		
		// Metaset result1 = metaset.filterByXPath("./AAA/CCC/DDD/*", null);
		// Metaset result2 = metaset.filterByXPath("./*/*/*/BBB", null);
		// Metaset result3 = metaset.filterByXPath(".//*", null);
		//		
		// assertEquals(4, result1.elements().size());
		// assertEquals(5, result2.elements().size());
		// assertEquals(17, result3.elements().size());
		//		
		// metaset.elements().clear();

	}

	public void testElementSelectionWithNamespace()
			throws MetasetParsingException {
		// Metaset root =
		// MetasetParserFactory.getStAXParser().parse("textFile/xpath/elementNamespaceSelection.xml");
		// metaset.add(root);
		// root.setParent(metaset);
		//		
		// Map<String, String> map = new HashMap<String, String>();
		// map.put("pre", "www.example.com");
		//		
		// Metaset result1 = metaset.filterByXPath("./AAA/BBB", map);
		// Metaset result2 = metaset.filterByXPath("./AAA/pre:BBB", map);
		// Metaset result3 =
		// metaset.filterByXPath("./AAA/*[local-name()='BBB']", map);
		//
		// assertEquals(1, result1.elements().size());
		// assertEquals(2, result2.elements().size());
		// assertEquals(3, result3.elements().size());
	}

	public void testAttributeSelection() throws MetasetParsingException {
		// Metaset root =
		// MetasetParserFactory.getStAXParser().parse("textFile/xpath/attributeSelection.xml");
		// metaset.add(root);
		// root.setParent(metaset);
		//		
		// List<String> result1 = metaset.selectorsAttributeValueByXPath(".//*",
		// "id", null);
		// Metaset result2 = metaset.filterByXPath(".//BBB[@id]", null);
		// Metaset result3 = metaset.filterByXPath(".//BBB[@name]", null);
		// Metaset result4 = metaset.filterByXPath(".//BBB[@*]", null);
		//		
		// assertEquals(2, result1.size());
		// assertTrue(result1.contains("b1"));
		// assertTrue(result1.contains("b2"));
		// assertEquals(2, result2.elements().size());
		// assertEquals(1, result3.elements().size());
		// assertEquals(3, result4.elements().size());
		//		
		// metaset.elements().clear();

	}

	public void testAttributeSelectionWithNamespace()
			throws MetasetParsingException {
		InputStream in = MetasetFilterByXPath.class.getClassLoader()
				.getResourceAsStream(
						"textFile/xpath/attributeNamespaceSelection.xml");
		Metaset root = MetasetParserFactory.getStAXParser().parse(in);
		metaset.add(root);
		root.setParent(metaset);

		Map<String, String> map = new HashMap<String, String>();
		map.put("wukan", "http://www.wukan.com/");
		map.put("alun", "http://www.alun.com/");

		List<String> result1 = metaset.selectorsAttributeValueByXPath(
				"./AAA/BBB", "id", map);
		List<String> result2 = metaset.selectorsAttributeValueByXPath(
				"./AAA/BBB", "wukan:id", map);
		List<String> result3 = metaset.selectorsAttributeValueByXPath(
				"./AAA/BBB", "*[local-name()='id']", map);

		assertEquals(1, result1.size());
		assertEquals(1, result2.size());
		assertTrue(result2.contains("b1"));
		assertEquals(3, result3.size());
	}
}
