package org.act.xservices.rt.xom.impl.xpath;

import java.io.InputStream;
import java.util.Iterator;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.xpath.DefaultXPath;
import org.jaxen.JaxenException;
import org.jaxen.saxpath.SAXPathException;
import junit.framework.TestCase;

public class MetasetXPathTest extends TestCase {

	private static final String BASIC_XML = "textFile/xpath/basic.xml";
	private Metaset metaset;
	private MetasetBuilder builder;

	public MetasetXPathTest(String name) {
		super(name);
	}

	public void setUp() {
		builder = new MetasetBuilder();
		metaset = builder.newMetaset();
	}

	public void testConstruction() throws JaxenException {
		DefaultXPath xpath = new DefaultXPath("./foo/bar/baz");
		// assertEquals("./foo/bar/baz", xpath.toString());
	}

	public void testConstructionWithNamespacePrefix() throws JaxenException {
		DefaultXPath xpath = new DefaultXPath("./p:foo/p:bar/a:baz");
		// assertEquals("./p:foo/p:bar/a:baz", xpath.toString());
	}

	@SuppressWarnings("unchecked")
	public void testMetasetSelection() throws MetasetParsingException,
			SAXPathException {
		DefaultXPath xpath = new DefaultXPath("./foo/bar/baz");
		InputStream in = MetasetFilterByXPath.class.getClassLoader()
				.getResourceAsStream(BASIC_XML);
		Metaset root = MetasetParserFactory.getStAXParser().parse(in);
		metaset.add(root);
		root.setParent(metaset);

		List<Metaset> results = xpath.selectNodes(metaset);

		assertEquals(3, results.size());

		Iterator iter = results.iterator();

		assertEquals("baz", ((Metaset) iter.next()).getName());

		assertEquals("baz", ((Metaset) iter.next()).getName());

		assertEquals("baz", ((Metaset) iter.next()).getName());

		assertTrue(!iter.hasNext());

		metaset.elements().clear();

	}

}
