package org.act.xservices.rt.xresource.basefault;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import org.act.xservices.rt.xresource.faults.ResourceUnavailableFault;


/**
 * 
 * WsbfUtils is a set of convenience methods related to WS-BaseFaults v1.2.
 *
 * @author douyl
 *
 */

public class WsbfUtils
{

	private static DateFormat _FORMATTER = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
	
	
    /**
     * 
     * @param error
     * 
     * @return The same Throwable recast as a BaseFault, <b>or</b> - if the 
     *         Throwable was not an instance of BaseFault - an instance of 
     *         ResourceUnavailableFault with the argument as the cause.
     *
     */

    public static BaseFault convertToFault(Throwable error)
    {
        if (error instanceof BaseFault)
            return (BaseFault)error;
        
        return new ResourceUnavailableFault();
    }
    
    
}
