/*
 * Created on 2006-4-9
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.faults;

import java.util.List;

import org.act.xservices.rt.xcontainer.addressing.EndpointReference;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.basefault.BaseFault;

/**
 * @author   Douyl
 */
public class ResourceNotDestroyedFault extends BaseFault{
	private static final long serialVersionUID = 6866739382979399756L;

	private final static String FAULT_TYPE = "ResourceNotDestroyedFault";
    /**
	 * A baseFaultType is needed, e.g ResourceUnknowFault
	 * 
	 * @param baseFaultType
	 */
    public ResourceNotDestroyedFault(){
    	super(FAULT_TYPE);
    }
    
    /**
	 * Constructor
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 */
	public ResourceNotDestroyedFault(List<String> description) {
		super(FAULT_TYPE, description);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public ResourceNotDestroyedFault(String baseFaultType, List<String> description,
			Metaset faultCause) {
		super(FAULT_TYPE, description, faultCause);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 */
	public ResourceNotDestroyedFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference) {
		super(FAULT_TYPE, description, originatorReference);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public ResourceNotDestroyedFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference, Metaset faultCause) {
		super(FAULT_TYPE, description, originatorReference, faultCause );
	}
}
