package org.act.xservices.rt.xresource.faults;

import java.util.List;

import org.act.xservices.rt.xcontainer.addressing.EndpointReference;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.basefault.BaseFault;

/**
 * 
 * @author douyl
 *
 */

public class ResourceUnavailableFault extends BaseFault
{
    private static final long serialVersionUID = -7569634397313256251L;

    private final static String FAULT_TYPE = "ResourceUnavailableFault";
    /**
	 * A baseFaultType is needed, e.g ResourceUnknowFault
	 * 
	 * @param baseFaultType
	 */
    public ResourceUnavailableFault(){
    	super(FAULT_TYPE);
    }
    
    /**
	 * Constructor
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 */
	public ResourceUnavailableFault(List<String> description) {
		super(FAULT_TYPE, description);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public ResourceUnavailableFault(String baseFaultType, List<String> description,
			Metaset faultCause) {
		super(FAULT_TYPE, description, faultCause);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 */
	public ResourceUnavailableFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference) {
		super(FAULT_TYPE, description, originatorReference);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public ResourceUnavailableFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference, Metaset faultCause) {
		super(FAULT_TYPE, description, originatorReference, faultCause );
	}
}
