package org.act.xservices.rt.xresource.faults;

import java.util.List;

import org.act.xservices.rt.xcontainer.addressing.EndpointReference;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.basefault.BaseFault;

/**
 * @author   Administrator
 */
public class UnableToPutResourcePropertyDocumentFault extends BaseFault{
	private static final long serialVersionUID = 7882599000949695852L;

	private final static String FAULT_TYPE = "UnableToPutResourcePropertyDocumentFault";
    /**
	 * A baseFaultType is needed, e.g ResourceUnknowFault
	 * 
	 * @param baseFaultType
	 */
    public UnableToPutResourcePropertyDocumentFault(){
    	super(FAULT_TYPE);
    }
    
    /**
	 * Constructor
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 */
	public UnableToPutResourcePropertyDocumentFault(List<String> description) {
		super(FAULT_TYPE, description);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public UnableToPutResourcePropertyDocumentFault(String baseFaultType, List<String> description,
			Metaset faultCause) {
		super(FAULT_TYPE, description, faultCause);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 */
	public UnableToPutResourcePropertyDocumentFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference) {
		super(FAULT_TYPE, description, originatorReference);
	}

	/**
	 * 
	 * @param baseFaultType
	 *            A BaseFaultType, e.g ResourceUnknowFault
	 * @param description
	 *            Description about the fault, e.g Resource Unknown
	 * @param originatorReference
	 *            A WS-Addressing EndpointReference of the webservice that
	 *            generated the fault.
	 * @param faultCause
	 *            If present, MUST contain a BaseFault or an element whose type
	 *            extends
	 */
	public UnableToPutResourcePropertyDocumentFault(String baseFaultType, List<String> description,
			EndpointReference originatorReference, Metaset faultCause) {
		super(FAULT_TYPE, description, originatorReference, faultCause );
	}
}
