/*
 * Created on 2006-9-8
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.persistence;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.resource.IPersistentResource;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceContext;
import org.act.xservices.rt.xresource.resource.IResourceHome;
import org.act.xservices.rt.xresource.resource.IResourceLifetime;
import org.act.xservices.rt.xresource.resource.IllegalResourceTypeException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.ResourceUnknownException;
import org.act.xservices.rt.xresource.resource.impl.ResourceCleaner;
import org.act.xservices.rt.xresource.util.TimerManagerImpl;
import org.prevayler.Prevayler;

import commonj.timers.Timer;
import commonj.timers.TimerManager;

/**
 * @author   Administrator
 */
public class PrevaylerResourceHome implements IResourceHome,Serializable{
	Logger logger = LoggerFactory.getLogger(PrevaylerResourceHome.class);
	
	private String serviceName;//ƣʶResourceHome
	private String resourceClassName;//ùӦԴ
	private boolean initialized = false;
	private PersistentSweeper sweeper;
	private Class resourceClass;

	private long delay = 60000;//Ĭÿ1Sweeperһ
	private String instanceID;
	
	private Map resources = new HashMap();//洢resource
	
	public Map getResources() {
		return resources;
	}

	public void setResources(Map resources) {
		this.resources = resources;
	}

	public PrevaylerResourceHome(String serviceName,String resourceClassName){
		this.serviceName = serviceName;
		this.resourceClassName = resourceClassName;
		try{
			this.resourceClass = Class.forName(resourceClassName);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * @return   Returns the initialized.
	 * @uml.property   name="initialized"
	 */
	public boolean isInitialized(){
		return this.initialized;
	}
	
	
	/**
	 * @param resourceClass   The resourceClass to set.
	 * @uml.property   name="resourceClass"
	 */
	public void setResourceClass(Class resourceClass){
		if ((resourceClass != null)
				&& !IResource.class.isAssignableFrom(resourceClass)) {
			throw new IllegalArgumentException("Specified resource class '"
					+ resourceClass.getName() + "' does not implement the "
					+ IResource.class.getName() + " interface.");
		}
		this.resourceClass = resourceClass;
	}
	
	public void setResourceClassName(String resourceClassName){
		try{
			this.resourceClass = Class.forName(resourceClassName);
		}catch(ClassNotFoundException e){
			throw new RuntimeException(e);
		}
	}
	
	/**
	 * @return   Returns the resourceClassName.
	 * @uml.property   name="resourceClassName"
	 */
	public String getResourceClassName(){
		return (resourceClass!=null)? resourceClass.getName() : null;
	}
	
	/**
	 * @return   Returns the delay.
	 * @uml.property   name="delay"
	 */
	@Deprecated
	public long getDelay(){
		return this.delay;
	}
	
	/**
	 * @param delay   The delay to set.
	 * @uml.property   name="delay"
	 */
	@Deprecated
	public void setDelay(long delay){
		this.delay = delay;
	}
	
	/**
	 * Initialize the resource class
	 */
	public void initialize()throws Exception{
		if(isInitialized()){
			return;
		}
		if(resourceClass == null){
			throw new Exception("The resourceClass has not Configured");
		}
		if(!IResource.class.isAssignableFrom(resourceClass)){
			throw new Exception("The resourceClass configured is not supported");
		}
		if(!IPersistentResource.class.isAssignableFrom(resourceClass)){
			throw new Exception("The resourceClass configured is not persistent resource");
		}
		
		//ʼøhomeصSweeper
		TimerManager manager = TimerManagerImpl.getTimerManager();
		if(IResourceLifetime.class.isAssignableFrom(resourceClass)){
			this.sweeper = new PersistentSweeper(this,this.resources,manager,this.delay);
		}
		this.initialized = true;
	}
	
	public void addResource(String key, IResource resource) throws IllegalResourceTypeException{
		if(!(resource instanceof IPersistentResource)){
			throw new IllegalResourceTypeException("This is not a persistent resource");
		}
		synchronized(resources){
			resources.put(key,resource);
		}
		if(this.sweeper != null){
			this.sweeper.scheduleSweeper();
		}
	}
	
	public void removeResource(String key)throws ResourceUnknownException,ResourceException{
		if(resources.get(key) == null){
			throw new ResourceUnknownException(key,serviceName);
		}
		synchronized(resources){
			resources.remove(key);
		}
	}
	
	public int getResourceCount(){
		return resources.size();
	}
	
	
	
	public String create(){
		Class resourceClass;
		IPersistentResource resource = null;
		String key = null;
		try{
			resourceClass = Class.forName(resourceClassName);
			resource = (IPersistentResource)resourceClass.newInstance();	
		}catch(Exception e){
			e.printStackTrace();
		}
		resources.put(key,resource);
		return key;
	}
	
	public String extractResourceIdentifier(IResourceContext context){
		Metaset message = context.getRequestMessage();
		Metaset instanceIDMet = message.filter(".\\Header\\ResourceID").car();

		return instanceIDMet.getTextTrim();
		
	}
	
	public IResource find(String key)throws ResourceUnknownException,ResourceException{
		IResource resource = (IResource)resources.get(key);
		if(resource == null){
			throw new ResourceUnknownException(key,serviceName);
		}
		return resource;
	}
	

	public Object create(String key, String address) {
		
		return null;
	}
	
	
	private static class PersistentSweeper extends ResourceCleaner{

		private TimerManager timerManager;

		private Timer timer;

		private long delay;

		public PersistentSweeper(IResourceHome home, Map resources,
				TimerManager timerManager, long delay) {
			super(home, resources);
			this.timerManager = timerManager;
			this.delay = delay;
		}

		private synchronized void resetSweeper() {
			this.timer = null;
		}

		synchronized void scheduleSweeper() {
			System.err.println("Persistent Sweeper is running");
			if (this.timer == null) {
				this.timer = this.timerManager.schedule(this, this.delay);

			}
		}

		protected IResource getResource(Object key)
				throws ResourceException {
			return (IResource) this.resources.get(key);
		}

		public void timerExpired(Timer timer) {
			super.timerExpired(timer);
			resetSweeper();
			if (!this.resources.isEmpty()) {
				scheduleSweeper();
			}
		}
	}


	public Prevayler getPrevayler() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getResourceHomeClassName() {
		// TODO Auto-generated method stub
		return null;
	}
}
