package org.act.xservices.rt.xresource.provider;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.provider.AbstractInOutProvider;
import org.act.xservices.rt.xcontainer.framework.provider.ProviderProcessException;
import org.act.xservices.rt.xcontainer.framework.provider.ServiceProcessException;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcOperation;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.persistence.PrevaylerResourceHome;
import org.act.xservices.rt.xresource.resource.ResourceHomePool;
import org.act.xservices.rt.xresource.resource.impl.ResourceHome;
import org.act.xservices.rt.xresource.util.ResourceClassLoaderRepos;
import org.act.xservices.rt.xresource.util.SOAPUtil;
import org.act.xservices.rt.xresource.util.WsrfConstants;
import org.prevayler.Prevayler;
import org.prevayler.PrevaylerFactory;

/**
 * Դ
 * 
 * @version 1.0 2007-11-11
 * @author Lizq [lizq@act.buaa.edu.cn]
 * @since JDK1.5
 */
public class ResourceProvider extends AbstractInOutProvider {
	final static Logger logger = LoggerFactory
			.getLogger(ResourceProvider.class);

	public ResourceProvider() {

	}

	/**
	 * 
	 */
	public void init(IConfigElement configurableElement, XcService xcService)
			throws Exception {

		this.type = configurableElement.getAttribute("Type");
		this.mepURI = "http://www.w3.org/ns/wsdl/in-out";

		// ԪأClass
		IConfigElement[] providerParameters = configurableElement
				.getChildrenWithName("Parameter");

		// ˴ֵÿǣforѭЧ̫ͣݴԺ

		// Դʵ
		String resourceClassName = null;
		for (int i = 0; i < providerParameters.length; i++) {
			if (providerParameters[i].getAttribute("Name").equals(
					"ResourceClassName")) {
				resourceClassName = providerParameters[i].getAttribute("Value");
				break;
			}
		}

		// Դ
		String resourceHomeClassName = null;
		for (int i = 0; i < providerParameters.length; i++) {
			if (providerParameters[i].getAttribute("Name").equals(
					"ResourceHomeClassName")) {
				resourceHomeClassName = providerParameters[i]
						.getAttribute("Value");
				break;
			}
		}

		// Դ
		ResourceHomePool pool = ResourceHomePool.getHomePool();

		Class resourceClass = xcService.getServiceClassLoader().loadClass(
				resourceClassName);
		System.out.println("resourceClass:" + resourceClass.getName());

		// Դ
		// Prevaylerĳ־û
		System.out.println("resourceHomeClassName: " + resourceHomeClassName);
		
		// Prevayler
		Class homeClass = xcService.getServiceClassLoader().loadClass(resourceHomeClassName);
		ResourceHome resourceHome = (ResourceHome) homeClass.newInstance();
		resourceHome.setResourceClass(resourceClass);
		resourceHome.setResourceHomeClassName(resourceHomeClassName);
		resourceHome.initialize();
		
		for (String urlPath : xcService.getAllSupportURLPath()) {
			pool.put(urlPath, resourceHome);
		}
		
		// Store the classLoader
		ResourceClassLoaderRepos.getInstance().put(resourceHomeClassName, xcService.getServiceClassLoader());
		System.out.println("put in classLoader: " + resourceHomeClassName);
//		if (resourceHomeClassName
//				.equals("org.act.xservices.rt.xresource.persistence.PrevaylerResourceHome")) {
//			String baseDirectory = "persistent_data/"
//					+ xcService.getServiceName();
//			PrevaylerResourceHome prevResourceHome = new PrevaylerResourceHome(
//					xcService.getServiceName(), resourceClassName);
//			Prevayler prevayler = PrevaylerFactory.createPrevayler(
//					prevResourceHome, baseDirectory);
//			PrevaylerResourceHome resourcehome = (PrevaylerResourceHome) prevayler
//					.prevalentSystem();
//			resourcehome.setDelay(WsrfConstants.DELAY_TIME);
//
//			for (String urlPath : xcService.getAllSupportURLPath()) {
//				pool.put(urlPath, resourcehome);
//			}
//
//			startSnapshots(prevayler);
//
//		} else {
//			Class homeClass = xcService.getServiceClassLoader().loadClass(
//					resourceHomeClassName);
//
//			// עУעһҪڴ˴homeĸsetter(˴Ϊ)
//			ResourceHome resourcehome = (ResourceHome) homeClass.newInstance();
//			resourcehome.setResourceClass(resourceClass);
//			resourcehome.setDelay(WsrfConstants.DELAY_TIME);
//
//			for (String urlPath : xcService.getAllSupportURLPath()) {
//				System.out.println("urlPath: " + urlPath);
//				pool.put(urlPath, resourcehome);
//			}
//		}

	}

	static void startSnapshots(final Prevayler prevayler) throws Exception {

		new Thread() {
			public void run() {
				while (true) {
					try {
						Thread.sleep(1000 * 30);// ÿ10minһο
						prevayler.takeSnapshot();
					} catch (Exception e) {
						e.printStackTrace();
					}
					System.out.println("Snapshot taken at "
							+ new java.util.Date() + "...");
				}
			}
		}.start();
	}

	/**
	 * 
	 * 
	 * @param serviceContext
	 * @return
	 * @throws ProviderProcessException
	 * @throws ServiceProcessException
	 */
	public IServiceContext invokeBusinessLogic(IServiceContext serviceContext)
			throws ProviderProcessException, ServiceProcessException {
		String invokeMethodName = serviceContext.getXcOperation().getQName()
				.getName();
		// Դı׼
		if (SOAPUtil.isStandardOperation(invokeMethodName)) {
			// Before enter the resource, printing log info
			System.out.println("*********enter resource invoke********");
			System.out.println("invokeMethodName: " + invokeMethodName);
			System.out.println("inMessage:");
			System.out.println(serviceContext.getInMessage().asXML());

			// Դ
			ISOAPEnvelope envelope = SOAPUtil.doAction(serviceContext
					.getInMessage(), invokeMethodName);

			// صSOAPֱӷserviceContext
			serviceContext.setOutMessage(envelope);

			// Got out of resource invoke
			System.out.println("*********getout resource invoke********");
			System.out.println("invokeMethodName: " + invokeMethodName);
			System.out.println("responseMessage:");
			System.out.println(envelope.asXML());
			System.out.println("\n\n\nCurrent ResourceHomePool:");
			System.out.println(ResourceHomePool.getHomePool().getSize());

			return serviceContext;

		} else {
			// Got out of resource invoke
			System.out
					.println("*********is not a resource std operation********");
			System.out.println("invokeMethodName: " + invokeMethodName);
			System.out
					.println("*********is not a resource std operation********");
		}

		// Java

		Class serviceClass = serviceContext.getXcService().getServiceClass();
		logger.info("serviceClass:" + serviceClass.getName());
		// get the implementation class for the Web Service
		Object obj = getImplementationObject(serviceContext.getXcService());
		logger.info("obj:" + obj.toString());
		XcOperation xcOperation = serviceContext.getXcOperation();
		logger.info("operation: " + xcOperation.toString());
		Method method = findMethod(xcOperation, serviceClass);
		logger.info("method:" + method.toString());
		if (method == null) {
			throw new ProviderProcessException("method Does Not exist for "
					+ xcOperation.getQName());
		}

		// עԴ󣬴˴ҪSOAPϢ by lizq 2009-04-26
		Metaset parameterMetaset = serviceContext.getInMessage();
		logger.info("parameterMetaset: " + parameterMetaset.toFormatXML());
		if (parameterMetaset == null) {
			throw new ProviderProcessException(
					"Error Parameter in InSOAPMessage for Operation "
							+ xcOperation.getQName());
		}

		try {
			System.out.println("parameterMetaset: " + parameterMetaset.asXML());
			System.out.println("obj:" + obj);
			Object responseObject = method.invoke(obj,
					new Object[] { parameterMetaset });
			logger.info("responseObject: " + responseObject);
			// ע˴ûInOutInOnly
			if (responseObject == null) {

				serviceContext.setOutMessage(null);

			} else {
				Metaset responseMetaset = (Metaset) responseObject;
				serviceContext.setOutMessage(SOAPMessageUtil
						.creatResponseMessage(serviceContext.getInMessage()
								.getVersion(), responseMetaset, serviceContext
								.getInMessageHeaders()));
			}

			return serviceContext;

		} catch (IllegalArgumentException e) {
			e.printStackTrace();
			throw new ServiceProcessException(e);
		} catch (IllegalAccessException e) {
			e.printStackTrace();
			throw new ServiceProcessException(e);
		} catch (InvocationTargetException e) {
			e.printStackTrace();
			throw new ServiceProcessException(e);
		}
	}

	/**
	 * Looking for a method of the form "Metaset method(Metaset)"
	 * 
	 * @param xcop
	 * @param implClass
	 * @return
	 */
	private Method findMethod(XcOperation xcop, Class implClass)
			throws ProviderProcessException {

		Method method = xcop.getMethod();

		if (method != null)
			return method;

		String methodName = xcop.getQName().getName();

		try {
			// Looking for a method of the form "Metaset method(Metaset)"
			method = implClass.getMethod(methodName,
					new Class[] { Metaset.class });

			xcop.setMethod(method);

			return method;

		} catch (NoSuchMethodException e) {
			throw new ProviderProcessException("Error: Can not find method: "
					+ methodName + " in class: " + implClass.getName(), e);
		}

	}

}
