package org.act.xservices.rt.xresource.resource;

import java.io.Serializable;
import java.util.Calendar;

import org.act.xservices.rt.xcontainer.addressing.uuid.RandomUuidFactory;

public abstract class Resource implements IResource, Serializable {
	/**
	 * Uuid: ԴUuid, uuidֻԴʵ
	 * ԴĶλIServiceRef, IServiceRefUuidServiceURI
	 */
	protected String instanceID = RandomUuidFactory.getInstance().createUUID();
	
	/**
	 * Դĵ
	 */
	protected ResourceProperties propDoc;
	
	/**
	 * ֹʱ
	 */
	protected Calendar terminationTime;
	
	/**
	 * ԴURI, uuidһλĳԴ
	 */
	protected String serviceURI;

	/**
	 * úԴĳʼ,Դ񿪷Աʵ
	 */
	protected abstract void init();

	/**
	 * ɾԴʵ
	 * ԴʵɾʱҪһЩ,д˺
	 */
	public abstract void destroy();

	/* (non-Javadoc)
	 * @see org.act.xservices.rt.xresource.resource.IResource#getResourceProperties()
	 */
	public abstract IResourceProperties getResourceProperties();

	/* (non-Javadoc)
	 * @see org.act.xservices.rt.xresource.resource.IResource#setResourceProperties(org.act.xservices.rt.xresource.resource.ResourceProperties)
	 */
	public abstract void setResourceProperties(ResourceProperties properties);

	/* (non-Javadoc)
	 * @see org.act.xservices.rt.xresource.resource.IResource#getID()
	 */
	public String getID() {
		return instanceID;
	}

	/* (non-Javadoc)
	 * @see org.act.xservices.rt.xresource.resource.IResource#getServiceURI()
	 */
	public String getServiceURI() {
		return serviceURI;
	}

	/* (non-Javadoc)
	 * @see org.act.xservices.rt.xresource.resource.IResource#setServiceURI(java.lang.String)
	 */
	public void setServiceURI(String serviceURI) {
		this.serviceURI = serviceURI;
	}

	/**
	 * ȡֹʱ
	 * @return
	 */
	public Calendar getTerminationTime() {
		return terminationTime;
	}

	/**
	 * ֹʱ
	 * @param terminationTime
	 */
	public void setTerminationTime(Calendar terminationTime) {
		this.terminationTime = terminationTime;
	}
	
	/**
	 * Էʹ
	 * @return
	 */
	public boolean isEnabled(){
		if(this.terminationTime == null){
			return true;
		}else{
			return Calendar.getInstance().before(terminationTime);
		}
	}
}
