package org.act.xservices.rt.xresource.resource;

/**
 * @author duanjiaqin
 * 
 *         use the Singleton Pattern
 */
public class WsrfRuntime {

	private static WsrfRuntime instance = null;

	private WsrfRuntime() {
	}

	public static WsrfRuntime getInstance() {
		if (instance == null) {
			synchronized (WsrfRuntime.class) {
				if (instance == null) {
					instance = new WsrfRuntime();
				}
			}
		}
		return instance;
	}

	public IResourceHome getResourceHome(String name) {
		ResourceHomePool pool = ResourceHomePool.getHomePool();
		IResourceHome home = (IResourceHome) pool.get(name);
		return home;
	}
}
