/*
 * Created on 2006-2-27
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl;

import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.persistence.PrevaylerResourceHome;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceContext;
import org.act.xservices.rt.xresource.resource.IResourceHome;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.WsrfRuntime;


/**
 * @author   Administrator
 */

public class ResourceContext implements IResourceContext{
	Logger logger = LoggerFactory.getLogger(ResourceContext.class);
	private static final long serialVersionUID = 1L;
	
	private IServiceContext serviceContext;
	
	/**
	 * Refer to wsa:Action
	 */
	private String action;
	private String serviceName;
	
	/**
	 * Refer to wsa:To
	 */
	private URL serviceURL;
	private Metaset requestMessage;
	private IResourceHome home;
	
	public ResourceContext(Metaset message)throws Exception{
		if(message == null){
			throw new IllegalArgumentException("NULL MESSAGE");
		}
		this.requestMessage = message;
		extractFieldsByMessage(message);
		lookupHome();
		
	}
	
	public ResourceContext(IServiceContext serviceContext)throws Exception{
		if(serviceContext == null){
			throw new IllegalArgumentException("NULL SERVICE CONTEXT");
		}
		this.serviceContext = serviceContext;
		this.requestMessage = serviceContext.getInMessage();
		extractFieldsByContext(this.serviceContext);
		lookupHome();
	}
	
	/**
	 * @return   Returns the serviceName.
	 * @uml.property   name="serviceName"
	 */
	public String getServiceName(){
		return serviceName;
	}
	
	/**
	 * @return   Returns the serviceURL.
	 * @uml.property   name="serviceURL"
	 */
	public URL getServiceURL(){
		return serviceURL;
	}
	
	public String getRequestAction(){
		return action;
	}
	
	public IResourceHome getResourceHome(){
		return home;
	}
	
	/**
	 * @return   Returns the requestMessage.
	 * @uml.property   name="requestMessage"
	 */
	public Metaset getRequestMessage(){
		return requestMessage;
	}
	
	public void setResponseAction(URI action){
		
	}
	
	/**
	 * @param serviceName   The serviceName to set.
	 * @uml.property   name="serviceName"
	 */
	public void setServiceName(String serviceName){
		this.serviceName = serviceName;
	}
	
	/**
	 * @param serviceURL   The serviceURL to set.
	 * @uml.property   name="serviceURL"
	 */
	public void setServiceURL(URL serviceURL){
		this.serviceURL = serviceURL;
	}
	
	/*
	 * ڲͬԴͣķʽһ
	 */
	public IResource getResource()throws ResourceException{
		IResource resource = null;
		IResourceHome home = getResourceHome();
		String instanceID = home.extractResourceIdentifier(this);
		resource = ResourceTransactionManager.getInstance().doGet(home, instanceID);
		return resource;
	}
	
	private void extractFieldsByContext(IServiceContext serviceContext){
		 action         = getAddressingAction( serviceContext );
	     serviceURL     = getServiceURL( serviceContext );
	     serviceName    = getServiceName( serviceContext );
	}
	
	private void extractFieldsByMessage(Metaset message){
		action          = getAddressingActionByMessage(message);
		serviceURL      = getServiceURL(message);
		serviceName     = getServiceName(message);
	}
	
	private String getAddressingAction(IServiceContext serviceContext){
		Metaset message = serviceContext.getInMessage();
		Metaset actionMetaset = message.filter(".\\Header\\Action").car();
		String action = actionMetaset.getText();
		return action;
	}
	
	private String getAddressingActionByMessage(Metaset message){
		
		Metaset actionMetaset = message.filter(".\\Header\\Action").car();	
		String action = actionMetaset.getText();
		return action;
	}
	
	private URL getServiceURL(IServiceContext serviceContext){
		Metaset message = serviceContext.getInMessage();
		Metaset toMetaset = message.filter(".\\Header\\To").car();
		if(toMetaset != null){
			try{
				URL serviceURL = new URL(toMetaset.getText());
				return serviceURL;
			}catch(MalformedURLException e){
				throw new RuntimeException("The WS-Addressing destination specified in the SOAP header" +
							" (i.e. wsa:To header element) is not a valid URI.");
			}
		}
		return null;
	}
	
	private URL getServiceURL(Metaset message){
		Metaset toMetaset = message.filter(".\\Header\\To").car();
		if(toMetaset != null){
			try{
				URL serviceURL = new URL(toMetaset.getText());
				return serviceURL;
			}catch(MalformedURLException e){
				throw new RuntimeException("The WS-Addressing destination specified in the SOAP header" +
							" (i.e. wsa:To header element) is not a valid URI.");
			}
		}
		return null;
	}
	
	private String getServiceName(IServiceContext serviceContext){
		
		//TODO: ˴Ҫ޸ģӦ÷ServiceName
		return serviceContext.getXcService().getServiceName();
	}
	
	private String getServiceName(Metaset message){
		URL serviceURL = (this.serviceURL!=null) ? this.serviceURL : getServiceURL(message);

		return serviceURL.getPath();
	}
	
	private void lookupHome()throws Exception{
		WsrfRuntime runtime = WsrfRuntime.getInstance();
		home = runtime.getResourceHome(this.serviceName);		
		
		//FIXME:˴ĶResourceHomeĳʼѾתʱ
		initializeResourceHome();
		
	}
	
	private void initializeResourceHome()throws Exception{
		if(home instanceof ResourceHome){
			ResourceHome homeImpl = (ResourceHome)home;
			if(!homeImpl.isInitialized()){
				homeImpl.initialize();
			}
		}else if(home instanceof PrevaylerResourceHome){
			PrevaylerResourceHome homeImpl = (PrevaylerResourceHome)home;
			if(!homeImpl.isInitialized()){
				homeImpl.initialize();
			}
		}
	}
}
