package org.act.xservices.rt.xresource.resource.impl;

import java.io.Serializable;

import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceHome;
import org.act.xservices.rt.xresource.resource.Resource;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.ResourceMap;
import org.act.xservices.rt.xresource.resource.transaction.ResourceCreationTransaction;
import org.act.xservices.rt.xresource.resource.transaction.ResourceGetTransaction;
import org.act.xservices.rt.xresource.resource.transaction.ResourceRemoveTransaction;
import org.act.xservices.rt.xresource.resource.transaction.ResourceTransaction;
import org.act.xservices.rt.xresource.resource.transaction.ResourceUpdateTransaction;
import org.act.xservices.rt.xresource.util.ResourceClassLoaderRepos;
import org.prevayler.Prevayler;

/**
 *  ԴעĶԴʵɾĲֲԴעгȡ,ɸ
 *  ResourceTransactionManagerʵԴעֲͬʱ,
 *  ṩ˶Դʵĳ־ṵ̂߳ȫԼ֪ͨӦ
 */
public class ResourceTransactionManager implements Serializable {
	
	private ResourceUpdateTransaction resourceUpdateTransaction;
	private ResourceCreationTransaction resourceCreationTransaction;
	private ResourceRemoveTransaction resourceRemoveTransaction;
	private ResourceGetTransaction resourceGetTransaction;
	
	private static ResourceTransactionManager instance;
	
	private ResourceTransactionManager(){
		this.resourceCreationTransaction = new ResourceCreationTransaction();
		this.resourceUpdateTransaction = new ResourceUpdateTransaction();
		this.resourceRemoveTransaction = new ResourceRemoveTransaction();
		this.resourceGetTransaction = new ResourceGetTransaction();
	}
	
	/**
	 * ȡԴʵ
	 * ģʽ
	 * @return
	 */
	public static ResourceTransactionManager getInstance(){
		if(instance ==null){
			synchronized(ResourceTransactionManager.class){
				if(instance == null){
					instance = new ResourceTransactionManager();
				}
			}
		}
		return instance;
	}
	
	/**
	 * Դɾ, ҪĲresourceHomeinstanceID
	 * @throws Exception 
	 */
	public boolean doRemove(IResourceHome resourceHome, String instanceID) throws ResourceException{
		Prevayler prevayler = resourceHome.getPrevayler();
		resourceRemoveTransaction.setInstanceID(instanceID);
		Boolean flag = false;
		try {
			prevayler.execute(resourceRemoveTransaction);
		} catch (Exception e) {
			throw new ResourceException("Exception of Remove in ResourceTransactionManager.");
		}
		
		// TODO: Notification for removal action add here
		
		return flag;
	}
	
	/**
	 * ԴĲҲ
	 * @param resourceHome
	 * 		Դע
	 * @param instanceID
	 * 		ʵIDֵ
	 * @return
	 * 		Դʵ
	 * @throws ResourceException 
	 * @throws Exception
	 */
	public IResource doGet(IResourceHome resourceHome, String instanceID) throws ResourceException{
		Prevayler prevayler = resourceHome.getPrevayler();
		System.out.println();
//		resourceGetTransaction.setInstanceID(instanceID);
		IResource resource = null;
		try {
			System.out.println("I can go here, before doGet's execute...");
			resource = (IResource)prevayler.execute(resourceGetTransaction);
			System.out.println("After doGet's execute...");
		} catch (Exception e) {
			throw new ResourceException("Exception of Get in ResourceTransactionManager.");
		}
		
		// TODO: Notification for removal action add here
		
		return resource;
	}
	
	/**
	 * һԴʵ
	 * @param resourceHome
	 * 		Դע
	 * @return
	 * 		Դʵ
	 * @throws ResourceException 
	 * @throws ClassNotFoundException 
	 * @throws Exception
	 */
	public IResource doCreate(IResourceHome resourceHome) throws ResourceException, ClassNotFoundException{
		System.out.println("enter in doCreate....");
		Prevayler prevayler = resourceHome.getPrevayler();
		IResource resource = null;
		ClassLoader oldCL = Thread.currentThread().getContextClassLoader();
		try {
			System.out.println("get out classloader: " + resourceHome.getResourceHomeClassName());
			System.out.println("classLoader:" + ResourceClassLoaderRepos.getInstance().get(resourceHome.getResourceHomeClassName()));
			Thread.currentThread().setContextClassLoader(
					ResourceClassLoaderRepos.getInstance().get(resourceHome.getResourceHomeClassName()));
			System.out.println("before create a resource: " + ((ResourceMap)prevayler.prevalentSystem()).getResourceClass().getName());
			
			prevayler.execute(resourceCreationTransaction);
			System.out.println("after resouce create....");
		} catch (Exception e) {
			throw new ResourceException("Exception of Create in ResourceTransactionManager.");
		}finally{
			Thread.currentThread().setContextClassLoader(oldCL);
		}
		
		// TODO: Notification for removal action add here
		
		return resource;
	}
	
	/**
	 * һԴʵ
	 * @param resourceHome
	 * 		Դע
	 * @param updatedResource
	 * 		¹Դ
	 * @return
	 * @throws ResourceException 
	 * @throws Exception
	 */
	public boolean doUpdate(IResourceHome resourceHome, IResource updatedResource) throws ResourceException {
		Prevayler prevayler = resourceHome.getPrevayler();
		resourceUpdateTransaction.setResource(updatedResource);
		Boolean flag = false;
		try {
			flag = (Boolean)prevayler.execute(resourceUpdateTransaction);
		} catch (Exception e) {
			throw new ResourceException("Exception of Update in ResourceTransactionManager.");
		}
		
		// TODO: Notification for removal action add here
		
		return flag;
	}
}
