/*
 * Created on 2006-4-9
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.lifetime;

import java.rmi.RemoteException;
import java.util.Calendar;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.ResourceNotDestroyedFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceHome;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.resource.impl.ResourceTransactionManager;
import org.act.xservices.rt.xresource.resource.impl.properties.PropertyPortTypeOperation;
import org.act.xservices.rt.xresource.util.ResourceConstants;
import org.act.xservices.rt.xresource.util.SOAPUtil;
import org.act.xservices.rt.xresource.util.WsrlConstants;
import org.act.xservices.rt.xresource.util.WsrpConstants;

/**
 * @author duanjiaqin
 *
 * 
 * ıĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 *	      xmlns:wsa="http://www.w3.org/2005/08/addressing"
 *	      xmlns:wsrf-rl="http://docs.oasis-open.org/wsrf/rl-2"
 *	      xmlns:ex="http://examples.com/exampleNS">
 *		<s11:Header>
 *			<wsa:Action>http://docs.oasis-open.org/wsrf/rlw-2/ImmediateResourceTermination/DestroyRequest</wsa:Action>
 *			<wsa:To s11:mustUnderstand="1">http://www.provider.org/ProviderEndpoint</wsa:To>
 *			<ex:ResourceDiambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22</ex:ResourceDiambiguator>
 *		</s11:Header>
 *		<s11:Body>
 *			<wsrf-rl:Destroy/>
 *		</s11:Body>
 * </s11:Envelope>
 * صӦĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 * 				xmlns:wsa="http://www.w3.org/2005/08/addressing"
 * 				xmlns:wsrf-rl="http://docs.oasis-open.org/wsrf/rl-2">
 * 		<s11:Header>
 * 			<wsa:Action>
 * 				http://docs.oasis-open.org/wsrf/rlw-2/ImmediateResourceTermination/DestroyResponse
 * 			</wsa: Action>
 * 		<s11:Body>
 * 			<wsrf-rl:DestroyResponse/>
 * 		</s11:Body>
 * </s11:Envelope>
 */
public class DestroyPortType extends PropertyPortTypeOperation {
	Logger logger = LoggerFactory.getLogger(DestroyPortType.class);
	
	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		logger.debug("in DestroyPortType.validateSOAPMsg");
		Metaset propertyMet = soapEnv.getBody().element(WsrlConstants.DESTROY_QNAME);
		if(propertyMet == null){
			throw new InvalidMessageFormatFault();
		}
	}

	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		logger.debug("in DestroyPortType.generateResponseSOAPBody");
		IResourceHome home = null;
		IResource resource = null;
		String serviceURI = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			home = ctx.getResourceHome();
			resource = ctx.getResource();
		}catch(NoSuchResourceException e){
			ResourceUnknownFault fault = new ResourceUnknownFault();
			throw fault;
		}catch(Exception e){
			ResourceNotDestroyedFault fault = new ResourceNotDestroyedFault();
			throw fault;
		}
		if(resource == null)
			throw new ResourceUnknownFault();
		
		try{
			String instanceID = resource.getID();
			ResourceTransactionManager.getInstance().doRemove(home, instanceID);
		}catch(Exception e){
			throw new ResourceNotDestroyedFault();
		}
		
		// Build return soap message
		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
		Metaset bodyContent = metBuilder.newMetaset(WsrlConstants.DESTROY_RESPONSE_QNAME);
		return bodyContent;
	}

//	public Metaset destroy(Metaset request)throws ResourceUnknownFault,
//												  ResourceNotDestroyedFault{
//		IResourceHome home = null;
//		IResource resource = null;
//		
//		try{
//			ResourceContext ctx = new ResourceContext(request);
//			home = ctx.getResourceHome();
//			resource = ctx.getResource();
//		}catch(NoSuchResourceException e){
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}catch(Exception e){
//			ResourceNotDestroyedFault fault = new ResourceNotDestroyedFault();
//			throw fault;
//		}
//		
//		if(resource == null){
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}
//		try{
//			home.remove(resource.getID());
//		}catch(ResourceException e){
//			ResourceNotDestroyedFault fault = new ResourceNotDestroyedFault();
//			throw fault;
//		}
//		
//		//췵صsoap
//		String action = "http://docs.oasis-open.org/wsrf/rlw-2/ImmediateResourceTermination/DestroyResponse";
//		
//
//		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
//    	
//    	Metaset response = metBuilder.newMetaset("wsrf-rl","DestroyResponse");
//		
//		Metaset destroyResponse = SOAPUtil.generateSOAPForLifetime(action,response);
//		
//		return destroyResponse;
//	}
}
