/*
 * Created on 2006-4-9
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.lifetime;

import java.rmi.RemoteException;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.util.MetasetHelper;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.UnableToSetTerminationTimeFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceHome;
import org.act.xservices.rt.xresource.resource.IResourceLifetime;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceUnknownException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.resource.impl.ResourceTransactionManager;
import org.act.xservices.rt.xresource.resource.impl.properties.PropertyPortTypeOperation;
import org.act.xservices.rt.xresource.util.WsrlConstants;

/**
 * @author duanjiaqin
 *
 * ٣Դʱ䡣õʱϵͳǰʱ֮ǰ
 * ĵĸʽ£
 * <wsrf-rl:SetTerminationTime>
 *	[<wsrf-rl:RequestedTerminationTime xsi:nil=xsd:boolean?>
 * 		xsd:dateTime
 * 	</wsrf-rl:RequestedTerminationTime>]
 * 	|
 * 	[<wsrf-rl:RequestedLifetimeDuration>
 *		xsd:duration
 * 	</wsrf-rl:RequestedLifetimeDuration>]
 * </wsrf-rl:SetTerminationTime>
 * 磺
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 *	      xmlns:wsa="http://www.w3.org/2005/08/addressing"
 *	      xmlns:wsrf-rl="http://docs.oasis-open.org/wsrf/rl-2"
 *	      xmlns:ex="http://examples.com/exampleNS">
 *		<s11:Header>
 *			<wsa:Action>http://docs.oasis-open.org/wsrf/rlw-2/ScheduledResourceTermination/SetTerminationTimeRequest</wsa:Action>
 *			<wsa:To s11:mustUnderstand="1">http://www.provider.org/ProviderEndpoint</wsa:To>
 *			<ex:ResourceDiambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22</ex:ResourceDiambiguator>
 *		</s11:Header>
 *		<s11:Body>
 *			<wsrf-rl:SetTerminationTime>
 *				<wsrf-rl:RequestedTerminationTime>
 *					2001-12-31T12:00:00Z
 *				</wsrf-rl:RequestedTerminationTime>
 *			</wsrf-rl:SetTerminationTime>
 *		</s11:Body>
 * </s11:Envelope>
 * صӦĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 * 				xmlns:wsa="http://www.w3.org/2005/08/addressing"
 * 				xmlns:wsrf-rl="http://docs.oasis-open.org/wsrf/rl-2">
 * 		<s11:Header>
 * 			<wsa:Action>
 * 				http://docs.oasis-open.org/wsrf/rlw-2/ScheduledResourceTermination/SetTerminationTimeResponse
 * 			</wsa:Action> 
 * 		<s11:Body>
 * 			<wsrf-rl:SetTerminationTimeResponse>
 * 				<wsrf-rl:NewTerminationTime>
 * 					2001-12-31T12:00:00Z
 * 				</wsrf_rl:NewTerminationTime>
 * 				<wsrf-rl:CurrentTime>
 * 					2001-12-31T11:00:00Z
 * 				</wsrf-rl:CurrentTime>
 * 			</wsrf-rl:SetTerminationTimeResponse>
 * 		</s11:Body>
 * </s11:Envelope>
 */
public class SetTerminationTimePortType extends PropertyPortTypeOperation {
	Logger logger = LoggerFactory.getLogger(SetTerminationTimePortType.class);
	
	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		logger.debug("in SetTerminationTimePortType.validateSOAPMsg");
		Metaset rttMet = soapEnv.getBody().getFirstElement().element(WsrlConstants.REQUESTED_TIME_QNAME);
		Metaset rldMet = soapEnv.getBody().getFirstElement().element(WsrlConstants.REQUESTED_DURATION_QNAME);
		if(rttMet == null && rldMet == null){
			throw new InvalidMessageFormatFault();
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		logger.debug("in SetTerminationTimePortType.generateResponseSOAPBody");
		IResourceHome home = null;
		IResource resource = null;
		String uuid = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			home = ctx.getResourceHome();
			resource = ctx.getResource();
			uuid = resource.getID();
		}catch(NoSuchResourceException e){
			ResourceUnknownFault fault = new ResourceUnknownFault();
			throw fault;
		}catch(Exception e){
			throw new RemoteException("resourceDisoveryFailed",e);
		}
		
		if (!(resource instanceof IResourceLifetime)) {
			UnableToSetTerminationTimeFault fault = new UnableToSetTerminationTimeFault();
			throw fault;
        }
		
		Calendar terminationTime = null;
		try {
			terminationTime = getRequestedTerminationTime(soapEnv);
		} catch (ParseException e) {
			throw new UnableToSetTerminationTimeFault();
		}
		Calendar currentTime = Calendar.getInstance();
		Calendar newTerminationTime = null;
		
		//趨ʱڵǰʱ֮ǰ
		if(terminationTime!=null && terminationTime.getTime().before(currentTime.getTime())){
			try{
				ResourceTransactionManager.getInstance().doRemove(home, uuid);
				
			}catch(ResourceUnknownException e){
				ResourceUnknownFault fault = new ResourceUnknownFault();
				throw fault;
			}catch(Exception e){
				Calendar timestamp = Calendar.getInstance();
				UnableToSetTerminationTimeFault fault = new UnableToSetTerminationTimeFault();
				throw fault;
			}
			newTerminationTime = currentTime;
		}else{
			((IResourceLifetime)resource).setTerminationTime(terminationTime);
			newTerminationTime = terminationTime;
		}
		
		// Build response metaset
		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
    	
    	Metaset response = metBuilder.newMetaset(WsrlConstants.SET_TERMINATION_RESPONSE_QNAME);
    	
    	Metaset newTT = metBuilder.newMetaset(WsrlConstants.NEW_TIME_QNAME);
		newTT.setText(MetasetHelper.getInstance().getLocalTimeString(newTerminationTime.getTime()));

		Metaset curTT = metBuilder.newMetaset(WsrlConstants.CURRENT_TIME_QNAME);
		curTT.setText(MetasetHelper.getInstance().getLocalTimeString(currentTime.getTime()));
		
		response.add(newTT);
		response.add(curTT);
		
		return response;
	}

	
	//FIXME:Ŀǰ涨ʱĸʽֻΪ--Tʱ::Z2001-12-31T12:00:00Z
	private Calendar getRequestedTerminationTime(ISOAPEnvelope soapEnv) throws UnableToSetTerminationTimeFault, ParseException{
		Metaset requestedTerminationTime = soapEnv.getBody().getFirstElement().element(WsrlConstants.REQUESTED_TIME_QNAME);
		if(requestedTerminationTime == null)
			return null;
		
		String valueString = requestedTerminationTime.getTextTrim();
		Date date = MetasetHelper.getInstance().getLocalTime(valueString);
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		return cal;
	}
}
