/*
 * Created on 2006-4-8
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.properties;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;


import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.util.MetasetHelper;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.InvalidModificationFault;
import org.act.xservices.rt.xresource.faults.InvalidResourcePropertyQNameFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.UnableToModifyResourcePropertyFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IPersistentResource;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceProperties;
import org.act.xservices.rt.xresource.resource.IResourceWithCallback;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.ResourceProperties;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.util.ResourceConstants;
import org.act.xservices.rt.xresource.util.SOAPUtil;
import org.act.xservices.rt.xresource.util.WsrpConstants;
import org.act.xservices.rt.xresource.util.XMLPersistenceUtil;

/**
 * @author duanjiaqin
 *
 * ɾһԴԵֵ
 * Ϣıĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 *	      xmlns:wsa="http://www.w3.org/2005/08/addressing"
 *	      xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2"
 *	      xmlns:ex="http://examples.com/exampleNS">
 *		<s11:Header>
 *			<wsa:Action>http://docs.oasis-open.org/wsrf/rpw-2/DeleteResourceProperties/DeleteResourcePropertiesRequest</wsa:Action>
 *			<wsa:To s11:mustUnderstand="1">http://www.provider.org/ProviderEndpoint</wsa:To>
 *			<ex:ResourceDiambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22</ex:ResourceDiambiguator>
 *		</s11:Header>
 *		<s11:Body>
 *			<wsrf-rp:DeleteResourceProperties xmlns:tns="http://example.com/diskDrive">
 *				<wsrf-rp:Delete ResourceProperty="tns:Manufacturer"/>
 *			</wsrf-rp:DeleteResourceProperties>
 *		</s11:Body>
 * </s11:Envelope>
 * صӦĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 * 				xmlns:wsa="http://www.w3.org/2005/08/addressing"
 * 				xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2">
 * 		<s11:Header>
 * 			<wsa:Action>
 * 				http://docs.oasis-open.org/wsrf/rpw-2/DeleteResourceProperties/DeleteResourcePropertiesResponse
 * 			</wsa:Action>
 * 		<s11:Body>
 * 			<wsrf-rp:DeleteResourcePropertiesResponse>
 * 			</wsrf-rp:DeleteResourcePropertiesResponse>
 * 		</s11:Body>
 * </s11:Envelope>
 */
public class DeleteResourcePropertiesPortType extends PropertyPortTypeOperation {

	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		Metaset propertyMet = soapEnv.getBody().element(
				WsrpConstants.DELETE_RESOURCE_PROPERTIES_ACTION);
		if (propertyMet == null) {
			throw new InvalidMessageFormatFault();
		}

		Metaset deleteMet = propertyMet.element("Delete");
		if (deleteMet == null) {
			throw new InvalidMessageFormatFault();
		}

		String attrValueString = deleteMet.attributeValue("ResourceProperty");
		if(attrValueString == null || attrValueString.equals("")){
			throw new InvalidMessageFormatFault();
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		// Get Resource
		IResource resource = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			resource = ctx.getResource();
			
		}catch(NoSuchResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(ResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(Exception e){
			throw new RemoteException("resourceDisoveryFailed",e);
		}
		
		IResourceProperties irp = resource.getResourceProperties();
		Metaset rpDoc = irp.getdocument();
		
		// Start the set processing
		Metaset deleteMet = soapEnv.getBody().getFirstElement().element(WsrpConstants.DELETE_QNAME);
		String deleteQNameStr = deleteMet.attributeValue("ResourceProperty");
		QName deleteQName = MetasetHelper.getInstance().convertStringToQName(deleteQNameStr, deleteMet);
		List<Metaset> toDeleteItemList = rpDoc.elements(deleteQName);
		Iterator<Metaset> toDeleteItemIter = toDeleteItemList.iterator();
		while(toDeleteItemIter.hasNext()){
			rpDoc.remove(toDeleteItemIter.next());
		}

		// If you can go here, you get a sucessful operation
		// Then what you do is to return a response message
		// TODO: Thread safe
		return MetasetBuilder.getInstance().newMetaset(
				WsrpConstants.DELETE_RESPONSE_QNAME);
	}
	
//	public Metaset deleteResourceProperties(Metaset request)throws RemoteException,
//																   ResourceUnknownFault,
//																   InvalidModificationFault,
//																   UnableToModifyResourcePropertyFault,
//																   InvalidResourcePropertyQNameFault,
//																   DeleteResourcePropertiesRequestFailedFault{
//		IResource resource = null;
//		ResourceContext ctx = null;
//		
//		try{
//			ctx = new ResourceContext(request);
//			resource = ctx.getResource();
//		}catch(NoSuchResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault(timestamp,
//															ResourceConstants.RESOURCE_UNKNOWN_FAULT);
//			throw fault;
//		}catch(ResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault(timestamp,
//															ResourceConstants.RESOURCE_UNKNOWN_FAULT);
//			throw fault;
//		}catch(Exception e){
//			Calendar timestamp = Calendar.getInstance();
//			DeleteResourcePropertiesRequestFailedFault fault = new DeleteResourcePropertiesRequestFailedFault(timestamp,
//															ResourceConstants.DELETE_RESOURCE_PROPERTIES_REQUEST_FAILED_FAULT);
//			throw fault;
//		}
//		
//		if(resource == null){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault(timestamp,
//															ResourceConstants.RESOURCE_UNKNOWN_FAULT);
//			throw fault;
//		}
//		
//		//Metaset rpDocument = resource.getResourceProperties();
//		
//		
//	    IResourceProperties pro = resource.getResourceProperties();
//		
//		Metaset rpDocument = pro.getdocument();
//		
//		List childs = rpDocument.elements();
//		int originalLength = childs.size();
//		String namespace = rpDocument.selectorAttributeValue("*", "tns");
//		
//		QName deletename = getQName(request);
//		
//		
//		if(!deletename.getNamespaceURI().equals(namespace)){/////////////
//			Calendar timestamp = Calendar.getInstance();
//			InvalidResourcePropertyQNameFault fault = new InvalidResourcePropertyQNameFault(timestamp,
//															ResourceConstants.INVALID_RESOURCE_PROPERTY_QNAME_FAULT);
//			throw fault;
//		}
//		
//		for(int i=0;i<childs.size();i++){
//			Metaset child = (Metaset)childs.get(i);
//			if(child.getName().equals(deletename.getName())){
//				rpDocument.removeChildren(child);
//				i = i-1;//ÿһԪأsize1
//			}
//		}
//		
//		//ûɾκԣʾQNameƥ
//		int newLength = rpDocument.elements().size();
//		if(newLength == originalLength){
//			Calendar timestamp = Calendar.getInstance();
//			InvalidResourcePropertyQNameFault fault = new InvalidResourcePropertyQNameFault(timestamp,
//															ResourceConstants.INVALID_RESOURCE_PROPERTY_QNAME_FAULT);
//			throw fault;
//		}
//		
//		//add by liwu
//		//	2007-7-10:	עby cover_eye
////		if(ctx.getResourceHome().getResourceCallBack()!=null){
////		ctx.getResourceHome().getResourceCallBack().deleteResourceProperties();
////		}
//		if(resource instanceof IResourceWithCallback && ((IResourceWithCallback)resource).getResourceCallBack()!=null){
//			((IResourceWithCallback)resource).getResourceCallBack().deleteResourceProperties();
//			}
//		//end by liwu
//		
//		
//		
//		//Դǳ־ûģӦtransaction
//		if(IPersistentResource.class.isAssignableFrom(resource.getClass())){
////			ResourceHome home = (ResourceHome)ctx.getResourceHome();
////			Object key = home.extractResourceIdentifier(ctx);
////			ResourceProperties rpDoc = new ResourceProperties(rpDocument.getNamespace(),rpDocument.getName());
////			rpDoc = SOAPUtil.addChilds(rpDoc,rpDocument);
////			
////			home.changePersistentResourceState(key,rpDoc);
//			Object key = resource.getID();
//			try{
//				XMLPersistenceUtil helper = new XMLPersistenceUtil(resource.getClass());
//				helper.store(key,rpDocument);
//			}catch(Exception e){
//				
//			}
//		}
//		
//		//췵ر
//		String action = "http://docs.oasis-open.org/wsrf/rpw-2/DeleteResourceProperties/DeleteResourcePropertiesResponse";
//		
//		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
//    	Metaset response = metBuilder.newMetaset("wsrf-rp","DeleteResourcePropertiesResponse");
//		
//		Metaset deleteResourcePropertiesResponse = SOAPUtil.generateSOAP(action,response);
////		if(resource.getResourceCallBack()!=null){
////			resource.getResourceCallBack().deleteResourceProperties();
////		}
//		return deleteResourcePropertiesResponse;
//	}
//	
//	private static QName getQName(Metaset message){
//		QName qname = null;
//		Metaset delete = message.filter(".\\Body\\DeleteResourceProperties\\Delete").car();
//		List attributes = delete.elements();
//		Attribute attribute = (Attribute)attributes.iterator().next();
//		//ıĸԵƲResourceProperty,׳쳣
//		if(!attribute.getName().equals("ResourceProperty")){
//			Calendar timestamp = Calendar.getInstance();
//			DeleteResourcePropertiesRequestFailedFault fault = new DeleteResourcePropertiesRequestFailedFault(timestamp,
//															ResourceConstants.DELETE_RESOURCE_PROPERTIES_REQUEST_FAILED_FAULT);
//			throw fault;
//		}
//		String value = attribute.getText();
//		String namespace = value.substring(0,value.indexOf(":"));
//		String name = value.substring(value.indexOf(":")+1);
//		
//		String actualnamespace = MetasetUtil.findNsURIofPrefix(delete,namespace);
//		System.out.println(actualnamespace);
//		
//		qname = new QName(actualnamespace,name);
//		return qname;
//	}

}
