/*
 * Created on 2006-3-19
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.properties;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.xcontainer.addressing.uitl.SoapConstants;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.InvalidResourcePropertyQNameFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceProperties;
import org.act.xservices.rt.xresource.resource.IResourceWithCallback;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.util.ResourceConstants;
import org.act.xservices.rt.xresource.util.ResourceUtil;
import org.act.xservices.rt.xresource.util.SOAPUtil;
import org.act.xservices.rt.xresource.util.WsrpConstants;

/**
 * Get MultipleResourceProperties from Resource
 * 
 * @author Administrator
 */
public class GetMultipleResourcePropertiesPortType extends PropertyPortTypeOperation{
	final static Logger logger = LoggerFactory.getLogger(GetMultipleResourcePropertiesPortType.class);

	private QName[] propertyList;
	
	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		Metaset bodyMet = soapEnv.getBody().element(WsrpConstants.GET_MULTIPLE_QNAME);
		if(bodyMet == null){
			throw new InvalidMessageFormatFault();
		}
		
		// Check & extract properties requested
		List<Metaset> childrenList = bodyMet.elements();
		propertyList = new QName[childrenList.size()];
		for(int i = 0; i < propertyList.length; i++){
			Metaset tempMet = childrenList.get(i);
			String tempName = tempMet.getName();
			if(tempName == null || tempName.trim().length() == 0 || !tempName.equals("ResourceProperty")){
				throw new InvalidMessageFormatFault();
			}
			String tempText = tempMet.getTextTrim();
			if(tempText == null || tempText.trim().length() == 0){
				throw new InvalidMessageFormatFault(); 
			}
			int index = tempText.indexOf(':');
			if(index <= 0 || index>= tempText.length()-1){
				throw new InvalidMessageFormatFault(); 
			}
			
			String tempPrefix = tempText.substring(0, index);
			Namespace tempNS = tempMet.getNamespaceForPrefix(tempPrefix);
			if( tempNS == null ){
				throw new InvalidResourcePropertyQNameFault();
			}
			propertyList[i] = new QName(tempNS.getURI(), tempText.substring(index+1, tempText.length()), tempPrefix);
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		// Get propertyValue
		IResource resource = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			resource = ctx.getResource();
			
		}catch(NoSuchResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(ResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(Exception e){
			throw new RemoteException("resourceDisoveryFailed",e);
		}
		
		IResourceProperties iro = resource.getResourceProperties();
		
		// Build soapBody
//		SOAPFactory soapFact = SOAPFactory.getInstance();
//		ISOAPBody soapBody = soapFact.createSOAPBody(SoapConstants.BODY_QNAME);
		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
		Metaset responseMetaset = metBuilder.createElement(WsrpConstants.GET_MULTIPLE_RESPONSE_QNAME);
		
		// Build body content
		for(int i = 0; i < propertyList.length; i++){
			String propertyValue = iro.getProperty(propertyList[i].getName());
			Metaset tempMet = metBuilder.createElement(propertyList[i]);
			tempMet.setText(propertyValue);
			responseMetaset.add(tempMet);
		}
		return responseMetaset;
	}

	public static void main(String[] args) throws Exception{
		String xmlsoap = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">";
		xmlsoap += "<soapenv:Header>";
		xmlsoap += "<wsa:Action soapenv:actor=\"http://schemas.xmlsoap.org/soap/actor/next\" soapenv:mustUnderstand=\"0\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/03/addressing\">http://docs.oasis-open.org/wsrf/rpw-2/GetMultipleResourceProperties/GetMultipleResourcePropertiesRequest</wsa:Action>";
		xmlsoap += "<wsa:To soapenv:actor=\"http://schemas.xmlsoap.org/soap/actor/next\" soapenv:mustUnderstand=\"0\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/03/addressing\">http://192.168.2.100:8091/wsrf/services/JvmResourceService</wsa:To>";
		xmlsoap += "<ex:MessageId soapenv:actor=\"http://schemas.xmlsoap.org/soap/actor/next\" soapenv:mustUnderstand=\"0\" xmlns:ex=\"http://ws.act.org/resource/example/JvmResourceService\">9288</ex:MessageId>";
		xmlsoap += "</soapenv:Header>";
	    xmlsoap += "<soapenv:Body>";
	    xmlsoap += "<wsrf-rp:GetMultipleResourceProperties xmlns:wsrf-rp=\"http://docs.oasis-open.org/wsrf/rp-2\" xmlns:tns=\"http://ws.act.org/resource/example/JvmResourceService\">";
	    xmlsoap += "<wsrf-rp:ResourceProperty>tns:NumberOfBlocks</wsrf-rp:ResourceProperty>";
	    xmlsoap += "<wsrf-rp:ResourceProperty>tns:BlockSize</wsrf-rp:ResourceProperty>";
	    xmlsoap += "</wsrf-rp:GetMultipleResourceProperties>";
	    xmlsoap += "</soapenv:Body>";
	    xmlsoap += "</soapenv:Envelope>";
		Metaset met = MetasetParserFactory.getMetasetParser().parseXMLString(xmlsoap);
		Metaset ms = met.element("Body").element("GetMultipleResourceProperties").element("ResourceProperty");
		
		System.out.println(ms.getNamespaceForPrefix("tns").getURI());
	}

}
