/*
 * Created on 2006-3-20
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.properties;

import java.rmi.RemoteException;
import java.util.List;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPBody;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.xcontainer.addressing.uitl.SoapConstants;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.util.ResourceUtil;
import org.act.xservices.rt.xresource.util.WsrpConstants;

/**
 * Get ResourcePropertyDocument from Resource
 * @author Administartor
 */
public class GetResourcePropertyDocumentPortType extends PropertyPortTypeOperation {
	final static Logger logger = LoggerFactory.getLogger(GetResourcePropertyDocumentPortType.class);

	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		Metaset bodyContentMet = soapEnv.getBody().element(WsrpConstants.GET_RP_DOCUMENT_ACTION);
		if(bodyContentMet == null){
			throw new InvalidMessageFormatFault();
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		IResource resource = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			System.out.println("ctx: " + ctx.toString());
			resource = ctx.getResource();
			System.out.println("resource: " + resource);
		}catch(NoSuchResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(ResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(Exception e){
			e.printStackTrace();
			throw new RemoteException("resourceDisoveryFailed",e);
		}
		
		// Build soapBody
		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
		Metaset responseMetaset = metBuilder.createElement(WsrpConstants.GET_DOCUMENT_RESPONSE_QNAME);

		// Build body content
		Metaset rpDoc = resource.getResourceProperties().getdocument();
		responseMetaset.add(rpDoc.createCopy());
		
		return responseMetaset;
	}
}
