/*
 * Created on 2006-3-22
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.properties;

import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.util.MetasetHelper;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.InvalidRequestFormatFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.UnableToPutResourcePropertyDocumentFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.util.WsrpConstants;


/**
 * @author duanjiaqin
 *
 * ޸WS-ResourceԵֵ
 * ϢıĸʽΪ
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 *	      xmlns:wsa="http://www.w3.org/2005/08/addressing"
 *	      xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2"
 *	      xmlns:ex="http://examples.com/exampleNS">
 *		<s11:Header>
 *			<wsa:Action>http://docs.oasis-open.org/wsrf/rpw-2/PutResourcePropertyDocument/PutResourcePropertyDocumentRequest</wsa:Action>
 *			<wsa:To s11:mustUnderstand="1">http://www.provider.org/ProviderEndpoint</wsa:To>
 *			<ex:ResourceDiambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22</ex:ResourceDiambiguator>
 *		</s11:Header>
 *		<s11:Body>
 *			<wsrf-rp:PutResourcePropertyDocument>
 *				<tns:GenericDiskDriveProperties xmlns:tns="http://example.com/diskDrive">
 *					<tns:NumberOfBlocks>22</tns:NumberOfBlocks>
 *					<tns:BlockSize>1024</tns:BlockSize>
 *					<tns:Manufacturer>DrivesRUs</tns:Manufacturer>
 *				</tns:GenericDiskDriveProperties>
 *			</wsrf-rp:PutResourcePropertyDocument>
 *		</s11:Body>
 * </s11:Envelope>
 * صӦĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 * 				xmlns:wsa="http://www.w3.org/2005/08/addressing"
 * 				xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2">
 * 		<s11:Header>
 * 			<wsa:Action>
 * 				http://docs.oasis-open.org/wsrf/rpw-2/PutResourcePropertyDocument/PutResourcePropertyDocumentResponse
 * 			</wsa:Action>
 * 		<s11:Body>
 * 			<wsrf-rp:PutResourcePropertyDocumentResponse/>
 * 		</s11:Body>
 * </s11:Envelope>
 */
public class PutResourcePropertyDocumentPortType extends PropertyPortTypeOperation  {
	private MetasetHelper metHelper = MetasetHelper.getInstance();
	
	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Valid PutResourcePropertyDocument
		Metaset bodyContentMet = soapEnv.getBody().element(WsrpConstants.PUT_RP_DOCUMENT_ACTION);
		if(bodyContentMet == null){
			throw new InvalidMessageFormatFault();
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		// Get Resource
		IResource resource = null;
		try{
			ResourceContext ctx = new ResourceContext(soapEnv);
			resource = ctx.getResource();
			
		}catch(NoSuchResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(ResourceException e){
			throw new ResourceUnknownFault();
			
		}catch(Exception e){
			throw new RemoteException("resourceDisoveryFailed",e);
		}
		
		// Get the document
		Metaset rpDoc = resource.getResourceProperties().getdocument();
		List<Metaset> putDocList = soapEnv.getBody().getFirstElement().elements();
		if(putDocList == null || putDocList.size() == 0){
			throw new InvalidRequestFormatFault();
		}
		
		boolean flag = isEqual(rpDoc, putDocList.get(0));
		if(flag == false){
			throw new UnableToPutResourcePropertyDocumentFault();
		}
		
		// Build succeful soapbody
		// Build soapBody
		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
		Metaset responseMetaset = metBuilder.createElement(WsrpConstants.PUT_RESPONSE_QNAME);

		return responseMetaset;
	}
	
//	/**
//	 * Match two document's structure, 
//	 * the copy met2's value to met1 when their's values not equal.
//	 * This method only matches the children elements, excluding root elements
//	 * @param met1
//	 * @param met2
//	 * @return
//	 */
//	public boolean matchDocuments(Metaset met1, Metaset met2){
//		List<Metaset> children1 = met1.elements();
//		List<Metaset> children2 = met2.elements();
//		boolean flag = true;
//		for(int i = 0; i < children1.size(); i++ ){
//			Metaset e1 = children1.get(i);
//			Metaset e2 = children2.get(i);
//			
//			QName qname1 = e1.getQName();
//			QName qname2 = e2.getQName();
//
//			if (!qname1.equals(qname2))
//				return false;
//			
//			int type1 = metHelper.getTypeOfMetaset(e1);
//			int type2 = metHelper.getTypeOfMetaset(e2);
//
//			//
//			// nodes aren't the same type - WRONG ORDER!
//			//
//			if (type1 != type2)
//				return false;
//			else if(!haveMatchingAttributes(e1, e2)){
//				return false;
//			}
//
//			//
//			// only concerned with Text and Element nodes - Comments and
//			// CDATA are ignored
//			//
//
//			else if (type1 == MetasetHelper.TEXT_NODE) {
//				String text1 = e1.getTextTrim();
//				String text2 = e2.getTextTrim();
//
//				// Give the value
//				if(!text1.equals(text2)){
//					e1.setText(text2);
//				}
//			}else if (type1 == MetasetHelper.ELEMENT_NODE
//					&& !isEqual( e1, e2))
//				return false;
//		}
//		
//		return flag;
//	}
	
	/**
	 * 
	 * @param e1
	 * @param e2
	 * 
	 * @return True, if:
	 *         <ul>
	 *         <li>The two Elements have the same QName.</li>
	 *         <li>They have the same child elements, <b>in the same order</b>;
	 *         this includes Elements and Texts.</li>
	 *         <li>They have the same attributes, excluding XML namespace and
	 *         prefix definitions.</li>
	 *         </ul>
	 *         This method short-circuits to "true" if the two references are
	 *         the same (e1 == e2). It short-circuits to "false" if one
	 *         reference is null and the other isn't.
	 * 
	 */
	public boolean isEqual(Metaset e1, Metaset e2) {
		//
		// avoid semantic comparisons if we can
		//
		if (e1 == e2)
			return true;

		//
		// they're not the same reference, so if either equals null,
		// we can quit
		//
		if (e1 == null || e2 == null)
			return false;

		//
		// make sure root elements are the same, including tag name
		//
		QName qname1 = e1.getQName();
		QName qname2 = e2.getQName();

		if (!qname1.equals(qname2))
			return false;

		return haveMatchingChildren(e1, e2) && haveMatchingAttributes(e1, e2);
	}
	
	/**
	 * 
	 * Recursively compares the children in the Element sub-trees to see if they
	 * are of equal name, value, and <b>order</b>. Only Element and Text nodes
	 * are compared.
	 * 
	 * @param e1
	 * @param e2
	 * 
	 * @return True if the two Elements have the same children, in the same
	 *         order. The comparison only targets Element and Text children, not
	 *         Attr or other DOM Nodes.
	 * 
	 * @see #haveMatchingAttributes(Element, Element)
	 * 
	 */
	private boolean haveMatchingChildren(Metaset e1, Metaset e2) {
		//
		// compare all the child nodes... (w/o attributes). nodes must be
		// identical and IN THE SAME ORDER - if this is so, the node types
		// should match
		//
		List<Metaset> children1 = e1.elements();
		List<Metaset> children2 = e2.elements();

		int length1 = children1.size();
		int length2 = children2.size();

		if (length1 != length2)
			return false;

		for (int n = 0; n < length1; ++n) {
			Metaset next1 = children1.get(n);
			Metaset next2 = children2.get(n);
			
			QName qname1 = next1.getQName();
			QName qname2 = next2.getQName();

			if (!qname1.equals(qname2))
				return false;

			int type1 = metHelper.getTypeOfMetaset(next1);
			int type2 = metHelper.getTypeOfMetaset(next2);

			//
			// nodes aren't the same type - WRONG ORDER!
			//
			if (type1 != type2)
				return false;

			//
			// only concerned with Text and Element nodes - Comments and
			// CDATA are ignored
			//

			else if (type1 == MetasetHelper.TEXT_NODE) {
				String text1 = next1.getTextTrim();
				String text2 = next2.getTextTrim();

				// Give the value
				if(!text1.equals(text2)){
					System.out.println("text1: " + text1);
					next1.setText(text2);
				}
			}

			//
			// recurse down the tree to do more comparisons
			//
			else if (type1 == MetasetHelper.ELEMENT_NODE
					&& !isEqual((Metaset) next1, (Metaset) next2))
				return false;
		}

		return true;
	}

	/**
	 * Used by isEquals(e1, e2)
	 * 
	 * @param e1
	 * @param e2
	 * 
	 * @return True if the two Elements have the same attributes and attribute
	 *         values. The comparison <b>excludes</b> XML namespace
	 *         declarations, since the prefixes used in an XML fragment are not
	 *         important.
	 * 
	 */
	private boolean haveMatchingAttributes(Metaset e1, Metaset e2) {
		//
		// the order of the attributes is not important, just the values.
		// we ignore namespace URI attributes because the prefixes used
		// in a fragment are also unimportant
		//
		List<Attribute> attr1 = e1.attributes();
		List<Attribute> attr2 = e2.attributes();

		int length1 = attr1.size();
		int length2 = attr2.size();
		
		if(length1 != length2)
			return false;

		for (int n = 0; n < length1; ++n) {
			Attribute attr = attr1.get(n);
			String name = attr.getName();
			String value = attr.getValue();

			Attribute match = getNamedItem(attr2, name);
			if (match == null)
				return false;

			String matchValue = match.getValue();

			if (matchValue == null || !matchValue.equals(value))
				return false;
		}

		return true;
	}

	/**
	 * Get item from attrList whose name equals param name
	 * 
	 * @param attrList
	 * @param name
	 * @return
	 */
	private Attribute getNamedItem(List<Attribute> attrList, String name) {
		Iterator<Attribute> iter = attrList.iterator();
		while (iter.hasNext()) {
			Attribute attr = iter.next();
			if (name.equalsIgnoreCase(attr.getName()))
				return attr;
		}
		return null;
	}
	
//	public Metaset putResourcePropertyDocument(Metaset request)throws RemoteException,
//																	ResourceUnknownFault,
//																	UnableToPutResourcePropertyDocumentFault{
//		IResource resource = null;
//		ResourceContext ctx = null;
//		
//		try{
//			ctx = new ResourceContext(request);
//			resource = ctx.getResource();
//		}catch(NoSuchResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}catch(ResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}catch(Exception e){
//			throw new RemoteException("resourceDisoveryFailed",e);
//		}
//		
//		if(resource == null){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}
//		
//		//ȡԭԴĵ
//		//ResourceProperties rpDocument = (ResourceProperties)resource.getResourceProperties();
//
//		IResourceProperties pro = resource.getResourceProperties();
//		Metaset rpDocument = pro.getdocument();
//		
//		//add by cover_eye:07-12-7
//		Metaset old=null;
//		old = (Metaset) rpDocument.clone();
//		//end by cover_eye:07-12-7
//		
//		//ϢлȡµԴĵ
//		ResourceProperties replaceDocument = getResourcePropertyDocument(request);
//		if( (rpDocument.getName().equals(replaceDocument.getName())) && MetasetUtil.findNsURIofPrefix(rpDocument,"tns").equals(
//																		MetasetUtil.findNsURIofPrefix(replaceDocument,rpDocument.getNamespaceURI()))){
//			resource.setResourceProperties(replaceDocument);
//		}
//		
//		//add by cover_eye:07-12-7
//		if(resource instanceof IResourceWithCallback && ((IResourceWithCallback)resource).getResourceCallBack()!=null){
//			((IResourceWithCallback)resource).getResourceCallBack().putResourcePropertyDocument(old, (ResourceProperties)resource.getResourceProperties());
//			}
//	   //end by cover_eye:07-12-7
//		
//		
//		//Դǳ־ûģִtrancation
//		if(IPersistentResource.class.isAssignableFrom(resource.getClass())){
////			ResourceHome home = (ResourceHome)ctx.getResourceHome();
////			ResourceProperties rpDoc = new ResourceProperties(replaceDocument.getNamespace(),replaceDocument.getName());
////			rpDoc = SOAPUtil.addChilds(rpDoc,replaceDocument);
////			Object key = home.extractResourceIdentifier(ctx);
////			home.changePersistentResourceState(key,rpDoc);
//			Object key = resource.getID();
//			try{
//				XMLPersistenceUtil helper = new XMLPersistenceUtil(resource.getClass());
//				helper.store(key,rpDocument);
//			}catch(Exception e){
//				e.printStackTrace();
//			}
//		}
//		
//		//췵صSOAP
//		String action = "http://docs.oasis-open.org/wsrf/rpw-2/PutResourcePropertyDocument/PutResourcePropertyDocumentResponse";
//		
//		
//		
//		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
//    	Metaset response = metBuilder.newMetaset("wsrf-rp","PutResourcePropertyDocumentResponse");
//		
//		
//		Metaset getResourcePropertyDocumentResponse = SOAPUtil.generateSOAP(action,response);
//		
//		if(resource.getResourceCallBack()!=null){
//			resource.getResourceCallBack().putResourcePropertyDocument();
//		}
//		
//		return getResourcePropertyDocumentResponse;
//	}
	
}
							

