/*
 * Created on 2006-4-8
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.resource.impl.properties;

import java.io.IOException;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.utils.MetasetUtil;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.faults.InvalidModificationFault;
import org.act.xservices.rt.xresource.faults.InvalidResourcePropertyQNameFault;
import org.act.xservices.rt.xresource.faults.ResourceUnknownFault;
import org.act.xservices.rt.xresource.faults.UnableToModifyResourcePropertyFault;
import org.act.xservices.rt.xresource.faults.ext.InvalidMessageFormatFault;
import org.act.xservices.rt.xresource.resource.IPersistentResource;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.IResourceProperties;
import org.act.xservices.rt.xresource.resource.IResourceWithCallback;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.impl.ResourceContext;
import org.act.xservices.rt.xresource.util.ResourceConstants;
import org.act.xservices.rt.xresource.util.SOAPUtil;
import org.act.xservices.rt.xresource.util.WsrpConstants;
import org.act.xservices.rt.xresource.util.XMLPersistenceUtil;

/**
 * @author duanjiaqin
 *
 * ޸һԴ
 * Ϣıĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 *	      xmlns:wsa="http://www.w3.org/2005/08/addressing"
 *	      xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2"
 *	      xmlns:ex="http://examples.com/exampleNS">
 *		<s11:Header>
 *			<wsa:Action>http://docs.oasis-open.org/wsrf/rpw-2/UpdateResourceProperties/UpdateResourcePropertiesRequest</wsa:Action>
 *			<wsa:To s11:mustUnderstand="1">http://www.provider.org/ProviderEndpoint</wsa:To>
 *			<ex:ResourceDiambiguator>uuid:84decd55-7d3f-65ad-ac44-675d9fce5d22</ex:ResourceDiambiguator>
 *		</s11:Header>
 *		<s11:Body>
 *			<wsrf-rp:UpdateResourceProperties xmlns:tns="http://example.com/diskDrive">
 *				<wsrf-rp:Update>
 *					<tns:NumberOfBlocks>143</tns:NumberOfBlocks>
 *				</wsrf-rp:Update>
 *			</wsrf-rp:UpdateResourceProperties>
 *		</s11:Body>
 * </s11:Envelope>
 * صӦĸʽ£
 * <s11:Envelope xmlns:s11="http://schemas.xmlsoap.org/soap/envelope/"
 * 				xmlns:wsa="http://www.w3.org/2005/08/addressing"
 * 				xmlns:wsrf-rp="http://docs.oasis-open.org/wsrf/rp-2">
 * 		<s11:Header>
 * 			<wsa:Action>
 * 				http://docs.oasis-open.org/wsrf/rpw-2/UpdateResourceProperties/UpdateResourcePropertiesResponse
 * 			</wsa:Action>
 * 		<s11:Body>
 * 			<wsrf-rp:UpdateResourcePropertiesResponse>
 * 			</wsrf-rp:UpdateResourcePropertiesResponse>
 * 		</s11:Body>
 * </s11:Envelope>
 */
public class UpdateResourcePropertiesPortType extends PropertyPortTypeOperation{
	
	@Override
	protected void validateSOAPMsg(ISOAPEnvelope soapEnv) throws BaseFault {
		// Get the propertyName requested by client
		Metaset propertyMet = soapEnv.getBody().element(
				WsrpConstants.UPDATE_RESOURCE_PROPERTIES_ACTION);
		if (propertyMet == null) {
			throw new InvalidMessageFormatFault();
		}

		Metaset updateMet = propertyMet.element("Update");
		if (updateMet == null) {
			throw new InvalidMessageFormatFault();
		}

		List<Metaset> elemList = updateMet.elements();
		if (elemList == null || elemList.size() == 0) {
			throw new InvalidMessageFormatFault();
		}
	}
	
	@Override
	protected Metaset generateResponseSOAPBody(ISOAPEnvelope soapEnv)
			throws BaseFault, RemoteException {
		// Get Resource
		IResource resource = null;
		try {
			ResourceContext ctx = new ResourceContext(soapEnv);
			resource = ctx.getResource();

		} catch (NoSuchResourceException e) {
			throw new ResourceUnknownFault();

		} catch (ResourceException e) {
			throw new ResourceUnknownFault();

		} catch (Exception e) {
			throw new RemoteException("resourceDisoveryFailed", e);
		}

		IResourceProperties irp = resource.getResourceProperties();
		Metaset rpDoc = irp.getdocument();

		// Start the set processing
	
		List<Metaset> updateItemList = soapEnv.getBody().getFirstElement().element(WsrpConstants.UPDATE_QNAME).elements();
		Iterator<Metaset> updateIter = updateItemList.iterator();
		while(updateIter.hasNext()){
			Metaset updateItem = updateIter.next();
			QName updateQName = updateItem.getQName();
			Metaset toRemovedItem = rpDoc.element(updateQName);
			if(toRemovedItem == null)
				throw new InvalidResourcePropertyQNameFault();
			rpDoc.remove(toRemovedItem);
			rpDoc.add(updateItem.createCopy());
		}

		// If you can go here, you get a sucessful operation
		// Then what you do is to return a response message
		// TODO: Thread safe
		return MetasetBuilder.getInstance().newMetaset(
				WsrpConstants.UPDATE_RESPONSE_QNAME);
	}

//	
//	public Metaset updateResourceProperties(Metaset request)throws RemoteException,
//																   ResourceUnknownFault,
//																   InvalidModificationFault,
//																   UnableToModifyResourcePropertyFault,
//																   InvalidResourcePropertyQNameFault{
//		IResource resource = null;
//		ResourceContext ctx = null;
//		
//		try{
//			ctx = new ResourceContext(request);
//			resource = ctx.getResource();
//		}catch(NoSuchResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}catch(ResourceException e){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}catch(Exception e){
//			
//		}
//		
//		if(resource == null){
//			Calendar timestamp = Calendar.getInstance();
//			ResourceUnknownFault fault = new ResourceUnknownFault();
//			throw fault;
//		}
//		
//		//ȡԴĵ
//		
//		IResourceProperties pro = resource.getResourceProperties();
//		
//		
//		Metaset rpDocument = pro.getdocument();
//		
//		//add by cover_eye:2007-12-7
//		Metaset old=null;
//		// ǰõrpDocument.copy()
//		old = (Metaset) rpDocument.createCopy();
//
//		
//		List elements = rpDocument.elements();
//		String actualnamespace = rpDocument.selectorAttributeValue("*", "tns");
//		
//		Metaset updateProperties = getUpdateProperties(request);
//		List childs = updateProperties.elements();
//		
//		
//		
//		
//		
//		
//		//жϴ޸ĵǷϷ,ֿռǷԴĵͬ
//		Iterator iterator = childs.iterator();
//		while(iterator.hasNext()){
//			Metaset ch = (Metaset)iterator.next();
//			if(!MetasetUtil.findNsURIofPrefix(ch,ch.getNamespacePrefix()).equals(actualnamespace)){
//				Calendar timestamp = Calendar.getInstance();
//				InvalidResourcePropertyQNameFault fault = new InvalidResourcePropertyQNameFault();
//				throw fault;
//			}
//		}
//		
//		//Сѭ⣬ѭ
//		Iterator iter = childs.iterator();
//		boolean updateFlag = false;
//	
//		
//		
//		
//		while(iter.hasNext()){
//			Metaset child = (Metaset)iter.next(); //liying  µ
//		
//			updateFlag = pro.setProperty(child.getNamespacePrefix(), child.getText());
//		
////			
////			for(int i=0;i<elements.size();i++){
////				Metaset element = (Metaset)elements.get(i);
////				if(element.getLocalPart().equals(child.getLocalPart()))
////				{
//
////					element.setValue(child.getValue());
////					updateFlag = true;
//
////				}
////				MetasetUtil s;
////			}
//			MetasetUtil s;
//			
//			
//			//add by cover_eye:07-8-7
//			if(updateFlag==true){
//				ctx.getResource().getResourceProperties();
//				if(resource instanceof IResourceWithCallback && ((IResourceWithCallback)resource).getResourceCallBack()!=null){
//					((IResourceWithCallback)resource)
//					.getResourceCallBack()
//					.updateResourceProperties(old,rpDocument);
//					
//					//System.err.println("wo shi xiaoxiao !");
//					//System.err.println(old.toXML());
//					//System.err.println(rpDocument.toXML());
//					}
//			}
//			
//			
//			//end by cover_eye:07-8-7
//			
//			//ûƥԪأ׳쳣
//			if(updateFlag == false){
//				Calendar timestamp = Calendar.getInstance();
//				InvalidResourcePropertyQNameFault fault = new InvalidResourcePropertyQNameFault();
//				throw fault;
//			}
//		}
//		
//		//Դǳ־ûģӦtransaction
//		if(IPersistentResource.class.isAssignableFrom(resource.getClass())){
////			ResourceHome home = (ResourceHome)ctx.getResourceHome();
////			Object key = home.extractResourceIdentifier(ctx);
////			ResourceProperties rpDoc = new ResourceProperties(rpDocument.getNamespace(),rpDocument.getName());
////			rpDoc = SOAPUtil.addChilds(rpDoc,rpDocument);
////			home.changePersistentResourceState(key,rpDoc);
//			Object key = resource.getID();
//			try{
//				XMLPersistenceUtil helper = new XMLPersistenceUtil(resource.getClass());
//				helper.store(key,rpDocument);
//			}catch(Exception e){
//				e.printStackTrace();
//			}
//		}
//		
//		//췵ر
//		String action = "http://docs.oasis-open.org/wsrf/rpw-2/UpdateResourceProperties/UpdateResourcePropertiesResponse";
//		
//		
//		MetasetBuilder metBuilder = MetasetBuilder.getInstance();
//    	Metaset response = metBuilder.newMetaset("wsrf-rp","UpdateResourcePropertiesResponse");
//		
//		
//		Metaset updateResourcePropertyDocumentResponse = SOAPUtil.generateSOAP(action,response);
//		
////		if(resource.getResourceCallBack()!=null){
////			resource.getResourceCallBack().updateResourceProperties();
////		}
//		
//		return updateResourcePropertyDocumentResponse;
//	}
//	
//	private static Metaset getUpdateProperties(Metaset message){
//		Metaset update = message.filter(".\\Body\\UpdateResourceProperties\\Update").car();
//		return update;
//	}
	
}
