package org.act.xservices.rt.xresource.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPHeader;
import org.act.xservices.rt.soap.ISOAPHeaderBlock;
import org.act.xservices.rt.soap.exception.SOAPException;
import org.act.xservices.rt.soap.factory.SOAPFactory;
import org.act.xservices.rt.soap.util.SOAPMessageUtil;
import org.act.xservices.rt.xcontainer.addressing.uitl.WsaConstants;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xresource.addressing.ResourceMessageHeaders;
import org.act.xservices.rt.xresource.basefault.BaseFault;

public class FaultEnvelopeGenerator {
	private static FaultEnvelopeGenerator instance = null;
	
	private FaultEnvelopeGenerator(){}
	
	public static FaultEnvelopeGenerator getInstance(){
		if(instance == null){
			synchronized(FaultEnvelopeGenerator.class){
				if(instance == null){
					instance = new FaultEnvelopeGenerator();
				}
			}
		}
		return instance;
	}
	
	/**
	 * Gnerate a fault message
	 * @param soapEnv
	 * @param e
	 * @return
	 */
	public ISOAPEnvelope generateFaultEnvelope(ISOAPEnvelope soapEnv, Exception e){
		ResourceMessageHeaders rmHeaders = null;
		ResourceMessageHeaders faultHeaders = null;
		try {
			rmHeaders = new ResourceMessageHeaders(soapEnv.getHeader());
			faultHeaders = rmHeaders.createFaultHeaders();
			
		} catch (SOAPException e1) {
			e1.printStackTrace();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		
		ISOAPHeader soapHeader = faultHeaders.toSOAPHeader();
		soapHeader.element("Action").setText(WsbfConstants.BASE_FAULT_URI);
		
		BaseFault baseFault = null;
		if(!(e instanceof BaseFault)){
			List<String> description = new ArrayList<String>();
			description.add("It's not a sub-class of BaseFault.");
			baseFault = new BaseFault("Not a wsrf Exception.", description);
		}

		// Build fault envelope
		ISOAPEnvelope faultEnv = SOAPMessageUtil.creatStdFaultMessage(soapEnv.getVersion(),WsrfConstants.PREFIX + ":Client", e.getMessage(), null, baseFault.toMetaset());
		faultEnv.getHeader().addHeaderBlock("Action", new Namespace(WsaConstants.PREFIX, WsaConstants.NAMESPACE_URI)).addText(WsbfConstants.BASE_FAULT_URI);

		return faultEnv;
	}
}
