package org.act.xservices.rt.xresource.util;

import java.util.HashMap;
import java.util.Map;

/**
 * Store the resource classloader
 * @author Administrator
 *
 */
public class ResourceClassLoaderRepos {
	private Map<String, ClassLoader> map;
	
	private static ResourceClassLoaderRepos instance;
	
	private ResourceClassLoaderRepos(){
		map = new HashMap<String, ClassLoader>();
	}
	
	public static ResourceClassLoaderRepos getInstance(){
		if( instance == null ){
			synchronized (ResourceClassLoaderRepos.class) {
				if(instance == null){
					instance = new ResourceClassLoaderRepos();
				}
			}
		}
		return instance;
	}
	
	public void put(String key, ClassLoader classLoader){
		map.put(key, classLoader);
	}
	
	public ClassLoader get(String key){
		return map.get(key);
	}
}
