/*
 * Created on 2006-3-18
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.util;

import org.act.xservices.log.Logger;
import org.act.xservices.log.LoggerFactory;
import org.act.xservices.rt.soap.ISOAPEnvelope;
import org.act.xservices.rt.soap.ISOAPVersion;
import org.act.xservices.rt.xresource.basefault.BaseFault;
import org.act.xservices.rt.xresource.resource.impl.lifetime.DestroyPortType;
import org.act.xservices.rt.xresource.resource.impl.lifetime.SetTerminationTimePortType;
import org.act.xservices.rt.xresource.resource.impl.properties.DeleteResourcePropertiesPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.GetMultipleResourcePropertiesPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.GetResourcePropertyDocumentPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.GetResourcePropertyPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.InsertResourcePropertiesPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.PropertyPortTypeOperation;
import org.act.xservices.rt.xresource.resource.impl.properties.PutResourcePropertyDocumentPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.QueryResourcePropertiesPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.SetResourcePropertiesPortType;
import org.act.xservices.rt.xresource.resource.impl.properties.UpdateResourcePropertiesPortType;

/**
 * @author duanjiaqin
 *
 * Build SOAP Envelope
 */
public class SOAPUtil {
	final static Logger logger = LoggerFactory.getLogger(SOAPUtil.class);
	/**
	 * Process doAction, receive a request soap message & response associate soap message
	 * @param soapEnvRequest
	 * @param action
	 * @return
	 */
	public static ISOAPEnvelope doAction(ISOAPEnvelope soapEnvRequest, String action){
		// The soapVersion & soapFaultEnv is used to build fault envelope message
		ISOAPVersion soapVersion = soapEnvRequest.getVersion();
		ISOAPEnvelope soapFaultEnv = null;
		
		PropertyPortTypeOperation  ppto = null;
		if(action.equals(WsrpConstants.GET_RESOURCE_PROPERTY_ACTION)) {
			ppto = new GetResourcePropertyPortType();
			
		} else if(action.equals(WsrpConstants.GET_MULTIPLE_PROPERTIES_ACTION)) {
			ppto = new GetMultipleResourcePropertiesPortType();
			
		} else if(action.equals(WsrpConstants.GET_RP_DOCUMENT_ACTION)){
			ppto = new GetResourcePropertyDocumentPortType();
			
		} else if(action.equals(WsrpConstants.QUERY_RESOURCE_PROPERTIES_ACTION)){
			ppto = new QueryResourcePropertiesPortType();
			
		} else if(action.equals(WsrpConstants.PUT_RP_DOCUMENT_ACTION)){
			ppto = new PutResourcePropertyDocumentPortType();
			
		} else if(action.equals(WsrpConstants.SET_RESOURCE_PROPERTIES_ACTION)){
			ppto = new SetResourcePropertiesPortType();
		
		} else if(action.equals(WsrpConstants.INSERT_RESOURCE_PROPERTIES_ACTION)){
			ppto = new InsertResourcePropertiesPortType();
			
		} else if(action.equals(WsrpConstants.UPDATE_RESOURCE_PROPERTIES_ACTION)){
			ppto = new UpdateResourcePropertiesPortType();
			
		} else if(action.equals(WsrpConstants.DELETE_RESOURCE_PROPERTIES_ACTION)){
			ppto = new DeleteResourcePropertiesPortType();
			
		} else if(action.equals(WsrlConstants.DESTROY_ACTION)){
			ppto = new DestroyPortType();
			
		} else if(action.equals(WsrlConstants.SET_TERMINATION_ACTION)){
			ppto = new SetTerminationTimePortType();
			
		}
		
		try {
			return ppto.processRequestSOAPMsg(soapEnvRequest);
			
		} catch (BaseFault e) {
			return FaultEnvelopeGenerator.getInstance().generateFaultEnvelope(soapEnvRequest, e);
			
		} catch (Exception e) {
			return FaultEnvelopeGenerator.getInstance().generateFaultEnvelope(soapEnvRequest, e);
		} 
	}
	
	/**
	 * жǷWSRFЭеı׼
	 * @param action
	 * @returnWsrpConstants
	 */
	public static boolean isStandardOperation(String action){
		boolean result = false;
		if(action.equals(WsrpConstants.GET_RESOURCE_PROPERTY_ACTION) ||
			action.equals(WsrpConstants.GET_RP_DOCUMENT_ACTION) ||
			action.equals(WsrpConstants.GET_MULTIPLE_PROPERTIES_ACTION) ||
			action.equals(WsrpConstants.DEFAULT_DOCUMENT_QNAME) ||
			action.equals(WsrpConstants.QUERY_RESOURCE_PROPERTIES_ACTION) || 
			action.equals(WsrpConstants.PUT_RP_DOCUMENT_ACTION ) || 
			action.equals(WsrpConstants.SET_RESOURCE_PROPERTIES_ACTION)||
			action.equals(WsrpConstants.INSERT_RESOURCE_PROPERTIES_ACTION) || 
			action.equals(WsrpConstants.UPDATE_RESOURCE_PROPERTIES_ACTION) || 
			action.equals(WsrpConstants.DELETE_RESOURCE_PROPERTIES_ACTION) ||
			action.equals(WsrlConstants.DESTROY_ACTION) || 
			action.equals(WsrlConstants.SET_TERMINATION_ACTION)){
			result = true;
		}
		return result;
	}
	
}
