/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.act.xservices.rt.xresource.util;

import commonj.timers.CancelTimerListener;
import commonj.timers.Timer;
import commonj.timers.TimerListener;

/**
 * @author   Administrator
 */
public class TimerImpl
   implements Timer
{
   
   private TimerTaskImpl         m_timerTask;
   private TimerListener         m_listener;
   private long                  m_period;

   /**
    * Creates a new {@link TimerImpl} object.
    *
    * @param listener DOCUMENT_ME
    * @param period   DOCUMENT_ME
    */
   public TimerImpl( TimerListener listener,
                     long          period )
   {
      this.m_period      = period;
      this.m_listener    = listener;
   }

   /* (non-Javadoc)
    * @see commonj.timer.Timer#getPeriod()
    */
   public long getPeriod(  )
   {
      return this.m_period;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws IllegalStateException DOCUMENT_ME
    */
   public long getScheduledExecutionTime(  )
   throws IllegalStateException
   {
      return 0; // TODO: implement
   }

   /* (non-Javadoc)
    * @see commonj.timer.Timer#getTimerListener()
    */
   public TimerListener getTimerListener(  )
   {
      return this.m_listener;
   }

   /* (non-Javadoc)
    * @see commonj.timer.Timer#cancel()
    */
   public boolean cancel(  )
   {
     
      if ( this.m_listener instanceof CancelTimerListener )
      {
         ( (CancelTimerListener) this.m_listener ).timerCancel( this );
      }

      return m_timerTask.cancel(  );
   }

   /* (non-Javadoc)
    * @see commonj.timer.Timer#scheduledExecutionTime()
    */
   public long scheduledExecutionTime(  )
   {
      return this.m_timerTask.scheduledExecutionTime(  ) + this.m_period;
   }

   /**
    * @param timerTask The timerTask to set.
    */
   protected void setTimerTask( TimerTaskImpl timerTask )
   {
      this.m_timerTask = timerTask;
   }

   /**
    * @return Returns the timerTask.
    */
   protected TimerTaskImpl getTimerTask(  )
   {
      return this.m_timerTask;
   }
}