
/*
 * Created on 2006-3-14
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.util;

import commonj.timers.Timer;
import commonj.timers.TimerListener;
import java.util.TimerTask;

/**
 * @author   Administrator
 */
public class TimerTaskImpl
   extends TimerTask
{
   private Timer            m_timer;
   private TimerListener    m_timerListener;
   private TimerManagerImpl m_timerManager;
   private boolean          m_suspended;
   private boolean          m_expired;

   /**
    * DOCUMENT_ME
    *
    * @param timer
    * @param timerManager
    */
   public TimerTaskImpl( Timer            timer,
                         TimerManagerImpl timerManager )
   {
      m_timer = timer;
      if ( timer instanceof TimerImpl )
      {
         ( (TimerImpl) timer ).setTimerTask( this );
      }

      m_timerListener    = timer.getTimerListener(  );
      m_timerManager     = timerManager;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public boolean cancel(  )
   {
      m_timerManager.removeTask( this );
      return super.cancel(  );
   }

   /**
    * DOCUMENT_ME
    */
   public synchronized void resume(  )
   {
      m_suspended = false;
      if ( m_expired )
      {
         executeTimerExpiredAction(  );
         m_expired = false;
      }
   }

   /* (non-Javadoc)
    * @see java.lang.Runnable#run()
    */
   public synchronized void run(  )
   {
      if ( !m_suspended )
      {
         executeTimerExpiredAction(  );
      }
      else
      {
         m_expired = true;
      }
   }

   /**
    * DOCUMENT_ME
    */
   public synchronized void suspend(  )
   {
      m_suspended = true;
   }

   /**
    * @return Returns the listener.
    */
   protected TimerListener getListener(  )
   {
      return m_timerListener;
   }

   /**
    * @return Returns the timer.
    */
   protected Timer getTimer(  )
   {
      return m_timer;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   protected boolean stop(  )
   {
      return super.cancel(  );
   }

   private void executeTimerExpiredAction(  )
   {
      m_timerListener.timerExpired( m_timer );
      if ( m_timer.getPeriod(  ) == 0 )
      {
         m_timerManager.removeTask( this );
      }
   }
}
