package org.act.xservices.rt.xresource.util;

import org.act.xservices.rt.xom.QName;

/**
 * This is a extension for wsrf
 * The standard wsrf does not include a CREATE operation, so this extension give the
 * CREATE operation to wsrf
 * 
 * cr-1: means create_resource's first spec
 * @author Administrator
 *
 */
public class TnsConstants {
	public static final String NAMESPACE_URI = "http://act.buaa.edu.cn/xservices/wsrf/cr-1";
	
	public static final String PREFIX = "tns";
	
	public static final String CREATE_RESOURCE_REQUEST = "CreateResourceInstanceRequest";
	
	public static final String CREATE_RESOURCE_RESPONSE = "CreateResourceInstanceResponse";
	
	public static final QName CREATE_REQUEST_QNAME = new QName(NAMESPACE_URI, CREATE_RESOURCE_REQUEST, PREFIX);
	
	public static final QName CREATE_RESPONSE_QNAME = new QName(NAMESPACE_URI,CREATE_RESOURCE_RESPONSE, PREFIX );
	
	public static final String CREATE_REQUEST_URI = NAMESPACE_URI + "/CreateResourceInstance/CreateResourceInstanceRequest";
	
	public static final String CREATE_RESPONSE_URI = NAMESPACE_URI + "/CreateResourceInstance/CreateResourceInstanceResponse";
	
	public static final String INSTANCE_ID = "InstanceID";
	
	public static final QName INSTANCE_ID_QNAME = new QName(NAMESPACE_URI, INSTANCE_ID, PREFIX);
}
