package org.act.xservices.rt.xresource.util;

import org.act.xservices.rt.xom.QName;

/**
 *
 * WsbfConstants is a collection of properties that is useful when programming 
 * against the WS-BaseFaults spec. This class uses WS-BF v1.2.
 *
 * @author Douyl
 *
 */

public class WsbfConstants
{    
    public static final String NAMESPACE_URI = "http://docs.oasis-open.org/wsrf/bf-2";
    
    public static final String BASE_FAULT_URI = "http://docs.oasis-open.org/wsrf/fault";
    
    public static final String PREFIX = "wsrf-bf";
    
    public static final QName BASE_FAULT_QNAME = 
        new QName(NAMESPACE_URI, "BaseFault", PREFIX);

    public static final QName DESCRIPTION_QNAME = 
        new QName(NAMESPACE_URI, "Description", PREFIX);
    
    public static final String ERROR_CODE_DIALECT = "Dialect";

    public static final QName ERROR_CODE_QNAME = 
        new QName(NAMESPACE_URI, "ErrorCode", PREFIX);
    
    public static final QName FAULT_CAUSE_QNAME = 
        new QName(NAMESPACE_URI, "FaultCause", PREFIX);

    public static final QName ORIGINATOR_QNAME = 
        new QName(NAMESPACE_URI, "OriginatorReference", PREFIX);
    
    public static final QName TIMESTAMP_QNAME = 
        new QName(NAMESPACE_URI, "Timestamp", PREFIX);
}
