package org.act.xservices.rt.xresource.util;

import org.act.xservices.rt.xom.QName;

/**
 * 
 * WsrfConstants is a collection of constants defined in the WS-ResourceFramework 
 * spec, version 1.2. These values only pertain to the core WSRF spec, not the 
 * other four specs that build on top of it.
 *
 * @author douyl
 *
 */

public class WsrfConstants
{
    public static final String NAMESPACE_URI = "http://docs.oasis-open.org/wsrf/r-2";
    
    public static final String PREFIX = "wsrf-r";

    public static final String WSDL_NAMESPACE_URI = "http://docs.oasis-open.org/wsrf/rw-2";
    
    public static final String WSDL_PREFIX = "wsrf-rw";
    
    public static final QName RESOURCE_UNAVAILABLE_QNAME = 
        new QName(WSDL_NAMESPACE_URI, "ResourceUnavailableFault", WSDL_PREFIX);
    
    public static final QName RESOURCE_UNKNOWN_QNAME = 
        new QName(WSDL_NAMESPACE_URI, "ResourceUnknownFault", WSDL_PREFIX);
    
    /**
     * The common constants
     */
    public static final long DELAY_TIME = 60000;
}
