package org.act.xservices.rt.xresource.util;

import org.act.xservices.rt.xom.QName;

/**
 * 
 * WsrfExtConstants is a collection of constants used by Muse to extend the 
 * base WSRF v1.2 spec. Most of the identifiers here are for common faults that 
 * happen frequently in the WSRP capability implementations.
 *
 * @author douyl
 *
 */

public class WsrfExtConstants
{
    public static final String NAMESPACE_URI = "http://ws.apache.org/muse/wsrf";
    
    public static final String PREFIX = "muse-wsrf";
    
    public static final QName INVALID_MESSAGE_FORMAT_QNAME = 
        new QName(NAMESPACE_URI, "InvalidMessageFormat", PREFIX);
    
    public static final QName METADATA_VALIDATION_ERROR_QNAME = 
        new QName(NAMESPACE_URI, "MetadataValidationFault", PREFIX);
    
    public static final QName RESOURCE_INITIALIZATION_QNAME = 
        new QName(NAMESPACE_URI, "ResourceInitializationFault", PREFIX);
    
    public static final QName SCHEMA_VALIDATION_ERROR_QNAME = 
        new QName(NAMESPACE_URI, "SchemaValidationFault", PREFIX);
    
    public static final QName SERIALIZATION_ERROR_QNAME = 
        new QName(NAMESPACE_URI, "SerializationErrorFault", PREFIX);
}
