
package org.act.xservices.rt.xresource.util;

import org.act.xservices.rt.xom.QName;

/**
 *
 * WsrlConstants is a collection of properties that is useful when programming 
 * against the WS-ResourceLifetime spec. This class uses WS-RL v1.2.
 *
 * @author douyl
 *
 */

public class WsrlConstants
{
    public static final String NAMESPACE_URI = "http://docs.oasis-open.org/wsrf/rl-2";
    
    public static final String PREFIX = "wsrf-rl";
    
    public static final String WSDL_NAMESPACE_URI = "http://docs.oasis-open.org/wsrf/rlw-2";

    public static final String WSDL_PREFIX = "wsrf-rlw";
    
    public static final String IMMEDIATE_TERMINATION_URI = 
        WSDL_NAMESPACE_URI + "/ImmediateResourceTermination";
    
    public static final String SCHEDULED_TERMINATION_URI = 
        WSDL_NAMESPACE_URI + "/ScheduledResourceTermination";
    
    /**
     * 
     * The WS-A Action URI of the Destroy operation.
     * 
     */
    public static final String DESTROY_URI = IMMEDIATE_TERMINATION_URI + "/DestroyRequest";
    
    /**
     * 
     * The WS-A Action URI of the SetTerminationTime operation.
     * 
     */
    public static final String SET_TERMINATION_URI = SCHEDULED_TERMINATION_URI + "/SetTerminationTimeRequest";
    
    public static final String DESTROY_ACTION = "Destroy";
    
    public static final String SET_TERMINATION_ACTION = "SetTerminationTime";
    
    public static final QName DESTROY_QNAME = 
        new QName(NAMESPACE_URI, "Destroy", PREFIX); 
    
    
    public static final QName DESTROY_RESPONSE_QNAME = 
        new QName(NAMESPACE_URI, "DestroyResponse", PREFIX);
    
    public static final QName RESOURCE_NOT_DESTROYED_QNAME = 
        new QName(WSDL_NAMESPACE_URI, "ResourceNotDestroyedFault", WSDL_PREFIX);
    
    public static final QName SET_TERMINATION_QNAME = 
        new QName(NAMESPACE_URI, "SetTerminationTime", PREFIX);
    
    public static final QName SET_TERMINATION_RESPONSE_QNAME = 
        new QName(NAMESPACE_URI, "SetTerminationTimeResponse", PREFIX); 
    
    public static final QName UNABLE_TO_SET_TERMINATION_TIME_QNAME = 
        new QName(WSDL_NAMESPACE_URI, "UnableToSetTerminationTimeFault", WSDL_PREFIX); 
    
    public static final QName TERMINATION_TIME_CHANGE_REJECTED_QNAME = 
        new QName(WSDL_NAMESPACE_URI, "TerminationTimeChangeRejectedFault", WSDL_PREFIX);   
    
    public static final QName NEW_TIME_QNAME = 
        new QName(NAMESPACE_URI, "NewTerminationTime", PREFIX);
    
    public static final QName REQUESTED_TIME_QNAME = 
        new QName(NAMESPACE_URI, "RequestedTerminationTime", PREFIX);
    
    public static final QName REQUESTED_DURATION_QNAME = 
        new QName(NAMESPACE_URI, "RequestedLifetimeDuration", PREFIX);
    
    /**
     * 
     * The name of the wsrl:CurrentTime property.
     * 
     */
    public static final QName CURRENT_TIME_QNAME = 
        new QName(NAMESPACE_URI, "CurrentTime", PREFIX);
    
    /**
     * 
     * The name of the wsrl:TerminationTime property.
     * 
     */
    public static final QName TERMINATION_TIME_QNAME = 
        new QName(NAMESPACE_URI, "TerminationTime", PREFIX);
    
    /**
     * 
     * The name of the WS-RL resource termination event.
     * 
     */
    public static final QName NOTIFICATION_QNAME = 
        new QName(NAMESPACE_URI, "TerminationNotification", PREFIX);
    
    /**
     * 
     * The name of the WS-N Topic for WS-RL termination events.
     * 
     */
    public static final QName TERMINATION_TOPIC_QNAME = 
        new QName(NAMESPACE_URI, "ResourceTermination", PREFIX);
}
