/*
 * Created on 2006-5-10
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.act.xservices.rt.xresource.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xresource.resource.IResource;
import org.act.xservices.rt.xresource.resource.NoSuchResourceException;
import org.act.xservices.rt.xresource.resource.ResourceException;
import org.act.xservices.rt.xresource.resource.ResourceProperties;

/**
 * @author duanjiaqin
 *
 * XMLĳ־û
 */
public class XMLPersistenceUtil extends FilePersistenceUtil{
	private static final String FILE_SUFFIX = ".xml";
	
	public XMLPersistenceUtil(Class beenClass)throws IOException{
		super(beenClass,FILE_SUFFIX);
	}
	
	/**
     * Stores the object of the given key to persistent storage.
     * <br><b>Note:</b> Calls to this function must be synchronized on
     * per key basis.
     *
     * @param key key of object.
     * @param object object to persist.
     * @throws ResourceException If the object cannot be saved to a file.
     */
	public void store(Object key, Object object)throws ResourceException{
		System.out.println("Storing object to an XML file");
		Writer writer = null;
        File tmpFile = null;
        try {
            tmpFile = File.createTempFile("xph", ".tmp",
                                          getStorageDirectory());
            writer = new BufferedWriter(new FileWriter(tmpFile));
            writer.write(((Metaset)object).toXML());
        }catch(Exception e){
        	 if (tmpFile != null) {
                tmpFile.delete();
            }
        }finally{
        	if(writer != null){
        		try{
        			writer.close();
        		}catch(Exception e){
        			e.printStackTrace();
        		}
        	}
        }
        File file = getKeyAsFile(key);
        if (file.exists()) {
            file.delete();
        }
        
        if (!tmpFile.renameTo(file)) {
            file.delete();
            throw new ResourceException("resourceStoreFailed");
        }
        if(file.exists()){
        	tmpFile.delete();
        }
	}
	
	/**
     * Loads and returns the object of the given key from the persistent
     * storage.
     *
     * @param key key of object to load.
     * @return loaded Object instance.
     * @throws ResourceException If the object cannot be loaded from file.
     */
	public Object load(Object key)throws ResourceException{
		System.out.println( "Loading object by deserializing an XML file");

        File resourceFile = getKeyAsFile(key);
        Reader reader = null;
        if (!resourceFile.exists()) {
            System.out.println(
                "backingFileNotFound");
            throw new NoSuchResourceException();
        }

        ResourceProperties rpDoc = null;

        try {
        	Metaset metaset = MetasetParserFactory.getMetasetParser().parse(resourceFile.getAbsolutePath());
            
        	rpDoc = new ResourceProperties(metaset.getQName());
            rpDoc.add(metaset);
        } catch (Exception e) {
            throw new ResourceException("resourceLoadFailed");
        } finally {
            
        }

        return rpDoc;
	}
	
	/**
     * Removes the resource from persistent storage.
     *
     * @param resource the resource to remove from storage.
     * @throws ResourceException if the resource could not be removed.
     * @see org.act.wsrf.RemoveCallback
     */
    public void remove(Object resource)
        throws ResourceException {
        Class resourceBean = resource.getClass();
        if (!this.beanClass.isAssignableFrom(resourceBean)) {
            throw new IllegalArgumentException("expectedType of parameter");
        }
        try{
        	super.remove(((IResource)resource).getID());
        }catch(Exception e){
        	e.printStackTrace();
        }
    }
	
	public static void main(String[] args)throws Exception {
		long start = System.currentTimeMillis();
		Class clazz = Class.forName("org.act.wsrf.samples.PersistentCounter");		
		XMLPersistenceUtil helper = new XMLPersistenceUtil(clazz);
		
//		Metaset metaset = Metaset.create("E:/temp/conf/text.xml");
//		
//		ResourceProperties rpDoc = new ResourceProperties(metaset.getNamespace(),metaset.getName());
//		rpDoc = SOAPUtil.addChilds(rpDoc,metaset);
//		
//		QName topElementQName = new QName(metaset.getNamespace(),metaset.getName());
		String key = "123";
//		
//		helper.store(key,rpDoc);
		ResourceProperties rpDoc = (ResourceProperties)helper.load(key);
		System.out.println(rpDoc.toDocument());
		
		long escape = System.currentTimeMillis() - start;
		System.out.println("Persistent finished,espense time: " + escape);
	}
}
