package org.act.xservices.rt.xsecurity.dig.algfactory;

import org.act.xservices.rt.xsecurity.dig.algorithm.MD2DigestExe;
import org.act.xservices.rt.xsecurity.dig.algorithm.MD5DigestExe;
import org.act.xservices.rt.xsecurity.dig.algorithm.SHA256DigestExe;
import org.act.xservices.rt.xsecurity.dig.algorithm.SHA384DigestExe;
import org.act.xservices.rt.xsecurity.dig.algorithm.SHA512DigestExe;
import org.act.xservices.rt.xsecurity.dig.algorithm.SHADigestExe;

public class MessageDigestFactory {
	
	
	
	public MessageDigestExe getDigestAlgorithm(String s){
		
		MessageDigestExe digest=null;
		
		if(s.equals("http://www.w3.org/2000/09/xmldsig#sha1")){
			digest=new SHADigestExe();
		}
		else if(s.equals("http://www.w3.org/2000/09/xmldsig#sha256")){
			digest=new SHA256DigestExe();
		}
		else if(s.equals("http://www.w3.org/2000/09/xmldsig#sha384")){
			digest=new SHA384DigestExe();
		}
		else if(s.equals("http://www.w3.org/2000/09/xmldsig#sha512")){
			digest=new SHA512DigestExe();
		}
		else if(s.equals("http://www.w3.org/2000/09/xmldsig#MD2")){
			digest=new MD2DigestExe();
		}
		else if(s.equals("http://www.w3.org/2000/09/xmldsig#MD5")){
			digest=new MD5DigestExe();
		}
		else{
			digest=new SHADigestExe();
		}
		return digest;
	}

}
