package org.act.xservices.rt.xsecurity.enc;

import java.io.IOException;
import java.io.InputStream;
import java.security.Key;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.util.Date;

import javax.crypto.KeyGenerator;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.exception.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class EncryptedData extends EncryptedItem {

	private Metaset mencItem;

	public EncryptedData() {
		super(EncryptedItem.ENCRYPTEDDATA);
	}

	public void setEncData(Metaset encData) {
		this.mencItem = encData;
	}

	public String encrypt(Metaset souceData, Key key, String algName)
			throws NoSuchAlgorithmException, EncryptException {
		// System.out.println(souceData.toFormatXML());

		if (souceData == null) {
			System.out.println("*********************************************");
			System.out.println(souceData.toString());
			System.exit(0);
		}
		String cipher = innerEncrypt(souceData.toXML(), key, algName);
		return cipher;
	}

	public String decrypt(Metaset souceData, String para, Key key,
			String algName) throws NoSuchAlgorithmException, EncryptException,
			CipherDataNotFoundException, DataObjectNotFoundException,
			TransformationException, KeyResolverException, DecryptException {
		if (souceData.filter(".\\" + para
				+ "\\EncryptedData\\CipherData\\CipherValue") != null) {
			Metaset mtBody = souceData.filter(
					".\\" + para + "\\EncryptedData\\CipherData\\CipherValue").car();
			

			String cipher = innerDecrypt(mtBody.getText(), key, algName);

			return cipher;
		} else
			return "";

	}

	/**
	 * ݲKEY
	 * 
	 * @param strKey
	 */
	public Key getKey(String strKey) {

		Key k = null;
		try {
			KeyGenerator _generator = KeyGenerator.getInstance("DES");
			_generator.init(new SecureRandom(strKey.getBytes()));
//			_generator.init(arg0, arg1)
			k = _generator.generateKey();
			_generator = null;
		} catch (Exception e) {
			e.printStackTrace();
		}

		return k;
	}
	
	public Key getKey(String strKey,String algname) {

		Key k = null;
		String symname="";
		try {
			if(algname.equals("http://www.w3.org/2001/04/xmlenc#3des-cbc")){
				symname="DES";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			else if(algname.equals("http://www.w3.org/2001/04/xmlenc#tripledes-cbc")){
				symname="DESede";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			else if(algname.equals("http://www.w3.org/2001/04/xmlenc#aes128-cbc")){
				symname="AES";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(128,new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			else if(algname.equals("http://www.w3.org/2001/04/xmlenc#aes192-cbc")){
				symname="AES";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(192,new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			else if(algname.equals("http://www.w3.org/2001/04/xmlenc#aes256-cbc")){
				symname="AES";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(256,new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			else {
				symname="DES";
				KeyGenerator _generator = KeyGenerator.getInstance(symname);
				_generator.init(new SecureRandom(strKey.getBytes()));
				k = _generator.generateKey();
				_generator = null;
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}

		return k;
	}

	public String filterEncContent(Metaset source, String id) {
		String encStr = source.filter(".\\Body", "id", id).car().toXML();
		return encStr;
	}

}
