package org.act.xservices.rt.xsecurity.enc;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;



import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.enc.algfactory.SymEnc;
import org.act.xservices.rt.xsecurity.enc.algfactory.SymEncFactory;
import org.act.xservices.rt.xsecurity.enc.algorithm.*;
import org.act.xservices.rt.xsecurity.exception.*;

public abstract class EncryptedItem {
	public static int ENCRYPTEDKEY = 1;

	public static int ENCRYPTEDDATA = 2;

	private int mOpType;

	protected Metaset mencItem;

	private SymEncFactory algFactory = new SymEncFactory();

	private String EncAlgName = "";

	public EncryptedItem(int optype) {
		this.mOpType = optype;
		this.mencItem = null;
	}

	protected String innerEncrypt(String data, Key key, String algName)
			throws NoSuchAlgorithmException, EncryptException {
		Metaset encData = this.mencItem;
		SymEnc algMet = createEncAlg(encData, algName);
		if (null == algMet) {
			throw new NoSuchAlgorithmException("no such encryption algorithm");
		}
		String cipher = algMet.encrypt(data, key);
		return cipher;
	}

	protected byte[] innerEncrypt(byte[] data, Key key, String algName)
			throws NoSuchAlgorithmException, EncryptException {
		Metaset encData = this.mencItem;
		SymEnc algMet = createEncAlg(encData, algName);
		if (null == algMet) {
			throw new NoSuchAlgorithmException("no such encryption algorithm");
		}
		byte[] cipher = algMet.encrypt(data, key);
		return cipher;
	}

	protected byte[] innerDecrypt(byte[] data, Key key, String algName)
			throws NoSuchAlgorithmException, CipherDataNotFoundException,
			DataObjectNotFoundException, TransformationException,
			KeyResolverException, DecryptException, InvalidKeyException,
			NoSuchPaddingException, IllegalBlockSizeException,
			BadPaddingException, IOException {
		Metaset encData = this.mencItem;
		SymEnc algMet = createEncAlg(encData, algName);
		if (null == algMet) {
			throw new NoSuchAlgorithmException("no such encryption algorithm");
		}

		return algMet.decrypt(data, key);
	}

	protected String innerDecrypt(String data, Key key, String algName)
			throws NoSuchAlgorithmException, CipherDataNotFoundException,
			DataObjectNotFoundException, TransformationException,
			KeyResolverException, DecryptException {
		Metaset encData = this.mencItem;
		SymEnc algMet = createEncAlg(encData, algName);
		if (null == algMet) {
			throw new NoSuchAlgorithmException("no such encryption algorithm");
		}

		return algMet.decrypt(data, key);
	}

	private SymEnc createEncAlg(Metaset encData, String algName) {
		SymEnc algMet = null;
		algMet = algFactory.createEncryptionMethod(algName);
		return algMet;
	}

	private SymEnc createDecAlg(Metaset encData, String algName) {
		SymEnc algMet = null;
		algMet = algFactory.createEncryptionMethod(algName);
		return algMet;
	}

}
