package org.act.xservices.rt.xsecurity.enc;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;

import org.act.xservices.rt.xsecurity.exception.*;

public class EncryptedKey extends EncryptedItem {
	public EncryptedKey() {
		super(EncryptedItem.ENCRYPTEDKEY);
	}

	public byte[] encrypt(Key keyData, Key key, String algName)
			throws CipherDataNotFoundException, DataObjectNotFoundException,
			NoSuchAlgorithmException, EncryptException {
		final byte[] cipher = innerEncrypt(keyData.getEncoded(), key, algName);
		return cipher;
	}

	public byte[] decrypt(Key key, byte[] keyData, String algName)
			throws CipherDataNotFoundException, DataObjectNotFoundException,
			NoSuchAlgorithmException, TransformationException,
			KeyResolverException, DecryptException, InvalidKeyException,
			NoSuchPaddingException, IllegalBlockSizeException,
			BadPaddingException, IOException {
		final byte[] data = innerDecrypt(keyData, key, algName);
		return data;
	}

}
