package org.act.xservices.rt.xsecurity.enc;

import java.security.Key;
import java.security.KeyPair;

import org.act.xservices.rt.metaset.MetasetBuilder;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.util.tConst;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.CipherData;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.HeadEncKey;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.KeyInfo;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.RefList;


public class XMLEncDataBuilder {
	private String id;

	private String encedData;

	private String symKey;

	private String asymKeyPair;

	/**
	 * @param id
	 * @param str
	 */
	public XMLEncDataBuilder(String str) {
		encedData = str;
	}

	/**
	 * @param id2
	 * @param str
	 * @param symKey
	 * @param asymKeyPair
	 */
	public XMLEncDataBuilder(String symKey, String asymKeyPair) {
		super();
		this.symKey = symKey;
		this.asymKeyPair = asymKeyPair;

	}

	public Metaset buildhead(String id1, String id2, String algName,
			String asymKey) {
		QName Securityq = new QName(
				"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd",
				"Security", "wsse");
		Metaset mt = MetasetBuilder.getInstance().newMetaset(Securityq);
		HeadEncKey encryptedKey = new HeadEncKey();

		QName qEncryptionMethod = new QName(
				"http://www.w3.org/2001/04/xmlenc#", "EncryptionMethod", "xenc");
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		Metaset EncryptionMethod = MetasetBuilder.getInstance().newMetaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// Cons.rsa));
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"), algName));
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(new QName("Algorithm"), algName));
		
		KeyInfo keyInfo = new KeyInfo("asymKeyPair", asymKeyPair);

		CipherData cipherData = new CipherData(symKey);

		RefList rList = new RefList();
		Metaset referenceList1 = rList.addDataReference(id1, id2);

		encryptedKey.addChild(EncryptionMethod);
		encryptedKey.addChild(keyInfo.getKeyInfo());
		encryptedKey.addChild(cipherData.getCipherData());
		encryptedKey.addChild(referenceList1);

		mt.add(encryptedKey.getEncryptedKey());

		return mt;
	}
	
	public Metaset buildhead(String id1, String algName) {
		Metaset mt = MetasetBuilder.getInstance()
				.newMetaset(
						"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wsswssecurity-secext-1.0.xsd",
						"Security", "wsse");

		HeadEncKey encryptedKey = new HeadEncKey();

		QName qEncryptionMethod = new QName(
				"http://www.w3.org/2001/04/xmlenc#", "EncryptionMethod", "xenc");
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		Metaset EncryptionMethod = MetasetBuilder.getInstance().newMetaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// Cons.rsa));
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"), algName));
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(new QName(
				"Algorithm"), algName));
		// System.out.println("abcdefghjklouhhh\n"+EncryptionMethod.toFormatXML());

		KeyInfo keyInfo = new KeyInfo("asymKeyPair", asymKeyPair);

		CipherData cipherData = new CipherData(symKey);

		RefList rList = new RefList();
		Metaset referenceList1 = rList.addDataReference(id1);

		encryptedKey.addChild(EncryptionMethod);
		encryptedKey.addChild(keyInfo.getKeyInfo());
		encryptedKey.addChild(cipherData.getCipherData());
		encryptedKey.addChild(referenceList1);

		mt.add(encryptedKey.getEncryptedKey());

		return mt;
	}
	
	

	public Metaset buildhead(String id1, String id2, String algName) {
		Metaset mt = MetasetBuilder.getInstance().newMetaset(
						"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wsswssecurity-secext-1.0.xsd",
						"Security", "wsse");

		HeadEncKey encryptedKey = new HeadEncKey();

		QName qEncryptionMethod = new QName(
				"http://www.w3.org/2001/04/xmlenc#", "EncryptionMethod", "xenc");
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		Metaset EncryptionMethod = MetasetBuilder.getInstance().newMetaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// Cons.rsa));
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"), algName));
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(new QName(
				"Algorithm"), algName));
		// System.out.println("abcdefghjklouhhh\n"+EncryptionMethod.toFormatXML());

		KeyInfo keyInfo = new KeyInfo("asymKeyPair", asymKeyPair);

		CipherData cipherData = new CipherData(symKey);

		RefList rList = new RefList();
		Metaset referenceList1 = rList.addDataReference(id1, id2);

		encryptedKey.addChild(EncryptionMethod);
		encryptedKey.addChild(keyInfo.getKeyInfo());
		encryptedKey.addChild(cipherData.getCipherData());
		encryptedKey.addChild(referenceList1);

		mt.add(encryptedKey.getEncryptedKey());

		return mt;
	}

	public Metaset buildEncryptedData() {
		QName qCipherValue = new QName("CipherValue");
		QName qCipherData = new QName("CipherData");
		QName qEncryptionMethod = new QName("EncryptionMethod");
		QName qEncryptedData = new QName("EncryptedData");

		// Metaset CipherValue = new Metaset(qCipherValue);
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// tConst.des));
		// Metaset CipherData = new Metaset(qCipherData);
		// Metaset EncryptedData = new Metaset(qEncryptedData);
		// Attribute attribute = new Attribute(new QName("id"), this.id);

		// MetasetBuilderImpl CipherValuebuilder = new MetasetBuilderImpl();
		// MetasetImpl CipherValue = (MetasetImpl)
		// CipherValuebuilder.newMetaset(qCipherValue);
		Metaset CipherValue = MetasetBuilder.getInstance().newMetaset(qCipherValue);

		Metaset EncryptionMethod = MetasetBuilder.getInstance()
				.newMetaset(qEncryptionMethod);
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(
				new QName("Algorithm"), tConst.des));
		Metaset CipherData = MetasetBuilder.getInstance().newMetaset(qCipherData);
		Metaset EncryptedData = MetasetBuilder.getInstance().newMetaset(qEncryptedData);
		Attribute attribute = MetasetBuilder.getInstance().newAttribute(new QName("id"),
				this.id);
		EncryptedData.add(attribute);

		CipherValue.setText(encedData);
		CipherData.add(EncryptionMethod);
		CipherData.add(CipherValue);
		EncryptedData.add(CipherData);

		return EncryptedData;
	}

	public Metaset buildEncryptedData(String iid, String eencedData) {
		QName qCipherValue = new QName("www.w3.org/2001/04/xmlenc#",
				"CipherValue", "xenc");
		QName qCipherData = new QName("www.w3.org/2001/04/xmlenc#",
				"CipherData", "xenc");
		QName qEncryptionMethod = new QName("www.w3.org/2001/04/xmlenc#",
				"EncryptionMethod", "xenc");
		QName qEncryptedData = new QName("www.w3.org/2001/04/xmlenc#",
				"EncryptedData", "xenc");

		// Metaset CipherValue = new Metaset(qCipherValue);
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// tConst.des));
		// Metaset CipherData = new Metaset(qCipherData);
		// Metaset EncryptedData = new Metaset(qEncryptedData);
		// Attribute attribute = new Attribute(new QName("id"), iid);
		// EncryptedData.add(attribute);

		// MetasetBuilderImpl CipherValuebuilder = new MetasetBuilderImpl();
		// MetasetImpl CipherValue = (MetasetImpl)
		// CipherValuebuilder.newMetaset(qCipherValue);
		Metaset CipherValue = MetasetBuilder.getInstance().newMetaset(qCipherValue);

		Metaset EncryptionMethod = MetasetBuilder.getInstance()
				.newMetaset(qEncryptionMethod);
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(
				new QName("Algorithm"), tConst.des));
		Metaset CipherData = MetasetBuilder.getInstance().newMetaset(qCipherData);
		Metaset EncryptedData = MetasetBuilder.getInstance().newMetaset(qEncryptedData);
		Attribute attribute = MetasetBuilder.getInstance().newAttribute(new QName("id"),
				this.id);
		EncryptedData.add(attribute);

		CipherValue.setText(eencedData);
		CipherData.add(EncryptionMethod);
		CipherData.add(CipherValue);
		EncryptedData.add(CipherData);

		return EncryptedData;
	}
	
	public Metaset buildEncryptedData(String iid, String eencedData,String syname) {
		QName qCipherValue = new QName("www.w3.org/2001/04/xmlenc#",
				"CipherValue", "xenc");
		QName qCipherData = new QName("www.w3.org/2001/04/xmlenc#",
				"CipherData", "xenc");
		QName qEncryptionMethod = new QName("www.w3.org/2001/04/xmlenc#",
				"EncryptionMethod", "xenc");
		QName qEncryptedData = new QName("www.w3.org/2001/04/xmlenc#",
				"EncryptedData", "xenc");

		// Metaset CipherValue = new Metaset(qCipherValue);
		// Metaset EncryptionMethod = new Metaset(qEncryptionMethod);
		// EncryptionMethod.add(new Attribute(new QName("Algorithm"),
		// tConst.des));
		// Metaset CipherData = new Metaset(qCipherData);
		// Metaset EncryptedData = new Metaset(qEncryptedData);
		// Attribute attribute = new Attribute(new QName("id"), iid);
		// EncryptedData.add(attribute);

		// MetasetBuilderImpl CipherValuebuilder = new MetasetBuilderImpl();
		// MetasetImpl CipherValue = (MetasetImpl)
		// CipherValuebuilder.newMetaset(qCipherValue);
		Metaset CipherValue = MetasetBuilder.getInstance().newMetaset(qCipherValue);

		Metaset EncryptionMethod = MetasetBuilder.getInstance()
				.newMetaset(qEncryptionMethod);
		EncryptionMethod.add(MetasetBuilder.getInstance().newAttribute(
				new QName("Algorithm"), syname));
		Metaset CipherData = MetasetBuilder.getInstance().newMetaset(qCipherData);
		Metaset EncryptedData = MetasetBuilder.getInstance().newMetaset(qEncryptedData);
		Attribute attribute = MetasetBuilder.getInstance().newAttribute(new QName("id"),
				iid);
		EncryptedData.add(attribute);

		CipherValue.setText(eencedData);
		CipherData.add(EncryptionMethod);
		CipherData.add(CipherValue);
		EncryptedData.add(CipherData);

		return EncryptedData;
	}

	public static void main(String[] args) throws Exception {
		// EncDataBuilder edb = new EncDataBuilder("d");
		// MetaPrint.pXML(edb.build());
	}

}
