
package org.act.xservices.rt.xsecurity.enc.algorithm;


import java.security.*;
import java.security.spec.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

import org.act.xservices.rt.xsecurity.enc.algfactory.AsymDec;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEnc;




import sun.misc.BASE64Encoder;

import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.interfaces.*;
import java.math.*;
import java.io.*;

public class RSA_Enc implements AsymEnc
{
	
	public static String encpub(String str, String asymKey) throws Exception
	{

		String s = str;

//		FileInputStream f = new FileInputStream(asymKey);
//		ObjectInputStream b = new ObjectInputStream(f);
//		RSAPublicKey pbk = (RSAPublicKey) b.readObject();
		
		CertificateFactory certFactory=CertificateFactory.getInstance("X.509");
		FileInputStream fis=new FileInputStream(asymKey);
		Certificate cert=(Certificate) certFactory.generateCertificate(fis);
		RSAPublicKey pbk = (RSAPublicKey) cert.getPublicKey();

		BigInteger e = pbk.getPublicExponent();
		BigInteger n = pbk.getModulus();

		byte ptext[] = s.getBytes("UTF8");
		BigInteger m = new BigInteger(ptext);

		BigInteger c = m.modPow(e, n);

		BASE64Encoder base64en = new BASE64Encoder();
		String cs = c.toString();
		byte csb[] = cs.getBytes();
		String strMi = base64en.encode(csb);
		
		return strMi;
	}

	public static String encpri(String str, String asymKey) throws Exception
	{

		
		
		
		String s = str;

		FileInputStream f = new FileInputStream(asymKey);
		ObjectInputStream b = new ObjectInputStream(f);
		RSAPrivateKey pbk = (RSAPrivateKey) b.readObject();

		BigInteger e = pbk.getPrivateExponent();
		BigInteger n = pbk.getModulus();

		byte ptext[] = s.getBytes("UTF8");
		BigInteger m = new BigInteger(ptext);

		BigInteger c = m.modPow(e, n);

		return c.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.sec.enc.algfactory.AsymDec#encWithPri(java.lang.String,
	 *      java.lang.String)
	 */
	public String encWithPri(String s, String key)
	{

		FileInputStream f;
		try
		{
			f = new FileInputStream(key);
			ObjectInputStream b;
			try
			{
				b = new ObjectInputStream(f);
				RSAPrivateKey pbk;
				try
				{
					pbk = (RSAPrivateKey) b.readObject();
					BigInteger e = pbk.getPrivateExponent();
					BigInteger n = pbk.getModulus();

					byte ptext[] = s.getBytes("UTF8");
					BigInteger m = new BigInteger(ptext);

					BigInteger c = m.modPow(e, n);
					BASE64Encoder base64en = new BASE64Encoder();
					String cs = c.toString();
					byte csb[] = cs.getBytes();
					String strMi = base64en.encode(csb);
					return strMi;
				} catch (ClassNotFoundException e1)
				{
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}

				
			} catch (IOException e1)
			{
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
		} catch (FileNotFoundException e1)
		{
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		return null;
		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.sec.enc.algfactory.AsymDec#encWithPub(java.lang.String,
	 *      java.lang.String)
	 */
	public String encWithPub(String s, String key)
	{
       String asymKey = key;
		FileInputStream f;
		
			
			try
			{
				
				try
				{
					    CertificateFactory certFactory;
					
						certFactory = CertificateFactory.getInstance("X.509");
						FileInputStream fis=new FileInputStream(asymKey);
						Certificate cert=certFactory.generateCertificate(fis);
						RSAPublicKey pbk = (RSAPublicKey) cert.getPublicKey();
						BigInteger e = pbk.getPublicExponent();
						BigInteger n = pbk.getModulus();
						
						byte ptext[] = s.getBytes("UTF8");
						BigInteger m = new BigInteger(ptext);

						BigInteger c = m.modPow(e, n);
						BASE64Encoder base64en = new BASE64Encoder();
						String cs = c.toString();
						byte csb[] = cs.getBytes();
						String strMi = base64en.encode(csb);
						return strMi;
					} catch (CertificateException e1)
					{
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					

					
				
			} catch (IOException e1)
			{
				return "";
			}
			
		return null;
		

		
	}

	/* (non-Javadoc)
	 * @see org.act.sec.enc.algfactory.AsymEnc#encWithPri(java.lang.String, java.lang.String, java.lang.String)
	 */
	public String encWithPri(String s, String key, String psw)
	{
		FileInputStream input;
		try
		{
			input = new FileInputStream(key);
			KeyStore keyStore=KeyStore.getInstance("JKS");
			
			keyStore.load(input,psw.toCharArray());  //Կ
			input.close();
			PrivateKey pbk=(PrivateKey)keyStore.getKey("server",psw.toCharArray()); //CA֤ ֤
			
			BigInteger e = ((RSAPrivateKey) pbk).getPrivateExponent();
			BigInteger n = ((RSAKey) pbk).getModulus();

			byte ptext[] = s.getBytes("UTF8");
			BigInteger m = new BigInteger(ptext);

			BigInteger c = m.modPow(e, n);
			BASE64Encoder base64en = new BASE64Encoder();
			String cs = c.toString();
			byte csb[] = cs.getBytes();
			String strMi = base64en.encode(csb);
			return strMi;
			
		} catch (FileNotFoundException e1)
		{
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}//Կ
 catch (KeyStoreException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e)
{
	// TODO Auto-generated catch block
	e.printStackTrace();
} catch (CertificateException e)
{
	// TODO Auto-generated catch block
	e.printStackTrace();
} catch (IOException e)
{
	// TODO Auto-generated catch block
	e.printStackTrace();
} catch (UnrecoverableKeyException e)
{
	// TODO Auto-generated catch block
	e.printStackTrace();
}
		return psw;
		
	   
	}
}
