package org.act.xservices.rt.xsecurity.handler;

import java.security.Key;
import java.security.KeyPair;
import java.util.Date;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xsecurity.enc.XMLEncDataBuilder;
import org.act.xservices.rt.xsecurity.enc.XMLEncoder;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEnc;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEncFactory;
import org.act.xservices.rt.xsecurity.enc.algorithm.RSA_Enc;
import org.act.xservices.rt.xsecurity.util.tConst;

public class EncHandler {
	private String str4SymKey;

	private String str4ASymKey;

	private Key symKey;

	private KeyPair asymKeyPair;

	private String encedStr4SymKey;

	private String asymKey;

	private String SyAlgorithm;

	private String data2enc;

	Metaset soapMt = MetasetBuilder.getInstance().newMetaset();

	private String data2Sign;

	private String algName; // 㷨

	public EncHandler(String asymKey) {
		super();
		this.asymKey = asymKey;
	}

	public EncHandler() {
		super();
	}

	public void init(String algname, String asymkey, String syalgorithm) {

		this.algName = algname;
		this.asymKey = asymkey;
		this.SyAlgorithm = syalgorithm;

	}

	public void init(String algname, String asymkey, String syalgorithm,
			String encdata) {

		this.algName = algname;
		this.asymKey = asymkey;
		this.SyAlgorithm = syalgorithm;
		this.data2enc = encdata;

	}

	// ӷWSDLĲȡ㷨Կ
	public void init(Metaset wsdl, Metaset wsdd) {
		try {
			this.algName = wsdl.filter(tConst.enc_algName).car().getText();
		} catch (Exception e) {
			this.algName = "http://www.w3.org/2000/09/xmldsig#rsa";
		}
		try {
			this.asymKey = tConst.fod
					+ wsdl.filter(tConst.enc_asymKey).car().getText() + ".cer";
		} catch (Exception e) {
			this.asymKey = tConst.fod + "server.cer";
		}

		this.SyAlgorithm = "http://www.w3.org/2001/04/xmlenc#3des-cbc";
	}

	public Metaset process(Metaset soap) throws Exception {

		// str4SymKey =
		// "AA12345dddddddddddddddddddddddddddddddddddddddddddddddddddddddd";
		str4SymKey = getRandKeys(24);
//		System.out.println("~~~~~~~~~~~~~~~~~\n" + str4SymKey);
		Bridge bridge = new Bridge();
		// ַstr4AsymKeyһԳԿ

		Key symKey = bridge.creatSymKey(str4SymKey, this.SyAlgorithm); // ----------------

		// KeyPair asymKeyPair = bridge.creatASymKey(); //----------------

		

		if (this.data2enc == null) {
			// System.out.println("zenghaozhenghaozenghao\n"+soapMt.toFormatXML());

			// //ַstr4SymKeyһԳԿ
			// symKey = bridge.creatSymKey(str4SymKey);

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			// ʹöԳԿsymKeySoapsoap
			// ֵ
			XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
					this.SyAlgorithm);
			String encedContent = se.EncExecuteAction();
			// ñxmlid
			String id1 = se.getId();
			// System.out.println("Id1::"+id1);

			// ʹöԳԿsymKeySoapsoapͷ
			// ֵ
			XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
					this.SyAlgorithm);
			String encedContent2 = xmlEncoder.EncExecuteAction();
			// ñxmlid
			String id2 = xmlEncoder.getId();
			// System.out.println("Id2:::"+id2);

			// ܺSoapͷSoap
			XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
					encedStr4SymKey, asymKey);
			Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
					encedContent, this.SyAlgorithm);
			Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
					encedContent2, this.SyAlgorithm);

			Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
			// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

			// ԭsoapBodyǩ
			// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
			// id="#xiaoshan">
			Metaset hdbodyMt = (Metaset) soap.elements().get(1);
			hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
			hdbodyMt.add(bodyMt);

			// ԭsoapHeaderǩ
			// hdMt--<S:Header> </S:Header>

			while (soap.filter(".\\Header").car().elements().size() > 0) {
				for (int i = 0; i < soap.filter(".\\Header").car().elements()
						.size(); i++) {
					soap.car().removeChildren(
							soap.filter(".\\Header").car().elements().get(i));
				}
			}

			// for (int i = 0; i <
			// soap.filter(".\\Header").car().getChilds().size(); i++) {
			// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
			// }
			// soap.car().remove(soap.filter(".\\Header").car());
			Metaset hdMt = soap.car();

			// headMt1soapͷϢ
			// headMt2

			hdMt.add(headMt1);
			hdMt.add(headMt2);

			// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
			soap.add(MetasetBuilder.getInstance().newAttribute("xmlns:xenc",
					"http://www.w3.org/2001/04/xmlenc#"));
			soap
					.add(MetasetBuilder
							.getInstance()
							.newAttribute(
									"xmlns:wsse",
									"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

		} else {

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			if (this.data2enc.equals("Body")) {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				String id1 = se.getId();
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent);
				Metaset headMt2 = encDataBuilder.buildhead(id1, algName);
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else if (this.data2enc.equals("Header")) {
				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
						this.SyAlgorithm);
				String encedContent2 = xmlEncoder.EncExecuteAction();
				// ñxmlid
				String id2 = xmlEncoder.getId();
				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);

				Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
						encedContent2, this.SyAlgorithm);

				Metaset headMt2 = encDataBuilder.buildhead(id2, algName);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt1);
				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				// ñxmlid
				String id1 = se.getId();
				// System.out.println("Id1::"+id1);

				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				// XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey,
				// "Header",
				// this.SyAlgorithm);
				// String encedContent2 = xmlEncoder.EncExecuteAction();
				// // ñxmlid
				// String id2 = xmlEncoder.getId();
				// System.out.println("Id2:::"+id2);

				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent, this.SyAlgorithm);
				// Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
				// encedContent2,this.SyAlgorithm);

				Metaset headMt2 = encDataBuilder.buildhead(id1, algName);
				// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

				// ԭsoapBodyǩ
				// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
				// id="#xiaoshan">
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				// hdMt.addChildren(headMt1);
				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			}

		}

		return soap;

	}

	public Metaset process(Metaset soapHeadMt, Metaset soapBodyMt,
			QName soapname) throws Exception {

		// str4SymKey =
		// "AA12345dddddddddddddddddddddddddddddddddddddddddddddddddddddddd";
		str4SymKey = getRandKeys(24);
//		System.out.println("~~~~~~~~~~~~~~~~~\n" + str4SymKey);
		Bridge bridge = new Bridge();
		// ַstr4AsymKeyһԳԿ

		Key symKey = bridge.creatSymKey(str4SymKey, this.SyAlgorithm); // ----------------

		// KeyPair asymKeyPair = bridge.creatASymKey(); //----------------

		Metaset soap = reConsSoap(soapHeadMt, soapBodyMt, soapname);
		soapMt = soap;

		if (this.data2enc == null) {
			// System.out.println("zenghaozhenghaozenghao\n"+soapMt.toFormatXML());

			// //ַstr4SymKeyһԳԿ
			// symKey = bridge.creatSymKey(str4SymKey);

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			// ʹöԳԿsymKeySoapsoap
			// ֵ
			XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
					this.SyAlgorithm);
			String encedContent = se.EncExecuteAction();
			// ñxmlid
			String id1 = se.getId();
			// System.out.println("Id1::"+id1);

			// ʹöԳԿsymKeySoapsoapͷ
			// ֵ
			XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
					this.SyAlgorithm);
			String encedContent2 = xmlEncoder.EncExecuteAction();
			// ñxmlid
			String id2 = xmlEncoder.getId();
			// System.out.println("Id2:::"+id2);

			// ܺSoapͷSoap
			XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
					encedStr4SymKey, asymKey);
			Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
					encedContent, this.SyAlgorithm);
			Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
					encedContent2, this.SyAlgorithm);

			Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
			// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

			// ԭsoapBodyǩ
			// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
			// id="#xiaoshan">
			Metaset hdbodyMt = (Metaset) soap.elements().get(1);
			hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
			hdbodyMt.add(bodyMt);

			// ԭsoapHeaderǩ
			// hdMt--<S:Header> </S:Header>

			while (soap.filter(".\\Header").car().elements().size() > 0) {
				for (int i = 0; i < soap.filter(".\\Header").car().elements()
						.size(); i++) {
					soap.car().removeChildren(
							soap.filter(".\\Header").car().elements().get(i));
				}
			}

			// for (int i = 0; i <
			// soap.filter(".\\Header").car().getChilds().size(); i++) {
			// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
			// }
			// soap.car().remove(soap.filter(".\\Header").car());
			Metaset hdMt = soap.car();

			// headMt1soapͷϢ
			// headMt2

			hdMt.add(headMt1);
			hdMt.add(headMt2);

			// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
			soap.add(MetasetBuilder.getInstance().newAttribute("xmlns:xenc",
					"http://www.w3.org/2001/04/xmlenc#"));
			soap
					.add(MetasetBuilder
							.getInstance()
							.newAttribute(
									"xmlns:wsse",
									"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

		} else {

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			if (this.data2enc.equals("Body")) {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				String id1 = se.getId();
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent);
				Metaset headMt2 = encDataBuilder.buildhead(id1, algName);
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else if (this.data2enc.equals("Header")) {
				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
						this.SyAlgorithm);
				String encedContent2 = xmlEncoder.EncExecuteAction();
				// ñxmlid
				String id2 = xmlEncoder.getId();
				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);

				Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
						encedContent2, this.SyAlgorithm);

				Metaset headMt2 = encDataBuilder.buildhead(id2, algName);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt1);
				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				// ñxmlid
				String id1 = se.getId();
				// System.out.println("Id1::"+id1);

				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				// XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey,
				// "Header",
				// this.SyAlgorithm);
				// String encedContent2 = xmlEncoder.EncExecuteAction();
				// // ñxmlid
				// String id2 = xmlEncoder.getId();
				// System.out.println("Id2:::"+id2);

				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent, this.SyAlgorithm);
				// Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
				// encedContent2,this.SyAlgorithm);

				Metaset headMt2 = encDataBuilder.buildhead(id1, algName);
				// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

				// ԭsoapBodyǩ
				// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
				// id="#xiaoshan">
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				// hdMt.addChildren(headMt1);
				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			}

		}

		
		return soap;

	}

	public Metaset process(Metaset soapHeadMt, Metaset soapBodyMt)
			throws Exception {

		// str4SymKey = "aadd";
		str4SymKey = getRandKeys(8);

		Bridge bridge = new Bridge();
		// ַstr4AsymKeyһԳԿ

		Key symKey = bridge.creatSymKey(str4SymKey); // ----------------

		// KeyPair asymKeyPair = bridge.creatASymKey(); //----------------

		Metaset soap = reConsSoap(soapHeadMt, soapBodyMt);
		soapMt = soap;

		if (this.data2enc == null) {
			// System.out.println("zenghaozhenghaozenghao\n"+soapMt.toFormatXML());

			// //ַstr4SymKeyһԳԿ
			// symKey = bridge.creatSymKey(str4SymKey);

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			// ʹöԳԿsymKeySoapsoap
			// ֵ
			XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
					this.SyAlgorithm);
			String encedContent = se.EncExecuteAction();
			// ñxmlid
			String id1 = se.getId();
			// System.out.println("Id1::"+id1);

			// ʹöԳԿsymKeySoapsoapͷ
			// ֵ
			XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
					this.SyAlgorithm);
			String encedContent2 = xmlEncoder.EncExecuteAction();
			// ñxmlid
			String id2 = xmlEncoder.getId();
			// System.out.println("Id2:::"+id2);

			// ܺSoapͷSoap
			XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
					encedStr4SymKey, asymKey);
			Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
					encedContent);
			Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
					encedContent2);

			Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
			// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

			// ԭsoapBodyǩ
			// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
			// id="#xiaoshan">
			Metaset hdbodyMt = (Metaset) soap.elements().get(1);
			hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
			hdbodyMt.add(bodyMt);

			// ԭsoapHeaderǩ
			// hdMt--<S:Header> </S:Header>

			while (soap.filter(".\\Header").car().elements().size() > 0) {
				for (int i = 0; i < soap.filter(".\\Header").car().elements()
						.size(); i++) {
					soap.car().removeChildren(
							soap.filter(".\\Header").car().elements().get(i));
				}
			}

			// for (int i = 0; i <
			// soap.filter(".\\Header").car().getChilds().size(); i++) {
			// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
			// }
			// soap.car().remove(soap.filter(".\\Header").car());
			Metaset hdMt = soap.car();

			// headMt1soapͷϢ
			// headMt2

			hdMt.add(headMt1);
			hdMt.add(headMt2);

			// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
			soap.add(MetasetBuilder.getInstance().newAttribute("xmlns:xenc",
					"http://www.w3.org/2001/04/xmlenc#"));
			soap
					.add(MetasetBuilder
							.getInstance()
							.newAttribute(
									"xmlns:wsse",
									"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

		} else {

			// ʹ÷ǶԳƼܣstr4SymKey
			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			encedStr4SymKey = asymEnc.encWithPub(str4SymKey, asymKey);

			if (this.data2enc.equals("Body")) {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				String id1 = se.getId();
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent);
				Metaset headMt2 = encDataBuilder.buildhead(id1, algName);
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt2);

				// MetasetBuilder mtabuilder = new MetasetBuilderImpl();
				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else if (this.data2enc.equals("Header")) {
				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
						this.SyAlgorithm);
				String encedContent2 = xmlEncoder.EncExecuteAction();
				// ñxmlid
				String id2 = xmlEncoder.getId();
				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);

				Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
						encedContent2);

				Metaset headMt2 = encDataBuilder.buildhead(id2, algName);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt1);
				hdMt.add(headMt2);

				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			} else {
				// ʹöԳԿsymKeySoapsoap
				// ֵ
				XMLEncoder se = new XMLEncoder(soap, symKey, "Body",
						this.SyAlgorithm);
				String encedContent = se.EncExecuteAction();
				// ñxmlid
				String id1 = se.getId();
				// System.out.println("Id1::"+id1);

				// ʹöԳԿsymKeySoapsoapͷ
				// ֵ
				XMLEncoder xmlEncoder = new XMLEncoder(soap, symKey, "Header",
						this.SyAlgorithm);
				String encedContent2 = xmlEncoder.EncExecuteAction();
				// ñxmlid
				String id2 = xmlEncoder.getId();
				// System.out.println("Id2:::"+id2);

				// ܺSoapͷSoap
				XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
						encedStr4SymKey, asymKey);
				Metaset bodyMt = encDataBuilder.buildEncryptedData(id1,
						encedContent);
				Metaset headMt1 = encDataBuilder.buildEncryptedData(id2,
						encedContent2);

				Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
				// System.out.println("zenghaozhenghaozhenghaoznehnghaongdhgasd\n"+headMt2.toFormatXML());

				// ԭsoapBodyǩ
				// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
				// id="#xiaoshan">
				Metaset hdbodyMt = (Metaset) soap.elements().get(1);
				hdbodyMt.removeChildren(soap.filter(".\\Body").car().car());
				hdbodyMt.add(bodyMt);

				// ԭsoapHeaderǩ
				// hdMt--<S:Header> </S:Header>

				while (soap.filter(".\\Header").car().elements().size() > 0) {
					for (int i = 0; i < soap.filter(".\\Header").car()
							.elements().size(); i++) {
						soap.car().removeChildren(
								soap.filter(".\\Header").car().elements()
										.get(i));
					}
				}

				// for (int i = 0; i <
				// soap.filter(".\\Header").car().getChilds().size(); i++) {
				// soap.car().remove((Metaset)soap.filter(".\\Header").car().getChilds().get(i));
				// }
				// soap.car().remove(soap.filter(".\\Header").car());
				Metaset hdMt = soap.car();

				// headMt1soapͷϢ
				// headMt2

				hdMt.add(headMt1);
				hdMt.add(headMt2);

				soap.add(MetasetBuilder.getInstance().newAttribute(
						"xmlns:xenc", "http://www.w3.org/2001/04/xmlenc#"));
				soap
						.add(MetasetBuilder
								.getInstance()
								.newAttribute(
										"xmlns:wsse",
										"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));

			}

		}

		return soap;

	}

//	public Metaset process(Metaset soapMt) throws Exception {
//		Bridge bridge = new Bridge();
//		// ַstr4SymKeyһԳԿ
//		symKey = bridge.creatSymKey(str4SymKey);
//
//		// ʹ÷ǶԳƼܣstr4SymKey
//		encedStr4SymKey = RSA_Enc.encpub(str4SymKey, asymKey);
//
//		// ʹöԳԿsymKeySoapsoap
//		// ֵ
//		XMLEncoder se = new XMLEncoder(soapMt, symKey, "Body", this.SyAlgorithm);
//		String encedContent = se.EncExecuteAction();
//		// ñxmlid
//		String id1 = se.getId();
//
//		// ʹöԳԿsymKeySoapsoapͷ
//		// ֵ
//		XMLEncoder xmlEncoder = new XMLEncoder(soapMt, symKey, "Header",
//				this.SyAlgorithm);
//		String encedContent2 = xmlEncoder.EncExecuteAction();
//		// ñxmlid
//		String id2 = xmlEncoder.getId();
//
//		// ܺSoapͷSoap
//		XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
//				encedStr4SymKey, asymKey);
//		Metaset bodyMt = encDataBuilder.buildEncryptedData(id1, encedContent);
//		Metaset headMt1 = encDataBuilder.buildEncryptedData(id2, encedContent2);
//		Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
//
//		// ԭsoapBodyǩ
//		// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
//		// id="#xiaoshan">
//		Metaset hdbodyMt = (Metaset) soapMt.elements().get(1);
//		hdbodyMt.removeChildren(soapMt.filter(".\\Body").car().car());
//		hdbodyMt.add(bodyMt);
//
//		// ԭsoapHeaderǩ
//		// hdMt--<S:Header> </S:Header>
//		soapMt.car().removeChildren(soapMt.filter(".\\Header").car().car());
//		Metaset hdMt = soapMt.car();
//		// headMt1soapͷϢ
//		// headMt2
//		hdMt.add(headMt1);
//		hdMt.add(headMt2);
//
//		return soapMt;
//	}
//
//	public Metaset process() throws Exception {
//		Bridge bridge = new Bridge();
//		// ַstr4SymKeyһԳԿ
//		symKey = bridge.creatSymKey(str4SymKey);
//
//		// ʹ÷ǶԳƼܣstr4SymKey
//		encedStr4SymKey = RSA_Enc.encpub(str4SymKey, asymKey);
//
//		// ʹöԳԿsymKeySoapsoap
//		// ֵ
//		XMLEncoder se = new XMLEncoder(soapMt, symKey, "Body", this.SyAlgorithm);
//		String encedContent = se.EncExecuteAction();
//		// ñxmlid
//		String id1 = se.getId();
//
//		// ʹöԳԿsymKeySoapsoapͷ
//		// ֵ
//		XMLEncoder xmlEncoder = new XMLEncoder(soapMt, symKey, "Header",
//				this.SyAlgorithm);
//		String encedContent2 = xmlEncoder.EncExecuteAction();
//		// ñxmlid
//		String id2 = xmlEncoder.getId();
//
//		// ܺSoapͷSoap
//		XMLEncDataBuilder encDataBuilder = new XMLEncDataBuilder(
//				encedStr4SymKey, "k1");
//		Metaset bodyMt = encDataBuilder.buildEncryptedData(id1, encedContent);
//		Metaset headMt1 = encDataBuilder.buildEncryptedData(id2, encedContent2);
//		Metaset headMt2 = encDataBuilder.buildhead(id1, id2, algName);
//
//		// ԭsoapBodyǩ
//		// hdbodyMt--<SOAP-ENV:Body id="#xiaoshan"> </SOAP-ENV:Body
//		// id="#xiaoshan">
//		Metaset hdbodyMt = (Metaset) soapMt.elements().get(1);
//		hdbodyMt.removeChildren(soapMt.filter(".\\Body").car().car());
//		hdbodyMt.add(bodyMt);
//
//		// ԭsoapHeaderǩ
//		// hdMt--<S:Header> </S:Header>
//		soapMt.car().removeChildren(soapMt.filter(".\\Header").car().car());
//		Metaset hdMt = soapMt.car();
//		// headMt1soapͷϢ
//		// headMt2
//		hdMt.add(headMt1);
//		hdMt.add(headMt2);
//
//		return soapMt;
//	}

	/**
	 * @return the asymKeyPair
	 */
	public KeyPair getAsymKeyPair() {
		return asymKeyPair;
	}

	/**
	 * @param asymKeyPair
	 *            the asymKeyPair to set
	 */
	public void setAsymKeyPair(KeyPair asymKeyPair) {
		this.asymKeyPair = asymKeyPair;
	}

	/**
	 * @return the symKey
	 */
	public Key getSymKey() {
		return symKey;
	}

	/**
	 * @param symKey
	 *            the symKey to set
	 */
	public void setSymKey(Key symKey) {
		this.symKey = symKey;
	}

	/**
	 * @return the symKeyEnced
	 */

	/**
	 * @return the str4SymKey
	 */
	public String getstr4SymKey() {
		return str4SymKey;
	}

	/**
	 * @param str4SymKey
	 *            the str4SymKey to set
	 */
	public void setstr4SymKey(String str4SymKey) {
		this.str4SymKey = str4SymKey;
	}

	/**
	 * @return the str4ASymKey
	 */
	public String getStr4ASymKey() {
		return str4ASymKey;
	}

	/**
	 * @param str4ASymKey
	 *            the str4ASymKey to set
	 */
	public void setStr4ASymKey(String str4ASymKey) {
		this.str4ASymKey = str4ASymKey;
	}

	/**
	 * @return the encedStr4SymKey
	 */
	public String getEncedStr4SymKey() {
		return encedStr4SymKey;
	}

	/**
	 * @param encedStr4SymKey
	 *            the encedStr4SymKey to set
	 */
	public void setEncedStr4SymKey(String encedStr4SymKey) {
		this.encedStr4SymKey = encedStr4SymKey;
	}

	public Metaset reConsSoap(Metaset soapHeadMt, Metaset soapBodyMt) {
		QName rpQName = new QName("Header");
		QName rpQName2 = new QName("Body");

		Metaset soap = MetasetBuilder.getInstance().newMetaset("Envelope");

		soap.add(MetasetBuilder.getInstance().newAttribute("xmlns",
				"http://schemas.xmlsoap.org/soap/envelope/"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://www.w3.org/2001/XMLSchema-instance", "xsi",
						"xmlns"), "http://www.w3.org/2001/XMLSchema-instance"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://www.w3.org/2001/XMLSchema", "xsd", "xmlns"),
				"http://www.w3.org/2001/XMLSchema"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://schemas.xmlsoap.org/soap/encoding/",
						"soapenc", "xmlns"),
				"http://schemas.xmlsoap.org/soap/encoding/"));

		// Metaset header = new Metaset(rpQName);
		Metaset header = MetasetBuilder.getInstance().newMetaset(rpQName);

		for (int i = 0; i < soapHeadMt.elements().size(); i++) {
			header.addChildren(".\\", (Metaset) soapHeadMt.elements().get(i));
		}

		Metaset body = MetasetBuilder.getInstance().newMetaset(rpQName2);
		body.addChildren(".\\", soapBodyMt.car());
		soap.add(header);
		soap.add(body);

		return soap;
	}

	public Metaset reConsSoap(Metaset soapHeadMt, Metaset soapBodyMt,
			QName soapname) {
		QName rpQName;
		QName rpQName2;

		if (soapname.getNamespaceURI().equals(
				"http://schemas.xmlsoap.org/soap/envelope/")) {
			rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Body", soapname.getNamespacePrefix());
		} else if (soapname.getNamespaceURI().equals(
				"http://www.w3.org/2003/05/soap-envelope")) {
			rpQName = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Body", soapname.getNamespacePrefix());
		} else {
			rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Body", soapname.getNamespacePrefix());
		}

		Metaset soap = MetasetBuilder.getInstance().newMetaset(soapname);

		soap.add(MetasetBuilder.getInstance().newAttribute("xmlns",
				"http://schemas.xmlsoap.org/soap/envelope/"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://www.w3.org/2001/XMLSchema-instance", "xsi",
						"xmlns"), "http://www.w3.org/2001/XMLSchema-instance"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://www.w3.org/2001/XMLSchema", "xsd", "xmlns"),
				"http://www.w3.org/2001/XMLSchema"));
		soap.add(MetasetBuilder.getInstance().newAttribute(
				new QName("http://schemas.xmlsoap.org/soap/encoding/",
						"soapenc", "xmlns"),
				"http://schemas.xmlsoap.org/soap/encoding/"));

		// Metaset header = new Metaset(rpQName);
		Metaset header = MetasetBuilder.getInstance().newMetaset(rpQName);

		// for (int i = 0; i < soapHeadMt.elements().size(); i++) {
		// header.addChildren(".\\", (Metaset) soapHeadMt.elements()
		// .get(i));
		//			
		// }
		for (Metaset temp1 : soapHeadMt.elements()) {
			temp1.detach();
			header.add(temp1);
		}

		Metaset body = MetasetBuilder.getInstance().newMetaset(rpQName2);
		Metaset tempM = (Metaset) soapBodyMt.node(0);
		tempM.detach();
		body.add(tempM);
		// body.addChildren(".\\", soapBodyMt.car());

		soap.add(header);
		soap.add(body);

		return soap;
	}

	private String getRandKeys(int intLength) {

		String retStr = "";
		String strTable = "0123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnpqrstuvwxyz";
		int len = strTable.length();
		boolean bDone = true;
		do {
			retStr = "";
			int count = 0;
			for (int i = 0; i < intLength; i++) {
				double dblR = Math.random() * len;
				int intR = (int) Math.floor(dblR);
				char c = strTable.charAt(intR);
				if (('0' <= c) && (c <= '9')) {
					count++;
				}
				retStr += strTable.charAt(intR);
			}
			if (count >= 2) {
				bDone = false;
			}
		} while (bDone);

		return retStr;
	}

}
