package org.act.xservices.rt.xsecurity.handler;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.net.URI;
import java.util.Date;
import java.util.List;
import java.util.Random;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParser;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestExe;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestFactory;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEnc;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEncFactory;
import org.act.xservices.rt.xsecurity.enc.algorithm.RSA_Enc;
import org.act.xservices.rt.xsecurity.handler.DigestValueExe;
import org.act.xservices.rt.xsecurity.saml.AttributeStatement;
import org.act.xservices.rt.xsecurity.saml.AuthnContext;
import org.act.xservices.rt.xsecurity.saml.AuthnStatement;
import org.act.xservices.rt.xsecurity.saml.SAMLAttribute;
import org.act.xservices.rt.xsecurity.saml.SimpleSAML;
import org.act.xservices.rt.xsecurity.saml.Subject;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.util.tConst;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.*;
import org.act.xservices.rt.xsecurity.xacml.context.ContextAction;
import org.act.xservices.rt.xsecurity.xacml.context.ContextAttribute;
import org.act.xservices.rt.xsecurity.xacml.context.ContextResource;
import org.act.xservices.rt.xsecurity.xacml.context.ContextSubject;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.context.Request;
import org.act.xservices.rt.xsecurity.xacml.context.ResourceContent;
import org.act.xservices.rt.xsecurity.xacml.context.Result;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.pdp.PolicyEngine;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;
import org.act.xservices.rt.xsecurity.xacml.policy.target.AttributeValue;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

public class SAMLHandler {
	@SuppressWarnings("null")
	public static String process( Metaset SamlSoap )
	{
	int a = 0,b = 0,c = 0;
	Request request = new Request();
//1.  SAMLƴSOAPͷгȡ,ƹAssertion

	
//	SimpleSAML saml =
//	SimpleSAML[] saml = (SimpleSAML[]) UtilMetaset.extractChildrenByName(SamlSoap, "Assertion");
//	saml.setId("01");
//	saml.setIssueinstant("2010");
//	saml.setIssuer("yf");
//	saml.setVersion("2.0");
//	Metaset header=SamlSoap.element("Header");
//	Metaset securty=header.element("Security");
//	Metaset asserttion=securty.element("Assertion");
	
	//ȡSOAPϢеassertionԲ
	Metaset assertion = (Metaset)SamlSoap
				.selectSingleNode(".//SOAP-ENV:Header//saml:Assertion");
	//ȡSOAPСеbody
	Metaset Soapbody = (Metaset)SamlSoap.selectSingleNode(".//SOAP-ENV:Body");
	

//2.  жж	

	if (assertion == null)
	{
		System.out.print("**************************************"+"\n"+"\n"+"\n");
	    System.out.print("This is not a SAML Assertion.");
	    System.out.print("\n"+"\n"+"\n"+"**************************************");
	    
		return "NOT SAML Assertion";
		
	}
	
	
	//	String attributeStatement = assertion.element("AttributeStatement").getStringValue();	
    
	System.out.print("**************************************"+"\n"+"\n"+"\n");
	
	Metaset attributeStatement = assertion.element("AttributeStatement");
	if (attributeStatement != null)
	{
	c=1;
	System.out.print("This is a AttributeStatement Assertion."+"\n");
	};
	Metaset authnStatement = assertion.element("AuthnStatement");
	if ( authnStatement != null)
		{
		a=1;
		System.out.print("This is a AuthnStatement Assertion."+"\n");
		};
	
	Metaset authzDecisionStatement = assertion.element("AuthzDecisionStatement");	
	if (authzDecisionStatement != null)
		{
		b=1;
		System.out.print("This is a AuthzDecisionStatement Assertion."+"\n");
		};
		
		
//3.  SAMLģ  saml
		SimpleSAML saml = new SimpleSAML();
		
	    //assertionԵĸԪؼSimpleSAMLģйsaml
		
		//*******      Issuer
		Metaset issue = assertion.element("Issuer");
		String sissue = issue.getStringValue().replaceAll("\n", "");
		sissue = sissue.replaceAll(" ", "");
		saml.setIssuer(sissue);
		

		
		//*******    Subject
		
		Metaset subje = assertion.element("Subject");
		String ssubje = subje.getStringValue().replaceAll("\n", "");
		ssubje = ssubje.replaceAll(" ", "");
		Subject test = new Subject();
		test.setNameID(ssubje);
		saml.setSubject(test);
		
		//*******    ֱAuthnStatement, AttributeStatement
         //ȣ֤   a = 1  AuthnStatement
		if(a == 1)
		{
			
			Metaset authn = assertion.element("AuthnStatement").element("AuthnContext").element("AuthnContextClassRef");
			String sauthn = authn.getStringValue().replaceAll("\n", "");
			sauthn = sauthn.replaceAll(" ", "");
			AuthnContext newauthncontext = new AuthnContext();
			newauthncontext.setAuthnContextClassRef(sauthn);
			AuthnStatement newAuthnStatement = new AuthnStatement();
			newAuthnStatement.setAuthncontext(newauthncontext);
			saml.setAuthnStatements(newAuthnStatement);
						
		}
		 //ΣԶ c = 1 AttributeStatement
		if(c == 1)
		{
			
			Metaset asser = assertion.element("AttributeStatement");
			String sasser = asser.getStringValue().replaceAll("\n", "");
			sasser = sasser.replaceAll(" ", "");
			SAMLAttribute newattribute = new SAMLAttribute();
			newattribute.setAttributevalues(sasser);
			AttributeStatement newAttributeStatement = new AttributeStatement();
			newAttributeStatement.setAttribute(newattribute);
			saml.setAttributestatement(newAttributeStatement);
						
		}
		
		
		
		
	
//3.  жԾߣȨ߶ֱӱȽactionWSDLbodygetLowerCaseǷͬͬ򷵻֤ԺԶŵrequestннһж		
    if(b == 1)
    {
    	long start = System.currentTimeMillis();
    	
    	String eleact = authzDecisionStatement.element("Action").getText().replaceAll("\n", "");
    	eleact = eleact.replaceAll(" ", "");
    	String eleglc = Soapbody.element("getLowerCase").getText().replaceAll("\n", "");
    	eleglc = eleglc.replaceAll(" ", "");
    	
    	if(eleact.equals(eleglc))
    		{
    		long end=System.currentTimeMillis();
    		System.out.println(end-start);
    		System.out.println("PASS");
    	    return "PASS";
    	    }
    	else  
    	{
    		long end=System.currentTimeMillis();
    		System.out.println(end-start);
    		System.out.println("DENY");
    	    return "DENY";
	    }
    }
  //4.  requestʼrequest
    else if(a == 1)
    {
		//request  Subject
    	ContextSubject[] subjects = new ContextSubject[1];
    	ContextAttribute[] attributes = new ContextAttribute[1];
    	URI attributeId = URI.create("urn:oasis:names:tc:xacml:1.0:subject:subject-id");
    	URI dataType = URI.create("http://www.w3.org/2001/XMLSchema#string");
    	
    	String issuer = saml.getIssuer();
    	String subj = saml.getSubject().getNameID();
    	
    	AttributeValue value = null;
		try {
			value = AttributeValue.newInstance(dataType,subj);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
    	ContextAttribute attr = new ContextAttribute(attributeId, dataType,  issuer, value);
    	attributes[0]=attr;
    	ContextSubject subject = new ContextSubject(Constants.SUBJECT_CATEGORY_ACCESS,attributes);
    	subjects[0]=subject;
    	request.setSubjects(subjects);

    
    	//request  resource
    	
    	
    	ContextAttribute[] attributes1 = new ContextAttribute[1];
    	AttributeValue value1 = null;
    	String res = "resource";
    	URI attributeId1 = URI.create("urn:oasis:names:tc:xacml:1.0:resource:resource-id");
    	URI dataType1 = URI.create("http://www.w3.org/2001/XMLSchema#anyURI");
		try {
			value1 = AttributeValue.newInstance(dataType1,res);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
    	ContextAttribute attr1 = new ContextAttribute(attributeId1, dataType1,  issuer, value1);
    	attributes1[0]=attr1;
    	ResourceContent resourceContent=null;
    	
    	ContextResource resource = new ContextResource(resourceContent,attributes1);
    	
    	request.setResource(resource);
    	
        // request  action
    	
    	ContextAttribute[] attributes2 = new ContextAttribute[1];
    	AttributeValue value2 = null;
    	String act = saml.getAuthnStatements().getAuthncontext().getAuthnContextClassRef();
    	URI attributeId2 = URI.create("urn:oasis:names:tc:xacml:1.0:action:action-id");
    	URI dataType2 = URI.create("http://www.w3.org/2001/XMLSchema#string");
		try {
			value2 = AttributeValue.newInstance(dataType2,act);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
    	ContextAttribute attr2 = new ContextAttribute(attributeId2, dataType2,  issuer, value2);
    	attributes2[0]=attr2;	
    	ContextAction action = new ContextAction(attributes2);
    	request.setAction(action);
    
 
    	

//5.  ֤Ե PolicyEngine ож

		Result r=null;
		long start=System.currentTimeMillis();
		
			
			r= PolicyEngine.getInstance().evaluate(request);
		
		long end=System.currentTimeMillis();
		System.out.println(end-start);
		System.out.println(r.getDecision());	
		
		System.out.print("\n"+"\n"+"**************************************");
		return r.getDecision().toString();
	
	
	  }
    else if(c ==1)
    {

		
    	//request  Subject
    	ContextSubject[] subjects = new ContextSubject[1];
    	ContextAttribute[] attributes = new ContextAttribute[1] ;
    	URI attributeId = URI.create("urn:oasis:names:tc:xacml:1.0:subject:subject-id");
    	URI dataType = URI.create("http://www.w3.org/2001/XMLSchema#string");
    	
    	String issuer = saml.getIssuer();
    	String subj = saml.getSubject().getNameID();
    	
    	AttributeValue value = null;
		try {
			value = AttributeValue.newInstance(dataType,subj);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

		ContextAttribute attr = new ContextAttribute(attributeId, dataType, issuer, value);
    	attributes[0]= attr;
    	ContextSubject subject = new ContextSubject(Constants.SUBJECT_CATEGORY_ACCESS,attributes);
    	subjects[0]=subject;
    	request.setSubjects(subjects);

    
    	//request  resource
    	
    	
    	ContextAttribute[] attributes1 = new ContextAttribute[1];
    	AttributeValue value1 = null;
    	String res = "resource";
    	URI attributeId1 = URI.create("urn:oasis:names:tc:xacml:1.0:resource:resource-id");
    	URI dataType1 = URI.create("http://www.w3.org/2001/XMLSchema#anyURI");
		try {
			value1 = AttributeValue.newInstance(dataType1,res);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
    	ContextAttribute attr1 = new ContextAttribute(attributeId1, dataType1,  issuer, value1);
    	attributes1[0]=attr1;
    	ResourceContent resourceContent=null;
    	
    	ContextResource resource = new ContextResource(resourceContent,attributes1);
    	
    	request.setResource(resource);
    	
  // request  action
    	
    	ContextAttribute[] attributes2 = new ContextAttribute[1];
    	AttributeValue value2 = null;
    	String act = saml.getAttributestatement().getAttributes().getAttributevalues();
    	URI attributeId2 = URI.create("urn:oasis:names:tc:xacml:1.0:action:action-id");
    	URI dataType2 = URI.create("http://www.w3.org/2001/XMLSchema#string");
		try {
			value2 = AttributeValue.newInstance(dataType2,act);
		} catch (DataTypeMappingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
    	ContextAttribute attr2 = new ContextAttribute(attributeId2, dataType2,  issuer, value2);
    	attributes2[0]=attr2;	
    	ContextAction action = new ContextAction(attributes2);
    	request.setAction(action);
    	
//       	MetaPrint.pXML(request.getXmlElement(), "Request");
       	
//ԶԵ PolicyEngine ож

		Result r=null;
		long start=System.currentTimeMillis();
		
			
			r= PolicyEngine.getInstance().evaluate(request);
		
		long end=System.currentTimeMillis();
		System.out.println(end-start);
		System.out.println(r.getDecision());	
		
		System.out.print("\n"+"\n"+"**************************************");
		
		return r.getDecision().toString();
	
	
	  	
     }
     else return null;
    
    
	}
}
