
package org.act.xservices.rt.xsecurity.handler;

import java.util.ArrayList;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xsecurity.authen.AuthenProcessor;
import org.act.xservices.rt.xsecurity.authen.LoginContext;
import org.act.xservices.rt.xsecurity.authen.SigLoginFactory;
import org.act.xservices.rt.xsecurity.authen.SigLoginModule;
import org.act.xservices.rt.xsecurity.authen.SinatureLoginModule;
import org.act.xservices.rt.xsecurity.exception.LoginException;
import org.act.xservices.rt.xsecurity.util.tConst;





public class SignAnaHandler
{
	private AuthenProcessor[] loginModules = null;
	private String id;
	private Metaset soap;
	private static Metaset securityToken;	
	private String clientAsymPubKey;
	private String algName;  //㷨
	private String data2Path; //ǩSOAPе·
	private Metaset wsdd;
	private String Digname;
	
	public SignAnaHandler()
	{
		super();
//		System.out.println
//			("************************ ʼǩ֤ ***************************");
	}
	
	public void init(String asykey, String algname,String digname, String data){
		this.clientAsymPubKey=asykey;
		this.algName=algname;
		this.data2Path=data;
		this.Digname=digname;
		this.wsdd = wsdd; 
		
	}
	
	public void init(Metaset wsdl, Metaset wsdd)
	{
		
//		this.algName = wsdl.filter(tConst.ansig_algName).car().getValue();	
		this.clientAsymPubKey = "conf/WSSecureFiles/files/server.cer";

//		this.data2Path =
//		wsdl.filter(tConst.ansig_data2Path).car().getValue();
		
//		System.out.println("###############################################\n");
//		
//		System.out.println(this.algName);
//		System.out.println("###############################################\n");
		
		this.algName = "http://www.w3.org/2000/09/xmldsig#rsa";
		this.data2Path = ".\\Body";
		
		this.wsdd = wsdd; 
	}

	public Metaset process(Metaset headerMt, Metaset bodyMt)
	{
		try{
			String userName 
				= headerMt.filter(".\\Security\\UsernameToken\\Username").car().getText();
//			this.clientAsymPubKey 
//				= wsdd.filter(".\\Security\\SenderAsymPubKey","username",userName).car().getText();
			
			this.soap = reConsSoap(headerMt,bodyMt);
			
			SigLoginFactory sigLoginFactory = new SigLoginFactory(soap);
			SigLoginModule slm = sigLoginFactory.getInstance();
//			System.out.println("###############################################\n");
//			
//			System.out.println(algName);
//			System.out.println("###############################################\n");
	
			slm.setAlgName(algName);
			slm.setData2Path(data2Path);
			slm.setClientAsymPubKey(clientAsymPubKey);
			slm.login(soap);
			
//			Metaset mt1 = new Metaset("xacml");
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl  mtbuilder = new MetasetBuilderImpl();
			Metaset mt1 = MetasetBuilder.getInstance().newMetaset("xacml");
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");
			
			mt2.setText(slm.getId());
			mt1.add(mt2);
			return mt1;
		}catch(Exception e){
//			Metaset mt1 = new Metaset("xacml");
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl MetasetBuilder.getInstance() = new MetasetBuilderImpl();
			Metaset mt1 =  MetasetBuilder.getInstance().newMetaset("xacml");
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");
			mt2.setText("wrong person");
			mt1.add(mt2);
			return mt1;
		}
	}
	
	
	public Metaset process(Metaset headerMt, Metaset bodyMt,QName soapname)
	{
		try{
			String userName 
				= headerMt.filter(".\\Security\\UsernameToken\\Username").car().getText();
//			this.clientAsymPubKey 
//				= wsdd.filter(".\\Security\\SenderAsymPubKey","username",userName).car().getText();
			
			this.soap = reConsSoap(headerMt,bodyMt,soapname);
			
			SigLoginFactory sigLoginFactory = new SigLoginFactory(soap);
			SigLoginModule slm = sigLoginFactory.getInstance();
//			System.out.println("###############################################\n");
//			
//			System.out.println(algName);
//			System.out.println("###############################################\n");
	
	 
			slm.setDigalgorithm(this.Digname);
			slm.setAlgName(algName);
			slm.setData2Path(data2Path);
			slm.setClientAsymPubKey(clientAsymPubKey);
			slm.login(soap);
			
			
//			Metaset mt1 = new Metaset("xacml");
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl  MetasetBuilder.getInstance() = new MetasetBuilderImpl();
			Metaset mt1 = MetasetBuilder.getInstance().newMetaset("xacml");
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");
			
			mt2.setText(slm.getId());
			mt1.add(mt2);
			return mt1;
		}catch(Exception e){
//			Metaset mt1 = new Metaset("xacml");
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl MetasetBuilder.getInstance() = new MetasetBuilderImpl();
			Metaset mt1 =  MetasetBuilder.getInstance().newMetaset("xacml");
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");
			mt2.setText("wrong person");
			mt1.add(mt2);
			return mt1;
		}
	}
	
	


	public void process(MessageContext msgContext) throws Exception
	{
		LoginContext lc = new LoginContext();
		lc.setLoginModules(loginModules);

		//		lc.setSOAPSecurity((SOAPSecurity) msgContext
		//				.getProperty(SOAPSecurity.class.getName()));

//		SOAPSecurity ss = new SOAPSecurity(msgContext.getToken());
//		lc.setSOAPSecurity(ss);

		if (lc.login())
		{
			// ɹ֤
			msgContext.setUserSubject(lc.getSubject());
			msgContext.setProperty("LoginContext", lc);
			id = lc.getId();

		} else
		{
			throw new Exception("֤ʧ");
		}
	}
	
	

	/**
	 * @return the id
	 */
	public String getId()
	{
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id)
	{
		this.id = id;
	}

	/**
	 * @param decedSoapMt
	 * @param string
	 * @param clientAsymPubKey
	 */
	public void init(Metaset decedSoapMt, String string, String clientAsymPubKey)
	{
		// TODO Auto-generated method stub

		//		 TODO Auto-generated constructor stub
		
		this.clientAsymPubKey = clientAsymPubKey;
		

	}
	
	

	/**
	 * @throws Exception 
	 * @throws LoginException 
	 * 
	 */
	public Metaset process() throws LoginException, Exception
	{

		Metaset mt = null;
		LoginContext lc = new LoginContext();
		lc.setLoginModules(loginModules);
		lc.setClientAsymPubKey(clientAsymPubKey);

		//		lc.setSOAPSecurity((SOAPSecurity) msgContext
		//				.getProperty(SOAPSecurity.class.getName()));

//		SOAPSecurity ss = new SOAPSecurity(token);
//		lc.setSOAPSecurity(ss);

		if (lc.login())
		{
			// ɹ֤
			//msgContext.setUserSubject(lc.getSubject());
			//msgContext.setProperty("LoginContext", lc);
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl MetasetBuilder.getInstance() = new MetasetBuilderImpl();
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");

			id = lc.getId();
			mt2.setText(id);

//			mt = new Metaset("signature");
			mt =  MetasetBuilder.getInstance().newMetaset("signature");
			mt.add(mt2);

		} else
		{
			throw new Exception("֤ʧ");
		}

		return mt;

	}
	
	public Metaset process_bak(Metaset headerMt,Metaset bodyMt) throws LoginException, Exception
	{
		this.soap = reConsSoap(headerMt,bodyMt);
		securityToken =  soap.filter(".\\Header\\Security\\UsernameToken");
		if (securityToken != null)
		{
			//this.token = new SinatureToken(soap);
		} else
		{
			securityToken = soap
					.filter(".\\Header\\Security\\BinarySecurityToken");
			if (securityToken != null)
			{
				//this.token = new SinatureToken(soap);
			}
		}
		
		Metaset mt = null;
		LoginContext lc = new LoginContext();
		lc.setLoginModules(loginModules);
		lc.setClientAsymPubKey(clientAsymPubKey);

//		SOAPSecurity ss = new SOAPSecurity(token);
//		lc.setSOAPSecurity(ss);

		if (lc.login())
		{
			// ɹ֤
			//msgContext.setUserSubject(lc.getSubject());
			//msgContext.setProperty("LoginContext", lc);
//			Metaset mt2 = new Metaset("id");
//			MetasetBuilderImpl MetasetBuilder.getInstance() = new MetasetBuilderImpl();
			Metaset mt2 =  MetasetBuilder.getInstance().newMetaset("id");

			id = lc.getId();
			mt2.setText(id);

//			mt = new Metaset("signature");
			mt =  MetasetBuilder.getInstance().newMetaset("signature");
			mt.add(mt2);

		} else
		{
			throw new Exception("֤ʧ");
		}

		return mt;

	}
	
	public Metaset notifyerr(){
		
		QName rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/", "Header","SOAP-ENV");
		QName rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/", "Body","SOAP-ENV");
//		MetasetBuilderImpl soapbuilder = new MetasetBuilderImpl();
		Metaset soap =  MetasetBuilder.getInstance().newMetaset("Envelope");
		Metaset header =  MetasetBuilder.getInstance().newMetaset(rpQName);
		Metaset body =  MetasetBuilder.getInstance().newMetaset(rpQName2);
		Metaset Fault =  MetasetBuilder.getInstance().newMetaset("Fault");
		Metaset faultcode =  MetasetBuilder.getInstance().newMetaset("faultcode");
		faultcode.setText("Client");
		Metaset faultstring =  MetasetBuilder.getInstance().newMetaset("faultstring");
		faultstring.setText("Sorry,your id is worry! Please set the id again!");
		Fault.add(faultcode);
		Fault.add(faultstring);
		body.add(Fault);
		soap.add(header);
		soap.add(body);	
		soap.add(new Namespace("SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/"));
		
		return soap;
		
	}
	
	public Metaset reConsSoap(Metaset soapHeadMt,Metaset soapBodyMt)
	{
		QName rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/", "Header","SOAP-ENV");
		QName rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/", "Body","SOAP-ENV");
//		Metaset soap = new Metaset("SOAP-ENV");
//		Metaset header = new Metaset(rpQName);
		
//		MetasetBuilderImpl MetasetBuilder.getInstance() = new MetasetBuilderImpl();
		Metaset soap =  MetasetBuilder.getInstance().newMetaset("Envelope");
		Metaset header =  MetasetBuilder.getInstance().newMetaset(rpQName);
		
		for (int i=0;i<soapHeadMt.elements().size();i++)
		{
			header.addChildren(".\\", soapHeadMt.elements().get(i));
		}	
//		Metaset body = new Metaset(rpQName2);
//		body.add(".\\",soapBodyMt.car());
//		soap.add(header);
		
		Metaset body =  MetasetBuilder.getInstance().newMetaset(rpQName2);
		body.addChildren(".\\",soapBodyMt.car());
		soap.add(header);
		soap.add(body);	
		return soap;	
	}

	public Metaset reConsSoap(Metaset soapHeadMt,Metaset soapBodyMt,QName soapname)
	{
		QName rpQName;
		QName rpQName2;

		if (soapname.getNamespaceURI().equals(
				"http://schemas.xmlsoap.org/soap/envelope/")) {
			rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Body", soapname.getNamespacePrefix());
		} else if (soapname.getNamespaceURI().equals(
				"http://www.w3.org/2003/05/soap-envelope")) {
			rpQName = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Body", soapname.getNamespacePrefix());
		} else {
			rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Body", soapname.getNamespacePrefix());
		}
		
Metaset soap = MetasetBuilder.getInstance().newMetaset(soapname);

		Metaset header =  MetasetBuilder.getInstance().newMetaset(rpQName);
		
		for (int i=0;i<soapHeadMt.elements().size();i++)
		{
			header.addChildren(".\\", soapHeadMt.elements().get(i));
		}	
//		Metaset body = new Metaset(rpQName2);
//		body.add(".\\",soapBodyMt.car());
//		soap.add(header);
		
		
		Metaset body =  MetasetBuilder.getInstance().newMetaset(rpQName2);
//		Metaset bodymt = 
		body.addChildren(".\\",soapBodyMt.car().car());
//		body.addAttribute("id", "#xiaoshan");
		soap.add(header);
		soap.add(body);	
		return soap;	
	}

}
