package org.act.xservices.rt.xsecurity.handler;

import java.util.Date;
import java.util.List;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestExe;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestFactory;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEnc;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymEncFactory;
import org.act.xservices.rt.xsecurity.enc.algorithm.RSA_Enc;
import org.act.xservices.rt.xsecurity.handler.DigestValueExe;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.util.tConst;
import org.act.xservices.rt.xsecurity.wssecurity.grammar.*;

public class SinatureHandler {
	private Metaset soapMt;

	private Metaset signSoapMt;

	private String data2Sign;

	private String asymKey;

	private String algName; // 㷨

	private String data2Path;

	private String psw;

	private String userName;

	private String DigestAlgorithm = "http://www.w3.org/2000/09/xmldsig#sha1";

	private List<Attribute> attributesList;

	/**
	 * 
	 */
	public SinatureHandler() {
		super();
	}

	/**
	 * @param soapMt
	 * @param data2Sign
	 */
	public SinatureHandler(Metaset soapMt, String data2Sign, String asymKey) {
		super();
		this.soapMt = soapMt;
		this.data2Sign = data2Sign;
		this.asymKey = asymKey;

	}

	public void init(Metaset soapMt, String data2Sign, String asymKey,
			List<Attribute> attributesList) {
		this.data2Sign = data2Sign;
		this.asymKey = asymKey;
		this.attributesList = attributesList;

	}

	public void init(String algorithmname, String data2path,
			String digestalgorithm, List<Attribute> attributesList) {
		this.algName = algorithmname;
		this.DigestAlgorithm = digestalgorithm;
		this.data2Path = data2path;
		this.attributesList = attributesList;
		this.asymKey = "D:/files/server.keystore";
		this.psw = "password";
		this.userName = "southeast";

	}

	public void init(Metaset wsdl, Metaset wsdd, List<Attribute> attributesList) {
		try {
			this.algName = wsdl.filter(tConst.sig_algName).car().getText();
		} catch (Exception e) {
			this.algName = "http://www.w3.org/2000/09/xmldsig#rsa";
		}
		try {
			this.data2Path = wsdl.filter(tConst.sig_data2Path).car().getText();
		} catch (Exception e) {
			this.data2Path = ".\\Body";
		}
		try {
			this.asymKey = wsdd.filter(tConst.sig_asymKey).car().getText();
		} catch (Exception e) {
			this.asymKey = tConst.folder + "server.keystore";
		}
		try {
			this.psw = wsdd.filter(tConst.sig_psw).car().getText();
		} catch (Exception e) {
			this.psw = "password";
		}
		try {
			this.userName = wsdd.filter(tConst.sig_userName).car().getText();
		} catch (Exception e) {
			this.userName = "username";
		}
		this.attributesList = attributesList;
	}

	public String digest() {
		String str = "";

		return str;
	}

	public String sign() {
		String str = "";

		return str;
	}

	public Metaset process() throws Exception {
		// Metaset mt = new Metaset();
		// MetasetBuilderImpl mtbuilder = new MetasetBuilderImpl();
		Metaset mt = MetasetBuilder.getInstance().newMetaset();

		Ref rf = new Ref("#MsgBody");
		DigestMethod dm = new DigestMethod(
				"http://www.w3.org/2000/09/xmldsig#sha1");
		Metaset dmMt = dm.getDigestMethod();

		String dgValue = DigestValueExe.MdigestSHA(data2Sign);

		DigestValue dv = new DigestValue(dgValue);
		Metaset dvMt = dv.getDigestValue();

		rf.addDigestMethod(dmMt);
		rf.addDigestValue(dvMt);

		Metaset rfMt = rf.getReference();

		Canonicalization cm = new Canonicalization(
				"http://www.w3.org/2000/09/xmldsig#hmac-sha1");
		Metaset cmMt = cm.getCanonicalizationMethod();
		SignInfo si = new SignInfo();
		Metaset siMt = si.getSignedInfo();
		si.addChild(cmMt);
		si.addChild(rfMt);

		Sign s = new Sign();

		// String sgValue = SignatureValueExe.MdigestSHA(dgValue);
		String sgValue = RSA_Enc.encpri(dgValue, asymKey);
		SignValue sv = new SignValue(sgValue);
		Metaset svMt = sv.getSignatureValue();
		s.addChild(siMt);
		s.addChild(svMt);
		Metaset sMt = s.getSignature();

		signSoapMt = sMt;

		BuildSoap();

		return soapMt;
	}

	public Metaset process(Metaset soapHeadMt, Metaset soapBodyMt)
			throws Exception {

		Metaset soap = reConsSoap(soapHeadMt, soapBodyMt, userName);
		MetaPrint.pXML(soap, "ǩSoap");
		soapMt = soap;
		this.data2Sign = soapMt.filter(data2Path).car().toXML();
		// Metaset mt = new Metaset();
		Metaset mt = MetasetBuilder.getInstance().newMetaset();
		Ref rf = new Ref("#MsgBody");
		DigestMethod dm = new DigestMethod(this.DigestAlgorithm);
		Metaset dmMt = dm.getDigestMethod();
		// String dgValue = DigestValueExe.MdigestSHA(data2Sign);
		MessageDigestFactory factory = new MessageDigestFactory();
		MessageDigestExe digest = factory
				.getDigestAlgorithm(this.DigestAlgorithm);
		String dgValue = digest.encode(data2Sign);

		DigestValue dv = new DigestValue(dgValue);
		Metaset dvMt = dv.getDigestValue();
		rf.addDigestMethod(dmMt);
		rf.addDigestValue(dvMt);
		Metaset rfMt = rf.getReference();
		Canonicalization cm = new Canonicalization(
				"http://www.w3.org/2000/09/xmldsig#hmac-sha1");
		Metaset cmMt = cm.getCanonicalizationMethod();
		SignInfo si = new SignInfo();
		Metaset siMt = si.getSignedInfo();
		si.addChild(cmMt);
		si.addChild(rfMt);
		Sign s = new Sign();

		AsymEncFactory asymEncFactory = new AsymEncFactory();
		AsymEnc asymEnc = asymEncFactory.getDec(algName);
		String sgValue = asymEnc.encWithPri(dgValue, asymKey, psw);
		SignValue sv = new SignValue(sgValue);
		Metaset svMt = sv.getSignatureValue();
		s.addChild(siMt);
		s.addChild(svMt);
		Metaset sMt = s.getSignature();
		signSoapMt = sMt;
		BuildSoap(soapMt);

		return soapMt;
	}
	

	public Metaset process(Metaset soapHeadMt, Metaset soapBodyMt,QName soapname)
			throws Exception {

		Metaset soap = reConsSoap(soapHeadMt, soapBodyMt, userName,soapname);
//		MetaPrint.pXML(soap, "ǩSoap");
		soapMt = soap;
//		this.data2Sign = soapMt.filter(data2Path).car().toFormatDocument();
		Metaset aa = soapMt.filter(data2Path).car();
		this.data2Sign = aa.toXML();
	
//		Metaset meta = (Metaset)soapMt.element("Body").node(0);
//		this.data2Sign = meta.toXML();
		// Metaset mt = new Metaset();
		// MetasetBuilderImpl mtbuilder = new MetasetBuilderImpl();
		Metaset mt = MetasetBuilder.getInstance().newMetaset();
		
		if(data2Path.equals(".\\Body")){
			
			Ref rf = new Ref("#MsgBody");
			DigestMethod dm = new DigestMethod(this.DigestAlgorithm);
			Metaset dmMt = dm.getDigestMethod();
			// String dgValue = DigestValueExe.MdigestSHA(data2Sign);
			MessageDigestFactory factory = new MessageDigestFactory();
			MessageDigestExe digest = factory
					.getDigestAlgorithm(this.DigestAlgorithm);
			String dgValue = digest.encode(data2Sign);

			DigestValue dv = new DigestValue(dgValue);
			Metaset dvMt = dv.getDigestValue();
			rf.addDigestMethod(dmMt);
			rf.addDigestValue(dvMt);
			Metaset rfMt = rf.getReference();
			Canonicalization cm = new Canonicalization(
					"http://www.w3.org/2000/09/xmldsig#hmac-sha1");
			Metaset cmMt = cm.getCanonicalizationMethod();
			SignInfo si = new SignInfo();
			Metaset siMt = si.getSignedInfo();
			si.addChild(cmMt);
			si.addChild(rfMt);
			Sign s = new Sign();

			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			String sgValue = asymEnc.encWithPri(dgValue, asymKey, psw);
			SignValue sv = new SignValue(sgValue);
			Metaset svMt = sv.getSignatureValue();
			s.addChild(siMt);
			s.addChild(svMt);
			Metaset sMt = s.getSignature();
			signSoapMt = sMt;
			BuildSoap(soapMt);
			
		}
		else if(data2Path.equals(".\\Header")){
			Ref rf = new Ref("#MsgHeader");
			DigestMethod dm = new DigestMethod(this.DigestAlgorithm);
			Metaset dmMt = dm.getDigestMethod();
			// String dgValue = DigestValueExe.MdigestSHA(data2Sign);
			MessageDigestFactory factory = new MessageDigestFactory();
			MessageDigestExe digest = factory
					.getDigestAlgorithm(this.DigestAlgorithm);
			String dgValue = digest.encode(data2Sign);

			DigestValue dv = new DigestValue(dgValue);
			Metaset dvMt = dv.getDigestValue();
			rf.addDigestMethod(dmMt);
			rf.addDigestValue(dvMt);
			Metaset rfMt = rf.getReference();
			Canonicalization cm = new Canonicalization(
					"http://www.w3.org/2000/09/xmldsig#hmac-sha1");
			Metaset cmMt = cm.getCanonicalizationMethod();
			SignInfo si = new SignInfo();
			Metaset siMt = si.getSignedInfo();
			si.addChild(cmMt);
			si.addChild(rfMt);
			Sign s = new Sign();

			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			String sgValue = asymEnc.encWithPri(dgValue, asymKey, psw);
			SignValue sv = new SignValue(sgValue);
			Metaset svMt = sv.getSignatureValue();
			s.addChild(siMt);
			s.addChild(svMt);
			Metaset sMt = s.getSignature();
			signSoapMt = sMt;
			BuildSoap(soapMt);
		}
		else{
			Ref rf = new Ref("#MsgBody");
			DigestMethod dm = new DigestMethod(this.DigestAlgorithm);
			Metaset dmMt = dm.getDigestMethod();
			// String dgValue = DigestValueExe.MdigestSHA(data2Sign);
			MessageDigestFactory factory = new MessageDigestFactory();
			MessageDigestExe digest = factory
					.getDigestAlgorithm(this.DigestAlgorithm);
			String dgValue = digest.encode(data2Sign);

			DigestValue dv = new DigestValue(dgValue);
			Metaset dvMt = dv.getDigestValue();
			rf.addDigestMethod(dmMt);
			rf.addDigestValue(dvMt);
			Metaset rfMt = rf.getReference();
			Canonicalization cm = new Canonicalization(
					"http://www.w3.org/2000/09/xmldsig#hmac-sha1");
			Metaset cmMt = cm.getCanonicalizationMethod();
			SignInfo si = new SignInfo();
			Metaset siMt = si.getSignedInfo();
			si.addChild(cmMt);
			si.addChild(rfMt);
			Sign s = new Sign();

			AsymEncFactory asymEncFactory = new AsymEncFactory();
			AsymEnc asymEnc = asymEncFactory.getDec(algName);
			String sgValue = asymEnc.encWithPri(dgValue, asymKey, psw);
			SignValue sv = new SignValue(sgValue);
			Metaset svMt = sv.getSignatureValue();
			s.addChild(siMt);
			s.addChild(svMt);
			Metaset sMt = s.getSignature();
			signSoapMt = sMt;
			BuildSoap(soapMt);
		}
		

		return soapMt;
	}

	public void BuildSoap() {
		soapMt.addChildren(".\\Header\\Security", signSoapMt);
	}

	public void BuildSoap(Metaset mt) {

		soapMt.addChildren(".\\Header\\Security", signSoapMt);
		// soapMt.addAttribute(new
		// AttributeImpl("xmlns:ds","http://www.w3.org/2000/09/xmldsig#"));
		// AttributeImplnew
		// AttributeImpl("xmlns:ds","http://www.w3.org/2000/09/xmldsig#")
		// MetasetBuilderImpl attrbuilder = new MetasetBuilderImpl();
		boolean b = soapMt
				.addAttribute(".\\Header\\Security", MetasetBuilder.getInstance().newAttribute(
						"xmlns:ds", "http://www.w3.org/2000/09/xmldsig#"));
		if(data2Path.equals(".\\Header")){
			boolean cd = soapMt.removeAttributeByPath(".\\Header", "id");
			boolean c = soapMt.addAttribute(".\\Header", MetasetBuilder.getInstance().newAttribute(
					"wsu:Id", "MsgHeader"));
		}
		else{
			//Metaset body=soapMt.element("Body");
			//body.remove(body.attribute("id"));
			
			boolean cd = soapMt.removeAttributeByPath(".\\Body", "id");
			boolean c = soapMt.addAttribute(".\\Body", MetasetBuilder.getInstance().newAttribute(
					"wsu:Id", "MsgBody"));
		}
		
	}

	public Metaset reConsSoap(Metaset soapHeadMt, Metaset soapBodyMt,
			String uName, QName soapname) {
		
		QName rpQName;
		QName rpQName2;
		
		if(soapname.getNamespaceURI().equals("http://schemas.xmlsoap.org/soap/envelope/")){
		rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
				"Header", soapname.getNamespacePrefix());
		rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
				"Body", soapname.getNamespacePrefix());
		}
		else if(soapname.getNamespaceURI().equals("http://www.w3.org/2003/05/soap-envelope")){
			rpQName = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://www.w3.org/2003/05/soap-envelope",
					"Body", soapname.getNamespacePrefix());
		}
		else{
			rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Header", soapname.getNamespacePrefix());
			rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/",
					"Body", soapname.getNamespacePrefix());
		}
		
		// Metaset soap = new Metaset("Envelope");
		// Metaset header = new Metaset(rpQName);
		Metaset soap = MetasetBuilder.getInstance().newMetaset(soapname);
		Metaset header = MetasetBuilder.getInstance().newMetaset(rpQName);

		for (int j = 0; j < this.attributesList.size(); j++) {
			Attribute attr = this.attributesList.get(j);
			attr.detach();
			soap.add(attr);
		}
//		if(soapname.getNamespaceURI().equals("http://schemas.xmlsoap.org/soap/envelope/")){
//			soap.add(MetasetBuilder.getInstance().newAttribute(new QName(
//					"http://schemas.xmlsoap.org/soap/envelope/", "SOAP-ENV",
//					"xmlns"), "http://schemas.xmlsoap.org/soap/envelope/"));
//		}
//		else if(soapname.getNamespaceURI().equals("http://www.w3.org/2003/05/soap-envelope")){
//			soap.add(MetasetBuilder.getInstance().newAttribute(new QName(
//					"http://www.w3.org/2003/05/soap-envelope", "SOAP-ENV",
//					"xmlns"), "http://www.w3.org/2003/05/soap-envelope"));
//		}
		
//		soap.add(MetasetBuilder.getInstance().newAttribute(
//								new QName(
//										"http://schemas.xmlsoap.org/soap/envelope/",
//										"wsse", "xmlns"),
//								"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));
//		soap.addNamespace("xmlns", "http://localhost:8091/EchoString");
		soap.addNamespace("wsse", "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd");

		
		for (int i = 0; i < soapHeadMt.elements().size(); i++) {
			header.addChildren(".\\", soapHeadMt.elements().get(i));
		}
		header.addChildren(".\\", drawUserNameToken(uName));
		// Metaset body = new Metaset(rpQName2);
		Metaset body = MetasetBuilder.getInstance().newMetaset(rpQName2);
//		body.addChildren(".\\", soapBodyMt.car());
//		Metaset elem = (Metaset)soapBodyMt.element("Body");
//		elem.detach();
//		body.add(elem);
		// System.out.println("rrrrrrrrrrrrrrrrrrrrrrrrrrrrrr\n"
		// + (soapBodyMt.car()).toFormatXML());
		
		soap.add(header);
		Metaset elem=soapBodyMt.element("Body");
		elem.detach();
		soap.add(elem);
		return soap;
	}

	
	public Metaset reConsSoap(Metaset soapHeadMt,Metaset soapBodyMt,String uName)
	{
		QName rpQName = new QName("http://schemas.xmlsoap.org/soap/envelope/","Header","SOAP-ENV");
		QName rpQName2 = new QName("http://schemas.xmlsoap.org/soap/envelope/","Body","SOAP-ENV");
//		Metaset soap = new Metaset("Envelope");
//		Metaset header = new Metaset(rpQName);
//		MetasetBuilderImpl soapbuilder = new MetasetBuilderImpl();
		Metaset soap =  MetasetBuilder.getInstance().newMetaset("Envelope");
		Metaset header =  MetasetBuilder.getInstance().newMetaset(rpQName);
	    
		for(int j =0;j<this.attributesList.size();j++){
			soap.add(this.attributesList.get(j));
		}
		soap.add(MetasetBuilder.getInstance().newAttribute(new QName("http://schemas.xmlsoap.org/soap/envelope/","SOAP-ENV","xmlns"), "http://schemas.xmlsoap.org/soap/envelope/"));
		soap.add(MetasetBuilder.getInstance().newAttribute(new QName("http://schemas.xmlsoap.org/soap/envelope/","wsse","xmlns"), "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"));
		for (int i=0;i<soapHeadMt.elements().size();i++)
		{
			header.addChildren(".\\", soapHeadMt.elements().get(i));
		}	
		header.addChildren(".\\", drawUserNameToken(uName));
//		Metaset body = new Metaset(rpQName2);
		Metaset body =  MetasetBuilder.getInstance().newMetaset(rpQName2);
		body.addChildren(".\\",soapBodyMt.car());
		System.out.println("rrrrrrrrrrrrrrrrrrrrrrrrrrrrrr\n"+(soapBodyMt.car()).toFormatXML());
		soap.add(header);
		soap.add(body);	
		return soap;	
	}
	
	
	public Metaset drawUserNameToken(String uName) {
		Metaset securityMt = MetasetBuilder.getInstance().newMetaset(new QName(
						"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd",
						"Security", "wsse"));
		Metaset usernameTokenMt = MetasetBuilder.getInstance().newMetaset(new QName(
						"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd",
						"UsernameToken", "wsse"));
		Metaset userNameMt = MetasetBuilder.getInstance().newMetaset(new QName(
						"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd",
						"Username", "wsse"));
		userNameMt.setText(uName);
		usernameTokenMt.add(userNameMt);
		securityMt.add(usernameTokenMt);
		return securityMt;
	}

}
