/**
 * AContextEntity.java
 */
package org.act.xservices.rt.xsecurity.saml;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.context.ContextAttribute;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * İʵ壬SubjectResourceActionEnvironmentǵĳ࣬ʵǹеԡ
 * 
 */
public abstract class AContextEntity extends AXacmlElement {
	public static final String ATTRIBUTE = "Attribute";

	private ContextAttribute[] attributes = null;

	public AContextEntity(ContextAttribute[] attributes) {
		this.attributes = attributes;
		for (int i = 0; i < this.attributes.length; i++) {
			this.attributes[i].setParent(this);
		}
	}

	public AContextEntity(Metaset xmlElement)
			throws PolicySyntaxErrorException, DataTypeMappingException {
		super(xmlElement);
		Metaset[] attrChildren = UtilMetaset.extractChildrenByName(xmlElement,
				ATTRIBUTE);
		this.attributes = new ContextAttribute[attrChildren.length];
		for (int i = 0; i < this.attributes.length; i++) {
			this.attributes[i] = new ContextAttribute(attrChildren[i]);
			this.attributes[i].setParent(this);
		}
	}

	public ContextAttribute[] getAttributes() {
		return attributes;
	}

	public void setAttributes(ContextAttribute[] attributes) {
		this.attributes = attributes;
		for (int i = 0; i < this.attributes.length; i++) {
			this.attributes[i].setParent(this);
		}
	}
}
