/**
 * Request.java
 */
package org.act.xservices.rt.xsecurity.saml;

import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.context.*;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;
import org.act.xservices.rt.xsecurity.xacml.policy.rule.VariableDefinition;
import org.act.xservices.rt.xsecurity.xacml.policy.target.AttributeValue;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 *
 * ʵֶSAMLĽģSAMLеҪصȡıǩ磺Subject, AuthnStatement, AuthzDecisionStatement, AttributeStatement
 * ѽкġSOAPȡSAMLϢݷŵXACMLУXACMLĲдؽString
 */

import java.util.List;

import javax.xml.namespace.QName;

//import org.joda.time.DateTime;
//
//import org.opensaml.common.SignableSAMLObject;


/**
 * SAML 2.0 Core Assertion.
 */
public class SimpleSAML extends AXacmlElement {

	private String version = "Vision"; 
	private String id = "ID";
	private String issuer = "Issuer"; 
	private String issueinstant = "IssueInstant"; 
	Subject subject;
	AuthnStatement authnstatement;
	AttributeStatement attributestatement;
	
	
	public String getVersion() {
		return version;
	}
	public void setVersion(String version) {
		this.version = version;
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getIssuer() {
		return issuer;
	}
	public void setIssuer(String issuer) {
		this.issuer = issuer;
	}
	public String getIssueinstant() {
		return issueinstant;
	}
	public void setIssueinstant(String issueinstant) {
		this.issueinstant = issueinstant;
	}
	
	
	/**
     * Gets the Subject of this assertion.
     * 
     * @return the Subject of this assertion
     */
    public Subject getSubject() {

		return subject;
	}

    /**
     * Sets the Subject of this assertion.
     * 
     * @param newSubject the Subject of this assertion
     */
    public void setSubject(Subject newSubject) {
    	this.subject = newSubject;
	}

    /**
     * Gets the Conditions placed on this assertion.
     * 
     * @return the Conditions placed on this assertion
     */
    /**
     * Gets the list of AuthnStatements attached to this assertion.
     * 
     * @return the list of AuthnStatements attached to this assertion
     */
    public AuthnStatement getAuthnStatements() {
		return authnstatement;
	}
    
    public void setAuthnStatements(AuthnStatement newAuthnStatement) {
    	this.authnstatement = newAuthnStatement;
	}
    /**
     * Gets the list of AuthzDecisionStatements attached to this assertion.
     * 
     * @return the list of AuthzDecisionStatements attached to this assertion
     */
    public List<AuthzDecisionStatement> getAuthzDecisionStatements() {
		return null;
	}

	public AttributeStatement getAttributestatement() {
		return attributestatement;
	}
	public void setAttributestatement(AttributeStatement attributestatement) {
		this.attributestatement = attributestatement;
	}
	public static SimpleSAML[] extractChildrenByName(Metaset xmlElement,
			String localPart) {
		List<Metaset> children = xmlElement.elements();
		List<Metaset> resultChildren = new ArrayList<Metaset>();
		for (Metaset m : children) {
			if (m.getName().equals(localPart)) {
				resultChildren.add(m);
			}
		}
		return resultChildren.toArray(new SimpleSAML[1]);
	}

}