package org.act.xservices.rt.xsecurity.signature;

import java.util.Date;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestExe;
import org.act.xservices.rt.xsecurity.dig.algfactory.MessageDigestFactory;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymDec;
import org.act.xservices.rt.xsecurity.enc.algfactory.AsymDecFactory;
import org.act.xservices.rt.xsecurity.enc.algorithm.RSA_Dec;
import org.act.xservices.rt.xsecurity.enc.algorithm.RSA_Enc;
import org.act.xservices.rt.xsecurity.handler.DigestValueExe;
import org.act.xservices.rt.xsecurity.util.MetaPrint;

public class AntiSign {
	private Metaset soapMt;

	private String input;

	private String dgValueServer;

	private boolean flag;
	
	private String digalgname;

	private String clientAsymPubKey;

	private String algName; // 㷨

	private String data2Path; // ǩSOAPе·
	
	public void setDigestName(String algname){
		this.digalgname=algname;
	}

	public AntiSign(Metaset soapMt, String ipt) {
		super();
		this.soapMt = soapMt;
		// input = ipt;
	}

	public AntiSign(Metaset soapMt) {
		super();
		this.soapMt = soapMt;
		// input = ipt;
	}

	public boolean checkDigestValue() {
		input = soapMt.filter(data2Path).car().toXML();
        input= input.replaceFirst("xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\"", "");
        input = input.replaceFirst(" ", "");
//		dgValueServer = DigestValueExe.MdigestSHA(input);
		String dgValueClient = filterDigestValue();
		MessageDigestFactory factory = new MessageDigestFactory();
		MessageDigestExe digest = factory.getDigestAlgorithm(this.digalgname);
		dgValueServer = digest.encode(input);
		if (dgValueServer.equals(dgValueClient)) {
			flag = true;
			System.out.println("Yes, pass digest check...");
		} else {
			flag = false;
		}

		return flag;
	}

	public boolean checkSigatureValue() throws Exception {

		String digestFromSignature = filterSignatureValue();
//		System.out.println("digest content decypted from signature: "
//				+ digestFromSignature);
		if (digestFromSignature.equals(dgValueServer)) {
			flag = true;
			System.out.println("Yes, pass signature check...");
		} else {
			flag = false;
		}

		return flag;
	}

	public String filterDigestValue() {
		// MetaPrint.pXML(Signature.filter(".\\ds:SignatureValue"),"Signature.filter");

		// String dValue
		// =
		// soapMt.filter(".\\SignedInfo\\Reference\\DigestValue").car().getValue();

		String dValue = soapMt
				.filter(
						".\\Header\\Security\\Signature\\SignedInfo\\Reference\\DigestValue")
				.car().getText();

		// String dValue
		// = "640379400691474264366615840525912707324669783821";
		return dValue;
	}

	public String filterSignatureValue() throws Exception {
		// String sValue
		// = Signature.car().filter(".\\SignatureValue").car().getValue();

		String signatureServerValue = soapMt.filter(
				".\\Header\\Security\\Signature\\SignatureValue").car()
				.getText();

		AsymDecFactory asymDecFactory = new AsymDecFactory();
		AsymDec asymDec = asymDecFactory.getDec(algName);
		String sValue = asymDec.encWithPub(signatureServerValue,
				clientAsymPubKey);

		// String sValue
		// = RSA_Dec.decpub(signatureServerValue,clientAsymPubKey);

		// String sValue
		// = "-218064215967171867600651351336534845712188319025";
		return sValue;
	}

	public boolean isFlag() {
//		this.flag= true;
		return flag;
	}

	public void setFlag(boolean flag) {
		this.flag = flag;
	}

	/**
	 * @return the clientAsymPubKey
	 */
	public String getClientAsymPubKey() {
		return clientAsymPubKey;
	}

	/**
	 * @param clientAsymPubKey
	 *            the clientAsymPubKey to set
	 */
	public void setClientAsymPubKey(String clientAsymPubKey) {
		this.clientAsymPubKey = clientAsymPubKey;
	}

	/**
	 * @return the algName
	 */
	public String getAlgName() {
		return algName;
	}

	/**
	 * @param algName
	 *            the algName to set
	 */
	public void setAlgName(String algName) {
		this.algName = algName;
	}

	/**
	 * @return the data2Path
	 */
	public String getData2Path() {
		return data2Path;
	}

	/**
	 * @param data2Path
	 *            the data2Path to set
	 */
	public void setData2Path(String data2Path) {
		this.data2Path = data2Path;
	}

	/**
	 * @return the dgValueServer
	 */
	public String getDgValueServer() {
		return dgValueServer;
	}

	/**
	 * @param dgValueServer
	 *            the dgValueServer to set
	 */
	public void setDgValueServer(String dgValueServer) {
		this.dgValueServer = dgValueServer;
	}

	/**
	 * @return the input
	 */
	public String getInput() {
		return input;
	}

	/**
	 * @param input
	 *            the input to set
	 */
	public void setInput(String input) {
		this.input = input;
	}

	/**
	 * @return the soapMt
	 */
	public Metaset getSoapMt() {
		return soapMt;
	}

	/**
	 * @param soapMt
	 *            the soapMt to set
	 */
	public void setSoapMt(Metaset soapMt) {
		this.soapMt = soapMt;
	}

}
