package org.act.xservices.rt.xsecurity.test;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.handler.DecryptionHandler;
import org.act.xservices.rt.xsecurity.handler.EncHandler;
import org.act.xservices.rt.xsecurity.handler.SAMLHandler;
import org.act.xservices.rt.xsecurity.handler.SignAnaHandler;
import org.act.xservices.rt.xsecurity.handler.SinatureHandler;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.xacml.exception.CacheOverflowException;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCache;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCacheableItem;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyLoader;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

public class SAMLTest {

	/**
	 * аSAMLSOAPϢĲԾ߲
	 * 1,SOAPͷгȡSAMLϢ
	 * 2,SAML Handlerдж, ʽתSAMLķrequestУXACMLд
	 * @param
	 * @return
	 * @throws CacheOverflowException 
	 * @throws UnsuportedLocationTypeException 
	 * @throws IndeterminateException 
	 * @throws DataTypeMappingException 
	 * @throws PolicySyntaxErrorException 
	 * @throws MetasetParsingException 
	 * @throws IOException 
	 * @throws
	 * @param args
	 */
	public static void main(String[] args) throws Exception {

		/*
		 * ̣   1. ʼSoap     2. ѱеSAMLԲֳȡ    3. SAMLϢSAML Handlerд
		 * 
		 * 4. SAMLݷŵXACMLĵbodyУXACMLвԾ
		 * 
		 * 5. ؾ߽Stringͣ
		 * 
		 * 6. ݾ߽ µSOAP
		 *
		 */

		
       /* Եļ
		       ļ 
		
		         ֤        AuthnStSOAP.xml
		         Ȩ߶        AuthzDeSOAP.xml
		         Զ                  AttiStSOAP.xml
		         SAML             NotSamlSOAP.xml
       */
        String selectfile = "AttiStSOAP.xml";
		//1.  ʼsoap
		Metaset SamlSoap;

		System.out.println("SAMLԳ......\n");
		
		// ȡģSoap
        // MetasetBuilder mtbuilder = MetasetBuilder.getInstance();
		
		// ·ǰ׺  /org.act.xservices.rt.xsecurity/src/main/resources/conf/WSSecureFiles/files
		String requestPath = System.getProperty("user.dir") + File.separator + "src" + File.separator + "main" +File.separator + "resources" + File.separator
		+"conf"+File.separator+"WSSecureFiles"+File.separator;
		
		SamlSoap = MetasetParserFactory.getMetasetParser().parse(requestPath+"files\\"+selectfile);
		MetaPrint.pXML(SamlSoap, "ʼSoap");
		System.out.println("\n");

	

		// 2.  ʼSAML Handler SAMLģжϲ
		
		
		String r = SAMLHandler.process(SamlSoap);
		
		//3.  ؽ
		
		System.out.println("\n");
		Metaset Soapbody = (Metaset)SamlSoap.selectSingleNode(".//SOAP-ENV:Body");
		Soapbody.setContent(null);
		if(r.equalsIgnoreCase("PASS"))
		{
		 //bodyɾ  
			
			MetaPrint.pXML(SamlSoap, "");
		}
		else if (r.equalsIgnoreCase("DENY"))
		 {
		 //bodyɾ
			Soapbody.setText("The decision : Deny");
			MetaPrint.pXML(SamlSoap, "ؽ");
		 }
		else if (r.equalsIgnoreCase("INDETERMINATE"))
		 {
		 //bodyɾ	
			Soapbody.setText("The decision : INDETERMINATE");
			MetaPrint.pXML(SamlSoap, "ؽ");
		 }
		else if (r.equalsIgnoreCase("NOTAPPLICABLE"))
		 {
		 //bodyɾ
			
			Soapbody.setText("The decision : NOTAPPLICABLE");
			MetaPrint.pXML(SamlSoap, "ؽ");
		 }
		else if (r.equalsIgnoreCase("NOT SAML Assertion"))
		{
			MetaPrint.pXML(SamlSoap, "ԭSOAPĲSAML  ԭ");
			
		}
	}
}