

package org.act.xservices.rt.xsecurity.wsspolicy;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

import org.apache.neethi.PolicyComponent;


/**
 * 
 * @author Ruchith Fernando (ruchith.fernando@gmail.com)
 */
public class HttpsToken extends Token {

//    public HttpsToken(int version){
//        setVersion(version);
//    }
    
    private boolean requireClientCertificate = false;
    private boolean httpBasicAuthentication = false;
    private boolean httpDigestAuthentication = false;

    public boolean isRequireClientCertificate() {
        return requireClientCertificate;
    }

    public void setRequireClientCertificate(boolean requireClientCertificate) {
        this.requireClientCertificate = requireClientCertificate;
    }
    
   
    public boolean isHttpBasicAuthentication()
    {
        return httpBasicAuthentication;
    }

   
    public void setHttpBasicAuthentication(boolean httpBasicAuthentication)
    {
        this.httpBasicAuthentication = httpBasicAuthentication;
    }

   
    public boolean isHttpDigestAuthentication()
    {
        return httpDigestAuthentication;
    }

    
    public void setHttpDigestAuthentication(boolean httpDigestAuthentication)
    {
        this.httpDigestAuthentication = httpDigestAuthentication;
    }

    public QName getName() {
//        if (version == SPConstants.SP_V12) {
            return SP12Constants.HTTPS_TOKEN;
//        } else {
//            return SP11Constants.HTTPS_TOKEN;
//        }
    }

    public PolicyComponent normalize() {
        throw new UnsupportedOperationException();
    }

    public void serialize(XMLStreamWriter writer) throws XMLStreamException {

        String localname = getName().getLocalPart();
        String namespaceURI = getName().getNamespaceURI();

        String prefix = writer.getPrefix(namespaceURI);
        if (prefix == null) {
            prefix = getName().getPrefix();
            writer.setPrefix(prefix, namespaceURI);
        }

        // <sp:HttpsToken
        writer.writeStartElement(prefix, localname, namespaceURI);


//        if (version == SPConstants.SP_V12) {
            
            if (isRequireClientCertificate() ||
                isHttpBasicAuthentication() ||
                isHttpDigestAuthentication()) {
                // <wsp:Policy>
                writer.writeStartElement(SPConstants.POLICY.getPrefix(), SPConstants.POLICY.getLocalPart(), SPConstants.POLICY.getNamespaceURI());
                
               
                if(isHttpBasicAuthentication()) {
                    writer.writeStartElement(prefix, SPConstants.HTTP_BASIC_AUTHENTICATION.getLocalPart(), namespaceURI);
                    writer.writeEndElement();
                } else if(isHttpDigestAuthentication()) {
                    writer.writeStartElement(prefix, SPConstants.HTTP_DIGEST_AUTHENTICATION.getLocalPart(), namespaceURI);
                    writer.writeEndElement();
                } else if(isRequireClientCertificate()) {
                    writer.writeStartElement(prefix, SPConstants.REQUIRE_CLIENT_CERTIFICATE.getLocalPart(), namespaceURI);
                    writer.writeEndElement();
                }
                // </wsp:Policy>
                writer.writeEndElement();
            }
//        } else {
//            // RequireClientCertificate=".."
//            writer.writeAttribute(SPConstants.REQUIRE_CLIENT_CERTIFICATE.getLocalPart(), Boolean
//                            .toString(isRequireClientCertificate()));
//        }

        writer.writeEndElement();
        // </sp:HttpsToken>
    }
}
