

package org.act.xservices.rt.xsecurity.wsspolicy;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.HashMap;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

import org.apache.neethi.PolicyComponent;

public class SignedEncryptedElements extends AbstractSecurityAssertion {

    private ArrayList xPathExpressions = new ArrayList();
    
    private HashMap declaredNamespaces = new HashMap();

    private String xPathVersion;

   
    private boolean signedElemets;

    public SignedEncryptedElements(boolean signedElements) {
        this.signedElemets = signedElements;
//        setVersion(version);
    }

   
    public ArrayList getXPathExpressions() {
        return xPathExpressions;
    }

    public void addXPathExpression(String expr) {
        this.xPathExpressions.add(expr);
    }

    
    public String getXPathVersion() {
        return xPathVersion;
    }

    
    public void setXPathVersion(String pathVersion) {
        xPathVersion = pathVersion;
    }

   
    public boolean isSignedElemets() {
        return signedElemets;
    }
    
    public HashMap getDeclaredNamespaces () {
        return declaredNamespaces;
    }
    
    public void addDeclaredNamespaces(String uri, String prefix ) {
        declaredNamespaces.put(prefix, uri);
    }
        
    public void serialize(XMLStreamWriter writer) throws XMLStreamException {

        String localName = getName().getLocalPart();
        String namespaceURI = getName().getNamespaceURI();

        String prefix = writer.getPrefix(namespaceURI);

        if (prefix == null) {
            prefix = getName().getPrefix();
            writer.setPrefix(prefix, namespaceURI);
        }

        // <sp:SignedElements> | <sp:EncryptedElements>
        writer.writeStartElement(prefix, localName, namespaceURI);
        
        // xmlns:sp=".."
        writer.writeNamespace(prefix, namespaceURI);

        if (xPathVersion != null) {
            writer.writeAttribute(prefix, namespaceURI, SPConstants.XPATH_VERSION, xPathVersion);
        }

        String xpathExpression;

        for (Iterator iterator = xPathExpressions.iterator(); iterator
                .hasNext();) {
            xpathExpression = (String) iterator.next();
            // <sp:XPath ..>
            writer.writeStartElement(prefix, SPConstants.XPATH_EXPR, namespaceURI);

            Iterator<String> namespaces = declaredNamespaces.keySet().iterator();

            while(namespaces.hasNext()) {
                prefix = (String) namespaces.next();
                namespaceURI = (String) declaredNamespaces.get(prefix);
                writer.writeNamespace(prefix,namespaceURI);
            }

            writer.writeCharacters(xpathExpression);
            writer.writeEndElement();
        }

        // </sp:SignedElements> | </sp:EncryptedElements>
        writer.writeEndElement();
    }

    public QName getName() {
        if (signedElemets) {
//            if (version == SPConstants.SP_V12) {
                return SP12Constants.SIGNED_ELEMENTS;
           
            
        } 
        
//        if (version == SPConstants.SP_V12) {
            return SP12Constants.ENCRYPTED_ELEMENTS;
//        } else {
//            return SP11Constants.ENCRYPTED_ELEMENTS;
//        }
    }

    public PolicyComponent normalize() {
        return this;
    }
}
