package org.act.xservices.rt.xsecurity.wsspolicy.processor;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.policy.IPolicyProcessor;
import org.act.xservices.rt.xcontainer.framework.policy.PolicyProcessException;
import org.act.xservices.rt.xcontainer.framework.util.XContainerUtil;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.Node;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.xpath.DefaultXPath;
import org.act.xservices.rt.xsecurity.handler.DecryptionHandler;
import org.act.xservices.rt.xsecurity.handler.EncHandler;
import org.act.xservices.rt.xsecurity.handler.SAMLHandler;
import org.act.xservices.rt.xsecurity.handler.SignAnaHandler;
import org.act.xservices.rt.xsecurity.handler.SinatureHandler;
import org.act.xservices.rt.xsecurity.handler.DecryptionHandler;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.wsspolicy.SPConstants;
import org.act.xservices.rt.xsecurity.wsspolicy.WSSPolicyException;
import org.act.xservices.rt.xsecurity.wsspolicy.WSSecurityPolicy;
import org.act.xservices.rt.xsecurity.wsspolicy.AlgorithmSuite;

/*
 * ݽģİȫԶ󣬽аȫ
 * 
 */

public class SAMLPolicyProcessor implements IPolicyProcessor {

	private String PolicyProcessorName = "";
	private String PolicyType = "";
	private String WsPolicy = "";
	
	// SAML
	private String samlInclude = "";
	private String samlIssuer = "";
	boolean samlver1 = false;
	boolean samlver2 = false;
	boolean issaml = false;// ʾǷsaml
	boolean samlnever = false;
	boolean samlonce = false;
	boolean samltoRept = false;
	boolean samltoIntr = false;
	boolean issamlissuer = false;// ʾSAMLissuerǷļҪ
	private String SamlResult = "";
	
	public void destroy() {
		// TODO Auto-generated method stub

	}

	public String getPolicyProcessorName() {
		// TODO Auto-generated method stub
		return this.PolicyProcessorName;
	}

	public String getPolicyType() {
		// TODO Auto-generated method stub
		return this.PolicyType;
	}

	public String getWsPolicy() {
		// TODO Auto-generated method stub
		return WsPolicy;
	}

	public void init(IConfigElement processorCfg) {
		// TODO Auto-generated method stub
		setPolicyProcessorName(processorCfg.getName());
		setPolicyType(processorCfg.getAttribute("policyType"));

	}

	// ͨWSSecurityPolicyðȫԴز
	public void WSSecurityPolicyProcess(WSSecurityPolicy wsspolicy) {

	}

	public void processIN(IServiceContext serviceContext)
			throws PolicyProcessException {
		
		Metaset ExtElement = getExtElement(serviceContext, "handlin");
		Metaset WsSecurityPolicy = MetasetBuilder.getInstance().newMetaset(
				"wssecuritypolicy");

		while (ExtElement.elements().size() != 0) {
			if ((ExtElement.elements().get(0).getQName().getNamespaceURI())
					.equals("http://www.w3.org/ns/ws-policy")) {
				Metaset exe = ExtElement.elements().get(0);
				exe.detach();
				WsSecurityPolicy.add(exe);

			}
		}

		this.setWsPolicy(WsSecurityPolicy.toXML());

		Metaset inMessage = serviceContext.getInMessage();

		// TODO Auto-generated method stub
		// SAML ӦdecedSoapMtд

		inMessage = handlesamlIN(inMessage);

		serviceContext.getMessageContext()
				.setSoapMessageBySOAPEnvMetaset(inMessage);
		return;
		

	}

	public void processOUT(IServiceContext serviceContext)
			throws PolicyProcessException {

		Metaset ExtElement = getExtElement(serviceContext, "handlout");
		Metaset WsSecurityPolicy = MetasetBuilder.getInstance().newMetaset(
				"wssecuritypolicy");
		for (int j = 0; j < ExtElement.elements().size(); j++) {
			if ((ExtElement.elements().get(j).getQName().getNamespaceURI())
					.equals("http://www.w3.org/ns/ws-policy")) {
				Metaset exem = ExtElement.elements().get(j);
				exem.detach();
				WsSecurityPolicy.add(exem);
			}
		}

		this.setWsPolicy(WsSecurityPolicy.toXML());
		Metaset outMessage = serviceContext.getOutMessage();
		// SAML decedSoapMtд

		outMessage = handlesamlOUT(outMessage);

		serviceContext.getMessageContext()
				.setSoapMessageBySOAPEnvMetaset(outMessage);
		return;
	

	}

	public void setPolicyProcessorName(String policyProcessorName) {
		// TODO Auto-generated method stub
		this.PolicyProcessorName = policyProcessorName;

	}

	public void setPolicyType(String policyType) {
		// TODO Auto-generated method stub
		this.PolicyType = policyType;
	}

	public void setWsPolicy(String wsPolicy) {
		// TODO Auto-generated method stub
		this.WsPolicy = wsPolicy;
	}



	public Metaset getMatchPolicy(String wsPolicy) {

		Metaset MatchPolicy = MetasetBuilder.getInstance().newMetaset(
				"MatchPolicy");
		try {

			Metaset wspolicy = MetasetParserFactory.getMetasetParser()
					.parseXMLString(wsPolicy);
			if (wspolicy.elements().size() > 0) {
				MatchPolicy = wspolicy.elements().get(0);
			}

		} catch (MetasetParsingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return MatchPolicy;
	}

	public void setpolicyprocessIN(Metaset processpt) {

//		System.out.print("\n" + "********Դ(INPUT PART)*****" + "\n");

		getinpart(processpt);// ԱĽз
		// н

		
		// SAML ֵж
//		if (issaml == false) {
//			System.out.print("There is no SAML Token Assertion in the WSDL"
//					+ "\n");
//		} else {
//			JudgeSaml();
//			if (samlnever) {
//				System.out.print("No SAML Token Assertion in the input message"
//						+ "\n");
//			}
//			if (samlonce || samltoRept) {
//				System.out.print("SAML Token Assertion in the input message"
//						+ "\n");
//			}
//		}
	}

	public void setpolicyprocessOUT(Metaset processpt) {
		// ӦҪĲַ봦

//		System.out.print("\n" + "********Դ(OUTPUT PART)*****" + "\n");
		getoutpart(processpt);// ԱĽз
		
		// SAML ֵж
//		if (issaml == false) {
//			System.out.print("There is no SAML Token Assertion in the WSDL"
//					+ "\n");
//		} else {
//			JudgeSaml();
//			if (samlnever) {
//				System.out
//						.print("No SAML Token Assertion in the output message"
//								+ "\n");
//			}
//			if (samltoIntr) {
//				System.out.print("SAML Token Assertion in the output message"
//						+ "\n");
//			}
//		}
	}

	public void setpolicyprocess(Metaset processpt) {
		// ӦҪĲַ봦

//		System.out.print("\n" + "********Դ(Total PART)*****" + "\n");
		// MetaPrint.pXML(processpt, "дı");
		getoutpart(processpt);// ԱĽз
		// н

		// SAML ֵж
//		if (issaml == false) {
//			System.out.print("There is no SAML Token Assertion in the WSDL"
//					+ "\n");
//		} else {
//			JudgeSaml();
//			if (samlnever) {
//				System.out.print("No SAML Token Assertion in the  message"
//						+ "\n");
//			}
//			if (samlonce || samltoRept || samltoIntr) {
//				System.out.print("SAML Token Assertion in the  message" + "\n");
//			}
//		}
	}

	private void getinpart(Metaset processpt) {

		if (processpt.element("Servicept") != null) {
			Metaset policypart = processpt.element("Servicept").element(
					"Policy");
			// ******  SAMLĲ֡жǷSAML
			if (policypart.element("SamlToken") != null) {
				issaml = true;
				Metaset samlpart = policypart.element("SamlToken");
				if (samlpart.attributes().get(0).getQName().getName() == "IncludeToken") {
					samlInclude = samlpart.attributes().get(0).getValue();

				}
				if (samlpart.element("Issuer") != null) {
					samlIssuer = samlpart.element("Issuer").getText();
				}
				if (samlpart.element("WssSamlV11Token10") != null
						|| samlpart.element("WssSamlV11Token11") != null) {
					samlver1 = true;
				}
				if (samlpart.element("WssSamlV20Token11") != null) {
					samlver2 = true;
				}
			}

//			System.out.println("\n" + "ȡ" + "\n");
		}
	}

	private void getoutpart(Metaset processpt) {

		if (processpt.element("Servicept") != null) {
			Metaset policypart = processpt.element("Servicept").element(
					"Policy");
			// ******  SAMLĲ֡жǷSAML
			if (policypart.element("SamlToken") != null) {
				issaml = true;
				Metaset samlpart = policypart.element("SamlToken");
				if (samlpart.attributes().get(0).getQName().getName() == "IncludeToken") {
					samlInclude = samlpart.attributes().get(0).getValue();

				}
				if (samlpart.element("Issuer") != null) {
					samlIssuer = samlpart.element("Issuer").getText();
				}
				if (samlpart.element("WssSamlV11Token10") != null
						|| samlpart.element("WssSamlV11Token11") != null) {
					samlver1 = true;
				}
				if (samlpart.element("WssSamlV20Token11") != null) {
					samlver2 = true;
				}
			}

			System.out.println("\n" + "ȡ" + "\n");
		}
	}

	// ȡSAML֣жϣsetpolicyprocesssetpolicyprocessOUTsetpolicyprocessIN
	private void JudgeSaml() {

		if (samlInclude
				.equalsIgnoreCase("http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702/IncludeToken/Never")) {
			samlnever = true;
		}
		if (samlInclude
				.equalsIgnoreCase("http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702/IncludeToken/Once")) {
			samlonce = true;
		}
		if (samlInclude
				.equalsIgnoreCase("http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702/IncludeToken/AlwaysToRecipient")) {
			samltoRept = true;
		}
		if (samlInclude
				.equalsIgnoreCase("http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702/IncludeToken/AlwaysToInitiator")) {
			samltoIntr = true;
		}
		if (samlInclude
				.equalsIgnoreCase("http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702/IncludeToken/Always")) {
			samltoRept = true;
			samltoIntr = true;
		}
	}

	// *******SAMLĴ
	private Metaset handlesamlIN(Metaset samlsoap) {

		if (issaml == true && (samlonce || samltoRept)) {
			// һ³жϣWSDL˵inputmessageSAMLԣʵSOAPϢûSAMLԣ򷵻ظSOAPϢϹĴ
			if (samlsoap.element("Header") != null) {
				if (samlsoap.element("Header").element("Assertion") != null) {
					// ߼ж SAMLIssuerǷΪxservices涨ķߣ򷵻شidϢ
					if (samlIssuer.equalsIgnoreCase("testSAML")) // ****ҪĶͨļȡissuer
					{
						issamlissuer = true;
						this.SamlResult = SAMLHandler.process(samlsoap);
						return samlsoap;
					} else {
						samlsoap.setText("The SAML Issuer is not Correct\n");
						return samlsoap;
					}
				} else {// ³жϽΪSOAPδWSDL涨SAML
					samlsoap
							.setText("The SOAP is not Correct, because it has no SAML Assertion as the WSDL says\n");
					return samlsoap;
				}
			} else {// ³жϽΪSOAPδWSDL涨SAML
				samlsoap
						.setText("The SOAP is not Correct, because it has no SAML Assertion as the WSDL says\n");
				return samlsoap;
			}

		}
		return samlsoap;
	}

	private Metaset handlesamlOUT(Metaset outMessage) {
		Metaset samlsoap = null;
		if (issaml == true && samltoIntr) {
		
			// һ֤
			String requestPath = System.getProperty("user.dir").replaceAll("xcontainer.container", "xsecurity")
					+ File.separator + "src" + File.separator + "main"
					+ File.separator + "resources" + File.separator + "conf"
					+ File.separator + "WSSecureFiles" + File.separator;
			String selectfile;
			if (samlver1) {
				selectfile = "SAMLBackSOAPVer1.xml";
			} else if (samlver2) {
				selectfile = "SAMLBackSOAPVer2.xml";
			} else {   
				// ĬΪ1.0汾 
				selectfile = "SAMLBackSOAPVer1.xml";
			}
			try {
				samlsoap = MetasetParserFactory.getMetasetParser().parse(
						requestPath + "files\\" + selectfile);
			} catch (MetasetParsingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Metaset assertion = (Metaset) samlsoap
					.selectSingleNode(".//SOAP-ENV:Header//saml:Assertion//saml:AuthzDecisionStatement");
			if(SamlResult=="") 
			{
				SamlResult = "INDETERMINATE";//ΪգĬֵINDETERMINATE
				}
//			String add = "\"http://thisisanexample.com\"";
//			String addecision = "Resource="+add+"\n"+"Decision="+"\""+SamlResult+"\""+">"+"\n";
			String addecision = "Decision="+SamlResult;
			assertion.setText(addecision );
					
			// Ҫbodyֻԭsoap
			Metaset samlbody = (Metaset) samlsoap.selectSingleNode(".//SOAP-ENV:Body");
            samlbody.add(outMessage);
            return samlsoap;
		} else {
			// WSDLҪSAMLԣsamlsoapд
			return outMessage;
		}
		
	}
    public Metaset getExtElement(IServiceContext serviceContext,String HandlerType){
    	
    	MetasetBuilder builder = MetasetBuilder.getInstance();
    	int a =0;
		
    	Metaset ExtElement = builder.newMetaset("ExtElement");
		
		if((serviceContext.getXcService().getExtensibilityElements().size())!=0){
			for(int i=0;i<(serviceContext.getXcService().getExtensibilityElements().size());i++){
	    	

	    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
	    			serviceContext.getXcService().getExtensibilityElements().get(i).getExtElement()));
	    
	    }	
			a++;
		}
		
		
		if((serviceContext.getXcEndpoint().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcEndpoint().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcEndpoint().getExtensibilityElements().get(i).getExtElement()));
		    	
		    }	
		    a++;
		}
		
		
		if((serviceContext.getXcOperation().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcOperation().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcOperation().getExtensibilityElements().get(i).getExtElement()));
		    }
		    a++;
		}
		
		if((serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().get(i).getExtElement()));
		    }
		    a++;
		}
		
		
		
		
		if(HandlerType.equals("handlin")){
			
			if((serviceContext.getXcOperation().getInputXcMessage())!=null){
				    
					for(int i=0;i<(serviceContext.getXcOperation().getInputXcMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getInputXcMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}
					
					for(int i=0;i<(serviceContext.getXcOperation().getInputXcMessage().getXcBindingMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getInputXcMessage().getXcBindingMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					
					

			}
			
		}else if(HandlerType.equals("handlout")){
			if((serviceContext.getXcOperation().getOutputXcMessage())!=null){
				   
					for(int i=0;i<(serviceContext.getXcOperation().getOutputXcMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getOutputXcMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					for(int i=0;i<(serviceContext.getXcOperation().getOutputXcMessage().getXcBindingMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getOutputXcMessage().getXcBindingMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					
			}
		}
		if(a<2){
			ExtElement.removeElements(".\\*");
		}
		
		return ExtElement;
    }
}