package org.act.xservices.rt.xsecurity.wsspolicy.processor;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.metaset.MetasetBuilder;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xcontainer.framework.config.IConfigElement;
import org.act.xservices.rt.xcontainer.framework.policy.IPolicyProcessor;
import org.act.xservices.rt.xcontainer.framework.policy.PolicyProcessException;
import org.act.xservices.rt.xcontainer.framework.util.XContainerUtil;
import org.act.xservices.rt.xcontainer.inf.context.IServiceContext;
import org.act.xservices.rt.xcontainer.inf.service.wsdl.XcService;
import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xom.Namespace;
import org.act.xservices.rt.xom.Node;
import org.act.xservices.rt.xom.QName;
import org.act.xservices.rt.xom.xpath.DefaultXPath;
import org.act.xservices.rt.xsecurity.handler.DecryptionHandler;
import org.act.xservices.rt.xsecurity.handler.EncHandler;
import org.act.xservices.rt.xsecurity.handler.SAMLHandler;
import org.act.xservices.rt.xsecurity.handler.SignAnaHandler;
import org.act.xservices.rt.xsecurity.handler.SinatureHandler;
import org.act.xservices.rt.xsecurity.handler.DecryptionHandler;
import org.act.xservices.rt.xsecurity.util.MetaPrint;
import org.act.xservices.rt.xsecurity.wsspolicy.SPConstants;
import org.act.xservices.rt.xsecurity.wsspolicy.WSSPolicyException;
import org.act.xservices.rt.xsecurity.wsspolicy.WSSecurityPolicy;
import org.act.xservices.rt.xsecurity.wsspolicy.AlgorithmSuite;

/*
 * ݽģİȫԶ󣬽аȫ
 * 
 */

public class SecurityPolicyProcessor implements IPolicyProcessor {

	private String PolicyProcessorName = "";
	private String PolicyType = "";
	private String WsPolicy = "";
	private String PolicyResult = "";

	private String algoSuiteString;
	// ʶ
	boolean INSignBody = false;
	boolean INSignHeader = false;
	boolean INEncrypBody = false;
	boolean INEncrypHeader = false;
	boolean OUTSignBody = false;
	boolean OUTSignHeader = false;
	boolean OUTEncrypBody = false;
	boolean OUTEncrypHeader = false;

	private String digest;
	private String encryption;
	private String asymmetricKeyWrap;
//	private final static String keystore = "E:\\SVNCode\\XServicesRuntime3_6\\org.act.xservices.rt.xsecurity\\src\\main\\resources\\conf\\WSSecureFiles\\files\\server.keystore";
	private final static String keystore = "conf\\WSSecureFiles\\files\\server.keystore";

	private final static String servercer = "conf\\WSSecureFiles\\files\\server.cer";
	private final static String WssecurityXsd = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd";
	
	public void destroy() {
		// TODO Auto-generated method stub

	}

	public String getPolicyProcessorName() {
		// TODO Auto-generated method stub
		return this.PolicyProcessorName;
	}

	public String getPolicyType() {
		// TODO Auto-generated method stub
		return this.PolicyType;
	}

	public String getWsPolicy() {
		// TODO Auto-generated method stub
		return WsPolicy;
	}

	public void init(IConfigElement processorCfg) {
		// TODO Auto-generated method stub
		setPolicyProcessorName(processorCfg.getName());
		setPolicyType(processorCfg.getAttribute("policyType"));

	}

	// ͨWSSecurityPolicyðȫԴز
	public void WSSecurityPolicyProcess(WSSecurityPolicy wsspolicy) {

	}

	public void processIN(IServiceContext serviceContext)
			throws PolicyProcessException {
		
		Metaset ExtElement = getExtElement(serviceContext, "handlin");
		Metaset WsSecurityPolicy = MetasetBuilder.getInstance().newMetaset(
				"wssecuritypolicy");

		while (ExtElement.elements().size() != 0) {
			if ((ExtElement.elements().get(0).getQName().getNamespaceURI())
					.equals("http://www.w3.org/ns/ws-policy")) {
				Metaset exe = ExtElement.elements().get(0);
				exe.detach();
				WsSecurityPolicy.add(exe);

			}
		}

		this.setWsPolicy(WsSecurityPolicy.toXML());

		Metaset inMessage = serviceContext.getInMessage();

		// TODO Auto-generated method stub
		PolicyResult();
		List<Attribute> attributesList = inMessage.attributes();
		// *****ҪInput Messageнܺǩֲ
		if (this.PolicyResult.equals("BothSignedandEncrypted")) {
			Metaset EncWSDL = MetasetBuilder.getInstance().newMetaset();
			Metaset decedSoapMt = null;
			// *****************  ܴ EncHandler
			DecryptionHandler decryptionHandler = new DecryptionHandler();
			// ѡ㷨й涨㷨ĽܹûĬ㷨
			Metaset bdy1 = null;
			// Metaset bdy2 = null;
			Metaset bdy3 = null;
			Metaset bdy4 = null;
			Metaset bdyhead = (Metaset) inMessage.element("Header");
			Metaset bdybody = (Metaset) inMessage.element("Body");
			if ((digest == null)) {
				decryptionHandler
						.init(
								SPConstants.KW_RSA15,
								keystore,
								attributesList, "soap");

				try {
					decedSoapMt = decryptionHandler.process(inMessage,
							SPConstants.TRIPLE_DES);
					// ֻܱͷbodyֵ
					if (INEncrypHeader == false) {
						bdy1 = (Metaset) decedSoapMt.element("Header");
						bdy1.detach();
						bdy3 = (Metaset) decedSoapMt.element("Body");
						bdy4 = (Metaset) decedSoapMt.element("Body");
						bdy3.detach();
						decedSoapMt.add(bdyhead);
						decedSoapMt.add(bdy4);

					}
					if (INEncrypBody == false) {
						bdy1 = (Metaset) decedSoapMt.element("Body");
						bdy1.detach();
						decedSoapMt.add(bdybody);

					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				decryptionHandler
						.init(
								asymmetricKeyWrap,
								keystore,
								attributesList, "soap");
				try {
					decedSoapMt = decryptionHandler.process(inMessage,
							encryption);
					if (INEncrypHeader == false) {
						bdy1 = (Metaset) decedSoapMt.element("Header");
						bdy1.detach();
						bdy3 = (Metaset) decedSoapMt.element("Body");
						bdy4 = (Metaset) decedSoapMt.element("Body");
						bdy3.detach();
						decedSoapMt.add(bdyhead);
						decedSoapMt.add(bdy4);

					}
					if (INEncrypBody == false) {
						bdy1 = (Metaset) decedSoapMt.element("Body");
						bdy1.detach();
						decedSoapMt.add(bdybody);

					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

			// *****************   ǩ EncHandler

			Metaset HandlerLinks4 = MetasetBuilder.getInstance().newMetaset(
					"HandlerLinks");
			Metaset hder4 = decedSoapMt.filter(".\\Header").car();
			for (Metaset temp : hder4.elements()) {
				temp.detach();
				HandlerLinks4.add(temp);
			}

			Metaset operation4 = MetasetBuilder.getInstance().newMetaset(
					"operation");
			Metaset bdy2 = (Metaset) decedSoapMt.element("Body");
			bdy2.detach();
			operation4.add(bdy2);
			SignAnaHandler SignAnaHandler = new SignAnaHandler();
			
			if ((digest == null)) {
				SignAnaHandler
						.init(
								servercer,
								"http://www.w3.org/2000/09/xmldsig#rsa",
								SPConstants.SHA1,
								".\\Body");
			} else {
				SignAnaHandler
						.init(
								servercer,
								asymmetricKeyWrap, digest, ".\\Body");
			}
			Metaset signanaMt = SignAnaHandler.process(HandlerLinks4,
					operation4, decedSoapMt.getQName());

			String id = signanaMt.car().getText();
			if (id.equals("wrong person")) {
				Metaset mt = SignAnaHandler.notifyerr();
				mt.detach();
				serviceContext.getMessageContext()
						.setSoapMessageBySOAPEnvMetaset(mt);

				return;
			}

			else {
				// 0806ʾ Ķ  ******
				QName rpQName = new QName(
						"http://schemas.xmlsoap.org/soap/envelope/", "Envelope",
						"soapenv");
				QName rpQName2 = new QName(
						"http://schemas.xmlsoap.org/soap/envelope/", "Body",
						"soapenv");
				Metaset soap = MetasetBuilder.getInstance().newMetaset(
						rpQName);
				Metaset header = MetasetBuilder.getInstance().newMetaset(
						"soapenv:Header");
				Metaset body = MetasetBuilder.getInstance()
						.newMetaset("Body");

				soap.add(header);
				Metaset bd = operation4.car();
				bd.detach();
				soap.add(bd);
				serviceContext.getMessageContext()
						.setSoapMessageBySOAPEnvMetaset(soap);
				return;
			}
		} else if (this.PolicyResult.equals("OnlySigned")) {

			Metaset HandlerLinks4 = MetasetBuilder.getInstance().newMetaset(
					"HandlerLinks");
			Metaset hder4 = inMessage.filter(".\\Header").car();
			for (Metaset temp : hder4.elements()) {
				temp.detach();
				HandlerLinks4.add(temp);
			}

			Metaset operation4 = MetasetBuilder.getInstance().newMetaset(
					"operation");
			Metaset bdy4 = (Metaset) inMessage.element("Body");
			bdy4.detach();
			operation4.add(bdy4);

			SignAnaHandler SignAnaHandler = new SignAnaHandler();
			if ((digest == null)) {
				SignAnaHandler
						.init(
								servercer,
								SPConstants.KW_RSA15,
								SPConstants.SHA1,
								".\\Body");
			} else
				SignAnaHandler
						.init(
								servercer,
								asymmetricKeyWrap, digest, ".\\Body");

			Metaset signanaMt = SignAnaHandler.process(HandlerLinks4,
					operation4, inMessage.getQName());
			String id = signanaMt.car().getText();
			if (id.equals("wrong person")) {
				Metaset mt = SignAnaHandler.notifyerr();
			

				serviceContext.getMessageContext()
						.setSoapMessageBySOAPEnvMetaset(mt);
				return;
			}
			else {
				//   ʿƴACHandler
				QName rpQName = new QName(
						"http://schemas.xmlsoap.org/soap/envelope/", "Header",
						"SOAP-ENV");
				QName rpQName2 = new QName(
						"http://schemas.xmlsoap.org/soap/envelope/", "Body",
						"SOAP-ENV");
				Metaset soap = MetasetBuilder.getInstance().newMetaset(
						"Envelope");
				Metaset header = MetasetBuilder.getInstance().newMetaset(
						rpQName);
				Metaset body = MetasetBuilder.getInstance()
						.newMetaset(rpQName2);
				body.addChildren(".\\", operation4.car());
				soap.add(header);
				soap.add(body);
			

				serviceContext.getMessageContext()
						.setSoapMessageBySOAPEnvMetaset(soap);
				return;
			}
		} else if (this.PolicyResult.equals("OnlyEncrypted")) {
			Metaset EncWSDL = MetasetBuilder.getInstance().newMetaset();
			Metaset decedSoapMt = null;
			// *****************   ܴ EncHandler
			DecryptionHandler decryptionHandler = new DecryptionHandler();
			Metaset bdy1 = null;
		//  Metaset bdy2 = null;
			Metaset bdy3 = null;
			Metaset bdy4 = null;
			Metaset bdyhead = (Metaset) inMessage.element("Header");
			Metaset bdybody = (Metaset) inMessage.element("Body");
			if ((digest == null)) {
				decryptionHandler
						.init(
								SPConstants.KW_RSA15,
								keystore,
								attributesList, "soap");

				try {
					decedSoapMt = decryptionHandler.process(inMessage,
							SPConstants.TRIPLE_DES);
					// "http://www.w3.org/2001/04/xmlenc#aes256-cbc");

				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				decryptionHandler
						.init(
								asymmetricKeyWrap,
								keystore,
								attributesList, "soap");
				try {
					decedSoapMt = decryptionHandler.process(inMessage,
							encryption);
					if (INEncrypHeader == false) {
						bdy1 = (Metaset) decedSoapMt.element("Header");
						bdy1.detach();
						bdy3 = (Metaset) decedSoapMt.element("Body");
						bdy4 = (Metaset) decedSoapMt.element("Body");
						bdy3.detach();
						decedSoapMt.add(bdyhead);
						decedSoapMt.add(bdy4);

					}
					if (INEncrypBody == false) {
						bdy1 = (Metaset) decedSoapMt.element("Body");
						bdy1.detach();
						decedSoapMt.add(bdybody);

					}

				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			

			serviceContext.getMessageContext().setSoapMessageBySOAPEnvMetaset(
					decedSoapMt);
			return;
		} else {

			return;

		}

	}

	public void processOUT(IServiceContext serviceContext)
			throws PolicyProcessException {

		Metaset ExtElement = getExtElement(serviceContext, "handlout");
		Metaset WsSecurityPolicy = MetasetBuilder.getInstance().newMetaset(
				"wssecuritypolicy");
		for (int j = 0; j < ExtElement.elements().size(); j++) {
			if ((ExtElement.elements().get(j).getQName().getNamespaceURI())
					.equals("http://www.w3.org/ns/ws-policy")) {
				Metaset exem = ExtElement.elements().get(j);
				exem.detach();
				WsSecurityPolicy.add(exem);
			}
		}

		this.setWsPolicy(WsSecurityPolicy.toXML());


		Metaset outMessage = serviceContext.getOutMessage();

		// TODO Auto-generated method stub
		PolicyResult();
		// ͬʱҪܺǩ
		if (this.PolicyResult.equals("BothSignedandEncrypted")
				|| ((OUTEncrypBody || OUTEncrypHeader) && (OUTSignBody || OUTSignHeader))) {

			Metaset EncWSDL = MetasetBuilder.getInstance().newMetaset();

			Metaset wsdd2 = MetasetBuilder.getInstance().newMetaset();

			List<Attribute> attributesList = outMessage.attributes();
			outMessage.removeElements(".\\Header\\Security");
			// Է񷵻رĽǩ

			Metaset HandlerLinks7 = MetasetBuilder.getInstance().newMetaset(
					"HandlerLinks");

			Metaset hder7 = outMessage.element("Header");

			for (Metaset temp : hder7.elements()) {
				temp.detach();
				HandlerLinks7.add(temp);
			}

			Metaset operation7 = MetasetBuilder.getInstance().newMetaset(
					"operation");

			Metaset bdy7 = (Metaset) outMessage.element("Body");

			bdy7.detach();
			operation7.add(bdy7);

			SinatureHandler sinatureHandler2 = new SinatureHandler();
			if ((digest == null)) {
				sinatureHandler2.init(
						SPConstants.KW_RSA15, ".\\Body",
						SPConstants.SHA1,
						attributesList);
			} else {
				sinatureHandler2.init(asymmetricKeyWrap, ".\\Body", digest,
						attributesList);
			}

			Metaset signedSoapMt2 = null;
			try {
				signedSoapMt2 = sinatureHandler2.process(HandlerLinks7,
						operation7, outMessage.getQName());

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			// Է񷵻رĽм

			signedSoapMt2
					.addNamespace(
							"wsu",
							WssecurityXsd);
			EncHandler encHandler2 = new EncHandler();
			if ((digest == null)) {
				encHandler2
						.init(
								SPConstants.KW_RSA15,
								servercer,
								SPConstants.TRIPLE_DES);
			} else {
				encHandler2
						.init(
								asymmetricKeyWrap,
								servercer,
								encryption);
			}

			Metaset encedSoapMt2 = null;
			try {
				encedSoapMt2 = encHandler2.process(signedSoapMt2);

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			serviceContext.getMessageContext().setSoapMessageBySOAPEnvMetaset(
					encedSoapMt2);
			return;
		} else if (this.PolicyResult.equals("OnlySigned")) {

			Metaset EncWSDL = MetasetBuilder.getInstance().newMetaset();
			outMessage.add(MetasetBuilder.getInstance().newAttribute("xmlns",
					"http://schemas.xmlsoap.org/soap/envelope/"));
			Metaset wsdd2 = MetasetBuilder.getInstance().newMetaset();
			List<Attribute> attributesList = outMessage.attributes();
			outMessage.removeElements(".\\Header\\Security");
			// Է񷵻رĽǩ

			Metaset HandlerLinks7 = MetasetBuilder.getInstance().newMetaset(
					"HandlerLinks");
			Metaset hder7 = outMessage.filter(".\\Header").car();

			for (Metaset temp : hder7.elements()) {
				temp.detach();
				HandlerLinks7.add(temp);
			}

			Metaset operation7 = MetasetBuilder.getInstance().newMetaset(
					"operation");

			Metaset bdy7 = (Metaset) outMessage.element("Body");
			bdy7.detach();
			operation7.add(bdy7);

			SinatureHandler sinatureHandler2 = new SinatureHandler();
			// sinatureHandler2.init(EncWSDL,wsdd2,attributesList);
			if ((digest == null)) {
				sinatureHandler2.init(
						SPConstants.KW_RSA15, ".\\Body",
						SPConstants.SHA1,
						attributesList);
			} else
				sinatureHandler2.init(asymmetricKeyWrap, ".\\Body", digest,
						attributesList);
			Metaset signedSoapMt2 = null;
			try {
				signedSoapMt2 = sinatureHandler2.process(HandlerLinks7,
						operation7);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			serviceContext.getMessageContext().setSoapMessageBySOAPEnvMetaset(
					signedSoapMt2);
			return;
		} else if (this.PolicyResult.equals("OnlyEncrypted")) {
			//   Է񷵻رĽм
			//

			EncHandler encHandler2 = new EncHandler();
			if ((digest == null)) {
				encHandler2
						.init(
								SPConstants.KW_RSA15,
								servercer,
								SPConstants.AES256);
			} else
				encHandler2
						.init(
								asymmetricKeyWrap,
								servercer,
								encryption);
			Metaset encedSoapMt2 = null;
			try {
				encedSoapMt2 = encHandler2.process(outMessage);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			serviceContext.getMessageContext().setSoapMessageBySOAPEnvMetaset(
					encedSoapMt2);
			return;
		} else {
			serviceContext.getMessageContext().setSoapMessageBySOAPEnvMetaset(
					outMessage);
			return;
		}

	}

	public void setPolicyProcessorName(String policyProcessorName) {
		// TODO Auto-generated method stub
		this.PolicyProcessorName = policyProcessorName;

	}

	public void setPolicyType(String policyType) {
		// TODO Auto-generated method stub
		this.PolicyType = policyType;
	}

	public void setWsPolicy(String wsPolicy) {
		// TODO Auto-generated method stub
		this.WsPolicy = wsPolicy;
	}

	public void PolicyResult() {
		Metaset Matchpolicy = getMatchPolicy(this.WsPolicy);

		String xdsd = Matchpolicy.toFormatXML();
		if ((Matchpolicy.elements().size()) != 0) {
			if (((Matchpolicy.filter(".\\SignedParts")) != null)
					&& ((Matchpolicy.filter(".\\EncryptedParts")) != null)) {
				this.PolicyResult = "BothSignedandEncrypted";
			} else if ((Matchpolicy.filter(".\\SignedParts")) != null) {
				this.PolicyResult = "OnlySigned";
			} else if ((Matchpolicy.filter(".\\EncryptedParts")) != null) {
				this.PolicyResult = "OnlyEncrypted";
			} else {
				this.PolicyResult = "NotSignedandEncrypted";
			}
		} else {
			this.PolicyResult = "NotSignedandEncrypted";
		}

	}

	public Metaset getMatchPolicy(String wsPolicy) {

		Metaset MatchPolicy = MetasetBuilder.getInstance().newMetaset(
				"MatchPolicy");
		try {

			Metaset wspolicy = MetasetParserFactory.getMetasetParser()
					.parseXMLString(wsPolicy);
			if (wspolicy.elements().size() > 0) {
				MatchPolicy = wspolicy.elements().get(0);
			}

		} catch (MetasetParsingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return MatchPolicy;
	}

	public void setpolicyprocessIN(Metaset processpt) {

//		System.out.print("\n" + "********Դ(INPUT PART)*****" + "\n");
		// MetaPrint.pXML(processpt, "дı");

		getinpart(processpt);// ԱĽз
		// н

//		if (INSignBody == true) {
//			System.out.print("Sign Body to the input message" + "\n");
//		}
//		if (INSignHeader == true) {
//			System.out.print("Sign Header to the input message" + "\n");
//		}
//		if (INEncrypBody == true) {
//			System.out.print("DeEncryp Body to the input message" + "\n");
//		}
//		if (INEncrypHeader == true) {
//			System.out.print("DeEncryp Header to the input message" + "\n");
//		}
//		if (digest != null) {
//			System.out.print("The sign algorithm to the input message :"
//					+ digest + "\n");
//		} else {
//			System.out
//					.print("The sign algorithm to the input message as Default "
//							+ "\n");
//		}
//		if (encryption != null) {
//			System.out.print("The encryption algorithm to the input message :"
//					+ encryption + "\n");
//		} else {
//			System.out
//					.print("The encryption algorithm to the input message as Default "
//							+ "\n");
//		}
//		if (asymmetricKeyWrap != null) {
//			System.out.print("The assysmetric algorithm to the input message :"
//					+ asymmetricKeyWrap + "\n");
//		} else {
//			System.out
//					.print("The assysmetric algorithm to the output message as Default "
//							+ "\n");
//		}


	}

	public void setpolicyprocessOUT(Metaset processpt) {
		// ӦҪĲַ봦

//		System.out.print("\n" + "********Դ(OUTPUT PART)*****" + "\n");
		// MetaPrint.pXML(processpt, "дı");
		getoutpart(processpt);// ԱĽз
		// н

//		if (OUTSignBody == true) {
//			System.out.print("Sign Body to the output message" + "\n");
//		}
//		if (OUTSignHeader == true) {
//			System.out.print("Sign Header to the output message" + "\n");
//		}
//		if (OUTEncrypBody == true) {
//			System.out.print("Encryp Body to the output message" + "\n");
//		}
//		if (OUTEncrypHeader == true) {
//			System.out.print("Encryp Header to the output message" + "\n");
//		}
//		if (digest != null) {
//			System.out.print("The sign algorithm to the output message :"
//					+ digest + "\n");
//		} else {
//			System.out
//					.print("The sign algorithm to the output message as Default "
//							+ "\n");
//		}
//		if (encryption != null) {
//			System.out.print("The encryption algorithm to the output message :"
//					+ encryption + "\n");
//		} else {
//			System.out
//					.print("The encryption algorithm to the output message as Default "
//							+ "\n");
//		}
//		if (asymmetricKeyWrap != null) {
//			System.out
//					.print("The assysmetric algorithm to the output message :"
//							+ asymmetricKeyWrap + "\n");
//		} else {
//			System.out
//					.print("The assysmetric algorithm to the output message as Default "
//							+ "\n");
//		}
	}

	public void setpolicyprocess(Metaset processpt) {
		// ӦҪĲַ봦

//		System.out.print("\n" + "********Դ(Total PART)*****" + "\n");
		// MetaPrint.pXML(processpt, "дı");
		getoutpart(processpt);// ԱĽз
		// н

//		if (OUTSignBody == true) {
//			System.out.print("Sign Body to the message" + "\n");
//		}
//		if (OUTSignHeader == true) {
//			System.out.print("Sign Header to the message" + "\n");
//		}
//		if (OUTEncrypBody == true) {
//			System.out.print("Encryp Body to the message" + "\n");
//		}
//		if (OUTEncrypHeader == true) {
//			System.out.print("Encryp Header to the message" + "\n");
//		}
//		if (digest != null) {
//			System.out.print("The sign algorithm to the message :" + digest
//					+ "\n");
//		}
//		if (encryption != null) {
//			System.out.print("The encryption algorithm to the omessage"
//					+ encryption + "\n");
//		}
//		if (asymmetricKeyWrap != null) {
//			System.out.print("The assysmetric algorithm to the message"
//					+ asymmetricKeyWrap + "\n");
//		} else {
//			System.out
//					.print("The assysmetric algorithm to the output message as Default "
//							+ "\n");
//		}
	}

	public void setAlgorithmSuite(String algoSuite) throws WSSPolicyException {
		setAlgoSuiteString(algoSuite);
		this.algoSuiteString = algoSuite;

		// TODO: Optimize this :-)
		if (SPConstants.ALGO_SUITE_BASIC256.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES256;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC192.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES192;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC128.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES128;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_TRIPLE_DES.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.TRIPLE_DES;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC256_RSA15.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES256;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_BASIC192_RSA15.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES192;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_BASIC128_RSA15.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.AES128;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_TRIPLE_DES_RSA15.equals(algoSuite)) {
			this.digest = SPConstants.SHA1;
			this.encryption = SPConstants.TRIPLE_DES;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_BASIC256_SHA256.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES256;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC192_SHA256.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES192;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC128_SHA256.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES128;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_TRIPLE_DES_SHA256.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.TRIPLE_DES;

			this.asymmetricKeyWrap = SPConstants.KW_RSA_OAEP;

		} else if (SPConstants.ALGO_SUITE_BASIC256_SHA256_RSA15
				.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES256;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_BASIC192_SHA256_RSA15
				.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES192;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_BASIC128_SHA256_RSA15
				.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.AES128;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else if (SPConstants.ALGO_SUITE_TRIPLE_DES_SHA256_RSA15
				.equals(algoSuite)) {
			this.digest = SPConstants.SHA256;
			this.encryption = SPConstants.TRIPLE_DES;

			this.asymmetricKeyWrap = SPConstants.KW_RSA15;

		} else {
			throw new WSSPolicyException("Invalid algorithm suite : "
					+ algoSuite);
		}
	}

	private void setAlgoSuiteString(String algoSuiteString) {
		this.algoSuiteString = algoSuiteString;
	}

	private void getinpart(Metaset processpt) {

		if (processpt.element("Servicept") != null) {
			Metaset policypart = processpt.element("Servicept").element(
					"Policy");
			// 
			if (policypart.element("SignedParts") != null) {
				Metaset signedpart = policypart.element("SignedParts");
				if (signedpart.element("Body") != null) {
					INSignBody = true;
				}
				if (signedpart.element("Header") != null) {
					INSignHeader = true;
				}
				if (signedpart.element("Body") == null
						&& signedpart.element("Header") == null) {
					INSignBody = true;
					INSignHeader = true;
				}
			}

			// ǩ
			if (policypart.element("EncryptedParts") != null) {
				Metaset encrypart = policypart.element("EncryptedParts");
				if (encrypart.element("Body") != null) {
					INEncrypBody = true;
				}
				if (encrypart.element("Header") != null) {
					INEncrypHeader = true;
				}
				if (encrypart.element("Body") == null
						&& encrypart.element("Header") == null) {
					INEncrypBody = true;
					INEncrypHeader = true;
				}
			}
			if (policypart.element("AlgorithmSuite") != null) {
				String algoSuite = policypart.element("AlgorithmSuite")
						.elements().get(0).getQName().getName();
				try {
					setAlgorithmSuite(algoSuite);
				} catch (WSSPolicyException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
//			System.out.println("\n" + "ȡ" + "\n");
		}
	}

	private void getoutpart(Metaset processpt) {

		if (processpt.element("Servicept") != null) {
			Metaset policypart = processpt.element("Servicept").element(
					"Policy");
			// 
			if (policypart.element("SignedParts") != null) {
				Metaset signedpart = policypart.element("SignedParts");
				if (signedpart.element("Body") != null) {
					OUTSignBody = true;
				}
				if (signedpart.element("Header") != null) {
					OUTSignHeader = true;
				}
				if (signedpart.element("Body") == null
						&& signedpart.element("Header") == null) {
					OUTSignBody = true;
					OUTSignHeader = true;
				}
			}

			// ǩ
			if (policypart.element("EncryptedParts") != null) {
				Metaset encrypart = policypart.element("EncryptedParts");
				if (encrypart.element("Body") != null) {
					OUTEncrypBody = true;
				}
				if (encrypart.element("Header") != null) {
					OUTEncrypHeader = true;
				}
				if (encrypart.element("Body") == null
						&& encrypart.element("Header") == null) {
					OUTEncrypBody = true;
					OUTEncrypHeader = true;
				}
			}
			if (policypart.element("AlgorithmSuite") != null) {
				String algoSuite = policypart.element("AlgorithmSuite")
						.elements().get(0).getQName().getName();
				try {
					setAlgorithmSuite(algoSuite);
				} catch (WSSPolicyException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

//			System.out.println("\n" + "ȡ" + "\n");
		}
	}

    public Metaset getExtElement(IServiceContext serviceContext,String HandlerType){
    	
    	MetasetBuilder builder = MetasetBuilder.getInstance();
    	int a =0;
		
    	Metaset ExtElement = builder.newMetaset("ExtElement");
		
		if((serviceContext.getXcService().getExtensibilityElements().size())!=0){
			for(int i=0;i<(serviceContext.getXcService().getExtensibilityElements().size());i++){
	    	

	    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
	    			serviceContext.getXcService().getExtensibilityElements().get(i).getExtElement()));
	    
	    }	
			a++;
		}
		
		
		if((serviceContext.getXcEndpoint().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcEndpoint().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcEndpoint().getExtensibilityElements().get(i).getExtElement()));
		    	
		    }	
		    a++;
		}
		
		
		if((serviceContext.getXcOperation().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcOperation().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcOperation().getExtensibilityElements().get(i).getExtElement()));
		    }
		    a++;
		}
		
		if((serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().size())!=0){
		    for(int i=0;i<(serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().size());i++){
		    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
		    			serviceContext.getXcOperation().getXcBindingOperation().getExtensibilityElements().get(i).getExtElement()));
		    }
		    a++;
		}
		
		
		
		
		if(HandlerType.equals("handlin")){
			
			if((serviceContext.getXcOperation().getInputXcMessage())!=null){
				    
					for(int i=0;i<(serviceContext.getXcOperation().getInputXcMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getInputXcMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}
					
					for(int i=0;i<(serviceContext.getXcOperation().getInputXcMessage().getXcBindingMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getInputXcMessage().getXcBindingMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					
					

			}
			
		}else if(HandlerType.equals("handlout")){
			if((serviceContext.getXcOperation().getOutputXcMessage())!=null){
				   
					for(int i=0;i<(serviceContext.getXcOperation().getOutputXcMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getOutputXcMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					for(int i=0;i<(serviceContext.getXcOperation().getOutputXcMessage().getXcBindingMessage().getExtensibilityElements().size());i++){
				    	ExtElement.add(XContainerUtil.ChangeDomElementToMetaset(
				    			serviceContext.getXcOperation().getOutputXcMessage().getXcBindingMessage().getExtensibilityElements().get(i).getExtElement()));
				    	 a++;
					}	
					
					
			}
		}
		if(a<2){
			ExtElement.removeElements(".\\*");
		}
		
		return ExtElement;
    }
}