/**
 * ACacheableItem.java
 */
package org.act.xservices.rt.xsecurity.xacml;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;

/**
 * 
 */
public abstract class ACacheableItem implements ICacheable,Comparable<ACacheableItem> {

	protected long createTime;

	protected long lastUseTime;

	protected boolean expired;

	protected ACacheableItem() {
		this.createTime = System.currentTimeMillis();
		this.lastUseTime = System.currentTimeMillis();
		this.expired = false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.xacml.ICacheable#getCreateTime()
	 */
	public long getCreateTime() {
		// TODO Auto-generated method stub
		return this.createTime;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.xacml.ICacheable#getLatestUseTime()
	 */
	public long getLastUseTime() {
		// TODO Auto-generated method stub
		return this.lastUseTime;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.xacml.ICacheable#isExpired()
	 */
	public boolean isExpired() {
		// TODO Auto-generated method stub
		return this.expired;
	}
	
	/*
	 *  ˢ»Ԫأ
	 * 	1. ʹʱΪǰʱ䣻
	 * 	2. ڱʶλ
	 * 	2. ûĻѵڣػݣtrue򣬷false;
	 * 
	 */
	public boolean refresh() throws MetasetParsingException,
			PolicySyntaxErrorException, DataTypeMappingException,
			IndeterminateException, UnsuportedLocationTypeException {
		// TODO Auto-generated method stub
		this.lastUseTime = System.currentTimeMillis();
		this.expired=false;
		return touch();
	}

	protected abstract boolean touch() throws MetasetParsingException,
			PolicySyntaxErrorException, DataTypeMappingException,
			IndeterminateException, UnsuportedLocationTypeException;
	
	/*
	 *  λڻ:
	 * 	1. λڱʶλ
	 * 	2. ʱûѾڵ״̬򷵻falseͷŻݣtrue
	 */
	public boolean release(){
		this.expired=true;
		return free();
	}
	
	protected abstract boolean free();

	public int compareTo(ACacheableItem o) {
		// TODO Auto-generated method stub
		long r=this.lastUseTime-o.getLastUseTime();
		if(r<0)
			return -1;
		else if(r>0){
			return 1;
		}
		else {
			return 0;
		}
	}	

}
