/**
 * AXacmlElement.java
 */
package org.act.xservices.rt.xsecurity.xacml;

import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public class AXacmlElement implements IXacmlElement {

	protected String elementName = null;

	protected IXacmlElement parent = null;

	protected IXacmlElement root = null;

	protected Metaset xmlElement = null;

	protected AXacmlElement() {
	}

	protected AXacmlElement(String elementName) {
		this.elementName = elementName;
	}

	protected AXacmlElement(Metaset xmlElement) {
		this.xmlElement = xmlElement;
		this.elementName = xmlElement.getName();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.xacml.IXacmlElement#setElementName()
	 */
	public String getElementName() {
		// TODO Auto-generated method stub
		return this.elementName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.act.xacml.IXacmlElement#setElementName(java.lang.String)
	 */
	public void setElementName(String elementName) {
		// TODO Auto-generated method stub
		this.elementName = elementName;
	}

	public IXacmlElement getParent() {
		// TODO Auto-generated method stub
		return this.parent;
	}

	public IXacmlElement getRoot() {
		// TODO Auto-generated method stub
		if (root == null) {
			IXacmlElement cur = this;
			while (cur != null) {
				root = cur;
				cur = cur.getParent();
			}
		}
		return root;
	}

	public void setParent(IXacmlElement parent) {
		// TODO Auto-generated method stub
		this.parent = parent;
	}

	public void setRoot(IXacmlElement root) {
		// TODO Auto-generated method stub
		this.root = root;
	}

	public Metaset getXmlElement() {
		return xmlElement;
	}

	public void setXmlElement(Metaset xmlElement) {
		this.xmlElement = xmlElement;
	}
}
