/**
 * Cache.java
 */
package org.act.xservices.rt.xsecurity.xacml;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * 
 */
public abstract class Cache {
//	 ߳б
	protected Boolean clean_running = false;
	
	protected Lock lock = new ReentrantLock();
	
	protected void cleanupExpired(final boolean emergent) {
		synchronized (this.clean_running) {
			if (this.clean_running) {
				return;
			}
			this.clean_running=true;
			
			Thread t=new Thread(){
				public void run(){
					cleanup(emergent);
					clean_running=false;
				}
			};
			
			t.start();
		}
	}
	
	protected abstract void cleanup(boolean emergent);
	
	public void lock() {
		this.lock.lock();
	}

	public void unlock() {
		this.lock.unlock();
	}
	
}
