/**
 * ContextResource.java
 */
package org.act.xservices.rt.xsecurity.xacml.context;


import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * OASIS XACML2.06.3ڡ
 * <xs:element name="Resource" type="xacml-context:ResourceType"/>
 * <xs:complexType name="ResourceType"> <xs:sequence> <xs:element
 * ref="xacml-context:ResourceContent" minOccurs="0"/> <xs:element
 * ref="xacml-context:Attribute" minOccurs="0" maxOccurs="unbounded"/>
 * </xs:sequence> </xs:complexType>
 * 
 * 
 */
public class ContextResource extends AContextEntity {
	public static final String RESOURCE_CONTENT = "ResourceContent";

	private ResourceContent resourceContent = null;

	public ContextResource(ResourceContent resourceContent,
			ContextAttribute[] attributes) {
		super(attributes);
		// TODO Auto-generated constructor stub
		this.resourceContent = resourceContent;
	}

	public ContextResource(Metaset xmlElement)
			throws PolicySyntaxErrorException, DataTypeMappingException {
		super(xmlElement);
		Metaset[] contentChildren = UtilMetaset.extractChildrenByName(
				xmlElement, RESOURCE_CONTENT);
		if (contentChildren != null && contentChildren.length != 0) {
			UtilMetaset.checkNumber(contentChildren, 1, RESOURCE_CONTENT);
			this.resourceContent = new ResourceContent(contentChildren[0]);
		}

	}

}
