/**
 * ContextSubject.java
 */
package org.act.xservices.rt.xsecurity.xacml.context;

import java.net.URI;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * ʵеSubjectԪءOASIS XACML2.06.2ڡ 
 * <xs:element name="Subject"
 * type="xacml-context:SubjectType"/> <xs:complexType name="SubjectType">
 * <xs:sequence> <xs:element ref="xacml-context:Attribute" minOccurs="0"
 * maxOccurs="unbounded"/> </xs:sequence> <xs:attribute name="SubjectCategory"
 * type="xs:anyURI"
 * default="urn:oasis:names:tc:xacml:1.0:subject-category:access-subject"/>
 * </xs:complexType>
 * 
 * 
 */
public class ContextSubject extends AContextEntity {
	public static final String SUBJECT_CATEGORY="SubjectCategory";
	
	private URI category=Constants.SUBJECT_CATEGORY_ACCESS;

	public ContextSubject(URI category,ContextAttribute[] attributes){
		super(attributes);
		this.category=category;
	}
	public ContextSubject(Metaset xmlElement) throws PolicySyntaxErrorException, DataTypeMappingException{
		super(xmlElement);
		Attribute[] attrs=UtilMetaset.extractAttributesByName(xmlElement,SUBJECT_CATEGORY);
		if(attrs!=null&&attrs.length!=0){
			UtilMetaset.checkNumber(attrs, 1, SUBJECT_CATEGORY);
			this.category=URI.create(attrs[0].getValue().trim());
		}
		
	}
	public URI getCategory() {
		return category;
	}
	public void setCategory(URI category) {
		this.category = category;
	}
}
