/**
 * StatusCode.java
 */
package org.act.xservices.rt.xsecurity.xacml.context;

import java.net.URI;

import org.act.xservices.rt.xsecurity.xacml.exception.XacmlException;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public class StatusCode {

	// OASIS XACML淶״̬롣
	public static final StatusCode STATUS_OK = new StatusCode(null,
			Constants.STATUS_OK);

	public static final StatusCode STATUS_MISSING_ATTR = new StatusCode(null,
			Constants.STATUS_MISSINGATTRIBUTE);

	public static final StatusCode STATUS_SYNTAX_ERROR = new StatusCode(null,
			Constants.STATUS_SYNTAXERROR);

	public static final StatusCode STATUS_PROCESSING_ERROR = new StatusCode(
			null, Constants.STATUS_PROCESSINGERROR);

	// Զ״̬
	public static final StatusCode STATUS_UNKNOWN_ERROR = new StatusCode(null,
			Constants.STATUS_UNKNOWNERROR);

	public static final StatusCode STATUS_SERVER_ERROR = new StatusCode(null,
			Constants.STATUS_SERVERERROR);

	private StatusCode childStatusCode = null;

	private URI value = null;

	public StatusCode() {
	}

	public StatusCode(StatusCode childStatusCode, URI value) {
		this.childStatusCode = childStatusCode;
		this.value = value;
	}

	public StatusCode getChildStatusCode() {
		return childStatusCode;
	}

	public void setChildStatusCode(StatusCode childStatusCode) {
		this.childStatusCode = childStatusCode;
	}

	public URI getValue() {
		return value;
	}

	public void setValue(URI value) {
		this.value = value;
	}

	public static StatusCode newStatusCode(XacmlException e,
			StatusCode childStatusCode) {
		if (e.getStatusCode() == null) {
			return STATUS_UNKNOWN_ERROR;
		} else if (e.getStatusCode().equals(Constants.STATUS_MISSINGATTRIBUTE)) {
			if (childStatusCode == null) {
				return STATUS_MISSING_ATTR;
			} else {
				return new StatusCode(childStatusCode,
						Constants.STATUS_MISSINGATTRIBUTE);
			}
		} else if (e.getStatusCode().equals(Constants.STATUS_SYNTAXERROR)) {
			if (childStatusCode == null) {
				return STATUS_SYNTAX_ERROR;
			} else {
				return new StatusCode(childStatusCode,
						Constants.STATUS_SYNTAXERROR);
			}
		} else if (e.getStatusCode().equals(Constants.STATUS_PROCESSINGERROR)) {
			if (childStatusCode == null) {
				return STATUS_PROCESSING_ERROR;
			} else {
				return new StatusCode(childStatusCode,
						Constants.STATUS_PROCESSINGERROR);
			}
		} else if (e.getStatusCode().equals(Constants.STATUS_UNKNOWNERROR)) {
			if (childStatusCode == null) {
				return STATUS_UNKNOWN_ERROR;
			} else {
				return new StatusCode(childStatusCode,
						Constants.STATUS_UNKNOWNERROR);
			}
		} else if (e.getStatusCode().equals(Constants.STATUS_SERVERERROR)) {
			if (childStatusCode == null) {
				return STATUS_SERVER_ERROR;
			} else {
				return new StatusCode(childStatusCode,
						Constants.STATUS_SERVERERROR);
			}
		} else
			return STATUS_UNKNOWN_ERROR;
	}

}
