/**
 * PolicyCacheCleaner.java
 */
package org.act.xservices.rt.xsecurity.xacml.pap;

import java.util.List;
import java.util.logging.Logger;

import org.act.xservices.rt.xsecurity.xacml.util.LoggerFactory;

/**
 * 
 */
public class PolicyCacheCleaner implements Runnable {

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Runnable#run()
	 * 
	 */
	
	private static Logger logger=LoggerFactory.getLogger(PolicyCacheCleaner.class);
	
	private PolicyCache cache = null;

	public PolicyCacheCleaner(PolicyCache cache) {
		this.cache = cache;
	}

	public void run() {
		// TODO Auto-generated method stub
		
		try {
			this.cache.lock();
			cleanup();
		} finally {
			this.cache.unlock();
		}
		

	}
	
	private void cleanup(){
		//
		for(List<PolicyCacheableItem> list:this.cache.getCache().values()){
			for(PolicyCacheableItem itm:list){
				if(!itm.isExpired()){
					long lut=itm.getLastUseTime();
					long now=System.currentTimeMillis();
					long span=(now-lut)/1000;
				}
			}
		}
	}

}
