/**
 * PolicyCacheableItem.java
 */
package org.act.xservices.rt.xsecurity.xacml.pap;

import java.net.URI;
import java.util.logging.Logger;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xsecurity.xacml.ACacheableItem;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;
import org.act.xservices.rt.xsecurity.xacml.policy.AXacmlPolicy;
import org.act.xservices.rt.xsecurity.xacml.util.LoggerFactory;

/**
 * 
 */
public class PolicyCacheableItem extends ACacheableItem{
	
	private static Logger logger=LoggerFactory.getLogger(PolicyCacheableItem.class);
	
	private URI policyId=null;
	
	// Եáܱϵͳͷš
	private AXacmlPolicy xacmlPolicy = null;

	// Եĵַһļ·ҲһURL
	private String fileLocation = null;

	// ԵַͣļڱأΪļ·ΪһURL
	private String locationType = null;

	private PolicyCache owner = null;

	public PolicyCache getOwner() {
		return owner;
	}

	public void setOwner(PolicyCache owner) {
		this.owner = owner;
	}

	public PolicyCacheableItem() {
	}

	public PolicyCacheableItem(String fileLocation,
			String locationType,PolicyCache owner) {
		super();
		this.fileLocation = fileLocation;
		this.locationType = locationType;
		this.owner=owner;
	}

	public String getFileLocation() {
		return fileLocation;
	}

	public void setFileLocation(String fileLocation) {
		this.fileLocation = fileLocation;
	}

	public String getLocationType() {
		return locationType;
	}

	public void setLocationType(String locationType) {
		this.locationType = locationType;
	}

	public AXacmlPolicy getXacmlPolicy() {
		return xacmlPolicy;
	}

	public void setXacmlPolicy(AXacmlPolicy xacmlPolicy) {
		this.xacmlPolicy = xacmlPolicy;
	}

	@Override
	protected boolean touch() throws MetasetParsingException,
			PolicySyntaxErrorException, DataTypeMappingException,
			IndeterminateException, UnsuportedLocationTypeException {
		// TODO Auto-generated method stub
		if (this.xacmlPolicy == null) {
			PolicyLoader loader = this.owner.getPolicyLoader();
			this.xacmlPolicy = loader.loadXacmlPolicy(this.fileLocation,
					this.locationType);
			if(this.policyId==null){
				this.policyId=this.xacmlPolicy.getId();
			}
			return true;
		}
		return false;
	}
	
	@Override
	protected boolean free() {
		// TODO Auto-generated method stub

		// ղռõڴ
		// ѶԸòԵΪգһԵıΪ0ʱɱϵͳա		
		if(this.xacmlPolicy!=null){
			this.xacmlPolicy=null;
			return true;
		}
		return false;
	}

	public URI getPolicyId() {
		return policyId;
	}

	public void setPolicyId(URI policyId) {
		this.policyId = policyId;
	}

	public boolean equals(Object obj){
		if(obj==null){
			return false;
		}
		if(obj.getClass()!=this.getClass()){
			return false;
		}
		PolicyCacheableItem other=(PolicyCacheableItem)obj;
		if(other.getPolicyId().equals(this.policyId)){
			return true;
		}else{
			return false;
		}
	}
	
	public int hashCode(){
		return this.policyId.hashCode();
	}
}
