/**
 * MetasetUtil.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public class UtilMetaset {
	
	public static final String XML_NS="xmlns";
	public static final String DEFAULT_NS_PREFIX="";
	/**
	 * ӶӦMetasetгȡ(ǰ׺ͱ)Ԫء
	 * 
	 * @param xmlElement
	 * @param prefix
	 * @param localPart
	 * @return
	 */
	public static Attribute[] extractAttributesByName(Metaset xmlElement,
			String prefix, String localPart) {
		List<Attribute> attrs = xmlElement.attributes();
		List<Attribute> resultAttrs = new ArrayList<Attribute>();
		for (Attribute a : attrs) {
			if (a.getNamespacePrefix().equals(prefix)
					&& a.getName().equals(localPart)) {
				resultAttrs.add(a);
			}
		}
		return resultAttrs.toArray(new Attribute[0]);
	}

	/**
	 * ֻݱƴӶӦMetasetгȡԡƿռȷΣЧʡ
	 * 
	 * @param xmlElement
	 * @param prefix
	 * @param localPart
	 * @return
	 */
	public static Attribute[] extractAttributesByName(Metaset xmlElement,
			String localPart) {
		List<Attribute> attrs = xmlElement.attributes();
		List<Attribute> resultAttrs = new ArrayList<Attribute>();
		for (Attribute a : attrs) {
			if (a.getName().equals(localPart)) {
				resultAttrs.add(a);
			}
		}
		return resultAttrs.toArray(new Attribute[0]);
	}

	/**
	 * ӶӦMetasetгȡ(ǰ׺ͱ)Ԫء
	 * 
	 * @param xmlElement
	 * @param prefix
	 * @param localPart
	 * @return
	 */
	public static Metaset[] extractChildrenByName(Metaset xmlElement,
			String prefix, String localPart) {
		List<Metaset> children = xmlElement.elements();
		List<Metaset> resultChildren = new ArrayList<Metaset>();
		for (Metaset m : children) {
			if (m.getNamespacePrefix().equals(prefix)
					&& m.getName().equals(localPart)) {
				resultChildren.add(m);
			}
		}
		return resultChildren.toArray(new Metaset[0]);
	}

	/**
	 * ֻݱƴӶӦMetasetгȡԪءƿռȷΣЧʡ
	 * 
	 * @param xmlElement
	 * @param prefix
	 * @param localPart
	 * @return
	 */
	public static Metaset[] extractChildrenByName(Metaset xmlElement,
			String localPart) {
		List<Metaset> children = xmlElement.elements();
		List<Metaset> resultChildren = new ArrayList<Metaset>();
		for (Metaset m : children) {
			if (m.getName().equals(localPart)) {
				resultChildren.add(m);
			}
		}
		return resultChildren.toArray(new Metaset[0]);
	}

	public static void checkEmpty(Object[] array, String name)
			throws PolicySyntaxErrorException {
		if (array == null || array.length == 0) {
			throw new PolicySyntaxErrorException(Constants.STATUS_SYNTAXERROR,
					"No " + name, null);
		}
	}

	public static void checkNumber(Object[] array, int expected, String name)
			throws PolicySyntaxErrorException {
		if (array.length != expected) {
			throw new PolicySyntaxErrorException(Constants.STATUS_SYNTAXERROR,
					"Invalid number of " + name + ", expected " + expected
							+ ", but got " + array.length, null);
		}
	}
	
	public static Map<String ,String> extractNameSpaceMap(Metaset xmlElement){
		Map<String,String> map = new HashMap<String, String>();
		List<Attribute> attrs=xmlElement.attributes();
		for(Attribute a:attrs){
			if(a.getNamespacePrefix().equalsIgnoreCase(XML_NS) ){
				map.put(a.getName(), a.getValue());
			}
		}
		return map;
	}
}
