/**
 * VersionMatch.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy;

import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public class VersionMatch extends AXacmlElement {

	// XACML淶İ汾ŹʽһStringʽVERSION_MATCH_PATTERNȷ
	private String vMatchString = null;

	// JavaʽȷvMatchStringĸʽ
	public static final String VERSION_MATCH_PATTERN = "((\\d+|\\*)\\.)*(\\d+|\\*|\\+)";

	// XACML淶İ汾ŹʽvMatchStringתΪJavaʽĽ
	private String vReg = null;

	public VersionMatch() {
	}

	public VersionMatch(String vMatchString) throws PolicySyntaxErrorException {
		if (vMatchString.matches(VERSION_MATCH_PATTERN)) {
			this.vMatchString = vMatchString;
			// XACML淶İ汾ŹʽתΪJvaʽ
			// һѰ汾Źʽе"*"(һ)תΪ"\\d"
			String step1 = this.vMatchString.replaceAll("\\*", "\\\\d");
			// ڶѰ汾Źʽе".+"תΪ".\\d"
			String step2 = step1.replaceAll("\\.\\+", ".\\\\d+");
			// Ѱ汾Źʽе"."תΪ"\\."(ʵʵ'.'ַת.javaʽͳ)
			String step3 = step2.replaceAll("\\.", "\\\\.");
			this.vReg = step3;
		} else {
			PolicySyntaxErrorException e = new PolicySyntaxErrorException(
					Constants.STATUS_SYNTAXERROR,
					"Version-match string does not match VERSION_MATCH_PATTERN !",
					null);
			throw e;
		}
	}

	public String getVMatchString() {
		return vMatchString;
	}

	public void setVMatchString(String matchString) {
		vMatchString = matchString;
	}

	public String getVReg() {
		return vReg;
	}

	public void setVReg(String reg) {
		vReg = reg;
	}

	public boolean match(Version version) {
		return version.getVersionString().matches(this.vReg);
	}

	public static void main(String[] args) throws PolicySyntaxErrorException {

		VersionMatch vm = new VersionMatch("1.*.3.+");
		System.out.println(vm.getVReg());
		Version v1 = new Version("1.5.3.123");
		System.out.println(vm.match(v1));
		Version v4 = new Version("1.0.3.0");
		System.out.println(vm.match(v4));
		Version v2 = new Version("1.5.3");
		System.out.println(vm.match(v2));
		Version v3 = new Version("1.55.3.0");
		System.out.println(vm.match(v3));
	}
}
