/**
 * XacmlPolicyDefaults.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy;

import java.net.URI;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * 
 */
public class XacmlPolicyDefaults extends AXacmlElement {
	public static final String XPATH_VERSION="XPathVersion";
	private URI xPathVersion = null;

	public XacmlPolicyDefaults() {
	}
	
	public XacmlPolicyDefaults(Metaset xmlElement)
			throws PolicySyntaxErrorException{
		super(xmlElement);
		Metaset[] xpChildren=UtilMetaset.extractChildrenByName(xmlElement, XPATH_VERSION);
		if(xpChildren!=null && xpChildren.length!=0){
			UtilMetaset.checkNumber(xpChildren, 1, XPATH_VERSION);
			String vStr=xpChildren[0].getText().trim();
			this.xPathVersion=URI.create(vStr);
		}
	}

	public XacmlPolicyDefaults(URI xPathVersion) {
		this.xPathVersion = xPathVersion;
	}

	public URI getXPathVersion() {
		return xPathVersion;
	}

	public void setXPathVersion(URI pathVersion) {
		xPathVersion = pathVersion;
	}
}
