/**
 * AAttributeLocator.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public abstract class AAttributeLocator extends AXacmlElement implements
		IAttributeLocator {
	public static final String MUST_BE_PRESENT = "MustBePresent";

	protected boolean mustBePresent;

	protected AAttributeLocator(boolean mustBePresent) {
		this.mustBePresent = mustBePresent;
	}

	protected AAttributeLocator(Metaset xmlElement)
			throws PolicySyntaxErrorException {
		super(xmlElement);
		Attribute[] mustBePresentChildren = UtilMetaset.extractAttributesByName(
				xmlElement, MUST_BE_PRESENT);
		if (mustBePresentChildren != null && mustBePresentChildren.length != 0) {
			if (mustBePresentChildren[0].getValue().trim().equalsIgnoreCase(
					"true")) {
				this.mustBePresent = true;
			} else if (mustBePresentChildren[0].getValue().trim()
					.equalsIgnoreCase("false")) {
				this.mustBePresent = false;
			} else {
				throw new PolicySyntaxErrorException(
						Constants.STATUS_SYNTAXERROR, "Illegal boolean value",
						null);
			}
		}
	}

	public abstract Object evaluate(IRequest request)
			throws IndeterminateException, DataTypeMappingException;

}
