/**
 * Action.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:ActionԪء
 * 
 * 
 */
public class Action extends ConjunctiveMatch {
	public Action(ActionMatch[] actionMatches) {
		this.matches = actionMatches;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Action(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> actionMatches = xmlElement.elements();
		this.matches = new ActionMatch[actionMatches.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new ActionMatch(actionMatches.get(i));
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public void setActionMatches(ActionMatch[] actionMatches) {
		this.matches = actionMatches;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public ActionMatch[] getActionMatches() {
		return (ActionMatch[]) this.matches;
	}
}
