/**
 * ActionMatch.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * 
 */
public class ActionMatch extends AEntityMatch {
	public static final String ACTION_ATTR_DSGN = "ActionAttributeDesignator";

	public static final String ACTION_MATCH_NAME = "ActionMatch";

	public ActionMatch(URI matchId, AttributeValue attributeValue,
			ActionAttributeDesignator actionAttributeDesignator) {
		super(ACTION_MATCH_NAME, matchId, attributeValue,
				actionAttributeDesignator);

	}

	public ActionMatch(URI matchId, AttributeValue attributeValue,
			AttributeSelector attributeSelector) {
		super(ACTION_MATCH_NAME, matchId, attributeValue, attributeSelector);

	}

	public ActionMatch(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		if (this.attributeLocator == null) {
			Metaset[] disgnChildren = UtilMetaset.extractChildrenByName(xmlElement,
					ACTION_ATTR_DSGN);
			if (disgnChildren != null && disgnChildren.length != 0) {
				UtilMetaset.checkNumber(disgnChildren, 1, ACTION_ATTR_DSGN);
				this.attributeLocator = new ActionAttributeDesignator(
						disgnChildren[0]);
				((AXacmlElement)this.attributeLocator).setParent(this);
			}
		}
	}
}
