/**
 * Actions.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:ActionsԪء
 * 
 * 
 */
public class Actions extends DisjunctiveMatch {
	public Actions(Action[] actions) {
		this.matches = actions;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Actions(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> actions = xmlElement.elements();
		this.matches = new Action[actions.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new Action(actions.get(i));
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public void setActions(Action[] actions) {
		this.matches = actions;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Action[] getActions() {
		return (Action[]) this.matches;
	}
}
