/**
 * Environment.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:EnvironmentԪء
 * 
 * 
 */
public class Environment extends ConjunctiveMatch {
	public Environment(EnvironmentMatch[] environmentMatches) {
		this.matches = environmentMatches;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Environment(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> envMatches = xmlElement.elements();
		this.matches = new EnvironmentMatch[envMatches.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new EnvironmentMatch(envMatches.get(i));
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public void setEnvironmentMatches(EnvironmentMatch[] environmentMatches) {
		this.matches = environmentMatches;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public EnvironmentMatch[] getEnvironmentMatches() {
		return (EnvironmentMatch[]) this.matches;
	}
}
