/**
 * EnvironmentAttributeLocator.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

import com.sun.org.apache.xerces.internal.jaxp.datatype.XMLGregorianCalendarImpl;

/**
 * 
 */
public class EnvironmentAttributeDesignator extends AAttributeDesignator {
	
	
	public EnvironmentAttributeDesignator(URI attributeId, URI dataType,
			String issuer, Boolean mustBePresent) {
		super(attributeId, dataType, issuer, mustBePresent);
	}

	public EnvironmentAttributeDesignator(Metaset xmlElement)
			throws PolicySyntaxErrorException {
		super(xmlElement);
	}

	@Override
	protected AttributeValue[] getAttributeValues(IRequest request)
			 {
		// TODO Auto-generated method stub
		return request
				.queryAttributeValues(attributeId, dataType, issuer, null);
	}

	@Override
	protected AttributeValue[] getAttributeValuesFromRepository() throws DataTypeMappingException{
		// TODO Auto-generated method stub
		List<AttributeValue> list=new ArrayList<AttributeValue>();
		if(this.attributeId.equals(Constants.ENVIRONMENT_ATTR_TIME)){
			Calendar c=Calendar.getInstance();
			int h=c.get(Calendar.HOUR_OF_DAY);
			int m=c.get(Calendar.MINUTE);
			int s=c.get(Calendar.SECOND);
//			System.out.println(h+" : "+m+" : "+s);
//			XMLGregorianCalendarImpl value=XMLGregorianCalendarImpl.createTime(hours, minutes, seconds, timezone)
			XMLGregorianCalendarImpl value=new XMLGregorianCalendarImpl();
			value.setHour(h);
			value.setMinute(m);
			value.setSecond(s);
			AttributeValue attrValue=AttributeValue.newInstance(Constants.TYPE_TIME,value);
			list.add(attrValue);
		}
		return list.toArray(new AttributeValue[0]);
	}
	

}
