/**
 * EnvironmentMatch.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * 
 */
public class EnvironmentMatch extends AEntityMatch {
	public static final String ENV_ATTR_DSGN = "EnvironmentAttributeDesignator";

	public static final String ENV_MATCH_NAME = "EnvironmentMatch";

	public EnvironmentMatch(URI matchId, AttributeValue attributeValue,
			EnvironmentAttributeDesignator envAttributeDesignator) {
		super(ENV_MATCH_NAME, matchId, attributeValue, envAttributeDesignator);
	}

	public EnvironmentMatch(URI matchId, AttributeValue attributeValue,
			AttributeSelector attributeSelector) {
		super(ENV_MATCH_NAME, matchId, attributeValue, attributeSelector);
	}

	public EnvironmentMatch(Metaset xmlElement)
			throws PolicySyntaxErrorException, DataTypeMappingException {
		super(xmlElement);
		if (this.attributeLocator == null) {
			Metaset[] disgnChildren = UtilMetaset.extractChildrenByName(
					xmlElement, ENV_ATTR_DSGN);
			if (disgnChildren != null && disgnChildren.length != 0) {
				UtilMetaset.checkNumber(disgnChildren, 1, ENV_ATTR_DSGN);
				this.attributeLocator = new EnvironmentAttributeDesignator(
						disgnChildren[0]);
				((AXacmlElement) this.attributeLocator).setParent(this);
			}
		}
	}
}
