/**
 * Environments.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:EnvironmentsԪء
 * 
 * 
 */
public class Environments extends DisjunctiveMatch {
	public Environments(Environment[] environments) {
		this.matches = environments;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Environments(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> envs = xmlElement.elements();
		this.matches = new Environment[envs.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new Environment(envs.get(i));
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public void setEnvironments(Environment[] environments) {
		this.matches = environments;
		for(int i=0;i<this.matches.length;i++){
			((AXacmlElement)this.matches[i]).setParent(this);
		}
	}

	public Environment[] getEnvironments() {
		return (Environment[]) this.matches;
	}
}
