/**
 * ResourceMatch.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * 
 */
public class ResourceMatch extends AEntityMatch {
	public static final String RES_ATTR_DSGN = "ResourceAttributeDesignator";

	public static final String RES_MATCH_NAME = "ResourceMatch";

	public ResourceMatch(URI matchId, AttributeValue attributeValue,
			ResourceAttributeDesignator resAttributeDesignator) {
		super(RES_MATCH_NAME, matchId, attributeValue, resAttributeDesignator);

	}

	public ResourceMatch(URI matchId, AttributeValue attributeValue,
			AttributeSelector attributeSelector) {
		super(RES_MATCH_NAME, matchId, attributeValue, attributeSelector);

	}

	public ResourceMatch(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		if (this.attributeLocator == null) {
			Metaset[] disgnChildren = UtilMetaset.extractChildrenByName(xmlElement,
					RES_ATTR_DSGN);
			if (disgnChildren != null && disgnChildren.length != 0) {
				UtilMetaset.checkNumber(disgnChildren, 1, RES_ATTR_DSGN);
				this.attributeLocator = new ResourceAttributeDesignator(
						disgnChildren[0]);
				((AXacmlElement)this.attributeLocator).setParent(this);
			}
		}
	}
}
