/**
 * Resources.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:ResourceԪء
 * 
 * 
 */
public class Resources extends DisjunctiveMatch {
	public Resources(Resource[] resources) {
		this.matches = resources;
		for (int i = 0; i < this.matches.length; i++) {
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public Resources(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> resources = xmlElement.elements();
		this.matches = new Resource[resources.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new Resource(resources.get(i));
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public void setResources(Resource[] resources) {
		this.matches = resources;
		for (int i = 0; i < this.matches.length; i++) {
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public Resource[] getResources() {
		return (Resource[]) this.matches;
	}
}
