/**
 * Subject.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.util.List;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;

/**
 * OASIS XACML淶2.0жpolicy:SubjectԪء
 * 
 * 
 */
public class Subject extends ConjunctiveMatch {

	public Subject(SubjectMatch[] subjectMatches) {
		this.matches = subjectMatches;
		for (int i = 0; i < this.matches.length; i++) {
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public Subject(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		List<Metaset> subMatches = xmlElement.elements();
		this.matches = new SubjectMatch[subMatches.size()];
		for (int i = 0; i < this.matches.length; i++) {
			this.matches[i] = new SubjectMatch(subMatches.get(i));
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public void setSubjectMatches(SubjectMatch[] subjectMatches) {
		this.matches = subjectMatches;
		for (int i = 0; i < this.matches.length; i++) {
			((AXacmlElement)this.matches[i]).setParent(this); 
		}
	}

	public SubjectMatch[] getSubjectMatches() {
		return (SubjectMatch[]) this.matches;
	}
}
