/**
 * SubjectAttributeLocator.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;

import org.act.xservices.rt.xom.Attribute;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;
import org.act.xservices.rt.xsecurity.xacml.util.Constants;

/**
 * 
 */
public class SubjectAttributeDesignator extends AAttributeDesignator {
	public static final String CATEGORY = "SubjectCategory";

	// OASIS XACML淶2.0SubjectCategoryĬֵΪAccessSubject.
	private URI subjectCategory = Constants.SUBJECT_CATEGORY_ACCESS;

	public SubjectAttributeDesignator(URI attributeId, URI dataType,
			String issuer, Boolean mustBePresent) {
		super(attributeId, dataType, issuer, mustBePresent);
	}

	public SubjectAttributeDesignator(Metaset xmlElement)
			throws PolicySyntaxErrorException {
		super(xmlElement);
		Attribute[] categoryAttrs = UtilMetaset.extractAttributesByName(xmlElement,
				CATEGORY);
		if (categoryAttrs != null && categoryAttrs.length != 0) {
			UtilMetaset.checkNumber(categoryAttrs, 1, CATEGORY);
			String catStr = categoryAttrs[0].getValue();
			this.subjectCategory = URI.create(catStr);
		}
	}

	@Override
	protected AttributeValue[] getAttributeValues(IRequest request) {
		// TODO Auto-generated method stub
		return request.queryAttributeValues(attributeId, dataType, issuer,
				subjectCategory);
	}

	@Override
	protected AttributeValue[] getAttributeValuesFromRepository() {
		// TODO Auto-generated method stub
		return null;
	}
}
