/**
 * SubjectMatch.java
 */
package org.act.xservices.rt.xsecurity.xacml.policy.target;

import java.net.URI;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.AXacmlElement;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.policy.UtilMetaset;

/**
 * 
 */
public class SubjectMatch extends AEntityMatch {

	public static final String SUB_MATCH_NAME = "SubjectMatch";
	public static final String SUB_ATTR_DSGN="SubjectAttributeDesignator";

	public SubjectMatch(URI matchId, AttributeValue attributeValue,
			SubjectAttributeDesignator subAttributeDesignator) {
		super(SUB_MATCH_NAME, matchId, attributeValue, subAttributeDesignator);
	}

	public SubjectMatch(URI matchId, AttributeValue attributeValue,
			AttributeSelector attributeSelector) {
		super(SUB_MATCH_NAME, matchId, attributeValue, attributeSelector);
	}

	public SubjectMatch(Metaset xmlElement) throws PolicySyntaxErrorException,
			DataTypeMappingException {
		super(xmlElement);
		if(this.attributeLocator==null){
			Metaset[] disgnChildren=UtilMetaset.extractChildrenByName(xmlElement,SUB_ATTR_DSGN);
			if(disgnChildren!=null && disgnChildren.length!=0){
				UtilMetaset.checkNumber(disgnChildren,1,SUB_ATTR_DSGN);
				this.attributeLocator=new SubjectAttributeDesignator(disgnChildren[0]);
				((AXacmlElement)this.attributeLocator).setParent(this);
			}
		}
	}
}
