package org.act.xservices.rt.xsecurity.xacml.test.performance;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.act.xservices.rt.metaset.MetasetParser;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.context.Request;
import org.act.xservices.rt.xsecurity.xacml.context.Result;
import org.act.xservices.rt.xsecurity.xacml.exception.CacheOverflowException;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;
import org.act.xservices.rt.xsecurity.xacml.exception.XacmlFunctionInvokeException;
import org.act.xservices.rt.xsecurity.xacml.exception.XacmlFunctionLoadException;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCache;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCacheableItem;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyLoader;
import org.act.xservices.rt.xsecurity.xacml.pdp.PDP;

public class EvaluationTest {


	private static MetasetParser builder = MetasetParserFactory.getMetasetParser();
	
	/**
	 * @param
	 * @return
	 * @throws CacheOverflowException 
	 * @throws UnsuportedLocationTypeException 
	 * @throws IndeterminateException 
	 * @throws DataTypeMappingException 
	 * @throws PolicySyntaxErrorException 
	 * @throws MetasetParsingException 
	 * @throws FileNotFoundException 
	 * @throws XacmlFunctionLoadException 
	 * @throws XacmlFunctionInvokeException 
	 * @throws
	 * @param args
	 */
	public static void main(String[] args) throws MetasetParsingException, PolicySyntaxErrorException, DataTypeMappingException, IndeterminateException, UnsuportedLocationTypeException, CacheOverflowException, FileNotFoundException, XacmlFunctionLoadException, XacmlFunctionInvokeException {
		// TODO Auto-generated method stub
		
		//زԿ
		String dir = "performance_test1\\size10";
		PolicyLoader loader = new PolicyLoader();
		PolicyCache cache = new PolicyCache(loader);
		List<String> paths=new ArrayList<String>();
		File file = new File(dir);
		if (file.isDirectory()) {
			File[] policies = file.listFiles();
			for (int i = 0; i < policies.length; i++) {
				File policy = policies[i];
				paths.add(policy.getAbsolutePath());
			}
		}
		for(String path:paths){
			cache.AddPolicyCacheableItem(new PolicyCacheableItem(path,"local_file",cache));
		}
		
		
		//PDP
		PDP pdp=new PDP(cache,null);
		
		
		//Ŀ
		File requestFileDir=new File("performance_test1\\requests");
		File[] files=requestFileDir.listFiles();
		
		IRequest[] requests=new IRequest[files.length];
		
		for(int i=0;i<requests.length;i++){
			Metaset requestMetaset = builder.parse(new FileInputStream(files[i]));
			requests[i]=new Request(requestMetaset);
		}
		
		
		//УΪĵ˳
		Random random=new Random();
		int[] a=new int[500];
		int range=requests.length;
		for(int i=0;i<500;i++){
			a[i]=((int)random.nextFloat()*10000) % range;
		}
		
		Result r=null;
		long start=System.currentTimeMillis();
		for(int i=0;i<500;i++){
			
			r= pdp.evaluate(requests[a[i]]);
		}
		long end=System.currentTimeMillis();
		System.out.println(end-start);
		System.out.println(r.getDecision());
	}

}
