package org.act.xservices.rt.xsecurity.xacml.test.performance;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.act.xservices.rt.metaset.MetasetParser;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.context.Request;
import org.act.xservices.rt.xsecurity.xacml.context.Result;
import org.act.xservices.rt.xsecurity.xacml.exception.CacheOverflowException;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;
import org.act.xservices.rt.xsecurity.xacml.exception.XacmlFunctionInvokeException;
import org.act.xservices.rt.xsecurity.xacml.exception.XacmlFunctionLoadException;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCache;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCacheableItem;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyLoader;
import org.act.xservices.rt.xsecurity.xacml.pdp.PDP;

public class EvaluationTest2 {

	
	
	private static MetasetParser builder = MetasetParserFactory.getMetasetParser();
	
	private static int size=100;
	
	/**
	 * @param
	 * @return
	 * @throws CacheOverflowException
	 * @throws UnsuportedLocationTypeException
	 * @throws IndeterminateException
	 * @throws DataTypeMappingException
	 * @throws PolicySyntaxErrorException
	 * @throws MetasetParsingException
	 * @throws XacmlFunctionLoadException
	 * @throws FileNotFoundException 
	 * @throws XacmlFunctionInvokeException 
	 * @throws
	 * @param args
	 */
	public static void main(String[] args) throws MetasetParsingException,
			PolicySyntaxErrorException, DataTypeMappingException,
			IndeterminateException, UnsuportedLocationTypeException,
			CacheOverflowException, XacmlFunctionLoadException, FileNotFoundException, XacmlFunctionInvokeException {
		// TODO Auto-generated method stub
		String dir = "performance_test2\\size"+size+"\\policies";
//		System.out.print(dir);
		PolicyLoader loader = new PolicyLoader();
		PolicyCache cache = new PolicyCache(loader);
		List<String> paths = new ArrayList<String>();
		File file = new File(dir);
		if (file.isDirectory()) {
			File[] policies = file.listFiles();
			for (int i = 0; i < policies.length; i++) {
				File policy = policies[i];
				paths.add(policy.getAbsolutePath());
			}
		}
		
		long start=System.currentTimeMillis();
		for (String path : paths) {
			cache.AddPolicyCacheableItem(new PolicyCacheableItem(path,
					"local_file", cache));
		}
		long end=System.currentTimeMillis();
		System.out.println("Loading policy: "+(end-start)+" milliseconds.");
		

		// PDP
		PDP pdp = new PDP(cache, null);
		
		// Ŀ
		File requestFileDir=new File("performance_test2\\size"+size+"\\requests");
		File[] files=requestFileDir.listFiles();
		
		IRequest[] requests=new IRequest[500];
		for(int i=0;i<500;i++){
			Random r=new Random();
			int n=(int)(r.nextDouble()*size);
			Metaset requestMetaset = builder.parse(new FileInputStream(files[n]));
			requests[i]=new Request(requestMetaset);
		}
		
		Result[] results=new Result[500];
		start=System.currentTimeMillis();
		for(int i=0;i<500;i++){
			results[i]=pdp.evaluate(requests[i]);
		}
		end=System.currentTimeMillis();
//*****2010.06.23 д ʾ results
		String string = "";
    	for(Result logStr : results){
    		string += logStr + "\n";
    	}
    	System.out.print(string);
		
		
		System.out.println("Evaluation :"+(end-start)+" milliseconds.");
	
//		for(int i=0;i<500;i++){
//			System.out.println(results[i].getDecision());
//		}
	}
}
