package org.act.xservices.rt.xsecurity.xacml.test.performance;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.act.xservices.rt.metaset.exception.MetasetParsingException;
import org.act.xservices.rt.xsecurity.xacml.exception.CacheOverflowException;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.IndeterminateException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.exception.UnsuportedLocationTypeException;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCache;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyCacheableItem;
import org.act.xservices.rt.xsecurity.xacml.pap.PolicyLoader;

public class LoadTest {

	/**
	 * @param
	 * @return
	 * @throws CacheOverflowException 
	 * @throws UnsuportedLocationTypeException 
	 * @throws IndeterminateException 
	 * @throws DataTypeMappingException 
	 * @throws PolicySyntaxErrorException 
	 * @throws MetasetParsingException 
	 * @throws IOException 
	 * @throws
	 * @param args
	 */
	public static void main(String[] args) throws MetasetParsingException, PolicySyntaxErrorException, DataTypeMappingException, IndeterminateException, UnsuportedLocationTypeException, CacheOverflowException, IOException {
		// TODO Auto-generated method stub
		
		String dir = "performance_test1\\size10";
		PolicyLoader loader = new PolicyLoader();
		PolicyCache cache = new PolicyCache(loader);
		
		List<String> paths=new ArrayList<String>();
		File file = new File(dir);
	
		if (file.isDirectory()) {
			File[] policies = file.listFiles();
			for (int i = 0; i < policies.length; i++) {
				File policy = policies[i];
				paths.add(policy.getAbsolutePath());
			}
		}
		long start=System.currentTimeMillis();
		for(String path:paths){
			cache.AddPolicyCacheableItem(new PolicyCacheableItem(path,"local_file",cache));
		}
		long end=System.currentTimeMillis();
		System.out.println(end-start);
		
		cache.dump_detail(System.out);
		
		
	}
}

