package org.act.xservices.rt.xsecurity.xacml.test.performance;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;


import org.act.xservices.rt.metaset.MetasetParser;
import org.act.xservices.rt.metaset.MetasetParserFactory;
import org.act.xservices.rt.metaset.exception.MetasetParsingException;

import org.act.xservices.rt.xom.Metaset;
import org.act.xservices.rt.xsecurity.xacml.context.IRequest;
import org.act.xservices.rt.xsecurity.xacml.context.Request;
import org.act.xservices.rt.xsecurity.xacml.context.Result;
import org.act.xservices.rt.xsecurity.xacml.exception.DataTypeMappingException;
import org.act.xservices.rt.xsecurity.xacml.exception.PolicySyntaxErrorException;
import org.act.xservices.rt.xsecurity.xacml.pdp.*;



public class TestforEngine {

	private static MetasetParser builder = MetasetParserFactory.getMetasetParser();
	public static void main(String[] args) { 
		File requestFileDir=new File("performance_test1\\requests");
		File[] files=requestFileDir.listFiles();
		
		IRequest[] requests=new IRequest[files.length];
		
		for(int i=0;i<requests.length;i++){
			Metaset requestMetaset = null;
			try {
				requestMetaset = builder.parse(new FileInputStream(files[i]));
			} catch (MetasetParsingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			try {
				requests[i]=new Request(requestMetaset);
			} catch (PolicySyntaxErrorException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (DataTypeMappingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	
		Random random=new Random();
		int[] a=new int[500];
		int range=requests.length;
		for(int i=0;i<500;i++){
			a[i]=((int)random.nextFloat()*10000) % range;
		}
		
		Result r=null;
		long start=System.currentTimeMillis();
		for(int i=0;i<500;i++){
			
			r= PolicyEngine.getInstance().evaluate(requests[a[i]]);
		}
		long end=System.currentTimeMillis();
		System.out.println(end-start);
		System.out.println(r.getDecision());	
		
		
		
	
    System.out.print("The Call of the PolicyEngine is running!");
	
	
	
	}
}
