/**
 * LoggerFactory.java
 */
package org.act.xservices.rt.xsecurity.xacml.util;

import java.util.logging.ConsoleHandler;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

import org.act.xservices.rt.xsecurity.xacml.exception.XacmlException;

/**
 * 
 */
public class LoggerFactory {

	private static final String DEF_LOGGER_NAME = "org.act.ac.logger";

	private static boolean isDebug = false;

	private static String loggerName = DEF_LOGGER_NAME;

	private static int LOG_ROTATION_COUNT = 10;

	static {
		// 
	}

	public static Logger getLogger(Class clz) {
		Logger logger = null;
		try {

			if (clz == null) {
				logger = Logger.getLogger(loggerName);
			} else {
				logger = Logger.getLogger(clz.getName());
			}

//			long start=System.currentTimeMillis();
			logger.setUseParentHandlers(false);

			Handler cHandler = new ConsoleHandler();
			cHandler.setFormatter(new SimpleFormatter());
			logger.addHandler(cHandler);

			Handler fHandler = new FileHandler("%h/ACLog%g.log", 0,
					LOG_ROTATION_COUNT);
			fHandler.setFormatter(new SimpleFormatter());
			logger.addHandler(fHandler);

			if (isDebug) {
				logger.setLevel(Level.ALL);
				cHandler.setLevel(Level.ALL);
				fHandler.setLevel(Level.ALL);
			} else {
				logger.setLevel(Level.INFO);
				cHandler.setLevel(Level.INFO);
				fHandler.setLevel(Level.INFO);
			}
//			long end=System.currentTimeMillis();
			
//			System.out.println("getLogger for "+clz.getName()+" :"+(end-start)+" milliseconds");

		} catch (Exception e) {
			// TODO Auto-generated catch block
//			logger.warning("Failed to create the log file. Cause: "
//					+ e.getMessage());
		}
		
		return logger;
	}

	public static void main(String[] args) throws XacmlException {
		Logger lg = getLogger(null);
		lg.severe("SEVERE");
		lg.info("INFO");
		lg.config("CONFIG");
		lg.finest("FINEST");
	}
}
